# Autogenerated file. Changes will be overwritten.

from coriolis import CRL, Hurricane, Viewer, Cfg
from coriolis.Hurricane import (
    Technology, DataBase, DbU, Library,
    Layer, BasicLayer,
    Cell, Net, Horizontal, Vertical, Rectilinear, Box, Point,
    Instance, Transformation,
    NetExternalComponents,
)
from coriolis.helpers import u, l
from coriolis.helpers.technology import setEnclosures
from coriolis.helpers.overlay import CfgCache, UpdateSession

__all__ = ["setup"]

def createRL(tech, net, layer, coords):
    coords = [Point(u(x), u(y)) for x,y in coords]
    Rectilinear.create(net, tech.getLayer(layer), coords)

def _routing():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()

    rg = CRL.RoutingGauge.create('StdCell3V3Lib')
    rg.setSymbolic(False)
    metal = tech.getLayer('Metal1')
    via = tech.getLayer('Metal1_Via1_Metal2')
    setEnclosures(via, metal, (u(0.01), u(0.05)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.PinOnly, 0, 0.0,
        u(0.0), u(0.5), u(0.21), u(0.16), u(0.19), u(0.18),
    ))
    metal = tech.getLayer('Metal2')
    via = tech.getLayer('Metal1_Via1_Metal2')
    setEnclosures(via, metal, (u(0.01), u(0.05)))
    via = tech.getLayer('Metal2_Via2_Metal3')
    setEnclosures(via, metal, (u(0.05), u(0.05)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 1, 0.0,
        u(0.0), u(0.5), u(0.29), u(0.2), u(0.19), u(0.21),
    ))
    metal = tech.getLayer('Metal3')
    via = tech.getLayer('Metal2_Via2_Metal3')
    setEnclosures(via, metal, (u(0.05), u(0.05)))
    via = tech.getLayer('Metal3_Via3_Metal4')
    setEnclosures(via, metal, (u(0.05), u(0.05)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.Default, 2, 0.0,
        u(0.0), u(0.5), u(0.29), u(0.2), u(0.19), u(0.21),
    ))
    metal = tech.getLayer('Metal4')
    via = tech.getLayer('Metal3_Via3_Metal4')
    setEnclosures(via, metal, (u(0.05), u(0.05)))
    via = tech.getLayer('Metal4_Via4_Metal5')
    setEnclosures(via, metal, (u(0.125), u(0.05)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 3, 0.0,
        u(0.0), u(0.5), u(0.29), u(0.2), u(0.19), u(0.21),
    ))
    metal = tech.getLayer('Metal5')
    via = tech.getLayer('Metal4_Via4_Metal5')
    setEnclosures(via, metal, (u(0.125), u(0.05)))
    via = tech.getLayer('Metal5_TopVia1_TopMetal1')
    setEnclosures(via, metal, (u(0.01), u(0.74)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.Default, 4, 0.0,
        u(0.0), u(0.65), u(0.44), u(0.2), u(0.42), u(0.21),
    ))
    metal = tech.getLayer('TopMetal1')
    via = tech.getLayer('Metal5_TopVia1_TopMetal1')
    setEnclosures(via, metal, (u(0.42), u(0.74)))
    via = tech.getLayer('TopMetal1_TopVia2_TopMetal2')
    setEnclosures(via, metal, (u(0.55), u(0.5)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 5, 0.0,
        u(0.0), u(3.54), u(1.9), u(1.64), u(0.9), u(1.64),
    ))
    metal = tech.getLayer('TopMetal2')
    via = tech.getLayer('TopMetal1_TopVia2_TopMetal2')
    setEnclosures(via, metal, (u(0.55), u(0.5)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.PowerSupply, 6, 0.0,
        u(0.0), u(4.0), u(2.0), u(2.0), u(0.9), u(2.0),
    ))
    af.addRoutingGauge(rg)
    af.setRoutingGauge('StdCell3V3Lib')

    cg = CRL.CellGauge.create(
        'StdCell3V3Lib', 'Metal2',
        u(0.68), u(6.8), u(1.0),
    )
    af.addCellGauge(cg)
    af.setCellGauge('StdCell3V3Lib')

    # Place & Route setup
    with CfgCache(priority=Cfg.Parameter.Priority.ConfigurationFile) as cfg:
        env = af.getEnvironment()
        env.setRegister('^dff.*')
        cfg.lefImport.minTerminalWidth = 0.0
        cfg.crlcore.groundName = 'vss'
        cfg.crlcore.powerName = 'vdd'
        cfg.etesian.aspectRatio = 1.00
        cfg.etesian.aspectRatio = [10, 1000]
        cfg.etesian.spaceMargin = 0.10
        cfg.etesian.uniformDensity = True
        cfg.etesian.densityVariation = 0.05
        cfg.etesian.routingDriven = False
        cfg.etesian.latchUpDistance = u(30.0 - 1.0)
        cfg.etesian.diodeName = 'diode_w1'
        cfg.etesian.antennaInsertThreshold = 0.50
        cfg.etesian.tieName = None
        cfg.etesian.antennaGateMaxWL = u(400.0)
        cfg.etesian.antennaDiodeMaxWL = u(800.0)
        cfg.etesian.feedNames = 'tie,decap_w0'
        cfg.etesian.defaultFeed = 'tie'
        cfg.etesian.cell.zero = 'zero_x1'
        cfg.etesian.cell.one = 'one_x1'
        cfg.etesian.bloat = 'disabled'
        cfg.etesian.effort = 2
        cfg.etesian.effort = (
            ('Fast', 1),
            ('Standard', 2),
            ('High', 3 ),
            ('Extreme', 4 ),
        )
        cfg.etesian.graphics = 2
        cfg.etesian.graphics = (
            ('Show every step', 1),
            ('Show lower bound', 2),
            ('Show result only', 3),
        )
        cfg.anabatic.routingGauge = 'StdCell3V3Lib'
        cfg.anabatic.globalLengthThreshold = 1450
        cfg.anabatic.saturateRatio = 0.90
        cfg.anabatic.saturateRp = 10
        cfg.anabatic.topRoutingLayer = 'TopMetal1'
        cfg.anabatic.edgeLength = 24
        cfg.anabatic.edgeWidth = 4
        cfg.anabatic.edgeCostH = 9.0
        cfg.anabatic.edgeCostK = -10.0
        cfg.anabatic.edgeHInc = 1.0
        cfg.anabatic.edgeHScaling = 1.0
        cfg.anabatic.globalIterations = 20
        cfg.anabatic.globalIterations = [ 1, 100 ]
        cfg.anabatic.gcell.displayMode = 1
        cfg.anabatic.gcell.displayMode = (("Boundary", 1), ("Density", 2))
        cfg.anabatic.searchHalo = 2
        cfg.katana.trackFill = 0
        cfg.katana.runRealignStage = True
        cfg.katana.hTracksReservedMin   = 4
        cfg.katana.hTracksReservedLocal = 20
        cfg.katana.hTracksReservedLocal = [0, 30]
        cfg.katana.vTracksReservedMin   = 4
        cfg.katana.vTracksReservedLocal = 20
        cfg.katana.vTracksReservedLocal = [0, 30]
        cfg.katana.termSatReservedLocal = 8
        cfg.katana.termSatThreshold = 9
        cfg.katana.eventsLimit = 4000002
        cfg.katana.ripupCost = 3
        cfg.katana.ripupCost = [0, None]
        cfg.katana.strapRipupLimit = 16
        cfg.katana.strapRipupLimit = [1, None]
        cfg.katana.localRipupLimit = 9
        cfg.katana.localRipupLimit = [1, None]
        cfg.katana.globalRipupLimit = 5
        cfg.katana.globalRipupLimit = [1, None]
        cfg.katana.longGlobalRipupLimit = 5
        cfg.chip.padCoreSide = 'South'

    # Plugins setup
    with CfgCache(priority=Cfg.Parameter.Priority.ConfigurationFile) as cfg:
        cfg.viewer.minimumSize = 500
        cfg.viewer.pixelThreshold = 10
        cfg.chip.block.rails.count = 5
        cfg.chip.block.rails.hWidth = u(2.68)
        cfg.chip.block.rails.vWidth = u(2.68)
        cfg.chip.block.rails.hSpacing = u(0.7)
        cfg.chip.block.rails.vSpacing = u(0.7)
        cfg.chip.supplyRailWidth = u(20.0)
        cfg.chip.supplyRailPitch = u(40.0)
        cfg.clockTree.placerEngine = 'Etesian'
        cfg.block.spareSide = 8*u(6.8)
        cfg.spares.buffer = 'buf_x4'
        cfg.spares.hfnsBuffer = 'buf_x4'
        cfg.spares.maxSinks = 31


def _load():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()
    rootlib = db.getRootLibrary()

    lib = Library.create(rootlib, 'StdCell3V3Lib')
    new_cells = {
        'fill': Cell.create(lib, 'fill'),
        'tie': Cell.create(lib, 'tie'),
        'tie_poly': Cell.create(lib, 'tie_poly'),
        'fill_w2': Cell.create(lib, 'fill_w2'),
        'tie_w2': Cell.create(lib, 'tie_w2'),
        'tie_diff_w2': Cell.create(lib, 'tie_diff_w2'),
        'tie_poly_w2': Cell.create(lib, 'tie_poly_w2'),
        'fill_w4': Cell.create(lib, 'fill_w4'),
        'tie_w4': Cell.create(lib, 'tie_w4'),
        'tie_diff_w4': Cell.create(lib, 'tie_diff_w4'),
        'tie_poly_w4': Cell.create(lib, 'tie_poly_w4'),
        'diode_w1': Cell.create(lib, 'diode_w1'),
        'zero_x1': Cell.create(lib, 'zero_x1'),
        'one_x1': Cell.create(lib, 'one_x1'),
        'zeroone_x1': Cell.create(lib, 'zeroone_x1'),
        'decap_w0': Cell.create(lib, 'decap_w0'),
        'inv_x0': Cell.create(lib, 'inv_x0'),
        'inv_x1': Cell.create(lib, 'inv_x1'),
        'inv_x2': Cell.create(lib, 'inv_x2'),
        'inv_x4': Cell.create(lib, 'inv_x4'),
        'buf_x1': Cell.create(lib, 'buf_x1'),
        'buf_x2': Cell.create(lib, 'buf_x2'),
        'buf_x4': Cell.create(lib, 'buf_x4'),
        'nand2_x0': Cell.create(lib, 'nand2_x0'),
        'nand2_x1': Cell.create(lib, 'nand2_x1'),
        'nand3_x0': Cell.create(lib, 'nand3_x0'),
        'nand3_x1': Cell.create(lib, 'nand3_x1'),
        'nand4_x0': Cell.create(lib, 'nand4_x0'),
        'nand4_x1': Cell.create(lib, 'nand4_x1'),
        'and2_x1': Cell.create(lib, 'and2_x1'),
        'and3_x1': Cell.create(lib, 'and3_x1'),
        'and4_x1': Cell.create(lib, 'and4_x1'),
        'nor2_x0': Cell.create(lib, 'nor2_x0'),
        'nor2_x1': Cell.create(lib, 'nor2_x1'),
        'nor3_x0': Cell.create(lib, 'nor3_x0'),
        'nor3_x1': Cell.create(lib, 'nor3_x1'),
        'nor4_x0': Cell.create(lib, 'nor4_x0'),
        'nor4_x1': Cell.create(lib, 'nor4_x1'),
        'or2_x1': Cell.create(lib, 'or2_x1'),
        'or3_x1': Cell.create(lib, 'or3_x1'),
        'or4_x1': Cell.create(lib, 'or4_x1'),
        'mux2_x1': Cell.create(lib, 'mux2_x1'),
        'and21nor_x0': Cell.create(lib, 'and21nor_x0'),
        'and21nor_x1': Cell.create(lib, 'and21nor_x1'),
        'or21nand_x0': Cell.create(lib, 'or21nand_x0'),
        'or21nand_x1': Cell.create(lib, 'or21nand_x1'),
        'xor2_x0': Cell.create(lib, 'xor2_x0'),
        'nexor2_x0': Cell.create(lib, 'nexor2_x0'),
        'nsnrlatch_x0': Cell.create(lib, 'nsnrlatch_x0'),
        'nsnrlatch_x1': Cell.create(lib, 'nsnrlatch_x1'),
        'dff_x1': Cell.create(lib, 'dff_x1'),
        'dffnr_x1': Cell.create(lib, 'dffnr_x1'),
        'Gallery': Cell.create(lib, 'Gallery'),
    }

    cell = new_cells['fill']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(1.0,6.8),(1.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(1.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(1.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(1.62,7.42),(1.62,3.4),(-0.62,3.4)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(1.0,1.22),(1.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(1.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(1.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(1.27,7.07),(1.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.0,0.0),(0.0,0.31),(1.0,0.31),(1.0,0.0),(0.0,0.0)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.25,6.385),(0.25,6.705),(0.75,6.705),(0.75,6.385),(0.25,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(1.0,6.8),(1.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(1.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(1.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.13,6.085),(-0.13,7.005),(1.13,7.005),(1.13,6.085),(-0.13,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(1.62,7.42),(1.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(1.205,7.005),(1.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.18,6.395),(0.18,6.695),(0.82,6.695),(0.82,6.395),(0.18,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(0.895,6.695),(0.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.25,6.465),(0.25,6.625),(0.41,6.625),(0.41,6.465),(0.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.59,6.465),(0.59,6.625),(0.75,6.625),(0.75,6.465),(0.59,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(1.0,1.22),(1.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.25,0.095),(0.25,0.415),(0.75,0.415),(0.75,0.095),(0.25,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(1.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(1.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.18,0.105),(0.18,0.405),(0.82,0.405),(0.82,0.105),(0.18,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(0.895,0.405),(0.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.25,0.175),(0.25,0.335),(0.41,0.335),(0.41,0.175),(0.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.59,0.175),(0.59,0.335),(0.75,0.335),(0.75,0.175),(0.59,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(1.27,7.07),(1.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.0,-0.075),(0.0,0.585),(1.0,0.585),(1.0,-0.075),(0.0,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.075,0.585),(1.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(1.075,6.21),(1.075,3.4),(-0.075,3.4)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.25,6.385),(0.25,6.705),(0.75,6.705),(0.75,6.385),(0.25,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(1.0,6.8),(1.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(1.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(1.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.13,6.085),(-0.13,7.005),(1.13,7.005),(1.13,6.085),(-0.13,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(1.62,7.42),(1.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(1.205,7.005),(1.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.18,6.395),(0.18,6.695),(0.82,6.695),(0.82,6.395),(0.18,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(0.895,6.695),(0.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.25,6.465),(0.25,6.625),(0.41,6.625),(0.41,6.465),(0.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.59,6.465),(0.59,6.625),(0.75,6.625),(0.75,6.465),(0.59,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(1.0,1.22),(1.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.25,0.095),(0.25,0.415),(0.75,0.415),(0.75,0.095),(0.25,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.42,0.465),(0.42,0.785),(0.58,0.785),(0.58,0.465),(0.42,0.465)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(1.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(1.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.18,0.105),(0.18,0.405),(0.82,0.405),(0.82,0.105),(0.18,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(0.895,0.405),(0.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,0.545),(0.42,0.705),(0.58,0.705),(0.58,0.545),(0.42,0.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.25,0.175),(0.25,0.335),(0.41,0.335),(0.41,0.175),(0.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.59,0.175),(0.59,0.335),(0.75,0.335),(0.75,0.175),(0.59,0.175)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.35,0.475),(0.35,0.775),(0.65,0.775),(0.65,0.475),(0.35,0.475)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.09,0.475),(0.09,6.325),(0.91,6.325),(0.91,0.475),(0.09,0.475)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(1.27,7.07),(1.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.0,-0.075),(0.0,0.585),(1.0,0.585),(1.0,-0.075),(0.0,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.075,0.585),(1.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(1.075,6.21),(1.075,3.4),(-0.075,3.4)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['fill_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.0,0.0),(0.0,0.31),(2.0,0.31),(2.0,0.0),(0.0,0.0)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(2.075,6.21),(2.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_diff_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.125,3.71),(0.125,7.005),(1.875,7.005),(1.875,3.71),(0.125,3.71)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.435,4.02),(0.435,6.695),(1.565,6.695),(1.565,4.02),(0.435,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.435,0.105),(0.435,2.78),(1.565,2.78),(1.565,0.105),(0.435,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.255,-0.075),(0.255,2.96),(1.745,2.96),(1.745,-0.075),(0.255,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.92,0.465),(0.92,0.785),(1.08,0.785),(1.08,0.465),(0.92,0.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.545),(0.92,0.705),(1.08,0.705),(1.08,0.545),(0.92,0.545)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.09,0.475),(0.09,6.325),(1.91,6.325),(1.91,0.475),(0.09,0.475)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.85,0.475),(0.85,0.775),(1.15,0.775),(1.15,0.475),(0.85,0.475)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(2.075,6.21),(2.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['fill_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.0,0.0),(0.0,0.31),(4.0,0.31),(4.0,0.0),(0.0,0.0)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_diff_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.125,3.71),(0.125,7.005),(3.875,7.005),(3.875,3.71),(0.125,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.435,4.02),(0.435,6.695),(3.565,6.695),(3.565,4.02),(0.435,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.435,0.105),(0.435,2.78),(3.565,2.78),(3.565,0.105),(0.435,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.255,-0.075),(0.255,2.96),(3.745,2.96),(3.745,-0.075),(0.255,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.92,0.465),(1.92,0.785),(2.08,0.785),(2.08,0.465),(1.92,0.465)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.545),(1.92,0.705),(2.08,0.705),(2.08,0.545),(1.92,0.545)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.09,0.475),(0.09,6.325),(3.91,6.325),(3.91,0.475),(0.09,0.475)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.85,0.475),(1.85,0.775),(2.15,0.775),(2.15,0.475),(1.85,0.475)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['diode_w1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.25,6.385),(0.25,6.705),(0.75,6.705),(0.75,6.385),(0.25,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(1.0,6.8),(1.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(1.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(1.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.13,6.085),(-0.13,7.005),(1.13,7.005),(1.13,6.085),(-0.13,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(1.62,7.42),(1.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.04,3.71),(0.04,5.67),(0.96,5.67),(0.96,3.71),(0.04,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(1.205,7.005),(1.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.18,6.395),(0.18,6.695),(0.82,6.695),(0.82,6.395),(0.18,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(0.895,6.695),(0.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.25,6.465),(0.25,6.625),(0.41,6.625),(0.41,6.465),(0.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.59,6.465),(0.59,6.625),(0.75,6.625),(0.75,6.465),(0.59,6.465)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(1.0,1.22),(1.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.25,0.095),(0.25,0.415),(0.75,0.415),(0.75,0.095),(0.25,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(1.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(1.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.18,0.105),(0.18,0.405),(0.82,0.405),(0.82,0.105),(0.18,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(0.895,0.405),(0.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.25,0.175),(0.25,0.335),(0.41,0.335),(0.41,0.175),(0.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.59,0.175),(0.59,0.335),(0.75,0.335),(0.75,0.175),(0.59,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(1.27,7.07),(1.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.0,-0.075),(0.0,0.585),(1.0,0.585),(1.0,-0.075),(0.0,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.075,0.585),(1.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(1.075,6.21),(1.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.17,3.84),(0.17,5.54),(0.83,5.54),(0.83,3.84),(0.17,3.84)),
        )
        net = nets['i']
        createRL(
            tech, net, 'Activ',
            ((0.35,4.02),(0.35,5.36),(0.65,5.36),(0.65,4.02),(0.35,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.35,1.44),(0.35,2.78),(0.65,2.78),(0.65,1.44),(0.35,1.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,4.1),(0.42,4.26),(0.58,4.26),(0.58,4.1),(0.42,4.1)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,4.44),(0.42,4.6),(0.58,4.6),(0.58,4.44),(0.42,4.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,4.78),(0.42,4.94),(0.58,4.94),(0.58,4.78),(0.42,4.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,5.12),(0.42,5.28),(0.58,5.28),(0.58,5.12),(0.42,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,1.52),(0.42,1.68),(0.58,1.68),(0.58,1.52),(0.42,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,1.86),(0.42,2.02),(0.58,2.02),(0.58,1.86),(0.42,1.86)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,2.2),(0.42,2.36),(0.58,2.36),(0.58,2.2),(0.42,2.2)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.42,2.54),(0.42,2.7),(0.58,2.7),(0.58,2.54),(0.42,2.54)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.42,4.02),(0.42,5.36),(0.58,5.36),(0.58,4.02),(0.42,4.02)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.42,1.44),(0.42,2.78),(0.58,2.78),(0.58,1.44),(0.42,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.395,1.44),(0.395,5.36),(0.605,5.36),(0.605,1.44),(0.395,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.5), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.5), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)

    cell = new_cells['zero_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.215),(0.105,5.195),(0.405,5.195),(0.405,4.215),(0.105,4.215)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.285),(0.175,4.445),(0.335,4.445),(0.335,4.285),(0.175,4.285)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.625),(0.175,4.785),(0.335,4.785),(0.335,4.625),(0.175,4.625)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.965),(0.175,5.125),(0.335,5.125),(0.335,4.965),(0.175,4.965)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.05),(0.175,5.36),(0.335,5.36),(0.335,4.05),(0.175,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.205),(0.175,5.205),(0.335,5.205),(0.335,4.205),(0.175,4.205)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,2.97),(0.15,4.37),(0.36,4.37),(0.36,2.97),(0.15,2.97)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(0.67,3.28),(0.67,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.28),(0.895,3.28),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.815),(-0.075,5.595),(0.585,5.595),(0.585,3.815),(-0.075,3.815)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(2.075,6.21),(2.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.415,6.21),(1.415,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.905),(-0.205,5.505),(0.715,5.505),(0.715,3.905),(-0.205,3.905)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.545,6.12),(1.545,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.235,5.81),(1.235,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['zero']
        createRL(
            tech, net, 'Activ',
            ((0.935,1.605),(0.935,2.585),(1.235,2.585),(1.235,1.605),(0.935,1.605)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.235,2.78),(1.235,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,3.52),(0.67,3.82),(1.085,3.82),(1.085,3.52),(0.67,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.52),(0.445,5.99),(0.895,5.99),(0.895,3.52),(0.445,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.935,3.52),(0.935,3.82),(1.235,3.82),(1.235,3.52),(0.935,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.675),(1.005,1.835),(1.165,1.835),(1.165,1.675),(1.005,1.675)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.015),(1.005,2.175),(1.165,2.175),(1.165,2.015),(1.005,2.015)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.355),(1.005,2.515),(1.165,2.515),(1.165,2.355),(1.005,2.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,3.59),(1.005,3.75),(1.165,3.75),(1.165,3.59),(1.005,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.75),(1.165,2.75),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,3.51),(1.005,3.83),(1.165,3.83),(1.165,3.51),(1.005,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.595),(1.005,2.595),(1.165,2.595),(1.165,1.595),(1.005,1.595)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,1.44),(0.98,5.36),(1.19,5.36),(1.19,1.44),(0.98,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['zero'].setDirection(Net.Direction.OUT)

    cell = new_cells['one_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.215),(0.105,5.195),(0.405,5.195),(0.405,4.215),(0.105,4.215)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.285),(0.175,4.445),(0.335,4.445),(0.335,4.285),(0.175,4.285)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.625),(0.175,4.785),(0.335,4.785),(0.335,4.625),(0.175,4.625)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.965),(0.175,5.125),(0.335,5.125),(0.335,4.965),(0.175,4.965)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.05),(0.175,5.36),(0.335,5.36),(0.335,4.05),(0.175,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.205),(0.175,5.205),(0.335,5.205),(0.335,4.205),(0.175,4.205)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(0.67,3.28),(0.67,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.28),(0.895,3.28),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.815),(-0.075,5.595),(0.585,5.595),(0.585,3.815),(-0.075,3.815)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(2.075,6.21),(2.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.415,6.21),(1.415,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.905),(-0.205,5.505),(0.715,5.505),(0.715,3.905),(-0.205,3.905)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.545,6.12),(1.545,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.235,5.81),(1.235,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['zero']
        createRL(
            tech, net, 'Activ',
            ((0.935,1.605),(0.935,2.585),(1.235,2.585),(1.235,1.605),(0.935,1.605)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.235,2.78),(1.235,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,3.52),(0.67,3.82),(1.085,3.82),(1.085,3.52),(0.67,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.52),(0.445,5.99),(0.895,5.99),(0.895,3.52),(0.445,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.935,3.52),(0.935,3.82),(1.235,3.82),(1.235,3.52),(0.935,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.675),(1.005,1.835),(1.165,1.835),(1.165,1.675),(1.005,1.675)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.015),(1.005,2.175),(1.165,2.175),(1.165,2.015),(1.005,2.015)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.355),(1.005,2.515),(1.165,2.515),(1.165,2.355),(1.005,2.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,3.59),(1.005,3.75),(1.165,3.75),(1.165,3.59),(1.005,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.75),(1.165,2.75),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,3.51),(1.005,3.83),(1.165,3.83),(1.165,3.51),(1.005,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,2.43),(0.98,3.83),(1.19,3.83),(1.19,2.43),(0.98,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.595),(1.005,2.595),(1.165,2.595),(1.165,1.595),(1.005,1.595)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['one'].setDirection(Net.Direction.OUT)

    cell = new_cells['zeroone_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.215),(0.105,5.195),(0.405,5.195),(0.405,4.215),(0.105,4.215)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.285),(0.175,4.445),(0.335,4.445),(0.335,4.285),(0.175,4.285)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.625),(0.175,4.785),(0.335,4.785),(0.335,4.625),(0.175,4.625)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.965),(0.175,5.125),(0.335,5.125),(0.335,4.965),(0.175,4.965)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.05),(0.175,5.36),(0.335,5.36),(0.335,4.05),(0.175,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.205),(0.175,5.205),(0.335,5.205),(0.335,4.205),(0.175,4.205)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(0.67,3.28),(0.67,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.28),(0.895,3.28),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.815),(-0.075,5.595),(0.585,5.595),(0.585,3.815),(-0.075,3.815)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(2.075,6.21),(2.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.415,6.21),(1.415,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.905),(-0.205,5.505),(0.715,5.505),(0.715,3.905),(-0.205,3.905)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.545,6.12),(1.545,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.235,5.81),(1.235,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['zero']
        createRL(
            tech, net, 'Activ',
            ((0.935,1.605),(0.935,2.585),(1.235,2.585),(1.235,1.605),(0.935,1.605)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.235,2.78),(1.235,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,3.52),(0.67,3.82),(1.085,3.82),(1.085,3.52),(0.67,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.52),(0.445,5.99),(0.895,5.99),(0.895,3.52),(0.445,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.935,3.52),(0.935,3.82),(1.235,3.82),(1.235,3.52),(0.935,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.675),(1.005,1.835),(1.165,1.835),(1.165,1.675),(1.005,1.675)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.015),(1.005,2.175),(1.165,2.175),(1.165,2.015),(1.005,2.015)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.355),(1.005,2.515),(1.165,2.515),(1.165,2.355),(1.005,2.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,3.59),(1.005,3.75),(1.165,3.75),(1.165,3.59),(1.005,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.75),(1.165,2.75),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,3.51),(1.005,3.83),(1.165,3.83),(1.165,3.51),(1.005,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.595),(1.005,2.595),(1.165,2.595),(1.165,1.595),(1.005,1.595)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,1.44),(0.98,5.36),(1.19,5.36),(1.19,1.44),(0.98,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['one'].setDirection(Net.Direction.OUT)
        nets['zero'].setDirection(Net.Direction.OUT)

    cell = new_cells['decap_w0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.215),(0.105,5.195),(0.405,5.195),(0.405,4.215),(0.105,4.215)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.285),(0.175,4.445),(0.335,4.445),(0.335,4.285),(0.175,4.285)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.625),(0.175,4.785),(0.335,4.785),(0.335,4.625),(0.175,4.625)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.965),(0.175,5.125),(0.335,5.125),(0.335,4.965),(0.175,4.965)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.05),(0.175,5.36),(0.335,5.36),(0.335,4.05),(0.175,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.205),(0.175,5.205),(0.335,5.205),(0.335,4.205),(0.175,4.205)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,2.97),(0.15,4.37),(0.36,4.37),(0.36,2.97),(0.15,2.97)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(0.67,3.28),(0.67,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.28),(0.895,3.28),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.815),(-0.075,5.595),(0.585,5.595),(0.585,3.815),(-0.075,3.815)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(2.075,6.21),(2.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.415,6.21),(1.415,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.905),(-0.205,5.505),(0.715,5.505),(0.715,3.905),(-0.205,3.905)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.545,6.12),(1.545,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.235,5.81),(1.235,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['zero']
        createRL(
            tech, net, 'Activ',
            ((0.935,1.605),(0.935,2.585),(1.235,2.585),(1.235,1.605),(0.935,1.605)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.235,2.78),(1.235,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,3.52),(0.67,3.82),(1.085,3.82),(1.085,3.52),(0.67,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.52),(0.445,5.99),(0.895,5.99),(0.895,3.52),(0.445,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.935,3.52),(0.935,3.82),(1.235,3.82),(1.235,3.52),(0.935,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.675),(1.005,1.835),(1.165,1.835),(1.165,1.675),(1.005,1.675)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.015),(1.005,2.175),(1.165,2.175),(1.165,2.015),(1.005,2.015)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.355),(1.005,2.515),(1.165,2.515),(1.165,2.355),(1.005,2.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,3.59),(1.005,3.75),(1.165,3.75),(1.165,3.59),(1.005,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.75),(1.165,2.75),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,3.51),(1.005,3.83),(1.165,3.83),(1.165,3.51),(1.005,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,2.43),(0.98,3.83),(1.19,3.83),(1.19,2.43),(0.98,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.595),(1.005,2.595),(1.165,2.595),(1.165,1.595),(1.005,1.595)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['inv_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.545,6.12),(1.545,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,5.66),(1.545,5.66),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,5.75),(1.415,5.75),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(2.075,6.21),(2.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.415,6.21),(1.415,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.45),(0.935,1.75),(1.235,1.75),(1.235,1.45),(0.935,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.235,5.81),(1.235,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.35),(1.235,5.35),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.235,1.75),(1.235,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.52),(1.005,1.68),(1.165,1.68),(1.165,1.52),(1.005,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.12),(1.005,5.28),(1.165,5.28),(1.165,5.12),(1.005,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,1.44),(0.98,5.36),(1.19,5.36),(1.19,1.44),(0.98,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,5.04),(1.005,5.36),(1.165,5.36),(1.165,5.04),(1.005,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,1.76),(1.165,1.76),(1.165,1.44),(1.005,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.17,0.105),(0.17,0.405),(1.83,0.405),(1.83,0.105),(0.17,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.895,0.405),(1.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,0.175),(0.24,0.335),(0.4,0.335),(0.4,0.175),(0.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,0.175),(0.58,0.335),(0.74,0.335),(0.74,0.175),(0.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,0.175),(0.92,0.335),(1.08,0.335),(1.08,0.175),(0.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,0.175),(1.26,0.335),(1.42,0.335),(1.42,0.175),(1.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,0.175),(1.6,0.335),(1.76,0.335),(1.76,0.175),(1.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,0.095),(0.24,0.415),(1.76,0.415),(1.76,0.095),(0.24,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(2.0,1.22),(2.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.17,6.395),(0.17,6.695),(1.83,6.695),(1.83,6.395),(0.17,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(1.895,6.695),(1.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.14,6.085),(-0.14,7.005),(2.14,7.005),(2.14,6.085),(-0.14,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(2.205,7.005),(2.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.545,6.12),(1.545,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(2.62,7.42),(2.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.715),(0.625,5.655),(1.545,5.655),(1.545,3.715),(0.625,3.715)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.24,6.465),(0.24,6.625),(0.4,6.625),(0.4,6.465),(0.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.58,6.465),(0.58,6.625),(0.74,6.625),(0.74,6.465),(0.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.92,6.465),(0.92,6.625),(1.08,6.625),(1.08,6.465),(0.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.26,6.465),(1.26,6.625),(1.42,6.625),(1.42,6.465),(1.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.6,6.465),(1.6,6.625),(1.76,6.625),(1.76,6.465),(1.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.24,6.385),(0.24,6.705),(1.76,6.705),(1.76,6.385),(0.24,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(2.0,6.8),(2.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.0), u(2.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.625),(0.755,5.745),(1.415,5.745),(1.415,3.625),(0.755,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.01,-0.075),(-0.01,0.585),(2.01,0.585),(2.01,-0.075),(-0.01,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(2.075,6.21),(2.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.415,6.21),(1.415,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.075,0.585),(2.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(2.27,7.07),(2.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.235,2.78),(1.235,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.025),(0.935,5.345),(1.235,5.345),(1.235,4.025),(0.935,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.235,5.81),(1.235,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.455),(0.935,2.775),(1.235,2.775),(1.235,1.455),(0.935,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.095),(1.005,4.255),(1.165,4.255),(1.165,4.095),(1.005,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.435),(1.005,4.595),(1.165,4.595),(1.165,4.435),(1.005,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.775),(1.005,4.935),(1.165,4.935),(1.165,4.775),(1.005,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.115),(1.005,5.275),(1.165,5.275),(1.165,5.115),(1.005,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.525),(1.005,1.685),(1.165,1.685),(1.165,1.525),(1.005,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.865),(1.005,2.025),(1.165,2.025),(1.165,1.865),(1.005,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.205),(1.005,2.365),(1.165,2.365),(1.165,2.205),(1.005,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.545),(1.005,2.705),(1.165,2.705),(1.165,2.545),(1.005,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.785),(1.165,2.785),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.445),(1.005,2.785),(1.165,2.785),(1.165,1.445),(1.005,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.36),(1.165,5.36),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,1.44),(0.98,5.36),(1.19,5.36),(1.19,1.44),(0.98,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.355),(1.165,5.355),(1.165,4.015),(1.005,4.015)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.065,2.78),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.065,5.81),(2.065,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.715),(0.625,5.655),(1.545,5.655),(1.545,3.715),(0.625,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.375,6.12),(2.375,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.245,6.21),(2.245,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.625),(0.755,5.745),(1.415,5.745),(1.415,3.625),(0.755,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.025),(0.935,5.345),(1.235,5.345),(1.235,4.025),(0.935,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.455),(0.935,2.775),(1.235,2.775),(1.235,1.455),(0.935,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.095),(1.005,4.255),(1.165,4.255),(1.165,4.095),(1.005,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.435),(1.005,4.595),(1.165,4.595),(1.165,4.435),(1.005,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.775),(1.005,4.935),(1.165,4.935),(1.165,4.775),(1.005,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.115),(1.005,5.275),(1.165,5.275),(1.165,5.115),(1.005,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.525),(1.005,1.685),(1.165,1.685),(1.165,1.525),(1.005,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.865),(1.005,2.025),(1.165,2.025),(1.165,1.865),(1.005,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.205),(1.005,2.365),(1.165,2.365),(1.165,2.205),(1.005,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.545),(1.005,2.705),(1.165,2.705),(1.165,2.545),(1.005,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.785),(1.165,2.785),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.445),(1.005,2.785),(1.165,2.785),(1.165,1.445),(1.005,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.36),(1.165,5.36),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,1.44),(0.98,5.36),(1.19,5.36),(1.19,1.44),(0.98,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.355),(1.165,5.355),(1.165,4.015),(1.005,4.015)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(1.5,3.55),(1.5,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.78),(2.555,2.78),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,2.78),(3.385,2.78),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.29),(3.725,1.29),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.78),(2.105,2.78),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,2.78),(3.725,2.78),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.035,2.78),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.725,2.78),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,2.78),(3.615,2.78),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.06),(3.495,1.22),(3.655,1.22),(3.655,1.06),(3.495,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,1.06),(3.415,1.22),(3.735,1.22),(3.735,1.06),(3.415,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.02),(2.105,5.81),(2.555,5.81),(2.555,4.02),(2.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,4.02),(2.935,5.81),(3.385,5.81),(3.385,4.02),(2.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.51),(3.425,5.81),(3.725,5.81),(3.725,5.51),(3.425,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,4.02),(3.425,5.81),(3.725,5.81),(3.725,4.02),(3.425,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.02),(1.875,5.81),(2.105,5.81),(2.105,4.02),(1.875,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.035,5.81),(2.035,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,4.02),(3.385,5.81),(3.615,5.81),(3.615,4.02),(3.385,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.725,5.81),(3.725,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.715),(2.285,5.655),(3.205,5.655),(3.205,3.715),(2.285,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.175,6.12),(3.175,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,5.2),(3.115,6.12),(4.035,6.12),(4.035,5.2),(3.115,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.035,6.12),(4.035,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.345,6.12),(2.345,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,3.71),(3.115,6.12),(4.035,6.12),(4.035,3.71),(3.115,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.71),(2.285,6.12),(3.205,6.12),(3.205,3.71),(2.285,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.71),(1.565,6.12),(3.095,6.12),(3.095,3.71),(1.565,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.715),(0.625,5.655),(1.545,5.655),(1.545,3.715),(0.625,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,3.71),(2.395,6.12),(3.925,6.12),(3.925,3.71),(2.395,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.58),(3.495,5.74),(3.655,5.74),(3.655,5.58),(3.495,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,5.58),(3.415,5.74),(3.735,5.74),(3.735,5.58),(3.415,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((3.245,3.62),(3.245,6.21),(3.905,6.21),(3.905,3.62),(3.245,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.625),(2.415,5.745),(3.075,5.745),(3.075,3.625),(2.415,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,5.11),(3.245,6.21),(3.905,6.21),(3.905,5.11),(3.245,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.62),(1.705,6.21),(2.955,6.21),(2.955,3.62),(1.705,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,3.84),(2.525,5.99),(3.795,5.99),(3.795,3.84),(2.525,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.62),(2.535,6.21),(3.785,6.21),(3.785,3.62),(2.535,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.625),(0.755,5.745),(1.415,5.745),(1.415,3.625),(0.755,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.62),(2.415,6.21),(3.075,6.21),(3.075,3.62),(2.415,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.84),(1.695,5.99),(2.965,5.99),(2.965,3.84),(1.695,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.215,6.21),(2.215,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.045,6.21),(3.045,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.905,6.21),(3.905,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,3.05),(3.055,3.05),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.76),(1.765,6.07),(2.895,6.07),(2.895,3.76),(1.765,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,3.76),(2.595,6.07),(3.725,6.07),(3.725,3.76),(2.595,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,3.75),(2.435,6.08),(3.885,6.08),(3.885,3.75),(2.435,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,3.04),(2.895,3.04),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,3.04),(3.725,3.04),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.75),(1.605,6.08),(3.055,6.08),(3.055,3.75),(1.605,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,3.05),(3.885,3.05),(3.885,0.72),(2.435,0.72)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,2.78),(2.895,2.78),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,4.02),(2.705,5.81),(2.935,5.81),(2.935,4.02),(2.705,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.865,2.78),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.865,5.81),(2.865,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,2.78),(2.935,2.78),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.02),(2.595,5.81),(2.895,5.81),(2.895,4.02),(2.595,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.025),(2.595,5.345),(2.895,5.345),(2.895,4.025),(2.595,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.78),(2.785,2.78),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.025),(0.935,5.345),(1.235,5.345),(1.235,4.025),(0.935,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.455),(0.935,2.775),(1.235,2.775),(1.235,1.455),(0.935,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.455),(2.595,2.775),(2.895,2.775),(2.895,1.455),(2.595,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.02),(2.555,5.81),(2.785,5.81),(2.785,4.02),(2.555,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.095),(2.665,4.255),(2.825,4.255),(2.825,4.095),(2.665,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.435),(2.665,4.595),(2.825,4.595),(2.825,4.435),(2.665,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.775),(2.665,4.935),(2.825,4.935),(2.825,4.775),(2.665,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.115),(2.665,5.275),(2.825,5.275),(2.825,5.115),(2.665,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.095),(1.005,4.255),(1.165,4.255),(1.165,4.095),(1.005,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.435),(1.005,4.595),(1.165,4.595),(1.165,4.435),(1.005,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.775),(1.005,4.935),(1.165,4.935),(1.165,4.775),(1.005,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.115),(1.005,5.275),(1.165,5.275),(1.165,5.115),(1.005,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.525),(2.665,1.685),(2.825,1.685),(2.825,1.525),(2.665,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.865),(2.665,2.025),(2.825,2.025),(2.825,1.865),(2.665,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,2.205),(2.665,2.365),(2.825,2.365),(2.825,2.205),(2.665,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,2.545),(2.665,2.705),(2.825,2.705),(2.825,2.545),(2.665,2.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.525),(1.005,1.685),(1.165,1.685),(1.165,1.525),(1.005,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.865),(1.005,2.025),(1.165,2.025),(1.165,1.865),(1.005,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.205),(1.005,2.365),(1.165,2.365),(1.165,2.205),(1.005,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.545),(1.005,2.705),(1.165,2.705),(1.165,2.545),(1.005,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,2.465),(2.64,4.335),(2.85,4.335),(2.85,2.465),(2.64,2.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.785),(1.165,2.785),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.445),(1.005,2.785),(1.165,2.785),(1.165,1.445),(1.005,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,3.24),(1.085,3.56),(2.745,3.56),(2.745,3.24),(1.085,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.36),(1.165,5.36),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,3.24),(0.98,3.56),(1.19,3.56),(1.19,3.24),(0.98,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.445),(2.665,2.785),(2.825,2.785),(2.825,1.445),(2.665,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,3.24),(2.64,3.56),(2.85,3.56),(2.85,3.24),(2.64,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.015),(2.665,5.36),(2.825,5.36),(2.825,4.015),(2.665,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.98,1.44),(0.98,5.36),(1.19,5.36),(1.19,1.44),(0.98,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.015),(2.665,5.355),(2.825,5.355),(2.825,4.015),(2.665,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.355),(1.165,5.355),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,2.785),(2.825,2.785),(2.825,1.44),(2.665,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.085), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,2.96),(3.385,2.96),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.84),(2.105,5.99),(2.555,5.99),(2.555,3.84),(2.105,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(3.16,3.55),(3.16,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,3.84),(2.935,5.99),(3.385,5.99),(3.385,3.84),(2.935,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.96),(2.555,2.96),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.84),(2.555,3.84),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,3.84),(3.385,3.84),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_i_n': Net.create(cell, '_i_n'),
            'i': Net.create(cell, 'i'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_i_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(1.53,3.55),(1.53,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.305,3.98),(1.305,5.99),(1.755,5.99),(1.755,3.98),(1.305,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.305,0.81),(1.305,2.82),(1.755,2.82),(1.755,0.81),(1.305,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.305,0.81),(1.305,3.98),(1.755,3.98),(1.755,0.81),(1.305,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.76),(0.785,6.21),(1.445,6.21),(1.445,3.76),(0.785,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,5.11),(0.785,6.21),(1.445,6.21),(1.445,5.11),(0.785,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.76),(1.615,6.21),(2.275,6.21),(2.275,3.76),(1.615,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.645,3.76),(1.645,6.21),(2.275,6.21),(2.275,3.76),(1.645,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.95),(1.615,5.73),(2.275,5.73),(2.275,3.95),(1.615,3.95)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.895,3.98),(0.895,5.99),(2.165,5.99),(2.165,3.98),(0.895,3.98)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.76),(0.785,6.21),(1.415,6.21),(1.415,3.76),(0.785,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.905,3.76),(0.905,6.21),(2.155,6.21),(2.155,3.76),(0.905,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.805,0.72),(0.805,2.91),(2.255,2.91),(2.255,0.72),(0.805,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.965,0.73),(0.965,2.9),(2.095,2.9),(2.095,0.73),(0.965,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.965,3.9),(0.965,6.07),(2.095,6.07),(2.095,3.9),(0.965,3.9)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.805,3.89),(0.805,6.08),(2.255,6.08),(2.255,3.89),(0.805,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.765,3.85),(0.765,6.12),(2.295,6.12),(2.295,3.85),(0.765,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.85),(1.485,6.12),(2.405,6.12),(2.405,3.85),(1.485,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,5.2),(0.655,6.12),(1.575,6.12),(1.575,5.2),(0.655,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.85),(0.655,6.12),(1.575,6.12),(1.575,3.85),(0.655,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.04),(1.485,5.64),(2.405,5.64),(2.405,4.04),(1.485,4.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.515,3.85),(1.515,6.12),(2.405,6.12),(2.405,3.85),(1.515,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.85),(0.655,6.12),(1.545,6.12),(1.545,3.85),(0.655,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.305,4.16),(1.305,5.81),(1.755,5.81),(1.755,4.16),(1.305,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.16),(0.965,5.81),(1.235,5.81),(1.235,4.16),(0.965,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.51),(0.965,5.81),(1.265,5.81),(1.265,5.51),(0.965,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.16),(0.965,5.81),(1.265,5.81),(1.265,4.16),(0.965,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.075,4.16),(1.075,5.81),(1.305,5.81),(1.305,4.16),(1.075,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.035,5.58),(1.035,5.74),(1.195,5.74),(1.195,5.58),(1.035,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.955,5.58),(0.955,5.74),(1.275,5.74),(1.275,5.58),(0.955,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.305,0.99),(1.305,2.64),(1.755,2.64),(1.755,0.99),(1.305,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.29),(1.265,1.29),(1.265,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.075,0.99),(1.075,2.64),(1.305,2.64),(1.305,0.99),(1.075,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.64),(1.265,2.64),(1.265,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.64),(1.235,2.64),(1.235,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.035,1.06),(1.035,1.22),(1.195,1.22),(1.195,1.06),(1.035,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.955,1.06),(0.955,1.22),(1.275,1.22),(1.275,1.06),(0.955,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.79),(0.445,5.99),(0.895,5.99),(0.895,3.79),(0.445,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.01),(0.895,3.01),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,3.79),(0.67,4.09),(0.685,4.09),(0.685,3.79),(0.67,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,2.71),(0.67,3.01),(0.685,3.01),(0.685,2.71),(0.67,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.71),(0.535,3.01),(0.835,3.01),(0.835,2.71),(0.535,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.79),(0.535,4.09),(0.835,4.09),(0.835,3.79),(0.535,3.79)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.86),(0.605,4.02),(0.765,4.02),(0.765,3.86),(0.605,3.86)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.78),(0.605,2.94),(0.765,2.94),(0.765,2.78),(0.605,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.7),(0.605,3.02),(0.765,3.02),(0.765,2.7),(0.605,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.78),(0.605,4.1),(0.765,4.1),(0.765,3.78),(0.605,3.78)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((1.795,4.16),(1.795,5.81),(2.095,5.81),(2.095,4.16),(1.795,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,1.47),(1.795,2.45),(2.095,2.45),(2.095,1.47),(1.795,1.47)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.825,0.99),(1.825,2.64),(2.095,2.64),(2.095,0.99),(1.825,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.64),(2.095,2.64),(2.095,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.35),(1.795,5.33),(2.095,5.33),(2.095,4.35),(1.795,4.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.825,4.16),(1.825,5.81),(2.095,5.81),(2.095,4.16),(1.825,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.755,4.16),(1.755,5.81),(1.985,5.81),(1.985,4.16),(1.755,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.755,0.99),(1.755,2.64),(1.985,2.64),(1.985,0.99),(1.755,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,1.54),(1.865,1.7),(2.025,1.7),(2.025,1.54),(1.865,1.54)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,1.88),(1.865,2.04),(2.025,2.04),(2.025,1.88),(1.865,1.88)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,2.22),(1.865,2.38),(2.025,2.38),(2.025,2.22),(1.865,2.22)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,4.42),(1.865,4.58),(2.025,4.58),(2.025,4.42),(1.865,4.42)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,4.76),(1.865,4.92),(2.025,4.92),(2.025,4.76),(1.865,4.76)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,5.1),(1.865,5.26),(2.025,5.26),(2.025,5.1),(1.865,5.1)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.865,4.34),(1.865,5.34),(2.025,5.34),(2.025,4.34),(1.865,4.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.865,4.32),(1.865,5.36),(2.025,5.36),(2.025,4.32),(1.865,4.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.84,1.44),(1.84,5.36),(2.05,5.36),(2.05,1.44),(1.84,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.865,1.46),(1.865,2.46),(2.025,2.46),(2.025,1.46),(1.865,1.46)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.865,1.44),(1.865,2.48),(2.025,2.48),(2.025,1.44),(1.865,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.945), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.945), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_i_n': Net.create(cell, '_i_n'),
            'i': Net.create(cell, 'i'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_i_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(2.36,3.55),(2.36,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,3.98),(2.135,5.99),(2.585,5.99),(2.585,3.98),(2.135,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.305,3.98),(1.305,5.99),(1.755,5.99),(1.755,3.98),(1.305,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,0.81),(2.135,2.82),(2.585,2.82),(2.585,0.81),(2.135,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.305,0.81),(1.305,2.82),(1.755,2.82),(1.755,0.81),(1.305,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.305,0.81),(1.305,3.98),(1.755,3.98),(1.755,0.81),(1.305,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,0.81),(2.135,3.98),(2.585,3.98),(2.585,0.81),(2.135,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.645,3.76),(1.645,6.21),(2.245,6.21),(2.245,3.76),(1.645,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.76),(2.445,6.21),(3.105,6.21),(3.105,3.76),(2.445,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.76),(0.785,6.21),(1.415,6.21),(1.415,3.76),(0.785,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.76),(1.735,6.21),(2.985,6.21),(2.985,3.76),(1.735,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.725,3.98),(1.725,5.99),(2.995,5.99),(2.995,3.98),(1.725,3.98)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,5.11),(2.445,6.21),(3.105,6.21),(3.105,5.11),(2.445,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.95),(1.615,5.73),(2.275,5.73),(2.275,3.95),(1.615,3.95)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.905,3.76),(0.905,6.21),(2.155,6.21),(2.155,3.76),(0.905,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.475,3.76),(2.475,6.21),(3.105,6.21),(3.105,3.76),(2.475,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.76),(0.785,6.21),(1.445,6.21),(1.445,3.76),(0.785,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,5.11),(0.785,6.21),(1.445,6.21),(1.445,5.11),(0.785,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.895,3.98),(0.895,5.99),(2.165,5.99),(2.165,3.98),(0.895,3.98)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.76),(1.615,6.21),(2.275,6.21),(2.275,3.76),(1.615,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.805,0.72),(0.805,2.91),(2.255,2.91),(2.255,0.72),(0.805,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.965,0.73),(0.965,2.9),(2.095,2.9),(2.095,0.73),(0.965,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.635,0.72),(1.635,2.91),(3.085,2.91),(3.085,0.72),(1.635,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.965,3.9),(0.965,6.07),(2.095,6.07),(2.095,3.9),(0.965,3.9)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.635,3.89),(1.635,6.08),(3.085,6.08),(3.085,3.89),(1.635,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.795,3.9),(1.795,6.07),(2.925,6.07),(2.925,3.9),(1.795,3.9)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.805,3.89),(0.805,6.08),(2.255,6.08),(2.255,3.89),(0.805,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.795,0.73),(1.795,2.9),(2.925,2.9),(2.925,0.73),(1.795,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((2.315,3.85),(2.315,6.12),(3.235,6.12),(3.235,3.85),(2.315,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.765,3.85),(0.765,6.12),(2.295,6.12),(2.295,3.85),(0.765,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.85),(1.485,6.12),(2.405,6.12),(2.405,3.85),(1.485,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.515,3.85),(1.515,6.12),(2.375,6.12),(2.375,3.85),(1.515,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.345,3.85),(2.345,6.12),(3.235,6.12),(3.235,3.85),(2.345,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,5.2),(0.655,6.12),(1.575,6.12),(1.575,5.2),(0.655,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,5.2),(2.315,6.12),(3.235,6.12),(3.235,5.2),(2.315,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.85),(0.655,6.12),(1.575,6.12),(1.575,3.85),(0.655,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.04),(1.485,5.64),(2.405,5.64),(2.405,4.04),(1.485,4.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.595,3.85),(1.595,6.12),(3.125,6.12),(3.125,3.85),(1.595,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.85),(0.655,6.12),(1.545,6.12),(1.545,3.85),(0.655,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.51),(2.625,5.81),(2.925,5.81),(2.925,5.51),(2.625,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.305,4.16),(1.305,5.81),(1.755,5.81),(1.755,4.16),(1.305,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.16),(2.625,5.81),(2.925,5.81),(2.925,4.16),(2.625,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.585,4.16),(2.585,5.81),(2.815,5.81),(2.815,4.16),(2.585,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.51),(0.965,5.81),(1.265,5.81),(1.265,5.51),(0.965,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.16),(0.965,5.81),(1.235,5.81),(1.235,4.16),(0.965,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.655,4.16),(2.655,5.81),(2.925,5.81),(2.925,4.16),(2.655,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.16),(0.965,5.81),(1.265,5.81),(1.265,4.16),(0.965,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.075,4.16),(1.075,5.81),(1.305,5.81),(1.305,4.16),(1.075,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,4.16),(2.135,5.81),(2.585,5.81),(2.585,4.16),(2.135,4.16)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.58),(2.695,5.74),(2.855,5.74),(2.855,5.58),(2.695,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.035,5.58),(1.035,5.74),(1.195,5.74),(1.195,5.58),(1.035,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.955,5.58),(0.955,5.74),(1.275,5.74),(1.275,5.58),(0.955,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,5.58),(2.615,5.74),(2.935,5.74),(2.935,5.58),(2.615,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.64),(2.925,2.64),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.305,0.99),(1.305,2.64),(1.755,2.64),(1.755,0.99),(1.305,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.29),(1.265,1.29),(1.265,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.29),(2.925,1.29),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.075,0.99),(1.075,2.64),(1.305,2.64),(1.305,0.99),(1.075,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,0.99),(2.135,2.64),(2.585,2.64),(2.585,0.99),(2.135,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.585,0.99),(2.585,2.64),(2.815,2.64),(2.815,0.99),(2.585,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.64),(1.265,2.64),(1.265,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.64),(1.235,2.64),(1.235,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.655,0.99),(2.655,2.64),(2.925,2.64),(2.925,0.99),(2.655,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.06),(2.695,1.22),(2.855,1.22),(2.855,1.06),(2.695,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.035,1.06),(1.035,1.22),(1.195,1.22),(1.195,1.06),(1.035,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.955,1.06),(0.955,1.22),(1.275,1.22),(1.275,1.06),(0.955,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,1.06),(2.615,1.22),(2.935,1.22),(2.935,1.06),(2.615,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.79),(0.445,5.99),(0.895,5.99),(0.895,3.79),(0.445,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.01),(0.895,3.01),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,3.79),(0.67,4.09),(0.685,4.09),(0.685,3.79),(0.67,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,2.71),(0.67,3.01),(0.685,3.01),(0.685,2.71),(0.67,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.71),(0.535,3.01),(0.835,3.01),(0.835,2.71),(0.535,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.79),(0.535,4.09),(0.835,4.09),(0.835,3.79),(0.535,3.79)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.86),(0.605,4.02),(0.765,4.02),(0.765,3.86),(0.605,3.86)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.78),(0.605,2.94),(0.765,2.94),(0.765,2.78),(0.605,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.7),(0.605,3.02),(0.765,3.02),(0.765,2.7),(0.605,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.78),(0.605,4.1),(0.765,4.1),(0.765,3.78),(0.605,3.78)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((1.795,4.16),(1.795,5.81),(2.095,5.81),(2.095,4.16),(1.795,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.825,0.99),(1.825,2.64),(2.065,2.64),(2.065,0.99),(1.825,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,1.47),(1.795,2.45),(2.095,2.45),(2.095,1.47),(1.795,1.47)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.905,4.16),(1.905,5.81),(2.135,5.81),(2.135,4.16),(1.905,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.64),(2.095,2.64),(2.095,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.905,0.99),(1.905,2.64),(2.135,2.64),(2.135,0.99),(1.905,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.35),(1.795,5.33),(2.095,5.33),(2.095,4.35),(1.795,4.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.825,4.16),(1.825,5.81),(2.065,5.81),(2.065,4.16),(1.825,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.755,4.16),(1.755,5.81),(1.985,5.81),(1.985,4.16),(1.755,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.755,0.99),(1.755,2.64),(1.985,2.64),(1.985,0.99),(1.755,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,1.54),(1.865,1.7),(2.025,1.7),(2.025,1.54),(1.865,1.54)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,1.88),(1.865,2.04),(2.025,2.04),(2.025,1.88),(1.865,1.88)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,2.22),(1.865,2.38),(2.025,2.38),(2.025,2.22),(1.865,2.22)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,4.42),(1.865,4.58),(2.025,4.58),(2.025,4.42),(1.865,4.42)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,4.76),(1.865,4.92),(2.025,4.92),(2.025,4.76),(1.865,4.76)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,5.1),(1.865,5.26),(2.025,5.26),(2.025,5.1),(1.865,5.1)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.865,4.34),(1.865,5.34),(2.025,5.34),(2.025,4.34),(1.865,4.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.865,4.32),(1.865,5.36),(2.025,5.36),(2.025,4.32),(1.865,4.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.84,1.44),(1.84,5.36),(2.05,5.36),(2.05,1.44),(1.84,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.865,1.46),(1.865,2.46),(2.025,2.46),(2.025,1.46),(1.865,1.46)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.865,1.44),(1.865,2.48),(2.025,2.48),(2.025,1.44),(1.865,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.945), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.945), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(5.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_i_n': Net.create(cell, '_i_n'),
            'i': Net.create(cell, 'i'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_i_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,4.16),(0.105,5.81),(0.405,5.81),(0.405,4.16),(0.105,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.64),(0.375,2.64),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.64),(0.405,2.64),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.64),(0.445,2.64),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.35),(0.105,5.33),(0.405,5.33),(0.405,4.35),(0.105,4.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.16),(0.105,5.81),(0.375,5.81),(0.375,4.16),(0.105,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.47),(0.105,2.45),(0.405,2.45),(0.405,1.47),(0.105,1.47)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.16),(0.215,5.81),(0.445,5.81),(0.445,4.16),(0.215,4.16)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.54),(0.175,1.7),(0.335,1.7),(0.335,1.54),(0.175,1.54)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.88),(0.175,2.04),(0.335,2.04),(0.335,1.88),(0.175,1.88)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.22),(0.175,2.38),(0.335,2.38),(0.335,2.22),(0.175,2.22)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.42),(0.175,4.58),(0.335,4.58),(0.335,4.42),(0.175,4.42)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.76),(0.175,4.92),(0.335,4.92),(0.335,4.76),(0.175,4.76)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.1),(0.175,5.26),(0.335,5.26),(0.335,5.1),(0.175,5.1)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,2.16),(0.15,4.64),(0.36,4.64),(0.36,2.16),(0.15,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.46),(0.175,2.46),(0.335,2.46),(0.335,1.46),(0.175,1.46)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,2.48),(0.335,2.48),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.32),(0.175,5.36),(0.335,5.36),(0.335,4.32),(0.175,4.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.34),(0.175,5.34),(0.335,5.34),(0.335,4.34),(0.175,4.34)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,0.81),(3.765,2.82),(4.215,2.82),(4.215,0.81),(3.765,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.82),(2.555,2.82),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,3.98),(2.935,5.99),(3.385,5.99),(3.385,3.98),(2.935,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(3.99,3.55),(3.99,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.82),(1.725,2.82),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,2.82),(3.385,2.82),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,3.98),(3.765,5.99),(4.215,5.99),(4.215,3.98),(3.765,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.98),(1.725,3.98),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.98),(2.555,3.98),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.98),(1.275,5.99),(1.725,5.99),(1.725,3.98),(1.275,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.98),(2.105,5.99),(2.555,5.99),(2.555,3.98),(2.105,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,3.98),(3.385,3.98),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,0.81),(3.765,3.98),(4.215,3.98),(4.215,0.81),(3.765,0.81)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.95),(-0.075,5.73),(0.585,5.73),(0.585,3.95),(-0.075,3.95)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.76),(0.045,6.21),(1.295,6.21),(1.295,3.76),(0.045,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.76),(1.585,6.21),(2.245,6.21),(2.245,3.76),(1.585,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,3.98),(2.525,5.99),(3.795,5.99),(3.795,3.98),(2.525,3.98)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.76),(0.785,6.21),(1.385,6.21),(1.385,3.76),(0.785,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.76),(1.705,6.21),(2.955,6.21),(2.955,3.76),(1.705,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(5.075,0.585),(5.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(5.075,6.21),(5.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.76),(0.755,6.21),(1.415,6.21),(1.415,3.76),(0.755,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.76),(3.275,6.21),(3.875,6.21),(3.875,3.76),(3.275,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.365,3.76),(3.365,6.21),(4.615,6.21),(4.615,3.76),(3.365,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.95),(1.585,5.73),(2.245,5.73),(2.245,3.95),(1.585,3.95)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,3.76),(3.245,6.21),(3.905,6.21),(3.905,3.76),(3.245,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.76),(1.615,6.21),(2.215,6.21),(2.215,3.76),(1.615,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.98),(0.865,5.99),(2.135,5.99),(2.135,3.98),(0.865,3.98)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.76),(-0.075,6.21),(0.585,6.21),(0.585,3.76),(-0.075,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.98),(0.035,5.99),(1.305,5.99),(1.305,3.98),(0.035,3.98)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.76),(2.415,6.21),(3.075,6.21),(3.075,3.76),(2.415,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,3.95),(3.245,5.73),(3.905,5.73),(3.905,3.95),(3.245,3.95)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.76),(2.535,6.21),(3.785,6.21),(3.785,3.76),(2.535,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.075,5.11),(4.075,6.21),(4.735,6.21),(4.735,5.11),(4.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,3.76),(4.105,6.21),(4.735,6.21),(4.735,3.76),(4.105,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(5.04,0.585),(5.04,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.76),(0.875,6.21),(2.125,6.21),(2.125,3.76),(0.875,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,5.11),(2.415,6.21),(3.075,6.21),(3.075,5.11),(2.415,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.76),(2.445,6.21),(3.045,6.21),(3.045,3.76),(2.445,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.075,3.76),(4.075,6.21),(4.735,6.21),(4.735,3.76),(4.075,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.355,3.98),(3.355,5.99),(4.625,5.99),(4.625,3.98),(3.355,3.98)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.76),(-0.075,6.21),(0.555,6.21),(0.555,3.76),(-0.075,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.98),(1.695,5.99),(2.965,5.99),(2.965,3.98),(1.695,3.98)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,3.89),(2.435,6.08),(3.885,6.08),(3.885,3.89),(2.435,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.9),(0.105,6.07),(1.235,6.07),(1.235,3.9),(0.105,3.9)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.91),(1.395,2.91),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.265,3.89),(3.265,6.08),(4.715,6.08),(4.715,3.89),(3.265,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.9),(1.235,2.9),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.89),(0.775,6.08),(2.225,6.08),(2.225,3.89),(0.775,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.425,3.9),(3.425,6.07),(4.555,6.07),(4.555,3.9),(3.425,3.9)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.9),(2.895,2.9),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.9),(1.765,6.07),(2.895,6.07),(2.895,3.9),(1.765,3.9)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.425,0.73),(3.425,2.9),(4.555,2.9),(4.555,0.73),(3.425,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.265,0.72),(3.265,2.91),(4.715,2.91),(4.715,0.72),(3.265,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.91),(3.885,2.91),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.89),(-0.055,6.08),(1.395,6.08),(1.395,3.89),(-0.055,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.91),(3.055,2.91),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.89),(1.605,6.08),(3.055,6.08),(3.055,3.89),(1.605,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(5.27,7.07),(5.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.91),(2.225,2.91),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.9),(3.725,2.9),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.9),(2.065,2.9),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.9),(0.935,6.07),(2.065,6.07),(2.065,3.9),(0.935,3.9)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,3.9),(2.595,6.07),(3.725,6.07),(3.725,3.9),(2.595,3.9)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((1.455,3.85),(1.455,6.12),(2.375,6.12),(2.375,3.85),(1.455,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(5.205,7.005),(5.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,4.04),(3.115,5.64),(4.035,5.64),(4.035,4.04),(3.115,4.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.85),(2.315,6.12),(3.175,6.12),(3.175,3.85),(2.315,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(5.62,7.42),(5.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.225,3.85),(3.225,6.12),(4.755,6.12),(4.755,3.85),(3.225,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,3.85),(3.115,6.12),(4.035,6.12),(4.035,3.85),(3.115,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,3.85),(3.975,6.12),(4.865,6.12),(4.865,3.85),(3.975,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.945,5.2),(3.945,6.12),(4.865,6.12),(4.865,5.2),(3.945,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.945,3.85),(3.945,6.12),(4.865,6.12),(4.865,3.85),(3.945,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.04),(-0.205,5.64),(0.715,5.64),(0.715,4.04),(-0.205,4.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.04),(1.455,5.64),(2.375,5.64),(2.375,4.04),(1.455,4.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.85),(0.655,6.12),(1.515,6.12),(1.515,3.85),(0.655,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,5.2),(2.285,6.12),(3.205,6.12),(3.205,5.2),(2.285,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,6.085),(-0.17,7.005),(5.17,7.005),(5.17,6.085),(-0.17,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.85),(1.565,6.12),(3.095,6.12),(3.095,3.85),(1.565,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.85),(-0.095,6.12),(1.435,6.12),(1.435,3.85),(-0.095,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.85),(-0.205,6.12),(0.685,6.12),(0.685,3.85),(-0.205,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.85),(1.485,6.12),(2.345,6.12),(2.345,3.85),(1.485,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.85),(-0.205,6.12),(0.715,6.12),(0.715,3.85),(-0.205,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.85),(2.285,6.12),(3.205,6.12),(3.205,3.85),(2.285,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.85),(0.735,6.12),(2.265,6.12),(2.265,3.85),(0.735,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.85),(3.145,6.12),(4.005,6.12),(4.005,3.85),(3.145,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.85),(0.625,6.12),(1.545,6.12),(1.545,3.85),(0.625,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,3.85),(2.395,6.12),(3.925,6.12),(3.925,3.85),(2.395,3.85)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.51),(2.595,5.81),(2.895,5.81),(2.895,5.51),(2.595,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.16),(1.275,5.81),(1.725,5.81),(1.725,4.16),(1.275,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.16),(2.625,5.81),(2.865,5.81),(2.865,4.16),(2.625,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.255,5.51),(4.255,5.81),(4.555,5.81),(4.555,5.51),(4.255,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.16),(1.045,5.81),(1.275,5.81),(1.275,4.16),(1.045,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.16),(2.595,5.81),(2.895,5.81),(2.895,4.16),(2.595,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,4.16),(4.285,5.81),(4.555,5.81),(4.555,4.16),(4.285,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.16),(2.105,5.81),(2.555,5.81),(2.555,4.16),(2.105,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.16),(0.935,5.81),(1.235,5.81),(1.235,4.16),(0.935,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.215,4.16),(4.215,5.81),(4.445,5.81),(4.445,4.16),(4.215,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.16),(0.445,5.81),(0.895,5.81),(0.895,4.16),(0.445,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.255,4.16),(4.255,5.81),(4.555,5.81),(4.555,4.16),(4.255,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,6.395),(0.14,6.695),(4.86,6.695),(4.86,6.395),(0.14,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.16),(2.555,5.81),(2.785,5.81),(2.785,4.16),(2.555,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.16),(0.895,5.81),(1.125,5.81),(1.125,4.16),(0.895,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(4.895,6.695),(4.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.16),(0.965,5.81),(1.205,5.81),(1.205,4.16),(0.965,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,4.16),(2.935,5.81),(3.385,5.81),(3.385,4.16),(2.935,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,4.16),(3.765,5.81),(4.215,5.81),(4.215,4.16),(3.765,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,4.16),(2.705,5.81),(2.935,5.81),(2.935,4.16),(2.705,4.16)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,6.465),(0.21,6.625),(0.37,6.625),(0.37,6.465),(0.21,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,6.465),(0.55,6.625),(0.71,6.625),(0.71,6.465),(0.55,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,6.465),(0.89,6.625),(1.05,6.625),(1.05,6.465),(0.89,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,6.465),(1.23,6.625),(1.39,6.625),(1.39,6.465),(1.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.57,6.465),(1.57,6.625),(1.73,6.625),(1.73,6.465),(1.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.91,6.465),(1.91,6.625),(2.07,6.625),(2.07,6.465),(1.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.25,6.465),(2.25,6.625),(2.41,6.625),(2.41,6.465),(2.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.59,6.465),(2.59,6.625),(2.75,6.625),(2.75,6.465),(2.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.93,6.465),(2.93,6.625),(3.09,6.625),(3.09,6.465),(2.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.27,6.465),(3.27,6.625),(3.43,6.625),(3.43,6.465),(3.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.61,6.465),(3.61,6.625),(3.77,6.625),(3.77,6.465),(3.61,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.95,6.465),(3.95,6.625),(4.11,6.625),(4.11,6.465),(3.95,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.29,6.465),(4.29,6.625),(4.45,6.625),(4.45,6.465),(4.29,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.63,6.465),(4.63,6.625),(4.79,6.625),(4.79,6.465),(4.63,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.325,5.58),(4.325,5.74),(4.485,5.74),(4.485,5.58),(4.325,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.58),(2.665,5.74),(2.825,5.74),(2.825,5.58),(2.665,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(5.0,6.8),(5.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,6.385),(0.21,6.705),(4.79,6.705),(4.79,6.385),(0.21,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.585,5.58),(2.585,5.74),(2.905,5.74),(2.905,5.58),(2.585,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.245,5.58),(4.245,5.74),(4.565,5.74),(4.565,5.58),(4.245,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.5), u(5.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.5), u(5.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(4.86,0.405),(4.86,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,0.99),(4.285,2.64),(4.555,2.64),(4.555,0.99),(4.285,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.64),(2.865,2.64),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.64),(1.275,2.64),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.255,0.99),(4.255,2.64),(4.555,2.64),(4.555,0.99),(4.255,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.64),(0.895,2.64),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,0.99),(3.765,2.64),(4.215,2.64),(4.215,0.99),(3.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.64),(2.785,2.64),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.64),(1.205,2.64),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.64),(1.725,2.64),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.64),(1.235,2.64),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.255,0.99),(4.255,1.29),(4.555,1.29),(4.555,0.99),(4.255,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(4.895,0.405),(4.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.64),(2.555,2.64),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.215,0.99),(4.215,2.64),(4.445,2.64),(4.445,0.99),(4.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.29),(2.895,1.29),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,2.64),(3.385,2.64),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,2.64),(2.935,2.64),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.64),(1.125,2.64),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,2.64),(2.895,2.64),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.57,0.175),(1.57,0.335),(1.73,0.335),(1.73,0.175),(1.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.91,0.175),(1.91,0.335),(2.07,0.335),(2.07,0.175),(1.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.25,0.175),(2.25,0.335),(2.41,0.335),(2.41,0.175),(2.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.59,0.175),(2.59,0.335),(2.75,0.335),(2.75,0.175),(2.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.93,0.175),(2.93,0.335),(3.09,0.335),(3.09,0.175),(2.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.27,0.175),(3.27,0.335),(3.43,0.335),(3.43,0.175),(3.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.61,0.175),(3.61,0.335),(3.77,0.335),(3.77,0.175),(3.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.95,0.175),(3.95,0.335),(4.11,0.335),(4.11,0.175),(3.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.29,0.175),(4.29,0.335),(4.45,0.335),(4.45,0.175),(4.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.63,0.175),(4.63,0.335),(4.79,0.335),(4.79,0.175),(4.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.06),(2.665,1.22),(2.825,1.22),(2.825,1.06),(2.665,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.325,1.06),(4.325,1.22),(4.485,1.22),(4.485,1.06),(4.325,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(5.0,1.22),(5.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.585,1.06),(2.585,1.22),(2.905,1.22),(2.905,1.06),(2.585,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(4.79,0.415),(4.79,0.095),(0.21,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.245,1.06),(4.245,1.22),(4.565,1.22),(4.565,1.06),(4.245,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.5), u(5.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.5), u(5.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.98),(0.445,5.99),(0.895,5.99),(0.895,3.98),(0.445,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.79),(0.445,5.99),(0.895,5.99),(0.895,3.79),(0.445,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.01),(0.895,3.01),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,3.79),(0.67,4.09),(0.685,4.09),(0.685,3.79),(0.67,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.82),(0.895,2.82),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,2.71),(0.67,3.01),(0.685,3.01),(0.685,2.71),(0.67,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.71),(0.535,3.01),(0.835,3.01),(0.835,2.71),(0.535,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.79),(0.535,4.09),(0.835,4.09),(0.835,3.79),(0.535,3.79)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.86),(0.605,4.02),(0.765,4.02),(0.765,3.86),(0.605,3.86)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.78),(0.605,2.94),(0.765,2.94),(0.765,2.78),(0.605,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.7),(0.605,3.02),(0.765,3.02),(0.765,2.7),(0.605,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.78),(0.605,4.1),(0.765,4.1),(0.765,3.78),(0.605,3.78)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.64),(2.105,2.64),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.64),(1.955,2.64),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.535,4.16),(3.535,5.81),(3.765,5.81),(3.765,4.16),(3.535,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.16),(1.725,5.81),(1.955,5.81),(1.955,4.16),(1.725,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,4.16),(3.385,5.81),(3.615,5.81),(3.615,4.16),(3.385,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,2.64),(3.725,2.64),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.64),(2.035,2.64),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.535,0.99),(3.535,2.64),(3.765,2.64),(3.765,0.99),(3.535,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.16),(1.875,5.81),(2.105,5.81),(2.105,4.16),(1.875,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.64),(2.065,2.64),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.47),(1.765,2.45),(2.065,2.45),(2.065,1.47),(1.765,1.47)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,2.64),(3.615,2.64),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.35),(1.765,5.33),(2.065,5.33),(2.065,4.35),(1.765,4.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,1.47),(3.425,2.45),(3.725,2.45),(3.725,1.47),(3.425,1.47)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.64),(3.695,2.64),(3.695,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,4.35),(3.425,5.33),(3.725,5.33),(3.725,4.35),(3.425,4.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,4.16),(3.425,5.81),(3.725,5.81),(3.725,4.16),(3.425,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.16),(1.795,5.81),(2.035,5.81),(2.035,4.16),(1.795,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.16),(1.765,5.81),(2.065,5.81),(2.065,4.16),(1.765,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.16),(3.455,5.81),(3.695,5.81),(3.695,4.16),(3.455,4.16)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.54),(1.835,1.7),(1.995,1.7),(1.995,1.54),(1.835,1.54)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.88),(1.835,2.04),(1.995,2.04),(1.995,1.88),(1.835,1.88)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,2.22),(1.835,2.38),(1.995,2.38),(1.995,2.22),(1.835,2.22)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,4.42),(3.495,4.58),(3.655,4.58),(3.655,4.42),(3.495,4.42)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,4.76),(3.495,4.92),(3.655,4.92),(3.655,4.76),(3.495,4.76)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.1),(3.495,5.26),(3.655,5.26),(3.655,5.1),(3.495,5.1)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.54),(3.495,1.7),(3.655,1.7),(3.655,1.54),(3.495,1.54)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.88),(3.495,2.04),(3.655,2.04),(3.655,1.88),(3.495,1.88)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,2.22),(3.495,2.38),(3.655,2.38),(3.655,2.22),(3.495,2.22)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.42),(1.835,4.58),(1.995,4.58),(1.995,4.42),(1.835,4.42)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.76),(1.835,4.92),(1.995,4.92),(1.995,4.76),(1.835,4.76)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.1),(1.835,5.26),(1.995,5.26),(1.995,5.1),(1.835,5.1)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,4.34),(1.835,5.34),(1.995,5.34),(1.995,4.34),(1.835,4.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,4.32),(1.835,5.36),(1.995,5.36),(1.995,4.32),(1.835,4.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,1.46),(3.495,2.46),(3.655,2.46),(3.655,1.46),(3.495,1.46)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,2.48),(1.995,2.48),(1.995,1.44),(1.835,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,4.34),(3.495,5.34),(3.655,5.34),(3.655,4.34),(3.495,4.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,3.24),(1.81,3.56),(2.02,3.56),(2.02,3.24),(1.81,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,3.24),(3.47,3.56),(3.68,3.56),(3.68,3.24),(3.47,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,3.24),(1.915,3.56),(3.575,3.56),(3.575,3.24),(1.915,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,2.16),(3.47,4.64),(3.68,4.64),(3.68,2.16),(3.47,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,1.44),(3.495,2.48),(3.655,2.48),(3.655,1.44),(3.495,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,4.32),(3.495,5.36),(3.655,5.36),(3.655,4.32),(3.495,4.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.46),(1.835,2.46),(1.995,2.46),(1.995,1.46),(1.835,1.46)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,1.44),(1.81,5.36),(2.02,5.36),(2.02,1.44),(1.81,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['nand2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.065,5.81),(2.065,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.375,6.12),(2.375,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,5.66),(1.545,5.66),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.245,6.21),(2.245,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,5.75),(1.415,5.75),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,1.75),(1.27,1.75),(1.27,0.99),(0.9,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.065,1.75),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.45),(1.765,1.75),(2.065,1.75),(2.065,1.45),(1.765,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.35),(1.235,5.35),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.52),(1.835,1.68),(1.995,1.68),(1.995,1.52),(1.835,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.12),(1.005,5.28),(1.165,5.28),(1.165,5.12),(1.005,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,5.04),(1.005,5.36),(1.165,5.36),(1.165,5.04),(1.005,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,5.04),(1.085,5.36),(1.915,5.36),(1.915,5.04),(1.085,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,5.04),(1.81,5.36),(2.02,5.36),(2.02,5.04),(1.81,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,1.44),(1.81,5.36),(2.02,5.36),(2.02,1.44),(1.81,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,1.76),(1.995,1.76),(1.995,1.44),(1.835,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.44),(1.12,4.82),(1.33,4.82),(1.33,1.44),(1.12,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nand2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.065,5.81),(2.065,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.715),(0.625,5.655),(1.545,5.655),(1.545,3.715),(0.625,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.375,6.12),(2.375,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.245,6.21),(2.245,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.625),(0.755,5.745),(1.415,5.745),(1.415,3.625),(0.755,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,2.78),(1.27,2.78),(1.27,0.99),(0.9,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.935,4.025),(0.935,5.345),(1.235,5.345),(1.235,4.025),(0.935,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.455),(1.765,2.775),(2.065,2.775),(2.065,1.455),(1.765,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.065,2.78),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.525),(1.835,1.685),(1.995,1.685),(1.995,1.525),(1.835,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.865),(1.835,2.025),(1.995,2.025),(1.995,1.865),(1.835,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,2.205),(1.835,2.365),(1.995,2.365),(1.995,2.205),(1.835,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,2.545),(1.835,2.705),(1.995,2.705),(1.995,2.545),(1.835,2.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.095),(1.005,4.255),(1.165,4.255),(1.165,4.095),(1.005,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.435),(1.005,4.595),(1.165,4.595),(1.165,4.435),(1.005,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.775),(1.005,4.935),(1.165,4.935),(1.165,4.775),(1.005,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.115),(1.005,5.275),(1.165,5.275),(1.165,5.115),(1.005,5.115)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,4.015),(1.085,5.36),(1.915,5.36),(1.915,4.015),(1.085,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.445),(1.835,2.785),(1.995,2.785),(1.995,1.445),(1.835,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.36),(1.165,5.36),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,4.015),(1.81,4.335),(2.02,4.335),(2.02,4.015),(1.81,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,2.785),(1.995,2.785),(1.995,1.44),(1.835,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.355),(1.165,5.355),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,1.44),(1.81,5.36),(2.02,5.36),(2.02,1.44),(1.81,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.44),(1.12,3.795),(1.33,3.795),(1.33,1.44),(1.12,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nand3_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.205,6.12),(3.205,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,5.66),(3.205,5.66),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.205,6.12),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,5.66),(1.545,5.66),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,5.75),(1.415,5.75),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.075,6.21),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,5.75),(3.075,5.75),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.075,6.21),(3.075,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,1.75),(1.27,1.75),(1.27,0.99),(0.9,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.35),(2.895,5.35),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.895,5.81),(2.895,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.45),(2.595,1.75),(2.895,1.75),(2.895,1.45),(2.595,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.895,5.81),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.895,1.75),(2.895,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.895,1.75),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.35),(1.235,5.35),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.52),(2.665,1.68),(2.825,1.68),(2.825,1.52),(2.665,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.12),(2.665,5.28),(2.825,5.28),(2.825,5.12),(2.665,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.12),(1.005,5.28),(1.165,5.28),(1.165,5.12),(1.005,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,5.04),(1.005,5.36),(1.165,5.36),(1.165,5.04),(1.005,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,1.76),(2.825,1.76),(2.825,1.44),(2.665,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,1.44),(2.64,5.36),(2.85,5.36),(2.85,1.44),(2.64,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,5.04),(2.665,5.36),(2.825,5.36),(2.825,5.04),(2.665,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,5.04),(1.085,5.36),(2.745,5.36),(2.745,5.04),(1.085,5.04)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.44),(1.12,4.82),(1.33,4.82),(1.33,1.44),(1.12,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,1.75),(2.1,1.75),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,4.82),(2.16,4.82),(2.16,1.44),(1.95,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nand3_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.78),(2.555,2.78),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.02),(2.105,5.81),(2.555,5.81),(2.555,4.02),(2.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.02),(1.875,5.81),(2.105,5.81),(2.105,4.02),(1.875,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.035,5.81),(2.035,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.71),(2.285,6.12),(3.205,6.12),(3.205,3.71),(2.285,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.715),(2.285,5.655),(3.205,5.655),(3.205,3.715),(2.285,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.345,6.12),(2.345,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.715),(0.625,5.655),(1.545,5.655),(1.545,3.715),(0.625,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.205,6.12),(3.205,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.71),(1.565,6.12),(3.095,6.12),(3.095,3.71),(1.565,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.625),(2.415,5.745),(3.075,5.745),(3.075,3.625),(2.415,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.62),(1.705,6.21),(2.955,6.21),(2.955,3.62),(1.705,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.075,6.21),(3.075,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.625),(0.755,5.745),(1.415,5.745),(1.415,3.625),(0.755,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.62),(2.415,6.21),(3.075,6.21),(3.075,3.62),(2.415,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.84),(1.695,5.99),(2.965,5.99),(2.965,3.84),(1.695,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.215,6.21),(2.215,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,3.05),(3.055,3.05),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.76),(1.765,6.07),(2.895,6.07),(2.895,3.76),(1.765,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,3.04),(2.895,3.04),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.75),(1.605,6.08),(3.055,6.08),(3.055,3.75),(1.605,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,2.78),(1.27,2.78),(1.27,0.99),(0.9,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,2.78),(2.895,2.78),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.025),(0.935,5.345),(1.235,5.345),(1.235,4.025),(0.935,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.895,2.78),(2.895,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.02),(2.595,5.81),(2.895,5.81),(2.895,4.02),(2.595,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.455),(2.595,2.775),(2.895,2.775),(2.895,1.455),(2.595,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.895,5.81),(2.895,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.02),(2.555,5.81),(2.785,5.81),(2.785,4.02),(2.555,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.025),(2.595,5.345),(2.895,5.345),(2.895,4.025),(2.595,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.78),(2.785,2.78),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.095),(2.665,4.255),(2.825,4.255),(2.825,4.095),(2.665,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.435),(2.665,4.595),(2.825,4.595),(2.825,4.435),(2.665,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.775),(2.665,4.935),(2.825,4.935),(2.825,4.775),(2.665,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.115),(2.665,5.275),(2.825,5.275),(2.825,5.115),(2.665,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.095),(1.005,4.255),(1.165,4.255),(1.165,4.095),(1.005,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.435),(1.005,4.595),(1.165,4.595),(1.165,4.435),(1.005,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.775),(1.005,4.935),(1.165,4.935),(1.165,4.775),(1.005,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.115),(1.005,5.275),(1.165,5.275),(1.165,5.115),(1.005,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.525),(2.665,1.685),(2.825,1.685),(2.825,1.525),(2.665,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.865),(2.665,2.025),(2.825,2.025),(2.825,1.865),(2.665,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,2.205),(2.665,2.365),(2.825,2.365),(2.825,2.205),(2.665,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,2.545),(2.665,2.705),(2.825,2.705),(2.825,2.545),(2.665,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.36),(1.165,5.36),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.445),(2.665,2.785),(2.825,2.785),(2.825,1.445),(2.665,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,4.015),(1.085,5.36),(2.745,5.36),(2.745,4.015),(1.085,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,1.44),(2.64,5.36),(2.85,5.36),(2.85,1.44),(2.64,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.015),(2.665,5.36),(2.825,5.36),(2.825,4.015),(2.665,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.015),(2.665,5.355),(2.825,5.355),(2.825,4.015),(2.665,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.355),(1.165,5.355),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,2.785),(2.825,2.785),(2.825,1.44),(2.665,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.44),(1.12,3.795),(1.33,3.795),(1.33,1.44),(1.12,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,2.78),(2.1,2.78),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.035,2.78),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.78),(2.105,2.78),(2.105,0.99),(1.875,0.99)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.84),(2.105,5.99),(2.555,5.99),(2.555,3.84),(2.105,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.96),(2.555,2.96),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.84),(2.555,3.84),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,3.795),(2.16,3.795),(2.16,1.44),(1.95,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nand4_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,1.75),(3.385,1.75),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,5.05),(3.455,5.81),(3.725,5.81),(3.725,5.05),(3.455,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,5.05),(2.935,5.81),(3.385,5.81),(3.385,5.05),(2.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.51),(3.425,5.81),(3.725,5.81),(3.725,5.51),(3.425,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,5.05),(3.385,5.81),(3.615,5.81),(3.615,5.05),(3.385,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.05),(3.425,5.81),(3.725,5.81),(3.725,5.05),(3.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.175,6.12),(3.175,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.205,6.12),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,5.2),(3.115,6.12),(4.035,6.12),(4.035,5.2),(3.115,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,5.66),(1.545,5.66),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,5.66),(3.205,5.66),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,4.74),(2.395,6.12),(3.925,6.12),(3.925,4.74),(2.395,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,4.74),(3.145,6.12),(4.035,6.12),(4.035,4.74),(3.145,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,4.74),(3.115,6.12),(4.035,6.12),(4.035,4.74),(3.115,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.58),(3.495,5.74),(3.655,5.74),(3.655,5.58),(3.495,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,5.58),(3.415,5.74),(3.735,5.74),(3.735,5.58),(3.415,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.045,6.21),(3.045,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,5.11),(3.245,6.21),(3.905,6.21),(3.905,5.11),(3.245,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,5.75),(1.415,5.75),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,4.65),(3.275,6.21),(3.905,6.21),(3.905,4.65),(3.275,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.075,6.21),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,5.75),(3.075,5.75),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,4.65),(3.245,6.21),(3.905,6.21),(3.905,4.65),(3.245,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,4.87),(2.525,5.99),(3.795,5.99),(3.795,4.87),(2.525,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.65),(2.535,6.21),(3.785,6.21),(3.785,4.65),(2.535,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,4.78),(2.435,6.08),(3.885,6.08),(3.885,4.78),(2.435,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,4.79),(2.595,6.07),(3.725,6.07),(3.725,4.79),(2.595,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.02),(3.885,2.02),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.01),(3.725,2.01),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,1.75),(1.27,1.75),(1.27,0.99),(0.9,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,1.75),(3.725,1.75),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.35),(2.895,5.35),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,5.05),(2.705,5.81),(2.935,5.81),(2.935,5.05),(2.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.895,5.81),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,1.75),(3.615,1.75),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.865,5.81),(2.865,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.35),(1.235,5.35),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,1.45),(3.425,1.75),(3.725,1.75),(3.725,1.45),(3.425,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.75),(3.725,1.75),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.12),(2.665,5.28),(2.825,5.28),(2.825,5.12),(2.665,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.52),(3.495,1.68),(3.655,1.68),(3.655,1.52),(3.495,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.12),(1.005,5.28),(1.165,5.28),(1.165,5.12),(1.005,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,1.44),(3.47,5.36),(3.68,5.36),(3.68,1.44),(3.47,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,5.04),(1.005,5.36),(1.165,5.36),(1.165,5.04),(1.005,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,5.04),(1.085,5.36),(3.575,5.36),(3.575,5.04),(1.085,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,5.04),(2.665,5.36),(2.825,5.36),(2.825,5.04),(2.665,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,5.04),(3.47,5.36),(3.68,5.36),(3.68,5.04),(3.47,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,1.44),(3.495,1.76),(3.655,1.76),(3.655,1.44),(3.495,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.575), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.575), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.44),(1.12,4.82),(1.33,4.82),(1.33,1.44),(1.12,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,1.75),(2.1,1.75),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.56,0.99),(2.56,1.75),(2.93,1.75),(2.93,0.99),(2.56,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.865,1.75),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,1.75),(2.935,1.75),(2.935,0.99),(2.705,0.99)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,4.82),(2.16,4.82),(2.16,1.44),(1.95,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,1.93),(3.385,1.93),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.87),(2.935,5.99),(3.385,5.99),(3.385,4.87),(2.935,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,4.87),(3.385,4.87),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.25),(2.735,3.55),(3.035,3.55),(3.035,3.25),(2.735,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.25),(2.885,3.55),(3.16,3.55),(3.16,3.25),(2.885,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.32),(2.805,3.48),(2.965,3.48),(2.965,3.32),(2.805,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.44),(2.78,4.82),(2.99,4.82),(2.99,1.44),(2.78,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.24),(2.805,3.56),(2.965,3.56),(2.965,3.24),(2.805,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.885), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.885), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['nand4_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.78),(2.555,2.78),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,2.78),(3.385,2.78),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.02),(2.105,5.81),(2.555,5.81),(2.555,4.02),(2.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,4.02),(2.935,5.81),(3.385,5.81),(3.385,4.02),(2.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.51),(3.425,5.81),(3.725,5.81),(3.725,5.51),(3.425,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,4.02),(3.425,5.81),(3.725,5.81),(3.725,4.02),(3.425,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.02),(1.875,5.81),(2.105,5.81),(2.105,4.02),(1.875,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.035,5.81),(2.035,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,4.02),(3.385,5.81),(3.615,5.81),(3.615,4.02),(3.385,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.725,5.81),(3.725,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.715),(2.285,5.655),(3.205,5.655),(3.205,3.715),(2.285,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.175,6.12),(3.175,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,5.2),(3.115,6.12),(4.035,6.12),(4.035,5.2),(3.115,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.035,6.12),(4.035,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.345,6.12),(2.345,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,3.71),(3.115,6.12),(4.035,6.12),(4.035,3.71),(3.115,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.71),(2.285,6.12),(3.205,6.12),(3.205,3.71),(2.285,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.71),(1.565,6.12),(3.095,6.12),(3.095,3.71),(1.565,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.715),(0.625,5.655),(1.545,5.655),(1.545,3.715),(0.625,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,3.71),(2.395,6.12),(3.925,6.12),(3.925,3.71),(2.395,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.58),(3.495,5.74),(3.655,5.74),(3.655,5.58),(3.495,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,5.58),(3.415,5.74),(3.735,5.74),(3.735,5.58),(3.415,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((3.245,3.62),(3.245,6.21),(3.905,6.21),(3.905,3.62),(3.245,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.625),(2.415,5.745),(3.075,5.745),(3.075,3.625),(2.415,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,5.11),(3.245,6.21),(3.905,6.21),(3.905,5.11),(3.245,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.62),(1.705,6.21),(2.955,6.21),(2.955,3.62),(1.705,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,3.84),(2.525,5.99),(3.795,5.99),(3.795,3.84),(2.525,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.62),(2.535,6.21),(3.785,6.21),(3.785,3.62),(2.535,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.625),(0.755,5.745),(1.415,5.745),(1.415,3.625),(0.755,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.62),(2.415,6.21),(3.075,6.21),(3.075,3.62),(2.415,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.84),(1.695,5.99),(2.965,5.99),(2.965,3.84),(1.695,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.215,6.21),(2.215,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.045,6.21),(3.045,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.905,6.21),(3.905,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,3.05),(3.055,3.05),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.76),(1.765,6.07),(2.895,6.07),(2.895,3.76),(1.765,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,3.76),(2.595,6.07),(3.725,6.07),(3.725,3.76),(2.595,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,3.75),(2.435,6.08),(3.885,6.08),(3.885,3.75),(2.435,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,3.04),(2.895,3.04),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,3.04),(3.725,3.04),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.75),(1.605,6.08),(3.055,6.08),(3.055,3.75),(1.605,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,3.05),(3.885,3.05),(3.885,0.72),(2.435,0.72)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,2.78),(1.27,2.78),(1.27,0.99),(0.9,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.935,4.025),(0.935,5.345),(1.235,5.345),(1.235,4.025),(0.935,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.02),(2.595,5.81),(2.895,5.81),(2.895,4.02),(2.595,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,4.02),(2.705,5.81),(2.935,5.81),(2.935,4.02),(2.705,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.02),(2.555,5.81),(2.785,5.81),(2.785,4.02),(2.555,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,2.78),(3.725,2.78),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.865,5.81),(2.865,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.725,2.78),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.025),(2.595,5.345),(2.895,5.345),(2.895,4.025),(2.595,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,1.455),(3.425,2.775),(3.725,2.775),(3.725,1.455),(3.425,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,2.78),(3.615,2.78),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.095),(2.665,4.255),(2.825,4.255),(2.825,4.095),(2.665,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.435),(2.665,4.595),(2.825,4.595),(2.825,4.435),(2.665,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.775),(2.665,4.935),(2.825,4.935),(2.825,4.775),(2.665,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.115),(2.665,5.275),(2.825,5.275),(2.825,5.115),(2.665,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.525),(3.495,1.685),(3.655,1.685),(3.655,1.525),(3.495,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.865),(3.495,2.025),(3.655,2.025),(3.655,1.865),(3.495,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,2.205),(3.495,2.365),(3.655,2.365),(3.655,2.205),(3.495,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,2.545),(3.495,2.705),(3.655,2.705),(3.655,2.545),(3.495,2.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.095),(1.005,4.255),(1.165,4.255),(1.165,4.095),(1.005,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.435),(1.005,4.595),(1.165,4.595),(1.165,4.435),(1.005,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.775),(1.005,4.935),(1.165,4.935),(1.165,4.775),(1.005,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.115),(1.005,5.275),(1.165,5.275),(1.165,5.115),(1.005,5.115)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,1.44),(3.47,5.36),(3.68,5.36),(3.68,1.44),(3.47,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.36),(1.165,5.36),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,1.445),(3.495,2.785),(3.655,2.785),(3.655,1.445),(3.495,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.015),(2.665,5.36),(2.825,5.36),(2.825,4.015),(2.665,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.015),(2.665,5.355),(2.825,5.355),(2.825,4.015),(2.665,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.015),(1.005,5.355),(1.165,5.355),(1.165,4.015),(1.005,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,4.015),(3.47,4.335),(3.68,4.335),(3.68,4.015),(3.47,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,1.44),(3.495,2.785),(3.655,2.785),(3.655,1.44),(3.495,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,4.015),(1.085,5.36),(3.575,5.36),(3.575,4.015),(1.085,4.015)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.575), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.575), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.44),(1.12,3.795),(1.33,3.795),(1.33,1.44),(1.12,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,2.78),(2.1,2.78),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.035,2.78),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.78),(2.105,2.78),(2.105,0.99),(1.875,0.99)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,2.78),(2.935,2.78),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.865,2.78),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.56,0.99),(2.56,2.78),(2.93,2.78),(2.93,0.99),(2.56,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.78),(2.785,2.78),(2.785,0.99),(2.555,0.99)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.84),(2.105,5.99),(2.555,5.99),(2.555,3.84),(2.105,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.96),(2.555,2.96),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.84),(2.555,3.84),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,3.795),(2.16,3.795),(2.16,1.44),(1.95,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,3.84),(2.935,5.99),(3.385,5.99),(3.385,3.84),(2.935,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.25),(2.735,3.55),(3.035,3.55),(3.035,3.25),(2.735,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,2.96),(3.385,2.96),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,3.84),(3.385,3.84),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.25),(2.885,3.55),(3.16,3.55),(3.16,3.25),(2.885,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.32),(2.805,3.48),(2.965,3.48),(2.965,3.32),(2.805,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.44),(2.78,3.795),(2.99,3.795),(2.99,1.44),(2.78,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.24),(2.805,3.56),(2.965,3.56),(2.965,3.24),(2.805,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.885), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.885), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['and2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.35),(1.235,5.35),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.12),(1.005,5.28),(1.165,5.28),(1.165,5.12),(1.005,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,1.76),(2.16,1.76),(2.16,1.44),(1.95,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,5.04),(1.95,5.36),(2.16,5.36),(2.16,5.04),(1.95,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,1.76),(2.055,1.76),(2.055,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,5.04),(1.005,5.36),(1.165,5.36),(1.165,5.04),(1.005,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,5.36),(2.16,5.36),(2.16,1.44),(1.95,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,5.04),(1.085,5.36),(2.055,5.36),(2.055,5.04),(1.085,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,3.84),(2.135,5.99),(2.585,5.99),(2.585,3.84),(2.135,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,0.81),(2.135,2.96),(2.585,2.96),(2.585,0.81),(2.135,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,0.81),(2.135,3.84),(2.585,3.84),(2.585,0.81),(2.135,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.36,3.55),(2.36,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.905,4.02),(1.905,5.81),(2.135,5.81),(2.135,4.02),(1.905,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.065,5.81),(2.065,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.095,5.81),(2.095,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,4.02),(2.135,5.81),(2.585,5.81),(2.585,4.02),(2.135,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.51),(1.795,5.81),(2.095,5.81),(2.095,5.51),(1.795,5.51)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.715),(2.315,5.655),(3.235,5.655),(3.235,3.715),(2.315,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.235,6.12),(3.235,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,5.2),(1.485,6.12),(2.405,6.12),(2.405,5.2),(1.485,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.405,6.12),(2.405,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.345,3.71),(2.345,6.12),(3.235,6.12),(3.235,3.71),(2.345,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.595,3.71),(1.595,6.12),(3.125,6.12),(3.125,3.71),(1.595,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.375,6.12),(2.375,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,5.66),(1.545,5.66),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,5.58),(1.865,5.74),(2.025,5.74),(2.025,5.58),(1.865,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.785,5.58),(1.785,5.74),(2.105,5.74),(2.105,5.58),(1.785,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.105,6.21),(3.105,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,5.75),(1.415,5.75),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.725,3.84),(1.725,5.99),(2.995,5.99),(2.995,3.84),(1.725,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.475,3.62),(2.475,6.21),(3.105,6.21),(3.105,3.62),(2.475,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.625),(2.445,5.745),(3.105,5.745),(3.105,3.625),(2.445,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,5.11),(1.615,6.21),(2.275,6.21),(2.275,5.11),(1.615,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.62),(1.735,6.21),(2.985,6.21),(2.985,3.62),(1.735,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.275,6.21),(2.275,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.245,6.21),(2.245,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.635,0.72),(1.635,3.05),(3.085,3.05),(3.085,0.72),(1.635,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.795,3.76),(1.795,6.07),(2.925,6.07),(2.925,3.76),(1.795,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.795,0.73),(1.795,3.04),(2.925,3.04),(2.925,0.73),(1.795,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.635,3.75),(1.635,6.08),(3.085,6.08),(3.085,3.75),(1.635,3.75)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.095,2.78),(2.095,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,0.99),(2.135,2.78),(2.585,2.78),(2.585,0.99),(2.135,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.065,2.78),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.905,0.99),(1.905,2.78),(2.135,2.78),(2.135,0.99),(1.905,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.29),(2.095,1.29),(2.095,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,1.06),(1.865,1.22),(2.025,1.22),(2.025,1.06),(1.865,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.785,1.06),(1.785,1.22),(2.105,1.22),(2.105,1.06),(1.785,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,1.75),(1.27,1.75),(1.27,0.99),(0.9,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.98),(0.15,5.36),(0.36,5.36),(0.36,1.98),(0.15,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,4.82),(1.33,4.82),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((2.655,4.02),(2.655,5.81),(2.925,5.81),(2.925,4.02),(2.655,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.925,5.81),(2.925,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.655,0.99),(2.655,2.78),(2.925,2.78),(2.925,0.99),(2.655,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.925,2.78),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,1.455),(2.625,2.775),(2.925,2.775),(2.925,1.455),(2.625,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.585,4.02),(2.585,5.81),(2.815,5.81),(2.815,4.02),(2.585,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.585,0.99),(2.585,2.78),(2.815,2.78),(2.815,0.99),(2.585,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.025),(2.625,5.345),(2.925,5.345),(2.925,4.025),(2.625,4.025)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.095),(2.695,4.255),(2.855,4.255),(2.855,4.095),(2.695,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.435),(2.695,4.595),(2.855,4.595),(2.855,4.435),(2.695,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.775),(2.695,4.935),(2.855,4.935),(2.855,4.775),(2.695,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.115),(2.695,5.275),(2.855,5.275),(2.855,5.115),(2.695,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.525),(2.695,1.685),(2.855,1.685),(2.855,1.525),(2.695,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.865),(2.695,2.025),(2.855,2.025),(2.855,1.865),(2.695,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,2.205),(2.695,2.365),(2.855,2.365),(2.855,2.205),(2.695,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,2.545),(2.695,2.705),(2.855,2.705),(2.855,2.545),(2.695,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.445),(2.695,2.785),(2.855,2.785),(2.855,1.445),(2.695,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,4.015),(2.695,5.36),(2.855,5.36),(2.855,4.015),(2.695,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,1.44),(2.67,5.36),(2.88,5.36),(2.88,1.44),(2.67,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.44),(2.695,2.785),(2.855,2.785),(2.855,1.44),(2.695,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,4.015),(2.695,5.355),(2.855,5.355),(2.855,4.015),(2.695,4.015)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['and3_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.35),(2.065,5.35),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.12),(1.835,5.28),(1.995,5.28),(1.995,5.12),(1.835,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.32),(2.805,3.48),(2.965,3.48),(2.965,3.32),(2.805,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,5.04),(0.255,5.36),(2.885,5.36),(2.885,5.04),(0.255,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,5.04),(1.835,5.36),(1.995,5.36),(1.995,5.04),(1.835,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,1.76),(2.885,1.76),(2.885,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.44),(2.78,1.76),(2.99,1.76),(2.99,1.44),(2.78,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.44),(2.78,5.36),(2.99,5.36),(2.99,1.44),(2.78,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.24),(2.805,3.56),(2.965,3.56),(2.965,3.24),(2.805,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,5.04),(2.78,5.36),(2.99,5.36),(2.99,5.04),(2.78,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.965,0.81),(2.965,3.84),(3.415,3.84),(3.415,0.81),(2.965,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.965,0.81),(2.965,2.96),(3.415,2.96),(3.415,0.81),(2.965,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.965,3.84),(2.965,5.99),(3.415,5.99),(3.415,3.84),(2.965,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.25),(2.735,3.55),(3.035,3.55),(3.035,3.25),(2.735,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.25),(2.885,3.55),(3.19,3.55),(3.19,3.25),(2.885,3.25)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.935,6.21),(3.935,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.555,3.84),(2.555,5.99),(3.825,5.99),(3.825,3.84),(2.555,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.565,3.62),(2.565,6.21),(3.815,6.21),(3.815,3.62),(2.565,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.075,6.21),(3.075,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.305,3.62),(3.305,6.21),(3.935,6.21),(3.935,3.62),(3.305,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.625),(3.275,5.745),(3.935,5.745),(3.935,3.625),(3.275,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,5.11),(2.445,6.21),(3.105,6.21),(3.105,5.11),(2.445,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.105,6.21),(3.105,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,5.75),(2.245,5.75),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.625,3.76),(2.625,6.07),(3.755,6.07),(3.755,3.76),(2.625,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.465,3.75),(2.465,6.08),(3.915,6.08),(3.915,3.75),(2.465,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.465,0.72),(2.465,3.05),(3.915,3.05),(3.915,0.72),(2.465,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.625,0.73),(2.625,3.04),(3.755,3.04),(3.755,0.73),(2.625,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.065,6.12),(4.065,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.715),(3.145,5.655),(4.065,5.655),(4.065,3.715),(3.145,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.235,6.12),(3.235,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.425,3.71),(2.425,6.12),(3.955,6.12),(3.955,3.71),(2.425,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,5.66),(2.375,5.66),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.175,3.71),(3.175,6.12),(4.065,6.12),(4.065,3.71),(3.175,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,5.2),(2.315,6.12),(3.235,6.12),(3.235,5.2),(2.315,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.205,6.12),(3.205,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.51),(2.625,5.81),(2.925,5.81),(2.925,5.51),(2.625,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.965,4.02),(2.965,5.81),(3.415,5.81),(3.415,4.02),(2.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.735,4.02),(2.735,5.81),(2.965,5.81),(2.965,4.02),(2.735,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.895,5.81),(2.895,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.925,5.81),(2.925,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.58),(2.695,5.74),(2.855,5.74),(2.855,5.58),(2.695,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,5.58),(2.615,5.74),(2.935,5.74),(2.935,5.58),(2.615,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.735,0.99),(2.735,2.78),(2.965,2.78),(2.965,0.99),(2.735,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.895,2.78),(2.895,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.965,0.99),(2.965,2.78),(3.415,2.78),(3.415,0.99),(2.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.925,2.78),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.29),(2.925,1.29),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.06),(2.695,1.22),(2.855,1.22),(2.855,1.06),(2.695,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,1.06),(2.615,1.22),(2.935,1.22),(2.935,1.06),(2.615,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,1.75),(1.27,1.75),(1.27,0.99),(0.9,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.98),(0.15,4.82),(0.36,4.82),(0.36,1.98),(0.15,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,4.82),(1.33,4.82),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,1.75),(2.1,1.75),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.98),(1.95,4.82),(2.16,4.82),(2.16,1.98),(1.95,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((3.485,0.99),(3.485,2.78),(3.755,2.78),(3.755,0.99),(3.485,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.415,0.99),(3.415,2.78),(3.645,2.78),(3.645,0.99),(3.415,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.025),(3.455,5.345),(3.755,5.345),(3.755,4.025),(3.455,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.485,4.02),(3.485,5.81),(3.755,5.81),(3.755,4.02),(3.485,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,1.455),(3.455,2.775),(3.755,2.775),(3.755,1.455),(3.455,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.755,5.81),(3.755,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.415,4.02),(3.415,5.81),(3.645,5.81),(3.645,4.02),(3.415,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.755,2.78),(3.755,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,4.095),(3.525,4.255),(3.685,4.255),(3.685,4.095),(3.525,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,4.435),(3.525,4.595),(3.685,4.595),(3.685,4.435),(3.525,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,4.775),(3.525,4.935),(3.685,4.935),(3.685,4.775),(3.525,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,5.115),(3.525,5.275),(3.685,5.275),(3.685,5.115),(3.525,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,1.525),(3.525,1.685),(3.685,1.685),(3.685,1.525),(3.525,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,1.865),(3.525,2.025),(3.685,2.025),(3.685,1.865),(3.525,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,2.205),(3.525,2.365),(3.685,2.365),(3.685,2.205),(3.525,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,2.545),(3.525,2.705),(3.685,2.705),(3.685,2.545),(3.525,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.525,4.015),(3.525,5.355),(3.685,5.355),(3.685,4.015),(3.525,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.525,1.44),(3.525,2.785),(3.685,2.785),(3.685,1.44),(3.525,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.5,1.44),(3.5,5.36),(3.71,5.36),(3.71,1.44),(3.5,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.525,4.015),(3.525,5.36),(3.685,5.36),(3.685,4.015),(3.525,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.525,1.445),(3.525,2.785),(3.685,2.785),(3.685,1.445),(3.525,1.445)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.605), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.605), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['and4_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(5.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.35),(2.895,5.35),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,5.05),(2.705,5.81),(2.935,5.81),(2.935,5.05),(2.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.895,5.81),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.865,5.81),(2.865,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.35),(1.235,5.35),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.12),(2.665,5.28),(2.825,5.28),(2.825,5.12),(2.665,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.635,3.32),(3.635,3.48),(3.795,3.48),(3.795,3.32),(3.635,3.32)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.12),(1.005,5.28),(1.165,5.28),(1.165,5.12),(1.005,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,5.04),(3.61,5.36),(3.82,5.36),(3.82,5.04),(3.61,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.44),(3.61,1.76),(3.82,1.76),(3.82,1.44),(3.61,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.635,3.24),(3.635,3.56),(3.795,3.56),(3.795,3.24),(3.635,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,5.04),(1.085,5.36),(3.715,5.36),(3.715,5.04),(1.085,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,5.04),(1.005,5.36),(1.165,5.36),(1.165,5.04),(1.005,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,5.04),(2.665,5.36),(2.825,5.36),(2.825,5.04),(2.665,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.44),(3.61,5.36),(3.82,5.36),(3.82,1.44),(3.61,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,1.76),(3.715,1.76),(3.715,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.795,0.81),(3.795,3.84),(4.245,3.84),(4.245,0.81),(3.795,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,3.25),(3.565,3.55),(3.865,3.55),(3.865,3.25),(3.565,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.795,3.84),(3.795,5.99),(4.245,5.99),(4.245,3.84),(3.795,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.715,3.25),(3.715,3.55),(4.02,3.55),(4.02,3.25),(3.715,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.795,0.81),(3.795,2.96),(4.245,2.96),(4.245,0.81),(3.795,0.81)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.755,5.81),(3.755,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,5.05),(2.935,5.81),(3.385,5.81),(3.385,5.05),(2.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.565,4.02),(3.565,5.81),(3.795,5.81),(3.795,4.02),(3.565,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.795,4.02),(3.795,5.81),(4.245,5.81),(4.245,4.02),(3.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,6.395),(0.14,6.695),(4.86,6.695),(4.86,6.395),(0.14,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(4.895,6.695),(4.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,5.05),(3.385,5.81),(3.615,5.81),(3.615,5.05),(3.385,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.725,5.81),(3.725,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,5.51),(3.455,5.81),(3.755,5.81),(3.755,5.51),(3.455,5.51)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.065,6.12),(4.065,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.175,6.12),(3.175,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.205,6.12),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(5.205,7.005),(5.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,3.71),(3.975,6.12),(4.895,6.12),(4.895,3.71),(3.975,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,3.715),(3.975,5.655),(4.895,5.655),(4.895,3.715),(3.975,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,5.66),(1.545,5.66),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(5.62,7.42),(5.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.005,3.71),(4.005,6.12),(4.895,6.12),(4.895,3.71),(4.005,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,5.66),(3.205,5.66),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,4.74),(2.395,6.12),(3.925,6.12),(3.925,4.74),(2.395,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.255,3.71),(3.255,6.12),(4.785,6.12),(4.785,3.71),(3.255,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.035,6.12),(4.035,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,6.085),(-0.17,7.005),(5.17,7.005),(5.17,6.085),(-0.17,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,5.2),(3.145,6.12),(4.065,6.12),(4.065,5.2),(3.145,5.2)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,6.465),(0.21,6.625),(0.37,6.625),(0.37,6.465),(0.21,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,6.465),(0.55,6.625),(0.71,6.625),(0.71,6.465),(0.55,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,6.465),(0.89,6.625),(1.05,6.625),(1.05,6.465),(0.89,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,6.465),(1.23,6.625),(1.39,6.625),(1.39,6.465),(1.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.57,6.465),(1.57,6.625),(1.73,6.625),(1.73,6.465),(1.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.91,6.465),(1.91,6.625),(2.07,6.625),(2.07,6.465),(1.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.25,6.465),(2.25,6.625),(2.41,6.625),(2.41,6.465),(2.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.59,6.465),(2.59,6.625),(2.75,6.625),(2.75,6.465),(2.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.93,6.465),(2.93,6.625),(3.09,6.625),(3.09,6.465),(2.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.27,6.465),(3.27,6.625),(3.43,6.625),(3.43,6.465),(3.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.61,6.465),(3.61,6.625),(3.77,6.625),(3.77,6.465),(3.61,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.95,6.465),(3.95,6.625),(4.11,6.625),(4.11,6.465),(3.95,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.29,6.465),(4.29,6.625),(4.45,6.625),(4.45,6.465),(4.29,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.63,6.465),(4.63,6.625),(4.79,6.625),(4.79,6.465),(4.63,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,5.58),(3.525,5.74),(3.685,5.74),(3.685,5.58),(3.525,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(5.0,6.8),(5.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,6.385),(0.21,6.705),(4.79,6.705),(4.79,6.385),(0.21,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.445,5.58),(3.445,5.74),(3.765,5.74),(3.765,5.58),(3.445,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.5), u(5.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.5), u(5.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,3.62),(4.105,6.21),(4.765,6.21),(4.765,3.62),(4.105,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.385,3.84),(3.385,5.99),(4.655,5.99),(4.655,3.84),(3.385,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.045,6.21),(3.045,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,5.75),(1.415,5.75),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.935,6.21),(3.935,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,5.11),(3.275,6.21),(3.935,6.21),(3.935,5.11),(3.275,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(5.075,0.585),(5.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(5.075,6.21),(5.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.075,6.21),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,5.75),(3.075,5.75),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,3.625),(4.105,5.745),(4.765,5.745),(4.765,3.625),(4.105,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,4.87),(2.525,5.99),(3.795,5.99),(3.795,4.87),(2.525,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(5.04,0.585),(5.04,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.395,3.62),(3.395,6.21),(4.645,6.21),(4.645,3.62),(3.395,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.135,3.62),(4.135,6.21),(4.765,6.21),(4.765,3.62),(4.135,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.905,6.21),(3.905,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.65),(2.535,6.21),(3.785,6.21),(3.785,4.65),(2.535,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,4.78),(2.435,6.08),(3.885,6.08),(3.885,4.78),(2.435,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.455,0.73),(3.455,3.04),(4.585,3.04),(4.585,0.73),(3.455,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.455,3.76),(3.455,6.07),(4.585,6.07),(4.585,3.76),(3.455,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.295,3.75),(3.295,6.08),(4.745,6.08),(4.745,3.75),(3.295,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.295,0.72),(3.295,3.05),(4.745,3.05),(4.745,0.72),(3.295,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,4.79),(2.595,6.07),(3.725,6.07),(3.725,4.79),(2.595,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.01),(3.725,2.01),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(5.27,7.07),(5.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.02),(3.885,2.02),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(4.86,0.405),(4.86,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(4.895,0.405),(4.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.795,0.99),(3.795,2.78),(4.245,2.78),(4.245,0.99),(3.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,1.75),(3.615,1.75),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.565,0.99),(3.565,2.78),(3.795,2.78),(3.795,0.99),(3.565,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,1.75),(3.385,1.75),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,1.29),(3.755,1.29),(3.755,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.725,2.78),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.755,2.78),(3.755,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,1.06),(3.525,1.22),(3.685,1.22),(3.685,1.06),(3.525,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.57,0.175),(1.57,0.335),(1.73,0.335),(1.73,0.175),(1.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.91,0.175),(1.91,0.335),(2.07,0.335),(2.07,0.175),(1.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.25,0.175),(2.25,0.335),(2.41,0.335),(2.41,0.175),(2.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.59,0.175),(2.59,0.335),(2.75,0.335),(2.75,0.175),(2.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.93,0.175),(2.93,0.335),(3.09,0.335),(3.09,0.175),(2.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.27,0.175),(3.27,0.335),(3.43,0.335),(3.43,0.175),(3.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.61,0.175),(3.61,0.335),(3.77,0.335),(3.77,0.175),(3.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.95,0.175),(3.95,0.335),(4.11,0.335),(4.11,0.175),(3.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.29,0.175),(4.29,0.335),(4.45,0.335),(4.45,0.175),(4.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.63,0.175),(4.63,0.335),(4.79,0.335),(4.79,0.175),(4.63,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.445,1.06),(3.445,1.22),(3.765,1.22),(3.765,1.06),(3.445,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(4.79,0.415),(4.79,0.095),(0.21,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(5.0,1.22),(5.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.5), u(5.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.5), u(5.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,1.75),(1.27,1.75),(1.27,0.99),(0.9,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.98),(0.15,5.36),(0.36,5.36),(0.36,1.98),(0.15,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,4.82),(1.33,4.82),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,1.75),(2.1,1.75),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.56,0.99),(2.56,1.75),(2.93,1.75),(2.93,0.99),(2.56,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.865,1.75),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,1.75),(2.935,1.75),(2.935,0.99),(2.705,0.99)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.98),(1.95,4.82),(2.16,4.82),(2.16,1.98),(1.95,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,1.93),(3.385,1.93),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.87),(2.935,5.99),(3.385,5.99),(3.385,4.87),(2.935,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,4.87),(3.385,4.87),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.25),(2.735,3.55),(3.035,3.55),(3.035,3.25),(2.735,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.25),(2.885,3.55),(3.16,3.55),(3.16,3.25),(2.885,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.32),(2.805,3.48),(2.965,3.48),(2.965,3.32),(2.805,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.98),(2.78,4.82),(2.99,4.82),(2.99,1.98),(2.78,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.24),(2.805,3.56),(2.965,3.56),(2.965,3.24),(2.805,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.885), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.885), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((4.285,4.02),(4.285,5.81),(4.585,5.81),(4.585,4.02),(4.285,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,4.02),(4.315,5.81),(4.585,5.81),(4.585,4.02),(4.315,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,1.455),(4.285,2.775),(4.585,2.775),(4.585,1.455),(4.285,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,0.99),(4.285,2.78),(4.585,2.78),(4.585,0.99),(4.285,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,4.02),(4.245,5.81),(4.475,5.81),(4.475,4.02),(4.245,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,4.025),(4.285,5.345),(4.585,5.345),(4.585,4.025),(4.285,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,0.99),(4.245,2.78),(4.475,2.78),(4.475,0.99),(4.245,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,0.99),(4.315,2.78),(4.585,2.78),(4.585,0.99),(4.315,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,4.095),(4.355,4.255),(4.515,4.255),(4.515,4.095),(4.355,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,4.435),(4.355,4.595),(4.515,4.595),(4.515,4.435),(4.355,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,4.775),(4.355,4.935),(4.515,4.935),(4.515,4.775),(4.355,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,5.115),(4.355,5.275),(4.515,5.275),(4.515,5.115),(4.355,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,1.525),(4.355,1.685),(4.515,1.685),(4.515,1.525),(4.355,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,1.865),(4.355,2.025),(4.515,2.025),(4.515,1.865),(4.355,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,2.205),(4.355,2.365),(4.515,2.365),(4.515,2.205),(4.355,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,2.545),(4.355,2.705),(4.515,2.705),(4.515,2.545),(4.355,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.355,1.445),(4.355,2.785),(4.515,2.785),(4.515,1.445),(4.355,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.355,4.015),(4.355,5.36),(4.515,5.36),(4.515,4.015),(4.355,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.33,1.44),(4.33,5.36),(4.54,5.36),(4.54,1.44),(4.33,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.355,1.44),(4.355,2.785),(4.515,2.785),(4.515,1.44),(4.355,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.355,4.015),(4.355,5.355),(4.515,5.355),(4.515,4.015),(4.355,4.015)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(4.435), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.435), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['nor2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.065,1.75),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,4.74),(0.59,6.12),(1.58,6.12),(1.58,4.74),(0.59,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.375,6.12),(2.375,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,5.66),(2.375,5.66),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,5.75),(2.245,5.75),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.245,6.21),(2.245,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,4.65),(0.72,6.21),(1.45,6.21),(1.45,4.65),(0.72,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.45),(0.935,1.75),(1.235,1.75),(1.235,1.45),(0.935,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.065,5.81),(2.065,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.35),(2.065,5.35),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.52),(1.005,1.68),(1.165,1.68),(1.165,1.52),(1.005,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.12),(1.835,5.28),(1.995,5.28),(1.995,5.12),(1.835,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,5.04),(1.835,5.36),(1.995,5.36),(1.995,5.04),(1.835,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,1.44),(1.085,1.76),(1.915,1.76),(1.915,1.44),(1.085,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,1.76),(1.165,1.76),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,1.44),(1.81,5.36),(2.02,5.36),(2.02,1.44),(1.81,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,1.44),(1.81,1.76),(2.02,1.76),(2.02,1.44),(1.81,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,5.05),(0.9,5.81),(1.27,5.81),(1.27,5.05),(0.9,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,5.36),(1.33,5.36),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nor2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.065,2.78),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.715),(1.455,5.655),(2.375,5.655),(2.375,3.715),(1.455,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,3.71),(0.59,6.12),(1.58,6.12),(1.58,3.71),(0.59,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.375,6.12),(2.375,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,3.62),(0.72,6.21),(1.45,6.21),(1.45,3.62),(0.72,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.245,6.21),(2.245,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.625),(1.585,5.745),(2.245,5.745),(2.245,3.625),(1.585,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.025),(1.765,5.345),(2.065,5.345),(2.065,4.025),(1.765,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.065,5.81),(2.065,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.455),(0.935,2.775),(1.235,2.775),(1.235,1.455),(0.935,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.095),(1.835,4.255),(1.995,4.255),(1.995,4.095),(1.835,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.435),(1.835,4.595),(1.995,4.595),(1.995,4.435),(1.835,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.775),(1.835,4.935),(1.995,4.935),(1.995,4.775),(1.835,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.115),(1.835,5.275),(1.995,5.275),(1.995,5.115),(1.835,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.525),(1.005,1.685),(1.165,1.685),(1.165,1.525),(1.005,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.865),(1.005,2.025),(1.165,2.025),(1.165,1.865),(1.005,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.205),(1.005,2.365),(1.165,2.365),(1.165,2.205),(1.005,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.545),(1.005,2.705),(1.165,2.705),(1.165,2.545),(1.005,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,2.465),(1.81,2.785),(2.02,2.785),(2.02,2.465),(1.81,2.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.785),(1.165,2.785),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.445),(1.005,2.785),(1.165,2.785),(1.165,1.445),(1.005,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,4.015),(1.835,5.355),(1.995,5.355),(1.995,4.015),(1.835,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,1.44),(1.085,2.785),(1.915,2.785),(1.915,1.44),(1.085,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,4.015),(1.835,5.36),(1.995,5.36),(1.995,4.015),(1.835,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,1.44),(1.81,5.36),(2.02,5.36),(2.02,1.44),(1.81,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.915), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,4.02),(0.9,5.81),(1.27,5.81),(1.27,4.02),(0.9,4.02)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,3.005),(1.12,5.36),(1.33,5.36),(1.33,3.005),(1.12,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nor3_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.205,6.12),(3.205,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,5.66),(3.205,5.66),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,4.74),(0.59,6.12),(1.58,6.12),(1.58,4.74),(0.59,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.42,4.74),(1.42,6.12),(2.41,6.12),(2.41,4.74),(1.42,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.205,6.12),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.55,4.65),(1.55,6.21),(2.28,6.21),(2.28,4.65),(1.55,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.075,6.21),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,5.75),(3.075,5.75),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,4.65),(0.72,6.21),(1.45,6.21),(1.45,4.65),(0.72,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.075,6.21),(3.075,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.35),(2.895,5.35),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.895,5.81),(2.895,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.45),(2.595,1.75),(2.895,1.75),(2.895,1.45),(2.595,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.895,5.81),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.45),(0.935,1.75),(1.235,1.75),(1.235,1.45),(0.935,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.895,1.75),(2.895,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.895,1.75),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.52),(2.665,1.68),(2.825,1.68),(2.825,1.52),(2.665,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.12),(2.665,5.28),(2.825,5.28),(2.825,5.12),(2.665,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.52),(1.005,1.68),(1.165,1.68),(1.165,1.52),(1.005,1.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,1.76),(2.825,1.76),(2.825,1.44),(2.665,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,1.44),(2.64,5.36),(2.85,5.36),(2.85,1.44),(2.64,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,5.04),(2.665,5.36),(2.825,5.36),(2.825,5.04),(2.665,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,1.44),(1.085,1.76),(2.745,1.76),(2.745,1.44),(1.085,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,1.76),(1.165,1.76),(1.165,1.44),(1.005,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,5.05),(0.9,5.81),(1.27,5.81),(1.27,5.05),(0.9,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,5.36),(1.33,5.36),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,5.05),(1.73,5.81),(2.1,5.81),(2.1,5.05),(1.73,5.05)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.98),(1.95,5.36),(2.16,5.36),(2.16,1.98),(1.95,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nor3_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.78),(2.555,2.78),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.895,0.405),(2.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.035,2.78),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.78),(2.105,2.78),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,0.105),(0.16,0.405),(2.84,0.405),(2.84,0.105),(0.16,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,0.175),(0.23,0.335),(0.39,0.335),(0.39,0.175),(0.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,0.175),(0.57,0.335),(0.73,0.335),(0.73,0.175),(0.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,0.175),(0.91,0.335),(1.07,0.335),(1.07,0.175),(0.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,0.175),(1.25,0.335),(1.41,0.335),(1.41,0.175),(1.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,0.175),(1.59,0.335),(1.75,0.335),(1.75,0.175),(1.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,0.175),(1.93,0.335),(2.09,0.335),(2.09,0.175),(1.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,0.175),(2.27,0.335),(2.43,0.335),(2.43,0.175),(2.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,0.175),(2.61,0.335),(2.77,0.335),(2.77,0.175),(2.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,0.095),(0.23,0.415),(2.77,0.415),(2.77,0.095),(0.23,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(3.0,1.22),(3.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.02),(2.105,5.81),(2.555,5.81),(2.555,4.02),(2.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.16,6.395),(0.16,6.695),(2.84,6.695),(2.84,6.395),(0.16,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(2.895,6.695),(2.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.71),(2.285,6.12),(3.205,6.12),(3.205,3.71),(2.285,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.715),(2.285,5.655),(3.205,5.655),(3.205,3.715),(2.285,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.345,6.12),(2.345,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(3.205,7.005),(3.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.42,3.71),(1.42,6.12),(2.41,6.12),(2.41,3.71),(1.42,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.15,6.085),(-0.15,7.005),(3.15,7.005),(3.15,6.085),(-0.15,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,3.71),(0.59,6.12),(1.58,6.12),(1.58,3.71),(0.59,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(3.62,7.42),(3.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.205,6.12),(3.205,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.71),(1.565,6.12),(3.095,6.12),(3.095,3.71),(1.565,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.23,6.465),(0.23,6.625),(0.39,6.625),(0.39,6.465),(0.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.57,6.465),(0.57,6.625),(0.73,6.625),(0.73,6.465),(0.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.91,6.465),(0.91,6.625),(1.07,6.625),(1.07,6.465),(0.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.25,6.465),(1.25,6.625),(1.41,6.625),(1.41,6.465),(1.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.59,6.465),(1.59,6.625),(1.75,6.625),(1.75,6.465),(1.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.93,6.465),(1.93,6.625),(2.09,6.625),(2.09,6.465),(1.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.27,6.465),(2.27,6.625),(2.43,6.625),(2.43,6.465),(2.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.61,6.465),(2.61,6.625),(2.77,6.625),(2.77,6.465),(2.61,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.23,6.385),(0.23,6.705),(2.77,6.705),(2.77,6.385),(0.23,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(3.0,6.8),(3.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.5), u(3.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,3.62),(0.72,6.21),(1.45,6.21),(1.45,3.62),(0.72,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.625),(2.415,5.745),(3.075,5.745),(3.075,3.625),(2.415,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.62),(1.705,6.21),(2.955,6.21),(2.955,3.62),(1.705,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.02,-0.075),(-0.02,0.585),(3.02,0.585),(3.02,-0.075),(-0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.075,0.585),(3.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.55,3.62),(1.55,6.21),(2.28,6.21),(2.28,3.62),(1.55,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.075,6.21),(3.075,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(3.075,6.21),(3.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.62),(2.415,6.21),(3.075,6.21),(3.075,3.62),(2.415,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.84),(1.695,5.99),(2.965,5.99),(2.965,3.84),(1.695,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.215,6.21),(2.215,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,3.05),(3.055,3.05),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.76),(1.765,6.07),(2.895,6.07),(2.895,3.76),(1.765,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(3.27,7.07),(3.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,3.04),(2.895,3.04),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.75),(1.605,6.08),(3.055,6.08),(3.055,3.75),(1.605,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,2.78),(2.895,2.78),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.895,2.78),(2.895,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.02),(2.595,5.81),(2.895,5.81),(2.895,4.02),(2.595,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.455),(2.595,2.775),(2.895,2.775),(2.895,1.455),(2.595,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.895,5.81),(2.895,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.02),(2.555,5.81),(2.785,5.81),(2.785,4.02),(2.555,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.025),(2.595,5.345),(2.895,5.345),(2.895,4.025),(2.595,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.455),(0.935,2.775),(1.235,2.775),(1.235,1.455),(0.935,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.78),(2.785,2.78),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.095),(2.665,4.255),(2.825,4.255),(2.825,4.095),(2.665,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.435),(2.665,4.595),(2.825,4.595),(2.825,4.435),(2.665,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.775),(2.665,4.935),(2.825,4.935),(2.825,4.775),(2.665,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.115),(2.665,5.275),(2.825,5.275),(2.825,5.115),(2.665,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.525),(2.665,1.685),(2.825,1.685),(2.825,1.525),(2.665,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.865),(2.665,2.025),(2.825,2.025),(2.825,1.865),(2.665,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,2.205),(2.665,2.365),(2.825,2.365),(2.825,2.205),(2.665,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,2.545),(2.665,2.705),(2.825,2.705),(2.825,2.545),(2.665,2.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.525),(1.005,1.685),(1.165,1.685),(1.165,1.525),(1.005,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.865),(1.005,2.025),(1.165,2.025),(1.165,1.865),(1.005,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.205),(1.005,2.365),(1.165,2.365),(1.165,2.205),(1.005,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.545),(1.005,2.705),(1.165,2.705),(1.165,2.545),(1.005,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,1.44),(1.085,2.785),(2.745,2.785),(2.745,1.44),(1.085,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.785),(1.165,2.785),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.445),(1.005,2.785),(1.165,2.785),(1.165,1.445),(1.005,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.445),(2.665,2.785),(2.825,2.785),(2.825,1.445),(2.665,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,1.44),(2.64,5.36),(2.85,5.36),(2.85,1.44),(2.64,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.015),(2.665,5.36),(2.825,5.36),(2.825,4.015),(2.665,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.015),(2.665,5.355),(2.825,5.355),(2.825,4.015),(2.665,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,2.785),(2.825,2.785),(2.825,1.44),(2.665,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,4.02),(0.9,5.81),(1.27,5.81),(1.27,4.02),(0.9,4.02)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,3.005),(1.12,5.36),(1.33,5.36),(1.33,3.005),(1.12,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.875,4.02),(1.875,5.81),(2.105,5.81),(2.105,4.02),(1.875,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.035,5.81),(2.035,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,4.02),(1.73,5.81),(2.1,5.81),(2.1,4.02),(1.73,4.02)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.84),(2.105,5.99),(2.555,5.99),(2.555,3.84),(2.105,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.96),(2.555,2.96),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.84),(2.555,3.84),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,3.005),(1.95,5.36),(2.16,5.36),(2.16,3.005),(1.95,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nor4_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,1.75),(3.385,1.75),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.29),(3.725,1.29),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.75),(3.725,1.75),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,1.75),(3.725,1.75),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,1.75),(3.615,1.75),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.06),(3.495,1.22),(3.655,1.22),(3.655,1.06),(3.495,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,1.06),(3.415,1.22),(3.735,1.22),(3.735,1.06),(3.415,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,5.05),(2.935,5.81),(3.385,5.81),(3.385,5.05),(2.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.175,6.12),(3.175,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,4.74),(2.395,6.12),(3.925,6.12),(3.925,4.74),(2.395,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,4.74),(3.145,6.12),(4.035,6.12),(4.035,4.74),(3.145,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,4.74),(3.115,6.12),(4.035,6.12),(4.035,4.74),(3.115,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.25,4.74),(2.25,6.12),(3.24,6.12),(3.24,4.74),(2.25,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,4.74),(3.115,5.66),(4.035,5.66),(4.035,4.74),(3.115,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,4.74),(0.59,6.12),(1.58,6.12),(1.58,4.74),(0.59,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.42,4.74),(1.42,6.12),(2.41,6.12),(2.41,4.74),(1.42,4.74)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.045,6.21),(3.045,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.55,4.65),(1.55,6.21),(2.28,6.21),(2.28,4.65),(1.55,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,4.65),(3.275,6.21),(3.905,6.21),(3.905,4.65),(3.275,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.38,4.65),(2.38,6.21),(3.11,6.21),(3.11,4.65),(2.38,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,4.65),(3.245,6.21),(3.905,6.21),(3.905,4.65),(3.245,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,4.87),(2.525,5.99),(3.795,5.99),(3.795,4.87),(2.525,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,4.65),(3.245,5.75),(3.905,5.75),(3.905,4.65),(3.245,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,4.65),(0.72,6.21),(1.45,6.21),(1.45,4.65),(0.72,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.65),(2.535,6.21),(3.785,6.21),(3.785,4.65),(2.535,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,4.78),(2.435,6.08),(3.885,6.08),(3.885,4.78),(2.435,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,4.79),(2.595,6.07),(3.725,6.07),(3.725,4.79),(2.595,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.02),(3.885,2.02),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.01),(3.725,2.01),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,1.75),(2.935,1.75),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,5.05),(3.385,5.81),(3.615,5.81),(3.615,5.05),(3.385,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.45),(2.595,1.75),(2.895,1.75),(2.895,1.45),(2.595,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.45),(0.935,1.75),(1.235,1.75),(1.235,1.45),(0.935,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.895,1.75),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,5.05),(3.455,5.81),(3.725,5.81),(3.725,5.05),(3.455,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.05),(3.425,5.35),(3.725,5.35),(3.725,5.05),(3.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.05),(3.425,5.81),(3.725,5.81),(3.725,5.05),(3.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.865,1.75),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.52),(2.665,1.68),(2.825,1.68),(2.825,1.52),(2.665,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.52),(1.005,1.68),(1.165,1.68),(1.165,1.52),(1.005,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.12),(3.495,5.28),(3.655,5.28),(3.655,5.12),(3.495,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,1.44),(3.47,5.36),(3.68,5.36),(3.68,1.44),(3.47,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,1.44),(3.47,1.76),(3.68,1.76),(3.68,1.44),(3.47,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,1.44),(1.085,1.76),(3.575,1.76),(3.575,1.44),(1.085,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,1.76),(2.825,1.76),(2.825,1.44),(2.665,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,5.04),(3.495,5.36),(3.655,5.36),(3.655,5.04),(3.495,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,1.76),(1.165,1.76),(1.165,1.44),(1.005,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.575), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.575), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,5.05),(0.9,5.81),(1.27,5.81),(1.27,5.05),(0.9,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,5.36),(1.33,5.36),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,5.05),(1.73,5.81),(2.1,5.81),(2.1,5.05),(1.73,5.05)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.98),(1.95,5.36),(2.16,5.36),(2.16,1.98),(1.95,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.705,5.05),(2.705,5.81),(2.935,5.81),(2.935,5.05),(2.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.865,5.81),(2.865,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.56,5.05),(2.56,5.81),(2.93,5.81),(2.93,5.05),(2.56,5.05)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,1.93),(3.385,1.93),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.87),(2.935,5.99),(3.385,5.99),(3.385,4.87),(2.935,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,4.87),(3.385,4.87),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.25),(2.735,3.55),(3.035,3.55),(3.035,3.25),(2.735,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.25),(2.885,3.55),(3.16,3.55),(3.16,3.25),(2.885,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.32),(2.805,3.48),(2.965,3.48),(2.965,3.32),(2.805,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.98),(2.78,5.36),(2.99,5.36),(2.99,1.98),(2.78,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.24),(2.805,3.56),(2.965,3.56),(2.965,3.24),(2.805,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.885), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.885), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['nor4_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.78),(2.555,2.78),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,2.78),(3.385,2.78),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.29),(3.725,1.29),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.78),(2.105,2.78),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,2.78),(3.725,2.78),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.035,2.78),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.725,2.78),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,2.78),(3.615,2.78),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.06),(3.495,1.22),(3.655,1.22),(3.655,1.06),(3.495,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,1.06),(3.415,1.22),(3.735,1.22),(3.735,1.06),(3.415,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((2.935,4.02),(2.935,5.81),(3.385,5.81),(3.385,4.02),(2.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.02),(2.105,5.81),(2.555,5.81),(2.555,4.02),(2.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.175,6.12),(3.175,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.035,6.12),(4.035,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.345,6.12),(2.345,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,3.71),(3.115,6.12),(4.035,6.12),(4.035,3.71),(3.115,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,3.715),(3.115,5.655),(4.035,5.655),(4.035,3.715),(3.115,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.25,3.71),(2.25,6.12),(3.24,6.12),(3.24,3.71),(2.25,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,3.71),(0.59,6.12),(1.58,6.12),(1.58,3.71),(0.59,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.71),(1.565,6.12),(3.095,6.12),(3.095,3.71),(1.565,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.42,3.71),(1.42,6.12),(2.41,6.12),(2.41,3.71),(1.42,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,3.71),(2.395,6.12),(3.925,6.12),(3.925,3.71),(2.395,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((3.245,3.62),(3.245,6.21),(3.905,6.21),(3.905,3.62),(3.245,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,3.62),(0.72,6.21),(1.45,6.21),(1.45,3.62),(0.72,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.62),(1.705,6.21),(2.955,6.21),(2.955,3.62),(1.705,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.38,3.62),(2.38,6.21),(3.11,6.21),(3.11,3.62),(2.38,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,3.84),(2.525,5.99),(3.795,5.99),(3.795,3.84),(2.525,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.55,3.62),(1.55,6.21),(2.28,6.21),(2.28,3.62),(1.55,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.62),(2.535,6.21),(3.785,6.21),(3.785,3.62),(2.535,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,3.625),(3.245,5.745),(3.905,5.745),(3.905,3.625),(3.245,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.84),(1.695,5.99),(2.965,5.99),(2.965,3.84),(1.695,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.215,6.21),(2.215,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.045,6.21),(3.045,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.905,6.21),(3.905,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,3.05),(3.055,3.05),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.76),(1.765,6.07),(2.895,6.07),(2.895,3.76),(1.765,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,3.76),(2.595,6.07),(3.725,6.07),(3.725,3.76),(2.595,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,3.75),(2.435,6.08),(3.885,6.08),(3.885,3.75),(2.435,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,3.04),(2.895,3.04),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,3.04),(3.725,3.04),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.75),(1.605,6.08),(3.055,6.08),(3.055,3.75),(1.605,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,3.05),(3.885,3.05),(3.885,0.72),(2.435,0.72)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,2.78),(2.895,2.78),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.455),(2.595,2.775),(2.895,2.775),(2.895,1.455),(2.595,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.865,2.78),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.725,5.81),(3.725,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,4.02),(3.425,5.81),(3.725,5.81),(3.725,4.02),(3.425,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,2.78),(2.935,2.78),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.455),(0.935,2.775),(1.235,2.775),(1.235,1.455),(0.935,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.78),(2.785,2.78),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,4.02),(3.385,5.81),(3.615,5.81),(3.615,4.02),(3.385,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,4.025),(3.425,5.345),(3.725,5.345),(3.725,4.025),(3.425,4.025)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.525),(2.665,1.685),(2.825,1.685),(2.825,1.525),(2.665,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.865),(2.665,2.025),(2.825,2.025),(2.825,1.865),(2.665,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,2.205),(2.665,2.365),(2.825,2.365),(2.825,2.205),(2.665,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,2.545),(2.665,2.705),(2.825,2.705),(2.825,2.545),(2.665,2.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,4.095),(3.495,4.255),(3.655,4.255),(3.655,4.095),(3.495,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,4.435),(3.495,4.595),(3.655,4.595),(3.655,4.435),(3.495,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,4.775),(3.495,4.935),(3.655,4.935),(3.655,4.775),(3.495,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.115),(3.495,5.275),(3.655,5.275),(3.655,5.115),(3.495,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.525),(1.005,1.685),(1.165,1.685),(1.165,1.525),(1.005,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.865),(1.005,2.025),(1.165,2.025),(1.165,1.865),(1.005,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.205),(1.005,2.365),(1.165,2.365),(1.165,2.205),(1.005,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,2.545),(1.005,2.705),(1.165,2.705),(1.165,2.545),(1.005,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,4.015),(3.495,5.36),(3.655,5.36),(3.655,4.015),(3.495,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,2.785),(1.165,2.785),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.445),(1.005,2.785),(1.165,2.785),(1.165,1.445),(1.005,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,1.44),(3.47,5.36),(3.68,5.36),(3.68,1.44),(3.47,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.445),(2.665,2.785),(2.825,2.785),(2.825,1.445),(2.665,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.47,2.465),(3.47,2.785),(3.68,2.785),(3.68,2.465),(3.47,2.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,4.015),(3.495,5.355),(3.655,5.355),(3.655,4.015),(3.495,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,1.44),(1.085,2.785),(3.575,2.785),(3.575,1.44),(1.085,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,2.785),(2.825,2.785),(2.825,1.44),(2.665,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.575), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.575), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,4.02),(0.9,5.81),(1.27,5.81),(1.27,4.02),(0.9,4.02)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,3.005),(1.12,5.36),(1.33,5.36),(1.33,3.005),(1.12,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.875,4.02),(1.875,5.81),(2.105,5.81),(2.105,4.02),(1.875,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.035,5.81),(2.035,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,4.02),(1.73,5.81),(2.1,5.81),(2.1,4.02),(1.73,4.02)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.84),(2.105,5.99),(2.555,5.99),(2.555,3.84),(2.105,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.96),(2.555,2.96),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.84),(2.555,3.84),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,3.005),(1.95,5.36),(2.16,5.36),(2.16,3.005),(1.95,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.56,4.02),(2.56,5.81),(2.93,5.81),(2.93,4.02),(2.56,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.865,5.81),(2.865,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,4.02),(2.705,5.81),(2.935,5.81),(2.935,4.02),(2.705,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.02),(2.555,5.81),(2.785,5.81),(2.785,4.02),(2.555,4.02)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,3.84),(2.935,5.99),(3.385,5.99),(3.385,3.84),(2.935,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.25),(2.735,3.55),(3.035,3.55),(3.035,3.25),(2.735,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,2.96),(3.385,2.96),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,3.84),(3.385,3.84),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.25),(2.885,3.55),(3.16,3.55),(3.16,3.25),(2.885,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.32),(2.805,3.48),(2.965,3.48),(2.965,3.32),(2.805,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,3.005),(2.78,5.36),(2.99,5.36),(2.99,3.005),(2.78,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.24),(2.805,3.56),(2.965,3.56),(2.965,3.24),(2.805,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.885), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.885), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['or2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.095,2.78),(2.095,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,0.99),(2.135,2.78),(2.585,2.78),(2.585,0.99),(2.135,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.065,2.78),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.905,0.99),(1.905,2.78),(2.135,2.78),(2.135,0.99),(1.905,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.29),(2.095,1.29),(2.095,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,1.06),(1.865,1.22),(2.025,1.22),(2.025,1.06),(1.865,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.785,1.06),(1.785,1.22),(2.105,1.22),(2.105,1.06),(1.785,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.45),(0.935,1.75),(1.235,1.75),(1.235,1.45),(0.935,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.52),(1.005,1.68),(1.165,1.68),(1.165,1.52),(1.005,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,1.76),(2.16,1.76),(2.16,1.44),(1.95,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,5.04),(1.95,5.36),(2.16,5.36),(2.16,5.04),(1.95,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,5.04),(0.255,5.36),(2.055,5.36),(2.055,5.04),(0.255,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,5.36),(2.16,5.36),(2.16,1.44),(1.95,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,1.76),(1.165,1.76),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,1.44),(1.085,1.76),(2.055,1.76),(2.055,1.44),(1.085,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,3.84),(2.135,5.99),(2.585,5.99),(2.585,3.84),(2.135,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,0.81),(2.135,2.96),(2.585,2.96),(2.585,0.81),(2.135,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.135,0.81),(2.135,3.84),(2.585,3.84),(2.585,0.81),(2.135,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.36,3.55),(2.36,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.105,6.21),(3.105,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.725,3.84),(1.725,5.99),(2.995,5.99),(2.995,3.84),(1.725,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.475,3.62),(2.475,6.21),(3.105,6.21),(3.105,3.62),(2.475,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.625),(2.445,5.745),(3.105,5.745),(3.105,3.625),(2.445,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,4.65),(0.72,6.21),(1.45,6.21),(1.45,4.65),(0.72,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,5.11),(1.615,6.21),(2.275,6.21),(2.275,5.11),(1.615,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.62),(1.735,6.21),(2.985,6.21),(2.985,3.62),(1.735,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.275,6.21),(2.275,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.245,6.21),(2.245,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.635,0.72),(1.635,3.05),(3.085,3.05),(3.085,0.72),(1.635,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.795,3.76),(1.795,6.07),(2.925,6.07),(2.925,3.76),(1.795,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.795,0.73),(1.795,3.04),(2.925,3.04),(2.925,0.73),(1.795,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.635,3.75),(1.635,6.08),(3.085,6.08),(3.085,3.75),(1.635,3.75)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.715),(2.315,5.655),(3.235,5.655),(3.235,3.715),(2.315,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.235,6.12),(3.235,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,4.74),(0.59,6.12),(1.58,6.12),(1.58,4.74),(0.59,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,5.2),(1.485,6.12),(2.405,6.12),(2.405,5.2),(1.485,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.345,3.71),(2.345,6.12),(3.235,6.12),(3.235,3.71),(2.345,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.405,6.12),(2.405,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.595,3.71),(1.595,6.12),(3.125,6.12),(3.125,3.71),(1.595,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.375,6.12),(2.375,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.905,4.02),(1.905,5.81),(2.135,5.81),(2.135,4.02),(1.905,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.065,5.81),(2.065,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.095,5.81),(2.095,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,4.02),(2.135,5.81),(2.585,5.81),(2.585,4.02),(2.135,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.51),(1.795,5.81),(2.095,5.81),(2.095,5.51),(1.795,5.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.865,5.58),(1.865,5.74),(2.025,5.74),(2.025,5.58),(1.865,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.785,5.58),(1.785,5.74),(2.105,5.74),(2.105,5.58),(1.785,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,4.82),(0.36,4.82),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,5.05),(0.9,5.81),(1.27,5.81),(1.27,5.05),(0.9,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,4.82),(1.33,4.82),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((2.655,4.02),(2.655,5.81),(2.925,5.81),(2.925,4.02),(2.655,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.925,5.81),(2.925,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.655,0.99),(2.655,2.78),(2.925,2.78),(2.925,0.99),(2.655,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.925,2.78),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,1.455),(2.625,2.775),(2.925,2.775),(2.925,1.455),(2.625,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.585,4.02),(2.585,5.81),(2.815,5.81),(2.815,4.02),(2.585,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.585,0.99),(2.585,2.78),(2.815,2.78),(2.815,0.99),(2.585,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.025),(2.625,5.345),(2.925,5.345),(2.925,4.025),(2.625,4.025)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.095),(2.695,4.255),(2.855,4.255),(2.855,4.095),(2.695,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.435),(2.695,4.595),(2.855,4.595),(2.855,4.435),(2.695,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.775),(2.695,4.935),(2.855,4.935),(2.855,4.775),(2.695,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.115),(2.695,5.275),(2.855,5.275),(2.855,5.115),(2.695,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.525),(2.695,1.685),(2.855,1.685),(2.855,1.525),(2.695,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.865),(2.695,2.025),(2.855,2.025),(2.855,1.865),(2.695,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,2.205),(2.695,2.365),(2.855,2.365),(2.855,2.205),(2.695,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,2.545),(2.695,2.705),(2.855,2.705),(2.855,2.545),(2.695,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.445),(2.695,2.785),(2.855,2.785),(2.855,1.445),(2.695,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,4.015),(2.695,5.36),(2.855,5.36),(2.855,4.015),(2.695,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,1.44),(2.67,5.36),(2.88,5.36),(2.88,1.44),(2.67,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.44),(2.695,2.785),(2.855,2.785),(2.855,1.44),(2.695,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,4.015),(2.695,5.355),(2.855,5.355),(2.855,4.015),(2.695,4.015)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['or3_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.45),(1.765,1.75),(2.065,1.75),(2.065,1.45),(1.765,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.32),(2.805,3.48),(2.965,3.48),(2.965,3.32),(2.805,3.32)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.52),(1.835,1.68),(1.995,1.68),(1.995,1.52),(1.835,1.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,5.04),(0.255,5.36),(2.885,5.36),(2.885,5.04),(0.255,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,1.76),(2.885,1.76),(2.885,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.44),(2.78,1.76),(2.99,1.76),(2.99,1.44),(2.78,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.44),(2.78,5.36),(2.99,5.36),(2.99,1.44),(2.78,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.24),(2.805,3.56),(2.965,3.56),(2.965,3.24),(2.805,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,1.76),(1.995,1.76),(1.995,1.44),(1.835,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,5.04),(2.78,5.36),(2.99,5.36),(2.99,5.04),(2.78,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.965,0.81),(2.965,3.84),(3.415,3.84),(3.415,0.81),(2.965,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.965,0.81),(2.965,2.96),(3.415,2.96),(3.415,0.81),(2.965,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.965,3.84),(2.965,5.99),(3.415,5.99),(3.415,3.84),(2.965,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.25),(2.735,3.55),(3.035,3.55),(3.035,3.25),(2.735,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.25),(2.885,3.55),(3.19,3.55),(3.19,3.25),(2.885,3.25)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.935,6.21),(3.935,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.555,3.84),(2.555,5.99),(3.825,5.99),(3.825,3.84),(2.555,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.565,3.62),(2.565,6.21),(3.815,6.21),(3.815,3.62),(2.565,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.55,4.65),(1.55,6.21),(2.28,6.21),(2.28,4.65),(1.55,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.075,6.21),(3.075,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.305,3.62),(3.305,6.21),(3.935,6.21),(3.935,3.62),(3.305,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.625),(3.275,5.745),(3.935,5.745),(3.935,3.625),(3.275,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,5.11),(2.445,6.21),(3.105,6.21),(3.105,5.11),(2.445,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,4.65),(0.72,6.21),(1.45,6.21),(1.45,4.65),(0.72,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.105,6.21),(3.105,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.625,3.76),(2.625,6.07),(3.755,6.07),(3.755,3.76),(2.625,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.465,3.75),(2.465,6.08),(3.915,6.08),(3.915,3.75),(2.465,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.465,0.72),(2.465,3.05),(3.915,3.05),(3.915,0.72),(2.465,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.625,0.73),(2.625,3.04),(3.755,3.04),(3.755,0.73),(2.625,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.065,6.12),(4.065,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.715),(3.145,5.655),(4.065,5.655),(4.065,3.715),(3.145,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.235,6.12),(3.235,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.425,3.71),(2.425,6.12),(3.955,6.12),(3.955,3.71),(2.425,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.175,3.71),(3.175,6.12),(4.065,6.12),(4.065,3.71),(3.175,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,4.74),(0.59,6.12),(1.58,6.12),(1.58,4.74),(0.59,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,5.2),(2.315,6.12),(3.235,6.12),(3.235,5.2),(2.315,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.42,4.74),(1.42,6.12),(2.41,6.12),(2.41,4.74),(1.42,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.205,6.12),(3.205,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.51),(2.625,5.81),(2.925,5.81),(2.925,5.51),(2.625,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.965,4.02),(2.965,5.81),(3.415,5.81),(3.415,4.02),(2.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.735,4.02),(2.735,5.81),(2.965,5.81),(2.965,4.02),(2.735,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.895,5.81),(2.895,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.925,5.81),(2.925,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.58),(2.695,5.74),(2.855,5.74),(2.855,5.58),(2.695,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,5.58),(2.615,5.74),(2.935,5.74),(2.935,5.58),(2.615,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.735,0.99),(2.735,2.78),(2.965,2.78),(2.965,0.99),(2.735,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.895,2.78),(2.895,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.965,0.99),(2.965,2.78),(3.415,2.78),(3.415,0.99),(2.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.925,2.78),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.29),(2.925,1.29),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.06),(2.695,1.22),(2.855,1.22),(2.855,1.06),(2.695,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,1.06),(2.615,1.22),(2.935,1.22),(2.935,1.06),(2.615,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.98),(0.15,4.82),(0.36,4.82),(0.36,1.98),(0.15,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,5.05),(0.9,5.81),(1.27,5.81),(1.27,5.05),(0.9,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,4.82),(1.33,4.82),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,5.05),(1.73,5.81),(2.1,5.81),(2.1,5.05),(1.73,5.05)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.98),(1.95,4.82),(2.16,4.82),(2.16,1.98),(1.95,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((3.485,0.99),(3.485,2.78),(3.755,2.78),(3.755,0.99),(3.485,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.415,0.99),(3.415,2.78),(3.645,2.78),(3.645,0.99),(3.415,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.025),(3.455,5.345),(3.755,5.345),(3.755,4.025),(3.455,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.485,4.02),(3.485,5.81),(3.755,5.81),(3.755,4.02),(3.485,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,1.455),(3.455,2.775),(3.755,2.775),(3.755,1.455),(3.455,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.755,5.81),(3.755,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.415,4.02),(3.415,5.81),(3.645,5.81),(3.645,4.02),(3.415,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.755,2.78),(3.755,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,4.095),(3.525,4.255),(3.685,4.255),(3.685,4.095),(3.525,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,4.435),(3.525,4.595),(3.685,4.595),(3.685,4.435),(3.525,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,4.775),(3.525,4.935),(3.685,4.935),(3.685,4.775),(3.525,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,5.115),(3.525,5.275),(3.685,5.275),(3.685,5.115),(3.525,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,1.525),(3.525,1.685),(3.685,1.685),(3.685,1.525),(3.525,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,1.865),(3.525,2.025),(3.685,2.025),(3.685,1.865),(3.525,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,2.205),(3.525,2.365),(3.685,2.365),(3.685,2.205),(3.525,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,2.545),(3.525,2.705),(3.685,2.705),(3.685,2.545),(3.525,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.525,4.015),(3.525,5.355),(3.685,5.355),(3.685,4.015),(3.525,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.525,1.44),(3.525,2.785),(3.685,2.785),(3.685,1.44),(3.525,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.5,1.44),(3.5,5.36),(3.71,5.36),(3.71,1.44),(3.5,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.525,4.015),(3.525,5.36),(3.685,5.36),(3.685,4.015),(3.525,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.525,1.445),(3.525,2.785),(3.685,2.785),(3.685,1.445),(3.525,1.445)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.605), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.605), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['or4_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(5.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(4.86,0.405),(4.86,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,1.75),(3.385,1.75),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.795,0.99),(3.795,2.78),(4.245,2.78),(4.245,0.99),(3.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.725,2.78),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(4.895,0.405),(4.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,1.75),(3.615,1.75),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.565,0.99),(3.565,2.78),(3.795,2.78),(3.795,0.99),(3.565,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,1.29),(3.755,1.29),(3.755,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.755,2.78),(3.755,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,1.06),(3.525,1.22),(3.685,1.22),(3.685,1.06),(3.525,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.57,0.175),(1.57,0.335),(1.73,0.335),(1.73,0.175),(1.57,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.91,0.175),(1.91,0.335),(2.07,0.335),(2.07,0.175),(1.91,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.25,0.175),(2.25,0.335),(2.41,0.335),(2.41,0.175),(2.25,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.59,0.175),(2.59,0.335),(2.75,0.335),(2.75,0.175),(2.59,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.93,0.175),(2.93,0.335),(3.09,0.335),(3.09,0.175),(2.93,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.27,0.175),(3.27,0.335),(3.43,0.335),(3.43,0.175),(3.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.61,0.175),(3.61,0.335),(3.77,0.335),(3.77,0.175),(3.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.95,0.175),(3.95,0.335),(4.11,0.335),(4.11,0.175),(3.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.29,0.175),(4.29,0.335),(4.45,0.335),(4.45,0.175),(4.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.63,0.175),(4.63,0.335),(4.79,0.335),(4.79,0.175),(4.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.445,1.06),(3.445,1.22),(3.765,1.22),(3.765,1.06),(3.445,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(4.79,0.415),(4.79,0.095),(0.21,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(5.0,1.22),(5.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.5), u(5.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.5), u(5.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,1.75),(2.935,1.75),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.45),(2.595,1.75),(2.895,1.75),(2.895,1.45),(2.595,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,1.45),(0.935,1.75),(1.235,1.75),(1.235,1.45),(0.935,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.895,1.75),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.865,1.75),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.52),(2.665,1.68),(2.825,1.68),(2.825,1.52),(2.665,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.52),(1.005,1.68),(1.165,1.68),(1.165,1.52),(1.005,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.635,3.32),(3.635,3.48),(3.795,3.48),(3.795,3.32),(3.635,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,5.04),(3.61,5.36),(3.82,5.36),(3.82,5.04),(3.61,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.44),(3.61,1.76),(3.82,1.76),(3.82,1.44),(3.61,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.635,3.24),(3.635,3.56),(3.795,3.56),(3.795,3.24),(3.635,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,1.76),(2.825,1.76),(2.825,1.44),(2.665,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.085,1.44),(1.085,1.76),(3.715,1.76),(3.715,1.44),(1.085,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,5.04),(0.255,5.36),(3.715,5.36),(3.715,5.04),(0.255,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,1.44),(1.005,1.76),(1.165,1.76),(1.165,1.44),(1.005,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.44),(3.61,5.36),(3.82,5.36),(3.82,1.44),(3.61,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.795,0.81),(3.795,3.84),(4.245,3.84),(4.245,0.81),(3.795,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,3.25),(3.565,3.55),(3.865,3.55),(3.865,3.25),(3.565,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.795,3.84),(3.795,5.99),(4.245,5.99),(4.245,3.84),(3.795,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.715,3.25),(3.715,3.55),(4.02,3.55),(4.02,3.25),(3.715,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.795,0.81),(3.795,2.96),(4.245,2.96),(4.245,0.81),(3.795,0.81)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,3.62),(4.105,6.21),(4.765,6.21),(4.765,3.62),(4.105,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.385,3.84),(3.385,5.99),(4.655,5.99),(4.655,3.84),(3.385,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.045,6.21),(3.045,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(5.075,0.585),(5.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.935,6.21),(3.935,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,5.11),(3.275,6.21),(3.935,6.21),(3.935,5.11),(3.275,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(5.075,6.21),(5.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.55,4.65),(1.55,6.21),(2.28,6.21),(2.28,4.65),(1.55,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.38,4.65),(2.38,6.21),(3.11,6.21),(3.11,4.65),(2.38,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,3.625),(4.105,5.745),(4.765,5.745),(4.765,3.625),(4.105,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,4.87),(2.525,5.99),(3.795,5.99),(3.795,4.87),(2.525,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(5.04,0.585),(5.04,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,4.65),(0.72,6.21),(1.45,6.21),(1.45,4.65),(0.72,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.395,3.62),(3.395,6.21),(4.645,6.21),(4.645,3.62),(3.395,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.135,3.62),(4.135,6.21),(4.765,6.21),(4.765,3.62),(4.135,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.905,6.21),(3.905,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.65),(2.535,6.21),(3.785,6.21),(3.785,4.65),(2.535,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,4.78),(2.435,6.08),(3.885,6.08),(3.885,4.78),(2.435,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.455,0.73),(3.455,3.04),(4.585,3.04),(4.585,0.73),(3.455,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.455,3.76),(3.455,6.07),(4.585,6.07),(4.585,3.76),(3.455,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.295,3.75),(3.295,6.08),(4.745,6.08),(4.745,3.75),(3.295,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.295,0.72),(3.295,3.05),(4.745,3.05),(4.745,0.72),(3.295,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,4.79),(2.595,6.07),(3.725,6.07),(3.725,4.79),(2.595,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.01),(3.725,2.01),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(5.27,7.07),(5.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.02),(3.885,2.02),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.065,6.12),(4.065,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.175,6.12),(3.175,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(5.205,7.005),(5.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,3.71),(3.975,6.12),(4.895,6.12),(4.895,3.71),(3.975,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,3.715),(3.975,5.655),(4.895,5.655),(4.895,3.715),(3.975,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(5.62,7.42),(5.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.005,3.71),(4.005,6.12),(4.895,6.12),(4.895,3.71),(4.005,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,4.74),(2.395,6.12),(3.925,6.12),(3.925,4.74),(2.395,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.255,3.71),(3.255,6.12),(4.785,6.12),(4.785,3.71),(3.255,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.035,6.12),(4.035,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,6.085),(-0.17,7.005),(5.17,7.005),(5.17,6.085),(-0.17,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.25,4.74),(2.25,6.12),(3.24,6.12),(3.24,4.74),(2.25,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,4.74),(0.59,6.12),(1.58,6.12),(1.58,4.74),(0.59,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.42,4.74),(1.42,6.12),(2.41,6.12),(2.41,4.74),(1.42,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,5.2),(3.145,6.12),(4.065,6.12),(4.065,5.2),(3.145,5.2)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.795,4.02),(3.795,5.81),(4.245,5.81),(4.245,4.02),(3.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,5.05),(3.385,5.81),(3.615,5.81),(3.615,5.05),(3.385,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,6.395),(0.14,6.695),(4.86,6.695),(4.86,6.395),(0.14,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.725,5.81),(3.725,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,5.51),(3.455,5.81),(3.755,5.81),(3.755,5.51),(3.455,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,5.05),(2.935,5.81),(3.385,5.81),(3.385,5.05),(2.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.755,5.81),(3.755,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.565,4.02),(3.565,5.81),(3.795,5.81),(3.795,4.02),(3.565,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(4.895,6.695),(4.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.525,5.58),(3.525,5.74),(3.685,5.74),(3.685,5.58),(3.525,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,6.465),(0.21,6.625),(0.37,6.625),(0.37,6.465),(0.21,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,6.465),(0.55,6.625),(0.71,6.625),(0.71,6.465),(0.55,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,6.465),(0.89,6.625),(1.05,6.625),(1.05,6.465),(0.89,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,6.465),(1.23,6.625),(1.39,6.625),(1.39,6.465),(1.23,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.57,6.465),(1.57,6.625),(1.73,6.625),(1.73,6.465),(1.57,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.91,6.465),(1.91,6.625),(2.07,6.625),(2.07,6.465),(1.91,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.25,6.465),(2.25,6.625),(2.41,6.625),(2.41,6.465),(2.25,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.59,6.465),(2.59,6.625),(2.75,6.625),(2.75,6.465),(2.59,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.93,6.465),(2.93,6.625),(3.09,6.625),(3.09,6.465),(2.93,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.27,6.465),(3.27,6.625),(3.43,6.625),(3.43,6.465),(3.27,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.61,6.465),(3.61,6.625),(3.77,6.625),(3.77,6.465),(3.61,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.95,6.465),(3.95,6.625),(4.11,6.625),(4.11,6.465),(3.95,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.29,6.465),(4.29,6.625),(4.45,6.625),(4.45,6.465),(4.29,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.63,6.465),(4.63,6.625),(4.79,6.625),(4.79,6.465),(4.63,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,6.385),(0.21,6.705),(4.79,6.705),(4.79,6.385),(0.21,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.445,5.58),(3.445,5.74),(3.765,5.74),(3.765,5.58),(3.445,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(5.0,6.8),(5.0,5.58),(0.0,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.5), u(5.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.5), u(5.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,4.82),(0.36,4.82),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,5.05),(0.9,5.81),(1.27,5.81),(1.27,5.05),(0.9,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,4.82),(1.33,4.82),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,5.05),(1.73,5.81),(2.1,5.81),(2.1,5.05),(1.73,5.05)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.25),(2.055,3.55),(2.33,3.55),(2.33,3.25),(2.055,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.25),(1.905,3.55),(2.205,3.55),(2.205,3.25),(1.905,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.32),(1.975,3.48),(2.135,3.48),(2.135,3.32),(1.975,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.98),(1.95,4.82),(2.16,4.82),(2.16,1.98),(1.95,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.24),(1.975,3.56),(2.135,3.56),(2.135,3.24),(1.975,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.055), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.055), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.705,5.05),(2.705,5.81),(2.935,5.81),(2.935,5.05),(2.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.865,5.81),(2.865,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.56,5.05),(2.56,5.81),(2.93,5.81),(2.93,5.05),(2.56,5.05)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,1.93),(3.385,1.93),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.87),(2.935,5.99),(3.385,5.99),(3.385,4.87),(2.935,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,4.87),(3.385,4.87),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.25),(2.735,3.55),(3.035,3.55),(3.035,3.25),(2.735,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.25),(2.885,3.55),(3.16,3.55),(3.16,3.25),(2.885,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.32),(2.805,3.48),(2.965,3.48),(2.965,3.32),(2.805,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.78,1.98),(2.78,4.82),(2.99,4.82),(2.99,1.98),(2.78,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.24),(2.805,3.56),(2.965,3.56),(2.965,3.24),(2.805,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.885), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.885), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((4.285,4.02),(4.285,5.81),(4.585,5.81),(4.585,4.02),(4.285,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,4.02),(4.315,5.81),(4.585,5.81),(4.585,4.02),(4.315,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,1.455),(4.285,2.775),(4.585,2.775),(4.585,1.455),(4.285,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,0.99),(4.285,2.78),(4.585,2.78),(4.585,0.99),(4.285,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,4.02),(4.245,5.81),(4.475,5.81),(4.475,4.02),(4.245,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,4.025),(4.285,5.345),(4.585,5.345),(4.585,4.025),(4.285,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,0.99),(4.245,2.78),(4.475,2.78),(4.475,0.99),(4.245,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,0.99),(4.315,2.78),(4.585,2.78),(4.585,0.99),(4.315,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,4.095),(4.355,4.255),(4.515,4.255),(4.515,4.095),(4.355,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,4.435),(4.355,4.595),(4.515,4.595),(4.515,4.435),(4.355,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,4.775),(4.355,4.935),(4.515,4.935),(4.515,4.775),(4.355,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,5.115),(4.355,5.275),(4.515,5.275),(4.515,5.115),(4.355,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,1.525),(4.355,1.685),(4.515,1.685),(4.515,1.525),(4.355,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,1.865),(4.355,2.025),(4.515,2.025),(4.515,1.865),(4.355,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,2.205),(4.355,2.365),(4.515,2.365),(4.515,2.205),(4.355,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,2.545),(4.355,2.705),(4.515,2.705),(4.515,2.545),(4.355,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.355,1.445),(4.355,2.785),(4.515,2.785),(4.515,1.445),(4.355,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.355,4.015),(4.355,5.36),(4.515,5.36),(4.515,4.015),(4.355,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.33,1.44),(4.33,5.36),(4.54,5.36),(4.54,1.44),(4.33,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.355,1.44),(4.355,2.785),(4.515,2.785),(4.515,1.44),(4.355,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.355,4.015),(4.355,5.355),(4.515,5.355),(4.515,4.015),(4.355,4.015)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(4.435), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.435), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['mux2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_q_n': Net.create(cell, '_q_n'),
            'cmd': Net.create(cell, 'cmd'),
            'cmd_n': Net.create(cell, 'cmd_n'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['cmd_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.805,3.86),(2.805,4.02),(2.965,4.02),(2.965,3.86),(2.805,3.86)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,2.78),(1.975,2.94),(2.135,2.94),(2.135,2.78),(1.975,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,1.76),(2.16,1.76),(2.16,1.44),(1.95,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,1.76),(2.055,1.76),(2.055,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,1.44),(1.95,4.1),(2.16,4.1),(2.16,1.44),(1.95,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.805,3.78),(2.805,4.1),(2.965,4.1),(2.965,3.78),(2.805,3.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,2.7),(1.975,3.02),(2.135,3.02),(2.135,2.7),(1.975,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.055,3.78),(2.055,4.1),(2.885,4.1),(2.885,3.78),(2.055,3.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.95,3.78),(1.95,4.1),(2.16,4.1),(2.16,3.78),(1.95,3.78)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.01),(2.555,3.01),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.885,3.79),(2.885,4.09),(3.16,4.09),(3.16,3.79),(2.885,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,3.79),(2.935,5.99),(3.385,5.99),(3.385,3.79),(2.935,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,2.71),(1.905,3.01),(2.205,3.01),(2.205,2.71),(1.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.735,3.79),(2.735,4.09),(3.035,4.09),(3.035,3.79),(2.735,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.87),(2.935,5.99),(3.385,5.99),(3.385,4.87),(2.935,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,2.71),(2.055,3.01),(2.33,3.01),(2.33,2.71),(2.055,2.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.045,6.21),(3.045,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.05,-0.075),(-0.05,0.585),(6.05,0.585),(6.05,-0.075),(-0.05,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.55,4.65),(1.55,6.21),(2.28,6.21),(2.28,4.65),(1.55,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.355,4.87),(3.355,5.99),(4.625,5.99),(4.625,4.87),(3.355,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,4.65),(3.275,6.21),(3.875,6.21),(3.875,4.65),(3.275,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,5.11),(4.105,6.21),(4.765,6.21),(4.765,5.11),(4.105,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.075,6.21),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,3.76),(4.105,6.21),(4.765,6.21),(4.765,3.76),(4.105,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.215,3.98),(4.215,5.99),(5.485,5.99),(5.485,3.98),(4.215,3.98)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,5.75),(3.075,5.75),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.935,3.95),(4.935,5.73),(5.595,5.73),(5.595,3.95),(4.935,3.95)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,4.87),(2.525,5.99),(3.795,5.99),(3.795,4.87),(2.525,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(6.075,0.585),(6.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.21,4.65),(3.21,6.21),(3.94,6.21),(3.94,4.65),(3.21,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,3.76),(4.105,6.21),(4.735,6.21),(4.735,3.76),(4.105,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.965,3.76),(4.965,6.21),(5.595,6.21),(5.595,3.76),(4.965,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.225,3.76),(4.225,6.21),(5.475,6.21),(5.475,3.76),(4.225,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.935,3.76),(4.935,6.21),(5.595,6.21),(5.595,3.76),(4.935,3.76)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(6.075,6.21),(6.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.365,4.65),(3.365,6.21),(4.615,6.21),(4.615,4.65),(3.365,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.65),(2.535,6.21),(3.785,6.21),(3.785,4.65),(2.535,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,4.78),(2.435,6.08),(3.885,6.08),(3.885,4.78),(2.435,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.285,3.9),(4.285,6.07),(5.415,6.07),(5.415,3.9),(4.285,3.9)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(6.27,7.07),(6.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.285,0.73),(4.285,2.9),(5.415,2.9),(5.415,0.73),(4.285,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,4.79),(2.595,6.07),(3.725,6.07),(3.725,4.79),(2.595,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.125,0.72),(4.125,2.91),(5.575,2.91),(5.575,0.72),(4.125,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.265,0.72),(3.265,2.02),(4.715,2.02),(4.715,0.72),(3.265,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.265,4.78),(3.265,6.08),(4.715,6.08),(4.715,4.78),(3.265,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.01),(3.725,2.01),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.425,4.79),(3.425,6.07),(4.555,6.07),(4.555,4.79),(3.425,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.02),(3.885,2.02),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.425,0.73),(3.425,2.01),(4.555,2.01),(4.555,0.73),(3.425,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.125,3.89),(4.125,6.08),(5.575,6.08),(5.575,3.89),(4.125,3.89)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.175,6.12),(3.175,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.205,6.12),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,5.2),(3.975,6.12),(4.895,6.12),(4.895,5.2),(3.975,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,4.74),(3.145,6.12),(4.005,6.12),(4.005,4.74),(3.145,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.805,4.04),(4.805,5.64),(5.725,5.64),(5.725,4.04),(4.805,4.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,5.66),(3.205,5.66),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,4.74),(2.395,6.12),(3.925,6.12),(3.925,4.74),(2.395,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,3.85),(3.975,6.12),(4.865,6.12),(4.865,3.85),(3.975,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.085,3.85),(4.085,6.12),(5.615,6.12),(5.615,3.85),(4.085,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.08,4.74),(3.08,6.12),(4.07,6.12),(4.07,4.74),(3.08,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.18,6.085),(-0.18,7.005),(6.18,7.005),(6.18,6.085),(-0.18,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,3.85),(3.975,6.12),(4.895,6.12),(4.895,3.85),(3.975,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.225,4.74),(3.225,6.12),(4.755,6.12),(4.755,4.74),(3.225,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(6.205,7.005),(6.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.805,3.85),(4.805,6.12),(5.725,6.12),(5.725,3.85),(4.805,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.835,3.85),(4.835,6.12),(5.725,6.12),(5.725,3.85),(4.835,3.85)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(6.62,7.42),(6.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.42,4.74),(1.42,6.12),(2.41,6.12),(2.41,4.74),(1.42,4.74)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.625,4.16),(4.625,5.81),(5.075,5.81),(5.075,4.16),(4.625,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.395,4.16),(4.395,5.81),(4.625,5.81),(4.625,4.16),(4.395,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.215,5.05),(4.215,5.81),(4.445,5.81),(4.445,5.05),(4.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,5.51),(4.285,5.81),(4.585,5.81),(4.585,5.51),(4.285,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.13,6.395),(0.13,6.695),(5.87,6.695),(5.87,6.395),(0.13,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,4.16),(4.285,5.81),(4.555,5.81),(4.555,4.16),(4.285,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,4.16),(4.285,5.81),(4.585,5.81),(4.585,4.16),(4.285,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(5.895,6.695),(5.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,5.05),(3.765,5.81),(4.215,5.81),(4.215,5.05),(3.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,5.05),(2.935,5.81),(3.385,5.81),(3.385,5.05),(2.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.2,6.465),(0.2,6.625),(0.36,6.625),(0.36,6.465),(0.2,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.54,6.465),(0.54,6.625),(0.7,6.625),(0.7,6.465),(0.54,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.88,6.465),(0.88,6.625),(1.04,6.625),(1.04,6.465),(0.88,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.22,6.465),(1.22,6.625),(1.38,6.625),(1.38,6.465),(1.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.56,6.465),(1.56,6.625),(1.72,6.625),(1.72,6.465),(1.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.9,6.465),(1.9,6.625),(2.06,6.625),(2.06,6.465),(1.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.24,6.465),(2.24,6.625),(2.4,6.625),(2.4,6.465),(2.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.58,6.465),(2.58,6.625),(2.74,6.625),(2.74,6.465),(2.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.92,6.465),(2.92,6.625),(3.08,6.625),(3.08,6.465),(2.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.26,6.465),(3.26,6.625),(3.42,6.625),(3.42,6.465),(3.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.6,6.465),(3.6,6.625),(3.76,6.625),(3.76,6.465),(3.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.94,6.465),(3.94,6.625),(4.1,6.625),(4.1,6.465),(3.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.28,6.465),(4.28,6.625),(4.44,6.625),(4.44,6.465),(4.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.62,6.465),(4.62,6.625),(4.78,6.625),(4.78,6.465),(4.62,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.96,6.465),(4.96,6.625),(5.12,6.625),(5.12,6.465),(4.96,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.3,6.465),(5.3,6.625),(5.46,6.625),(5.46,6.465),(5.3,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.64,6.465),(5.64,6.625),(5.8,6.625),(5.8,6.465),(5.64,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,5.58),(4.355,5.74),(4.515,5.74),(4.515,5.58),(4.355,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(6.0,6.8),(6.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.275,5.58),(4.275,5.74),(4.595,5.74),(4.595,5.58),(4.275,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.2,6.385),(0.2,6.705),(5.8,6.705),(5.8,6.385),(0.2,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.0), u(6.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.0), u(6.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(5.895,0.405),(5.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.395,0.99),(4.395,2.64),(4.625,2.64),(4.625,0.99),(4.395,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,0.99),(4.285,2.64),(4.555,2.64),(4.555,0.99),(4.285,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.625,0.99),(4.625,2.64),(5.075,2.64),(5.075,0.99),(4.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,1.75),(3.385,1.75),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,0.99),(4.285,2.64),(4.585,2.64),(4.585,0.99),(4.285,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.215,0.99),(4.215,1.75),(4.445,1.75),(4.445,0.99),(4.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,0.99),(4.285,1.29),(4.585,1.29),(4.585,0.99),(4.285,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.13,0.105),(0.13,0.405),(5.87,0.405),(5.87,0.105),(0.13,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,0.99),(3.765,1.75),(4.215,1.75),(4.215,0.99),(3.765,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.2,0.175),(0.2,0.335),(0.36,0.335),(0.36,0.175),(0.2,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.54,0.175),(0.54,0.335),(0.7,0.335),(0.7,0.175),(0.54,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.88,0.175),(0.88,0.335),(1.04,0.335),(1.04,0.175),(0.88,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.22,0.175),(1.22,0.335),(1.38,0.335),(1.38,0.175),(1.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.56,0.175),(1.56,0.335),(1.72,0.335),(1.72,0.175),(1.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.9,0.175),(1.9,0.335),(2.06,0.335),(2.06,0.175),(1.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.24,0.175),(2.24,0.335),(2.4,0.335),(2.4,0.175),(2.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.58,0.175),(2.58,0.335),(2.74,0.335),(2.74,0.175),(2.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.92,0.175),(2.92,0.335),(3.08,0.335),(3.08,0.175),(2.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.26,0.175),(3.26,0.335),(3.42,0.335),(3.42,0.175),(3.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.6,0.175),(3.6,0.335),(3.76,0.335),(3.76,0.175),(3.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.94,0.175),(3.94,0.335),(4.1,0.335),(4.1,0.175),(3.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.28,0.175),(4.28,0.335),(4.44,0.335),(4.44,0.175),(4.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.62,0.175),(4.62,0.335),(4.78,0.335),(4.78,0.175),(4.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.96,0.175),(4.96,0.335),(5.12,0.335),(5.12,0.175),(4.96,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.3,0.175),(5.3,0.335),(5.46,0.335),(5.46,0.175),(5.3,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.64,0.175),(5.64,0.335),(5.8,0.335),(5.8,0.175),(5.64,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.355,1.06),(4.355,1.22),(4.515,1.22),(4.515,1.06),(4.355,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.275,1.06),(4.275,1.22),(4.595,1.22),(4.595,1.06),(4.275,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.2,0.095),(0.2,0.415),(5.8,0.415),(5.8,0.095),(0.2,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(6.0,1.22),(6.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.0), u(6.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.0), u(6.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['cmd']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.25),(2.105,5.99),(2.555,5.99),(2.555,3.25),(2.105,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.25),(0.535,3.55),(0.835,3.55),(0.835,3.25),(0.535,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,1.93),(3.385,1.93),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,3.55),(3.385,3.55),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,3.25),(0.67,3.55),(3.16,3.55),(3.16,3.25),(0.67,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.32),(0.605,3.48),(0.765,3.48),(0.765,3.32),(0.605,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.24),(0.605,3.56),(0.765,3.56),(0.765,3.24),(0.605,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.98),(0.58,5.36),(0.79,5.36),(0.79,1.98),(0.58,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,1.75),(2.1,1.75),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.01),(1.725,3.01),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.075,2.71),(1.075,3.01),(1.375,3.01),(1.375,2.71),(1.075,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,2.71),(1.225,3.01),(1.5,3.01),(1.5,2.71),(1.225,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.79),(1.225,4.09),(1.5,4.09),(1.5,3.79),(1.225,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.79),(1.075,4.09),(1.375,4.09),(1.375,3.79),(1.075,3.79)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.79),(1.275,5.99),(1.725,5.99),(1.725,3.79),(1.275,3.79)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.86),(1.145,4.02),(1.305,4.02),(1.305,3.86),(1.145,3.86)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,2.78),(1.145,2.94),(1.305,2.94),(1.305,2.78),(1.145,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.78),(1.145,4.1),(1.305,4.1),(1.305,3.78),(1.145,3.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,2.7),(1.145,3.02),(1.305,3.02),(1.305,2.7),(1.145,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,5.36),(1.33,5.36),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,5.05),(1.73,5.81),(2.1,5.81),(2.1,5.05),(1.73,5.05)),
        )
        net = nets['_q_n']
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,1.75),(2.935,1.75),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.35),(2.895,5.35),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,5.05),(2.705,5.81),(2.935,5.81),(2.935,5.05),(2.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.45),(2.595,1.75),(2.895,1.75),(2.895,1.45),(2.595,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.895,5.81),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.865,5.81),(2.865,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.895,1.75),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.865,1.75),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.52),(2.665,1.68),(2.825,1.68),(2.825,1.52),(2.665,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.12),(2.665,5.28),(2.825,5.28),(2.825,5.12),(2.665,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.465,3.32),(4.465,3.48),(4.625,3.48),(4.625,3.32),(4.465,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.44,1.44),(4.44,1.76),(4.65,1.76),(4.65,1.44),(4.44,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.44,1.44),(4.44,5.36),(4.65,5.36),(4.65,1.44),(4.44,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,1.76),(2.825,1.76),(2.825,1.44),(2.665,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,5.04),(2.665,5.36),(2.825,5.36),(2.825,5.04),(2.665,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.745,5.04),(2.745,5.36),(4.545,5.36),(4.545,5.04),(2.745,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.465,3.24),(4.465,3.56),(4.625,3.56),(4.625,3.24),(4.465,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.745,1.44),(2.745,1.76),(4.545,1.76),(4.545,1.44),(2.745,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.44,5.04),(4.44,5.36),(4.65,5.36),(4.65,5.04),(4.44,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.545,3.25),(4.545,3.55),(4.85,3.55),(4.85,3.25),(4.545,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,0.81),(4.625,3.98),(5.075,3.98),(5.075,0.81),(4.625,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.395,3.25),(4.395,3.55),(4.695,3.55),(4.695,3.25),(4.395,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,3.98),(4.625,5.99),(5.075,5.99),(5.075,3.98),(4.625,3.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,0.81),(4.625,2.82),(5.075,2.82),(5.075,0.81),(4.625,0.81)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((3.39,0.99),(3.39,1.75),(3.76,1.75),(3.76,0.99),(3.39,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,1.75),(3.695,1.75),(3.695,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,1.75),(3.615,1.75),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.535,0.99),(3.535,1.75),(3.765,1.75),(3.765,0.99),(3.535,0.99)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Activ',
            ((3.385,5.05),(3.385,5.81),(3.615,5.81),(3.615,5.05),(3.385,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,5.05),(3.455,5.81),(3.695,5.81),(3.695,5.05),(3.455,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.535,5.05),(3.535,5.81),(3.765,5.81),(3.765,5.05),(3.535,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.39,5.05),(3.39,5.81),(3.76,5.81),(3.76,5.05),(3.39,5.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((3.715,2.71),(3.715,3.01),(3.99,3.01),(3.99,2.71),(3.715,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,2.71),(3.565,3.01),(3.865,3.01),(3.865,2.71),(3.565,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,0.81),(3.765,1.93),(4.215,1.93),(4.215,0.81),(3.765,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,0.81),(3.765,4.87),(4.215,4.87),(4.215,0.81),(3.765,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,4.87),(3.765,5.99),(4.215,5.99),(4.215,4.87),(3.765,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.635,2.78),(3.635,2.94),(3.795,2.94),(3.795,2.78),(3.635,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.635,2.7),(3.635,3.02),(3.795,3.02),(3.795,2.7),(3.635,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.98),(3.61,4.82),(3.82,4.82),(3.82,1.98),(3.61,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.715), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.715), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((5.115,4.16),(5.115,5.81),(5.415,5.81),(5.415,4.16),(5.115,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.115,1.47),(5.115,2.45),(5.415,2.45),(5.415,1.47),(5.115,1.47)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,4.16),(5.145,5.81),(5.415,5.81),(5.415,4.16),(5.145,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.075,0.99),(5.075,2.64),(5.305,2.64),(5.305,0.99),(5.075,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.075,4.16),(5.075,5.81),(5.305,5.81),(5.305,4.16),(5.075,4.16)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.115,0.99),(5.115,2.64),(5.415,2.64),(5.415,0.99),(5.115,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.115,4.35),(5.115,5.33),(5.415,5.33),(5.415,4.35),(5.115,4.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,0.99),(5.145,2.64),(5.415,2.64),(5.415,0.99),(5.145,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.185,1.54),(5.185,1.7),(5.345,1.7),(5.345,1.54),(5.185,1.54)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.185,1.88),(5.185,2.04),(5.345,2.04),(5.345,1.88),(5.185,1.88)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.185,2.22),(5.185,2.38),(5.345,2.38),(5.345,2.22),(5.185,2.22)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.185,4.42),(5.185,4.58),(5.345,4.58),(5.345,4.42),(5.185,4.42)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.185,4.76),(5.185,4.92),(5.345,4.92),(5.345,4.76),(5.185,4.76)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.185,5.1),(5.185,5.26),(5.345,5.26),(5.345,5.1),(5.185,5.1)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.185,4.32),(5.185,5.36),(5.345,5.36),(5.345,4.32),(5.185,4.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.16,1.44),(5.16,5.36),(5.37,5.36),(5.37,1.44),(5.16,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.185,1.46),(5.185,2.46),(5.345,2.46),(5.345,1.46),(5.185,1.46)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.185,4.34),(5.185,5.34),(5.345,5.34),(5.345,4.34),(5.185,4.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.185,1.44),(5.185,2.48),(5.345,2.48),(5.345,1.44),(5.185,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(5.265), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.265), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['cmd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['and21nor_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.29),(2.925,1.29),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.925,1.75),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.925,1.75),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.06),(2.695,1.22),(2.855,1.22),(2.855,1.06),(2.695,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,1.06),(2.615,1.22),(2.935,1.22),(2.935,1.06),(2.615,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.35),(2.065,5.35),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.12),(1.835,5.28),(1.995,5.28),(1.995,5.12),(1.835,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,5.04),(0.255,5.36),(1.915,5.36),(1.915,5.04),(0.255,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,5.04),(1.835,5.36),(1.995,5.36),(1.995,5.04),(1.835,5.04)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,5.75),(2.245,5.75),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.105,6.21),(3.105,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,5.75),(3.105,5.75),(3.105,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.235,6.12),(3.235,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,5.66),(3.235,5.66),(3.235,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,5.66),(2.375,5.66),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,1.75),(1.27,1.75),(1.27,0.99),(0.9,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,4.82),(0.36,4.82),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.35),(2.925,5.35),(2.925,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.925,5.81),(2.925,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.45),(1.765,1.75),(2.065,1.75),(2.065,1.45),(1.765,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.925,5.81),(2.925,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.12),(2.695,5.28),(2.855,5.28),(2.855,5.12),(2.695,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.52),(1.835,1.68),(1.995,1.68),(1.995,1.52),(1.835,1.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,1.44),(2.67,5.36),(2.88,5.36),(2.88,1.44),(2.67,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,1.44),(2.67,1.76),(2.88,1.76),(2.88,1.44),(2.67,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,5.04),(2.695,5.36),(2.855,5.36),(2.855,5.04),(2.695,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,1.44),(1.915,1.76),(2.775,1.76),(2.775,1.44),(1.915,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,1.76),(1.995,1.76),(1.995,1.44),(1.835,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.44),(1.12,4.82),(1.33,4.82),(1.33,1.44),(1.12,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.195,3.25),(2.195,3.55),(2.495,3.55),(2.495,3.25),(2.195,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.33,3.25),(2.33,3.55),(2.345,3.55),(2.345,3.25),(2.33,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.265,3.32),(2.265,3.48),(2.425,3.48),(2.425,3.32),(2.265,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.24,1.98),(2.24,5.36),(2.45,5.36),(2.45,1.98),(2.24,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.265,3.24),(2.265,3.56),(2.425,3.56),(2.425,3.24),(2.265,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.345), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.345), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['and21nor_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.78),(2.555,2.78),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.925,2.78),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.29),(2.925,1.29),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.925,2.78),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.29),(0.405,1.29),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.78),(2.785,2.78),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.06),(2.695,1.22),(2.855,1.22),(2.855,1.06),(2.695,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.06),(0.175,1.22),(0.335,1.22),(0.335,1.06),(0.175,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,1.06),(0.095,1.22),(0.415,1.22),(0.415,1.06),(0.095,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,1.06),(2.615,1.22),(2.935,1.22),(2.935,1.06),(2.615,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.765,4.025),(1.765,5.345),(2.065,5.345),(2.065,4.025),(1.765,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.02),(1.875,5.81),(2.105,5.81),(2.105,4.02),(1.875,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.035,5.81),(2.035,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.025),(0.105,5.345),(0.405,5.345),(0.405,4.025),(0.105,4.025)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.095),(0.175,4.255),(0.335,4.255),(0.335,4.095),(0.175,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.435),(0.175,4.595),(0.335,4.595),(0.335,4.435),(0.175,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.775),(0.175,4.935),(0.335,4.935),(0.335,4.775),(0.175,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.115),(0.175,5.275),(0.335,5.275),(0.335,5.115),(0.175,5.115)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.095),(1.835,4.255),(1.995,4.255),(1.995,4.095),(1.835,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.435),(1.835,4.595),(1.995,4.595),(1.995,4.435),(1.835,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.775),(1.835,4.935),(1.995,4.935),(1.995,4.775),(1.835,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.115),(1.835,5.275),(1.995,5.275),(1.995,5.115),(1.835,5.115)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,4.015),(1.835,5.355),(1.995,5.355),(1.995,4.015),(1.835,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,4.015),(0.255,5.36),(1.915,5.36),(1.915,4.015),(0.255,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.015),(0.175,5.36),(0.335,5.36),(0.335,4.015),(0.175,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,4.015),(1.835,5.36),(1.995,5.36),(1.995,4.015),(1.835,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.015),(0.175,5.355),(0.335,5.355),(0.335,4.015),(0.175,4.015)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.105,6.21),(3.105,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.62),(1.705,6.21),(2.955,6.21),(2.955,3.62),(1.705,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.105,6.21),(3.105,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.625),(2.445,5.745),(3.105,5.745),(3.105,3.625),(2.445,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.84),(1.695,5.99),(2.965,5.99),(2.965,3.84),(1.695,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.215,6.21),(2.215,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.625),(1.585,5.745),(2.245,5.745),(2.245,3.625),(1.585,3.625)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.625),(-0.075,5.745),(0.585,5.745),(0.585,3.625),(-0.075,3.625)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,3.05),(3.055,3.05),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.76),(1.765,6.07),(2.895,6.07),(2.895,3.76),(1.765,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,3.04),(2.895,3.04),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.75),(1.605,6.08),(3.055,6.08),(3.055,3.75),(1.605,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.715),(-0.205,5.655),(0.715,5.655),(0.715,3.715),(-0.205,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.235,6.12),(3.235,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.715),(2.315,5.655),(3.235,5.655),(3.235,3.715),(2.315,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.345,6.12),(2.345,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.715),(1.455,5.655),(2.375,5.655),(2.375,3.715),(1.455,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.235,6.12),(3.235,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.71),(1.565,6.12),(3.095,6.12),(3.095,3.71),(1.565,3.71)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.02),(2.105,5.81),(2.555,5.81),(2.555,4.02),(2.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,2.78),(1.27,2.78),(1.27,0.99),(0.9,0.99)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,3.795),(0.36,3.795),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.925,5.81),(2.925,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.455),(1.765,2.775),(2.065,2.775),(2.065,1.455),(1.765,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.02),(2.555,5.81),(2.785,5.81),(2.785,4.02),(2.555,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.925,5.81),(2.925,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.035,2.78),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.78),(2.105,2.78),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.025),(2.625,5.345),(2.925,5.345),(2.925,4.025),(2.625,4.025)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.525),(1.835,1.685),(1.995,1.685),(1.995,1.525),(1.835,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.865),(1.835,2.025),(1.995,2.025),(1.995,1.865),(1.835,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,2.205),(1.835,2.365),(1.995,2.365),(1.995,2.205),(1.835,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,2.545),(1.835,2.705),(1.995,2.705),(1.995,2.545),(1.835,2.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.095),(2.695,4.255),(2.855,4.255),(2.855,4.095),(2.695,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.435),(2.695,4.595),(2.855,4.595),(2.855,4.435),(2.695,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.775),(2.695,4.935),(2.855,4.935),(2.855,4.775),(2.695,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.115),(2.695,5.275),(2.855,5.275),(2.855,5.115),(2.695,5.115)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,4.015),(2.695,5.36),(2.855,5.36),(2.855,4.015),(2.695,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,1.44),(2.67,5.36),(2.88,5.36),(2.88,1.44),(2.67,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.445),(1.835,2.785),(1.995,2.785),(1.995,1.445),(1.835,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,4.015),(2.695,5.355),(2.855,5.355),(2.855,4.015),(2.695,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,2.785),(1.995,2.785),(1.995,1.44),(1.835,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,1.44),(1.915,2.785),(2.775,2.785),(2.775,1.44),(1.915,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,2.465),(2.67,2.785),(2.88,2.785),(2.88,2.465),(2.67,2.465)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.44),(1.12,3.795),(1.33,3.795),(1.33,1.44),(1.12,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.84),(2.105,5.99),(2.555,5.99),(2.555,3.84),(2.105,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.195,3.25),(2.195,3.55),(2.495,3.55),(2.495,3.25),(2.195,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.96),(2.555,2.96),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.84),(2.555,3.84),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.33,3.25),(2.33,3.55),(2.345,3.55),(2.345,3.25),(2.33,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.265,3.32),(2.265,3.48),(2.425,3.48),(2.425,3.32),(2.265,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.24,3.005),(2.24,5.36),(2.45,5.36),(2.45,3.005),(2.24,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.265,3.24),(2.265,3.56),(2.425,3.56),(2.425,3.24),(2.265,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.345), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.345), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['or21nand_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.45),(1.765,1.75),(2.065,1.75),(2.065,1.45),(1.765,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.52),(1.835,1.68),(1.995,1.68),(1.995,1.52),(1.835,1.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,1.76),(1.915,1.76),(1.915,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,1.76),(1.995,1.76),(1.995,1.44),(1.835,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.925,5.81),(2.925,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.51),(2.625,5.81),(2.925,5.81),(2.925,5.51),(2.625,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.925,5.81),(2.925,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.235,6.12),(3.235,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,4.74),(0.59,6.12),(1.58,6.12),(1.58,4.74),(0.59,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,5.2),(2.315,6.12),(3.235,6.12),(3.235,5.2),(2.315,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,5.66),(2.375,5.66),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.58),(2.695,5.74),(2.855,5.74),(2.855,5.58),(2.695,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,5.58),(2.615,5.74),(2.935,5.74),(2.935,5.58),(2.615,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,5.11),(2.445,6.21),(3.105,6.21),(3.105,5.11),(2.445,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,4.65),(0.72,6.21),(1.45,6.21),(1.45,4.65),(0.72,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,5.75),(2.245,5.75),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.105,6.21),(3.105,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.98),(0.15,5.36),(0.36,5.36),(0.36,1.98),(0.15,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,5.05),(0.9,5.81),(1.27,5.81),(1.27,5.05),(0.9,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,1.98),(1.12,5.36),(1.33,5.36),(1.33,1.98),(1.12,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((2.625,1.45),(2.625,1.75),(2.925,1.75),(2.925,1.45),(2.625,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.925,1.75),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.35),(2.065,5.35),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.925,1.75),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.12),(1.835,5.28),(1.995,5.28),(1.995,5.12),(1.835,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.52),(2.695,1.68),(2.855,1.68),(2.855,1.52),(2.695,1.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,5.04),(1.835,5.36),(1.995,5.36),(1.995,5.04),(1.835,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,1.44),(2.67,5.36),(2.88,5.36),(2.88,1.44),(2.67,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,5.04),(2.67,5.36),(2.88,5.36),(2.88,5.04),(2.67,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,5.04),(1.915,5.36),(2.775,5.36),(2.775,5.04),(1.915,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.44),(2.695,1.76),(2.855,1.76),(2.855,1.44),(2.695,1.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.195,3.25),(2.195,3.55),(2.495,3.55),(2.495,3.25),(2.195,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.33,3.25),(2.33,3.55),(2.345,3.55),(2.345,3.25),(2.33,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.265,3.32),(2.265,3.48),(2.425,3.48),(2.425,3.32),(2.265,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.24,1.44),(2.24,4.82),(2.45,4.82),(2.45,1.44),(2.24,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.265,3.24),(2.265,3.56),(2.425,3.56),(2.425,3.24),(2.265,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.345), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.345), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['or21nand_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.455),(0.105,2.775),(0.405,2.775),(0.405,1.455),(0.105,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.455),(1.765,2.775),(2.065,2.775),(2.065,1.455),(1.765,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.035,2.78),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.78),(2.105,2.78),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.525),(1.835,1.685),(1.995,1.685),(1.995,1.525),(1.835,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.865),(1.835,2.025),(1.995,2.025),(1.995,1.865),(1.835,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,2.205),(1.835,2.365),(1.995,2.365),(1.995,2.205),(1.835,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,2.545),(1.835,2.705),(1.995,2.705),(1.995,2.545),(1.835,2.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.525),(0.175,1.685),(0.335,1.685),(0.335,1.525),(0.175,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.865),(0.175,2.025),(0.335,2.025),(0.335,1.865),(0.175,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.205),(0.175,2.365),(0.335,2.365),(0.335,2.205),(0.175,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.545),(0.175,2.705),(0.335,2.705),(0.335,2.545),(0.175,2.545)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,2.785),(1.915,2.785),(1.915,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,2.785),(0.335,2.785),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.445),(1.835,2.785),(1.995,2.785),(1.995,1.445),(1.835,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,2.785),(1.995,2.785),(1.995,1.44),(1.835,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.445),(0.175,2.785),(0.335,2.785),(0.335,1.445),(0.175,1.445)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.925,5.81),(2.925,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.51),(2.625,5.81),(2.925,5.81),(2.925,5.51),(2.625,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.02),(2.555,5.81),(2.785,5.81),(2.785,4.02),(2.555,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.925,5.81),(2.925,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.02),(2.105,5.81),(2.555,5.81),(2.555,4.02),(2.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.235,6.12),(3.235,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.345,6.12),(2.345,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.715),(1.455,5.655),(2.375,5.655),(2.375,3.715),(1.455,3.715)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,5.2),(2.315,6.12),(3.235,6.12),(3.235,5.2),(2.315,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.235,6.12),(3.235,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.59,3.71),(0.59,6.12),(1.58,6.12),(1.58,3.71),(0.59,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.71),(1.565,6.12),(3.095,6.12),(3.095,3.71),(1.565,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,5.58),(2.695,5.74),(2.855,5.74),(2.855,5.58),(2.695,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.615,5.58),(2.615,5.74),(2.935,5.74),(2.935,5.58),(2.615,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.72,3.62),(0.72,6.21),(1.45,6.21),(1.45,3.62),(0.72,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.105,6.21),(3.105,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.62),(1.705,6.21),(2.955,6.21),(2.955,3.62),(1.705,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.105,6.21),(3.105,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,5.11),(2.445,6.21),(3.105,6.21),(3.105,5.11),(2.445,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.84),(1.695,5.99),(2.965,5.99),(2.965,3.84),(1.695,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.215,6.21),(2.215,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.625),(1.585,5.745),(2.245,5.745),(2.245,3.625),(1.585,3.625)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,3.05),(3.055,3.05),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.76),(1.765,6.07),(2.895,6.07),(2.895,3.76),(1.765,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,3.04),(2.895,3.04),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.75),(1.605,6.08),(3.055,6.08),(3.055,3.75),(1.605,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.78),(2.555,2.78),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,2.78),(1.235,2.78),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.25),(0.255,3.55),(0.67,3.55),(0.67,3.25),(0.255,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.25),(0.105,3.55),(0.405,3.55),(0.405,3.25),(0.105,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.32),(0.175,3.48),(0.335,3.48),(0.335,3.32),(0.175,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,3.005),(0.15,5.36),(0.36,5.36),(0.36,3.005),(0.15,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,3.56),(0.335,3.56),(0.335,3.24),(0.175,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,4.02),(0.9,5.81),(1.27,5.81),(1.27,4.02),(0.9,4.02)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.075,3.25),(1.075,3.55),(1.375,3.55),(1.375,3.25),(1.075,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,3.25),(1.225,3.55),(1.5,3.55),(1.5,3.25),(1.225,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.32),(1.145,3.48),(1.305,3.48),(1.305,3.32),(1.145,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.12,3.005),(1.12,5.36),(1.33,5.36),(1.33,3.005),(1.12,3.005)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,3.24),(1.145,3.56),(1.305,3.56),(1.305,3.24),(1.145,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.225), u(0.21), u(3.005), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.225), u(0.21), u(3.005), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.78),(2.785,2.78),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.025),(1.765,5.345),(2.065,5.345),(2.065,4.025),(1.765,4.025)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.925,2.78),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,1.455),(2.625,2.775),(2.925,2.775),(2.925,1.455),(2.625,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.925,2.78),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.02),(1.875,5.81),(2.105,5.81),(2.105,4.02),(1.875,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.035,5.81),(2.035,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.525),(2.695,1.685),(2.855,1.685),(2.855,1.525),(2.695,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.865),(2.695,2.025),(2.855,2.025),(2.855,1.865),(2.695,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,2.205),(2.695,2.365),(2.855,2.365),(2.855,2.205),(2.695,2.205)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,2.545),(2.695,2.705),(2.855,2.705),(2.855,2.545),(2.695,2.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.095),(1.835,4.255),(1.995,4.255),(1.995,4.095),(1.835,4.095)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.435),(1.835,4.595),(1.995,4.595),(1.995,4.435),(1.835,4.435)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,4.775),(1.835,4.935),(1.995,4.935),(1.995,4.775),(1.835,4.775)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.115),(1.835,5.275),(1.995,5.275),(1.995,5.115),(1.835,5.115)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.445),(2.695,2.785),(2.855,2.785),(2.855,1.445),(2.695,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,4.015),(2.67,4.335),(2.88,4.335),(2.88,4.015),(2.67,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.67,1.44),(2.67,5.36),(2.88,5.36),(2.88,1.44),(2.67,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,4.015),(1.835,5.355),(1.995,5.355),(1.995,4.015),(1.835,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,4.015),(1.915,5.36),(2.775,5.36),(2.775,4.015),(1.915,4.015)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.44),(2.695,2.785),(2.855,2.785),(2.855,1.44),(2.695,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,4.015),(1.835,5.36),(1.995,5.36),(1.995,4.015),(1.835,4.015)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.775), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.84),(2.105,5.99),(2.555,5.99),(2.555,3.84),(2.105,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.195,3.25),(2.195,3.55),(2.495,3.55),(2.495,3.25),(2.195,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.96),(2.555,2.96),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.84),(2.555,3.84),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.33,3.25),(2.33,3.55),(2.345,3.55),(2.345,3.25),(2.33,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.265,3.32),(2.265,3.48),(2.425,3.48),(2.425,3.32),(2.265,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.24,1.44),(2.24,3.795),(2.45,3.795),(2.45,1.44),(2.24,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.265,3.24),(2.265,3.56),(2.425,3.56),(2.425,3.24),(2.265,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.345), u(0.21), u(1.44), u(3.795),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.345), u(0.21), u(1.44), u(3.795),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['xor2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i0_n': Net.create(cell, 'i0_n'),
            'i1': Net.create(cell, 'i1'),
            'i1_n': Net.create(cell, 'i1_n'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i0_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.995,4.87),(2.995,5.99),(3.445,5.99),(3.445,4.87),(2.995,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.995,0.81),(2.995,1.93),(3.445,1.93),(3.445,0.81),(2.995,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(3.22,3.28),(3.22,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.995,0.81),(2.995,4.87),(3.445,4.87),(3.445,0.81),(2.995,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.88),(2.445,5.99),(3.105,5.99),(3.105,3.88),(2.445,3.88)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.05,-0.075),(-0.05,0.585),(6.05,0.585),(6.05,-0.075),(-0.05,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.105,6.21),(3.105,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.595,4.65),(2.595,6.21),(3.845,6.21),(3.845,4.65),(2.595,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.165,4.65),(4.165,6.21),(4.765,6.21),(4.765,4.65),(4.165,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.255,4.65),(4.255,6.21),(5.505,6.21),(5.505,4.65),(4.255,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.135,4.65),(4.135,6.21),(4.795,6.21),(4.795,4.65),(4.135,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.995,4.65),(4.995,6.21),(5.625,6.21),(5.625,4.65),(4.995,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(6.075,0.585),(6.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.425,4.65),(3.425,6.21),(4.675,6.21),(4.675,4.65),(3.425,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.965,4.65),(4.965,6.21),(5.625,6.21),(5.625,4.65),(4.965,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.335,4.65),(3.335,6.21),(3.935,6.21),(3.935,4.65),(3.335,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.305,4.65),(3.305,6.21),(3.965,6.21),(3.965,4.65),(3.305,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,5.75),(2.245,5.75),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(6.075,6.21),(6.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.135,5.11),(4.135,6.21),(4.795,6.21),(4.795,5.11),(4.135,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.965,4.65),(4.965,5.75),(5.625,5.75),(5.625,4.65),(4.965,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.245,4.87),(4.245,5.99),(5.515,5.99),(5.515,4.87),(4.245,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.305,4.65),(3.305,5.75),(3.965,5.75),(3.965,4.65),(3.305,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.88),(2.445,4.54),(3.105,4.54),(3.105,3.88),(2.445,3.88)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.585,4.87),(2.585,5.99),(3.855,5.99),(3.855,4.87),(2.585,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.415,4.87),(3.415,5.99),(4.685,5.99),(4.685,4.87),(3.415,4.87)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.325,4.78),(3.325,6.08),(4.775,6.08),(4.775,4.78),(3.325,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.325,0.72),(3.325,2.02),(4.775,2.02),(4.775,0.72),(3.325,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.485,0.73),(3.485,2.01),(4.615,2.01),(4.615,0.73),(3.485,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.155,4.78),(4.155,6.08),(5.605,6.08),(5.605,4.78),(4.155,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(6.27,7.07),(6.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.315,0.73),(4.315,2.01),(5.445,2.01),(5.445,0.73),(4.315,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.495,4.78),(2.495,6.08),(3.945,6.08),(3.945,4.78),(2.495,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.315,4.79),(4.315,6.07),(5.445,6.07),(5.445,4.79),(4.315,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.655,4.79),(2.655,6.07),(3.785,6.07),(3.785,4.79),(2.655,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.495,0.72),(2.495,2.02),(3.945,2.02),(3.945,0.72),(2.495,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.655,0.73),(2.655,2.01),(3.785,2.01),(3.785,0.73),(2.655,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.485,4.79),(3.485,6.07),(4.615,6.07),(4.615,4.79),(3.485,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.155,0.72),(4.155,2.02),(5.605,2.02),(5.605,0.72),(4.155,0.72)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.235,6.12),(3.235,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.175,4.74),(3.175,5.66),(4.095,5.66),(4.095,4.74),(3.175,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.835,4.74),(4.835,5.66),(5.755,5.66),(5.755,4.74),(4.835,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.285,4.74),(3.285,6.12),(4.815,6.12),(4.815,4.74),(3.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.005,4.74),(4.005,6.12),(4.925,6.12),(4.925,4.74),(4.005,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.205,4.74),(3.205,6.12),(4.065,6.12),(4.065,4.74),(3.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.18,6.085),(-0.18,7.005),(6.18,7.005),(6.18,6.085),(-0.18,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.75),(2.315,6.12),(3.235,6.12),(3.235,3.75),(2.315,3.75)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,5.66),(2.375,5.66),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.035,4.74),(4.035,6.12),(4.895,6.12),(4.895,4.74),(4.035,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(6.205,7.005),(6.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(6.62,7.42),(6.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.005,5.2),(4.005,6.12),(4.925,6.12),(4.925,5.2),(4.005,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.75),(2.315,4.67),(3.235,4.67),(3.235,3.75),(2.315,3.75)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.455,4.74),(2.455,6.12),(3.985,6.12),(3.985,4.74),(2.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.865,4.74),(4.865,6.12),(5.755,6.12),(5.755,4.74),(4.865,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.175,4.74),(3.175,6.12),(4.095,6.12),(4.095,4.74),(3.175,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.835,4.74),(4.835,6.12),(5.755,6.12),(5.755,4.74),(4.835,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.115,4.74),(4.115,6.12),(5.645,6.12),(5.645,4.74),(4.115,4.74)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.275,5.05),(4.275,5.81),(4.505,5.81),(4.505,5.05),(4.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.655,5.05),(4.655,5.81),(5.105,5.81),(5.105,5.05),(4.655,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.345,5.05),(4.345,5.81),(4.585,5.81),(4.585,5.05),(4.345,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.13,6.395),(0.13,6.695),(5.87,6.695),(5.87,6.395),(0.13,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.995,5.05),(2.995,5.81),(3.445,5.81),(3.445,5.05),(2.995,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.825,5.05),(3.825,5.81),(4.275,5.81),(4.275,5.05),(3.825,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,5.05),(4.315,5.81),(4.615,5.81),(4.615,5.05),(4.315,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(5.895,6.695),(5.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,5.51),(4.315,5.81),(4.615,5.81),(4.615,5.51),(4.315,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.425,5.05),(4.425,5.81),(4.655,5.81),(4.655,5.05),(4.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.2,6.465),(0.2,6.625),(0.36,6.625),(0.36,6.465),(0.2,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.54,6.465),(0.54,6.625),(0.7,6.625),(0.7,6.465),(0.54,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.88,6.465),(0.88,6.625),(1.04,6.625),(1.04,6.465),(0.88,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.22,6.465),(1.22,6.625),(1.38,6.625),(1.38,6.465),(1.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.56,6.465),(1.56,6.625),(1.72,6.625),(1.72,6.465),(1.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.9,6.465),(1.9,6.625),(2.06,6.625),(2.06,6.465),(1.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.24,6.465),(2.24,6.625),(2.4,6.625),(2.4,6.465),(2.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.58,6.465),(2.58,6.625),(2.74,6.625),(2.74,6.465),(2.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.92,6.465),(2.92,6.625),(3.08,6.625),(3.08,6.465),(2.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.26,6.465),(3.26,6.625),(3.42,6.625),(3.42,6.465),(3.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.6,6.465),(3.6,6.625),(3.76,6.625),(3.76,6.465),(3.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.94,6.465),(3.94,6.625),(4.1,6.625),(4.1,6.465),(3.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.28,6.465),(4.28,6.625),(4.44,6.625),(4.44,6.465),(4.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.62,6.465),(4.62,6.625),(4.78,6.625),(4.78,6.465),(4.62,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.96,6.465),(4.96,6.625),(5.12,6.625),(5.12,6.465),(4.96,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.3,6.465),(5.3,6.625),(5.46,6.625),(5.46,6.465),(5.3,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.64,6.465),(5.64,6.625),(5.8,6.625),(5.8,6.465),(5.64,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.385,5.58),(4.385,5.74),(4.545,5.74),(4.545,5.58),(4.385,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(6.0,6.8),(6.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.305,5.58),(4.305,5.74),(4.625,5.74),(4.625,5.58),(4.305,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.2,6.385),(0.2,6.705),(5.8,6.705),(5.8,6.385),(0.2,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.0), u(6.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.0), u(6.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((4.315,0.99),(4.315,1.29),(4.615,1.29),(4.615,0.99),(4.315,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(5.895,0.405),(5.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.995,0.99),(2.995,1.75),(3.445,1.75),(3.445,0.99),(2.995,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.425,0.99),(4.425,1.75),(4.655,1.75),(4.655,0.99),(4.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.275,0.99),(4.275,1.75),(4.505,1.75),(4.505,0.99),(4.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.655,0.99),(4.655,1.75),(5.105,1.75),(5.105,0.99),(4.655,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,0.99),(4.315,1.75),(4.615,1.75),(4.615,0.99),(4.315,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.825,0.99),(3.825,1.75),(4.275,1.75),(4.275,0.99),(3.825,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.13,0.105),(0.13,0.405),(5.87,0.405),(5.87,0.105),(0.13,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.345,0.99),(4.345,1.75),(4.585,1.75),(4.585,0.99),(4.345,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.2,0.175),(0.2,0.335),(0.36,0.335),(0.36,0.175),(0.2,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.54,0.175),(0.54,0.335),(0.7,0.335),(0.7,0.175),(0.54,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.88,0.175),(0.88,0.335),(1.04,0.335),(1.04,0.175),(0.88,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.22,0.175),(1.22,0.335),(1.38,0.335),(1.38,0.175),(1.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.56,0.175),(1.56,0.335),(1.72,0.335),(1.72,0.175),(1.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.9,0.175),(1.9,0.335),(2.06,0.335),(2.06,0.175),(1.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.24,0.175),(2.24,0.335),(2.4,0.335),(2.4,0.175),(2.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.58,0.175),(2.58,0.335),(2.74,0.335),(2.74,0.175),(2.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.92,0.175),(2.92,0.335),(3.08,0.335),(3.08,0.175),(2.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.26,0.175),(3.26,0.335),(3.42,0.335),(3.42,0.175),(3.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.6,0.175),(3.6,0.335),(3.76,0.335),(3.76,0.175),(3.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.94,0.175),(3.94,0.335),(4.1,0.335),(4.1,0.175),(3.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.28,0.175),(4.28,0.335),(4.44,0.335),(4.44,0.175),(4.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.62,0.175),(4.62,0.335),(4.78,0.335),(4.78,0.175),(4.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.96,0.175),(4.96,0.335),(5.12,0.335),(5.12,0.175),(4.96,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.3,0.175),(5.3,0.335),(5.46,0.335),(5.46,0.175),(5.3,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.64,0.175),(5.64,0.335),(5.8,0.335),(5.8,0.175),(5.64,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.385,1.06),(4.385,1.22),(4.545,1.22),(4.545,1.06),(4.385,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.2,0.095),(0.2,0.415),(5.8,0.415),(5.8,0.095),(0.2,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.305,1.06),(4.305,1.22),(4.625,1.22),(4.625,1.06),(4.305,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(6.0,1.22),(6.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.0), u(6.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.0), u(6.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.44),(0.535,2.74),(0.835,2.74),(0.835,2.44),(0.535,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,2.44),(0.67,2.74),(1.5,2.74),(1.5,2.44),(0.67,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,4.06),(0.535,4.36),(0.835,4.36),(0.835,4.06),(0.535,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.74),(0.895,2.74),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,4.06),(0.67,4.36),(1.5,4.36),(1.5,4.06),(0.67,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.06),(1.275,5.99),(1.725,5.99),(1.725,4.06),(1.275,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.74),(1.725,2.74),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.06),(0.445,5.99),(0.895,5.99),(0.895,4.06),(0.445,4.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.51),(0.605,2.67),(0.765,2.67),(0.765,2.51),(0.605,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,4.13),(0.605,4.29),(0.765,4.29),(0.765,4.13),(0.605,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.05),(0.605,4.37),(0.765,4.37),(0.765,4.05),(0.605,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.43),(0.605,2.75),(0.765,2.75),(0.765,2.43),(0.605,2.43)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,1.75),(2.1,1.75),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((3.485,5.05),(3.485,5.35),(3.785,5.35),(3.785,5.05),(3.485,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.515,5.05),(3.515,5.81),(3.755,5.81),(3.755,5.05),(3.515,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.595,5.05),(3.595,5.81),(3.825,5.81),(3.825,5.05),(3.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.485,5.05),(3.485,5.81),(3.785,5.81),(3.785,5.05),(3.485,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.35),(2.065,5.35),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.445,5.05),(3.445,5.81),(3.675,5.81),(3.675,5.05),(3.445,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.555,5.12),(3.555,5.28),(3.715,5.28),(3.715,5.12),(3.555,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.12),(1.835,5.28),(1.995,5.28),(1.995,5.12),(1.835,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.555,5.04),(3.555,5.36),(3.715,5.36),(3.715,5.04),(3.555,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,5.04),(1.835,5.36),(1.995,5.36),(1.995,5.04),(1.835,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,5.04),(1.915,5.36),(3.635,5.36),(3.635,5.04),(1.915,5.04)),
        )
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((2.625,4.06),(2.625,5.81),(2.925,5.81),(2.925,4.06),(2.625,4.06)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,1.45),(2.625,1.75),(2.925,1.75),(2.925,1.45),(2.625,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.925,5.81),(2.925,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.765,5.05),(2.765,5.81),(2.995,5.81),(2.995,5.05),(2.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.765,0.99),(2.765,1.75),(2.995,1.75),(2.995,0.99),(2.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.06),(2.625,4.36),(2.925,4.36),(2.925,4.06),(2.625,4.06)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.925,1.75),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.52),(2.695,1.68),(2.855,1.68),(2.855,1.52),(2.695,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.13),(2.695,4.29),(2.855,4.29),(2.855,4.13),(2.695,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.05),(1.115,4.37),(2.775,4.37),(2.775,4.05),(1.115,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,1.44),(1.115,1.76),(2.775,1.76),(2.775,1.44),(1.115,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.44),(1.01,1.76),(1.22,1.76),(1.22,1.44),(1.01,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,4.05),(2.695,4.37),(2.855,4.37),(2.855,4.05),(2.695,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.44),(1.01,4.82),(1.22,4.82),(1.22,1.44),(1.01,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.44),(2.695,1.76),(2.855,1.76),(2.855,1.44),(2.695,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,4.05),(1.01,4.37),(1.22,4.37),(1.22,4.05),(1.01,4.05)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.115), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.115), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((1.905,2.44),(1.905,2.74),(2.205,2.74),(2.205,2.44),(1.905,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.605,2.44),(4.605,2.74),(4.88,2.74),(4.88,2.44),(4.605,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.74),(2.555,2.74),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.455,4.06),(4.455,4.36),(4.755,4.36),(4.755,4.06),(4.455,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.455,2.44),(4.455,2.74),(4.755,2.74),(4.755,2.44),(4.455,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.655,0.81),(4.655,2.74),(5.105,2.74),(5.105,0.81),(4.655,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.655,4.87),(4.655,5.99),(5.105,5.99),(5.105,4.87),(4.655,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.655,0.81),(4.655,1.93),(5.105,1.93),(5.105,0.81),(4.655,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,2.44),(2.055,2.74),(2.33,2.74),(2.33,2.44),(2.055,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.825,4.06),(3.825,5.99),(4.275,5.99),(4.275,4.06),(3.825,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.655,4.06),(4.655,5.99),(5.105,5.99),(5.105,4.06),(4.655,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.05,4.06),(4.05,4.36),(4.88,4.36),(4.88,4.06),(4.05,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.825,4.87),(3.825,5.99),(4.275,5.99),(4.275,4.87),(3.825,4.87)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.525,2.51),(4.525,2.67),(4.685,2.67),(4.685,2.51),(4.525,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,2.51),(1.975,2.67),(2.135,2.67),(2.135,2.51),(1.975,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.525,4.13),(4.525,4.29),(4.685,4.29),(4.685,4.13),(4.525,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.525,2.43),(4.525,2.75),(4.685,2.75),(4.685,2.43),(4.525,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,2.43),(1.975,2.75),(2.135,2.75),(2.135,2.43),(1.975,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.5,1.44),(4.5,5.36),(4.71,5.36),(4.71,1.44),(4.5,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.5,2.43),(4.5,2.75),(4.71,2.75),(4.71,2.43),(4.5,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.055,2.43),(2.055,2.75),(4.605,2.75),(4.605,2.43),(2.055,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.525,4.05),(4.525,4.37),(4.685,4.37),(4.685,4.05),(4.525,4.05)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(4.605), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.605), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1_n']
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.52),(2.105,5.99),(2.555,5.99),(2.555,3.52),(2.105,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.825,0.81),(3.825,3.28),(4.275,3.28),(4.275,0.81),(3.825,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.52),(2.055,3.82),(2.33,3.82),(2.33,3.52),(2.055,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.625,2.98),(3.625,3.28),(3.925,3.28),(3.925,2.98),(3.625,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.775,2.98),(3.775,3.28),(5.295,3.28),(5.295,2.98),(3.775,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.52),(1.905,3.82),(2.205,3.82),(2.205,3.52),(1.905,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.145,2.98),(5.145,3.28),(5.445,3.28),(5.445,2.98),(5.145,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.825,0.81),(3.825,1.93),(4.275,1.93),(4.275,0.81),(3.825,0.81)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.105,5.05),(5.105,5.81),(5.335,5.81),(5.335,5.05),(5.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.175,0.99),(5.175,1.75),(5.445,1.75),(5.445,0.99),(5.175,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,5.05),(5.145,5.35),(5.445,5.35),(5.445,5.05),(5.145,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,1.45),(5.145,1.75),(5.445,1.75),(5.445,1.45),(5.145,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.105,0.99),(5.105,1.75),(5.335,1.75),(5.335,0.99),(5.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,5.05),(5.145,5.81),(5.445,5.81),(5.445,5.05),(5.145,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,0.99),(5.145,1.75),(5.445,1.75),(5.445,0.99),(5.145,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.175,5.05),(5.175,5.81),(5.445,5.81),(5.445,5.05),(5.175,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.215,1.52),(5.215,1.68),(5.375,1.68),(5.375,1.52),(5.215,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.215,5.12),(5.215,5.28),(5.375,5.28),(5.375,5.12),(5.215,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.215,3.05),(5.215,3.21),(5.375,3.21),(5.375,3.05),(5.215,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.695,3.05),(3.695,3.21),(3.855,3.21),(3.855,3.05),(3.695,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.59),(1.975,3.75),(2.135,3.75),(2.135,3.59),(1.975,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.67,3.51),(3.67,3.83),(3.88,3.83),(3.88,3.51),(3.67,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.055,3.51),(2.055,3.83),(3.775,3.83),(3.775,3.51),(2.055,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.695,2.97),(3.695,3.29),(3.855,3.29),(3.855,2.97),(3.695,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.19,1.44),(5.19,5.36),(5.4,5.36),(5.4,1.44),(5.19,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.215,1.44),(5.215,1.76),(5.375,1.76),(5.375,1.44),(5.215,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.215,5.04),(5.215,5.36),(5.375,5.36),(5.375,5.04),(5.215,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.215,2.97),(5.215,3.29),(5.375,3.29),(5.375,2.97),(5.215,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.51),(1.975,3.83),(2.135,3.83),(2.135,3.51),(1.975,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.67,2.97),(3.67,3.83),(3.88,3.83),(3.88,2.97),(3.67,2.97)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((3.45,0.99),(3.45,1.75),(3.82,1.75),(3.82,0.99),(3.45,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.595,0.99),(3.595,1.75),(3.825,1.75),(3.825,0.99),(3.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.445,0.99),(3.445,1.75),(3.675,1.75),(3.675,0.99),(3.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.515,0.99),(3.515,1.75),(3.755,1.75),(3.755,0.99),(3.515,0.99)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['nexor2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(6.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i0_n': Net.create(cell, 'i0_n'),
            'i1': Net.create(cell, 'i1'),
            'i1_n': Net.create(cell, 'i1_n'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i0_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.995,4.87),(2.995,5.99),(3.445,5.99),(3.445,4.87),(2.995,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.995,0.81),(2.995,1.93),(3.445,1.93),(3.445,0.81),(2.995,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(3.22,3.28),(3.22,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.995,0.81),(2.995,4.87),(3.445,4.87),(3.445,0.81),(2.995,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.88),(2.445,5.99),(3.105,5.99),(3.105,3.88),(2.445,3.88)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.05,-0.075),(-0.05,0.585),(6.05,0.585),(6.05,-0.075),(-0.05,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.105,6.21),(3.105,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.595,4.65),(2.595,6.21),(3.845,6.21),(3.845,4.65),(2.595,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.165,4.65),(4.165,6.21),(4.765,6.21),(4.765,4.65),(4.165,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.255,4.65),(4.255,6.21),(5.505,6.21),(5.505,4.65),(4.255,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.135,4.65),(4.135,6.21),(4.795,6.21),(4.795,4.65),(4.135,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.995,4.65),(4.995,6.21),(5.625,6.21),(5.625,4.65),(4.995,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(6.075,0.585),(6.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.425,4.65),(3.425,6.21),(4.675,6.21),(4.675,4.65),(3.425,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.965,4.65),(4.965,6.21),(5.625,6.21),(5.625,4.65),(4.965,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.335,4.65),(3.335,6.21),(3.935,6.21),(3.935,4.65),(3.335,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.305,4.65),(3.305,6.21),(3.965,6.21),(3.965,4.65),(3.305,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,5.75),(2.245,5.75),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(6.075,6.21),(6.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.135,5.11),(4.135,6.21),(4.795,6.21),(4.795,5.11),(4.135,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.965,4.65),(4.965,5.75),(5.625,5.75),(5.625,4.65),(4.965,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.245,4.87),(4.245,5.99),(5.515,5.99),(5.515,4.87),(4.245,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.305,4.65),(3.305,5.75),(3.965,5.75),(3.965,4.65),(3.305,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.88),(2.445,4.54),(3.105,4.54),(3.105,3.88),(2.445,3.88)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.585,4.87),(2.585,5.99),(3.855,5.99),(3.855,4.87),(2.585,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.415,4.87),(3.415,5.99),(4.685,5.99),(4.685,4.87),(3.415,4.87)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.325,4.78),(3.325,6.08),(4.775,6.08),(4.775,4.78),(3.325,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.325,0.72),(3.325,2.02),(4.775,2.02),(4.775,0.72),(3.325,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.485,0.73),(3.485,2.01),(4.615,2.01),(4.615,0.73),(3.485,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.155,4.78),(4.155,6.08),(5.605,6.08),(5.605,4.78),(4.155,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(6.27,7.07),(6.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.315,0.73),(4.315,2.01),(5.445,2.01),(5.445,0.73),(4.315,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.495,4.78),(2.495,6.08),(3.945,6.08),(3.945,4.78),(2.495,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.315,4.79),(4.315,6.07),(5.445,6.07),(5.445,4.79),(4.315,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.655,4.79),(2.655,6.07),(3.785,6.07),(3.785,4.79),(2.655,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.495,0.72),(2.495,2.02),(3.945,2.02),(3.945,0.72),(2.495,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.655,0.73),(2.655,2.01),(3.785,2.01),(3.785,0.73),(2.655,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.485,4.79),(3.485,6.07),(4.615,6.07),(4.615,4.79),(3.485,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.155,0.72),(4.155,2.02),(5.605,2.02),(5.605,0.72),(4.155,0.72)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.235,6.12),(3.235,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.175,4.74),(3.175,5.66),(4.095,5.66),(4.095,4.74),(3.175,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.835,4.74),(4.835,5.66),(5.755,5.66),(5.755,4.74),(4.835,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.285,4.74),(3.285,6.12),(4.815,6.12),(4.815,4.74),(3.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.005,4.74),(4.005,6.12),(4.925,6.12),(4.925,4.74),(4.005,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.205,4.74),(3.205,6.12),(4.065,6.12),(4.065,4.74),(3.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.18,6.085),(-0.18,7.005),(6.18,7.005),(6.18,6.085),(-0.18,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.75),(2.315,6.12),(3.235,6.12),(3.235,3.75),(2.315,3.75)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,5.66),(2.375,5.66),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.035,4.74),(4.035,6.12),(4.895,6.12),(4.895,4.74),(4.035,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(6.205,7.005),(6.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(6.62,7.42),(6.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.005,5.2),(4.005,6.12),(4.925,6.12),(4.925,5.2),(4.005,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.75),(2.315,4.67),(3.235,4.67),(3.235,3.75),(2.315,3.75)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.455,4.74),(2.455,6.12),(3.985,6.12),(3.985,4.74),(2.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.865,4.74),(4.865,6.12),(5.755,6.12),(5.755,4.74),(4.865,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.175,4.74),(3.175,6.12),(4.095,6.12),(4.095,4.74),(3.175,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.835,4.74),(4.835,6.12),(5.755,6.12),(5.755,4.74),(4.835,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.115,4.74),(4.115,6.12),(5.645,6.12),(5.645,4.74),(4.115,4.74)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.275,5.05),(4.275,5.81),(4.505,5.81),(4.505,5.05),(4.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.655,5.05),(4.655,5.81),(5.105,5.81),(5.105,5.05),(4.655,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.345,5.05),(4.345,5.81),(4.585,5.81),(4.585,5.05),(4.345,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.13,6.395),(0.13,6.695),(5.87,6.695),(5.87,6.395),(0.13,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.995,5.05),(2.995,5.81),(3.445,5.81),(3.445,5.05),(2.995,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.825,5.05),(3.825,5.81),(4.275,5.81),(4.275,5.05),(3.825,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,5.05),(4.315,5.81),(4.615,5.81),(4.615,5.05),(4.315,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(5.895,6.695),(5.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,5.51),(4.315,5.81),(4.615,5.81),(4.615,5.51),(4.315,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.425,5.05),(4.425,5.81),(4.655,5.81),(4.655,5.05),(4.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.2,6.465),(0.2,6.625),(0.36,6.625),(0.36,6.465),(0.2,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.54,6.465),(0.54,6.625),(0.7,6.625),(0.7,6.465),(0.54,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.88,6.465),(0.88,6.625),(1.04,6.625),(1.04,6.465),(0.88,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.22,6.465),(1.22,6.625),(1.38,6.625),(1.38,6.465),(1.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.56,6.465),(1.56,6.625),(1.72,6.625),(1.72,6.465),(1.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.9,6.465),(1.9,6.625),(2.06,6.625),(2.06,6.465),(1.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.24,6.465),(2.24,6.625),(2.4,6.625),(2.4,6.465),(2.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.58,6.465),(2.58,6.625),(2.74,6.625),(2.74,6.465),(2.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.92,6.465),(2.92,6.625),(3.08,6.625),(3.08,6.465),(2.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.26,6.465),(3.26,6.625),(3.42,6.625),(3.42,6.465),(3.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.6,6.465),(3.6,6.625),(3.76,6.625),(3.76,6.465),(3.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.94,6.465),(3.94,6.625),(4.1,6.625),(4.1,6.465),(3.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.28,6.465),(4.28,6.625),(4.44,6.625),(4.44,6.465),(4.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.62,6.465),(4.62,6.625),(4.78,6.625),(4.78,6.465),(4.62,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.96,6.465),(4.96,6.625),(5.12,6.625),(5.12,6.465),(4.96,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.3,6.465),(5.3,6.625),(5.46,6.625),(5.46,6.465),(5.3,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.64,6.465),(5.64,6.625),(5.8,6.625),(5.8,6.465),(5.64,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.385,5.58),(4.385,5.74),(4.545,5.74),(4.545,5.58),(4.385,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(6.0,6.8),(6.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.305,5.58),(4.305,5.74),(4.625,5.74),(4.625,5.58),(4.305,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.2,6.385),(0.2,6.705),(5.8,6.705),(5.8,6.385),(0.2,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.0), u(6.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.0), u(6.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((4.315,0.99),(4.315,1.29),(4.615,1.29),(4.615,0.99),(4.315,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(5.895,0.405),(5.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.995,0.99),(2.995,1.75),(3.445,1.75),(3.445,0.99),(2.995,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.425,0.99),(4.425,1.75),(4.655,1.75),(4.655,0.99),(4.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.275,0.99),(4.275,1.75),(4.505,1.75),(4.505,0.99),(4.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.655,0.99),(4.655,1.75),(5.105,1.75),(5.105,0.99),(4.655,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.315,0.99),(4.315,1.75),(4.615,1.75),(4.615,0.99),(4.315,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.825,0.99),(3.825,1.75),(4.275,1.75),(4.275,0.99),(3.825,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.13,0.105),(0.13,0.405),(5.87,0.405),(5.87,0.105),(0.13,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.345,0.99),(4.345,1.75),(4.585,1.75),(4.585,0.99),(4.345,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.2,0.175),(0.2,0.335),(0.36,0.335),(0.36,0.175),(0.2,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.54,0.175),(0.54,0.335),(0.7,0.335),(0.7,0.175),(0.54,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.88,0.175),(0.88,0.335),(1.04,0.335),(1.04,0.175),(0.88,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.22,0.175),(1.22,0.335),(1.38,0.335),(1.38,0.175),(1.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.56,0.175),(1.56,0.335),(1.72,0.335),(1.72,0.175),(1.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.9,0.175),(1.9,0.335),(2.06,0.335),(2.06,0.175),(1.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.24,0.175),(2.24,0.335),(2.4,0.335),(2.4,0.175),(2.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.58,0.175),(2.58,0.335),(2.74,0.335),(2.74,0.175),(2.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.92,0.175),(2.92,0.335),(3.08,0.335),(3.08,0.175),(2.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.26,0.175),(3.26,0.335),(3.42,0.335),(3.42,0.175),(3.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.6,0.175),(3.6,0.335),(3.76,0.335),(3.76,0.175),(3.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.94,0.175),(3.94,0.335),(4.1,0.335),(4.1,0.175),(3.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.28,0.175),(4.28,0.335),(4.44,0.335),(4.44,0.175),(4.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.62,0.175),(4.62,0.335),(4.78,0.335),(4.78,0.175),(4.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.96,0.175),(4.96,0.335),(5.12,0.335),(5.12,0.175),(4.96,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.3,0.175),(5.3,0.335),(5.46,0.335),(5.46,0.175),(5.3,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.64,0.175),(5.64,0.335),(5.8,0.335),(5.8,0.175),(5.64,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.385,1.06),(4.385,1.22),(4.545,1.22),(4.545,1.06),(4.385,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.2,0.095),(0.2,0.415),(5.8,0.415),(5.8,0.095),(0.2,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.305,1.06),(4.305,1.22),(4.625,1.22),(4.625,1.06),(4.305,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(6.0,1.22),(6.0,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.0), u(6.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.0), u(6.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.44),(0.535,2.74),(0.835,2.74),(0.835,2.44),(0.535,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,2.44),(0.67,2.74),(1.5,2.74),(1.5,2.44),(0.67,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,4.06),(0.535,4.36),(0.835,4.36),(0.835,4.06),(0.535,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.74),(0.895,2.74),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,4.06),(0.67,4.36),(1.5,4.36),(1.5,4.06),(0.67,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.06),(1.275,5.99),(1.725,5.99),(1.725,4.06),(1.275,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.74),(1.725,2.74),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.06),(0.445,5.99),(0.895,5.99),(0.895,4.06),(0.445,4.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.51),(0.605,2.67),(0.765,2.67),(0.765,2.51),(0.605,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,4.13),(0.605,4.29),(0.765,4.29),(0.765,4.13),(0.605,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.05),(0.605,4.37),(0.765,4.37),(0.765,4.05),(0.605,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.43),(0.605,2.75),(0.765,2.75),(0.765,2.43),(0.605,2.43)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.73,0.99),(1.73,1.75),(2.1,1.75),(2.1,0.99),(1.73,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((3.485,5.05),(3.485,5.35),(3.785,5.35),(3.785,5.05),(3.485,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.515,5.05),(3.515,5.81),(3.755,5.81),(3.755,5.05),(3.515,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.595,5.05),(3.595,5.81),(3.825,5.81),(3.825,5.05),(3.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.485,5.05),(3.485,5.81),(3.785,5.81),(3.785,5.05),(3.485,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.35),(2.065,5.35),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.445,5.05),(3.445,5.81),(3.675,5.81),(3.675,5.05),(3.445,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.555,5.12),(3.555,5.28),(3.715,5.28),(3.715,5.12),(3.555,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.12),(1.835,5.28),(1.995,5.28),(1.995,5.12),(1.835,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.555,5.04),(3.555,5.36),(3.715,5.36),(3.715,5.04),(3.555,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,5.04),(1.835,5.36),(1.995,5.36),(1.995,5.04),(1.835,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,5.04),(1.915,5.36),(3.635,5.36),(3.635,5.04),(1.915,5.04)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((2.625,4.06),(2.625,5.81),(2.925,5.81),(2.925,4.06),(2.625,4.06)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,1.45),(2.625,1.75),(2.925,1.75),(2.925,1.45),(2.625,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.925,5.81),(2.925,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.765,5.05),(2.765,5.81),(2.995,5.81),(2.995,5.05),(2.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.765,0.99),(2.765,1.75),(2.995,1.75),(2.995,0.99),(2.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.06),(2.625,4.36),(2.925,4.36),(2.925,4.06),(2.625,4.06)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.925,1.75),(2.925,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,1.52),(2.695,1.68),(2.855,1.68),(2.855,1.52),(2.695,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.695,4.13),(2.695,4.29),(2.855,4.29),(2.855,4.13),(2.695,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.05),(1.115,4.37),(2.775,4.37),(2.775,4.05),(1.115,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,1.44),(1.115,1.76),(2.775,1.76),(2.775,1.44),(1.115,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.44),(1.01,1.76),(1.22,1.76),(1.22,1.44),(1.01,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,4.05),(2.695,4.37),(2.855,4.37),(2.855,4.05),(2.695,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.44),(1.01,4.82),(1.22,4.82),(1.22,1.44),(1.01,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.695,1.44),(2.695,1.76),(2.855,1.76),(2.855,1.44),(2.695,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,4.05),(1.01,4.37),(1.22,4.37),(1.22,4.05),(1.01,4.05)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.115), u(0.21), u(1.44), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.115), u(0.21), u(1.44), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1_n']
        createRL(
            tech, net, 'GatPoly',
            ((1.905,2.44),(1.905,2.74),(2.205,2.74),(2.205,2.44),(1.905,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.74),(2.555,2.74),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,2.44),(2.055,2.74),(2.33,2.74),(2.33,2.44),(2.055,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.825,2.98),(3.825,5.99),(4.275,5.99),(4.275,2.98),(3.825,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.625,2.98),(3.625,3.28),(3.925,3.28),(3.925,2.98),(3.625,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.775,2.98),(3.775,3.28),(5.295,3.28),(5.295,2.98),(3.775,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.145,2.98),(5.145,3.28),(5.445,3.28),(5.445,2.98),(5.145,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.825,4.87),(3.825,5.99),(4.275,5.99),(4.275,4.87),(3.825,4.87)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.105,5.05),(5.105,5.81),(5.335,5.81),(5.335,5.05),(5.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.175,0.99),(5.175,1.75),(5.445,1.75),(5.445,0.99),(5.175,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,5.05),(5.145,5.35),(5.445,5.35),(5.445,5.05),(5.145,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,1.45),(5.145,1.75),(5.445,1.75),(5.445,1.45),(5.145,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.105,0.99),(5.105,1.75),(5.335,1.75),(5.335,0.99),(5.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,5.05),(5.145,5.81),(5.445,5.81),(5.445,5.05),(5.145,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.145,0.99),(5.145,1.75),(5.445,1.75),(5.445,0.99),(5.145,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.175,5.05),(5.175,5.81),(5.445,5.81),(5.445,5.05),(5.175,5.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.19,1.44),(5.19,5.36),(5.4,5.36),(5.4,1.44),(5.19,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.695,2.97),(3.695,3.29),(3.855,3.29),(3.855,2.97),(3.695,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,2.43),(1.975,2.75),(2.135,2.75),(2.135,2.43),(1.975,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.215,1.44),(5.215,1.76),(5.375,1.76),(5.375,1.44),(5.215,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.215,5.04),(5.215,5.36),(5.375,5.36),(5.375,5.04),(5.215,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.215,2.97),(5.215,3.29),(5.375,3.29),(5.375,2.97),(5.215,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.67,2.43),(3.67,3.29),(3.88,3.29),(3.88,2.43),(3.67,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.67,2.43),(3.67,2.75),(3.88,2.75),(3.88,2.43),(3.67,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.055,2.43),(2.055,2.75),(3.775,2.75),(3.775,2.43),(2.055,2.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.215,5.12),(5.215,5.28),(5.375,5.28),(5.375,5.12),(5.215,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.215,3.05),(5.215,3.21),(5.375,3.21),(5.375,3.05),(5.215,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.695,3.05),(3.695,3.21),(3.855,3.21),(3.855,3.05),(3.695,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.215,1.52),(5.215,1.68),(5.375,1.68),(5.375,1.52),(5.215,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,2.51),(1.975,2.67),(2.135,2.67),(2.135,2.51),(1.975,2.51)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((4.655,0.81),(4.655,2.74),(5.105,2.74),(5.105,0.81),(4.655,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.825,0.81),(3.825,1.93),(4.275,1.93),(4.275,0.81),(3.825,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.05,2.44),(4.05,2.74),(4.88,2.74),(4.88,2.44),(4.05,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.455,4.06),(4.455,4.36),(4.755,4.36),(4.755,4.06),(4.455,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.455,2.44),(4.455,2.74),(4.755,2.74),(4.755,2.44),(4.455,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.52),(2.105,5.99),(2.555,5.99),(2.555,3.52),(2.105,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.605,4.06),(4.605,4.36),(4.88,4.36),(4.88,4.06),(4.605,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.655,4.87),(4.655,5.99),(5.105,5.99),(5.105,4.87),(4.655,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.655,0.81),(4.655,1.93),(5.105,1.93),(5.105,0.81),(4.655,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.655,4.06),(4.655,5.99),(5.105,5.99),(5.105,4.06),(4.655,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.52),(2.055,3.82),(2.33,3.82),(2.33,3.52),(2.055,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.52),(1.905,3.82),(2.205,3.82),(2.205,3.52),(1.905,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.825,0.81),(3.825,2.74),(4.275,2.74),(4.275,0.81),(3.825,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.525,2.51),(4.525,2.67),(4.685,2.67),(4.685,2.51),(4.525,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.59),(1.975,3.75),(2.135,3.75),(2.135,3.59),(1.975,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.525,4.13),(4.525,4.29),(4.685,4.29),(4.685,4.13),(4.525,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.525,2.43),(4.525,2.75),(4.685,2.75),(4.685,2.43),(4.525,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.5,1.44),(4.5,5.36),(4.71,5.36),(4.71,1.44),(4.5,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.5,3.51),(4.5,3.83),(4.71,3.83),(4.71,3.51),(4.5,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.055,3.51),(2.055,3.83),(4.605,3.83),(4.605,3.51),(2.055,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.51),(1.975,3.83),(2.135,3.83),(2.135,3.51),(1.975,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.525,4.05),(4.525,4.37),(4.685,4.37),(4.685,4.05),(4.525,4.05)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(4.605), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.605), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((3.45,0.99),(3.45,1.75),(3.82,1.75),(3.82,0.99),(3.45,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.595,0.99),(3.595,1.75),(3.825,1.75),(3.825,0.99),(3.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.445,0.99),(3.445,1.75),(3.675,1.75),(3.675,0.99),(3.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.515,0.99),(3.515,1.75),(3.755,1.75),(3.755,0.99),(3.515,0.99)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['nsnrlatch_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'nq': Net.create(cell, 'nq'),
            'nrst': Net.create(cell, 'nrst'),
            'nset': Net.create(cell, 'nset'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.35),(1.235,5.35),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.59),(1.975,3.75),(2.135,3.75),(2.135,3.59),(1.975,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.12),(1.005,5.28),(1.165,5.28),(1.165,5.12),(1.005,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,5.04),(0.685,5.36),(1.085,5.36),(1.085,5.04),(0.685,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,5.04),(1.005,5.36),(1.165,5.36),(1.165,5.04),(1.005,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.51),(0.685,3.83),(2.055,3.83),(2.055,3.51),(0.685,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,1.76),(0.79,1.76),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.51),(1.975,3.83),(2.135,3.83),(2.135,3.51),(1.975,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,1.76),(0.685,1.76),(0.685,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,3.51),(0.58,3.83),(0.79,3.83),(0.79,3.51),(0.58,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,5.04),(0.58,5.36),(0.79,5.36),(0.79,5.04),(0.58,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,1.93),(2.555,1.93),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,4.87),(2.105,5.99),(2.555,5.99),(2.555,4.87),(2.105,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,2.98),(1.225,3.28),(1.5,3.28),(1.5,2.98),(1.225,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,4.87),(2.555,4.87),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.52),(2.055,3.82),(2.33,3.82),(2.33,3.52),(2.055,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.52),(1.905,3.82),(2.205,3.82),(2.205,3.52),(1.905,3.52)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.035,5.81),(2.035,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,5.05),(3.455,5.81),(3.725,5.81),(3.725,5.05),(3.455,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,5.05),(2.935,5.81),(3.385,5.81),(3.385,5.05),(2.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.51),(3.425,5.81),(3.725,5.81),(3.725,5.51),(3.425,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,5.05),(2.105,5.81),(2.555,5.81),(2.555,5.05),(2.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,5.05),(3.385,5.81),(3.615,5.81),(3.615,5.05),(3.385,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,5.05),(1.875,5.81),(2.105,5.81),(2.105,5.05),(1.875,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.05),(3.425,5.81),(3.725,5.81),(3.725,5.05),(3.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,4.74),(2.315,6.12),(3.175,6.12),(3.175,4.74),(2.315,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.205,6.12),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,4.74),(1.565,6.12),(3.095,6.12),(3.095,4.74),(1.565,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,5.2),(3.115,6.12),(4.035,6.12),(4.035,5.2),(3.115,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,5.66),(1.545,5.66),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,5.66),(3.205,5.66),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,4.74),(2.395,6.12),(3.925,6.12),(3.925,4.74),(2.395,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,4.74),(3.145,6.12),(4.035,6.12),(4.035,4.74),(3.145,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,4.74),(3.115,6.12),(4.035,6.12),(4.035,4.74),(3.115,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.345,6.12),(2.345,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.58),(3.495,5.74),(3.655,5.74),(3.655,5.58),(3.495,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,5.58),(3.415,5.74),(3.735,5.74),(3.735,5.58),(3.415,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.705,4.65),(1.705,6.21),(2.955,6.21),(2.955,4.65),(1.705,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,4.65),(2.445,6.21),(3.045,6.21),(3.045,4.65),(2.445,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,5.11),(3.245,6.21),(3.905,6.21),(3.905,5.11),(3.245,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,5.75),(1.415,5.75),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,4.65),(3.275,6.21),(3.905,6.21),(3.905,4.65),(3.275,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.075,6.21),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,5.75),(3.075,5.75),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.215,6.21),(2.215,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,4.65),(3.245,6.21),(3.905,6.21),(3.905,4.65),(3.245,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,4.87),(2.525,5.99),(3.795,5.99),(3.795,4.87),(2.525,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,4.87),(1.695,5.99),(2.965,5.99),(2.965,4.87),(1.695,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.65),(2.535,6.21),(3.785,6.21),(3.785,4.65),(2.535,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,2.02),(3.055,2.02),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,4.78),(2.435,6.08),(3.885,6.08),(3.885,4.78),(2.435,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,2.01),(2.895,2.01),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,4.79),(2.595,6.07),(3.725,6.07),(3.725,4.79),(2.595,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,4.78),(1.605,6.08),(3.055,6.08),(3.055,4.78),(1.605,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.02),(3.885,2.02),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.01),(3.725,2.01),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,4.79),(1.765,6.07),(2.895,6.07),(2.895,4.79),(1.765,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.035,1.75),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,1.75),(2.105,1.75),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,1.75),(3.385,1.75),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,1.75),(2.555,1.75),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,1.75),(1.27,1.75),(1.27,0.99),(0.9,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        net = nets['nset']
        createRL(
            tech, net, 'GatPoly',
            ((3.16,2.98),(3.16,3.28),(3.175,3.28),(3.175,2.98),(3.16,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.52),(0.255,3.82),(0.67,3.82),(0.67,3.52),(0.255,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,4.87),(0.895,4.87),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.52),(0.105,3.82),(0.405,3.82),(0.405,3.52),(0.105,3.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.59),(0.175,3.75),(0.335,3.75),(0.335,3.59),(0.175,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.98),(0.15,5.36),(0.36,5.36),(0.36,1.98),(0.15,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.51),(0.175,3.83),(0.335,3.83),(0.335,3.51),(0.175,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.075,2.98),(1.075,3.28),(1.375,3.28),(1.375,2.98),(1.075,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.12),(2.665,5.28),(2.825,5.28),(2.825,5.12),(2.665,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.05),(1.145,3.21),(1.305,3.21),(1.305,3.05),(1.145,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.52),(3.495,1.68),(3.655,1.68),(3.655,1.52),(3.495,1.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.745,1.44),(2.745,1.76),(3.575,1.76),(3.575,1.44),(2.745,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,2.97),(2.64,3.29),(2.85,3.29),(2.85,2.97),(2.64,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,1.44),(2.64,5.36),(2.85,5.36),(2.85,1.44),(2.64,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,5.04),(2.665,5.36),(2.825,5.36),(2.825,5.04),(2.665,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,1.44),(2.64,1.76),(2.85,1.76),(2.85,1.44),(2.64,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.225,2.97),(1.225,3.29),(2.745,3.29),(2.745,2.97),(1.225,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,2.97),(1.145,3.29),(1.305,3.29),(1.305,2.97),(1.145,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,1.44),(3.495,1.76),(3.655,1.76),(3.655,1.44),(3.495,1.44)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,1.75),(3.725,1.75),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.35),(2.895,5.35),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,5.05),(2.705,5.81),(2.935,5.81),(2.935,5.05),(2.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.895,5.81),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,5.05),(2.625,5.81),(2.865,5.81),(2.865,5.05),(2.625,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,1.75),(3.615,1.75),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,5.05),(2.555,5.81),(2.785,5.81),(2.785,5.05),(2.555,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,1.45),(3.425,1.75),(3.725,1.75),(3.725,1.45),(3.425,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.75),(3.725,1.75),(3.725,0.99),(3.425,0.99)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((2.56,0.99),(2.56,1.75),(2.93,1.75),(2.93,0.99),(2.56,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,1.75),(2.865,1.75),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,1.75),(2.785,1.75),(2.785,0.99),(2.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,1.75),(2.935,1.75),(2.935,0.99),(2.705,0.99)),
        )
        net = nets['nrst']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,1.93),(3.385,1.93),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.87),(2.935,5.99),(3.385,5.99),(3.385,4.87),(2.935,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,4.87),(3.385,4.87),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.025,2.98),(3.025,3.28),(3.325,3.28),(3.325,2.98),(3.025,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.095,3.05),(3.095,3.21),(3.255,3.21),(3.255,3.05),(3.095,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.095,2.97),(3.095,3.29),(3.255,3.29),(3.255,2.97),(3.095,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.07,1.98),(3.07,5.36),(3.28,5.36),(3.28,1.98),(3.07,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.175), u(0.21), u(1.98), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.175), u(0.21), u(1.98), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nset'].setDirection(Net.Direction.IN)
        nets['nrst'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['nsnrlatch_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'nq': Net.create(cell, 'nq'),
            'nrst': Net.create(cell, 'nrst'),
            'nset': Net.create(cell, 'nset'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((0.105,1.605),(0.105,2.585),(0.405,2.585),(0.405,1.605),(0.105,1.605)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,2.78),(0.445,2.78),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.02),(0.935,5.81),(1.235,5.81),(1.235,4.02),(0.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,4.215),(0.935,5.195),(1.235,5.195),(1.235,4.215),(0.935,4.215)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.405,2.78),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,4.02),(1.045,5.81),(1.275,5.81),(1.275,4.02),(1.045,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,2.78),(0.375,2.78),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,4.02),(0.965,5.81),(1.205,5.81),(1.205,4.02),(0.965,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,4.02),(0.895,5.81),(1.125,5.81),(1.125,4.02),(0.895,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.285),(1.005,4.445),(1.165,4.445),(1.165,4.285),(1.005,4.285)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.625),(1.005,4.785),(1.165,4.785),(1.165,4.625),(1.005,4.625)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,4.965),(1.005,5.125),(1.165,5.125),(1.165,4.965),(1.005,4.965)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.59),(1.975,3.75),(2.135,3.75),(2.135,3.59),(1.975,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.675),(0.175,1.835),(0.335,1.835),(0.335,1.675),(0.175,1.675)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.015),(0.175,2.175),(0.335,2.175),(0.335,2.015),(0.175,2.015)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.355),(0.175,2.515),(0.335,2.515),(0.335,2.355),(0.175,2.355)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.51),(0.685,3.83),(2.055,3.83),(2.055,3.51),(0.685,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,2.75),(0.335,2.75),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,3.51),(1.975,3.83),(2.135,3.83),(2.135,3.51),(1.975,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.44),(0.255,2.75),(0.685,2.75),(0.685,1.44),(0.255,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.205),(1.005,5.205),(1.165,5.205),(1.165,4.205),(1.005,4.205)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,3.51),(0.58,3.83),(0.79,3.83),(0.79,3.51),(0.58,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.595),(0.175,2.595),(0.335,2.595),(0.335,1.595),(0.175,1.595)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.005,4.05),(1.005,5.36),(1.165,5.36),(1.165,4.05),(1.005,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.05),(0.685,5.36),(1.085,5.36),(1.085,4.05),(0.685,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,4.05),(0.58,4.37),(0.79,4.37),(0.79,4.05),(0.58,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,2.43),(0.58,2.75),(0.79,2.75),(0.79,2.43),(0.58,2.43)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,3.84),(2.105,5.99),(2.555,5.99),(2.555,3.84),(2.105,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.225,2.98),(1.225,3.28),(1.5,3.28),(1.5,2.98),(1.225,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,3.52),(2.055,3.82),(2.33,3.82),(2.33,3.52),(2.055,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,2.96),(2.555,2.96),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.105,0.81),(2.105,3.84),(2.555,3.84),(2.555,0.81),(2.105,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.52),(1.905,3.82),(2.205,3.82),(2.205,3.52),(1.905,3.52)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.15,6.395),(0.15,6.695),(3.85,6.695),(3.85,6.395),(0.15,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.02),(2.105,5.81),(2.555,5.81),(2.555,4.02),(2.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,4.02),(2.935,5.81),(3.385,5.81),(3.385,4.02),(2.935,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.02),(0.445,5.81),(0.895,5.81),(0.895,4.02),(0.445,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.375,5.81),(0.375,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.51),(3.425,5.81),(3.725,5.81),(3.725,5.51),(3.425,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.51),(0.105,5.81),(0.405,5.81),(0.405,5.51),(0.105,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,4.02),(1.765,5.81),(2.065,5.81),(2.065,4.02),(1.765,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,4.02),(3.425,5.81),(3.725,5.81),(3.725,4.02),(3.425,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.02),(1.875,5.81),(2.105,5.81),(2.105,4.02),(1.875,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,4.02),(1.795,5.81),(2.035,5.81),(2.035,4.02),(1.795,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,4.02),(3.385,5.81),(3.615,5.81),(3.615,4.02),(3.385,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.51),(1.765,5.81),(2.065,5.81),(2.065,5.51),(1.765,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.02),(0.105,5.81),(0.405,5.81),(0.405,4.02),(0.105,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,4.02),(3.455,5.81),(3.725,5.81),(3.725,4.02),(3.455,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,4.02),(1.275,5.81),(1.725,5.81),(1.725,4.02),(1.275,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.02),(0.215,5.81),(0.445,5.81),(0.445,4.02),(0.215,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.02),(1.725,5.81),(1.955,5.81),(1.955,4.02),(1.725,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(3.895,6.695),(3.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,5.2),(1.455,6.12),(2.375,6.12),(2.375,5.2),(1.455,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.315,3.71),(2.315,6.12),(3.175,6.12),(3.175,3.71),(2.315,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,5.2),(3.115,6.12),(4.035,6.12),(4.035,5.2),(3.115,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,3.71),(3.145,6.12),(4.035,6.12),(4.035,3.71),(3.145,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.905),(2.285,5.505),(3.205,5.505),(3.205,3.905),(2.285,3.905)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.685,6.12),(0.685,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,3.71),(1.485,6.12),(2.345,6.12),(2.345,3.71),(1.485,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.2),(-0.205,6.12),(0.715,6.12),(0.715,5.2),(-0.205,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,3.71),(3.115,6.12),(4.035,6.12),(4.035,3.71),(3.115,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.71),(-0.205,6.12),(0.715,6.12),(0.715,3.71),(-0.205,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,3.71),(1.455,6.12),(2.375,6.12),(2.375,3.71),(1.455,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,3.71),(2.285,6.12),(3.205,6.12),(3.205,3.71),(2.285,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,3.71),(0.655,6.12),(1.515,6.12),(1.515,3.71),(0.655,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(4.205,7.005),(4.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.905),(0.625,5.505),(1.545,5.505),(1.545,3.905),(0.625,3.905)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,6.085),(-0.16,7.005),(4.16,7.005),(4.16,6.085),(-0.16,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.71),(1.565,6.12),(3.095,6.12),(3.095,3.71),(1.565,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(4.62,7.42),(4.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.71),(-0.095,6.12),(1.435,6.12),(1.435,3.71),(-0.095,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,3.71),(0.625,6.12),(1.545,6.12),(1.545,3.71),(0.625,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,3.71),(0.735,6.12),(2.265,6.12),(2.265,3.71),(0.735,3.71)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,3.71),(2.395,6.12),(3.925,6.12),(3.925,3.71),(2.395,3.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.58),(0.175,5.74),(0.335,5.74),(0.335,5.58),(0.175,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.58),(3.495,5.74),(3.655,5.74),(3.655,5.58),(3.495,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.58),(1.835,5.74),(1.995,5.74),(1.995,5.58),(1.835,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,6.465),(0.22,6.625),(0.38,6.625),(0.38,6.465),(0.22,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,6.465),(0.56,6.625),(0.72,6.625),(0.72,6.465),(0.56,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,6.465),(0.9,6.625),(1.06,6.625),(1.06,6.465),(0.9,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,6.465),(1.24,6.625),(1.4,6.625),(1.4,6.465),(1.24,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,6.465),(1.58,6.625),(1.74,6.625),(1.74,6.465),(1.58,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,6.465),(1.92,6.625),(2.08,6.625),(2.08,6.465),(1.92,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,6.465),(2.26,6.625),(2.42,6.625),(2.42,6.465),(2.26,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,6.465),(2.6,6.625),(2.76,6.625),(2.76,6.465),(2.6,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,6.465),(2.94,6.625),(3.1,6.625),(3.1,6.465),(2.94,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,6.465),(3.28,6.625),(3.44,6.625),(3.44,6.465),(3.28,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,6.465),(3.62,6.625),(3.78,6.625),(3.78,6.465),(3.62,6.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(4.0,6.8),(4.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,5.58),(1.755,5.74),(2.075,5.74),(2.075,5.58),(1.755,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,5.58),(3.415,5.74),(3.735,5.74),(3.735,5.58),(3.415,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,5.58),(0.095,5.74),(0.415,5.74),(0.415,5.58),(0.095,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,6.385),(0.22,6.705),(3.78,6.705),(3.78,6.385),(0.22,6.385)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((3.245,3.62),(3.245,6.21),(3.905,6.21),(3.905,3.62),(3.245,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,5.11),(-0.075,6.21),(0.585,6.21),(0.585,5.11),(-0.075,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,3.62),(0.045,6.21),(1.295,6.21),(1.295,3.62),(0.045,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,5.11),(3.245,6.21),(3.905,6.21),(3.905,5.11),(3.245,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,3.62),(1.705,6.21),(2.955,6.21),(2.955,3.62),(1.705,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.62),(0.755,6.21),(1.415,6.21),(1.415,3.62),(0.755,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(4.075,6.21),(4.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.84),(0.035,5.99),(1.305,5.99),(1.305,3.84),(0.035,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.555,6.21),(0.555,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,3.84),(0.865,5.99),(2.135,5.99),(2.135,3.84),(0.865,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,3.62),(1.585,6.21),(2.245,6.21),(2.245,3.62),(1.585,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,3.84),(2.525,5.99),(3.795,5.99),(3.795,3.84),(2.525,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.815),(2.415,5.595),(3.075,5.595),(3.075,3.815),(2.415,3.815)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.62),(-0.075,6.21),(0.585,6.21),(0.585,3.62),(-0.075,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.62),(2.535,6.21),(3.785,6.21),(3.785,3.62),(2.535,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,3.62),(2.415,6.21),(3.075,6.21),(3.075,3.62),(2.415,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.84),(1.695,5.99),(2.965,5.99),(2.965,3.84),(1.695,3.84)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,3.62),(0.875,6.21),(2.125,6.21),(2.125,3.62),(0.875,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,3.62),(1.615,6.21),(2.215,6.21),(2.215,3.62),(1.615,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.445,3.62),(2.445,6.21),(3.045,6.21),(3.045,3.62),(2.445,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,5.11),(1.585,6.21),(2.245,6.21),(2.245,5.11),(1.585,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,3.62),(3.275,6.21),(3.905,6.21),(3.905,3.62),(3.275,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,3.815),(0.755,5.595),(1.415,5.595),(1.415,3.815),(0.755,3.815)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,3.62),(0.785,6.21),(1.385,6.21),(1.385,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,3.75),(0.775,6.08),(2.225,6.08),(2.225,3.75),(0.775,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,0.72),(1.605,3.05),(3.055,3.05),(3.055,0.72),(1.605,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(4.27,7.07),(4.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,3.76),(1.765,6.07),(2.895,6.07),(2.895,3.76),(1.765,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,3.75),(-0.055,6.08),(1.395,6.08),(1.395,3.75),(-0.055,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,3.76),(0.935,6.07),(2.065,6.07),(2.065,3.76),(0.935,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,3.76),(2.595,6.07),(3.725,6.07),(3.725,3.76),(2.595,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,3.75),(2.435,6.08),(3.885,6.08),(3.885,3.75),(2.435,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,3.05),(2.225,3.05),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.765,0.73),(1.765,3.04),(2.895,3.04),(2.895,0.73),(1.765,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,3.04),(3.725,3.04),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,3.04),(2.065,3.04),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,3.76),(0.105,6.07),(1.235,6.07),(1.235,3.76),(0.105,3.76)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,3.05),(1.395,3.05),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((1.605,3.75),(1.605,6.08),(3.055,6.08),(3.055,3.75),(1.605,3.75)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,3.04),(1.235,3.04),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,3.05),(3.885,3.05),(3.885,0.72),(2.435,0.72)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.105,0.99),(2.105,2.78),(2.555,2.78),(2.555,0.99),(2.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,2.78),(3.385,2.78),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,2.78),(0.895,2.78),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,2.78),(2.065,2.78),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,2.78),(1.725,2.78),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,2.78),(2.035,2.78),(2.035,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.99),(1.875,2.78),(2.105,2.78),(2.105,0.99),(1.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,2.78),(1.955,2.78),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.29),(2.065,1.29),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.06),(1.835,1.22),(1.995,1.22),(1.995,1.06),(1.835,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.755,1.06),(1.755,1.22),(2.075,1.22),(2.075,1.06),(1.755,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(4.0,1.22),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,2.78),(1.125,2.78),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,2.78),(1.275,2.78),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,2.78),(1.205,2.78),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.9,0.99),(0.9,2.78),(1.27,2.78),(1.27,0.99),(0.9,0.99)),
        )
        net = nets['nset']
        createRL(
            tech, net, 'GatPoly',
            ((3.16,2.98),(3.16,3.28),(3.175,3.28),(3.175,2.98),(3.16,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.52),(0.255,3.82),(0.67,3.82),(0.67,3.52),(0.255,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.84),(0.445,5.99),(0.895,5.99),(0.895,3.84),(0.445,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.52),(0.105,3.82),(0.405,3.82),(0.405,3.52),(0.105,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,2.96),(0.895,2.96),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.84),(0.895,3.84),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.59),(0.175,3.75),(0.335,3.75),(0.335,3.59),(0.175,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,2.97),(0.15,5.36),(0.36,5.36),(0.36,2.97),(0.15,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.51),(0.175,3.83),(0.335,3.83),(0.335,3.51),(0.175,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(2.97), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(2.97), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,2.96),(1.725,2.96),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.075,2.98),(1.075,3.28),(1.375,3.28),(1.375,2.98),(1.075,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,3.84),(1.275,5.99),(1.725,5.99),(1.725,3.84),(1.275,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,3.84),(1.725,3.84),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.675),(3.495,1.835),(3.655,1.835),(3.655,1.675),(3.495,1.675)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,2.015),(3.495,2.175),(3.655,2.175),(3.655,2.015),(3.495,2.015)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,2.355),(3.495,2.515),(3.655,2.515),(3.655,2.355),(3.495,2.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.145,3.05),(1.145,3.21),(1.305,3.21),(1.305,3.05),(1.145,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.285),(2.665,4.445),(2.825,4.445),(2.825,4.285),(2.665,4.285)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.625),(2.665,4.785),(2.825,4.785),(2.825,4.625),(2.665,4.625)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,4.965),(2.665,5.125),(2.825,5.125),(2.825,4.965),(2.665,4.965)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,1.595),(3.495,2.595),(3.655,2.595),(3.655,1.595),(3.495,1.595)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.495,1.44),(3.495,2.75),(3.655,2.75),(3.655,1.44),(3.495,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.05),(2.665,5.36),(2.825,5.36),(2.825,4.05),(2.665,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,2.43),(2.64,2.75),(2.85,2.75),(2.85,2.43),(2.64,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,2.97),(2.64,3.29),(2.85,3.29),(2.85,2.97),(2.64,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.745,1.44),(2.745,2.75),(3.575,2.75),(3.575,1.44),(2.745,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.64,1.44),(2.64,5.36),(2.85,5.36),(2.85,1.44),(2.64,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.225,2.97),(1.225,3.29),(2.745,3.29),(2.745,2.97),(1.225,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,4.205),(2.665,5.205),(2.825,5.205),(2.825,4.205),(2.665,4.205)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,2.97),(1.145,3.29),(1.305,3.29),(1.305,2.97),(1.145,2.97)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.02),(2.595,5.81),(2.895,5.81),(2.895,4.02),(2.595,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,4.02),(2.705,5.81),(2.935,5.81),(2.935,4.02),(2.705,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,4.02),(2.555,5.81),(2.785,5.81),(2.785,4.02),(2.555,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,4.215),(2.595,5.195),(2.895,5.195),(2.895,4.215),(2.595,4.215)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,1.605),(3.425,2.585),(3.725,2.585),(3.725,1.605),(3.425,1.605)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,2.78),(3.725,2.78),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,4.02),(2.625,5.81),(2.865,5.81),(2.865,4.02),(2.625,4.02)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,2.78),(3.725,2.78),(3.725,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,2.78),(3.615,2.78),(3.615,0.99),(3.385,0.99)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.745), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,2.78),(2.935,2.78),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.625,0.99),(2.625,2.78),(2.865,2.78),(2.865,0.99),(2.625,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.56,0.99),(2.56,2.78),(2.93,2.78),(2.93,0.99),(2.56,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.555,0.99),(2.555,2.78),(2.785,2.78),(2.785,0.99),(2.555,0.99)),
        )
        net = nets['nrst']
        createRL(
            tech, net, 'GatPoly',
            ((2.935,3.84),(2.935,5.99),(3.385,5.99),(3.385,3.84),(2.935,3.84)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,2.96),(3.385,2.96),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,3.84),(3.385,3.84),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.025,2.98),(3.025,3.28),(3.325,3.28),(3.325,2.98),(3.025,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.095,3.05),(3.095,3.21),(3.255,3.21),(3.255,3.05),(3.095,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.095,2.97),(3.095,3.29),(3.255,3.29),(3.255,2.97),(3.095,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.07,2.97),(3.07,5.36),(3.28,5.36),(3.28,2.97),(3.07,2.97)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.175), u(0.21), u(2.97), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.175), u(0.21), u(2.97), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nset'].setDirection(Net.Direction.IN)
        nets['nrst'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['dff_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(12.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_clk_buf': Net.create(cell, '_clk_buf'),
            '_clk_n': Net.create(cell, '_clk_n'),
            '_dff_m': Net.create(cell, '_dff_m'),
            '_dff_s': Net.create(cell, '_dff_s'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            '_net5': Net.create(cell, '_net5'),
            '_u': Net.create(cell, '_u'),
            '_y': Net.create(cell, '_y'),
            'clk': Net.create(cell, 'clk'),
            'i': Net.create(cell, 'i'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_clk_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.615,2.51),(8.615,2.67),(8.775,2.67),(8.775,2.51),(8.615,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.465,2.51),(4.465,2.67),(4.625,2.67),(4.625,2.51),(4.465,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.465,3.59),(4.465,3.75),(4.625,3.75),(4.625,3.59),(4.465,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.59),(0.175,3.75),(0.335,3.75),(0.335,3.59),(0.175,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.615,3.59),(8.615,3.75),(8.775,3.75),(8.775,3.59),(8.615,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.59,2.43),(8.59,3.83),(8.8,3.83),(8.8,2.43),(8.59,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.465,2.43),(4.465,2.75),(4.625,2.75),(4.625,2.43),(4.465,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.615,2.43),(8.615,2.75),(8.775,2.75),(8.775,2.43),(8.615,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.465,3.51),(4.465,3.83),(4.625,3.83),(4.625,3.51),(4.465,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.51),(0.175,3.83),(0.335,3.83),(0.335,3.51),(0.175,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.615,3.51),(8.615,3.83),(8.775,3.83),(8.775,3.51),(8.615,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.44,2.43),(4.44,3.83),(4.65,3.83),(4.65,2.43),(4.44,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.545,3.52),(8.545,3.82),(8.845,3.82),(8.845,3.52),(8.545,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.395,2.44),(4.395,2.74),(4.695,2.74),(4.695,2.44),(4.395,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.915,4.87),(7.915,5.99),(8.365,5.99),(8.365,4.87),(7.915,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.425,3.52),(5.425,5.99),(5.875,5.99),(5.875,3.52),(5.425,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.52),(0.105,3.82),(0.405,3.82),(0.405,3.52),(0.105,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.595,0.81),(4.595,1.93),(5.045,1.93),(5.045,0.81),(4.595,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.52),(0.255,3.82),(8.695,3.82),(8.695,3.52),(0.255,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.695,2.44),(8.695,2.74),(8.97,2.74),(8.97,2.44),(8.695,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.915,3.52),(7.915,5.99),(8.365,5.99),(8.365,3.52),(7.915,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.745,0.81),(8.745,1.93),(9.195,1.93),(9.195,0.81),(8.745,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.595,0.81),(4.595,2.74),(5.045,2.74),(5.045,0.81),(4.595,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.545,2.44),(8.545,2.74),(8.845,2.74),(8.845,2.44),(8.545,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.745,0.81),(8.745,2.74),(9.195,2.74),(9.195,0.81),(8.745,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.395,3.52),(4.395,3.82),(4.695,3.82),(4.695,3.52),(4.395,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.545,2.44),(4.545,2.74),(4.82,2.74),(4.82,2.44),(4.545,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.425,4.87),(5.425,5.99),(5.875,5.99),(5.875,4.87),(5.425,4.87)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((9.915,4.03),(9.915,6.21),(10.575,6.21),(10.575,4.03),(9.915,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.565,5.11),(6.565,6.21),(7.225,6.21),(7.225,5.11),(6.565,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.395,4.65),(7.395,5.75),(8.055,5.75),(8.055,4.65),(7.395,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.185,4.87),(4.185,5.99),(5.455,5.99),(5.455,4.87),(4.185,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.855,4.65),(5.855,6.21),(7.105,6.21),(7.105,4.65),(5.855,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(12.075,6.21),(12.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.905,4.65),(4.905,5.75),(5.565,5.75),(5.565,4.65),(4.905,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.165,4.87),(9.165,5.99),(10.435,5.99),(10.435,4.87),(9.165,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,5.11),(3.245,6.21),(3.905,6.21),(3.905,5.11),(3.245,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.245,6.21),(2.245,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.745,4.03),(10.745,6.21),(11.405,6.21),(11.405,4.03),(10.745,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.345,4.65),(8.345,6.21),(9.595,6.21),(9.595,4.65),(8.345,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,4.65),(4.105,6.21),(4.705,6.21),(4.705,4.65),(4.105,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.035,4.03),(10.035,6.21),(11.285,6.21),(11.285,4.03),(10.035,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.355,4.87),(3.355,5.99),(4.625,5.99),(4.625,4.87),(3.355,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,4.65),(3.275,6.21),(3.875,6.21),(3.875,4.65),(3.275,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.915,4.03),(9.915,6.21),(10.545,6.21),(10.545,4.03),(9.915,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.565,4.65),(6.565,6.21),(7.225,6.21),(7.225,4.65),(6.565,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.075,6.21),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(12.075,0.585),(12.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.425,4.65),(7.425,6.21),(8.025,6.21),(8.025,4.65),(7.425,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.775,4.03),(10.775,6.21),(11.405,6.21),(11.405,4.03),(10.775,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,5.75),(3.075,5.75),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.935,4.65),(4.935,6.21),(5.535,6.21),(5.535,4.65),(4.935,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.025,4.65),(5.025,6.21),(6.275,6.21),(6.275,4.65),(5.025,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.7,4.65),(5.7,6.21),(6.43,6.21),(6.43,4.65),(5.7,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.685,4.65),(6.685,6.21),(7.935,6.21),(7.935,4.65),(6.685,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.045,6.21),(3.045,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.595,4.65),(6.595,6.21),(7.195,6.21),(7.195,4.65),(6.595,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.015,4.87),(5.015,5.99),(6.285,5.99),(6.285,4.87),(5.015,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,4.65),(3.245,6.21),(3.905,6.21),(3.905,4.65),(3.245,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,4.87),(2.525,5.99),(3.795,5.99),(3.795,4.87),(2.525,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.915,5.11),(9.915,6.21),(10.575,6.21),(10.575,5.11),(9.915,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.505,4.87),(7.505,5.99),(8.775,5.99),(8.775,4.87),(7.505,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.06,-0.075),(0.06,0.585),(11.94,0.585),(11.94,-0.075),(0.06,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.225,4.65),(8.225,6.21),(8.885,6.21),(8.885,4.65),(8.225,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.04,4.65),(4.04,6.21),(4.77,6.21),(4.77,4.65),(4.04,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.025,4.25),(10.025,5.99),(11.295,5.99),(11.295,4.25),(10.025,4.25)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.255,4.65),(8.255,6.21),(8.855,6.21),(8.855,4.65),(8.255,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,5.75),(2.245,5.75),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.175,4.65),(9.175,6.21),(10.425,6.21),(10.425,4.65),(9.175,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.675,4.87),(6.675,5.99),(7.945,5.99),(7.945,4.87),(6.675,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.225,4.65),(8.225,5.75),(8.885,5.75),(8.885,4.65),(8.225,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.745,4.255),(10.745,5.695),(11.405,5.695),(11.405,4.255),(10.745,4.255)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.765,4.65),(5.765,6.21),(6.365,6.21),(6.365,4.65),(5.765,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.085,4.65),(9.085,6.21),(9.685,6.21),(9.685,4.65),(9.085,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.905,4.65),(4.905,6.21),(5.565,6.21),(5.565,4.65),(4.905,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.395,4.65),(7.395,6.21),(8.055,6.21),(8.055,4.65),(7.395,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.845,4.87),(5.845,5.99),(7.115,5.99),(7.115,4.87),(5.845,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.365,4.65),(3.365,6.21),(4.615,6.21),(4.615,4.65),(3.365,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.02,4.65),(9.02,6.21),(9.75,6.21),(9.75,4.65),(9.02,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.195,4.65),(4.195,6.21),(5.445,6.21),(5.445,4.65),(4.195,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.335,4.87),(8.335,5.99),(9.605,5.99),(9.605,4.87),(8.335,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.65),(2.535,6.21),(3.785,6.21),(3.785,4.65),(2.535,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.515,4.65),(7.515,6.21),(8.765,6.21),(8.765,4.65),(7.515,4.65)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.235,4.79),(9.235,6.07),(10.365,6.07),(10.365,4.79),(9.235,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,4.78),(2.435,6.08),(3.885,6.08),(3.885,4.78),(2.435,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.095,0.72),(4.095,2.02),(5.545,2.02),(5.545,0.72),(4.095,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.915,4.79),(5.915,6.07),(7.045,6.07),(7.045,4.79),(5.915,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((7.575,0.73),(7.575,2.01),(8.705,2.01),(8.705,0.73),(7.575,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((8.405,4.79),(8.405,6.07),(9.535,6.07),(9.535,4.79),(8.405,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.075,0.72),(9.075,2.02),(10.525,2.02),(10.525,0.72),(9.075,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.755,4.78),(5.755,6.08),(7.205,6.08),(7.205,4.78),(5.755,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.935,4.16),(9.935,6.08),(11.385,6.08),(11.385,4.16),(9.935,4.16)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.085,4.79),(5.085,6.07),(6.215,6.07),(6.215,4.79),(5.085,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.235,0.73),(9.235,2.01),(10.365,2.01),(10.365,0.73),(9.235,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((6.585,0.72),(6.585,2.02),(8.035,2.02),(8.035,0.72),(6.585,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.755,0.72),(5.755,2.02),(7.205,2.02),(7.205,0.72),(5.755,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((7.415,4.78),(7.415,6.08),(8.865,6.08),(8.865,4.78),(7.415,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((8.245,4.78),(8.245,6.08),(9.695,6.08),(9.695,4.78),(8.245,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.085,0.73),(5.085,2.01),(6.215,2.01),(6.215,0.73),(5.085,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((10.095,4.17),(10.095,6.07),(11.225,6.07),(11.225,4.17),(10.095,4.17)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.925,0.72),(4.925,2.02),(6.375,2.02),(6.375,0.72),(4.925,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.075,4.78),(9.075,6.08),(10.525,6.08),(10.525,4.78),(9.075,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,4.79),(2.595,6.07),(3.725,6.07),(3.725,4.79),(2.595,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.915,0.73),(5.915,2.01),(7.045,2.01),(7.045,0.73),(5.915,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.935,0.72),(9.935,2.64),(11.385,2.64),(11.385,0.72),(9.935,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(12.27,7.07),(12.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((10.095,0.73),(10.095,2.63),(11.225,2.63),(11.225,0.73),(10.095,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.925,4.78),(4.925,6.08),(6.375,6.08),(6.375,4.78),(4.925,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.095,4.78),(4.095,6.08),(5.545,6.08),(5.545,4.78),(4.095,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((8.405,0.73),(8.405,2.01),(9.535,2.01),(9.535,0.73),(8.405,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.265,0.72),(3.265,2.02),(4.715,2.02),(4.715,0.72),(3.265,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.265,4.78),(3.265,6.08),(4.715,6.08),(4.715,4.78),(3.265,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.255,4.79),(4.255,6.07),(5.385,6.07),(5.385,4.79),(4.255,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.01),(3.725,2.01),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((7.415,0.72),(7.415,2.02),(8.865,2.02),(8.865,0.72),(7.415,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.255,0.73),(4.255,2.01),(5.385,2.01),(5.385,0.73),(4.255,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((6.745,4.79),(6.745,6.07),(7.875,6.07),(7.875,4.79),(6.745,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.425,4.79),(3.425,6.07),(4.555,6.07),(4.555,4.79),(3.425,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.02),(3.885,2.02),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.425,0.73),(3.425,2.01),(4.555,2.01),(4.555,0.73),(3.425,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((7.575,4.79),(7.575,6.07),(8.705,6.07),(8.705,4.79),(7.575,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((8.245,0.72),(8.245,2.02),(9.695,2.02),(9.695,0.72),(8.245,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((6.745,0.73),(6.745,2.01),(7.875,2.01),(7.875,0.73),(6.745,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((6.585,4.78),(6.585,6.08),(8.035,6.08),(8.035,4.78),(6.585,4.78)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((10.615,4.12),(10.615,6.12),(11.535,6.12),(11.535,4.12),(10.615,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.205,6.12),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.295,4.74),(7.295,6.12),(8.155,6.12),(8.155,4.74),(7.295,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.265,4.74),(7.265,6.12),(8.185,6.12),(8.185,4.74),(7.265,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,5.2),(3.115,6.12),(4.035,6.12),(4.035,5.2),(3.115,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.07,6.085),(-0.07,7.005),(12.07,7.005),(12.07,6.085),(-0.07,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.895,4.12),(9.895,6.12),(11.425,6.12),(11.425,4.12),(9.895,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.785,4.12),(9.785,6.12),(10.675,6.12),(10.675,4.12),(9.785,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,4.74),(3.145,6.12),(4.005,6.12),(4.005,4.74),(3.145,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.635,4.74),(5.635,6.12),(6.495,6.12),(6.495,4.74),(5.635,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.375,4.74),(7.375,6.12),(8.905,6.12),(8.905,4.74),(7.375,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.265,4.74),(7.265,5.66),(8.185,5.66),(8.185,4.74),(7.265,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.91,4.74),(3.91,6.12),(4.9,6.12),(4.9,4.74),(3.91,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,5.66),(3.205,5.66),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.095,4.74),(8.095,6.12),(9.015,6.12),(9.015,4.74),(8.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.205,4.74),(8.205,6.12),(9.735,6.12),(9.735,4.74),(8.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((10.615,4.345),(10.615,5.605),(11.535,5.605),(11.535,4.345),(10.615,4.345)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,4.74),(2.395,6.12),(3.925,6.12),(3.925,4.74),(2.395,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.035,4.74),(9.035,6.12),(10.565,6.12),(10.565,4.74),(9.035,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.785,5.2),(9.785,6.12),(10.705,6.12),(10.705,5.2),(9.785,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.375,6.12),(2.375,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.095,4.74),(8.095,5.66),(9.015,5.66),(9.015,4.74),(8.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.175,6.12),(3.175,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.435,5.2),(6.435,6.12),(7.355,6.12),(7.355,5.2),(6.435,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.715,4.74),(5.715,6.12),(7.245,6.12),(7.245,4.74),(5.715,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.125,4.74),(8.125,6.12),(8.985,6.12),(8.985,4.74),(8.125,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.055,4.74),(4.055,6.12),(5.585,6.12),(5.585,4.74),(4.055,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.955,4.74),(8.955,6.12),(9.815,6.12),(9.815,4.74),(8.955,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.435,4.74),(6.435,6.12),(7.355,6.12),(7.355,4.74),(6.435,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,4.74),(3.115,6.12),(4.035,6.12),(4.035,4.74),(3.115,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(12.62,7.42),(12.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.775,4.74),(4.775,6.12),(5.695,6.12),(5.695,4.74),(4.775,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.225,4.74),(3.225,6.12),(4.755,6.12),(4.755,4.74),(3.225,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((10.645,4.12),(10.645,6.12),(11.535,6.12),(11.535,4.12),(10.645,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,5.66),(2.375,5.66),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.805,4.74),(4.805,6.12),(5.665,6.12),(5.665,4.74),(4.805,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,4.74),(3.975,6.12),(4.835,6.12),(4.835,4.74),(3.975,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.885,4.74),(4.885,6.12),(6.415,6.12),(6.415,4.74),(4.885,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.465,4.74),(6.465,6.12),(7.325,6.12),(7.325,4.74),(6.465,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.775,4.74),(4.775,5.66),(5.695,5.66),(5.695,4.74),(4.775,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.57,4.74),(5.57,6.12),(6.56,6.12),(6.56,4.74),(5.57,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.545,4.74),(6.545,6.12),(8.075,6.12),(8.075,4.74),(6.545,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(12.205,7.005),(12.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.785,4.12),(9.785,6.12),(10.705,6.12),(10.705,4.12),(9.785,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.89,4.74),(8.89,6.12),(9.88,6.12),(9.88,4.74),(8.89,4.74)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.745,5.05),(6.745,5.81),(7.045,5.81),(7.045,5.05),(6.745,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.085,5.05),(7.085,5.81),(7.535,5.81),(7.535,5.05),(7.085,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.745,5.05),(8.745,5.81),(9.195,5.81),(9.195,5.05),(8.745,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.575,5.05),(9.575,5.81),(10.025,5.81),(10.025,5.05),(9.575,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.095,4.43),(10.095,5.81),(10.365,5.81),(10.365,4.43),(10.095,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.775,5.05),(6.775,5.81),(7.015,5.81),(7.015,5.05),(6.775,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.535,5.05),(3.535,5.81),(3.765,5.81),(3.765,5.05),(3.535,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.425,5.05),(5.425,5.81),(5.875,5.81),(5.875,5.05),(5.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.025,5.05),(10.025,5.81),(10.255,5.81),(10.255,5.05),(10.025,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.595,5.05),(4.595,5.81),(5.045,5.81),(5.045,5.05),(4.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,5.05),(3.455,5.81),(3.695,5.81),(3.695,5.05),(3.455,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.745,5.51),(6.745,5.81),(7.045,5.81),(7.045,5.51),(6.745,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,5.05),(6.855,5.81),(7.085,5.81),(7.085,5.05),(6.855,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,5.05),(2.935,5.81),(3.385,5.81),(3.385,5.05),(2.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(11.895,6.695),(11.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.51),(3.425,5.81),(3.725,5.81),(3.725,5.51),(3.425,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.095,5.51),(10.095,5.81),(10.395,5.81),(10.395,5.51),(10.095,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.255,5.05),(6.255,5.81),(6.705,5.81),(6.705,5.05),(6.255,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.435,4.43),(10.435,5.81),(10.885,5.81),(10.885,4.43),(10.435,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.915,5.05),(7.915,5.81),(8.365,5.81),(8.365,5.05),(7.915,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.24,6.395),(0.24,6.695),(11.76,6.695),(11.76,6.395),(0.24,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,5.05),(3.385,5.81),(3.615,5.81),(3.615,5.05),(3.385,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.095,4.43),(10.095,5.81),(10.395,5.81),(10.395,4.43),(10.095,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.705,5.05),(6.705,5.81),(6.935,5.81),(6.935,5.05),(6.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,5.05),(3.765,5.81),(4.215,5.81),(4.215,5.05),(3.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.05),(3.425,5.81),(3.725,5.81),(3.725,5.05),(3.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.205,4.43),(10.205,5.81),(10.435,5.81),(10.435,4.43),(10.205,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.58),(3.495,5.74),(3.655,5.74),(3.655,5.58),(3.495,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.31,6.465),(0.31,6.625),(0.47,6.625),(0.47,6.465),(0.31,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.65,6.465),(0.65,6.625),(0.81,6.625),(0.81,6.465),(0.65,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.99,6.465),(0.99,6.625),(1.15,6.625),(1.15,6.465),(0.99,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.33,6.465),(1.33,6.625),(1.49,6.625),(1.49,6.465),(1.33,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.67,6.465),(1.67,6.625),(1.83,6.625),(1.83,6.465),(1.67,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.01,6.465),(2.01,6.625),(2.17,6.625),(2.17,6.465),(2.01,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.35,6.465),(2.35,6.625),(2.51,6.625),(2.51,6.465),(2.35,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.69,6.465),(2.69,6.625),(2.85,6.625),(2.85,6.465),(2.69,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.03,6.465),(3.03,6.625),(3.19,6.625),(3.19,6.465),(3.03,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.37,6.465),(3.37,6.625),(3.53,6.625),(3.53,6.465),(3.37,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.71,6.465),(3.71,6.625),(3.87,6.625),(3.87,6.465),(3.71,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.05,6.465),(4.05,6.625),(4.21,6.625),(4.21,6.465),(4.05,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.39,6.465),(4.39,6.625),(4.55,6.625),(4.55,6.465),(4.39,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.73,6.465),(4.73,6.625),(4.89,6.625),(4.89,6.465),(4.73,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.07,6.465),(5.07,6.625),(5.23,6.625),(5.23,6.465),(5.07,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.41,6.465),(5.41,6.625),(5.57,6.625),(5.57,6.465),(5.41,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.75,6.465),(5.75,6.625),(5.91,6.625),(5.91,6.465),(5.75,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.09,6.465),(6.09,6.625),(6.25,6.625),(6.25,6.465),(6.09,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.43,6.465),(6.43,6.625),(6.59,6.625),(6.59,6.465),(6.43,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.77,6.465),(6.77,6.625),(6.93,6.625),(6.93,6.465),(6.77,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.11,6.465),(7.11,6.625),(7.27,6.625),(7.27,6.465),(7.11,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.45,6.465),(7.45,6.625),(7.61,6.625),(7.61,6.465),(7.45,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.79,6.465),(7.79,6.625),(7.95,6.625),(7.95,6.465),(7.79,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.13,6.465),(8.13,6.625),(8.29,6.625),(8.29,6.465),(8.13,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.47,6.465),(8.47,6.625),(8.63,6.625),(8.63,6.465),(8.47,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.81,6.465),(8.81,6.625),(8.97,6.625),(8.97,6.465),(8.81,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.15,6.465),(9.15,6.625),(9.31,6.625),(9.31,6.465),(9.15,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.49,6.465),(9.49,6.625),(9.65,6.625),(9.65,6.465),(9.49,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.83,6.465),(9.83,6.625),(9.99,6.625),(9.99,6.465),(9.83,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.17,6.465),(10.17,6.625),(10.33,6.625),(10.33,6.465),(10.17,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.51,6.465),(10.51,6.625),(10.67,6.625),(10.67,6.465),(10.51,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.85,6.465),(10.85,6.625),(11.01,6.625),(11.01,6.465),(10.85,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.19,6.465),(11.19,6.625),(11.35,6.625),(11.35,6.465),(11.19,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.53,6.465),(11.53,6.625),(11.69,6.625),(11.69,6.465),(11.53,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.815,5.58),(6.815,5.74),(6.975,5.74),(6.975,5.58),(6.815,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.165,5.58),(10.165,5.74),(10.325,5.74),(10.325,5.58),(10.165,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.735,5.58),(6.735,5.74),(7.055,5.74),(7.055,5.58),(6.735,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,5.58),(3.415,5.74),(3.735,5.74),(3.735,5.58),(3.415,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(12.0,6.8),(12.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.31,6.385),(0.31,6.705),(11.69,6.705),(11.69,6.385),(0.31,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.085,5.58),(10.085,5.74),(10.405,5.74),(10.405,5.58),(10.085,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(6.0), u(12.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(6.0), u(12.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((7.085,0.99),(7.085,1.75),(7.535,1.75),(7.535,0.99),(7.085,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.095,0.99),(10.095,1.29),(10.395,1.29),(10.395,0.99),(10.095,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,1.75),(3.385,1.75),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.29),(3.725,1.29),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.435,0.99),(10.435,2.37),(10.885,2.37),(10.885,0.99),(10.435,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.75),(3.725,1.75),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.24,0.105),(0.24,0.405),(11.76,0.405),(11.76,0.105),(0.24,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(11.895,0.405),(11.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.255,0.99),(6.255,1.75),(6.705,1.75),(6.705,0.99),(6.255,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.745,0.99),(6.745,1.75),(7.045,1.75),(7.045,0.99),(6.745,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.775,0.99),(6.775,1.75),(7.015,1.75),(7.015,0.99),(6.775,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.205,0.99),(10.205,2.37),(10.435,2.37),(10.435,0.99),(10.205,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.745,0.99),(8.745,1.75),(9.195,1.75),(9.195,0.99),(8.745,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.705,0.99),(6.705,1.75),(6.935,1.75),(6.935,0.99),(6.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,1.75),(3.695,1.75),(3.695,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,1.75),(3.615,1.75),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.025,0.99),(10.025,1.75),(10.255,1.75),(10.255,0.99),(10.025,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,0.99),(6.855,1.75),(7.085,1.75),(7.085,0.99),(6.855,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.535,0.99),(3.535,1.75),(3.765,1.75),(3.765,0.99),(3.535,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.915,0.99),(7.915,1.75),(8.365,1.75),(8.365,0.99),(7.915,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.095,0.99),(10.095,2.37),(10.395,2.37),(10.395,0.99),(10.095,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.095,0.99),(10.095,2.37),(10.365,2.37),(10.365,0.99),(10.095,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.745,0.99),(6.745,1.29),(7.045,1.29),(7.045,0.99),(6.745,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.595,0.99),(4.595,1.75),(5.045,1.75),(5.045,0.99),(4.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.425,0.99),(5.425,1.75),(5.875,1.75),(5.875,0.99),(5.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.575,0.99),(9.575,1.75),(10.025,1.75),(10.025,0.99),(9.575,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,0.99),(3.765,1.75),(4.215,1.75),(4.215,0.99),(3.765,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.165,1.06),(10.165,1.22),(10.325,1.22),(10.325,1.06),(10.165,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.815,1.06),(6.815,1.22),(6.975,1.22),(6.975,1.06),(6.815,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.31,0.175),(0.31,0.335),(0.47,0.335),(0.47,0.175),(0.31,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.65,0.175),(0.65,0.335),(0.81,0.335),(0.81,0.175),(0.65,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.99,0.175),(0.99,0.335),(1.15,0.335),(1.15,0.175),(0.99,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.33,0.175),(1.33,0.335),(1.49,0.335),(1.49,0.175),(1.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.67,0.175),(1.67,0.335),(1.83,0.335),(1.83,0.175),(1.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.01,0.175),(2.01,0.335),(2.17,0.335),(2.17,0.175),(2.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.35,0.175),(2.35,0.335),(2.51,0.335),(2.51,0.175),(2.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.69,0.175),(2.69,0.335),(2.85,0.335),(2.85,0.175),(2.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.03,0.175),(3.03,0.335),(3.19,0.335),(3.19,0.175),(3.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.37,0.175),(3.37,0.335),(3.53,0.335),(3.53,0.175),(3.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.71,0.175),(3.71,0.335),(3.87,0.335),(3.87,0.175),(3.71,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.05,0.175),(4.05,0.335),(4.21,0.335),(4.21,0.175),(4.05,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.39,0.175),(4.39,0.335),(4.55,0.335),(4.55,0.175),(4.39,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.73,0.175),(4.73,0.335),(4.89,0.335),(4.89,0.175),(4.73,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.07,0.175),(5.07,0.335),(5.23,0.335),(5.23,0.175),(5.07,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.41,0.175),(5.41,0.335),(5.57,0.335),(5.57,0.175),(5.41,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.75,0.175),(5.75,0.335),(5.91,0.335),(5.91,0.175),(5.75,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.09,0.175),(6.09,0.335),(6.25,0.335),(6.25,0.175),(6.09,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.43,0.175),(6.43,0.335),(6.59,0.335),(6.59,0.175),(6.43,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.77,0.175),(6.77,0.335),(6.93,0.335),(6.93,0.175),(6.77,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.11,0.175),(7.11,0.335),(7.27,0.335),(7.27,0.175),(7.11,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.45,0.175),(7.45,0.335),(7.61,0.335),(7.61,0.175),(7.45,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.79,0.175),(7.79,0.335),(7.95,0.335),(7.95,0.175),(7.79,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.13,0.175),(8.13,0.335),(8.29,0.335),(8.29,0.175),(8.13,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.47,0.175),(8.47,0.335),(8.63,0.335),(8.63,0.175),(8.47,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.81,0.175),(8.81,0.335),(8.97,0.335),(8.97,0.175),(8.81,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.15,0.175),(9.15,0.335),(9.31,0.335),(9.31,0.175),(9.15,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.49,0.175),(9.49,0.335),(9.65,0.335),(9.65,0.175),(9.49,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.83,0.175),(9.83,0.335),(9.99,0.335),(9.99,0.175),(9.83,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.17,0.175),(10.17,0.335),(10.33,0.335),(10.33,0.175),(10.17,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.51,0.175),(10.51,0.335),(10.67,0.335),(10.67,0.175),(10.51,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.85,0.175),(10.85,0.335),(11.01,0.335),(11.01,0.175),(10.85,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.19,0.175),(11.19,0.335),(11.35,0.335),(11.35,0.175),(11.19,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.53,0.175),(11.53,0.335),(11.69,0.335),(11.69,0.175),(11.53,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.06),(3.495,1.22),(3.655,1.22),(3.655,1.06),(3.495,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(12.0,1.22),(12.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,1.06),(3.415,1.22),(3.735,1.22),(3.735,1.06),(3.415,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.735,1.06),(6.735,1.22),(7.055,1.22),(7.055,1.06),(6.735,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.085,1.06),(10.085,1.22),(10.405,1.22),(10.405,1.06),(10.085,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.31,0.095),(0.31,0.415),(11.69,0.415),(11.69,0.095),(0.31,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(6.0), u(12.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(6.0), u(12.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['clk']
        createRL(
            tech, net, 'GatPoly',
            ((0.535,4.06),(0.535,4.36),(0.835,4.36),(0.835,4.06),(0.535,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,4.06),(0.67,4.36),(0.685,4.36),(0.685,4.06),(0.67,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.98),(0.535,3.28),(0.835,3.28),(0.835,2.98),(0.535,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.28),(0.895,3.28),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.06),(0.445,5.99),(0.895,5.99),(0.895,4.06),(0.445,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,2.98),(0.67,3.28),(0.685,3.28),(0.685,2.98),(0.67,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.05),(0.605,3.21),(0.765,3.21),(0.765,3.05),(0.605,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,4.13),(0.605,4.29),(0.765,4.29),(0.765,4.13),(0.605,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.05),(0.605,4.37),(0.765,4.37),(0.765,4.05),(0.605,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.97),(0.605,3.29),(0.765,3.29),(0.765,2.97),(0.605,2.97)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_clk_buf']
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.065,1.75),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.45),(1.765,1.75),(2.065,1.75),(2.065,1.45),(1.765,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.065,5.81),(2.065,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.35),(2.065,5.35),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.05),(1.975,3.21),(2.135,3.21),(2.135,3.05),(1.975,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.615,4.13),(8.615,4.29),(8.775,4.29),(8.775,4.13),(8.615,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.12),(1.835,5.28),(1.995,5.28),(1.995,5.12),(1.835,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.895,3.05),(4.895,3.21),(5.055,3.21),(5.055,3.05),(4.895,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.075,3.05),(8.075,3.21),(8.235,3.21),(8.235,3.05),(8.075,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.465,4.13),(4.465,4.29),(4.625,4.29),(4.625,4.13),(4.465,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.52),(1.835,1.68),(1.995,1.68),(1.995,1.52),(1.835,1.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.895,2.97),(4.895,3.29),(5.055,3.29),(5.055,2.97),(4.895,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,5.04),(1.835,5.36),(1.995,5.36),(1.995,5.04),(1.835,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.075,2.97),(8.075,3.29),(8.235,3.29),(8.235,2.97),(8.075,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.615,4.05),(8.615,4.37),(8.775,4.37),(8.775,4.05),(8.615,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.87,4.05),(4.87,4.37),(5.08,4.37),(5.08,4.05),(4.87,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,2.97),(1.81,3.29),(2.02,3.29),(2.02,2.97),(1.81,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.545,4.05),(4.545,4.37),(4.975,4.37),(4.975,4.05),(4.545,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,1.44),(1.81,5.36),(2.02,5.36),(2.02,1.44),(1.81,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.465,4.05),(4.465,4.37),(4.625,4.37),(4.625,4.05),(4.465,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.155,4.05),(8.155,4.37),(8.695,4.37),(8.695,4.05),(8.155,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.05,2.97),(8.05,4.37),(8.26,4.37),(8.26,2.97),(8.05,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.05,4.05),(8.05,4.37),(8.26,4.37),(8.26,4.05),(8.05,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,2.97),(1.975,3.29),(2.135,3.29),(2.135,2.97),(1.975,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.87,2.97),(4.87,4.37),(5.08,4.37),(5.08,2.97),(4.87,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,1.76),(1.995,1.76),(1.995,1.44),(1.835,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,2.97),(1.915,3.29),(2.055,3.29),(2.055,2.97),(1.915,2.97)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.595,4.87),(4.595,5.99),(5.045,5.99),(5.045,4.87),(4.595,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.825,2.98),(4.825,3.28),(5.125,3.28),(5.125,2.98),(4.825,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,2.98),(2.055,3.28),(8.155,3.28),(8.155,2.98),(2.055,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.915,0.81),(7.915,3.28),(8.365,3.28),(8.365,0.81),(7.915,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.745,4.06),(8.745,5.99),(9.195,5.99),(9.195,4.06),(8.745,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.595,4.06),(4.595,5.99),(5.045,5.99),(5.045,4.06),(4.595,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.695,4.06),(8.695,4.36),(8.97,4.36),(8.97,4.06),(8.695,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,2.98),(1.905,3.28),(2.205,3.28),(2.205,2.98),(1.905,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.005,2.98),(8.005,3.28),(8.305,3.28),(8.305,2.98),(8.005,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.915,0.81),(7.915,1.93),(8.365,1.93),(8.365,0.81),(7.915,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.545,4.06),(8.545,4.36),(8.845,4.36),(8.845,4.06),(8.545,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.425,0.81),(5.425,1.93),(5.875,1.93),(5.875,0.81),(5.425,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.745,4.87),(8.745,5.99),(9.195,5.99),(9.195,4.87),(8.745,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.425,0.81),(5.425,3.28),(5.875,3.28),(5.875,0.81),(5.425,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.395,4.06),(4.395,4.36),(4.695,4.36),(4.695,4.06),(4.395,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.545,4.06),(4.545,4.36),(4.82,4.36),(4.82,4.06),(4.545,4.06)),
        )
        net = nets['_u']
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,1.75),(2.935,1.75),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.865,1.75),(2.865,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.35),(2.895,5.35),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,5.05),(2.705,5.81),(2.935,5.81),(2.935,5.05),(2.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.45),(2.595,1.75),(2.895,1.75),(2.895,1.45),(2.595,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.895,5.81),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.895,1.75),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.865,5.81),(2.865,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.52),(2.665,1.68),(2.825,1.68),(2.825,1.52),(2.665,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.12),(2.665,5.28),(2.825,5.28),(2.825,5.12),(2.665,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.635,4.13),(3.635,4.29),(3.795,4.29),(3.795,4.13),(3.635,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.635,2.51),(3.635,2.67),(3.795,2.67),(3.795,2.51),(3.635,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,5.04),(3.61,5.36),(3.82,5.36),(3.82,5.04),(3.61,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.44),(3.61,1.76),(3.82,1.76),(3.82,1.44),(3.61,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,1.76),(2.825,1.76),(2.825,1.44),(2.665,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,5.04),(2.665,5.36),(2.825,5.36),(2.825,5.04),(2.665,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.745,5.04),(2.745,5.36),(3.715,5.36),(3.715,5.04),(2.745,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.745,1.44),(2.745,1.76),(3.715,1.76),(3.715,1.44),(2.745,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.44),(3.61,5.36),(3.82,5.36),(3.82,1.44),(3.61,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.635,4.05),(3.635,4.37),(3.795,4.37),(3.795,4.05),(3.635,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.635,2.43),(3.635,2.75),(3.795,2.75),(3.795,2.43),(3.635,2.43)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,2.44),(3.565,2.74),(3.865,2.74),(3.865,2.44),(3.565,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,4.06),(3.565,4.36),(3.865,4.36),(3.865,4.06),(3.565,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.715,2.44),(3.715,2.74),(3.99,2.74),(3.99,2.44),(3.715,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,4.06),(3.765,5.99),(4.215,5.99),(4.215,4.06),(3.765,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.715,4.06),(3.715,4.36),(3.99,4.36),(3.99,4.06),(3.715,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,0.81),(3.765,1.93),(4.215,1.93),(4.215,0.81),(3.765,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,0.81),(3.765,2.74),(4.215,2.74),(4.215,0.81),(3.765,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,4.87),(3.765,5.99),(4.215,5.99),(4.215,4.87),(3.765,4.87)),
        )
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((2.335,4.06),(2.335,4.36),(2.635,4.36),(2.635,4.06),(2.335,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.335,2.44),(2.335,2.74),(2.635,2.74),(2.635,2.44),(2.335,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.06),(2.935,5.99),(3.385,5.99),(3.385,4.06),(2.935,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,1.93),(3.385,1.93),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,2.74),(3.385,2.74),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.87),(2.935,5.99),(3.385,5.99),(3.385,4.87),(2.935,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.485,2.44),(2.485,2.74),(3.16,2.74),(3.16,2.44),(2.485,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.485,4.06),(2.485,4.36),(3.16,4.36),(3.16,4.06),(2.485,4.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.405,2.51),(2.405,2.67),(2.565,2.67),(2.565,2.51),(2.405,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.405,4.13),(2.405,4.29),(2.565,4.29),(2.565,4.13),(2.405,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.405,4.05),(2.405,4.37),(2.565,4.37),(2.565,4.05),(2.405,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.405,2.43),(2.405,2.75),(2.565,2.75),(2.565,2.43),(2.405,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.38,1.98),(2.38,4.82),(2.59,4.82),(2.59,1.98),(2.38,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.485), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.485), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((4.365,0.99),(4.365,1.75),(4.595,1.75),(4.595,0.99),(4.365,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.22,0.99),(4.22,1.75),(4.59,1.75),(4.59,0.99),(4.22,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.215,0.99),(4.215,1.75),(4.445,1.75),(4.445,0.99),(4.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,0.99),(4.285,1.75),(4.525,1.75),(4.525,0.99),(4.285,0.99)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((4.215,5.05),(4.215,5.81),(4.445,5.81),(4.445,5.05),(4.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.22,5.05),(4.22,5.81),(4.59,5.81),(4.59,5.05),(4.22,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.365,5.05),(4.365,5.81),(4.595,5.81),(4.595,5.05),(4.365,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,5.05),(4.285,5.81),(4.525,5.81),(4.525,5.05),(4.285,5.05)),
        )
        net = nets['_dff_m']
        createRL(
            tech, net, 'Activ',
            ((5.085,1.45),(5.085,1.75),(5.385,1.75),(5.385,1.45),(5.085,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.085,5.05),(5.085,5.81),(5.385,5.81),(5.385,5.05),(5.085,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.195,5.05),(5.195,5.81),(5.425,5.81),(5.425,5.05),(5.195,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.085,0.99),(5.085,1.75),(5.385,1.75),(5.385,0.99),(5.085,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.045,0.99),(5.045,1.75),(5.275,1.75),(5.275,0.99),(5.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.115,5.05),(5.115,5.81),(5.355,5.81),(5.355,5.05),(5.115,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.195,0.99),(5.195,1.75),(5.425,1.75),(5.425,0.99),(5.195,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.115,0.99),(5.115,1.75),(5.355,1.75),(5.355,0.99),(5.115,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.045,5.05),(5.045,5.81),(5.275,5.81),(5.275,5.05),(5.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.085,5.05),(5.085,5.35),(5.385,5.35),(5.385,5.05),(5.085,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.955,4.13),(6.955,4.29),(7.115,4.29),(7.115,4.13),(6.955,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.155,5.12),(5.155,5.28),(5.315,5.28),(5.315,5.12),(5.155,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.155,1.52),(5.155,1.68),(5.315,1.68),(5.315,1.52),(5.155,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.955,2.51),(6.955,2.67),(7.115,2.67),(7.115,2.51),(6.955,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.235,5.04),(5.235,5.36),(7.035,5.36),(7.035,5.04),(5.235,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.3,5.04),(5.3,5.36),(5.51,5.36),(5.51,5.04),(5.3,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.155,1.44),(5.155,1.76),(5.315,1.76),(5.315,1.44),(5.155,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.955,4.05),(6.955,4.37),(7.115,4.37),(7.115,4.05),(6.955,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.93,2.43),(6.93,5.36),(7.14,5.36),(7.14,2.43),(6.93,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.93,5.04),(6.93,5.36),(7.14,5.36),(7.14,5.04),(6.93,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.955,2.43),(6.955,2.75),(7.115,2.75),(7.115,2.43),(6.955,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.3,1.44),(5.3,1.76),(5.51,1.76),(5.51,1.44),(5.3,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.235,1.44),(5.235,1.76),(5.405,1.76),(5.405,1.44),(5.235,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.3,1.44),(5.3,5.36),(5.51,5.36),(5.51,1.44),(5.3,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.155,5.04),(5.155,5.36),(5.315,5.36),(5.315,5.04),(5.155,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.885,4.06),(6.885,4.36),(7.185,4.36),(7.185,4.06),(6.885,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.885,2.44),(6.885,2.74),(7.185,2.74),(7.185,2.44),(6.885,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.085,4.06),(7.085,5.99),(7.535,5.99),(7.535,4.06),(7.085,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.085,0.81),(7.085,2.74),(7.535,2.74),(7.535,0.81),(7.085,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.035,2.44),(7.035,2.74),(7.31,2.74),(7.31,2.44),(7.035,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.085,0.81),(7.085,1.93),(7.535,1.93),(7.535,0.81),(7.085,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.085,4.87),(7.085,5.99),(7.535,5.99),(7.535,4.87),(7.085,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.035,4.06),(7.035,4.36),(7.31,4.36),(7.31,4.06),(7.035,4.06)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((5.88,0.99),(5.88,1.75),(6.25,1.75),(6.25,0.99),(5.88,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.875,0.99),(5.875,1.75),(6.105,1.75),(6.105,0.99),(5.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.945,0.99),(5.945,1.75),(6.185,1.75),(6.185,0.99),(5.945,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.025,0.99),(6.025,1.75),(6.255,1.75),(6.255,0.99),(6.025,0.99)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Activ',
            ((6.025,5.05),(6.025,5.81),(6.255,5.81),(6.255,5.05),(6.025,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.945,5.05),(5.945,5.81),(6.185,5.81),(6.185,5.05),(5.945,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.88,5.05),(5.88,5.81),(6.25,5.81),(6.25,5.05),(5.88,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.875,5.05),(5.875,5.81),(6.105,5.81),(6.105,5.05),(5.875,5.05)),
        )
        net = nets['_y']
        createRL(
            tech, net, 'GatPoly',
            ((6.255,0.81),(6.255,2.74),(6.705,2.74),(6.705,0.81),(6.255,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.255,0.81),(6.255,1.93),(6.705,1.93),(6.705,0.81),(6.255,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.205,2.44),(6.205,2.74),(6.48,2.74),(6.48,2.44),(6.205,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.055,4.06),(6.055,4.36),(6.355,4.36),(6.355,4.06),(6.055,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.255,4.87),(6.255,5.99),(6.705,5.99),(6.705,4.87),(6.255,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.205,4.06),(6.205,4.36),(6.48,4.36),(6.48,4.06),(6.205,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.255,4.06),(6.255,5.99),(6.705,5.99),(6.705,4.06),(6.255,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.055,2.44),(6.055,2.74),(6.355,2.74),(6.355,2.44),(6.055,2.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.645,5.04),(7.645,5.36),(7.805,5.36),(7.805,5.04),(7.645,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.125,4.05),(6.125,4.37),(6.285,4.37),(6.285,4.05),(6.125,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.1,1.44),(6.1,1.76),(6.31,1.76),(6.31,1.44),(6.1,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.125,2.43),(6.125,2.75),(6.285,2.75),(6.285,2.43),(6.125,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.645,1.44),(7.645,1.76),(7.805,1.76),(7.805,1.44),(7.645,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.1,1.44),(6.1,4.37),(6.31,4.37),(6.31,1.44),(6.1,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.62,1.44),(7.62,5.36),(7.83,5.36),(7.83,1.44),(7.62,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.205,1.44),(6.205,1.76),(7.725,1.76),(7.725,1.44),(6.205,1.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.125,4.13),(6.125,4.29),(6.285,4.29),(6.285,4.13),(6.125,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.125,2.51),(6.125,2.67),(6.285,2.67),(6.285,2.51),(6.125,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.645,1.52),(7.645,1.68),(7.805,1.68),(7.805,1.52),(7.645,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.645,5.12),(7.645,5.28),(7.805,5.28),(7.805,5.12),(7.645,5.12)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.605,5.05),(7.605,5.81),(7.845,5.81),(7.845,5.05),(7.605,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.575,1.45),(7.575,1.75),(7.875,1.75),(7.875,1.45),(7.575,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.575,0.99),(7.575,1.75),(7.875,1.75),(7.875,0.99),(7.575,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.605,0.99),(7.605,1.75),(7.845,1.75),(7.845,0.99),(7.605,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.575,5.05),(7.575,5.81),(7.875,5.81),(7.875,5.05),(7.575,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.575,5.05),(7.575,5.35),(7.875,5.35),(7.875,5.05),(7.575,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.535,0.99),(7.535,1.75),(7.765,1.75),(7.765,0.99),(7.535,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.685,5.05),(7.685,5.81),(7.915,5.81),(7.915,5.05),(7.685,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.535,5.05),(7.535,5.81),(7.765,5.81),(7.765,5.05),(7.535,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.685,0.99),(7.685,1.75),(7.915,1.75),(7.915,0.99),(7.685,0.99)),
        )
        net = nets['_dff_s']
        createRL(
            tech, net, 'Activ',
            ((8.435,5.05),(8.435,5.81),(8.675,5.81),(8.675,5.05),(8.435,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.365,0.99),(8.365,1.75),(8.595,1.75),(8.595,0.99),(8.365,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.365,5.05),(8.365,5.81),(8.595,5.81),(8.595,5.05),(8.365,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.405,0.99),(8.405,1.75),(8.705,1.75),(8.705,0.99),(8.405,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.405,5.05),(8.405,5.35),(8.705,5.35),(8.705,5.05),(8.405,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.515,0.99),(8.515,1.75),(8.745,1.75),(8.745,0.99),(8.515,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.515,5.05),(8.515,5.81),(8.745,5.81),(8.745,5.05),(8.515,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.435,0.99),(8.435,1.75),(8.675,1.75),(8.675,0.99),(8.435,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.405,1.45),(8.405,1.75),(8.705,1.75),(8.705,1.45),(8.405,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.405,5.05),(8.405,5.81),(8.705,5.81),(8.705,5.05),(8.405,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.475,1.52),(8.475,1.68),(8.635,1.68),(8.635,1.52),(8.475,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.045,3.05),(9.045,3.21),(9.205,3.21),(9.205,3.05),(9.045,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.475,5.12),(8.475,5.28),(8.635,5.28),(8.635,5.12),(8.475,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.045,2.97),(9.045,3.29),(9.205,3.29),(9.205,2.97),(9.045,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.02,5.04),(9.02,5.36),(9.23,5.36),(9.23,5.04),(9.02,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.02,1.44),(9.02,1.76),(9.23,1.76),(9.23,1.44),(9.02,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.02,1.44),(9.02,5.36),(9.23,5.36),(9.23,1.44),(9.02,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.475,1.44),(8.475,1.76),(8.635,1.76),(8.635,1.44),(8.475,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.555,1.44),(8.555,1.76),(9.125,1.76),(9.125,1.44),(8.555,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.555,5.04),(8.555,5.36),(9.125,5.36),(9.125,5.04),(8.555,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.475,5.04),(8.475,5.36),(8.635,5.36),(8.635,5.04),(8.475,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.125,2.98),(9.125,3.28),(10.66,3.28),(10.66,2.98),(9.125,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((10.435,0.81),(10.435,4.25),(10.885,4.25),(10.885,0.81),(10.435,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((10.435,4.25),(10.435,5.99),(10.885,5.99),(10.885,4.25),(10.435,4.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((10.435,0.81),(10.435,2.55),(10.885,2.55),(10.885,0.81),(10.435,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.975,2.98),(8.975,3.28),(9.275,3.28),(9.275,2.98),(8.975,2.98)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'Activ',
            ((9.2,0.99),(9.2,1.75),(9.57,1.75),(9.57,0.99),(9.2,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.265,0.99),(9.265,1.75),(9.505,1.75),(9.505,0.99),(9.265,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.345,0.99),(9.345,1.75),(9.575,1.75),(9.575,0.99),(9.345,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.195,0.99),(9.195,1.75),(9.425,1.75),(9.425,0.99),(9.195,0.99)),
        )
        net = nets['_net5']
        createRL(
            tech, net, 'Activ',
            ((9.2,5.05),(9.2,5.81),(9.57,5.81),(9.57,5.05),(9.2,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.195,5.05),(9.195,5.81),(9.425,5.81),(9.425,5.05),(9.195,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.265,5.05),(9.265,5.81),(9.505,5.81),(9.505,5.05),(9.265,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.345,5.05),(9.345,5.81),(9.575,5.81),(9.575,5.05),(9.345,5.05)),
        )
        net = nets['q']
        createRL(
            tech, net, 'Metal1',
            ((9.555,4.59),(9.555,5.36),(11.075,5.36),(11.075,4.59),(9.555,4.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.995,1.495),(10.995,2.155),(11.155,2.155),(11.155,1.495),(10.995,1.495)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.45,1.89),(9.45,2.21),(9.66,2.21),(9.66,1.89),(9.45,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.45,1.44),(9.45,5.36),(9.66,5.36),(9.66,1.44),(9.45,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.475,3.51),(9.475,3.83),(9.635,3.83),(9.635,3.51),(9.475,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.475,2.43),(9.475,2.75),(9.635,2.75),(9.635,2.43),(9.475,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.995,1.44),(10.995,2.21),(11.155,2.21),(11.155,1.44),(10.995,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.555,1.44),(9.555,2.21),(11.075,2.21),(11.075,1.44),(9.555,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.45,4.59),(9.45,4.91),(9.66,4.91),(9.66,4.59),(9.45,4.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.995,4.645),(10.995,5.305),(11.155,5.305),(11.155,4.645),(10.995,4.645)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.995,4.59),(10.995,5.36),(11.155,5.36),(11.155,4.59),(10.995,4.59)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.575,4.87),(9.575,5.99),(10.025,5.99),(10.025,4.87),(9.575,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.405,2.44),(9.405,2.74),(9.705,2.74),(9.705,2.44),(9.405,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.575,3.52),(9.575,5.99),(10.025,5.99),(10.025,3.52),(9.575,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.405,3.52),(9.405,3.82),(9.705,3.82),(9.705,3.52),(9.405,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.555,3.52),(9.555,3.82),(9.8,3.82),(9.8,3.52),(9.555,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.555,2.44),(9.555,2.74),(9.8,2.74),(9.8,2.44),(9.555,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.575,0.81),(9.575,2.74),(10.025,2.74),(10.025,0.81),(9.575,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.575,0.81),(9.575,1.93),(10.025,1.93),(10.025,0.81),(9.575,0.81)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.995,1.575),(10.995,1.735),(11.155,1.735),(11.155,1.575),(10.995,1.575)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.995,1.915),(10.995,2.075),(11.155,2.075),(11.155,1.915),(10.995,1.915)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.475,2.51),(9.475,2.67),(9.635,2.67),(9.635,2.51),(9.475,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.475,3.59),(9.475,3.75),(9.635,3.75),(9.635,3.59),(9.475,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.995,4.725),(10.995,4.885),(11.155,4.885),(11.155,4.725),(10.995,4.725)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.995,5.065),(10.995,5.225),(11.155,5.225),(11.155,5.065),(10.995,5.065)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.925,4.655),(10.925,5.295),(11.225,5.295),(11.225,4.655),(10.925,4.655)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.955,0.99),(10.955,2.37),(11.225,2.37),(11.225,0.99),(10.955,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.925,4.43),(10.925,5.81),(11.225,5.81),(11.225,4.43),(10.925,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.925,1.505),(10.925,2.145),(11.225,2.145),(11.225,1.505),(10.925,1.505)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.955,4.43),(10.955,5.81),(11.225,5.81),(11.225,4.43),(10.955,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.925,0.99),(10.925,2.37),(11.225,2.37),(11.225,0.99),(10.925,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.885,4.43),(10.885,5.81),(11.115,5.81),(11.115,4.43),(10.885,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.885,0.99),(10.885,2.37),(11.115,2.37),(11.115,0.99),(10.885,0.99)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(9.555), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(9.555), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['clk'].setType(Net.Type.CLOCK)
        nets['clk'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['dffnr_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(14.0), u(6.8),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_clk_buf': Net.create(cell, '_clk_buf'),
            '_clk_n': Net.create(cell, '_clk_n'),
            '_dff_m': Net.create(cell, '_dff_m'),
            '_dff_s': Net.create(cell, '_dff_s'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            '_net5': Net.create(cell, '_net5'),
            '_net6': Net.create(cell, '_net6'),
            '_net7': Net.create(cell, '_net7'),
            '_u': Net.create(cell, '_u'),
            '_y': Net.create(cell, '_y'),
            'clk': Net.create(cell, 'clk'),
            'i': Net.create(cell, 'i'),
            'nrst': Net.create(cell, 'nrst'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_clk_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.375,5.81),(0.375,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.375,1.75),(0.375,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.45),(0.105,1.75),(0.405,1.75),(0.405,1.45),(0.105,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.81),(0.405,5.81),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.05),(0.105,5.35),(0.405,5.35),(0.405,5.05),(0.105,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,5.05),(0.215,5.81),(0.445,5.81),(0.445,5.05),(0.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.99),(0.215,1.75),(0.445,1.75),(0.445,0.99),(0.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.99),(0.105,1.75),(0.405,1.75),(0.405,0.99),(0.105,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.52),(0.175,1.68),(0.335,1.68),(0.335,1.52),(0.175,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.465,2.51),(4.465,2.67),(4.625,2.67),(4.625,2.51),(4.465,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.465,3.59),(4.465,3.75),(4.625,3.75),(4.625,3.59),(4.465,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.59),(0.175,3.75),(0.335,3.75),(0.335,3.59),(0.175,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,5.12),(0.175,5.28),(0.335,5.28),(0.335,5.12),(0.175,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.465,2.43),(4.465,2.75),(4.625,2.75),(4.625,2.43),(4.465,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.44),(0.15,5.36),(0.36,5.36),(0.36,1.44),(0.15,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.465,3.51),(4.465,3.83),(4.625,3.83),(4.625,3.51),(4.465,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.51),(0.175,3.83),(0.335,3.83),(0.335,3.51),(0.175,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.44,2.43),(4.44,3.83),(4.65,3.83),(4.65,2.43),(4.44,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,5.04),(0.175,5.36),(0.335,5.36),(0.335,5.04),(0.175,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.44),(0.175,1.76),(0.335,1.76),(0.335,1.44),(0.175,1.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.425,3.52),(5.425,5.99),(5.875,5.99),(5.875,3.52),(5.425,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,4.87),(1.725,4.87),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.395,3.52),(4.395,3.82),(4.695,3.82),(4.695,3.52),(4.395,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,0.81),(1.275,1.93),(1.725,1.93),(1.725,0.81),(1.275,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((10.435,4.87),(10.435,5.99),(10.885,5.99),(10.885,4.87),(10.435,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,3.52),(0.105,3.82),(0.405,3.82),(0.405,3.52),(0.105,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.395,2.44),(4.395,2.74),(4.695,2.74),(4.695,2.44),(4.395,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.275,4.87),(1.275,5.99),(1.725,5.99),(1.725,4.87),(1.275,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.595,0.81),(4.595,1.93),(5.045,1.93),(5.045,0.81),(4.595,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((10.435,0.81),(10.435,1.93),(10.885,1.93),(10.885,0.81),(10.435,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.545,2.44),(4.545,2.74),(4.82,2.74),(4.82,2.44),(4.545,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.425,4.87),(5.425,5.99),(5.875,5.99),(5.875,4.87),(5.425,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.595,0.81),(4.595,2.74),(5.045,2.74),(5.045,0.81),(4.595,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((10.435,0.81),(10.435,4.87),(10.885,4.87),(10.885,0.81),(10.435,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,3.52),(0.255,3.82),(10.66,3.82),(10.66,3.52),(0.255,3.52)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((7.395,4.65),(7.395,5.75),(8.055,5.75),(8.055,4.65),(7.395,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.855,4.65),(5.855,6.21),(7.105,6.21),(7.105,4.65),(5.855,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.905,4.65),(4.905,5.75),(5.565,5.75),(5.565,4.65),(4.905,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.025,4.87),(10.025,5.99),(11.295,5.99),(11.295,4.87),(10.025,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.615,4.65),(1.615,6.21),(2.245,6.21),(2.245,4.65),(1.615,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.345,4.65),(8.345,6.21),(9.595,6.21),(9.595,4.65),(8.345,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.555,6.21),(0.555,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.565,4.65),(6.565,6.21),(7.225,6.21),(7.225,4.65),(6.565,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.425,4.65),(7.425,6.21),(8.025,6.21),(8.025,4.65),(7.425,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.935,4.65),(4.935,6.21),(5.535,6.21),(5.535,4.65),(4.935,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((12.495,4.03),(12.495,6.21),(13.155,6.21),(13.155,4.03),(12.495,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.025,4.65),(5.025,6.21),(6.275,6.21),(6.275,4.65),(5.025,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.7,4.65),(5.7,6.21),(6.43,6.21),(6.43,4.65),(5.7,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((13.325,4.03),(13.325,6.21),(13.985,6.21),(13.985,4.03),(13.325,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.015,4.87),(5.015,5.99),(6.285,5.99),(6.285,4.87),(5.015,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.865,4.87),(0.865,5.99),(2.135,5.99),(2.135,4.87),(0.865,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.525,4.87),(2.525,5.99),(3.795,5.99),(3.795,4.87),(2.525,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.255,4.65),(8.255,6.21),(8.855,6.21),(8.855,4.65),(8.255,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.365,4.65),(3.365,6.21),(4.615,6.21),(4.615,4.65),(3.365,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.225,5.11),(8.225,6.21),(8.885,6.21),(8.885,5.11),(8.225,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.515,4.65),(7.515,6.21),(8.765,6.21),(8.765,4.65),(7.515,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.565,5.11),(6.565,6.21),(7.225,6.21),(7.225,5.11),(6.565,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.4),(-0.075,6.21),(14.075,6.21),(14.075,3.4),(-0.075,3.4)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.915,4.87),(10.915,5.99),(12.185,5.99),(12.185,4.87),(10.915,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.885,4.65),(9.885,6.21),(10.545,6.21),(10.545,4.65),(9.885,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.355,4.87),(3.355,5.99),(4.625,5.99),(4.625,4.87),(3.355,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((11.635,4.65),(11.635,6.21),(12.295,6.21),(12.295,4.65),(11.635,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.785,4.65),(0.785,6.21),(1.385,6.21),(1.385,4.65),(0.785,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.775,4.65),(10.775,6.21),(11.435,6.21),(11.435,4.65),(10.775,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.595,4.65),(6.595,6.21),(7.195,6.21),(7.195,4.65),(6.595,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(14.075,0.585),(14.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.505,4.87),(7.505,5.99),(8.775,5.99),(8.775,4.87),(7.505,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((11.665,4.65),(11.665,6.21),(12.265,6.21),(12.265,4.65),(11.665,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((12.495,4.03),(12.495,6.21),(13.125,6.21),(13.125,4.03),(12.495,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((13.355,4.03),(13.355,6.21),(13.985,6.21),(13.985,4.03),(13.355,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.845,4.87),(5.845,5.99),(7.115,5.99),(7.115,4.87),(5.845,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,4.65),(0.755,6.21),(1.415,6.21),(1.415,4.65),(0.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.65),(2.535,6.21),(3.785,6.21),(3.785,4.65),(2.535,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.885,3.88),(9.885,4.54),(10.545,4.54),(10.545,3.88),(9.885,3.88)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.105,4.65),(4.105,6.21),(4.705,6.21),(4.705,4.65),(4.105,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.275,4.65),(3.275,6.21),(3.875,6.21),(3.875,4.65),(3.275,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.885,3.88),(9.885,5.99),(10.545,5.99),(10.545,3.88),(9.885,3.88)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.775,3.88),(10.775,4.54),(11.435,4.54),(11.435,3.88),(10.775,3.88)),
        )
        createRL(
            tech, net, 'pSD',
            ((12.605,4.25),(12.605,5.99),(13.875,5.99),(13.875,4.25),(12.605,4.25)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.04,-0.075),(0.04,0.585),(13.96,0.585),(13.96,-0.075),(0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((11.635,4.65),(11.635,5.75),(12.295,5.75),(12.295,4.65),(11.635,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.775,3.88),(10.775,5.99),(11.435,5.99),(11.435,3.88),(10.775,3.88)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,4.87),(0.035,5.99),(1.305,5.99),(1.305,4.87),(0.035,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,4.65),(3.245,6.21),(3.905,6.21),(3.905,4.65),(3.245,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.875,4.65),(0.875,6.21),(2.125,6.21),(2.125,4.65),(0.875,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.765,4.65),(5.765,6.21),(6.365,6.21),(6.365,4.65),(5.765,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.905,4.65),(4.905,6.21),(5.565,6.21),(5.565,4.65),(4.905,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.335,4.87),(8.335,5.99),(9.605,5.99),(9.605,4.87),(8.335,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.185,4.87),(4.185,5.99),(5.455,5.99),(5.455,4.87),(4.185,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.925,4.65),(10.925,6.21),(12.175,6.21),(12.175,4.65),(10.925,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.245,5.11),(3.245,6.21),(3.905,6.21),(3.905,5.11),(3.245,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.045,4.65),(0.045,6.21),(1.295,6.21),(1.295,4.65),(0.045,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((10.035,4.65),(10.035,6.21),(11.285,6.21),(11.285,4.65),(10.035,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.755,5.11),(0.755,6.21),(1.415,6.21),(1.415,5.11),(0.755,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.075,6.21),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.055,4.65),(9.055,6.21),(9.715,6.21),(9.715,4.65),(9.055,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((12.615,4.03),(12.615,6.21),(13.865,6.21),(13.865,4.03),(12.615,4.03)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,5.75),(3.075,5.75),(3.075,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.055,4.65),(9.055,5.75),(9.715,5.75),(9.715,4.65),(9.055,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.685,4.65),(6.685,6.21),(7.935,6.21),(7.935,4.65),(6.685,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((12.495,5.11),(12.495,6.21),(13.155,6.21),(13.155,5.11),(12.495,5.11)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.415,4.65),(2.415,6.21),(3.045,6.21),(3.045,4.65),(2.415,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,6.21),(2.245,6.21),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((9.085,4.65),(9.085,6.21),(9.715,6.21),(9.715,4.65),(9.085,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((11.755,4.65),(11.755,6.21),(13.005,6.21),(13.005,4.65),(11.755,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.225,4.65),(8.225,6.21),(8.885,6.21),(8.885,4.65),(8.225,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.04,4.65),(4.04,6.21),(4.77,6.21),(4.77,4.65),(4.04,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,6.21),(0.585,6.21),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.585,4.65),(1.585,5.75),(2.245,5.75),(2.245,4.65),(1.585,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.675,4.87),(6.675,5.99),(7.945,5.99),(7.945,4.87),(6.675,4.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.395,4.65),(7.395,6.21),(8.055,6.21),(8.055,4.65),(7.395,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((13.325,4.255),(13.325,5.695),(13.985,5.695),(13.985,4.255),(13.325,4.255)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.65),(-0.075,5.75),(0.585,5.75),(0.585,4.65),(-0.075,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.195,4.65),(4.195,6.21),(5.445,6.21),(5.445,4.65),(4.195,4.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((11.745,4.87),(11.745,5.99),(13.015,5.99),(13.015,4.87),(11.745,4.87)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,4.78),(2.435,6.08),(3.885,6.08),(3.885,4.78),(2.435,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.095,0.72),(4.095,2.02),(5.545,2.02),(5.545,0.72),(4.095,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.915,4.79),(5.915,6.07),(7.045,6.07),(7.045,4.79),(5.915,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((7.575,0.73),(7.575,2.01),(8.705,2.01),(8.705,0.73),(7.575,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((8.405,4.79),(8.405,6.07),(9.535,6.07),(9.535,4.79),(8.405,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,4.79),(0.935,6.07),(2.065,6.07),(2.065,4.79),(0.935,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.075,0.72),(9.075,2.02),(10.525,2.02),(10.525,0.72),(9.075,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((12.675,4.17),(12.675,6.07),(13.805,6.07),(13.805,4.17),(12.675,4.17)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((12.515,4.16),(12.515,6.08),(13.965,6.08),(13.965,4.16),(12.515,4.16)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,4.78),(-0.055,6.08),(1.395,6.08),(1.395,4.78),(-0.055,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.755,4.78),(5.755,6.08),(7.205,6.08),(7.205,4.78),(5.755,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((12.515,0.72),(12.515,2.64),(13.965,2.64),(13.965,0.72),(12.515,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.935,0.73),(0.935,2.01),(2.065,2.01),(2.065,0.73),(0.935,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((10.095,4.79),(10.095,6.07),(11.225,6.07),(11.225,4.79),(10.095,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.085,4.79),(5.085,6.07),(6.215,6.07),(6.215,4.79),(5.085,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.235,0.73),(9.235,2.01),(10.365,2.01),(10.365,0.73),(9.235,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((12.675,0.73),(12.675,2.63),(13.805,2.63),(13.805,0.73),(12.675,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((10.825,4.78),(10.825,6.08),(12.275,6.08),(12.275,4.78),(10.825,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((6.585,0.72),(6.585,2.02),(8.035,2.02),(8.035,0.72),(6.585,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.755,0.72),(5.755,2.02),(7.205,2.02),(7.205,0.72),(5.755,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((7.415,4.78),(7.415,6.08),(8.865,6.08),(8.865,4.78),(7.415,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((8.245,4.78),(8.245,6.08),(9.695,6.08),(9.695,4.78),(8.245,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.085,0.73),(5.085,2.01),(6.215,2.01),(6.215,0.73),(5.085,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((10.095,0.73),(10.095,2.01),(11.225,2.01),(11.225,0.73),(10.095,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.925,0.72),(4.925,2.02),(6.375,2.02),(6.375,0.72),(4.925,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((11.655,4.78),(11.655,6.08),(13.105,6.08),(13.105,4.78),(11.655,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((11.655,0.72),(11.655,2.02),(13.105,2.02),(13.105,0.72),(11.655,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,4.79),(2.595,6.07),(3.725,6.07),(3.725,4.79),(2.595,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((5.915,0.73),(5.915,2.01),(7.045,2.01),(7.045,0.73),(5.915,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((11.815,0.73),(11.815,2.01),(12.945,2.01),(12.945,0.73),(11.815,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.935,4.78),(9.935,6.08),(11.385,6.08),(11.385,4.78),(9.935,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.925,4.78),(4.925,6.08),(6.375,6.08),(6.375,4.78),(4.925,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.095,4.78),(4.095,6.08),(5.545,6.08),(5.545,4.78),(4.095,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,0.72),(0.775,2.02),(2.225,2.02),(2.225,0.72),(0.775,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((9.935,0.72),(9.935,2.02),(11.385,2.02),(11.385,0.72),(9.935,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,0.73),(0.105,2.01),(1.235,2.01),(1.235,0.73),(0.105,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.265,0.72),(3.265,2.02),(4.715,2.02),(4.715,0.72),(3.265,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.265,4.78),(3.265,6.08),(4.715,6.08),(4.715,4.78),(3.265,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.255,4.79),(4.255,6.07),(5.385,6.07),(5.385,4.79),(4.255,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.775,4.78),(0.775,6.08),(2.225,6.08),(2.225,4.78),(0.775,4.78)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.595,0.73),(2.595,2.01),(3.725,2.01),(3.725,0.73),(2.595,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((0.105,4.79),(0.105,6.07),(1.235,6.07),(1.235,4.79),(0.105,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((7.415,0.72),(7.415,2.02),(8.865,2.02),(8.865,0.72),(7.415,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.27,-0.27),(-0.27,7.07),(14.27,7.07),(14.27,-0.27),(-0.27,-0.27)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((4.255,0.73),(4.255,2.01),(5.385,2.01),(5.385,0.73),(4.255,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((6.745,4.79),(6.745,6.07),(7.875,6.07),(7.875,4.79),(6.745,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.425,4.79),(3.425,6.07),(4.555,6.07),(4.555,4.79),(3.425,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((10.825,0.72),(10.825,2.02),(12.275,2.02),(12.275,0.72),(10.825,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((10.985,4.79),(10.985,6.07),(12.115,6.07),(12.115,4.79),(10.985,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((2.435,0.72),(2.435,2.02),(3.885,2.02),(3.885,0.72),(2.435,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((3.425,0.73),(3.425,2.01),(4.555,2.01),(4.555,0.73),(3.425,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((7.575,4.79),(7.575,6.07),(8.705,6.07),(8.705,4.79),(7.575,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((11.815,4.79),(11.815,6.07),(12.945,6.07),(12.945,4.79),(11.815,4.79)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((10.985,0.73),(10.985,2.01),(12.115,2.01),(12.115,0.73),(10.985,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((-0.055,0.72),(-0.055,2.02),(1.395,2.02),(1.395,0.72),(-0.055,0.72)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((6.745,0.73),(6.745,2.01),(7.875,2.01),(7.875,0.73),(6.745,0.73)),
        )
        createRL(
            tech, net, 'ThickGateOx',
            ((6.585,4.78),(6.585,6.08),(8.035,6.08),(8.035,4.78),(6.585,4.78)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((8.925,4.74),(8.925,6.12),(9.845,6.12),(9.845,4.74),(8.925,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,4.74),(0.625,6.12),(1.545,6.12),(1.545,4.74),(0.625,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((10.645,4.74),(10.645,6.12),(11.565,6.12),(11.565,4.74),(10.645,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.205,6.12),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.295,4.74),(7.295,6.12),(8.155,6.12),(8.155,4.74),(7.295,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.265,4.74),(7.265,6.12),(8.185,6.12),(8.185,4.74),(7.265,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.755,4.74),(9.755,6.12),(10.675,6.12),(10.675,4.74),(9.755,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,6.085),(-0.205,7.005),(14.205,7.005),(14.205,6.085),(-0.205,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.925,4.74),(8.925,5.66),(9.845,5.66),(9.845,4.74),(8.925,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,5.2),(3.115,6.12),(4.035,6.12),(4.035,5.2),(3.115,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((10.785,4.74),(10.785,6.12),(12.315,6.12),(12.315,4.74),(10.785,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.145,4.74),(3.145,6.12),(4.005,6.12),(4.005,4.74),(3.145,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((11.505,4.74),(11.505,6.12),(12.425,6.12),(12.425,4.74),(11.505,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.375,4.74),(7.375,6.12),(8.905,6.12),(8.905,4.74),(7.375,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.635,4.74),(5.635,6.12),(6.495,6.12),(6.495,4.74),(5.635,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.265,4.74),(7.265,5.66),(8.185,5.66),(8.185,4.74),(7.265,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((13.195,4.12),(13.195,6.12),(14.115,6.12),(14.115,4.12),(13.195,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.625,5.2),(0.625,6.12),(1.545,6.12),(1.545,5.2),(0.625,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.91,4.74),(3.91,6.12),(4.9,6.12),(4.9,4.74),(3.91,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,5.66),(3.205,5.66),(3.205,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.095,4.74),(8.095,6.12),(9.015,6.12),(9.015,4.74),(8.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.205,4.74),(8.205,6.12),(9.735,6.12),(9.735,4.74),(8.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.755,3.75),(9.755,6.12),(10.675,6.12),(10.675,3.75),(9.755,3.75)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.955,4.74),(8.955,6.12),(9.845,6.12),(9.845,4.74),(8.955,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((11.615,4.74),(11.615,6.12),(13.145,6.12),(13.145,4.74),(11.615,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.395,4.74),(2.395,6.12),(3.925,6.12),(3.925,4.74),(2.395,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((11.505,4.74),(11.505,5.66),(12.425,5.66),(12.425,4.74),(11.505,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,4.74),(-0.095,6.12),(1.435,6.12),(1.435,4.74),(-0.095,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.485,4.74),(1.485,6.12),(2.375,6.12),(2.375,4.74),(1.485,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.895,4.74),(9.895,6.12),(11.425,6.12),(11.425,4.74),(9.895,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((12.365,4.12),(12.365,6.12),(13.285,6.12),(13.285,4.12),(12.365,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.285,4.74),(2.285,6.12),(3.175,6.12),(3.175,4.74),(2.285,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((13.195,4.345),(13.195,5.605),(14.115,5.605),(14.115,4.345),(13.195,4.345)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.715,4.74),(5.715,6.12),(7.245,6.12),(7.245,4.74),(5.715,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((9.755,3.75),(9.755,4.67),(10.675,4.67),(10.675,3.75),(9.755,3.75)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.685,6.12),(0.685,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.125,4.74),(8.125,6.12),(8.985,6.12),(8.985,4.74),(8.125,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.055,4.74),(4.055,6.12),(5.585,6.12),(5.585,4.74),(4.055,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((10.645,3.75),(10.645,6.12),(11.565,6.12),(11.565,3.75),(10.645,3.75)),
        )
        createRL(
            tech, net, 'NWell',
            ((13.225,4.12),(13.225,6.12),(14.115,6.12),(14.115,4.12),(13.225,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,6.12),(2.375,6.12),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.735,4.74),(0.735,6.12),(2.265,6.12),(2.265,4.74),(0.735,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.435,4.74),(6.435,6.12),(7.355,6.12),(7.355,4.74),(6.435,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((11.535,4.74),(11.535,6.12),(12.395,6.12),(12.395,4.74),(11.535,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,6.12),(0.715,6.12),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.115,4.74),(3.115,6.12),(4.035,6.12),(4.035,4.74),(3.115,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.095,5.2),(8.095,6.12),(9.015,6.12),(9.015,5.2),(8.095,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.775,4.74),(4.775,6.12),(5.695,6.12),(5.695,4.74),(4.775,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.225,4.74),(3.225,6.12),(4.755,6.12),(4.755,4.74),(3.225,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((12.365,4.12),(12.365,6.12),(13.255,6.12),(13.255,4.12),(12.365,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.62,3.4),(-0.62,7.42),(14.62,7.42),(14.62,3.4),(-0.62,3.4)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.655,4.74),(0.655,6.12),(1.515,6.12),(1.515,4.74),(0.655,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.455,4.74),(1.455,5.66),(2.375,5.66),(2.375,4.74),(1.455,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.805,4.74),(4.805,6.12),(5.665,6.12),(5.665,4.74),(4.805,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((12.475,4.12),(12.475,6.12),(14.005,6.12),(14.005,4.12),(12.475,4.12)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.975,4.74),(3.975,6.12),(4.835,6.12),(4.835,4.74),(3.975,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((10.645,3.75),(10.645,4.67),(11.565,4.67),(11.565,3.75),(10.645,3.75)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.74),(-0.205,5.66),(0.715,5.66),(0.715,4.74),(-0.205,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.885,4.74),(4.885,6.12),(6.415,6.12),(6.415,4.74),(4.885,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.465,4.74),(6.465,6.12),(7.325,6.12),(7.325,4.74),(6.465,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.775,4.74),(4.775,5.66),(5.695,5.66),(5.695,4.74),(4.775,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.57,4.74),(5.57,6.12),(6.56,6.12),(6.56,4.74),(5.57,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.545,4.74),(6.545,6.12),(8.075,6.12),(8.075,4.74),(6.545,4.74)),
        )
        createRL(
            tech, net, 'NWell',
            ((12.365,5.2),(12.365,6.12),(13.285,6.12),(13.285,5.2),(12.365,5.2)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.09,6.085),(-0.09,7.005),(14.09,7.005),(14.09,6.085),(-0.09,6.085)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.435,5.2),(6.435,6.12),(7.355,6.12),(7.355,5.2),(6.435,5.2)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.155,5.05),(12.155,5.81),(12.605,5.81),(12.605,5.05),(12.155,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,5.05),(1.275,5.81),(1.725,5.81),(1.725,5.05),(1.275,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.745,5.05),(6.745,5.81),(7.045,5.81),(7.045,5.05),(6.745,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.085,5.05),(7.085,5.81),(7.535,5.81),(7.535,5.05),(7.085,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.745,5.05),(8.745,5.81),(9.195,5.81),(9.195,5.05),(8.745,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.05),(0.935,5.81),(1.235,5.81),(1.235,5.05),(0.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.775,5.05),(6.775,5.81),(7.015,5.81),(7.015,5.05),(6.775,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.535,5.05),(3.535,5.81),(3.765,5.81),(3.765,5.05),(3.535,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.425,5.05),(5.425,5.81),(5.875,5.81),(5.875,5.05),(5.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.595,5.05),(4.595,5.81),(5.045,5.81),(5.045,5.05),(4.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,5.05),(3.455,5.81),(3.695,5.81),(3.695,5.05),(3.455,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.015,4.43),(13.015,5.81),(13.465,5.81),(13.465,4.43),(13.015,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.435,5.05),(10.435,5.81),(10.885,5.81),(10.885,5.05),(10.435,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.745,5.51),(6.745,5.81),(7.045,5.81),(7.045,5.51),(6.745,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,5.05),(6.855,5.81),(7.085,5.81),(7.085,5.05),(6.855,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.515,5.05),(8.515,5.81),(8.745,5.81),(8.745,5.05),(8.515,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.405,5.51),(8.405,5.81),(8.705,5.81),(8.705,5.51),(8.405,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,5.05),(2.935,5.81),(3.385,5.81),(3.385,5.05),(2.935,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,5.05),(0.445,5.81),(0.895,5.81),(0.895,5.05),(0.445,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.605,5.05),(12.605,5.81),(12.835,5.81),(12.835,5.05),(12.605,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.405,5.05),(8.405,5.81),(8.705,5.81),(8.705,5.05),(8.405,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.435,5.05),(8.435,5.81),(8.675,5.81),(8.675,5.05),(8.435,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.51),(3.425,5.81),(3.725,5.81),(3.725,5.51),(3.425,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.325,5.05),(11.325,5.81),(11.775,5.81),(11.775,5.05),(11.325,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.785,4.43),(12.785,5.81),(13.015,5.81),(13.015,4.43),(12.785,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.255,5.05),(6.255,5.81),(6.705,5.81),(6.705,5.05),(6.255,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.675,4.43),(12.675,5.81),(12.975,5.81),(12.975,4.43),(12.675,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,6.395),(0.105,6.695),(13.895,6.695),(13.895,6.395),(0.105,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.915,5.05),(7.915,5.81),(8.365,5.81),(8.365,5.05),(7.915,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,5.05),(0.895,5.81),(1.125,5.81),(1.125,5.05),(0.895,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,5.05),(3.385,5.81),(3.615,5.81),(3.615,5.05),(3.385,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.365,5.05),(8.365,5.81),(8.595,5.81),(8.595,5.05),(8.365,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.22,6.395),(0.22,6.695),(13.78,6.695),(13.78,6.395),(0.22,6.395)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.675,5.51),(12.675,5.81),(12.975,5.81),(12.975,5.51),(12.675,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.705,5.05),(6.705,5.81),(6.935,5.81),(6.935,5.05),(6.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.675,4.43),(12.675,5.81),(12.945,5.81),(12.945,4.43),(12.675,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,5.05),(3.765,5.81),(4.215,5.81),(4.215,5.05),(3.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,5.51),(0.935,5.81),(1.235,5.81),(1.235,5.51),(0.935,5.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,5.05),(3.425,5.81),(3.725,5.81),(3.725,5.05),(3.425,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,5.05),(1.045,5.81),(1.275,5.81),(1.275,5.05),(1.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,5.05),(0.965,5.81),(1.205,5.81),(1.205,5.05),(0.965,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,5.58),(3.495,5.74),(3.655,5.74),(3.655,5.58),(3.495,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,5.58),(1.005,5.74),(1.165,5.74),(1.165,5.58),(1.005,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.745,5.58),(12.745,5.74),(12.905,5.74),(12.905,5.58),(12.745,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.815,5.58),(6.815,5.74),(6.975,5.74),(6.975,5.58),(6.815,5.58)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.29,6.465),(0.29,6.625),(0.45,6.625),(0.45,6.465),(0.29,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.63,6.465),(0.63,6.625),(0.79,6.625),(0.79,6.465),(0.63,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.97,6.465),(0.97,6.625),(1.13,6.625),(1.13,6.465),(0.97,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.31,6.465),(1.31,6.625),(1.47,6.625),(1.47,6.465),(1.31,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.65,6.465),(1.65,6.625),(1.81,6.625),(1.81,6.465),(1.65,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.99,6.465),(1.99,6.625),(2.15,6.625),(2.15,6.465),(1.99,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.33,6.465),(2.33,6.625),(2.49,6.625),(2.49,6.465),(2.33,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.67,6.465),(2.67,6.625),(2.83,6.625),(2.83,6.465),(2.67,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.01,6.465),(3.01,6.625),(3.17,6.625),(3.17,6.465),(3.01,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.35,6.465),(3.35,6.625),(3.51,6.625),(3.51,6.465),(3.35,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.69,6.465),(3.69,6.625),(3.85,6.625),(3.85,6.465),(3.69,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.03,6.465),(4.03,6.625),(4.19,6.625),(4.19,6.465),(4.03,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.37,6.465),(4.37,6.625),(4.53,6.625),(4.53,6.465),(4.37,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.71,6.465),(4.71,6.625),(4.87,6.625),(4.87,6.465),(4.71,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.05,6.465),(5.05,6.625),(5.21,6.625),(5.21,6.465),(5.05,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.39,6.465),(5.39,6.625),(5.55,6.625),(5.55,6.465),(5.39,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.73,6.465),(5.73,6.625),(5.89,6.625),(5.89,6.465),(5.73,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.07,6.465),(6.07,6.625),(6.23,6.625),(6.23,6.465),(6.07,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.41,6.465),(6.41,6.625),(6.57,6.625),(6.57,6.465),(6.41,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.75,6.465),(6.75,6.625),(6.91,6.625),(6.91,6.465),(6.75,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.09,6.465),(7.09,6.625),(7.25,6.625),(7.25,6.465),(7.09,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.43,6.465),(7.43,6.625),(7.59,6.625),(7.59,6.465),(7.43,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.77,6.465),(7.77,6.625),(7.93,6.625),(7.93,6.465),(7.77,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.11,6.465),(8.11,6.625),(8.27,6.625),(8.27,6.465),(8.11,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.45,6.465),(8.45,6.625),(8.61,6.625),(8.61,6.465),(8.45,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.79,6.465),(8.79,6.625),(8.95,6.625),(8.95,6.465),(8.79,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.13,6.465),(9.13,6.625),(9.29,6.625),(9.29,6.465),(9.13,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.47,6.465),(9.47,6.625),(9.63,6.625),(9.63,6.465),(9.47,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.81,6.465),(9.81,6.625),(9.97,6.625),(9.97,6.465),(9.81,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.15,6.465),(10.15,6.625),(10.31,6.625),(10.31,6.465),(10.15,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.49,6.465),(10.49,6.625),(10.65,6.625),(10.65,6.465),(10.49,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.83,6.465),(10.83,6.625),(10.99,6.625),(10.99,6.465),(10.83,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.17,6.465),(11.17,6.625),(11.33,6.625),(11.33,6.465),(11.17,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.51,6.465),(11.51,6.625),(11.67,6.625),(11.67,6.465),(11.51,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.85,6.465),(11.85,6.625),(12.01,6.625),(12.01,6.465),(11.85,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.19,6.465),(12.19,6.625),(12.35,6.625),(12.35,6.465),(12.19,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.53,6.465),(12.53,6.625),(12.69,6.625),(12.69,6.465),(12.53,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.87,6.465),(12.87,6.625),(13.03,6.625),(13.03,6.465),(12.87,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((13.21,6.465),(13.21,6.625),(13.37,6.625),(13.37,6.465),(13.21,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((13.55,6.465),(13.55,6.625),(13.71,6.625),(13.71,6.465),(13.55,6.465)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.475,5.58),(8.475,5.74),(8.635,5.74),(8.635,5.58),(8.475,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,6.8),(14.0,6.8),(14.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.29,6.385),(0.29,6.705),(13.71,6.705),(13.71,6.385),(0.29,6.385)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.735,5.58),(6.735,5.74),(7.055,5.74),(7.055,5.58),(6.735,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,5.58),(3.415,5.74),(3.735,5.74),(3.735,5.58),(3.415,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.665,5.58),(12.665,5.74),(12.985,5.74),(12.985,5.58),(12.665,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,5.58),(0.925,5.74),(1.245,5.74),(1.245,5.58),(0.925,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.395,5.58),(8.395,5.74),(8.715,5.74),(8.715,5.58),(8.395,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(7.0), u(14.0), u(5.58), u(6.8),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.0), u(14.0), u(5.58), u(6.8),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((7.085,0.99),(7.085,1.75),(7.535,1.75),(7.535,0.99),(7.085,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.895,0.99),(0.895,1.75),(1.125,1.75),(1.125,0.99),(0.895,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.935,0.99),(2.935,1.75),(3.385,1.75),(3.385,0.99),(2.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.015,0.99),(13.015,2.37),(13.465,2.37),(13.465,0.99),(13.015,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.29),(3.725,1.29),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.435,0.99),(10.435,1.75),(10.885,1.75),(10.885,0.99),(10.435,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.425,0.99),(3.425,1.75),(3.725,1.75),(3.725,0.99),(3.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.965,0.99),(0.965,1.75),(1.205,1.75),(1.205,0.99),(0.965,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.275,0.99),(1.275,1.75),(1.725,1.75),(1.725,0.99),(1.275,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(13.895,0.405),(13.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.045,0.99),(1.045,1.75),(1.275,1.75),(1.275,0.99),(1.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.99),(0.445,1.75),(0.895,1.75),(0.895,0.99),(0.445,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.255,0.99),(6.255,1.75),(6.705,1.75),(6.705,0.99),(6.255,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.745,0.99),(6.745,1.75),(7.045,1.75),(7.045,0.99),(6.745,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.775,0.99),(6.775,1.75),(7.015,1.75),(7.015,0.99),(6.775,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.75),(1.235,1.75),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.325,0.99),(11.325,1.75),(11.775,1.75),(11.775,0.99),(11.325,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.705,0.99),(6.705,1.75),(6.935,1.75),(6.935,0.99),(6.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.455,0.99),(3.455,1.75),(3.695,1.75),(3.695,0.99),(3.455,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.675,0.99),(12.675,2.37),(12.975,2.37),(12.975,0.99),(12.675,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.385,0.99),(3.385,1.75),(3.615,1.75),(3.615,0.99),(3.385,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,0.99),(6.855,1.75),(7.085,1.75),(7.085,0.99),(6.855,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.535,0.99),(3.535,1.75),(3.765,1.75),(3.765,0.99),(3.535,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.915,0.99),(7.915,1.75),(8.365,1.75),(8.365,0.99),(7.915,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.675,0.99),(12.675,1.29),(12.975,1.29),(12.975,0.99),(12.675,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.785,0.99),(12.785,2.37),(13.015,2.37),(13.015,0.99),(12.785,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.675,0.99),(12.675,2.37),(12.945,2.37),(12.945,0.99),(12.675,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.22,0.105),(0.22,0.405),(13.78,0.405),(13.78,0.105),(0.22,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.745,0.99),(6.745,1.29),(7.045,1.29),(7.045,0.99),(6.745,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.595,0.99),(4.595,1.75),(5.045,1.75),(5.045,0.99),(4.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.425,0.99),(5.425,1.75),(5.875,1.75),(5.875,0.99),(5.425,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.155,0.99),(12.155,1.75),(12.605,1.75),(12.605,0.99),(12.155,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.935,0.99),(0.935,1.29),(1.235,1.29),(1.235,0.99),(0.935,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.575,0.99),(9.575,1.75),(10.025,1.75),(10.025,0.99),(9.575,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((12.605,0.99),(12.605,1.75),(12.835,1.75),(12.835,0.99),(12.605,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,0.99),(3.765,1.75),(4.215,1.75),(4.215,0.99),(3.765,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.29,0.175),(0.29,0.335),(0.45,0.335),(0.45,0.175),(0.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.63,0.175),(0.63,0.335),(0.79,0.335),(0.79,0.175),(0.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.97,0.175),(0.97,0.335),(1.13,0.335),(1.13,0.175),(0.97,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.31,0.175),(1.31,0.335),(1.47,0.335),(1.47,0.175),(1.31,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.65,0.175),(1.65,0.335),(1.81,0.335),(1.81,0.175),(1.65,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.99,0.175),(1.99,0.335),(2.15,0.335),(2.15,0.175),(1.99,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.33,0.175),(2.33,0.335),(2.49,0.335),(2.49,0.175),(2.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.67,0.175),(2.67,0.335),(2.83,0.335),(2.83,0.175),(2.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.01,0.175),(3.01,0.335),(3.17,0.335),(3.17,0.175),(3.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.35,0.175),(3.35,0.335),(3.51,0.335),(3.51,0.175),(3.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.69,0.175),(3.69,0.335),(3.85,0.335),(3.85,0.175),(3.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.03,0.175),(4.03,0.335),(4.19,0.335),(4.19,0.175),(4.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.37,0.175),(4.37,0.335),(4.53,0.335),(4.53,0.175),(4.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.71,0.175),(4.71,0.335),(4.87,0.335),(4.87,0.175),(4.71,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.05,0.175),(5.05,0.335),(5.21,0.335),(5.21,0.175),(5.05,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.39,0.175),(5.39,0.335),(5.55,0.335),(5.55,0.175),(5.39,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.73,0.175),(5.73,0.335),(5.89,0.335),(5.89,0.175),(5.73,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.07,0.175),(6.07,0.335),(6.23,0.335),(6.23,0.175),(6.07,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.41,0.175),(6.41,0.335),(6.57,0.335),(6.57,0.175),(6.41,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.75,0.175),(6.75,0.335),(6.91,0.335),(6.91,0.175),(6.75,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.09,0.175),(7.09,0.335),(7.25,0.335),(7.25,0.175),(7.09,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.43,0.175),(7.43,0.335),(7.59,0.335),(7.59,0.175),(7.43,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.77,0.175),(7.77,0.335),(7.93,0.335),(7.93,0.175),(7.77,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.11,0.175),(8.11,0.335),(8.27,0.335),(8.27,0.175),(8.11,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.45,0.175),(8.45,0.335),(8.61,0.335),(8.61,0.175),(8.45,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.79,0.175),(8.79,0.335),(8.95,0.335),(8.95,0.175),(8.79,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.13,0.175),(9.13,0.335),(9.29,0.335),(9.29,0.175),(9.13,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.47,0.175),(9.47,0.335),(9.63,0.335),(9.63,0.175),(9.47,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.81,0.175),(9.81,0.335),(9.97,0.335),(9.97,0.175),(9.81,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.15,0.175),(10.15,0.335),(10.31,0.335),(10.31,0.175),(10.15,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.49,0.175),(10.49,0.335),(10.65,0.335),(10.65,0.175),(10.49,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.83,0.175),(10.83,0.335),(10.99,0.335),(10.99,0.175),(10.83,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.17,0.175),(11.17,0.335),(11.33,0.335),(11.33,0.175),(11.17,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.51,0.175),(11.51,0.335),(11.67,0.335),(11.67,0.175),(11.51,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.85,0.175),(11.85,0.335),(12.01,0.335),(12.01,0.175),(11.85,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.19,0.175),(12.19,0.335),(12.35,0.335),(12.35,0.175),(12.19,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.53,0.175),(12.53,0.335),(12.69,0.335),(12.69,0.175),(12.53,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.87,0.175),(12.87,0.335),(13.03,0.335),(13.03,0.175),(12.87,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((13.21,0.175),(13.21,0.335),(13.37,0.335),(13.37,0.175),(13.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((13.55,0.175),(13.55,0.335),(13.71,0.335),(13.71,0.175),(13.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.815,1.06),(6.815,1.22),(6.975,1.22),(6.975,1.06),(6.815,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.495,1.06),(3.495,1.22),(3.655,1.22),(3.655,1.06),(3.495,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.005,1.06),(1.005,1.22),(1.165,1.22),(1.165,1.06),(1.005,1.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.745,1.06),(12.745,1.22),(12.905,1.22),(12.905,1.06),(12.745,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.665,1.06),(12.665,1.22),(12.985,1.22),(12.985,1.06),(12.665,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.415,1.06),(3.415,1.22),(3.735,1.22),(3.735,1.06),(3.415,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.925,1.06),(0.925,1.22),(1.245,1.22),(1.245,1.06),(0.925,1.06)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.22),(14.0,1.22),(14.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.29,0.095),(0.29,0.415),(13.71,0.415),(13.71,0.095),(0.29,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.735,1.06),(6.735,1.22),(7.055,1.22),(7.055,1.06),(6.735,1.06)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(7.0), u(14.0), u(0.0), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(7.0), u(14.0), u(0.0), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['clk']
        createRL(
            tech, net, 'GatPoly',
            ((0.535,4.06),(0.535,4.36),(0.835,4.36),(0.835,4.06),(0.535,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,1.93),(0.895,1.93),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.87),(0.445,5.99),(0.895,5.99),(0.895,4.87),(0.445,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,4.06),(0.67,4.36),(0.685,4.36),(0.685,4.06),(0.67,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.98),(0.535,3.28),(0.835,3.28),(0.835,2.98),(0.535,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.81),(0.445,3.28),(0.895,3.28),(0.895,0.81),(0.445,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,4.06),(0.445,5.99),(0.895,5.99),(0.895,4.06),(0.445,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.67,2.98),(0.67,3.28),(0.685,3.28),(0.685,2.98),(0.67,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.05),(0.605,3.21),(0.765,3.21),(0.765,3.05),(0.605,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,4.13),(0.605,4.29),(0.765,4.29),(0.765,4.13),(0.605,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.44),(0.58,5.36),(0.79,5.36),(0.79,1.44),(0.58,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.05),(0.605,4.37),(0.765,4.37),(0.765,4.05),(0.605,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.97),(0.605,3.29),(0.765,3.29),(0.765,2.97),(0.605,2.97)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_clk_buf']
        createRL(
            tech, net, 'Activ',
            ((1.725,5.05),(1.725,5.81),(1.955,5.81),(1.955,5.05),(1.725,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,0.99),(1.795,1.75),(2.065,1.75),(2.065,0.99),(1.795,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.99),(1.725,1.75),(1.955,1.75),(1.955,0.99),(1.725,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,1.45),(1.765,1.75),(2.065,1.75),(2.065,1.45),(1.765,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.81),(2.065,5.81),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.795,5.05),(1.795,5.81),(2.065,5.81),(2.065,5.05),(1.795,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,5.05),(1.765,5.35),(2.065,5.35),(2.065,5.05),(1.765,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.765,0.99),(1.765,1.75),(2.065,1.75),(2.065,0.99),(1.765,0.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.975,3.05),(1.975,3.21),(2.135,3.21),(2.135,3.05),(1.975,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,5.12),(1.835,5.28),(1.995,5.28),(1.995,5.12),(1.835,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.135,3.59),(11.135,3.75),(11.295,3.75),(11.295,3.59),(11.135,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.895,3.05),(4.895,3.21),(5.055,3.21),(5.055,3.05),(4.895,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.505,3.05),(8.505,3.21),(8.665,3.21),(8.665,3.05),(8.505,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.465,4.13),(4.465,4.29),(4.625,4.29),(4.625,4.13),(4.465,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.835,1.52),(1.835,1.68),(1.995,1.68),(1.995,1.52),(1.835,1.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.895,2.97),(4.895,3.29),(5.055,3.29),(5.055,2.97),(4.895,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,5.04),(1.835,5.36),(1.995,5.36),(1.995,5.04),(1.835,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.585,3.51),(8.585,3.83),(11.215,3.83),(11.215,3.51),(8.585,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.87,4.05),(4.87,4.37),(5.08,4.37),(5.08,4.05),(4.87,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.505,2.97),(8.505,3.29),(8.665,3.29),(8.665,2.97),(8.505,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,2.97),(1.81,3.29),(2.02,3.29),(2.02,2.97),(1.81,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.545,4.05),(4.545,4.37),(4.975,4.37),(4.975,4.05),(4.545,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.81,1.44),(1.81,5.36),(2.02,5.36),(2.02,1.44),(1.81,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.465,4.05),(4.465,4.37),(4.625,4.37),(4.625,4.05),(4.465,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.135,3.51),(11.135,3.83),(11.295,3.83),(11.295,3.51),(11.135,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.975,2.97),(1.975,3.29),(2.135,3.29),(2.135,2.97),(1.975,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.48,3.51),(8.48,3.83),(8.69,3.83),(8.69,3.51),(8.48,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.87,2.97),(4.87,4.37),(5.08,4.37),(5.08,2.97),(4.87,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.835,1.44),(1.835,1.76),(1.995,1.76),(1.995,1.44),(1.835,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.915,2.97),(1.915,3.29),(2.055,3.29),(2.055,2.97),(1.915,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.48,2.97),(8.48,3.83),(8.69,3.83),(8.69,2.97),(8.48,2.97)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.595,4.87),(4.595,5.99),(5.045,5.99),(5.045,4.87),(4.595,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.825,2.98),(4.825,3.28),(5.125,3.28),(5.125,2.98),(4.825,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.595,4.06),(4.595,5.99),(5.045,5.99),(5.045,4.06),(4.595,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.325,3.52),(11.325,5.99),(11.775,5.99),(11.775,3.52),(11.325,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.055,2.98),(2.055,3.28),(9.8,3.28),(9.8,2.98),(2.055,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,2.98),(1.905,3.28),(2.205,3.28),(2.205,2.98),(1.905,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.435,2.98),(8.435,3.28),(8.735,3.28),(8.735,2.98),(8.435,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.325,4.87),(11.325,5.99),(11.775,5.99),(11.775,4.87),(11.325,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.065,3.52),(11.065,3.82),(11.365,3.82),(11.365,3.52),(11.065,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.425,0.81),(5.425,1.93),(5.875,1.93),(5.875,0.81),(5.425,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.215,3.52),(11.215,3.82),(11.55,3.82),(11.55,3.52),(11.215,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.425,0.81),(5.425,3.28),(5.875,3.28),(5.875,0.81),(5.425,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.395,4.06),(4.395,4.36),(4.695,4.36),(4.695,4.06),(4.395,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.575,0.81),(9.575,3.28),(10.025,3.28),(10.025,0.81),(9.575,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((9.575,0.81),(9.575,1.93),(10.025,1.93),(10.025,0.81),(9.575,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.545,4.06),(4.545,4.36),(4.82,4.36),(4.82,4.06),(4.545,4.06)),
        )
        net = nets['_u']
        createRL(
            tech, net, 'Activ',
            ((2.705,0.99),(2.705,1.75),(2.935,1.75),(2.935,0.99),(2.705,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.865,1.75),(2.865,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.35),(2.895,5.35),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.705,5.05),(2.705,5.81),(2.935,5.81),(2.935,5.05),(2.705,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,1.45),(2.595,1.75),(2.895,1.75),(2.895,1.45),(2.595,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.895,5.81),(2.895,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,0.99),(2.595,1.75),(2.895,1.75),(2.895,0.99),(2.595,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.595,5.05),(2.595,5.81),(2.865,5.81),(2.865,5.05),(2.595,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,1.52),(2.665,1.68),(2.825,1.68),(2.825,1.52),(2.665,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.665,5.12),(2.665,5.28),(2.825,5.28),(2.825,5.12),(2.665,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.635,4.13),(3.635,4.29),(3.795,4.29),(3.795,4.13),(3.635,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.635,2.51),(3.635,2.67),(3.795,2.67),(3.795,2.51),(3.635,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,5.04),(3.61,5.36),(3.82,5.36),(3.82,5.04),(3.61,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.44),(3.61,1.76),(3.82,1.76),(3.82,1.44),(3.61,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,1.44),(2.665,1.76),(2.825,1.76),(2.825,1.44),(2.665,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.665,5.04),(2.665,5.36),(2.825,5.36),(2.825,5.04),(2.665,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.745,5.04),(2.745,5.36),(3.715,5.36),(3.715,5.04),(2.745,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.745,1.44),(2.745,1.76),(3.715,1.76),(3.715,1.44),(2.745,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.61,1.44),(3.61,5.36),(3.82,5.36),(3.82,1.44),(3.61,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.635,4.05),(3.635,4.37),(3.795,4.37),(3.795,4.05),(3.635,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.635,2.43),(3.635,2.75),(3.795,2.75),(3.795,2.43),(3.635,2.43)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,2.44),(3.565,2.74),(3.865,2.74),(3.865,2.44),(3.565,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,4.06),(3.565,4.36),(3.865,4.36),(3.865,4.06),(3.565,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.715,2.44),(3.715,2.74),(3.99,2.74),(3.99,2.44),(3.715,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,4.06),(3.765,5.99),(4.215,5.99),(4.215,4.06),(3.765,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.715,4.06),(3.715,4.36),(3.99,4.36),(3.99,4.06),(3.715,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,0.81),(3.765,1.93),(4.215,1.93),(4.215,0.81),(3.765,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,0.81),(3.765,2.74),(4.215,2.74),(4.215,0.81),(3.765,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.765,4.87),(3.765,5.99),(4.215,5.99),(4.215,4.87),(3.765,4.87)),
        )
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((2.335,4.06),(2.335,4.36),(2.635,4.36),(2.635,4.06),(2.335,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.335,2.44),(2.335,2.74),(2.635,2.74),(2.635,2.44),(2.335,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.06),(2.935,5.99),(3.385,5.99),(3.385,4.06),(2.935,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,1.93),(3.385,1.93),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,0.81),(2.935,2.74),(3.385,2.74),(3.385,0.81),(2.935,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.935,4.87),(2.935,5.99),(3.385,5.99),(3.385,4.87),(2.935,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.485,2.44),(2.485,2.74),(3.16,2.74),(3.16,2.44),(2.485,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.485,4.06),(2.485,4.36),(3.16,4.36),(3.16,4.06),(2.485,4.06)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.405,2.51),(2.405,2.67),(2.565,2.67),(2.565,2.51),(2.405,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.405,4.13),(2.405,4.29),(2.565,4.29),(2.565,4.13),(2.405,4.13)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.405,4.05),(2.405,4.37),(2.565,4.37),(2.565,4.05),(2.405,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.405,2.43),(2.405,2.75),(2.565,2.75),(2.565,2.43),(2.405,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.38,1.98),(2.38,4.82),(2.59,4.82),(2.59,1.98),(2.38,1.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.485), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.485), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((4.365,0.99),(4.365,1.75),(4.595,1.75),(4.595,0.99),(4.365,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.22,0.99),(4.22,1.75),(4.59,1.75),(4.59,0.99),(4.22,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.215,0.99),(4.215,1.75),(4.445,1.75),(4.445,0.99),(4.215,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,0.99),(4.285,1.75),(4.525,1.75),(4.525,0.99),(4.285,0.99)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((4.215,5.05),(4.215,5.81),(4.445,5.81),(4.445,5.05),(4.215,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.22,5.05),(4.22,5.81),(4.59,5.81),(4.59,5.05),(4.22,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.365,5.05),(4.365,5.81),(4.595,5.81),(4.595,5.05),(4.365,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.285,5.05),(4.285,5.81),(4.525,5.81),(4.525,5.05),(4.285,5.05)),
        )
        net = nets['_dff_m']
        createRL(
            tech, net, 'Activ',
            ((5.085,1.45),(5.085,1.75),(5.385,1.75),(5.385,1.45),(5.085,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.085,5.05),(5.085,5.81),(5.385,5.81),(5.385,5.05),(5.085,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.195,5.05),(5.195,5.81),(5.425,5.81),(5.425,5.05),(5.195,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.085,0.99),(5.085,1.75),(5.385,1.75),(5.385,0.99),(5.085,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.045,0.99),(5.045,1.75),(5.275,1.75),(5.275,0.99),(5.045,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.115,5.05),(5.115,5.81),(5.355,5.81),(5.355,5.05),(5.115,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.195,0.99),(5.195,1.75),(5.425,1.75),(5.425,0.99),(5.195,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.115,0.99),(5.115,1.75),(5.355,1.75),(5.355,0.99),(5.115,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.045,5.05),(5.045,5.81),(5.275,5.81),(5.275,5.05),(5.045,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.085,5.05),(5.085,5.35),(5.385,5.35),(5.385,5.05),(5.085,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.955,4.13),(6.955,4.29),(7.115,4.29),(7.115,4.13),(6.955,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.155,5.12),(5.155,5.28),(5.315,5.28),(5.315,5.12),(5.155,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.155,1.52),(5.155,1.68),(5.315,1.68),(5.315,1.52),(5.155,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.955,2.51),(6.955,2.67),(7.115,2.67),(7.115,2.51),(6.955,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.235,5.04),(5.235,5.36),(7.035,5.36),(7.035,5.04),(5.235,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.3,5.04),(5.3,5.36),(5.51,5.36),(5.51,5.04),(5.3,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.155,1.44),(5.155,1.76),(5.315,1.76),(5.315,1.44),(5.155,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.955,4.05),(6.955,4.37),(7.115,4.37),(7.115,4.05),(6.955,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.93,2.43),(6.93,5.36),(7.14,5.36),(7.14,2.43),(6.93,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.93,5.04),(6.93,5.36),(7.14,5.36),(7.14,5.04),(6.93,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.955,2.43),(6.955,2.75),(7.115,2.75),(7.115,2.43),(6.955,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.3,1.44),(5.3,1.76),(5.51,1.76),(5.51,1.44),(5.3,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.235,1.44),(5.235,1.76),(5.405,1.76),(5.405,1.44),(5.235,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.3,1.44),(5.3,5.36),(5.51,5.36),(5.51,1.44),(5.3,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.155,5.04),(5.155,5.36),(5.315,5.36),(5.315,5.04),(5.155,5.04)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.885,4.06),(6.885,4.36),(7.185,4.36),(7.185,4.06),(6.885,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.885,2.44),(6.885,2.74),(7.185,2.74),(7.185,2.44),(6.885,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.085,4.06),(7.085,5.99),(7.535,5.99),(7.535,4.06),(7.085,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.085,0.81),(7.085,2.74),(7.535,2.74),(7.535,0.81),(7.085,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.035,2.44),(7.035,2.74),(7.31,2.74),(7.31,2.44),(7.035,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.085,0.81),(7.085,1.93),(7.535,1.93),(7.535,0.81),(7.085,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.085,4.87),(7.085,5.99),(7.535,5.99),(7.535,4.87),(7.085,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.035,4.06),(7.035,4.36),(7.31,4.36),(7.31,4.06),(7.035,4.06)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((5.88,0.99),(5.88,1.75),(6.25,1.75),(6.25,0.99),(5.88,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.875,0.99),(5.875,1.75),(6.105,1.75),(6.105,0.99),(5.875,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.945,0.99),(5.945,1.75),(6.185,1.75),(6.185,0.99),(5.945,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.025,0.99),(6.025,1.75),(6.255,1.75),(6.255,0.99),(6.025,0.99)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Activ',
            ((6.025,5.05),(6.025,5.81),(6.255,5.81),(6.255,5.05),(6.025,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.945,5.05),(5.945,5.81),(6.185,5.81),(6.185,5.05),(5.945,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.88,5.05),(5.88,5.81),(6.25,5.81),(6.25,5.05),(5.88,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.875,5.05),(5.875,5.81),(6.105,5.81),(6.105,5.05),(5.875,5.05)),
        )
        net = nets['_y']
        createRL(
            tech, net, 'GatPoly',
            ((6.255,0.81),(6.255,2.74),(6.705,2.74),(6.705,0.81),(6.255,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.255,0.81),(6.255,1.93),(6.705,1.93),(6.705,0.81),(6.255,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.205,2.44),(6.205,2.74),(6.48,2.74),(6.48,2.44),(6.205,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.055,4.06),(6.055,4.36),(6.355,4.36),(6.355,4.06),(6.055,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.255,4.87),(6.255,5.99),(6.705,5.99),(6.705,4.87),(6.255,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.205,4.06),(6.205,4.36),(6.48,4.36),(6.48,4.06),(6.205,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.255,4.06),(6.255,5.99),(6.705,5.99),(6.705,4.06),(6.255,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.055,2.44),(6.055,2.74),(6.355,2.74),(6.355,2.44),(6.055,2.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.135,4.05),(10.135,4.37),(10.295,4.37),(10.295,4.05),(10.135,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.645,5.04),(7.645,5.36),(7.805,5.36),(7.805,5.04),(7.645,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.48,4.05),(8.48,4.37),(8.69,4.37),(8.69,4.05),(8.48,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.125,4.05),(6.125,4.37),(6.285,4.37),(6.285,4.05),(6.125,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.1,1.44),(6.1,1.76),(6.31,1.76),(6.31,1.44),(6.1,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.125,2.43),(6.125,2.75),(6.285,2.75),(6.285,2.43),(6.125,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.62,1.44),(7.62,1.76),(7.83,1.76),(7.83,1.44),(7.62,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.475,1.44),(8.475,1.76),(8.635,1.76),(8.635,1.44),(8.475,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.585,4.05),(8.585,4.37),(10.215,4.37),(10.215,4.05),(8.585,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.48,5.04),(8.48,5.36),(8.69,5.36),(8.69,5.04),(8.48,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.725,5.04),(7.725,5.36),(8.585,5.36),(8.585,5.04),(7.725,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.1,1.44),(6.1,4.37),(6.31,4.37),(6.31,1.44),(6.1,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.62,1.44),(7.62,5.36),(7.83,5.36),(7.83,1.44),(7.62,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.48,4.05),(8.48,5.36),(8.69,5.36),(8.69,4.05),(8.48,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.205,1.44),(6.205,1.76),(8.555,1.76),(8.555,1.44),(6.205,1.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.125,4.13),(6.125,4.29),(6.285,4.29),(6.285,4.13),(6.125,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.645,5.12),(7.645,5.28),(7.805,5.28),(7.805,5.12),(7.645,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.135,4.13),(10.135,4.29),(10.295,4.29),(10.295,4.13),(10.135,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.125,2.51),(6.125,2.67),(6.285,2.67),(6.285,2.51),(6.125,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.475,1.52),(8.475,1.68),(8.635,1.68),(8.635,1.52),(8.475,1.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.065,5.05),(10.065,5.81),(10.365,5.81),(10.365,5.05),(10.065,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.365,0.99),(8.365,1.75),(8.595,1.75),(8.595,0.99),(8.365,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.065,4.06),(10.065,4.36),(10.365,4.36),(10.365,4.06),(10.065,4.06)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.605,5.05),(7.605,5.81),(7.845,5.81),(7.845,5.05),(7.605,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.405,0.99),(8.405,1.75),(8.705,1.75),(8.705,0.99),(8.405,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.785,0.99),(8.785,1.75),(9.155,1.75),(9.155,0.99),(8.785,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.2,0.99),(9.2,1.75),(9.57,1.75),(9.57,0.99),(9.2,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.97,0.99),(8.97,1.75),(9.505,1.75),(9.505,0.99),(8.97,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.435,0.99),(8.435,1.75),(8.97,1.75),(8.97,0.99),(8.435,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.575,5.05),(7.575,5.81),(7.875,5.81),(7.875,5.05),(7.575,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.345,0.99),(9.345,1.75),(9.575,1.75),(9.575,0.99),(9.345,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.205,5.05),(10.205,5.81),(10.435,5.81),(10.435,5.05),(10.205,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.065,4.06),(10.065,5.81),(10.365,5.81),(10.365,4.06),(10.065,4.06)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.405,1.45),(8.405,1.75),(8.705,1.75),(8.705,1.45),(8.405,1.45)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.575,5.05),(7.575,5.35),(7.875,5.35),(7.875,5.05),(7.575,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.555,0.99),(8.555,1.75),(9.385,1.75),(9.385,0.99),(8.555,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.685,5.05),(7.685,5.81),(7.915,5.81),(7.915,5.05),(7.685,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.535,5.05),(7.535,5.81),(7.765,5.81),(7.765,5.05),(7.535,5.05)),
        )
        net = nets['_net6']
        createRL(
            tech, net, 'Activ',
            ((7.54,0.99),(7.54,1.75),(7.91,1.75),(7.91,0.99),(7.54,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.605,0.99),(7.605,1.75),(7.845,1.75),(7.845,0.99),(7.605,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.535,0.99),(7.535,1.75),(7.765,1.75),(7.765,0.99),(7.535,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.685,0.99),(7.685,1.75),(7.915,1.75),(7.915,0.99),(7.685,0.99)),
        )
        net = nets['nrst']
        createRL(
            tech, net, 'GatPoly',
            ((7.915,4.87),(7.915,5.99),(8.365,5.99),(8.365,4.87),(7.915,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.915,4.06),(7.915,5.99),(8.365,5.99),(8.365,4.06),(7.915,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.14,4.06),(8.14,4.36),(8.97,4.36),(8.97,4.06),(8.14,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.745,4.06),(8.745,5.99),(9.195,5.99),(9.195,4.06),(8.745,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.325,0.81),(11.325,2.74),(11.775,2.74),(11.775,0.81),(11.325,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.14,2.44),(8.14,2.74),(8.155,2.74),(8.155,2.44),(8.14,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.005,4.06),(8.005,4.36),(8.305,4.36),(8.305,4.06),(8.005,4.06)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.005,2.44),(8.005,2.74),(8.305,2.74),(8.305,2.44),(8.005,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.325,0.81),(11.325,1.93),(11.775,1.93),(11.775,0.81),(11.325,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.915,0.81),(7.915,1.93),(8.365,1.93),(8.365,0.81),(7.915,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.915,0.81),(7.915,2.74),(8.365,2.74),(8.365,0.81),(7.915,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.215,2.44),(11.215,2.74),(11.55,2.74),(11.55,2.44),(11.215,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.745,4.87),(8.745,5.99),(9.195,5.99),(9.195,4.87),(8.745,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.065,2.44),(11.065,2.74),(11.365,2.74),(11.365,2.44),(11.065,2.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.075,4.05),(8.075,4.37),(8.235,4.37),(8.235,4.05),(8.075,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.155,2.43),(8.155,2.75),(11.215,2.75),(11.215,2.43),(8.155,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.135,2.43),(11.135,2.75),(11.295,2.75),(11.295,2.43),(11.135,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.11,2.43),(11.11,2.75),(11.32,2.75),(11.32,2.43),(11.11,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.05,1.98),(8.05,4.82),(8.26,4.82),(8.26,1.98),(8.05,1.98)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.05,2.43),(8.05,2.75),(8.26,2.75),(8.26,2.43),(8.05,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.075,2.43),(8.075,2.75),(8.235,2.75),(8.235,2.43),(8.075,2.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.075,2.51),(8.075,2.67),(8.235,2.67),(8.235,2.51),(8.075,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.075,4.13),(8.075,4.29),(8.235,4.29),(8.235,4.13),(8.075,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.135,2.51),(11.135,2.67),(11.295,2.67),(11.295,2.51),(11.135,2.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(8.155), u(0.21), u(1.98), u(4.82),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.155), u(0.21), u(1.98), u(4.82),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net5']
        createRL(
            tech, net, 'Activ',
            ((11.815,5.05),(11.815,5.81),(12.115,5.81),(12.115,5.05),(11.815,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.265,5.05),(9.265,5.81),(9.535,5.81),(9.535,5.05),(9.265,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.845,5.05),(11.845,5.81),(12.085,5.81),(12.085,5.05),(11.845,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.195,5.05),(9.195,5.81),(9.425,5.81),(9.425,5.05),(9.195,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.775,5.05),(11.775,5.81),(12.005,5.81),(12.005,5.05),(11.775,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.235,5.05),(9.235,5.81),(9.535,5.81),(9.535,5.05),(9.235,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.925,5.05),(11.925,5.81),(12.155,5.81),(12.155,5.05),(11.925,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.235,5.05),(9.235,5.35),(9.535,5.35),(9.535,5.05),(9.235,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.815,5.05),(11.815,5.35),(12.115,5.35),(12.115,5.05),(11.815,5.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.305,5.12),(9.305,5.28),(9.465,5.28),(9.465,5.12),(9.305,5.12)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.885,5.12),(11.885,5.28),(12.045,5.28),(12.045,5.12),(11.885,5.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.305,5.04),(9.305,5.36),(9.465,5.36),(9.465,5.04),(9.305,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.385,5.04),(9.385,5.36),(11.965,5.36),(11.965,5.04),(9.385,5.04)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.885,5.04),(11.885,5.36),(12.045,5.36),(12.045,5.04),(11.885,5.04)),
        )
        net = nets['_dff_s']
        createRL(
            tech, net, 'Activ',
            ((10.955,4.06),(10.955,4.36),(11.255,4.36),(11.255,4.06),(10.955,4.06)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.205,0.99),(10.205,1.75),(10.435,1.75),(10.435,0.99),(10.205,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.955,4.06),(10.955,5.81),(11.255,5.81),(11.255,4.06),(10.955,4.06)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.025,0.99),(10.025,1.75),(10.255,1.75),(10.255,0.99),(10.025,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.065,0.99),(10.065,1.75),(10.365,1.75),(10.365,0.99),(10.065,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.885,5.05),(10.885,5.81),(11.115,5.81),(11.115,5.05),(10.885,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.095,0.99),(10.095,1.75),(10.365,1.75),(10.365,0.99),(10.095,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.955,5.05),(10.955,5.81),(11.255,5.81),(11.255,5.05),(10.955,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.095,5.05),(11.095,5.81),(11.325,5.81),(11.325,5.05),(11.095,5.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.065,1.45),(10.065,1.75),(10.365,1.75),(10.365,1.45),(10.065,1.45)),
        )
        createRL(
            tech, net, 'Cont',
            ((10.135,1.52),(10.135,1.68),(10.295,1.68),(10.295,1.52),(10.135,1.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.025,4.13),(11.025,4.29),(11.185,4.29),(11.185,4.13),(11.025,4.13)),
        )
        createRL(
            tech, net, 'Cont',
            ((11.565,3.05),(11.565,3.21),(11.725,3.21),(11.725,3.05),(11.565,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.54,1.44),(11.54,1.76),(11.75,1.76),(11.75,1.44),(11.54,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.54,1.44),(11.54,4.37),(11.75,4.37),(11.75,1.44),(11.54,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.025,4.05),(11.025,4.37),(11.185,4.37),(11.185,4.05),(11.025,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.105,4.05),(11.105,4.37),(11.645,4.37),(11.645,4.05),(11.105,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.54,4.05),(11.54,4.37),(11.75,4.37),(11.75,4.05),(11.54,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((11.565,2.97),(11.565,3.29),(11.725,3.29),(11.725,2.97),(11.565,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.135,1.44),(10.135,1.76),(10.295,1.76),(10.295,1.44),(10.135,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((10.215,1.44),(10.215,1.76),(11.645,1.76),(11.645,1.44),(10.215,1.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.495,2.98),(11.495,3.28),(11.795,3.28),(11.795,2.98),(11.495,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((13.015,4.25),(13.015,5.99),(13.465,5.99),(13.465,4.25),(13.015,4.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((13.015,0.81),(13.015,4.25),(13.465,4.25),(13.465,0.81),(13.015,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((13.015,0.81),(13.015,2.55),(13.465,2.55),(13.465,0.81),(13.015,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((11.645,2.98),(11.645,3.28),(13.24,3.28),(13.24,2.98),(11.645,2.98)),
        )
        net = nets['_net7']
        createRL(
            tech, net, 'Activ',
            ((10.885,0.99),(10.885,1.75),(11.115,1.75),(11.115,0.99),(10.885,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.095,0.99),(11.095,1.75),(11.325,1.75),(11.325,0.99),(11.095,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.92,0.99),(10.92,1.75),(11.29,1.75),(11.29,0.99),(10.92,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((10.955,0.99),(10.955,1.75),(11.255,1.75),(11.255,0.99),(10.955,0.99)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'Activ',
            ((11.775,0.99),(11.775,1.75),(12.005,1.75),(12.005,0.99),(11.775,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.925,0.99),(11.925,1.75),(12.155,1.75),(12.155,0.99),(11.925,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.78,0.99),(11.78,1.75),(12.15,1.75),(12.15,0.99),(11.78,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((11.845,0.99),(11.845,1.75),(12.085,1.75),(12.085,0.99),(11.845,0.99)),
        )
        net = nets['q']
        createRL(
            tech, net, 'GatPoly',
            ((12.155,4.87),(12.155,5.99),(12.605,5.99),(12.605,4.87),(12.155,4.87)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((12.155,0.81),(12.155,1.93),(12.605,1.93),(12.605,0.81),(12.155,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((12.245,2.44),(12.245,2.74),(12.545,2.74),(12.545,2.44),(12.245,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((12.245,3.52),(12.245,3.82),(12.545,3.82),(12.545,3.52),(12.245,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((12.155,0.81),(12.155,2.74),(12.605,2.74),(12.605,0.81),(12.155,0.81)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((12.155,3.52),(12.155,5.99),(12.605,5.99),(12.605,3.52),(12.155,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((12.38,3.52),(12.38,3.82),(12.395,3.82),(12.395,3.52),(12.38,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((12.38,2.44),(12.38,2.74),(12.395,2.74),(12.395,2.44),(12.38,2.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.315,3.51),(12.315,3.83),(12.475,3.83),(12.475,3.51),(12.315,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.395,4.59),(12.395,5.36),(13.655,5.36),(13.655,4.59),(12.395,4.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.29,4.59),(12.29,4.91),(12.5,4.91),(12.5,4.59),(12.29,4.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((13.575,4.59),(13.575,5.36),(13.735,5.36),(13.735,4.59),(13.575,4.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((13.575,4.645),(13.575,5.305),(13.735,5.305),(13.735,4.645),(13.575,4.645)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.315,2.43),(12.315,2.75),(12.475,2.75),(12.475,2.43),(12.315,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((13.575,1.495),(13.575,2.155),(13.735,2.155),(13.735,1.495),(13.575,1.495)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.395,1.44),(12.395,2.21),(13.655,2.21),(13.655,1.44),(12.395,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.29,1.44),(12.29,5.36),(12.5,5.36),(12.5,1.44),(12.29,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((13.575,1.44),(13.575,2.21),(13.735,2.21),(13.735,1.44),(13.575,1.44)),
        )
        createRL(
            tech, net, 'Metal1',
            ((12.29,1.89),(12.29,2.21),(12.5,2.21),(12.5,1.89),(12.29,1.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.315,3.59),(12.315,3.75),(12.475,3.75),(12.475,3.59),(12.315,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((13.575,4.725),(13.575,4.885),(13.735,4.885),(13.735,4.725),(13.575,4.725)),
        )
        createRL(
            tech, net, 'Cont',
            ((13.575,5.065),(13.575,5.225),(13.735,5.225),(13.735,5.065),(13.575,5.065)),
        )
        createRL(
            tech, net, 'Cont',
            ((13.575,1.575),(13.575,1.735),(13.735,1.735),(13.735,1.575),(13.575,1.575)),
        )
        createRL(
            tech, net, 'Cont',
            ((13.575,1.915),(13.575,2.075),(13.735,2.075),(13.735,1.915),(13.575,1.915)),
        )
        createRL(
            tech, net, 'Cont',
            ((12.315,2.51),(12.315,2.67),(12.475,2.67),(12.475,2.51),(12.315,2.51)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.505,1.505),(13.505,2.145),(13.805,2.145),(13.805,1.505),(13.505,1.505)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.535,4.43),(13.535,5.81),(13.805,5.81),(13.805,4.43),(13.535,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.505,4.655),(13.505,5.295),(13.805,5.295),(13.805,4.655),(13.505,4.655)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.535,0.99),(13.535,2.37),(13.805,2.37),(13.805,0.99),(13.535,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.465,0.99),(13.465,2.37),(13.695,2.37),(13.695,0.99),(13.465,0.99)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.505,4.43),(13.505,5.81),(13.805,5.81),(13.805,4.43),(13.505,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.465,4.43),(13.465,5.81),(13.695,5.81),(13.695,4.43),(13.465,4.43)),
        )
        createRL(
            tech, net, 'Activ',
            ((13.505,0.99),(13.505,2.37),(13.805,2.37),(13.805,0.99),(13.505,0.99)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(12.395), u(0.21), u(1.44), u(5.36),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(12.395), u(0.21), u(1.44), u(5.36),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['clk'].setType(Net.Type.CLOCK)
        nets['clk'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['nrst'].setDirection(Net.Direction.IN)

    cell = new_cells['Gallery']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-6.8), u(193.0), u(13.6),
        ))
        nets = {
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,12.38),(0.0,13.6),(0.21,13.6),(0.21,12.38),(0.0,12.38)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,-1.22),(0.0,1.22),(0.21,1.22),(0.21,-1.22),(0.0,-1.22)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,-1.22),(0.0,1.22),(193.0,1.22),(193.0,-1.22),(0.0,-1.22)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,12.38),(0.0,13.6),(193.0,13.6),(193.0,12.38),(0.0,12.38)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(96.5), u(193.0), u(12.38), u(13.6),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(96.5), u(193.0), u(12.38), u(13.6),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(96.5), u(193.0), u(-1.22), u(1.22),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(96.5), u(193.0), u(-1.22), u(1.22),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Via1',
            ((0.01,-1.12),(0.01,-0.93),(0.2,-0.93),(0.2,-1.12),(0.01,-1.12)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,-0.71),(0.01,-0.52),(0.2,-0.52),(0.2,-0.71),(0.01,-0.71)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,-0.3),(0.01,-0.11),(0.2,-0.11),(0.2,-0.3),(0.01,-0.3)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,0.11),(0.01,0.3),(0.2,0.3),(0.2,0.11),(0.01,0.11)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,0.52),(0.01,0.71),(0.2,0.71),(0.2,0.52),(0.01,0.52)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,0.93),(0.01,1.12),(0.2,1.12),(0.2,0.93),(0.01,0.93)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,12.485),(0.01,12.675),(0.2,12.675),(0.2,12.485),(0.01,12.485)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,12.895),(0.01,13.085),(0.2,13.085),(0.2,12.895),(0.01,12.895)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,13.305),(0.01,13.495),(0.2,13.495),(0.2,13.305),(0.01,13.305)),
        )
        createRL(
            tech, net, 'Metal2',
            ((0.005,-1.17),(0.005,13.545),(0.205,13.545),(0.205,-1.17),(0.005,-1.17)),
        )
        createRL(
            tech, net, 'Metal2',
            ((0.005,-1.17),(0.005,1.17),(0.205,1.17),(0.205,-1.17),(0.005,-1.17)),
        )
        createRL(
            tech, net, 'Metal2',
            ((0.005,12.435),(0.005,13.545),(0.205,13.545),(0.205,12.435),(0.005,12.435)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,5.58),(0.0,8.02),(193.0,8.02),(193.0,5.58),(0.0,5.58)),
        )
        createRL(
            tech, net, 'Metal1',
            ((192.79,-6.8),(192.79,-5.58),(193.0,-5.58),(193.0,-6.8),(192.79,-6.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,-6.8),(0.0,-5.58),(193.0,-5.58),(193.0,-6.8),(0.0,-6.8)),
        )
        createRL(
            tech, net, 'Metal1',
            ((192.79,5.58),(192.79,8.02),(193.0,8.02),(193.0,5.58),(192.79,5.58)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(96.5), u(193.0), u(5.58), u(8.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(96.5), u(193.0), u(5.58), u(8.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(96.5), u(193.0), u(-6.8), u(-5.58),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(96.5), u(193.0), u(-6.8), u(-5.58),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Via1',
            ((192.8,5.68),(192.8,5.87),(192.99,5.87),(192.99,5.68),(192.8,5.68)),
        )
        createRL(
            tech, net, 'Via1',
            ((192.8,6.09),(192.8,6.28),(192.99,6.28),(192.99,6.09),(192.8,6.09)),
        )
        createRL(
            tech, net, 'Via1',
            ((192.8,6.5),(192.8,6.69),(192.99,6.69),(192.99,6.5),(192.8,6.5)),
        )
        createRL(
            tech, net, 'Via1',
            ((192.8,6.91),(192.8,7.1),(192.99,7.1),(192.99,6.91),(192.8,6.91)),
        )
        createRL(
            tech, net, 'Via1',
            ((192.8,7.32),(192.8,7.51),(192.99,7.51),(192.99,7.32),(192.8,7.32)),
        )
        createRL(
            tech, net, 'Via1',
            ((192.8,7.73),(192.8,7.92),(192.99,7.92),(192.99,7.73),(192.8,7.73)),
        )
        createRL(
            tech, net, 'Via1',
            ((192.8,-6.695),(192.8,-6.505),(192.99,-6.505),(192.99,-6.695),(192.8,-6.695)),
        )
        createRL(
            tech, net, 'Via1',
            ((192.8,-6.285),(192.8,-6.095),(192.99,-6.095),(192.99,-6.285),(192.8,-6.285)),
        )
        createRL(
            tech, net, 'Via1',
            ((192.8,-5.875),(192.8,-5.685),(192.99,-5.685),(192.99,-5.875),(192.8,-5.875)),
        )
        createRL(
            tech, net, 'Metal2',
            ((192.795,-6.745),(192.795,-5.635),(192.995,-5.635),(192.995,-6.745),(192.795,-6.745)),
        )
        createRL(
            tech, net, 'Metal2',
            ((192.795,5.63),(192.795,7.97),(192.995,7.97),(192.995,5.63),(192.795,5.63)),
        )
        createRL(
            tech, net, 'Metal2',
            ((192.795,-6.745),(192.795,7.97),(192.995,7.97),(192.995,-6.745),(192.795,-6.745)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['fill']
        except:
            subcell = af.getCell('fill', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'fill[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dffnr_x1']
        except:
            subcell = af.getCell('dffnr_x1', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'dffnr_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dffnr_x1']
        except:
            subcell = af.getCell('dffnr_x1', 0)
        trans = Transformation(
            u(0.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'dffnr_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie']
        except:
            subcell = af.getCell('tie', 0)
        trans = Transformation(
            u(1.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dff_x1']
        except:
            subcell = af.getCell('dff_x1', 0)
        trans = Transformation(
            u(14.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'dff_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill']
        except:
            subcell = af.getCell('fill', 0)
        trans = Transformation(
            u(14.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly']
        except:
            subcell = af.getCell('tie_poly', 0)
        trans = Transformation(
            u(2.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_poly[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x1']
        except:
            subcell = af.getCell('nsnrlatch_x1', 0)
        trans = Transformation(
            u(26.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nsnrlatch_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dff_x1']
        except:
            subcell = af.getCell('dff_x1', 0)
        trans = Transformation(
            u(15.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'dff_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w2']
        except:
            subcell = af.getCell('fill_w2', 0)
        trans = Transformation(
            u(3.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'fill_w2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x0']
        except:
            subcell = af.getCell('nsnrlatch_x0', 0)
        trans = Transformation(
            u(30.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nsnrlatch_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie']
        except:
            subcell = af.getCell('tie', 0)
        trans = Transformation(
            u(27.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w2']
        except:
            subcell = af.getCell('tie_w2', 0)
        trans = Transformation(
            u(5.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_w2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nexor2_x0']
        except:
            subcell = af.getCell('nexor2_x0', 0)
        trans = Transformation(
            u(34.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nexor2_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x1']
        except:
            subcell = af.getCell('nsnrlatch_x1', 0)
        trans = Transformation(
            u(28.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nsnrlatch_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w2']
        except:
            subcell = af.getCell('tie_diff_w2', 0)
        trans = Transformation(
            u(7.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_diff_w2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['xor2_x0']
        except:
            subcell = af.getCell('xor2_x0', 0)
        trans = Transformation(
            u(40.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'xor2_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly']
        except:
            subcell = af.getCell('tie_poly', 0)
        trans = Transformation(
            u(32.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w2']
        except:
            subcell = af.getCell('tie_poly_w2', 0)
        trans = Transformation(
            u(9.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_poly_w2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x1']
        except:
            subcell = af.getCell('or21nand_x1', 0)
        trans = Transformation(
            u(46.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or21nand_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x0']
        except:
            subcell = af.getCell('nsnrlatch_x0', 0)
        trans = Transformation(
            u(33.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nsnrlatch_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w4']
        except:
            subcell = af.getCell('fill_w4', 0)
        trans = Transformation(
            u(11.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'fill_w4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x0']
        except:
            subcell = af.getCell('or21nand_x0', 0)
        trans = Transformation(
            u(50.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or21nand_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w2']
        except:
            subcell = af.getCell('fill_w2', 0)
        trans = Transformation(
            u(37.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill_w2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w4']
        except:
            subcell = af.getCell('tie_w4', 0)
        trans = Transformation(
            u(15.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_w4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x1']
        except:
            subcell = af.getCell('and21nor_x1', 0)
        trans = Transformation(
            u(54.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and21nor_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nexor2_x0']
        except:
            subcell = af.getCell('nexor2_x0', 0)
        trans = Transformation(
            u(39.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nexor2_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w4']
        except:
            subcell = af.getCell('tie_diff_w4', 0)
        trans = Transformation(
            u(19.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_diff_w4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x0']
        except:
            subcell = af.getCell('and21nor_x0', 0)
        trans = Transformation(
            u(58.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and21nor_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w2']
        except:
            subcell = af.getCell('tie_w2', 0)
        trans = Transformation(
            u(45.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_w2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w4']
        except:
            subcell = af.getCell('tie_poly_w4', 0)
        trans = Transformation(
            u(23.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_poly_w4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['mux2_x1']
        except:
            subcell = af.getCell('mux2_x1', 0)
        trans = Transformation(
            u(62.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'mux2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['xor2_x0']
        except:
            subcell = af.getCell('xor2_x0', 0)
        trans = Transformation(
            u(47.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'xor2_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['diode_w1']
        except:
            subcell = af.getCell('diode_w1', 0)
        trans = Transformation(
            u(27.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'diode_w1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or4_x1']
        except:
            subcell = af.getCell('or4_x1', 0)
        trans = Transformation(
            u(68.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or4_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w2']
        except:
            subcell = af.getCell('tie_diff_w2', 0)
        trans = Transformation(
            u(53.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff_w2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zero_x1']
        except:
            subcell = af.getCell('zero_x1', 0)
        trans = Transformation(
            u(28.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'zero_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or3_x1']
        except:
            subcell = af.getCell('or3_x1', 0)
        trans = Transformation(
            u(73.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or3_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x1']
        except:
            subcell = af.getCell('or21nand_x1', 0)
        trans = Transformation(
            u(55.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or21nand_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['one_x1']
        except:
            subcell = af.getCell('one_x1', 0)
        trans = Transformation(
            u(30.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'one_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or2_x1']
        except:
            subcell = af.getCell('or2_x1', 0)
        trans = Transformation(
            u(77.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w2']
        except:
            subcell = af.getCell('tie_poly_w2', 0)
        trans = Transformation(
            u(59.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly_w2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zeroone_x1']
        except:
            subcell = af.getCell('zeroone_x1', 0)
        trans = Transformation(
            u(32.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'zeroone_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x1']
        except:
            subcell = af.getCell('nor4_x1', 0)
        trans = Transformation(
            u(81.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor4_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x0']
        except:
            subcell = af.getCell('or21nand_x0', 0)
        trans = Transformation(
            u(61.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or21nand_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['decap_w0']
        except:
            subcell = af.getCell('decap_w0', 0)
        trans = Transformation(
            u(34.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'decap_w0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x0']
        except:
            subcell = af.getCell('nor4_x0', 0)
        trans = Transformation(
            u(85.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor4_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w4']
        except:
            subcell = af.getCell('fill_w4', 0)
        trans = Transformation(
            u(65.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill_w4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x0']
        except:
            subcell = af.getCell('inv_x0', 0)
        trans = Transformation(
            u(36.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'inv_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x1']
        except:
            subcell = af.getCell('nor3_x1', 0)
        trans = Transformation(
            u(89.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor3_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x1']
        except:
            subcell = af.getCell('and21nor_x1', 0)
        trans = Transformation(
            u(69.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and21nor_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x1']
        except:
            subcell = af.getCell('inv_x1', 0)
        trans = Transformation(
            u(38.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'inv_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x0']
        except:
            subcell = af.getCell('nor3_x0', 0)
        trans = Transformation(
            u(92.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor3_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w4']
        except:
            subcell = af.getCell('tie_w4', 0)
        trans = Transformation(
            u(73.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_w4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x2']
        except:
            subcell = af.getCell('inv_x2', 0)
        trans = Transformation(
            u(40.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'inv_x2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x1']
        except:
            subcell = af.getCell('nor2_x1', 0)
        trans = Transformation(
            u(95.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x0']
        except:
            subcell = af.getCell('and21nor_x0', 0)
        trans = Transformation(
            u(77.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and21nor_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x4']
        except:
            subcell = af.getCell('inv_x4', 0)
        trans = Transformation(
            u(43.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'inv_x4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x0']
        except:
            subcell = af.getCell('nor2_x0', 0)
        trans = Transformation(
            u(98.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor2_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w4']
        except:
            subcell = af.getCell('tie_diff_w4', 0)
        trans = Transformation(
            u(81.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff_w4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x1']
        except:
            subcell = af.getCell('buf_x1', 0)
        trans = Transformation(
            u(47.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'buf_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and4_x1']
        except:
            subcell = af.getCell('and4_x1', 0)
        trans = Transformation(
            u(101.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and4_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['mux2_x1']
        except:
            subcell = af.getCell('mux2_x1', 0)
        trans = Transformation(
            u(85.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'mux2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x2']
        except:
            subcell = af.getCell('buf_x2', 0)
        trans = Transformation(
            u(50.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'buf_x2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and3_x1']
        except:
            subcell = af.getCell('and3_x1', 0)
        trans = Transformation(
            u(106.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and3_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w4']
        except:
            subcell = af.getCell('tie_poly_w4', 0)
        trans = Transformation(
            u(91.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly_w4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x4']
        except:
            subcell = af.getCell('buf_x4', 0)
        trans = Transformation(
            u(54.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'buf_x4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and2_x1']
        except:
            subcell = af.getCell('and2_x1', 0)
        trans = Transformation(
            u(110.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or4_x1']
        except:
            subcell = af.getCell('or4_x1', 0)
        trans = Transformation(
            u(95.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or4_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x0']
        except:
            subcell = af.getCell('nand2_x0', 0)
        trans = Transformation(
            u(59.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand2_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x1']
        except:
            subcell = af.getCell('nand4_x1', 0)
        trans = Transformation(
            u(114.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand4_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['diode_w1']
        except:
            subcell = af.getCell('diode_w1', 0)
        trans = Transformation(
            u(100.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'diode_w1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x1']
        except:
            subcell = af.getCell('nand2_x1', 0)
        trans = Transformation(
            u(62.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x0']
        except:
            subcell = af.getCell('nand4_x0', 0)
        trans = Transformation(
            u(118.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand4_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or3_x1']
        except:
            subcell = af.getCell('or3_x1', 0)
        trans = Transformation(
            u(101.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or3_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x0']
        except:
            subcell = af.getCell('nand3_x0', 0)
        trans = Transformation(
            u(65.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand3_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x1']
        except:
            subcell = af.getCell('nand3_x1', 0)
        trans = Transformation(
            u(122.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand3_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zero_x1']
        except:
            subcell = af.getCell('zero_x1', 0)
        trans = Transformation(
            u(105.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'zero_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x1']
        except:
            subcell = af.getCell('nand3_x1', 0)
        trans = Transformation(
            u(68.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand3_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x0']
        except:
            subcell = af.getCell('nand3_x0', 0)
        trans = Transformation(
            u(125.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand3_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or2_x1']
        except:
            subcell = af.getCell('or2_x1', 0)
        trans = Transformation(
            u(107.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x0']
        except:
            subcell = af.getCell('nand4_x0', 0)
        trans = Transformation(
            u(71.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand4_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x1']
        except:
            subcell = af.getCell('nand2_x1', 0)
        trans = Transformation(
            u(128.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['one_x1']
        except:
            subcell = af.getCell('one_x1', 0)
        trans = Transformation(
            u(111.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'one_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x1']
        except:
            subcell = af.getCell('nand4_x1', 0)
        trans = Transformation(
            u(75.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand4_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x0']
        except:
            subcell = af.getCell('nand2_x0', 0)
        trans = Transformation(
            u(131.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand2_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x1']
        except:
            subcell = af.getCell('nor4_x1', 0)
        trans = Transformation(
            u(113.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor4_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and2_x1']
        except:
            subcell = af.getCell('and2_x1', 0)
        trans = Transformation(
            u(79.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x4']
        except:
            subcell = af.getCell('buf_x4', 0)
        trans = Transformation(
            u(134.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zeroone_x1']
        except:
            subcell = af.getCell('zeroone_x1', 0)
        trans = Transformation(
            u(117.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'zeroone_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and3_x1']
        except:
            subcell = af.getCell('and3_x1', 0)
        trans = Transformation(
            u(83.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and3_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x2']
        except:
            subcell = af.getCell('buf_x2', 0)
        trans = Transformation(
            u(139.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x0']
        except:
            subcell = af.getCell('nor4_x0', 0)
        trans = Transformation(
            u(119.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor4_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and4_x1']
        except:
            subcell = af.getCell('and4_x1', 0)
        trans = Transformation(
            u(87.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and4_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x1']
        except:
            subcell = af.getCell('buf_x1', 0)
        trans = Transformation(
            u(143.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['decap_w0']
        except:
            subcell = af.getCell('decap_w0', 0)
        trans = Transformation(
            u(123.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'decap_w0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x0']
        except:
            subcell = af.getCell('nor2_x0', 0)
        trans = Transformation(
            u(92.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor2_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x4']
        except:
            subcell = af.getCell('inv_x4', 0)
        trans = Transformation(
            u(146.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x1']
        except:
            subcell = af.getCell('nor3_x1', 0)
        trans = Transformation(
            u(125.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor3_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x1']
        except:
            subcell = af.getCell('nor2_x1', 0)
        trans = Transformation(
            u(95.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x2']
        except:
            subcell = af.getCell('inv_x2', 0)
        trans = Transformation(
            u(150.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x0']
        except:
            subcell = af.getCell('inv_x0', 0)
        trans = Transformation(
            u(128.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x0']
        except:
            subcell = af.getCell('nor3_x0', 0)
        trans = Transformation(
            u(98.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor3_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x1']
        except:
            subcell = af.getCell('inv_x1', 0)
        trans = Transformation(
            u(153.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x0']
        except:
            subcell = af.getCell('nor3_x0', 0)
        trans = Transformation(
            u(130.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor3_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x1']
        except:
            subcell = af.getCell('nor3_x1', 0)
        trans = Transformation(
            u(101.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor3_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x0']
        except:
            subcell = af.getCell('inv_x0', 0)
        trans = Transformation(
            u(155.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x1']
        except:
            subcell = af.getCell('inv_x1', 0)
        trans = Transformation(
            u(133.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x0']
        except:
            subcell = af.getCell('nor4_x0', 0)
        trans = Transformation(
            u(104.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor4_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['decap_w0']
        except:
            subcell = af.getCell('decap_w0', 0)
        trans = Transformation(
            u(157.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'decap_w0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x1']
        except:
            subcell = af.getCell('nor2_x1', 0)
        trans = Transformation(
            u(135.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x1']
        except:
            subcell = af.getCell('nor4_x1', 0)
        trans = Transformation(
            u(108.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor4_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zeroone_x1']
        except:
            subcell = af.getCell('zeroone_x1', 0)
        trans = Transformation(
            u(159.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'zeroone_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x2']
        except:
            subcell = af.getCell('inv_x2', 0)
        trans = Transformation(
            u(138.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or2_x1']
        except:
            subcell = af.getCell('or2_x1', 0)
        trans = Transformation(
            u(112.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['one_x1']
        except:
            subcell = af.getCell('one_x1', 0)
        trans = Transformation(
            u(161.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'one_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x0']
        except:
            subcell = af.getCell('nor2_x0', 0)
        trans = Transformation(
            u(141.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor2_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or3_x1']
        except:
            subcell = af.getCell('or3_x1', 0)
        trans = Transformation(
            u(116.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or3_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zero_x1']
        except:
            subcell = af.getCell('zero_x1', 0)
        trans = Transformation(
            u(163.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'zero_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x4']
        except:
            subcell = af.getCell('inv_x4', 0)
        trans = Transformation(
            u(144.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or4_x1']
        except:
            subcell = af.getCell('or4_x1', 0)
        trans = Transformation(
            u(120.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or4_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['diode_w1']
        except:
            subcell = af.getCell('diode_w1', 0)
        trans = Transformation(
            u(165.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'diode_w1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and4_x1']
        except:
            subcell = af.getCell('and4_x1', 0)
        trans = Transformation(
            u(148.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and4_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['mux2_x1']
        except:
            subcell = af.getCell('mux2_x1', 0)
        trans = Transformation(
            u(125.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'mux2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w4']
        except:
            subcell = af.getCell('tie_poly_w4', 0)
        trans = Transformation(
            u(166.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly_w4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x1']
        except:
            subcell = af.getCell('buf_x1', 0)
        trans = Transformation(
            u(153.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x0']
        except:
            subcell = af.getCell('and21nor_x0', 0)
        trans = Transformation(
            u(131.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and21nor_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w4']
        except:
            subcell = af.getCell('tie_diff_w4', 0)
        trans = Transformation(
            u(170.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff_w4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and3_x1']
        except:
            subcell = af.getCell('and3_x1', 0)
        trans = Transformation(
            u(156.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and3_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x1']
        except:
            subcell = af.getCell('and21nor_x1', 0)
        trans = Transformation(
            u(135.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and21nor_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w4']
        except:
            subcell = af.getCell('tie_w4', 0)
        trans = Transformation(
            u(174.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_w4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x2']
        except:
            subcell = af.getCell('buf_x2', 0)
        trans = Transformation(
            u(160.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x0']
        except:
            subcell = af.getCell('or21nand_x0', 0)
        trans = Transformation(
            u(139.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or21nand_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w4']
        except:
            subcell = af.getCell('fill_w4', 0)
        trans = Transformation(
            u(178.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill_w4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and2_x1']
        except:
            subcell = af.getCell('and2_x1', 0)
        trans = Transformation(
            u(164.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x1']
        except:
            subcell = af.getCell('or21nand_x1', 0)
        trans = Transformation(
            u(143.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or21nand_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w2']
        except:
            subcell = af.getCell('tie_poly_w2', 0)
        trans = Transformation(
            u(182.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly_w2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x4']
        except:
            subcell = af.getCell('buf_x4', 0)
        trans = Transformation(
            u(168.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['xor2_x0']
        except:
            subcell = af.getCell('xor2_x0', 0)
        trans = Transformation(
            u(147.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'xor2_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w2']
        except:
            subcell = af.getCell('tie_diff_w2', 0)
        trans = Transformation(
            u(184.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff_w2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x1']
        except:
            subcell = af.getCell('nand4_x1', 0)
        trans = Transformation(
            u(173.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand4_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nexor2_x0']
        except:
            subcell = af.getCell('nexor2_x0', 0)
        trans = Transformation(
            u(153.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nexor2_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w2']
        except:
            subcell = af.getCell('tie_w2', 0)
        trans = Transformation(
            u(186.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_w2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x0']
        except:
            subcell = af.getCell('nand2_x0', 0)
        trans = Transformation(
            u(177.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand2_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x0']
        except:
            subcell = af.getCell('nsnrlatch_x0', 0)
        trans = Transformation(
            u(159.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nsnrlatch_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w2']
        except:
            subcell = af.getCell('fill_w2', 0)
        trans = Transformation(
            u(188.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill_w2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x0']
        except:
            subcell = af.getCell('nand4_x0', 0)
        trans = Transformation(
            u(180.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand4_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x1']
        except:
            subcell = af.getCell('nsnrlatch_x1', 0)
        trans = Transformation(
            u(163.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nsnrlatch_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly']
        except:
            subcell = af.getCell('tie_poly', 0)
        trans = Transformation(
            u(190.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x1']
        except:
            subcell = af.getCell('nand2_x1', 0)
        trans = Transformation(
            u(184.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dff_x1']
        except:
            subcell = af.getCell('dff_x1', 0)
        trans = Transformation(
            u(167.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'dff_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie']
        except:
            subcell = af.getCell('tie', 0)
        trans = Transformation(
            u(191.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x1']
        except:
            subcell = af.getCell('nand3_x1', 0)
        trans = Transformation(
            u(187.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand3_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dffnr_x1']
        except:
            subcell = af.getCell('dffnr_x1', 0)
        trans = Transformation(
            u(179.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'dffnr_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill']
        except:
            subcell = af.getCell('fill', 0)
        trans = Transformation(
            u(192.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x0']
        except:
            subcell = af.getCell('nand3_x0', 0)
        trans = Transformation(
            u(190.0), u(13.6), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand3_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    af.wrapLibrary(lib, 0)

    return lib

def setup():
    lib = _load()
    _routing()
    try:
        from .StdCell3V3Lib_fix import fix
    except:
        pass
    else:
        fix(lib)

    return lib
