# Autogenerated file. Changes will be overwritten.

from coriolis import CRL, Hurricane, Viewer, Cfg
from coriolis.Hurricane import (
    Technology, DataBase, DbU, Library,
    Layer, BasicLayer,
    Cell, Net, Horizontal, Vertical, Rectilinear, Box, Point,
    Instance, Transformation,
    NetExternalComponents,
)
from coriolis.helpers import u, l
from coriolis.helpers.technology import setEnclosures
from coriolis.helpers.overlay import CfgCache, UpdateSession

__all__ = ["setup"]

def createRL(tech, net, layer, coords):
    coords = [Point(u(x), u(y)) for x,y in coords]
    Rectilinear.create(net, tech.getLayer(layer), coords)

def _routing():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()

    rg = CRL.RoutingGauge.create('StdCellLib')
    rg.setSymbolic(False)
    metal = tech.getLayer('Metal1')
    via = tech.getLayer('Metal1_Via1_Metal2')
    setEnclosures(via, metal, (u(0.01), u(0.05)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.PinOnly, 0, 0.0,
        u(0.0), u(0.5), u(0.21), u(0.16), u(0.19), u(0.18),
    ))
    metal = tech.getLayer('Metal2')
    via = tech.getLayer('Metal1_Via1_Metal2')
    setEnclosures(via, metal, (u(0.01), u(0.05)))
    via = tech.getLayer('Metal2_Via2_Metal3')
    setEnclosures(via, metal, (u(0.05), u(0.05)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 1, 0.0,
        u(0.0), u(0.5), u(0.29), u(0.21), u(0.19), u(0.21),
    ))
    metal = tech.getLayer('Metal3')
    via = tech.getLayer('Metal2_Via2_Metal3')
    setEnclosures(via, metal, (u(0.05), u(0.05)))
    via = tech.getLayer('Metal3_Via3_Metal4')
    setEnclosures(via, metal, (u(0.05), u(0.05)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.Default, 2, 0.0,
        u(0.0), u(0.5), u(0.29), u(0.2), u(0.19), u(0.21),
    ))
    metal = tech.getLayer('Metal4')
    via = tech.getLayer('Metal3_Via3_Metal4')
    setEnclosures(via, metal, (u(0.05), u(0.05)))
    via = tech.getLayer('Metal4_Via4_Metal5')
    setEnclosures(via, metal, (u(0.125), u(0.05)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 3, 0.0,
        u(0.0), u(0.5), u(0.29), u(0.2), u(0.19), u(0.21),
    ))
    metal = tech.getLayer('Metal5')
    via = tech.getLayer('Metal4_Via4_Metal5')
    setEnclosures(via, metal, (u(0.125), u(0.05)))
    via = tech.getLayer('Metal5_TopVia1_TopMetal1')
    setEnclosures(via, metal, (u(0.01), u(0.74)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.Default, 4, 0.0,
        u(0.0), u(0.65), u(0.39), u(0.2), u(0.42), u(0.21),
    ))
    metal = tech.getLayer('TopMetal1')
    via = tech.getLayer('Metal5_TopVia1_TopMetal1')
    setEnclosures(via, metal, (u(0.42), u(0.74)))
    via = tech.getLayer('TopMetal1_TopVia2_TopMetal2')
    setEnclosures(via, metal, (u(0.55), u(0.5)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Horizontal, CRL.RoutingLayerGauge.Default, 5, 0.0,
        u(0.0), u(3.54), u(1.9), u(1.64), u(0.9), u(1.64),
    ))
    metal = tech.getLayer('TopMetal2')
    via = tech.getLayer('TopMetal1_TopVia2_TopMetal2')
    setEnclosures(via, metal, (u(0.55), u(0.5)))
    rg.addLayerGauge(CRL.RoutingLayerGauge.create(
        metal, CRL.RoutingLayerGauge.Vertical, CRL.RoutingLayerGauge.PowerSupply, 6, 0.0,
        u(0.0), u(4.0), u(2.0), u(2.0), u(0.9), u(2.0),
    ))
    af.addRoutingGauge(rg)
    af.setRoutingGauge('StdCellLib')

    cg = CRL.CellGauge.create(
        'StdCellLib', 'Metal2',
        u(0.576), u(5.76), u(0.8),
    )
    af.addCellGauge(cg)
    af.setCellGauge('StdCellLib')

    # Place & Route setup
    with CfgCache(priority=Cfg.Parameter.Priority.ConfigurationFile) as cfg:
        env = af.getEnvironment()
        env.setRegister('^dff.*')
        cfg.lefImport.minTerminalWidth = 0.0
        cfg.crlcore.groundName = 'vss'
        cfg.crlcore.powerName = 'vdd'
        cfg.etesian.aspectRatio = 1.00
        cfg.etesian.aspectRatio = [10, 1000]
        cfg.etesian.spaceMargin = 0.10
        cfg.etesian.uniformDensity = True
        cfg.etesian.densityVariation = 0.05
        cfg.etesian.routingDriven = False
        cfg.etesian.latchUpDistance = u(30.0 - 1.0)
        cfg.etesian.diodeName = 'diode_w1'
        cfg.etesian.antennaInsertThreshold = 0.50
        cfg.etesian.tieName = None
        cfg.etesian.antennaGateMaxWL = u(500.0)
        cfg.etesian.antennaDiodeMaxWL = u(50000.0)
        cfg.etesian.feedNames = 'tie,decap_w0'
        cfg.etesian.defaultFeed = 'tie'
        cfg.etesian.cell.zero = 'zero_x1'
        cfg.etesian.cell.one = 'one_x1'
        cfg.etesian.bloat = 'disabled'
        cfg.etesian.effort = 2
        cfg.etesian.effort = (
            ('Fast', 1),
            ('Standard', 2),
            ('High', 3 ),
            ('Extreme', 4 ),
        )
        cfg.etesian.graphics = 2
        cfg.etesian.graphics = (
            ('Show every step', 1),
            ('Show lower bound', 2),
            ('Show result only', 3),
        )
        cfg.anabatic.routingGauge = 'StdCellLib'
        cfg.anabatic.globalLengthThreshold = 1450
        cfg.anabatic.saturateRatio = 0.90
        cfg.anabatic.saturateRp = 10
        cfg.anabatic.topRoutingLayer = 'TopMetal1'
        cfg.anabatic.edgeLength = 24
        cfg.anabatic.edgeWidth = 4
        cfg.anabatic.edgeCostH = 9.0
        cfg.anabatic.edgeCostK = -10.0
        cfg.anabatic.edgeHInc = 1.0
        cfg.anabatic.edgeHScaling = 1.0
        cfg.anabatic.globalIterations = 20
        cfg.anabatic.globalIterations = [ 1, 100 ]
        cfg.anabatic.gcell.displayMode = 1
        cfg.anabatic.gcell.displayMode = (("Boundary", 1), ("Density", 2))
        cfg.anabatic.searchHalo = 2
        cfg.katana.trackFill = 0
        cfg.katana.runRealignStage = True
        cfg.katana.hTracksReservedMin   = 4
        cfg.katana.hTracksReservedLocal = 20
        cfg.katana.hTracksReservedLocal = [0, 30]
        cfg.katana.vTracksReservedMin   = 4
        cfg.katana.vTracksReservedLocal = 20
        cfg.katana.vTracksReservedLocal = [0, 30]
        cfg.katana.termSatReservedLocal = 8
        cfg.katana.termSatThreshold = 9
        cfg.katana.eventsLimit = 4000002
        cfg.katana.ripupCost = 3
        cfg.katana.ripupCost = [0, None]
        cfg.katana.strapRipupLimit = 16
        cfg.katana.strapRipupLimit = [1, None]
        cfg.katana.localRipupLimit = 9
        cfg.katana.localRipupLimit = [1, None]
        cfg.katana.globalRipupLimit = 5
        cfg.katana.globalRipupLimit = [1, None]
        cfg.katana.longGlobalRipupLimit = 5
        cfg.chip.padCoreSide = 'South'

    # Plugins setup
    with CfgCache(priority=Cfg.Parameter.Priority.ConfigurationFile) as cfg:
        cfg.viewer.minimumSize = 500
        cfg.viewer.pixelThreshold = 10
        cfg.chip.block.rails.count = 5
        cfg.chip.block.rails.hWidth = u(2.68)
        cfg.chip.block.rails.vWidth = u(2.68)
        cfg.chip.block.rails.hSpacing = u(0.7)
        cfg.chip.block.rails.vSpacing = u(0.7)
        cfg.chip.supplyRailWidth = u(20.0)
        cfg.chip.supplyRailPitch = u(40.0)
        cfg.clockTree.placerEngine = 'Etesian'
        cfg.block.spareSide = 8*u(5.76)
        cfg.spares.buffer = 'buf_x4'
        cfg.spares.hfnsBuffer = 'buf_x4'
        cfg.spares.maxSinks = 31


def _load():
    af = CRL.AllianceFramework.get()
    db = DataBase.getDB()
    tech = db.getTechnology()
    rootlib = db.getRootLibrary()

    lib = Library.create(rootlib, 'StdCellLib')
    new_cells = {
        'fill': Cell.create(lib, 'fill'),
        'tie': Cell.create(lib, 'tie'),
        'tie_diff': Cell.create(lib, 'tie_diff'),
        'tie_poly': Cell.create(lib, 'tie_poly'),
        'fill_w2': Cell.create(lib, 'fill_w2'),
        'tie_w2': Cell.create(lib, 'tie_w2'),
        'tie_diff_w2': Cell.create(lib, 'tie_diff_w2'),
        'tie_poly_w2': Cell.create(lib, 'tie_poly_w2'),
        'fill_w4': Cell.create(lib, 'fill_w4'),
        'tie_w4': Cell.create(lib, 'tie_w4'),
        'tie_diff_w4': Cell.create(lib, 'tie_diff_w4'),
        'tie_poly_w4': Cell.create(lib, 'tie_poly_w4'),
        'diode_w1': Cell.create(lib, 'diode_w1'),
        'zero_x1': Cell.create(lib, 'zero_x1'),
        'one_x1': Cell.create(lib, 'one_x1'),
        'zeroone_x1': Cell.create(lib, 'zeroone_x1'),
        'decap_w0': Cell.create(lib, 'decap_w0'),
        'inv_x0': Cell.create(lib, 'inv_x0'),
        'inv_x1': Cell.create(lib, 'inv_x1'),
        'inv_x2': Cell.create(lib, 'inv_x2'),
        'inv_x4': Cell.create(lib, 'inv_x4'),
        'buf_x1': Cell.create(lib, 'buf_x1'),
        'buf_x2': Cell.create(lib, 'buf_x2'),
        'buf_x4': Cell.create(lib, 'buf_x4'),
        'nand2_x0': Cell.create(lib, 'nand2_x0'),
        'nand2_x1': Cell.create(lib, 'nand2_x1'),
        'nand3_x0': Cell.create(lib, 'nand3_x0'),
        'nand3_x1': Cell.create(lib, 'nand3_x1'),
        'nand4_x0': Cell.create(lib, 'nand4_x0'),
        'nand4_x1': Cell.create(lib, 'nand4_x1'),
        'and2_x1': Cell.create(lib, 'and2_x1'),
        'and3_x1': Cell.create(lib, 'and3_x1'),
        'and4_x1': Cell.create(lib, 'and4_x1'),
        'nor2_x0': Cell.create(lib, 'nor2_x0'),
        'nor2_x1': Cell.create(lib, 'nor2_x1'),
        'nor3_x0': Cell.create(lib, 'nor3_x0'),
        'nor3_x1': Cell.create(lib, 'nor3_x1'),
        'nor4_x0': Cell.create(lib, 'nor4_x0'),
        'nor4_x1': Cell.create(lib, 'nor4_x1'),
        'or2_x1': Cell.create(lib, 'or2_x1'),
        'or3_x1': Cell.create(lib, 'or3_x1'),
        'or4_x1': Cell.create(lib, 'or4_x1'),
        'mux2_x1': Cell.create(lib, 'mux2_x1'),
        'and21nor_x0': Cell.create(lib, 'and21nor_x0'),
        'and21nor_x1': Cell.create(lib, 'and21nor_x1'),
        'or21nand_x0': Cell.create(lib, 'or21nand_x0'),
        'or21nand_x1': Cell.create(lib, 'or21nand_x1'),
        'xor2_x0': Cell.create(lib, 'xor2_x0'),
        'nexor2_x0': Cell.create(lib, 'nexor2_x0'),
        'nsnrlatch_x0': Cell.create(lib, 'nsnrlatch_x0'),
        'nsnrlatch_x1': Cell.create(lib, 'nsnrlatch_x1'),
        'dff_x1': Cell.create(lib, 'dff_x1'),
        'dffnr_x1': Cell.create(lib, 'dffnr_x1'),
        'Gallery': Cell.create(lib, 'Gallery'),
    }

    cell = new_cells['fill']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(0.8), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(0.8,5.76),(0.8,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.11,6.07),(1.11,2.86),(-0.31,2.86)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(0.8,1.12),(0.8,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.0,0.0),(0.0,0.31),(0.8,0.31),(0.8,0.0),(0.0,0.0)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(0.8), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.32,5.345),(0.32,5.665),(0.48,5.665),(0.48,5.345),(0.32,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(0.8,5.76),(0.8,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.005,5.965),(1.005,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.06,5.045),(-0.06,5.965),(0.86,5.965),(0.86,5.045),(-0.06,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.11,6.07),(1.11,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(0.695,5.655),(0.695,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.25,5.355),(0.25,5.655),(0.55,5.655),(0.55,5.355),(0.25,5.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,5.425),(0.32,5.585),(0.48,5.585),(0.48,5.425),(0.32,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(0.8,1.12),(0.8,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.32,0.095),(0.32,0.415),(0.48,0.415),(0.48,0.095),(0.32,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.25,0.105),(0.25,0.405),(0.55,0.405),(0.55,0.105),(0.25,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(0.695,0.405),(0.695,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,0.175),(0.32,0.335),(0.48,0.335),(0.48,0.175),(0.32,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(0.875,5.17),(0.875,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.07,-0.075),(0.07,0.585),(0.73,0.585),(0.73,-0.075),(0.07,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(0.875,0.585),(0.875,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_diff']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(0.8), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.32,5.345),(0.32,5.665),(0.48,5.665),(0.48,5.345),(0.32,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(0.8,5.76),(0.8,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.055,2.86),(-0.055,5.965),(0.855,5.965),(0.855,2.86),(-0.055,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.005,5.965),(1.005,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.06,5.045),(-0.06,5.965),(0.86,5.965),(0.86,5.045),(-0.06,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.11,6.07),(1.11,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(0.695,5.655),(0.695,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.25,5.355),(0.25,5.655),(0.55,5.655),(0.55,5.355),(0.25,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.255,3.17),(0.255,5.655),(0.545,5.655),(0.545,3.17),(0.255,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,5.425),(0.32,5.585),(0.48,5.585),(0.48,5.425),(0.32,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(0.8,1.12),(0.8,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.32,0.095),(0.32,0.415),(0.48,0.415),(0.48,0.095),(0.32,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.25,0.105),(0.25,0.405),(0.55,0.405),(0.55,0.105),(0.25,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(0.695,0.405),(0.695,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.255,0.105),(0.255,2.37),(0.545,2.37),(0.545,0.105),(0.255,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,0.175),(0.32,0.335),(0.48,0.335),(0.48,0.175),(0.32,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.075,-0.075),(0.075,2.55),(0.725,2.55),(0.725,-0.075),(0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.07,-0.075),(0.07,0.585),(0.73,0.585),(0.73,-0.075),(0.07,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(0.875,0.585),(0.875,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(0.8), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.32,5.345),(0.32,5.665),(0.48,5.665),(0.48,5.345),(0.32,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(0.8,5.76),(0.8,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.005,5.965),(1.005,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.06,5.045),(-0.06,5.965),(0.86,5.965),(0.86,5.045),(-0.06,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.11,6.07),(1.11,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(0.695,5.655),(0.695,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.25,5.355),(0.25,5.655),(0.55,5.655),(0.55,5.355),(0.25,5.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,5.425),(0.32,5.585),(0.48,5.585),(0.48,5.425),(0.32,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(0.8,1.12),(0.8,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.32,0.095),(0.32,0.415),(0.48,0.415),(0.48,0.095),(0.32,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.32,0.465),(0.32,0.785),(0.48,0.785),(0.48,0.465),(0.32,0.465)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.25,0.105),(0.25,0.405),(0.55,0.405),(0.55,0.105),(0.25,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(0.695,0.405),(0.695,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,0.545),(0.32,0.705),(0.48,0.705),(0.48,0.545),(0.32,0.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,0.175),(0.32,0.335),(0.48,0.335),(0.48,0.175),(0.32,0.175)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.25,0.475),(0.25,0.775),(0.55,0.775),(0.55,0.475),(0.25,0.475)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.09,0.475),(0.09,5.285),(0.71,5.285),(0.71,0.475),(0.09,0.475)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(0.875,5.17),(0.875,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.07,-0.075),(0.07,0.585),(0.73,0.585),(0.73,-0.075),(0.07,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(0.875,0.585),(0.875,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['fill_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.0,0.0),(0.0,0.31),(1.6,0.31),(1.6,0.0),(0.0,0.0)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_diff_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.055,2.86),(-0.055,5.965),(1.655,5.965),(1.655,2.86),(-0.055,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.255,3.17),(0.255,5.655),(1.345,5.655),(1.345,3.17),(0.255,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.255,0.105),(0.255,2.37),(1.345,2.37),(1.345,0.105),(0.255,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.075,-0.075),(0.075,2.55),(1.525,2.55),(1.525,-0.075),(0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly_w2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.72,0.465),(0.72,0.785),(0.88,0.785),(0.88,0.465),(0.72,0.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.72,0.545),(0.72,0.705),(0.88,0.705),(0.88,0.545),(0.72,0.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.09,0.475),(0.09,5.285),(1.51,5.285),(1.51,0.475),(0.09,0.475)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.65,0.475),(0.65,0.775),(0.95,0.775),(0.95,0.475),(0.65,0.475)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['fill_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.0,0.0),(0.0,0.31),(3.2,0.31),(3.2,0.0),(0.0,0.0)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_diff_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.055,2.86),(-0.055,5.965),(3.255,5.965),(3.255,2.86),(-0.055,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.255,3.17),(0.255,5.655),(2.945,5.655),(2.945,3.17),(0.255,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.255,0.105),(0.255,2.37),(2.945,2.37),(2.945,0.105),(0.255,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.075,-0.075),(0.075,2.55),(3.125,2.55),(3.125,-0.075),(0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['tie_poly_w4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((1.52,0.465),(1.52,0.785),(1.68,0.785),(1.68,0.465),(1.52,0.465)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.52,0.545),(1.52,0.705),(1.68,0.705),(1.68,0.545),(1.52,0.545)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.09,0.475),(0.09,5.285),(3.11,5.285),(3.11,0.475),(0.09,0.475)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.45,0.475),(1.45,0.775),(1.75,0.775),(1.75,0.475),(1.45,0.475)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['diode_w1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(0.8), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.32,5.345),(0.32,5.665),(0.48,5.665),(0.48,5.345),(0.32,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(0.8,5.76),(0.8,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'NWell',
            ((-0.06,2.86),(-0.06,4.73),(0.86,4.73),(0.86,2.86),(-0.06,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.005,5.965),(1.005,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.06,5.045),(-0.06,5.965),(0.86,5.965),(0.86,5.045),(-0.06,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.11,6.07),(1.11,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(0.695,5.655),(0.695,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.25,5.355),(0.25,5.655),(0.55,5.655),(0.55,5.355),(0.25,5.355)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,5.425),(0.32,5.585),(0.48,5.585),(0.48,5.425),(0.32,5.425)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(0.8,1.12),(0.8,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.32,0.095),(0.32,0.415),(0.48,0.415),(0.48,0.095),(0.32,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.8), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Activ',
            ((0.25,0.105),(0.25,0.405),(0.55,0.405),(0.55,0.105),(0.25,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(0.695,0.405),(0.695,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,0.175),(0.32,0.335),(0.48,0.335),(0.48,0.175),(0.32,0.175)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(0.875,5.17),(0.875,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.07,2.99),(0.07,4.6),(0.73,4.6),(0.73,2.99),(0.07,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.07,-0.075),(0.07,0.585),(0.73,0.585),(0.73,-0.075),(0.07,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(0.875,0.585),(0.875,-0.075),(-0.075,-0.075)),
        )
        net = nets['i']
        createRL(
            tech, net, 'Activ',
            ((0.25,3.17),(0.25,4.42),(0.55,4.42),(0.55,3.17),(0.25,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.25,1.34),(0.25,2.55),(0.55,2.55),(0.55,1.34),(0.25,1.34)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,3.375),(0.32,3.535),(0.48,3.535),(0.48,3.375),(0.32,3.375)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,3.715),(0.32,3.875),(0.48,3.875),(0.48,3.715),(0.32,3.715)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,4.055),(0.32,4.215),(0.48,4.215),(0.48,4.055),(0.32,4.055)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,1.525),(0.32,1.685),(0.48,1.685),(0.48,1.525),(0.32,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,1.865),(0.32,2.025),(0.48,2.025),(0.48,1.865),(0.32,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.32,2.205),(0.32,2.365),(0.48,2.365),(0.48,2.205),(0.32,2.205)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.295,1.34),(0.295,4.42),(0.505,4.42),(0.505,1.34),(0.295,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.32,3.17),(0.32,4.42),(0.48,4.42),(0.48,3.17),(0.32,3.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.32,1.34),(0.32,2.55),(0.48,2.55),(0.48,1.34),(0.32,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.4), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.4), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)

    cell = new_cells['zero_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.37),(0.575,2.37),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.375,2.37),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.37),(0.445,2.37),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.405,2.37),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Activ',
            ((0.215,3.35),(0.215,4.87),(0.445,4.87),(0.445,3.35),(0.215,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.375,4.87),(0.375,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.645),(0.105,4.285),(0.405,4.285),(0.405,3.645),(0.105,3.645)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.405,4.87),(0.405,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.715),(0.175,3.875),(0.335,3.875),(0.335,3.715),(0.175,3.715)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.055),(0.175,4.215),(0.335,4.215),(0.335,4.055),(0.175,4.055)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.51),(0.175,2.67),(0.335,2.67),(0.335,2.51),(0.175,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.51),(0.175,4.42),(0.335,4.42),(0.335,3.51),(0.175,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.43),(0.175,2.75),(0.335,2.75),(0.335,2.43),(0.175,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,2.43),(0.15,3.83),(0.36,3.83),(0.36,2.43),(0.15,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.635),(0.175,4.295),(0.335,4.295),(0.335,3.635),(0.175,3.635)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.44),(0.105,2.74),(0.405,2.74),(0.405,2.44),(0.105,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.74),(0.575,2.74),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.55),(0.575,2.55),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.44),(0.255,2.74),(0.51,2.74),(0.51,2.44),(0.255,2.44)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.17),(0.035,5.05),(0.985,5.05),(0.985,3.17),(0.035,3.17)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.345),(-0.075,4.585),(0.585,4.585),(0.585,3.345),(-0.075,3.345)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.555,5.17),(0.555,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.05),(0.145,5.17),(0.875,5.17),(0.875,3.05),(0.145,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.05),(0.465,5.17),(1.095,5.17),(1.095,3.05),(0.465,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.585,5.17),(0.585,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.05),(0.435,5.17),(1.095,5.17),(1.095,3.05),(0.435,3.05)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.715,5.18),(0.715,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.04),(0.335,5.18),(1.225,5.18),(1.225,3.04),(0.335,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.685,5.18),(0.685,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.04),(-0.095,5.18),(1.115,5.18),(1.115,3.04),(-0.095,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.04),(0.305,5.18),(1.225,5.18),(1.225,3.04),(0.305,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.335),(-0.205,4.595),(0.715,4.595),(0.715,3.335),(-0.205,3.335)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.35),(0.445,4.87),(0.575,4.87),(0.575,3.35),(0.445,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.35),(0.575,4.87),(0.805,4.87),(0.805,3.35),(0.575,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.35),(0.645,4.87),(0.915,4.87),(0.915,3.35),(0.645,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.35),(0.615,4.87),(0.915,4.87),(0.915,3.35),(0.615,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['zero']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.37),(0.915,2.37),(0.915,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.455),(0.615,2.095),(0.915,2.095),(0.915,1.455),(0.615,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.37),(0.805,2.37),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.37),(0.915,2.37),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.615,2.98),(0.615,3.28),(0.915,3.28),(0.915,2.98),(0.615,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.17),(0.445,5.05),(0.575,5.05),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.98),(0.445,5.05),(0.575,5.05),(0.575,2.98),(0.445,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.98),(0.51,3.28),(0.765,3.28),(0.765,2.98),(0.51,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.525),(0.685,1.685),(0.845,1.685),(0.845,1.525),(0.685,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.865),(0.685,2.025),(0.845,2.025),(0.845,1.865),(0.685,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.05),(0.685,3.21),(0.845,3.21),(0.845,3.05),(0.685,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,1.34),(0.66,4.42),(0.87,4.42),(0.87,1.34),(0.66,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.21),(0.845,2.21),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.445),(0.685,2.105),(0.845,2.105),(0.845,1.445),(0.685,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,2.97),(0.685,3.29),(0.845,3.29),(0.845,2.97),(0.685,2.97)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['zero'].setDirection(Net.Direction.OUT)

    cell = new_cells['one_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.37),(0.575,2.37),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.375,2.37),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.37),(0.445,2.37),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.405,2.37),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Activ',
            ((0.215,3.35),(0.215,4.87),(0.445,4.87),(0.445,3.35),(0.215,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.375,4.87),(0.375,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.645),(0.105,4.285),(0.405,4.285),(0.405,3.645),(0.105,3.645)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.405,4.87),(0.405,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.715),(0.175,3.875),(0.335,3.875),(0.335,3.715),(0.175,3.715)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.055),(0.175,4.215),(0.335,4.215),(0.335,4.055),(0.175,4.055)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.51),(0.175,2.67),(0.335,2.67),(0.335,2.51),(0.175,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.51),(0.175,4.42),(0.335,4.42),(0.335,3.51),(0.175,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.43),(0.175,2.75),(0.335,2.75),(0.335,2.43),(0.175,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.635),(0.175,4.295),(0.335,4.295),(0.335,3.635),(0.175,3.635)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.44),(0.105,2.74),(0.405,2.74),(0.405,2.44),(0.105,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.74),(0.575,2.74),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.55),(0.575,2.55),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.44),(0.255,2.74),(0.51,2.74),(0.51,2.44),(0.255,2.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.17),(0.035,5.05),(0.985,5.05),(0.985,3.17),(0.035,3.17)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.345),(-0.075,4.585),(0.585,4.585),(0.585,3.345),(-0.075,3.345)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.555,5.17),(0.555,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.05),(0.145,5.17),(0.875,5.17),(0.875,3.05),(0.145,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.05),(0.465,5.17),(1.095,5.17),(1.095,3.05),(0.465,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.585,5.17),(0.585,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.05),(0.435,5.17),(1.095,5.17),(1.095,3.05),(0.435,3.05)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.715,5.18),(0.715,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.04),(0.335,5.18),(1.225,5.18),(1.225,3.04),(0.335,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.685,5.18),(0.685,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.04),(-0.095,5.18),(1.115,5.18),(1.115,3.04),(-0.095,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.04),(0.305,5.18),(1.225,5.18),(1.225,3.04),(0.305,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.335),(-0.205,4.595),(0.715,4.595),(0.715,3.335),(-0.205,3.335)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.35),(0.445,4.87),(0.575,4.87),(0.575,3.35),(0.445,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.35),(0.575,4.87),(0.805,4.87),(0.805,3.35),(0.575,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.35),(0.645,4.87),(0.915,4.87),(0.915,3.35),(0.645,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.35),(0.615,4.87),(0.915,4.87),(0.915,3.35),(0.615,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['zero']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.37),(0.915,2.37),(0.915,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.455),(0.615,2.095),(0.915,2.095),(0.915,1.455),(0.615,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.37),(0.805,2.37),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.37),(0.915,2.37),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.615,2.98),(0.615,3.28),(0.915,3.28),(0.915,2.98),(0.615,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.17),(0.445,5.05),(0.575,5.05),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.98),(0.445,5.05),(0.575,5.05),(0.575,2.98),(0.445,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.98),(0.51,3.28),(0.765,3.28),(0.765,2.98),(0.51,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.525),(0.685,1.685),(0.845,1.685),(0.845,1.525),(0.685,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.865),(0.685,2.025),(0.845,2.025),(0.845,1.865),(0.685,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.05),(0.685,3.21),(0.845,3.21),(0.845,3.05),(0.685,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.21),(0.845,2.21),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.445),(0.685,2.105),(0.845,2.105),(0.845,1.445),(0.685,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,1.89),(0.66,3.29),(0.87,3.29),(0.87,1.89),(0.66,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,2.97),(0.685,3.29),(0.845,3.29),(0.845,2.97),(0.685,2.97)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['one'].setDirection(Net.Direction.OUT)

    cell = new_cells['zeroone_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.37),(0.575,2.37),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.375,2.37),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.37),(0.445,2.37),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.405,2.37),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Activ',
            ((0.215,3.35),(0.215,4.87),(0.445,4.87),(0.445,3.35),(0.215,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.375,4.87),(0.375,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.645),(0.105,4.285),(0.405,4.285),(0.405,3.645),(0.105,3.645)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.405,4.87),(0.405,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.715),(0.175,3.875),(0.335,3.875),(0.335,3.715),(0.175,3.715)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.055),(0.175,4.215),(0.335,4.215),(0.335,4.055),(0.175,4.055)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.51),(0.175,2.67),(0.335,2.67),(0.335,2.51),(0.175,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.51),(0.175,4.42),(0.335,4.42),(0.335,3.51),(0.175,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.43),(0.175,2.75),(0.335,2.75),(0.335,2.43),(0.175,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.635),(0.175,4.295),(0.335,4.295),(0.335,3.635),(0.175,3.635)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.44),(0.105,2.74),(0.405,2.74),(0.405,2.44),(0.105,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.74),(0.575,2.74),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.55),(0.575,2.55),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.44),(0.255,2.74),(0.51,2.74),(0.51,2.44),(0.255,2.44)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.17),(0.035,5.05),(0.985,5.05),(0.985,3.17),(0.035,3.17)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.345),(-0.075,4.585),(0.585,4.585),(0.585,3.345),(-0.075,3.345)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.555,5.17),(0.555,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.05),(0.145,5.17),(0.875,5.17),(0.875,3.05),(0.145,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.05),(0.465,5.17),(1.095,5.17),(1.095,3.05),(0.465,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.585,5.17),(0.585,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.05),(0.435,5.17),(1.095,5.17),(1.095,3.05),(0.435,3.05)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.715,5.18),(0.715,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.04),(0.335,5.18),(1.225,5.18),(1.225,3.04),(0.335,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.685,5.18),(0.685,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.04),(-0.095,5.18),(1.115,5.18),(1.115,3.04),(-0.095,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.04),(0.305,5.18),(1.225,5.18),(1.225,3.04),(0.305,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.335),(-0.205,4.595),(0.715,4.595),(0.715,3.335),(-0.205,3.335)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.35),(0.445,4.87),(0.575,4.87),(0.575,3.35),(0.445,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.35),(0.575,4.87),(0.805,4.87),(0.805,3.35),(0.575,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.35),(0.645,4.87),(0.915,4.87),(0.915,3.35),(0.645,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.35),(0.615,4.87),(0.915,4.87),(0.915,3.35),(0.615,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['zero']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.37),(0.915,2.37),(0.915,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.455),(0.615,2.095),(0.915,2.095),(0.915,1.455),(0.615,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.37),(0.805,2.37),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.37),(0.915,2.37),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.615,2.98),(0.615,3.28),(0.915,3.28),(0.915,2.98),(0.615,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.17),(0.445,5.05),(0.575,5.05),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.98),(0.445,5.05),(0.575,5.05),(0.575,2.98),(0.445,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.98),(0.51,3.28),(0.765,3.28),(0.765,2.98),(0.51,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.525),(0.685,1.685),(0.845,1.685),(0.845,1.525),(0.685,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.865),(0.685,2.025),(0.845,2.025),(0.845,1.865),(0.685,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.05),(0.685,3.21),(0.845,3.21),(0.845,3.05),(0.685,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,1.34),(0.66,4.42),(0.87,4.42),(0.87,1.34),(0.66,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.21),(0.845,2.21),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.445),(0.685,2.105),(0.845,2.105),(0.845,1.445),(0.685,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,2.97),(0.685,3.29),(0.845,3.29),(0.845,2.97),(0.685,2.97)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['one'].setDirection(Net.Direction.OUT)
        nets['zero'].setDirection(Net.Direction.OUT)

    cell = new_cells['decap_w0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'one': Net.create(cell, 'one'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
            'zero': Net.create(cell, 'zero'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.37),(0.575,2.37),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.375,2.37),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.37),(0.445,2.37),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.405,2.37),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['one']
        createRL(
            tech, net, 'Activ',
            ((0.215,3.35),(0.215,4.87),(0.445,4.87),(0.445,3.35),(0.215,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.375,4.87),(0.375,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.645),(0.105,4.285),(0.405,4.285),(0.405,3.645),(0.105,3.645)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.405,4.87),(0.405,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.715),(0.175,3.875),(0.335,3.875),(0.335,3.715),(0.175,3.715)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.055),(0.175,4.215),(0.335,4.215),(0.335,4.055),(0.175,4.055)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.51),(0.175,2.67),(0.335,2.67),(0.335,2.51),(0.175,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.51),(0.175,4.42),(0.335,4.42),(0.335,3.51),(0.175,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.43),(0.175,2.75),(0.335,2.75),(0.335,2.43),(0.175,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,2.43),(0.15,3.83),(0.36,3.83),(0.36,2.43),(0.15,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.635),(0.175,4.295),(0.335,4.295),(0.335,3.635),(0.175,3.635)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.44),(0.105,2.74),(0.405,2.74),(0.405,2.44),(0.105,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.74),(0.575,2.74),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.55),(0.575,2.55),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.44),(0.255,2.74),(0.51,2.74),(0.51,2.44),(0.255,2.44)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.17),(0.035,5.05),(0.985,5.05),(0.985,3.17),(0.035,3.17)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.345),(-0.075,4.585),(0.585,4.585),(0.585,3.345),(-0.075,3.345)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.555,5.17),(0.555,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.05),(0.145,5.17),(0.875,5.17),(0.875,3.05),(0.145,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.05),(0.465,5.17),(1.095,5.17),(1.095,3.05),(0.465,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.585,5.17),(0.585,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.05),(0.435,5.17),(1.095,5.17),(1.095,3.05),(0.435,3.05)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.715,5.18),(0.715,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.04),(0.335,5.18),(1.225,5.18),(1.225,3.04),(0.335,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.685,5.18),(0.685,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.04),(-0.095,5.18),(1.115,5.18),(1.115,3.04),(-0.095,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.04),(0.305,5.18),(1.225,5.18),(1.225,3.04),(0.305,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.335),(-0.205,4.595),(0.715,4.595),(0.715,3.335),(-0.205,3.335)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.35),(0.445,4.87),(0.575,4.87),(0.575,3.35),(0.445,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.35),(0.575,4.87),(0.805,4.87),(0.805,3.35),(0.575,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.35),(0.645,4.87),(0.915,4.87),(0.915,3.35),(0.645,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.35),(0.615,4.87),(0.915,4.87),(0.915,3.35),(0.615,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['zero']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.37),(0.915,2.37),(0.915,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.455),(0.615,2.095),(0.915,2.095),(0.915,1.455),(0.615,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.37),(0.805,2.37),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.37),(0.915,2.37),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.615,2.98),(0.615,3.28),(0.915,3.28),(0.915,2.98),(0.615,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.17),(0.445,5.05),(0.575,5.05),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.98),(0.445,5.05),(0.575,5.05),(0.575,2.98),(0.445,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.98),(0.51,3.28),(0.765,3.28),(0.765,2.98),(0.51,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.525),(0.685,1.685),(0.845,1.685),(0.845,1.525),(0.685,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.865),(0.685,2.025),(0.845,2.025),(0.845,1.865),(0.685,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.05),(0.685,3.21),(0.845,3.21),(0.845,3.05),(0.685,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.21),(0.845,2.21),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.445),(0.685,2.105),(0.845,2.105),(0.845,1.445),(0.685,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,1.89),(0.66,3.29),(0.87,3.29),(0.87,1.89),(0.66,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,2.97),(0.685,3.29),(0.845,3.29),(0.845,2.97),(0.685,2.97)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)

    cell = new_cells['inv_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.225,5.18),(1.225,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.79),(0.305,4.71),(1.225,4.71),(1.225,3.79),(0.305,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.8),(0.435,4.7),(1.095,4.7),(1.095,3.8),(0.435,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.095,5.17),(1.095,3.79),(0.465,3.79)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.915,1.67),(0.915,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.1),(0.615,4.4),(0.915,4.4),(0.915,4.1),(0.615,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.915,4.87),(0.915,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.36),(0.615,1.66),(0.915,1.66),(0.915,1.36),(0.615,1.36)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.43),(0.685,1.59),(0.845,1.59),(0.845,1.43),(0.685,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.17),(0.685,4.33),(0.845,4.33),(0.845,4.17),(0.685,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.42),(0.845,4.42),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.41),(0.845,4.41),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.35),(0.685,1.67),(0.845,1.67),(0.845,1.35),(0.685,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,1.67),(0.845,1.67),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,1.34),(0.66,4.42),(0.87,4.42),(0.87,1.34),(0.66,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,2.86),(0.305,5.18),(1.225,5.18),(1.225,2.86),(0.305,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.03),(0.305,4.63),(1.225,4.63),(1.225,3.03),(0.305,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.225,5.18),(1.225,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.095,5.17),(1.095,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.04),(0.435,4.62),(1.095,4.62),(1.095,3.04),(0.435,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,2.87),(0.435,5.17),(1.095,5.17),(1.095,2.87),(0.435,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.615,1.42),(0.615,2.4),(0.915,2.4),(0.915,1.42),(0.615,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.34),(0.615,4.32),(0.915,4.32),(0.915,3.34),(0.615,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.55),(0.915,2.55),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.915,2.55),(0.915,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.915,4.87),(0.915,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.17),(0.615,4.87),(0.915,4.87),(0.915,3.17),(0.615,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.49),(0.685,1.65),(0.845,1.65),(0.845,1.49),(0.685,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.83),(0.685,1.99),(0.845,1.99),(0.845,1.83),(0.685,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,2.17),(0.685,2.33),(0.845,2.33),(0.845,2.17),(0.685,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.41),(0.685,3.57),(0.845,3.57),(0.845,3.41),(0.685,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.75),(0.685,3.91),(0.845,3.91),(0.845,3.75),(0.685,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.09),(0.685,4.25),(0.845,4.25),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.33),(0.685,4.33),(0.845,4.33),(0.845,3.33),(0.685,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.48),(0.845,2.48),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,1.34),(0.66,4.42),(0.87,4.42),(0.87,1.34),(0.66,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.41),(0.685,2.41),(0.845,2.41),(0.845,1.41),(0.685,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.24),(0.685,4.42),(0.845,4.42),(0.845,3.24),(0.685,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,2.55),(1.425,2.55),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.425,2.55),(1.425,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,3.17),(1.125,4.87),(1.425,4.87),(1.425,3.17),(1.125,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.425,4.87),(1.425,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,2.86),(0.815,5.18),(1.735,5.18),(1.735,2.86),(0.815,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.03),(0.305,4.63),(1.225,4.63),(1.225,3.03),(0.305,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,2.86),(0.305,5.18),(1.225,5.18),(1.225,2.86),(0.305,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.735,5.18),(1.735,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.04),(0.435,4.62),(1.095,4.62),(1.095,3.04),(0.435,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,2.87),(0.945,5.17),(1.605,5.17),(1.605,2.87),(0.945,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,2.87),(0.435,5.17),(1.095,5.17),(1.095,2.87),(0.435,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.605,5.17),(1.605,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.42),(0.615,2.4),(0.915,2.4),(0.915,1.42),(0.615,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.34),(0.615,4.32),(0.915,4.32),(0.915,3.34),(0.615,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.55),(0.915,2.55),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.17),(0.615,4.87),(0.915,4.87),(0.915,3.17),(0.615,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.49),(0.685,1.65),(0.845,1.65),(0.845,1.49),(0.685,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.83),(0.685,1.99),(0.845,1.99),(0.845,1.83),(0.685,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,2.17),(0.685,2.33),(0.845,2.33),(0.845,2.17),(0.685,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.41),(0.685,3.57),(0.845,3.57),(0.845,3.41),(0.685,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.75),(0.685,3.91),(0.845,3.91),(0.845,3.75),(0.685,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.09),(0.685,4.25),(0.845,4.25),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.33),(0.685,4.33),(0.845,4.33),(0.845,3.33),(0.685,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.48),(0.845,2.48),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,1.34),(0.66,4.42),(0.87,4.42),(0.87,1.34),(0.66,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.41),(0.685,2.41),(0.845,2.41),(0.845,1.41),(0.685,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.24),(0.685,4.42),(0.845,4.42),(0.845,3.24),(0.685,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(1.02,3.01),(1.02,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['inv_x4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            'i': Net.create(cell, 'i'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,2.55),(2.445,2.55),(2.445,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,0.89),(1.975,2.55),(2.105,2.55),(2.105,0.89),(1.975,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.89),(2.105,2.55),(2.335,2.55),(2.335,0.89),(2.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.145,0.89),(2.145,2.55),(2.445,2.55),(2.445,0.89),(2.145,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,2.55),(1.595,2.55),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,2.55),(1.425,2.55),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.145,0.89),(2.145,1.19),(2.445,1.19),(2.445,0.89),(2.145,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,2.55),(1.465,2.55),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.395,2.55),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.215,0.96),(2.215,1.12),(2.375,1.12),(2.375,0.96),(2.215,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.135,0.96),(2.135,1.12),(2.455,1.12),(2.455,0.96),(2.135,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.125,3.17),(1.125,4.87),(1.425,4.87),(1.425,3.17),(1.125,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,3.17),(1.975,4.87),(2.105,4.87),(2.105,3.17),(1.975,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,3.17),(1.235,4.87),(1.465,4.87),(1.465,3.17),(1.235,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.145,4.57),(2.145,4.87),(2.445,4.87),(2.445,4.57),(2.145,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,3.17),(2.105,4.87),(2.335,4.87),(2.335,3.17),(2.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,3.17),(1.465,4.87),(1.595,4.87),(1.595,3.17),(1.465,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,3.17),(2.175,4.87),(2.445,4.87),(2.445,3.17),(2.175,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.395,4.87),(1.395,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.145,3.17),(2.145,4.87),(2.445,4.87),(2.445,3.17),(2.145,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.325,3.03),(1.325,4.63),(2.245,4.63),(2.245,3.03),(1.325,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,2.86),(0.925,5.18),(2.135,5.18),(2.135,2.86),(0.925,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,2.86),(1.865,5.18),(2.755,5.18),(2.755,2.86),(1.865,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.215,5.18),(2.215,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.03),(0.305,4.63),(1.225,4.63),(1.225,3.03),(0.305,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.705,5.18),(1.705,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,2.86),(0.305,5.18),(1.225,5.18),(1.225,2.86),(0.305,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.435,2.86),(1.435,5.18),(2.645,5.18),(2.645,2.86),(1.435,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.325,2.86),(1.325,5.18),(2.245,5.18),(2.245,2.86),(1.325,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,2.86),(0.815,5.18),(1.735,5.18),(1.735,2.86),(0.815,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.835,2.86),(1.835,5.18),(2.755,5.18),(2.755,2.86),(1.835,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.835,4.26),(1.835,5.18),(2.755,5.18),(2.755,4.26),(1.835,4.26)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.215,4.64),(2.215,4.8),(2.375,4.8),(2.375,4.64),(2.215,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.135,4.64),(2.135,4.8),(2.455,4.8),(2.455,4.64),(2.135,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.055,2.99),(1.055,5.05),(2.005,5.05),(2.005,2.99),(1.055,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.085,5.17),(2.085,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,2.87),(0.435,5.17),(1.095,5.17),(1.095,2.87),(0.435,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.965,4.27),(1.965,5.17),(2.625,5.17),(2.625,4.27),(1.965,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,2.87),(1.165,5.17),(1.895,5.17),(1.895,2.87),(1.165,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,2.87),(1.995,5.17),(2.625,5.17),(2.625,2.87),(1.995,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.455,3.04),(1.455,4.62),(2.115,4.62),(2.115,3.04),(1.455,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.455,2.87),(1.455,5.17),(2.115,5.17),(2.115,2.87),(1.455,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.04),(0.435,4.62),(1.095,4.62),(1.095,3.04),(0.435,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.565,2.99),(1.565,5.05),(2.515,5.05),(2.515,2.99),(1.565,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.675,2.87),(1.675,5.17),(2.405,5.17),(2.405,2.87),(1.675,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.575,5.17),(1.575,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,2.87),(0.945,5.17),(1.605,5.17),(1.605,2.87),(0.945,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.965,2.87),(1.965,5.17),(2.625,5.17),(2.625,2.87),(1.965,2.87)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,2.55),(1.825,2.55),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.905,4.87),(1.905,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,3.17),(1.745,4.87),(1.975,4.87),(1.975,3.17),(1.745,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.17),(0.615,4.87),(0.915,4.87),(0.915,3.17),(0.615,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,0.89),(1.745,2.55),(1.975,2.55),(1.975,0.89),(1.745,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.905,2.55),(1.905,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,1.42),(1.635,2.4),(1.935,2.4),(1.935,1.42),(1.635,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.55),(0.915,2.55),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,3.17),(1.595,4.87),(1.825,4.87),(1.825,3.17),(1.595,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,0.89),(1.635,2.55),(1.935,2.55),(1.935,0.89),(1.635,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,3.17),(1.635,4.87),(1.935,4.87),(1.935,3.17),(1.635,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,3.34),(1.635,4.32),(1.935,4.32),(1.935,3.34),(1.635,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.42),(0.615,2.4),(0.915,2.4),(0.915,1.42),(0.615,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.34),(0.615,4.32),(0.915,4.32),(0.915,3.34),(0.615,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.49),(0.685,1.65),(0.845,1.65),(0.845,1.49),(0.685,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.83),(0.685,1.99),(0.845,1.99),(0.845,1.83),(0.685,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,2.17),(0.685,2.33),(0.845,2.33),(0.845,2.17),(0.685,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,1.49),(1.705,1.65),(1.865,1.65),(1.865,1.49),(1.705,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,1.83),(1.705,1.99),(1.865,1.99),(1.865,1.83),(1.705,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,2.17),(1.705,2.33),(1.865,2.33),(1.865,2.17),(1.705,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.41),(0.685,3.57),(0.845,3.57),(0.845,3.41),(0.685,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.75),(0.685,3.91),(0.845,3.91),(0.845,3.75),(0.685,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.09),(0.685,4.25),(0.845,4.25),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,3.41),(1.705,3.57),(1.865,3.57),(1.865,3.41),(1.705,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,3.75),(1.705,3.91),(1.865,3.91),(1.865,3.75),(1.705,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,4.09),(1.705,4.25),(1.865,4.25),(1.865,4.09),(1.705,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,1.34),(1.705,2.48),(1.865,2.48),(1.865,1.34),(1.705,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,3.33),(1.705,4.33),(1.865,4.33),(1.865,3.33),(1.705,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,1.41),(1.705,2.41),(1.865,2.41),(1.865,1.41),(1.705,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.33),(0.685,4.33),(0.845,4.33),(0.845,3.33),(0.685,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,3.24),(1.705,4.42),(1.865,4.42),(1.865,3.24),(1.705,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.68,2.7),(1.68,3.02),(1.89,3.02),(1.89,2.7),(1.68,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,2.7),(0.765,3.02),(1.785,3.02),(1.785,2.7),(0.765,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.68,2.16),(1.68,3.56),(1.89,3.56),(1.89,2.16),(1.68,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.48),(0.845,2.48),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,1.34),(0.66,4.42),(0.87,4.42),(0.87,1.34),(0.66,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.41),(0.685,2.41),(0.845,2.41),(0.845,1.41),(0.685,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.24),(0.685,4.42),(0.845,4.42),(0.845,3.24),(0.685,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.66,2.7),(0.66,3.02),(0.87,3.02),(0.87,2.7),(0.66,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.765), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(2.04,3.01),(2.04,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,2.99),(2.105,2.99),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,2.73),(2.105,2.73),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,2.99),(1.975,5.05),(2.105,5.05),(2.105,2.99),(1.975,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,2.99),(1.465,5.05),(1.595,5.05),(1.595,2.99),(1.465,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.99),(1.595,2.99),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.73),(1.595,2.73),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_i_n': Net.create(cell, '_i_n'),
            'i': Net.create(cell, 'i'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_i_n']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.35),(0.15,4.41),(0.36,4.41),(0.36,1.35),(0.15,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(1.08,3.01),(1.08,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,2.28),(1.145,2.28),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,3.44),(1.145,3.44),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,3.44),(1.015,5.05),(1.145,5.05),(1.145,3.44),(1.015,3.44)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.035,3.32),(1.035,5.17),(1.665,5.17),(1.665,3.32),(1.035,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.32),(0.465,5.17),(1.125,5.17),(1.125,3.32),(0.465,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,4.27),(0.465,5.17),(1.125,5.17),(1.125,4.27),(0.465,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.605,3.44),(0.605,5.05),(1.555,5.05),(1.555,3.44),(0.605,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.715,3.32),(0.715,5.17),(1.445,5.17),(1.445,3.32),(0.715,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.65),(1.005,4.55),(1.665,4.55),(1.665,3.65),(1.005,3.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.32),(1.005,5.17),(1.665,5.17),(1.665,3.32),(1.005,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.32),(0.465,5.17),(1.125,5.17),(1.125,3.32),(0.465,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.335,3.31),(0.335,5.18),(1.255,5.18),(1.255,3.31),(0.335,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,4.26),(0.335,5.18),(1.255,5.18),(1.255,4.26),(0.335,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.475,3.31),(0.475,5.18),(1.685,5.18),(1.685,3.31),(0.475,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.31),(0.335,5.18),(1.255,5.18),(1.255,3.31),(0.335,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.905,3.31),(0.905,5.18),(1.795,5.18),(1.795,3.31),(0.905,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.64),(0.875,4.56),(1.795,4.56),(1.795,3.64),(0.875,3.64)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.31),(0.875,5.18),(1.795,5.18),(1.795,3.31),(0.875,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,3.62),(0.785,4.87),(1.015,4.87),(1.015,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.57),(0.645,4.87),(0.945,4.87),(0.945,4.57),(0.645,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,3.62),(1.015,4.87),(1.145,4.87),(1.145,3.62),(1.015,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.62),(0.645,4.87),(0.945,4.87),(0.945,3.62),(0.645,3.62)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.715,4.64),(0.715,4.8),(0.875,4.8),(0.875,4.64),(0.715,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.635,4.64),(0.635,4.8),(0.955,4.8),(0.955,4.64),(0.635,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.1),(0.945,2.1),(0.945,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,0.89),(1.015,2.1),(1.145,2.1),(1.145,0.89),(1.015,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,0.89),(0.785,2.1),(1.015,2.1),(1.015,0.89),(0.785,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.19),(0.945,1.19),(0.945,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.715,0.96),(0.715,1.12),(0.875,1.12),(0.875,0.96),(0.715,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.635,0.96),(0.635,1.12),(0.955,1.12),(0.955,0.96),(0.635,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.47),(0.575,2.47),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.17),(0.51,2.47),(0.685,2.47),(0.685,2.17),(0.51,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.17),(0.535,2.47),(0.835,2.47),(0.835,2.17),(0.535,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,3.25),(0.51,3.55),(0.685,3.55),(0.685,3.25),(0.51,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.25),(0.535,3.55),(0.835,3.55),(0.835,3.25),(0.535,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.25),(0.445,5.05),(0.575,5.05),(0.575,3.25),(0.445,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.24),(0.605,2.4),(0.765,2.4),(0.765,2.24),(0.605,2.24)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.32),(0.605,3.48),(0.765,3.48),(0.765,3.32),(0.605,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.24),(0.605,3.56),(0.765,3.56),(0.765,3.24),(0.605,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.16),(0.605,2.48),(0.765,2.48),(0.765,2.16),(0.605,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((1.215,0.89),(1.215,2.1),(1.485,2.1),(1.485,0.89),(1.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,2.1),(1.485,2.1),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,3.62),(1.145,4.87),(1.375,4.87),(1.375,3.62),(1.145,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.215,3.62),(1.215,4.87),(1.485,4.87),(1.485,3.62),(1.215,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.95),(1.185,4.25),(1.485,4.25),(1.485,3.95),(1.185,3.95)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.62),(1.185,4.87),(1.485,4.87),(1.485,3.62),(1.185,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,0.89),(1.145,2.1),(1.375,2.1),(1.375,0.89),(1.145,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.49),(1.185,1.79),(1.485,1.79),(1.485,1.49),(1.185,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.02),(1.255,4.18),(1.415,4.18),(1.415,4.02),(1.255,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.56),(1.255,1.72),(1.415,1.72),(1.415,1.56),(1.255,1.56)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.78),(1.255,4.42),(1.415,4.42),(1.415,3.78),(1.255,3.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,1.94),(1.415,1.94),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.48),(1.255,1.8),(1.415,1.8),(1.415,1.48),(1.255,1.48)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.34),(1.23,4.42),(1.44,4.42),(1.44,1.34),(1.23,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.94),(1.255,4.26),(1.415,4.26),(1.415,3.94),(1.255,3.94)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x2']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.4000000000000004), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_i_n': Net.create(cell, '_i_n'),
            'i': Net.create(cell, 'i'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_i_n']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.35),(0.15,4.41),(0.36,4.41),(0.36,1.35),(0.15,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,3.44),(1.655,3.44),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,2.28),(1.145,2.28),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,3.44),(1.145,3.44),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,3.44),(1.525,5.05),(1.655,5.05),(1.655,3.44),(1.525,3.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(1.59,3.01),(1.59,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,3.44),(1.015,5.05),(1.145,5.05),(1.145,3.44),(1.015,3.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,2.28),(1.655,2.28),(1.655,0.71),(1.525,0.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.605,3.44),(0.605,5.05),(1.555,5.05),(1.555,3.44),(0.605,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.715,3.32),(0.715,5.17),(1.445,5.17),(1.445,3.32),(0.715,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.32),(0.465,5.17),(1.125,5.17),(1.125,3.32),(0.465,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.32),(1.005,5.17),(1.665,5.17),(1.665,3.32),(1.005,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,4.27),(1.515,5.17),(2.175,5.17),(2.175,4.27),(1.515,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.225,3.32),(1.225,5.17),(1.955,5.17),(1.955,3.32),(1.225,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.035,3.32),(1.035,5.17),(1.635,5.17),(1.635,3.32),(1.035,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.115,3.44),(1.115,5.05),(2.065,5.05),(2.065,3.44),(1.115,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.32),(1.515,5.17),(2.175,5.17),(2.175,3.32),(1.515,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.02,-0.075),(0.02,0.585),(2.38,0.585),(2.38,-0.075),(0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(2.475,5.17),(2.475,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.545,3.32),(1.545,5.17),(2.175,5.17),(2.175,3.32),(1.545,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.32),(0.465,5.17),(1.125,5.17),(1.125,3.32),(0.465,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,4.27),(0.465,5.17),(1.125,5.17),(1.125,4.27),(0.465,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.65),(1.005,4.55),(1.665,4.55),(1.665,3.65),(1.005,3.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.475,0.585),(2.475,-0.075),(-0.075,-0.075)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.335,3.31),(0.335,5.18),(1.255,5.18),(1.255,3.31),(0.335,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.11,5.045),(-0.11,5.965),(2.51,5.965),(2.51,5.045),(-0.11,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.905,3.31),(0.905,5.18),(1.765,5.18),(1.765,3.31),(0.905,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(2.605,5.965),(2.605,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,4.26),(1.385,5.18),(2.305,5.18),(2.305,4.26),(1.385,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(2.71,6.07),(2.71,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.985,3.31),(0.985,5.18),(2.195,5.18),(2.195,3.31),(0.985,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,4.26),(0.335,5.18),(1.255,5.18),(1.255,4.26),(0.335,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.475,3.31),(0.475,5.18),(1.685,5.18),(1.685,3.31),(0.475,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.31),(1.385,5.18),(2.305,5.18),(2.305,3.31),(1.385,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.31),(0.335,5.18),(1.255,5.18),(1.255,3.31),(0.335,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.64),(0.875,4.56),(1.795,4.56),(1.795,3.64),(0.875,3.64)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.31),(0.875,5.18),(1.795,5.18),(1.795,3.31),(0.875,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.415,3.31),(1.415,5.18),(2.305,5.18),(2.305,3.31),(1.415,3.31)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,3.62),(1.525,4.87),(1.655,4.87),(1.655,3.62),(1.525,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,3.62),(0.785,4.87),(1.015,4.87),(1.015,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.62),(1.695,4.87),(1.995,4.87),(1.995,3.62),(1.695,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.57),(0.645,4.87),(0.945,4.87),(0.945,4.57),(0.645,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,5.355),(0.2,5.655),(2.2,5.655),(2.2,5.355),(0.2,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(2.295,5.655),(2.295,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,3.62),(1.015,4.87),(1.145,4.87),(1.145,3.62),(1.015,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.57),(1.695,4.87),(1.995,4.87),(1.995,4.57),(1.695,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,3.62),(1.725,4.87),(1.995,4.87),(1.995,3.62),(1.725,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,3.62),(1.655,4.87),(1.885,4.87),(1.885,3.62),(1.655,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.62),(0.645,4.87),(0.945,4.87),(0.945,3.62),(0.645,3.62)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,5.425),(0.27,5.585),(0.43,5.585),(0.43,5.425),(0.27,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,5.425),(0.61,5.585),(0.77,5.585),(0.77,5.425),(0.61,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,5.425),(0.95,5.585),(1.11,5.585),(1.11,5.425),(0.95,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,5.425),(1.29,5.585),(1.45,5.585),(1.45,5.425),(1.29,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,5.425),(1.63,5.585),(1.79,5.585),(1.79,5.425),(1.63,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,5.425),(1.97,5.585),(2.13,5.585),(2.13,5.425),(1.97,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.715,4.64),(0.715,4.8),(0.875,4.8),(0.875,4.64),(0.715,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.64),(1.765,4.8),(1.925,4.8),(1.925,4.64),(1.765,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,5.345),(0.27,5.665),(2.13,5.665),(2.13,5.345),(0.27,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(2.4,5.76),(2.4,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.635,4.64),(0.635,4.8),(0.955,4.8),(0.955,4.64),(0.635,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.685,4.64),(1.685,4.8),(2.005,4.8),(2.005,4.64),(1.685,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.1),(0.945,2.1),(0.945,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,0.89),(1.655,2.1),(1.885,2.1),(1.885,0.89),(1.655,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,0.89),(1.015,2.1),(1.145,2.1),(1.145,0.89),(1.015,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,1.19),(1.995,1.19),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,0.89),(0.785,2.1),(1.015,2.1),(1.015,0.89),(0.785,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,0.105),(0.2,0.405),(2.2,0.405),(2.2,0.105),(0.2,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.19),(0.945,1.19),(0.945,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.89),(1.725,2.1),(1.995,2.1),(1.995,0.89),(1.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.295,0.405),(2.295,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,2.1),(1.995,2.1),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,0.89),(1.525,2.1),(1.655,2.1),(1.655,0.89),(1.525,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,0.175),(0.27,0.335),(0.43,0.335),(0.43,0.175),(0.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,0.175),(0.61,0.335),(0.77,0.335),(0.77,0.175),(0.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,0.175),(0.95,0.335),(1.11,0.335),(1.11,0.175),(0.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,0.175),(1.29,0.335),(1.45,0.335),(1.45,0.175),(1.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,0.175),(1.63,0.335),(1.79,0.335),(1.79,0.175),(1.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,0.175),(1.97,0.335),(2.13,0.335),(2.13,0.175),(1.97,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.715,0.96),(0.715,1.12),(0.875,1.12),(0.875,0.96),(0.715,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,0.96),(1.765,1.12),(1.925,1.12),(1.925,0.96),(1.765,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(2.4,1.12),(2.4,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.685,0.96),(1.685,1.12),(2.005,1.12),(2.005,0.96),(1.685,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,0.095),(0.27,0.415),(2.13,0.415),(2.13,0.095),(0.27,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.635,0.96),(0.635,1.12),(0.955,1.12),(0.955,0.96),(0.635,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.47),(0.575,2.47),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.17),(0.51,2.47),(0.685,2.47),(0.685,2.17),(0.51,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.17),(0.535,2.47),(0.835,2.47),(0.835,2.17),(0.535,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,3.25),(0.51,3.55),(0.685,3.55),(0.685,3.25),(0.51,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.25),(0.535,3.55),(0.835,3.55),(0.835,3.25),(0.535,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.25),(0.445,5.05),(0.575,5.05),(0.575,3.25),(0.445,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.24),(0.605,2.4),(0.765,2.4),(0.765,2.24),(0.605,2.24)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.32),(0.605,3.48),(0.765,3.48),(0.765,3.32),(0.605,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.24),(0.605,3.56),(0.765,3.56),(0.765,3.24),(0.605,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.16),(0.605,2.48),(0.765,2.48),(0.765,2.16),(0.605,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((1.295,0.89),(1.295,2.1),(1.525,2.1),(1.525,0.89),(1.295,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,3.62),(1.295,4.87),(1.525,4.87),(1.525,3.62),(1.295,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,2.1),(1.485,2.1),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,3.62),(1.145,4.87),(1.375,4.87),(1.375,3.62),(1.145,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.215,0.89),(1.215,2.1),(1.455,2.1),(1.455,0.89),(1.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.215,3.62),(1.215,4.87),(1.455,4.87),(1.455,3.62),(1.215,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.95),(1.185,4.25),(1.485,4.25),(1.485,3.95),(1.185,3.95)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.62),(1.185,4.87),(1.485,4.87),(1.485,3.62),(1.185,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,0.89),(1.145,2.1),(1.375,2.1),(1.375,0.89),(1.145,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.49),(1.185,1.79),(1.485,1.79),(1.485,1.49),(1.185,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.02),(1.255,4.18),(1.415,4.18),(1.415,4.02),(1.255,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.56),(1.255,1.72),(1.415,1.72),(1.415,1.56),(1.255,1.56)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.78),(1.255,4.42),(1.415,4.42),(1.415,3.78),(1.255,3.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,1.94),(1.415,1.94),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.48),(1.255,1.8),(1.415,1.8),(1.415,1.48),(1.255,1.48)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.34),(1.23,4.42),(1.44,4.42),(1.44,1.34),(1.23,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.94),(1.255,4.26),(1.415,4.26),(1.415,3.94),(1.255,3.94)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['buf_x4']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_i_n': Net.create(cell, '_i_n'),
            'i': Net.create(cell, 'i'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_i_n']
        createRL(
            tech, net, 'Activ',
            ((0.105,3.62),(0.105,4.87),(0.375,4.87),(0.375,3.62),(0.105,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.1),(0.405,2.1),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.1),(0.445,2.1),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.49),(0.105,1.79),(0.405,1.79),(0.405,1.49),(0.105,1.49)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.1),(0.375,2.1),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.95),(0.105,4.25),(0.405,4.25),(0.405,3.95),(0.105,3.95)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.62),(0.215,4.87),(0.445,4.87),(0.445,3.62),(0.215,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.62),(0.105,4.87),(0.405,4.87),(0.405,3.62),(0.105,3.62)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.56),(0.175,1.72),(0.335,1.72),(0.335,1.56),(0.175,1.56)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.02),(0.175,4.18),(0.335,4.18),(0.335,4.02),(0.175,4.02)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.78),(0.175,4.42),(0.335,4.42),(0.335,3.78),(0.175,3.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.62),(0.15,4.1),(0.36,4.1),(0.36,1.62),(0.15,1.62)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.94),(0.175,4.26),(0.335,4.26),(0.335,3.94),(0.175,3.94)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.94),(0.335,1.94),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.48),(0.175,1.8),(0.335,1.8),(0.335,1.48),(0.175,1.48)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,3.44),(1.655,3.44),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,3.44),(2.545,5.05),(2.675,5.05),(2.675,3.44),(2.545,3.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,2.28),(1.145,2.28),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,3.44),(2.165,3.44),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,3.44),(1.145,3.44),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.44),(2.035,5.05),(2.165,5.05),(2.165,3.44),(2.035,3.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,3.44),(1.525,5.05),(1.655,5.05),(1.655,3.44),(1.525,3.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,2.28),(2.165,2.28),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,3.44),(1.015,5.05),(1.145,5.05),(1.145,3.44),(1.015,3.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,2.28),(1.655,2.28),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,2.28),(2.675,2.28),(2.675,0.71),(2.545,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,3.44),(2.675,3.44),(2.675,0.71),(2.545,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(2.61,3.01),(2.61,2.71),(0.255,2.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((2.025,3.65),(2.025,4.55),(2.685,4.55),(2.685,3.65),(2.025,3.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.32),(2.535,5.17),(3.195,5.17),(3.195,3.32),(2.535,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.565,3.32),(2.565,5.17),(3.195,5.17),(3.195,3.32),(2.565,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.605,3.44),(0.605,5.05),(1.555,5.05),(1.555,3.44),(0.605,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.27),(2.535,5.17),(3.195,5.17),(3.195,4.27),(2.535,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.32),(0.465,5.17),(1.125,5.17),(1.125,3.32),(0.465,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.715,3.32),(0.715,5.17),(1.445,5.17),(1.445,3.32),(0.715,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,4.27),(1.515,5.17),(2.175,5.17),(2.175,4.27),(1.515,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.32),(-0.075,5.17),(0.585,5.17),(0.585,3.32),(-0.075,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.44),(0.035,5.05),(0.985,5.05),(0.985,3.44),(0.035,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.32),(2.025,5.17),(2.685,5.17),(2.685,3.32),(2.025,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.32),(-0.075,5.17),(0.555,5.17),(0.555,3.32),(-0.075,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.225,3.32),(1.225,5.17),(1.955,5.17),(1.955,3.32),(1.225,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.65),(-0.075,4.55),(0.585,4.55),(0.585,3.65),(-0.075,3.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.245,3.32),(2.245,5.17),(2.975,5.17),(2.975,3.32),(2.245,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.115,3.44),(1.115,5.05),(2.065,5.05),(2.065,3.44),(1.115,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.035,3.32),(1.035,5.17),(1.635,5.17),(1.635,3.32),(1.035,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.32),(1.515,5.17),(2.175,5.17),(2.175,3.32),(1.515,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.545,3.32),(1.545,5.17),(2.145,5.17),(2.145,3.32),(1.545,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.625,3.44),(1.625,5.05),(2.575,5.05),(2.575,3.44),(1.625,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.32),(0.435,5.17),(1.095,5.17),(1.095,3.32),(0.435,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.055,3.32),(2.055,5.17),(2.655,5.17),(2.655,3.32),(2.055,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.32),(0.145,5.17),(0.875,5.17),(0.875,3.32),(0.145,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.135,3.44),(2.135,5.05),(3.085,5.05),(3.085,3.44),(2.135,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.32),(1.735,5.17),(2.465,5.17),(2.465,3.32),(1.735,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.32),(1.005,5.17),(1.665,5.17),(1.665,3.32),(1.005,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.65),(1.005,4.55),(1.665,4.55),(1.665,3.65),(1.005,3.65)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((1.895,3.31),(1.895,5.18),(2.815,5.18),(2.815,3.31),(1.895,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.64),(1.895,4.56),(2.815,4.56),(2.815,3.64),(1.895,3.64)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.495,3.31),(1.495,5.18),(2.705,5.18),(2.705,3.31),(1.495,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.31),(0.335,5.18),(1.255,5.18),(1.255,3.31),(0.335,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.925,3.31),(1.925,5.18),(2.785,5.18),(2.785,3.31),(1.925,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.64),(-0.205,4.56),(0.715,4.56),(0.715,3.64),(-0.205,3.64)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.435,3.31),(2.435,5.18),(3.325,5.18),(3.325,3.31),(2.435,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,4.26),(1.385,5.18),(2.305,5.18),(2.305,4.26),(1.385,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.31),(-0.205,5.18),(0.685,5.18),(0.685,3.31),(-0.205,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.31),(1.385,5.18),(2.305,5.18),(2.305,3.31),(1.385,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.005,3.31),(2.005,5.18),(3.215,5.18),(3.215,3.31),(2.005,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.905,3.31),(0.905,5.18),(1.765,5.18),(1.765,3.31),(0.905,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.415,3.31),(1.415,5.18),(2.275,5.18),(2.275,3.31),(1.415,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.31),(0.305,5.18),(1.225,5.18),(1.225,3.31),(0.305,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.475,3.31),(0.475,5.18),(1.685,5.18),(1.685,3.31),(0.475,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,3.31),(2.405,5.18),(3.325,5.18),(3.325,3.31),(2.405,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.31),(-0.205,5.18),(0.715,5.18),(0.715,3.31),(-0.205,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.985,3.31),(0.985,5.18),(2.195,5.18),(2.195,3.31),(0.985,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,4.26),(2.405,5.18),(3.325,5.18),(3.325,4.26),(2.405,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.31),(-0.095,5.18),(1.115,5.18),(1.115,3.31),(-0.095,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.31),(0.875,5.18),(1.795,5.18),(1.795,3.31),(0.875,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.64),(0.875,4.56),(1.795,4.56),(1.795,3.64),(0.875,3.64)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,3.62),(1.525,4.87),(1.655,4.87),(1.655,3.62),(1.525,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.62),(1.695,4.87),(1.995,4.87),(1.995,3.62),(1.695,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,3.62),(2.035,4.87),(2.165,4.87),(2.165,3.62),(2.035,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.57),(1.695,4.87),(1.995,4.87),(1.995,4.57),(1.695,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.62),(0.615,4.87),(0.915,4.87),(0.915,3.62),(0.615,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.675,3.62),(2.675,4.87),(2.905,4.87),(2.905,3.62),(2.675,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,3.62),(2.715,4.87),(3.015,4.87),(3.015,3.62),(2.715,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.62),(0.645,4.87),(0.945,4.87),(0.945,3.62),(0.645,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.62),(0.575,4.87),(0.805,4.87),(0.805,3.62),(0.575,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,4.57),(2.715,4.87),(3.015,4.87),(3.015,4.57),(2.715,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.62),(0.445,4.87),(0.575,4.87),(0.575,3.62),(0.445,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,3.62),(2.745,4.87),(3.015,4.87),(3.015,3.62),(2.745,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,3.62),(2.545,4.87),(2.675,4.87),(2.675,3.62),(2.545,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,3.62),(1.655,4.87),(1.885,4.87),(1.885,3.62),(1.655,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,3.62),(1.725,4.87),(1.965,4.87),(1.965,3.62),(1.725,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,3.62),(0.785,4.87),(1.015,4.87),(1.015,3.62),(0.785,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,3.62),(1.805,4.87),(2.035,4.87),(2.035,3.62),(1.805,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,3.62),(1.015,4.87),(1.145,4.87),(1.145,3.62),(1.015,3.62)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.64),(1.765,4.8),(1.925,4.8),(1.925,4.64),(1.765,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,4.64),(2.785,4.8),(2.945,4.8),(2.945,4.64),(2.785,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.705,4.64),(2.705,4.8),(3.025,4.8),(3.025,4.64),(2.705,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.685,4.64),(1.685,4.8),(2.005,4.8),(2.005,4.64),(1.685,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.655,0.89),(1.655,2.1),(1.885,2.1),(1.885,0.89),(1.655,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,0.89),(2.035,2.1),(2.165,2.1),(2.165,0.89),(2.035,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.89),(1.725,2.1),(1.965,2.1),(1.965,0.89),(1.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,1.19),(3.015,1.19),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,2.1),(1.995,2.1),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.1),(0.575,2.1),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,0.89),(2.545,2.1),(2.675,2.1),(2.675,0.89),(2.545,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,1.19),(1.995,1.19),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.675,0.89),(2.675,2.1),(2.905,2.1),(2.905,0.89),(2.675,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.1),(0.915,2.1),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,0.89),(1.525,2.1),(1.655,2.1),(1.655,0.89),(1.525,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.1),(0.805,2.1),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.1),(0.945,2.1),(0.945,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,0.89),(1.015,2.1),(1.145,2.1),(1.145,0.89),(1.015,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,0.89),(1.805,2.1),(2.035,2.1),(2.035,0.89),(1.805,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,0.89),(0.785,2.1),(1.015,2.1),(1.015,0.89),(0.785,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,2.1),(3.015,2.1),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,0.89),(2.745,2.1),(3.015,2.1),(3.015,0.89),(2.745,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,0.96),(2.785,1.12),(2.945,1.12),(2.945,0.96),(2.785,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,0.96),(1.765,1.12),(1.925,1.12),(1.925,0.96),(1.765,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.705,0.96),(2.705,1.12),(3.025,1.12),(3.025,0.96),(2.705,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.685,0.96),(1.685,1.12),(2.005,1.12),(2.005,0.96),(1.685,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.28),(0.575,2.28),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.17),(0.51,2.47),(0.685,2.47),(0.685,2.17),(0.51,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.17),(0.535,2.47),(0.835,2.47),(0.835,2.17),(0.535,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,3.25),(0.51,3.55),(0.685,3.55),(0.685,3.25),(0.51,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.25),(0.445,5.05),(0.575,5.05),(0.575,3.25),(0.445,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.25),(0.535,3.55),(0.835,3.55),(0.835,3.25),(0.535,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.47),(0.575,2.47),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.44),(0.445,5.05),(0.575,5.05),(0.575,3.44),(0.445,3.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.24),(0.605,2.4),(0.765,2.4),(0.765,2.24),(0.605,2.24)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.32),(0.605,3.48),(0.765,3.48),(0.765,3.32),(0.605,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.24),(0.605,3.56),(0.765,3.56),(0.765,3.24),(0.605,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.16),(0.605,2.48),(0.765,2.48),(0.765,2.16),(0.605,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((2.235,0.89),(2.235,2.1),(2.475,2.1),(2.475,0.89),(2.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,0.89),(1.295,2.1),(1.525,2.1),(1.525,0.89),(1.295,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,0.89),(2.165,2.1),(2.395,2.1),(2.395,0.89),(2.165,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.62),(2.205,4.87),(2.505,4.87),(2.505,3.62),(2.205,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.315,0.89),(2.315,2.1),(2.545,2.1),(2.545,0.89),(2.315,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,3.62),(1.145,4.87),(1.375,4.87),(1.375,3.62),(1.145,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.215,0.89),(1.215,2.1),(1.455,2.1),(1.455,0.89),(1.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.62),(1.185,4.87),(1.485,4.87),(1.485,3.62),(1.185,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,3.62),(2.235,4.87),(2.475,4.87),(2.475,3.62),(2.235,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,2.1),(2.505,2.1),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,2.1),(1.485,2.1),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.215,3.62),(1.215,4.87),(1.455,4.87),(1.455,3.62),(1.215,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.95),(2.205,4.25),(2.505,4.25),(2.505,3.95),(2.205,3.95)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.95),(1.185,4.25),(1.485,4.25),(1.485,3.95),(1.185,3.95)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,0.89),(1.145,2.1),(1.375,2.1),(1.375,0.89),(1.145,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,1.49),(2.205,1.79),(2.505,1.79),(2.505,1.49),(2.205,1.49)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.315,3.62),(2.315,4.87),(2.545,4.87),(2.545,3.62),(2.315,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.49),(1.185,1.79),(1.485,1.79),(1.485,1.49),(1.185,1.49)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,3.62),(1.295,4.87),(1.525,4.87),(1.525,3.62),(1.295,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,3.62),(2.165,4.87),(2.395,4.87),(2.395,3.62),(2.165,3.62)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.02),(2.275,4.18),(2.435,4.18),(2.435,4.02),(2.275,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.56),(2.275,1.72),(2.435,1.72),(2.435,1.56),(2.275,1.56)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.02),(1.255,4.18),(1.415,4.18),(1.415,4.02),(1.255,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.56),(1.255,1.72),(1.415,1.72),(1.415,1.56),(1.255,1.56)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.78),(1.255,4.42),(1.415,4.42),(1.415,3.78),(1.255,3.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,3.94),(2.275,4.26),(2.435,4.26),(2.435,3.94),(2.275,3.94)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,1.62),(2.25,4.1),(2.46,4.1),(2.46,1.62),(2.25,1.62)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,1.94),(1.415,1.94),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(2.355,3.02),(2.355,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.48),(2.275,1.8),(2.435,1.8),(2.435,1.48),(2.275,1.48)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,2.7),(2.25,3.02),(2.46,3.02),(2.46,2.7),(2.25,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.34),(2.275,1.94),(2.435,1.94),(2.435,1.34),(2.275,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.48),(1.255,1.8),(1.415,1.8),(1.415,1.48),(1.255,1.48)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,2.7),(1.23,3.02),(1.44,3.02),(1.44,2.7),(1.23,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.34),(1.23,4.42),(1.44,4.42),(1.44,1.34),(1.23,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,3.78),(2.275,4.42),(2.435,4.42),(2.435,3.78),(2.275,3.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.94),(1.255,4.26),(1.415,4.26),(1.415,3.94),(1.255,3.94)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['nand2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.09),(1.185,4.87),(1.485,4.87),(1.485,4.09),(1.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.485,4.87),(1.485,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.57),(1.185,4.87),(1.485,4.87),(1.485,4.57),(1.185,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,4.26),(0.875,5.18),(1.795,5.18),(1.795,4.26),(0.875,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.795,5.18),(1.795,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.79),(0.305,4.71),(1.225,4.71),(1.225,3.79),(0.305,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.78),(0.875,5.18),(1.795,5.18),(1.795,3.78),(0.875,3.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.64),(1.255,4.8),(1.415,4.8),(1.415,4.64),(1.255,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.175,4.64),(1.175,4.8),(1.495,4.8),(1.495,4.64),(1.175,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,4.27),(1.005,5.17),(1.665,5.17),(1.665,4.27),(1.005,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.665,5.17),(1.665,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.8),(0.435,4.7),(1.095,4.7),(1.095,3.8),(0.435,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.79),(1.005,5.17),(1.665,5.17),(1.665,3.79),(1.005,3.79)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,1.67),(0.95,1.67),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.485,1.67),(1.485,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.1),(0.615,4.4),(0.915,4.4),(0.915,4.1),(0.615,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.36),(1.185,1.66),(1.485,1.66),(1.485,1.36),(1.185,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,1.67),(1.485,1.67),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.43),(1.255,1.59),(1.415,1.59),(1.415,1.43),(1.255,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.17),(0.685,4.33),(0.845,4.33),(0.845,4.17),(0.685,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,4.09),(1.23,4.41),(1.44,4.41),(1.44,4.09),(1.23,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.42),(0.845,4.42),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.41),(0.845,4.41),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.35),(1.255,1.67),(1.415,1.67),(1.415,1.35),(1.255,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,4.09),(0.765,4.42),(1.335,4.42),(1.335,4.09),(0.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,1.67),(1.415,1.67),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.34),(1.23,4.42),(1.44,4.42),(1.44,1.34),(1.23,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.34),(0.8,3.87),(1.01,3.87),(1.01,1.34),(0.8,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nand2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.57),(1.185,4.87),(1.485,4.87),(1.485,4.57),(1.185,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.485,4.87),(1.485,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.17),(1.185,4.87),(1.485,4.87),(1.485,3.17),(1.185,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,2.86),(0.875,5.18),(1.795,5.18),(1.795,2.86),(0.875,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,4.26),(0.875,5.18),(1.795,5.18),(1.795,4.26),(0.875,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.795,5.18),(1.795,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.03),(0.305,4.63),(1.225,4.63),(1.225,3.03),(0.305,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,2.86),(0.305,5.18),(1.225,5.18),(1.225,2.86),(0.305,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.64),(1.255,4.8),(1.415,4.8),(1.415,4.64),(1.255,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.175,4.64),(1.175,4.8),(1.495,4.8),(1.495,4.64),(1.175,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,4.27),(1.005,5.17),(1.665,5.17),(1.665,4.27),(1.005,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.04),(0.435,4.62),(1.095,4.62),(1.095,3.04),(0.435,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.665,5.17),(1.665,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,2.87),(0.435,5.17),(1.095,5.17),(1.095,2.87),(0.435,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,2.87),(1.005,5.17),(1.665,5.17),(1.665,2.87),(1.005,2.87)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,2.55),(0.95,2.55),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.34),(0.615,4.32),(0.915,4.32),(0.915,3.34),(0.615,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.485,2.55),(1.485,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.42),(1.185,2.4),(1.485,2.4),(1.485,1.42),(1.185,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,2.55),(1.485,2.55),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.17),(0.615,4.87),(0.915,4.87),(0.915,3.17),(0.615,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.41),(0.685,3.57),(0.845,3.57),(0.845,3.41),(0.685,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.75),(0.685,3.91),(0.845,3.91),(0.845,3.75),(0.685,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.09),(0.685,4.25),(0.845,4.25),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.49),(1.255,1.65),(1.415,1.65),(1.415,1.49),(1.255,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.83),(1.255,1.99),(1.415,1.99),(1.415,1.83),(1.255,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,2.17),(1.255,2.33),(1.415,2.33),(1.415,2.17),(1.255,2.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.33),(0.685,4.33),(0.845,4.33),(0.845,3.33),(0.685,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,3.24),(0.765,4.42),(1.335,4.42),(1.335,3.24),(0.765,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,2.48),(1.415,2.48),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,3.24),(1.23,3.56),(1.44,3.56),(1.44,3.24),(1.23,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.34),(1.23,4.42),(1.44,4.42),(1.44,1.34),(1.23,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.41),(1.255,2.41),(1.415,2.41),(1.415,1.41),(1.255,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.24),(0.685,4.42),(0.845,4.42),(0.845,3.24),(0.685,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.34),(0.8,3.02),(1.01,3.02),(1.01,1.34),(0.8,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nand3_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.4000000000000004), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.295,0.405),(2.295,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,0.105),(0.2,0.405),(2.2,0.405),(2.2,0.105),(0.2,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,0.175),(0.27,0.335),(0.43,0.335),(0.43,0.175),(0.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,0.175),(0.61,0.335),(0.77,0.335),(0.77,0.175),(0.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,0.175),(0.95,0.335),(1.11,0.335),(1.11,0.175),(0.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,0.175),(1.29,0.335),(1.45,0.335),(1.45,0.175),(1.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,0.175),(1.63,0.335),(1.79,0.335),(1.79,0.175),(1.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,0.175),(1.97,0.335),(2.13,0.335),(2.13,0.175),(1.97,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(2.4,1.12),(2.4,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,0.095),(0.27,0.415),(2.13,0.415),(2.13,0.095),(0.27,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.09),(1.125,4.87),(1.425,4.87),(1.425,4.09),(1.125,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,5.355),(0.2,5.655),(2.2,5.655),(2.2,5.355),(0.2,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(2.295,5.655),(2.295,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,3.78),(0.815,5.18),(1.735,5.18),(1.735,3.78),(0.815,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.79),(1.385,4.71),(2.305,4.71),(2.305,3.79),(1.385,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.11,5.045),(-0.11,5.965),(2.51,5.965),(2.51,5.045),(-0.11,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(2.605,5.965),(2.605,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.79),(0.305,4.71),(1.225,4.71),(1.225,3.79),(0.305,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(2.71,6.07),(2.71,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.78),(1.385,5.18),(2.305,5.18),(2.305,3.78),(1.385,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.305,5.18),(2.305,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,5.425),(0.27,5.585),(0.43,5.585),(0.43,5.425),(0.27,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,5.425),(0.61,5.585),(0.77,5.585),(0.77,5.425),(0.61,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,5.425),(0.95,5.585),(1.11,5.585),(1.11,5.425),(0.95,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,5.425),(1.29,5.585),(1.45,5.585),(1.45,5.425),(1.29,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,5.425),(1.63,5.585),(1.79,5.585),(1.79,5.425),(1.63,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,5.425),(1.97,5.585),(2.13,5.585),(2.13,5.425),(1.97,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,5.345),(0.27,5.665),(2.13,5.665),(2.13,5.345),(0.27,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(2.4,5.76),(2.4,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.8),(0.435,4.7),(1.095,4.7),(1.095,3.8),(0.435,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.8),(1.515,4.7),(2.175,4.7),(2.175,3.8),(1.515,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.79),(1.515,5.17),(2.175,5.17),(2.175,3.79),(1.515,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,3.79),(0.945,5.17),(1.605,5.17),(1.605,3.79),(0.945,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.02,-0.075),(0.02,0.585),(2.38,0.585),(2.38,-0.075),(0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(2.475,5.17),(2.475,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.175,5.17),(2.175,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.475,0.585),(2.475,-0.075),(-0.075,-0.075)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,1.67),(0.95,1.67),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.995,4.87),(1.995,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.1),(0.615,4.4),(0.915,4.4),(0.915,4.1),(0.615,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.995,1.67),(1.995,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,1.36),(1.695,1.66),(1.995,1.66),(1.995,1.36),(1.695,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.1),(1.695,4.4),(1.995,4.4),(1.995,4.1),(1.695,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.09),(1.695,4.87),(1.995,4.87),(1.995,4.09),(1.695,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,1.67),(1.995,1.67),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.43),(1.765,1.59),(1.925,1.59),(1.925,1.43),(1.765,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.17),(0.685,4.33),(0.845,4.33),(0.845,4.17),(0.685,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.17),(1.765,4.33),(1.925,4.33),(1.925,4.17),(1.765,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,4.09),(0.765,4.42),(1.845,4.42),(1.845,4.09),(0.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.42),(1.925,4.42),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.41),(1.925,4.41),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.35),(1.765,1.67),(1.925,1.67),(1.925,1.35),(1.765,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.34),(1.74,4.42),(1.95,4.42),(1.95,1.34),(1.74,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.42),(0.845,4.42),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.41),(0.845,4.41),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.34),(1.765,1.67),(1.925,1.67),(1.925,1.34),(1.765,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.34),(0.8,3.87),(1.01,3.87),(1.01,1.34),(0.8,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,1.67),(1.46,1.67),(1.46,0.89),(1.09,0.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.34),(1.31,3.87),(1.52,3.87),(1.52,1.34),(1.31,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nand3_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.4000000000000004), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,2.55),(1.595,2.55),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,0.105),(0.2,0.405),(2.2,0.405),(2.2,0.105),(0.2,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.295,0.405),(2.295,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,0.175),(0.27,0.335),(0.43,0.335),(0.43,0.175),(0.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,0.175),(0.61,0.335),(0.77,0.335),(0.77,0.175),(0.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,0.175),(0.95,0.335),(1.11,0.335),(1.11,0.175),(0.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,0.175),(1.29,0.335),(1.45,0.335),(1.45,0.175),(1.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,0.175),(1.63,0.335),(1.79,0.335),(1.79,0.175),(1.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,0.175),(1.97,0.335),(2.13,0.335),(2.13,0.175),(1.97,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(2.4,1.12),(2.4,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,0.095),(0.27,0.415),(2.13,0.415),(2.13,0.095),(0.27,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.235,3.17),(1.235,4.87),(1.465,4.87),(1.465,3.17),(1.235,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.395,4.87),(1.395,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,3.17),(1.125,4.87),(1.425,4.87),(1.425,3.17),(1.125,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,3.17),(1.465,4.87),(1.595,4.87),(1.595,3.17),(1.465,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,5.355),(0.2,5.655),(2.2,5.655),(2.2,5.355),(0.2,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(2.295,5.655),(2.295,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,2.86),(0.815,5.18),(1.735,5.18),(1.735,2.86),(0.815,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,2.86),(0.925,5.18),(2.135,5.18),(2.135,2.86),(0.925,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.305,5.18),(2.305,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.11,5.045),(-0.11,5.965),(2.51,5.965),(2.51,5.045),(-0.11,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.03),(1.385,4.63),(2.305,4.63),(2.305,3.03),(1.385,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(2.605,5.965),(2.605,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,2.86),(1.385,5.18),(2.305,5.18),(2.305,2.86),(1.385,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(2.71,6.07),(2.71,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.03),(0.305,4.63),(1.225,4.63),(1.225,3.03),(0.305,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,2.86),(0.305,5.18),(1.225,5.18),(1.225,2.86),(0.305,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.705,5.18),(1.705,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,5.425),(0.27,5.585),(0.43,5.585),(0.43,5.425),(0.27,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,5.425),(0.61,5.585),(0.77,5.585),(0.77,5.425),(0.61,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,5.425),(0.95,5.585),(1.11,5.585),(1.11,5.425),(0.95,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,5.425),(1.29,5.585),(1.45,5.585),(1.45,5.425),(1.29,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,5.425),(1.63,5.585),(1.79,5.585),(1.79,5.425),(1.63,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,5.425),(1.97,5.585),(2.13,5.585),(2.13,5.425),(1.97,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,5.345),(0.27,5.665),(2.13,5.665),(2.13,5.345),(0.27,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(2.4,5.76),(2.4,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.055,2.99),(1.055,5.05),(2.005,5.05),(2.005,2.99),(1.055,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,2.87),(0.435,5.17),(1.095,5.17),(1.095,2.87),(0.435,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,2.87),(1.165,5.17),(1.895,5.17),(1.895,2.87),(1.165,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.04),(1.515,4.62),(2.175,4.62),(2.175,3.04),(1.515,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.04),(0.435,4.62),(1.095,4.62),(1.095,3.04),(0.435,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.02,-0.075),(0.02,0.585),(2.38,0.585),(2.38,-0.075),(0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(2.475,5.17),(2.475,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,2.87),(1.515,5.17),(2.175,5.17),(2.175,2.87),(1.515,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.575,5.17),(1.575,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,2.87),(0.945,5.17),(1.605,5.17),(1.605,2.87),(0.945,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.175,5.17),(2.175,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.475,0.585),(2.475,-0.075),(-0.075,-0.075)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,2.55),(0.95,2.55),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.995,4.87),(1.995,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,2.55),(1.995,2.55),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,1.42),(1.695,2.4),(1.995,2.4),(1.995,1.42),(1.695,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.34),(0.615,4.32),(0.915,4.32),(0.915,3.34),(0.615,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,2.55),(1.825,2.55),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,3.17),(1.595,4.87),(1.825,4.87),(1.825,3.17),(1.595,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.34),(1.695,4.32),(1.995,4.32),(1.995,3.34),(1.695,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.17),(1.695,4.87),(1.995,4.87),(1.995,3.17),(1.695,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.995,2.55),(1.995,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.17),(0.615,4.87),(0.915,4.87),(0.915,3.17),(0.615,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.49),(1.765,1.65),(1.925,1.65),(1.925,1.49),(1.765,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.83),(1.765,1.99),(1.925,1.99),(1.925,1.83),(1.765,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,2.17),(1.765,2.33),(1.925,2.33),(1.925,2.17),(1.765,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.41),(0.685,3.57),(0.845,3.57),(0.845,3.41),(0.685,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.75),(0.685,3.91),(0.845,3.91),(0.845,3.75),(0.685,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.09),(0.685,4.25),(0.845,4.25),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.41),(1.765,3.57),(1.925,3.57),(1.925,3.41),(1.765,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.75),(1.765,3.91),(1.925,3.91),(1.925,3.75),(1.765,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.09),(1.765,4.25),(1.925,4.25),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.41),(1.765,2.41),(1.925,2.41),(1.925,1.41),(1.765,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.33),(0.685,4.33),(0.845,4.33),(0.845,3.33),(0.685,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.34),(1.74,4.42),(1.95,4.42),(1.95,1.34),(1.74,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.33),(1.765,4.33),(1.925,4.33),(1.925,3.33),(1.765,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.34),(1.765,2.48),(1.925,2.48),(1.925,1.34),(1.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,3.24),(0.765,4.42),(1.845,4.42),(1.845,3.24),(0.765,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.24),(1.765,4.42),(1.925,4.42),(1.925,3.24),(1.765,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.24),(0.685,4.42),(0.845,4.42),(0.845,3.24),(0.685,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.34),(0.8,3.02),(1.01,3.02),(1.01,1.34),(0.8,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,2.55),(1.46,2.55),(1.46,0.89),(1.09,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,2.55),(1.465,2.55),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.395,2.55),(1.395,0.89),(1.155,0.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,2.99),(1.465,5.05),(1.595,5.05),(1.595,2.99),(1.465,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.99),(1.595,2.99),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.73),(1.595,2.73),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.34),(1.31,3.02),(1.52,3.02),(1.52,1.34),(1.31,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nand4_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.975,0.89),(1.975,1.67),(2.105,1.67),(2.105,0.89),(1.975,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((2.105,4.09),(2.105,4.87),(2.335,4.87),(2.335,4.09),(2.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,4.09),(2.175,4.87),(2.505,4.87),(2.505,4.09),(2.175,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.09),(1.125,4.87),(1.425,4.87),(1.425,4.09),(1.125,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.09),(2.205,4.87),(2.505,4.87),(2.505,4.09),(2.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.57),(2.205,4.87),(2.505,4.87),(2.505,4.57),(2.205,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,4.09),(1.975,4.87),(2.105,4.87),(2.105,4.09),(1.975,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,3.78),(0.815,5.18),(1.735,5.18),(1.735,3.78),(0.815,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,4.26),(1.895,5.18),(2.815,5.18),(2.815,4.26),(1.895,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.325,3.79),(1.325,4.71),(2.245,4.71),(2.245,3.79),(1.325,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.215,5.18),(2.215,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.79),(0.305,4.71),(1.225,4.71),(1.225,3.79),(0.305,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.325,3.78),(1.325,5.18),(2.245,5.18),(2.245,3.78),(1.325,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,3.78),(1.865,5.18),(2.815,5.18),(2.815,3.78),(1.865,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.78),(1.895,5.18),(2.815,5.18),(2.815,3.78),(1.895,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.435,3.78),(1.435,5.18),(2.645,5.18),(2.645,3.78),(1.435,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.64),(2.275,4.8),(2.435,4.8),(2.435,4.64),(2.275,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,4.64),(2.195,4.8),(2.515,4.8),(2.515,4.64),(2.195,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.8),(0.435,4.7),(1.095,4.7),(1.095,3.8),(0.435,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.79),(2.025,5.17),(2.685,5.17),(2.685,3.79),(2.025,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,3.79),(0.945,5.17),(1.605,5.17),(1.605,3.79),(0.945,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.455,3.79),(1.455,5.17),(2.115,5.17),(2.115,3.79),(1.455,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.675,3.79),(1.675,5.17),(2.405,5.17),(2.405,3.79),(1.675,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.565,3.91),(1.565,5.05),(2.515,5.05),(2.515,3.91),(1.565,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.085,5.17),(2.085,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,4.27),(2.025,5.17),(2.685,5.17),(2.685,4.27),(2.025,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,3.79),(1.995,5.17),(2.685,5.17),(2.685,3.79),(1.995,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.455,3.8),(1.455,4.7),(2.115,4.7),(2.115,3.8),(1.455,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,1.67),(0.95,1.67),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,1.67),(2.505,1.67),(2.505,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,4.1),(1.635,4.4),(1.935,4.4),(1.935,4.1),(1.635,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.89),(2.105,1.67),(2.335,1.67),(2.335,0.89),(2.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,4.09),(1.745,4.87),(1.975,4.87),(1.975,4.09),(1.745,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.1),(0.615,4.4),(0.915,4.4),(0.915,4.1),(0.615,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.905,4.87),(1.905,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,4.09),(1.635,4.87),(1.935,4.87),(1.935,4.09),(1.635,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,1.36),(2.205,1.66),(2.505,1.66),(2.505,1.36),(2.205,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.67),(2.505,1.67),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,4.17),(1.705,4.33),(1.865,4.33),(1.865,4.17),(1.705,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.17),(0.685,4.33),(0.845,4.33),(0.845,4.17),(0.685,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.43),(2.275,1.59),(2.435,1.59),(2.435,1.43),(2.275,1.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,1.34),(2.25,4.42),(2.46,4.42),(2.46,1.34),(2.25,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,4.09),(1.705,4.41),(1.865,4.41),(1.865,4.09),(1.705,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.42),(0.845,4.42),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.41),(0.845,4.41),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,4.09),(0.765,4.42),(2.355,4.42),(2.355,4.09),(0.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,4.09),(2.25,4.41),(2.46,4.41),(2.46,4.09),(2.25,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.34),(2.275,1.67),(2.435,1.67),(2.435,1.34),(2.275,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,4.09),(1.705,4.42),(1.865,4.42),(1.865,4.09),(1.705,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.35),(2.275,1.67),(2.435,1.67),(2.435,1.35),(2.275,1.35)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.34),(0.8,3.87),(1.01,3.87),(1.01,1.34),(0.8,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,1.67),(1.46,1.67),(1.46,0.89),(1.09,0.89)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((1.6,0.89),(1.6,1.67),(1.97,1.67),(1.97,0.89),(1.6,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.905,1.67),(1.905,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,0.89),(1.745,1.67),(1.975,1.67),(1.975,0.89),(1.745,0.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.34),(1.31,3.87),(1.52,3.87),(1.52,1.34),(1.31,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((1.975,3.91),(1.975,5.05),(2.105,5.05),(2.105,3.91),(1.975,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,2.71),(1.925,3.01),(2.04,3.01),(2.04,2.71),(1.925,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,3.91),(2.105,3.91),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,2.71),(1.775,3.01),(2.075,3.01),(2.075,2.71),(1.775,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,1.85),(2.105,1.85),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,2.78),(1.845,2.94),(2.005,2.94),(2.005,2.78),(1.845,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,2.7),(1.845,3.02),(2.005,3.02),(2.005,2.7),(1.845,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.34),(1.82,3.87),(2.03,3.87),(2.03,1.34),(1.82,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.925), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.925), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['nand4_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,2.55),(1.595,2.55),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,0.89),(1.975,2.55),(2.105,2.55),(2.105,0.89),(1.975,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.125,3.17),(1.125,4.87),(1.425,4.87),(1.425,3.17),(1.125,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.17),(2.205,4.87),(2.505,4.87),(2.505,3.17),(2.205,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,3.17),(2.175,4.87),(2.505,4.87),(2.505,3.17),(2.175,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,3.17),(1.975,4.87),(2.105,4.87),(2.105,3.17),(1.975,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,3.17),(1.235,4.87),(1.465,4.87),(1.465,3.17),(1.235,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,3.17),(2.105,4.87),(2.335,4.87),(2.335,3.17),(2.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,3.17),(1.465,4.87),(1.595,4.87),(1.595,3.17),(1.465,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.57),(2.205,4.87),(2.505,4.87),(2.505,4.57),(2.205,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.395,4.87),(1.395,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.325,3.03),(1.325,4.63),(2.245,4.63),(2.245,3.03),(1.325,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,2.86),(1.895,5.18),(2.815,5.18),(2.815,2.86),(1.895,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,2.86),(1.865,5.18),(2.815,5.18),(2.815,2.86),(1.865,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,4.26),(1.895,5.18),(2.815,5.18),(2.815,4.26),(1.895,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,2.86),(0.925,5.18),(2.135,5.18),(2.135,2.86),(0.925,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.215,5.18),(2.215,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.03),(0.305,4.63),(1.225,4.63),(1.225,3.03),(0.305,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.705,5.18),(1.705,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,2.86),(0.305,5.18),(1.225,5.18),(1.225,2.86),(0.305,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.435,2.86),(1.435,5.18),(2.645,5.18),(2.645,2.86),(1.435,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.325,2.86),(1.325,5.18),(2.245,5.18),(2.245,2.86),(1.325,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,2.86),(0.815,5.18),(1.735,5.18),(1.735,2.86),(0.815,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.64),(2.275,4.8),(2.435,4.8),(2.435,4.64),(2.275,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,4.64),(2.195,4.8),(2.515,4.8),(2.515,4.64),(2.195,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.055,2.99),(1.055,5.05),(2.005,5.05),(2.005,2.99),(1.055,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.085,5.17),(2.085,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,2.87),(0.435,5.17),(1.095,5.17),(1.095,2.87),(0.435,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,2.87),(1.165,5.17),(1.895,5.17),(1.895,2.87),(1.165,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,2.87),(2.025,5.17),(2.685,5.17),(2.685,2.87),(2.025,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.455,3.04),(1.455,4.62),(2.115,4.62),(2.115,3.04),(1.455,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.455,2.87),(1.455,5.17),(2.115,5.17),(2.115,2.87),(1.455,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.04),(0.435,4.62),(1.095,4.62),(1.095,3.04),(0.435,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.565,2.99),(1.565,5.05),(2.515,5.05),(2.515,2.99),(1.565,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.675,2.87),(1.675,5.17),(2.405,5.17),(2.405,2.87),(1.675,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.575,5.17),(1.575,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,2.87),(0.945,5.17),(1.605,5.17),(1.605,2.87),(0.945,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,4.27),(2.025,5.17),(2.685,5.17),(2.685,4.27),(2.025,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,2.87),(1.995,5.17),(2.685,5.17),(2.685,2.87),(1.995,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,2.55),(0.95,2.55),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,3.17),(1.745,4.87),(1.975,4.87),(1.975,3.17),(1.745,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.34),(0.615,4.32),(0.915,4.32),(0.915,3.34),(0.615,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,3.17),(1.635,4.87),(1.935,4.87),(1.935,3.17),(1.635,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,2.55),(2.505,2.55),(2.505,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,3.17),(1.595,4.87),(1.825,4.87),(1.825,3.17),(1.595,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,2.55),(2.505,2.55),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.89),(2.105,2.55),(2.335,2.55),(2.335,0.89),(2.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,1.42),(2.205,2.4),(2.505,2.4),(2.505,1.42),(2.205,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.905,4.87),(1.905,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,3.34),(1.635,4.32),(1.935,4.32),(1.935,3.34),(1.635,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.17),(0.615,4.87),(0.915,4.87),(0.915,3.17),(0.615,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.49),(2.275,1.65),(2.435,1.65),(2.435,1.49),(2.275,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.83),(2.275,1.99),(2.435,1.99),(2.435,1.83),(2.275,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,2.17),(2.275,2.33),(2.435,2.33),(2.435,2.17),(2.275,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.41),(0.685,3.57),(0.845,3.57),(0.845,3.41),(0.685,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.75),(0.685,3.91),(0.845,3.91),(0.845,3.75),(0.685,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.09),(0.685,4.25),(0.845,4.25),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,3.41),(1.705,3.57),(1.865,3.57),(1.865,3.41),(1.705,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,3.75),(1.705,3.91),(1.865,3.91),(1.865,3.75),(1.705,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,4.09),(1.705,4.25),(1.865,4.25),(1.865,4.09),(1.705,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,1.34),(2.25,4.42),(2.46,4.42),(2.46,1.34),(2.25,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,3.33),(1.705,4.33),(1.865,4.33),(1.865,3.33),(1.705,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.34),(2.275,2.48),(2.435,2.48),(2.435,1.34),(2.275,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,3.24),(2.25,3.56),(2.46,3.56),(2.46,3.24),(2.25,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.33),(0.685,4.33),(0.845,4.33),(0.845,3.33),(0.685,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,3.24),(0.765,4.42),(2.355,4.42),(2.355,3.24),(0.765,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,3.24),(1.705,4.42),(1.865,4.42),(1.865,3.24),(1.705,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.41),(2.275,2.41),(2.435,2.41),(2.435,1.41),(2.275,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.24),(0.685,4.42),(0.845,4.42),(0.845,3.24),(0.685,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.34),(0.8,3.02),(1.01,3.02),(1.01,1.34),(0.8,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,2.55),(1.46,2.55),(1.46,0.89),(1.09,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,2.55),(1.465,2.55),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.395,2.55),(1.395,0.89),(1.155,0.89)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.905,2.55),(1.905,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.6,0.89),(1.6,2.55),(1.97,2.55),(1.97,0.89),(1.6,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,2.55),(1.825,2.55),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,0.89),(1.745,2.55),(1.975,2.55),(1.975,0.89),(1.745,0.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,2.99),(1.465,5.05),(1.595,5.05),(1.595,2.99),(1.465,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.99),(1.595,2.99),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.73),(1.595,2.73),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.34),(1.31,3.02),(1.52,3.02),(1.52,1.34),(1.31,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,2.99),(2.105,2.99),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,2.71),(1.925,3.01),(2.04,3.01),(2.04,2.71),(1.925,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,2.73),(2.105,2.73),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,2.99),(1.975,5.05),(2.105,5.05),(2.105,2.99),(1.975,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,2.71),(1.775,3.01),(2.075,3.01),(2.075,2.71),(1.775,2.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,2.78),(1.845,2.94),(2.005,2.94),(2.005,2.78),(1.845,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,2.7),(1.845,3.02),(2.005,3.02),(2.005,2.7),(1.845,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.34),(1.82,3.02),(2.03,3.02),(2.03,1.34),(1.82,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.925), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.925), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['and2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.4000000000000004), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.1),(0.615,4.4),(0.915,4.4),(0.915,4.1),(0.615,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.17),(0.685,4.33),(0.845,4.33),(0.845,4.17),(0.685,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,4.09),(1.31,4.41),(1.52,4.41),(1.52,4.09),(1.31,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,4.09),(0.765,4.42),(1.415,4.42),(1.415,4.09),(0.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,1.67),(1.415,1.67),(1.415,1.34),(0.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.35),(1.31,4.41),(1.52,4.41),(1.52,1.35),(1.31,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.42),(0.845,4.42),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.35),(1.31,1.67),(1.52,1.67),(1.52,1.35),(1.31,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.41),(0.845,4.41),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.56,3.01),(1.56,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.495,0.71),(1.495,2.99),(1.625,2.99),(1.625,0.71),(1.495,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.495,2.99),(1.495,5.05),(1.625,5.05),(1.625,2.99),(1.495,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.495,0.71),(1.495,2.73),(1.625,2.73),(1.625,0.71),(1.495,0.71)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.495,3.17),(1.495,4.87),(1.625,4.87),(1.625,3.17),(1.495,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.455,4.87),(1.455,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.425,4.87),(1.425,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,5.355),(0.2,5.655),(2.2,5.655),(2.2,5.355),(0.2,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(2.295,5.655),(2.295,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.265,3.17),(1.265,4.87),(1.495,4.87),(1.495,3.17),(1.265,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.57),(1.155,4.87),(1.455,4.87),(1.455,4.57),(1.155,4.57)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.11,5.045),(-0.11,5.965),(2.51,5.965),(2.51,5.045),(-0.11,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.03),(1.385,4.63),(2.305,4.63),(2.305,3.03),(1.385,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(2.605,5.965),(2.605,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.79),(0.305,4.71),(1.225,4.71),(1.225,3.79),(0.305,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,2.86),(1.385,5.18),(2.305,5.18),(2.305,2.86),(1.385,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(2.71,6.07),(2.71,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.955,2.86),(0.955,5.18),(2.165,5.18),(2.165,2.86),(0.955,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,2.86),(1.385,5.18),(2.305,5.18),(2.305,2.86),(1.385,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.765,5.18),(1.765,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,4.26),(0.845,5.18),(1.765,5.18),(1.765,4.26),(0.845,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.735,5.18),(1.735,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,5.425),(0.27,5.585),(0.43,5.585),(0.43,5.425),(0.27,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,5.425),(0.61,5.585),(0.77,5.585),(0.77,5.425),(0.61,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,5.425),(0.95,5.585),(1.11,5.585),(1.11,5.425),(0.95,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,5.425),(1.29,5.585),(1.45,5.585),(1.45,5.425),(1.29,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,5.425),(1.63,5.585),(1.79,5.585),(1.79,5.425),(1.63,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,5.425),(1.97,5.585),(2.13,5.585),(2.13,5.425),(1.97,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.225,4.64),(1.225,4.8),(1.385,4.8),(1.385,4.64),(1.225,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,4.64),(1.145,4.8),(1.465,4.8),(1.465,4.64),(1.145,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,5.345),(0.27,5.665),(2.13,5.665),(2.13,5.345),(0.27,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(2.4,5.76),(2.4,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.195,2.87),(1.195,5.17),(1.925,5.17),(1.925,2.87),(1.195,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.8),(0.435,4.7),(1.095,4.7),(1.095,3.8),(0.435,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.635,5.17),(1.635,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,4.27),(0.975,5.17),(1.635,5.17),(1.635,4.27),(0.975,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.04),(1.515,4.62),(2.175,4.62),(2.175,3.04),(1.515,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.02,-0.075),(0.02,0.585),(2.38,0.585),(2.38,-0.075),(0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(2.475,5.17),(2.475,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,2.87),(1.515,5.17),(2.175,5.17),(2.175,2.87),(1.515,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.085,2.99),(1.085,5.05),(2.035,5.05),(2.035,2.99),(1.085,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,2.87),(1.515,5.17),(2.175,5.17),(2.175,2.87),(1.515,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.605,5.17),(1.605,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.475,0.585),(2.475,-0.075),(-0.075,-0.075)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.455,2.55),(1.455,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.19),(1.455,1.19),(1.455,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,0.105),(0.2,0.405),(2.2,0.405),(2.2,0.105),(0.2,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.265,0.89),(1.265,2.55),(1.495,2.55),(1.495,0.89),(1.265,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.425,2.55),(1.425,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.295,0.405),(2.295,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.495,0.89),(1.495,2.55),(1.625,2.55),(1.625,0.89),(1.495,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.225,0.96),(1.225,1.12),(1.385,1.12),(1.385,0.96),(1.225,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,0.175),(0.27,0.335),(0.43,0.335),(0.43,0.175),(0.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,0.175),(0.61,0.335),(0.77,0.335),(0.77,0.175),(0.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,0.175),(0.95,0.335),(1.11,0.335),(1.11,0.175),(0.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,0.175),(1.29,0.335),(1.45,0.335),(1.45,0.175),(1.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,0.175),(1.63,0.335),(1.79,0.335),(1.79,0.175),(1.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,0.175),(1.97,0.335),(2.13,0.335),(2.13,0.175),(1.97,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(2.4,1.12),(2.4,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,0.095),(0.27,0.415),(2.13,0.415),(2.13,0.095),(0.27,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,0.96),(1.145,1.12),(1.465,1.12),(1.465,0.96),(1.145,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,1.67),(0.95,1.67),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.89),(0.15,4.42),(0.36,4.42),(0.36,1.89),(0.15,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,3.87),(1.01,3.87),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((1.625,3.17),(1.625,4.87),(1.855,4.87),(1.855,3.17),(1.625,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,1.42),(1.695,2.4),(1.995,2.4),(1.995,1.42),(1.695,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,2.55),(1.995,2.55),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.34),(1.695,4.32),(1.995,4.32),(1.995,3.34),(1.695,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.17),(1.695,4.87),(1.995,4.87),(1.995,3.17),(1.695,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.17),(1.695,4.87),(1.995,4.87),(1.995,3.17),(1.695,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.625,0.89),(1.625,2.55),(1.855,2.55),(1.855,0.89),(1.625,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,2.55),(1.995,2.55),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.49),(1.765,1.65),(1.925,1.65),(1.925,1.49),(1.765,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.83),(1.765,1.99),(1.925,1.99),(1.925,1.83),(1.765,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,2.17),(1.765,2.33),(1.925,2.33),(1.925,2.17),(1.765,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.41),(1.765,3.57),(1.925,3.57),(1.925,3.41),(1.765,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.75),(1.765,3.91),(1.925,3.91),(1.925,3.75),(1.765,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.09),(1.765,4.25),(1.925,4.25),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.41),(1.765,2.41),(1.925,2.41),(1.925,1.41),(1.765,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.33),(1.765,4.33),(1.925,4.33),(1.925,3.33),(1.765,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.34),(1.765,2.48),(1.925,2.48),(1.925,1.34),(1.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.24),(1.765,4.42),(1.925,4.42),(1.925,3.24),(1.765,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.34),(1.74,4.42),(1.95,4.42),(1.95,1.34),(1.74,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['and3_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.09),(1.125,4.87),(1.425,4.87),(1.425,4.09),(1.125,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.1),(1.125,4.4),(1.425,4.4),(1.425,4.1),(1.125,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.17),(1.195,4.33),(1.355,4.33),(1.355,4.17),(1.195,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,2.78),(1.845,2.94),(2.005,2.94),(2.005,2.78),(1.845,2.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,2.7),(1.845,3.02),(2.005,3.02),(2.005,2.7),(1.845,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,4.09),(1.82,4.41),(2.03,4.41),(2.03,4.09),(1.82,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.195,4.09),(1.195,4.42),(1.355,4.42),(1.355,4.09),(1.195,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,4.09),(0.255,4.42),(1.925,4.42),(1.925,4.09),(0.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.35),(1.82,1.67),(2.03,1.67),(2.03,1.35),(1.82,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.195,4.09),(1.195,4.41),(1.355,4.41),(1.355,4.09),(1.195,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.35),(1.82,4.41),(2.03,4.41),(2.03,1.35),(1.82,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,1.67),(1.925,1.67),(1.925,1.34),(0.255,1.34)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.005,2.99),(2.005,5.05),(2.135,5.05),(2.135,2.99),(2.005,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,2.71),(1.775,3.01),(2.075,3.01),(2.075,2.71),(1.775,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,2.71),(1.925,3.01),(2.07,3.01),(2.07,2.71),(1.925,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.005,0.71),(2.005,2.99),(2.135,2.99),(2.135,0.71),(2.005,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.005,0.71),(2.005,2.73),(2.135,2.73),(2.135,0.71),(2.005,0.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.945,3.8),(0.945,4.7),(1.605,4.7),(1.605,3.8),(0.945,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,2.87),(2.025,5.17),(2.685,5.17),(2.685,2.87),(2.025,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.145,5.17),(2.145,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.04),(2.025,4.62),(2.685,4.62),(2.685,3.04),(2.025,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,2.87),(2.025,5.17),(2.685,5.17),(2.685,2.87),(2.025,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.595,2.99),(1.595,5.05),(2.545,5.05),(2.545,2.99),(1.595,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,3.79),(0.945,5.17),(1.605,5.17),(1.605,3.79),(0.945,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,4.27),(1.485,5.17),(2.145,5.17),(2.145,4.27),(1.485,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,2.87),(1.705,5.17),(2.435,5.17),(2.435,2.87),(1.705,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.115,5.17),(2.115,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.815,3.79),(0.815,4.71),(1.735,4.71),(1.735,3.79),(0.815,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,3.78),(0.815,5.18),(1.735,5.18),(1.735,3.78),(0.815,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,2.86),(1.895,5.18),(2.815,5.18),(2.815,2.86),(1.895,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,2.86),(1.895,5.18),(2.815,5.18),(2.815,2.86),(1.895,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.465,2.86),(1.465,5.18),(2.675,5.18),(2.675,2.86),(1.465,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.03),(1.895,4.63),(2.815,4.63),(2.815,3.03),(1.895,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,4.26),(1.355,5.18),(2.275,5.18),(2.275,4.26),(1.355,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.245,5.18),(2.245,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.275,5.18),(2.275,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.005,3.17),(2.005,4.87),(2.135,4.87),(2.135,3.17),(2.005,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.775,3.17),(1.775,4.87),(2.005,4.87),(2.005,3.17),(1.775,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.965,4.87),(1.965,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.935,4.87),(1.935,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.57),(1.665,4.87),(1.965,4.87),(1.965,4.57),(1.665,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.735,4.64),(1.735,4.8),(1.895,4.8),(1.895,4.64),(1.735,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.655,4.64),(1.655,4.8),(1.975,4.8),(1.975,4.64),(1.655,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.19),(1.965,1.19),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.935,2.55),(1.935,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.775,0.89),(1.775,2.55),(2.005,2.55),(2.005,0.89),(1.775,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.965,2.55),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.005,0.89),(2.005,2.55),(2.135,2.55),(2.135,0.89),(2.005,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.735,0.96),(1.735,1.12),(1.895,1.12),(1.895,0.96),(1.735,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.655,0.96),(1.655,1.12),(1.975,1.12),(1.975,0.96),(1.655,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,1.67),(0.95,1.67),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.89),(0.15,3.87),(0.36,3.87),(0.36,1.89),(0.15,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,3.87),(1.01,3.87),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,1.67),(1.46,1.67),(1.46,0.89),(1.09,0.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.89),(1.31,3.87),(1.52,3.87),(1.52,1.89),(1.31,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((2.205,3.17),(2.205,4.87),(2.505,4.87),(2.505,3.17),(2.205,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.17),(2.205,4.87),(2.505,4.87),(2.505,3.17),(2.205,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.34),(2.205,4.32),(2.505,4.32),(2.505,3.34),(2.205,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,2.55),(2.505,2.55),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,0.89),(2.135,2.55),(2.365,2.55),(2.365,0.89),(2.135,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,3.17),(2.135,4.87),(2.365,4.87),(2.365,3.17),(2.135,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,1.42),(2.205,2.4),(2.505,2.4),(2.505,1.42),(2.205,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,2.55),(2.505,2.55),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.49),(2.275,1.65),(2.435,1.65),(2.435,1.49),(2.275,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.83),(2.275,1.99),(2.435,1.99),(2.435,1.83),(2.275,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,2.17),(2.275,2.33),(2.435,2.33),(2.435,2.17),(2.275,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,3.41),(2.275,3.57),(2.435,3.57),(2.435,3.41),(2.275,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,3.75),(2.275,3.91),(2.435,3.91),(2.435,3.75),(2.275,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.09),(2.275,4.25),(2.435,4.25),(2.435,4.09),(2.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,1.34),(2.25,4.42),(2.46,4.42),(2.46,1.34),(2.25,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,3.24),(2.275,4.42),(2.435,4.42),(2.435,3.24),(2.275,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.34),(2.275,2.48),(2.435,2.48),(2.435,1.34),(2.275,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.41),(2.275,2.41),(2.435,2.41),(2.435,1.41),(2.275,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,3.33),(2.275,4.33),(2.435,4.33),(2.435,3.33),(2.275,3.33)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['and4_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,4.1),(1.635,4.4),(1.935,4.4),(1.935,4.1),(1.635,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,4.09),(1.745,4.87),(1.975,4.87),(1.975,4.09),(1.745,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.1),(0.615,4.4),(0.915,4.4),(0.915,4.1),(0.615,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.905,4.87),(1.905,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,4.09),(1.635,4.87),(1.935,4.87),(1.935,4.09),(1.635,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,4.17),(1.705,4.33),(1.865,4.33),(1.865,4.17),(1.705,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.17),(0.685,4.33),(0.845,4.33),(0.845,4.17),(0.685,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.355,2.78),(2.355,2.94),(2.515,2.94),(2.515,2.78),(2.355,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,1.67),(2.435,1.67),(2.435,1.34),(0.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,4.09),(1.705,4.41),(1.865,4.41),(1.865,4.09),(1.705,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.33,1.35),(2.33,4.41),(2.54,4.41),(2.54,1.35),(2.33,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.33,1.35),(2.33,1.67),(2.54,1.67),(2.54,1.35),(2.33,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.42),(0.845,4.42),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.41),(0.845,4.41),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.355,2.7),(2.355,3.02),(2.515,3.02),(2.515,2.7),(2.355,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.33,4.09),(2.33,4.41),(2.54,4.41),(2.54,4.09),(2.33,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,4.09),(1.705,4.42),(1.865,4.42),(1.865,4.09),(1.705,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,4.09),(0.765,4.42),(2.435,4.42),(2.435,4.09),(0.765,4.09)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.515,0.71),(2.515,2.73),(2.645,2.73),(2.645,0.71),(2.515,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.285,2.71),(2.285,3.01),(2.585,3.01),(2.585,2.71),(2.285,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.435,2.71),(2.435,3.01),(2.58,3.01),(2.58,2.71),(2.435,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.515,2.99),(2.515,5.05),(2.645,5.05),(2.645,2.99),(2.515,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.515,0.71),(2.515,2.99),(2.645,2.99),(2.645,0.71),(2.515,0.71)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((2.105,4.09),(2.105,4.87),(2.335,4.87),(2.335,4.09),(2.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,3.17),(2.175,4.87),(2.475,4.87),(2.475,3.17),(2.175,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,4.57),(2.175,4.87),(2.475,4.87),(2.475,4.57),(2.175,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.09),(1.125,4.87),(1.425,4.87),(1.425,4.09),(1.125,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.285,3.17),(2.285,4.87),(2.515,4.87),(2.515,3.17),(2.285,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.515,3.17),(2.515,4.87),(2.645,4.87),(2.645,3.17),(2.515,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,3.17),(2.175,4.87),(2.445,4.87),(2.445,3.17),(2.175,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,4.09),(1.975,4.87),(2.105,4.87),(2.105,4.09),(1.975,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,3.78),(0.815,5.18),(1.735,5.18),(1.735,3.78),(0.815,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.975,2.86),(1.975,5.18),(3.185,5.18),(3.185,2.86),(1.975,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.325,3.79),(1.325,4.71),(2.245,4.71),(2.245,3.79),(1.325,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.215,5.18),(2.215,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,2.86),(2.405,5.18),(3.325,5.18),(3.325,2.86),(2.405,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.79),(0.305,4.71),(1.225,4.71),(1.225,3.79),(0.305,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,3.03),(2.405,4.63),(3.325,4.63),(3.325,3.03),(2.405,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,2.86),(1.865,5.18),(2.755,5.18),(2.755,2.86),(1.865,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.325,3.78),(1.325,5.18),(2.245,5.18),(2.245,3.78),(1.325,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.435,3.78),(1.435,5.18),(2.645,5.18),(2.645,3.78),(1.435,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,2.86),(1.865,5.18),(2.785,5.18),(2.785,2.86),(1.865,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,2.86),(2.405,5.18),(3.325,5.18),(3.325,2.86),(2.405,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,4.26),(1.865,5.18),(2.785,5.18),(2.785,4.26),(1.865,4.26)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.245,4.64),(2.245,4.8),(2.405,4.8),(2.405,4.64),(2.245,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.165,4.64),(2.165,4.8),(2.485,4.8),(2.485,4.64),(2.165,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((2.535,2.87),(2.535,5.17),(3.195,5.17),(3.195,2.87),(2.535,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.04),(2.535,4.62),(3.195,4.62),(3.195,3.04),(2.535,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.8),(0.435,4.7),(1.095,4.7),(1.095,3.8),(0.435,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,2.87),(1.995,5.17),(2.655,5.17),(2.655,2.87),(1.995,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,3.79),(0.945,5.17),(1.605,5.17),(1.605,3.79),(0.945,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.455,3.79),(1.455,5.17),(2.115,5.17),(2.115,3.79),(1.455,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.675,3.79),(1.675,5.17),(2.405,5.17),(2.405,3.79),(1.675,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.565,3.91),(1.565,5.05),(2.515,5.05),(2.515,3.91),(1.565,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.105,2.99),(2.105,5.05),(3.055,5.05),(3.055,2.99),(2.105,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,2.87),(2.535,5.17),(3.195,5.17),(3.195,2.87),(2.535,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.085,5.17),(2.085,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.215,2.87),(2.215,5.17),(2.945,5.17),(2.945,2.87),(2.215,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,4.27),(1.995,5.17),(2.655,5.17),(2.655,4.27),(1.995,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.455,3.8),(1.455,4.7),(2.115,4.7),(2.115,3.8),(1.455,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,2.87),(1.995,5.17),(2.625,5.17),(2.625,2.87),(1.995,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,2.55),(2.445,2.55),(2.445,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.89),(2.105,1.67),(2.335,1.67),(2.335,0.89),(2.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.515,0.89),(2.515,2.55),(2.645,2.55),(2.645,0.89),(2.515,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,0.89),(1.975,1.67),(2.105,1.67),(2.105,0.89),(1.975,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,1.19),(2.475,1.19),(2.475,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.285,0.89),(2.285,2.55),(2.515,2.55),(2.515,0.89),(2.285,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,2.55),(2.475,2.55),(2.475,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.245,0.96),(2.245,1.12),(2.405,1.12),(2.405,0.96),(2.245,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.165,0.96),(2.165,1.12),(2.485,1.12),(2.485,0.96),(2.165,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,1.67),(0.95,1.67),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.89),(0.15,4.42),(0.36,4.42),(0.36,1.89),(0.15,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,3.87),(1.01,3.87),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,1.67),(1.46,1.67),(1.46,0.89),(1.09,0.89)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((1.6,0.89),(1.6,1.67),(1.97,1.67),(1.97,0.89),(1.6,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.905,1.67),(1.905,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,0.89),(1.745,1.67),(1.975,1.67),(1.975,0.89),(1.745,0.89)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.89),(1.31,3.87),(1.52,3.87),(1.52,1.89),(1.31,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((1.975,3.91),(1.975,5.05),(2.105,5.05),(2.105,3.91),(1.975,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,2.71),(1.925,3.01),(2.04,3.01),(2.04,2.71),(1.925,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,3.91),(2.105,3.91),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,2.71),(1.775,3.01),(2.075,3.01),(2.075,2.71),(1.775,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,1.85),(2.105,1.85),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,2.78),(1.845,2.94),(2.005,2.94),(2.005,2.78),(1.845,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,2.7),(1.845,3.02),(2.005,3.02),(2.005,2.7),(1.845,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.89),(1.82,3.87),(2.03,3.87),(2.03,1.89),(1.82,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.925), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.925), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((2.715,3.34),(2.715,4.32),(3.015,4.32),(3.015,3.34),(2.715,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,2.55),(3.015,2.55),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,3.17),(2.715,4.87),(3.015,4.87),(3.015,3.17),(2.715,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,2.55),(3.015,2.55),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,3.17),(2.715,4.87),(3.015,4.87),(3.015,3.17),(2.715,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,1.42),(2.715,2.4),(3.015,2.4),(3.015,1.42),(2.715,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.645,0.89),(2.645,2.55),(2.875,2.55),(2.875,0.89),(2.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.645,3.17),(2.645,4.87),(2.875,4.87),(2.875,3.17),(2.645,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,3.41),(2.785,3.57),(2.945,3.57),(2.945,3.41),(2.785,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,3.75),(2.785,3.91),(2.945,3.91),(2.945,3.75),(2.785,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,4.09),(2.785,4.25),(2.945,4.25),(2.945,4.09),(2.785,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,1.49),(2.785,1.65),(2.945,1.65),(2.945,1.49),(2.785,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,1.83),(2.785,1.99),(2.945,1.99),(2.945,1.83),(2.785,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,2.17),(2.785,2.33),(2.945,2.33),(2.945,2.17),(2.785,2.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.785,1.41),(2.785,2.41),(2.945,2.41),(2.945,1.41),(2.785,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.76,1.34),(2.76,4.42),(2.97,4.42),(2.97,1.34),(2.76,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.785,1.34),(2.785,2.48),(2.945,2.48),(2.945,1.34),(2.785,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.785,3.33),(2.785,4.33),(2.945,4.33),(2.945,3.33),(2.785,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.785,3.24),(2.785,4.42),(2.945,4.42),(2.945,3.24),(2.785,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.865), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.865), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['nor2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.485,1.67),(1.485,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,1.19),(1.485,1.19),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,1.67),(1.485,1.67),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,0.96),(1.255,1.12),(1.415,1.12),(1.415,0.96),(1.255,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.175,0.96),(1.175,1.12),(1.495,1.12),(1.495,0.96),(1.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.79),(0.875,4.71),(1.795,4.71),(1.795,3.79),(0.875,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.795,5.18),(1.795,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,3.78),(0.27,5.18),(1.26,5.18),(1.26,3.78),(0.27,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.78),(0.875,5.18),(1.795,5.18),(1.795,3.78),(0.875,3.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,3.79),(0.4,5.17),(1.13,5.17),(1.13,3.79),(0.4,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.79),(1.005,5.17),(1.665,5.17),(1.665,3.79),(1.005,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.665,5.17),(1.665,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.8),(1.005,4.7),(1.665,4.7),(1.665,3.8),(1.005,3.8)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.09),(1.185,4.87),(1.485,4.87),(1.485,4.09),(1.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.485,4.87),(1.485,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.1),(1.185,4.4),(1.485,4.4),(1.485,4.1),(1.185,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.36),(0.615,1.66),(0.915,1.66),(0.915,1.36),(0.615,1.36)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.43),(0.685,1.59),(0.845,1.59),(0.845,1.43),(0.685,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.17),(1.255,4.33),(1.415,4.33),(1.415,4.17),(1.255,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.35),(1.23,1.67),(1.44,1.67),(1.44,1.35),(1.23,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.42),(1.415,4.42),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.41),(1.415,4.41),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.35),(0.685,1.67),(0.845,1.67),(0.845,1.35),(0.685,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,1.67),(0.845,1.67),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.34),(1.23,4.42),(1.44,4.42),(1.44,1.34),(1.23,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,1.34),(0.765,1.67),(1.335,1.67),(1.335,1.34),(0.765,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,4.09),(0.58,4.87),(0.95,4.87),(0.95,4.09),(0.58,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,4.42),(1.01,4.42),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nor2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(1.6), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.485,2.55),(1.485,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,0.105),(0.14,0.405),(1.46,0.405),(1.46,0.105),(0.14,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(1.495,0.405),(1.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,2.55),(1.485,2.55),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,1.19),(1.485,1.19),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,0.175),(0.21,0.335),(0.37,0.335),(0.37,0.175),(0.21,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,0.175),(0.55,0.335),(0.71,0.335),(0.71,0.175),(0.55,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,0.175),(0.89,0.335),(1.05,0.335),(1.05,0.175),(0.89,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,0.175),(1.23,0.335),(1.39,0.335),(1.39,0.175),(1.23,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,0.96),(1.255,1.12),(1.415,1.12),(1.415,0.96),(1.255,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.175,0.96),(1.175,1.12),(1.495,1.12),(1.495,0.96),(1.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(1.6,1.12),(1.6,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,0.095),(0.21,0.415),(1.39,0.415),(1.39,0.095),(0.21,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(1.495,5.655),(1.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.14,5.355),(0.14,5.655),(1.46,5.655),(1.46,5.355),(0.14,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,2.86),(0.875,5.18),(1.795,5.18),(1.795,2.86),(0.875,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.17,5.045),(-0.17,5.965),(1.77,5.965),(1.77,5.045),(-0.17,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,2.86),(0.27,5.18),(1.26,5.18),(1.26,2.86),(0.27,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.795,5.18),(1.795,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(1.91,6.07),(1.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(1.805,5.965),(1.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.03),(0.875,4.63),(1.795,4.63),(1.795,3.03),(0.875,3.03)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.21,5.425),(0.21,5.585),(0.37,5.585),(0.37,5.425),(0.21,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.55,5.425),(0.55,5.585),(0.71,5.585),(0.71,5.425),(0.55,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.89,5.425),(0.89,5.585),(1.05,5.585),(1.05,5.425),(0.89,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.23,5.425),(1.23,5.585),(1.39,5.585),(1.39,5.425),(1.23,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(1.6,5.76),(1.6,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.21,5.345),(0.21,5.665),(1.39,5.665),(1.39,5.345),(0.21,5.345)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.8), u(1.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(1.675,0.585),(1.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,2.87),(0.4,5.17),(1.13,5.17),(1.13,2.87),(0.4,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.665,5.17),(1.665,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(1.675,5.17),(1.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.04,-0.075),(-0.04,0.585),(1.64,0.585),(1.64,-0.075),(-0.04,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.04),(1.005,4.62),(1.665,4.62),(1.665,3.04),(1.005,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,2.87),(1.005,5.17),(1.665,5.17),(1.665,2.87),(1.005,2.87)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.42),(0.615,2.4),(0.915,2.4),(0.915,1.42),(0.615,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.485,4.87),(1.485,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.55),(0.915,2.55),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.17),(1.185,4.87),(1.485,4.87),(1.485,3.17),(1.185,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.34),(1.185,4.32),(1.485,4.32),(1.485,3.34),(1.185,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.49),(0.685,1.65),(0.845,1.65),(0.845,1.49),(0.685,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.83),(0.685,1.99),(0.845,1.99),(0.845,1.83),(0.685,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,2.17),(0.685,2.33),(0.845,2.33),(0.845,2.17),(0.685,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,3.41),(1.255,3.57),(1.415,3.57),(1.415,3.41),(1.255,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,3.75),(1.255,3.91),(1.415,3.91),(1.415,3.75),(1.255,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.09),(1.255,4.25),(1.415,4.25),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.33),(1.255,4.33),(1.415,4.33),(1.415,3.33),(1.255,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,1.34),(0.765,2.48),(1.335,2.48),(1.335,1.34),(0.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,2.16),(1.23,2.48),(1.44,2.48),(1.44,2.16),(1.23,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.24),(1.255,4.42),(1.415,4.42),(1.415,3.24),(1.255,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.48),(0.845,2.48),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.41),(0.685,2.41),(0.845,2.41),(0.845,1.41),(0.685,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.34),(1.23,4.42),(1.44,4.42),(1.44,1.34),(1.23,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.335), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.58,3.17),(0.58,4.87),(0.95,4.87),(0.95,3.17),(0.58,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,2.7),(0.8,4.42),(1.01,4.42),(1.01,2.7),(0.8,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['nor3_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.4000000000000004), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.295,0.405),(2.295,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,0.105),(0.2,0.405),(2.2,0.405),(2.2,0.105),(0.2,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.67),(1.425,1.67),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,0.175),(0.27,0.335),(0.43,0.335),(0.43,0.175),(0.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,0.175),(0.61,0.335),(0.77,0.335),(0.77,0.175),(0.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,0.175),(0.95,0.335),(1.11,0.335),(1.11,0.175),(0.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,0.175),(1.29,0.335),(1.45,0.335),(1.45,0.175),(1.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,0.175),(1.63,0.335),(1.79,0.335),(1.79,0.175),(1.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,0.175),(1.97,0.335),(2.13,0.335),(2.13,0.175),(1.97,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,0.095),(0.27,0.415),(2.13,0.415),(2.13,0.095),(0.27,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(2.4,1.12),(2.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,5.355),(0.2,5.655),(2.2,5.655),(2.2,5.355),(0.2,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(2.295,5.655),(2.295,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.79),(1.385,4.71),(2.305,4.71),(2.305,3.79),(1.385,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.11,5.045),(-0.11,5.965),(2.51,5.965),(2.51,5.045),(-0.11,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(2.605,5.965),(2.605,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.78,3.78),(0.78,5.18),(1.77,5.18),(1.77,3.78),(0.78,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(2.71,6.07),(2.71,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.78),(1.385,5.18),(2.305,5.18),(2.305,3.78),(1.385,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.305,5.18),(2.305,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,3.78),(0.27,5.18),(1.26,5.18),(1.26,3.78),(0.27,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,5.425),(0.27,5.585),(0.43,5.585),(0.43,5.425),(0.27,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,5.425),(0.61,5.585),(0.77,5.585),(0.77,5.425),(0.61,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,5.425),(0.95,5.585),(1.11,5.585),(1.11,5.425),(0.95,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,5.425),(1.29,5.585),(1.45,5.585),(1.45,5.425),(1.29,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,5.425),(1.63,5.585),(1.79,5.585),(1.79,5.425),(1.63,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,5.425),(1.97,5.585),(2.13,5.585),(2.13,5.425),(1.97,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,5.345),(0.27,5.665),(2.13,5.665),(2.13,5.345),(0.27,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(2.4,5.76),(2.4,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.8),(1.515,4.7),(2.175,4.7),(2.175,3.8),(1.515,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.79),(1.515,5.17),(2.175,5.17),(2.175,3.79),(1.515,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.91,3.79),(0.91,5.17),(1.64,5.17),(1.64,3.79),(0.91,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,3.79),(0.4,5.17),(1.13,5.17),(1.13,3.79),(0.4,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.02,-0.075),(0.02,0.585),(2.38,0.585),(2.38,-0.075),(0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(2.475,5.17),(2.475,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.175,5.17),(2.175,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.475,0.585),(2.475,-0.075),(-0.075,-0.075)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.995,4.87),(1.995,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.995,1.67),(1.995,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,1.36),(1.695,1.66),(1.995,1.66),(1.995,1.36),(1.695,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.1),(1.695,4.4),(1.995,4.4),(1.995,4.1),(1.695,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.09),(1.695,4.87),(1.995,4.87),(1.995,4.09),(1.695,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,1.67),(1.995,1.67),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.36),(0.615,1.66),(0.915,1.66),(0.915,1.36),(0.615,1.36)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.43),(0.685,1.59),(0.845,1.59),(0.845,1.43),(0.685,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.17),(1.765,4.33),(1.925,4.33),(1.925,4.17),(1.765,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.43),(1.765,1.59),(1.925,1.59),(1.925,1.43),(1.765,1.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.42),(1.925,4.42),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.41),(1.925,4.41),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.35),(1.765,1.67),(1.925,1.67),(1.925,1.35),(1.765,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.34),(1.74,4.42),(1.95,4.42),(1.95,1.34),(1.74,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.35),(0.685,1.67),(0.845,1.67),(0.845,1.35),(0.685,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,1.67),(0.845,1.67),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,1.34),(0.765,1.67),(1.845,1.67),(1.845,1.34),(0.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.34),(1.765,1.67),(1.925,1.67),(1.925,1.34),(1.765,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,4.09),(0.58,4.87),(0.95,4.87),(0.95,4.09),(0.58,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,4.42),(1.01,4.42),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,4.09),(1.09,4.87),(1.46,4.87),(1.46,4.09),(1.09,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.89),(1.31,4.42),(1.52,4.42),(1.52,1.89),(1.31,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nor3_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.4000000000000004), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,2.55),(1.595,2.55),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,2.55),(1.465,2.55),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,2.55),(1.425,2.55),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.395,2.55),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,0.105),(0.2,0.405),(2.2,0.405),(2.2,0.105),(0.2,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.295,0.405),(2.295,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,0.175),(0.27,0.335),(0.43,0.335),(0.43,0.175),(0.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,0.175),(0.61,0.335),(0.77,0.335),(0.77,0.175),(0.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,0.175),(0.95,0.335),(1.11,0.335),(1.11,0.175),(0.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,0.175),(1.29,0.335),(1.45,0.335),(1.45,0.175),(1.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,0.175),(1.63,0.335),(1.79,0.335),(1.79,0.175),(1.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,0.175),(1.97,0.335),(2.13,0.335),(2.13,0.175),(1.97,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,0.095),(0.27,0.415),(2.13,0.415),(2.13,0.095),(0.27,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(2.4,1.12),(2.4,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,3.17),(1.465,4.87),(1.595,4.87),(1.595,3.17),(1.465,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,5.355),(0.2,5.655),(2.2,5.655),(2.2,5.355),(0.2,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(2.295,5.655),(2.295,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.305,5.18),(2.305,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,2.86),(0.925,5.18),(2.135,5.18),(2.135,2.86),(0.925,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.11,5.045),(-0.11,5.965),(2.51,5.965),(2.51,5.045),(-0.11,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,2.86),(0.27,5.18),(1.26,5.18),(1.26,2.86),(0.27,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.78,2.86),(0.78,5.18),(1.77,5.18),(1.77,2.86),(0.78,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.03),(1.385,4.63),(2.305,4.63),(2.305,3.03),(1.385,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(2.605,5.965),(2.605,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,2.86),(1.385,5.18),(2.305,5.18),(2.305,2.86),(1.385,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(2.71,6.07),(2.71,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.705,5.18),(1.705,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,5.425),(0.27,5.585),(0.43,5.585),(0.43,5.425),(0.27,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,5.425),(0.61,5.585),(0.77,5.585),(0.77,5.425),(0.61,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,5.425),(0.95,5.585),(1.11,5.585),(1.11,5.425),(0.95,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,5.425),(1.29,5.585),(1.45,5.585),(1.45,5.425),(1.29,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,5.425),(1.63,5.585),(1.79,5.585),(1.79,5.425),(1.63,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,5.425),(1.97,5.585),(2.13,5.585),(2.13,5.425),(1.97,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,5.345),(0.27,5.665),(2.13,5.665),(2.13,5.345),(0.27,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(2.4,5.76),(2.4,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.055,2.99),(1.055,5.05),(2.005,5.05),(2.005,2.99),(1.055,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,2.87),(0.4,5.17),(1.13,5.17),(1.13,2.87),(0.4,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,2.87),(1.165,5.17),(1.895,5.17),(1.895,2.87),(1.165,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.91,2.87),(0.91,5.17),(1.64,5.17),(1.64,2.87),(0.91,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.04),(1.515,4.62),(2.175,4.62),(2.175,3.04),(1.515,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.02,-0.075),(0.02,0.585),(2.38,0.585),(2.38,-0.075),(0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(2.475,5.17),(2.475,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,2.87),(1.515,5.17),(2.175,5.17),(2.175,2.87),(1.515,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.575,5.17),(1.575,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.175,5.17),(2.175,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.475,0.585),(2.475,-0.075),(-0.075,-0.075)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.42),(0.615,2.4),(0.915,2.4),(0.915,1.42),(0.615,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.995,4.87),(1.995,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,1.42),(1.695,2.4),(1.995,2.4),(1.995,1.42),(1.695,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,2.55),(1.995,2.55),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,2.55),(1.825,2.55),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.55),(0.915,2.55),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,3.17),(1.595,4.87),(1.825,4.87),(1.825,3.17),(1.595,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.34),(1.695,4.32),(1.995,4.32),(1.995,3.34),(1.695,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.17),(1.695,4.87),(1.995,4.87),(1.995,3.17),(1.695,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.995,2.55),(1.995,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.49),(0.685,1.65),(0.845,1.65),(0.845,1.49),(0.685,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.83),(0.685,1.99),(0.845,1.99),(0.845,1.83),(0.685,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,2.17),(0.685,2.33),(0.845,2.33),(0.845,2.17),(0.685,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.49),(1.765,1.65),(1.925,1.65),(1.925,1.49),(1.765,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.83),(1.765,1.99),(1.925,1.99),(1.925,1.83),(1.765,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,2.17),(1.765,2.33),(1.925,2.33),(1.925,2.17),(1.765,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.41),(1.765,3.57),(1.925,3.57),(1.925,3.41),(1.765,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.75),(1.765,3.91),(1.925,3.91),(1.925,3.75),(1.765,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.09),(1.765,4.25),(1.925,4.25),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.41),(1.765,2.41),(1.925,2.41),(1.925,1.41),(1.765,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,1.34),(0.765,2.48),(1.845,2.48),(1.845,1.34),(0.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.33),(1.765,4.33),(1.925,4.33),(1.925,3.33),(1.765,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.48),(0.845,2.48),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.41),(0.685,2.41),(0.845,2.41),(0.845,1.41),(0.685,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.34),(1.765,2.48),(1.925,2.48),(1.925,1.34),(1.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.24),(1.765,4.42),(1.925,4.42),(1.925,3.24),(1.765,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.34),(1.74,4.42),(1.95,4.42),(1.95,1.34),(1.74,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.58,3.17),(0.58,4.87),(0.95,4.87),(0.95,3.17),(0.58,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,2.7),(0.8,4.42),(1.01,4.42),(1.01,2.7),(0.8,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.09,3.17),(1.09,4.87),(1.46,4.87),(1.46,3.17),(1.09,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.395,4.87),(1.395,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,3.17),(1.235,4.87),(1.465,4.87),(1.465,3.17),(1.235,3.17)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,2.99),(1.465,5.05),(1.595,5.05),(1.595,2.99),(1.465,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.99),(1.595,2.99),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.73),(1.595,2.73),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,2.7),(1.31,4.42),(1.52,4.42),(1.52,2.7),(1.31,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['nor4_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,1.67),(2.505,1.67),(2.505,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.19),(2.505,1.19),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.67),(2.505,1.67),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.89),(2.105,1.67),(2.335,1.67),(2.335,0.89),(2.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,0.89),(1.975,1.67),(2.105,1.67),(2.105,0.89),(1.975,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.67),(1.425,1.67),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,0.96),(2.275,1.12),(2.435,1.12),(2.435,0.96),(2.275,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,0.96),(2.195,1.12),(2.515,1.12),(2.515,0.96),(2.195,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,4.09),(1.975,4.87),(2.105,4.87),(2.105,4.09),(1.975,4.09)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,3.78),(0.27,5.18),(1.26,5.18),(1.26,3.78),(0.27,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.215,5.18),(2.215,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.78,3.78),(0.78,5.18),(1.77,5.18),(1.77,3.78),(0.78,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.29,3.78),(1.29,5.18),(2.28,5.18),(2.28,3.78),(1.29,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,3.78),(1.865,5.18),(2.815,5.18),(2.815,3.78),(1.865,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.78),(1.895,5.18),(2.815,5.18),(2.815,3.78),(1.895,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.435,3.78),(1.435,5.18),(2.645,5.18),(2.645,3.78),(1.435,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.79),(1.895,4.71),(2.815,4.71),(2.815,3.79),(1.895,3.79)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.42,3.79),(1.42,5.17),(2.15,5.17),(2.15,3.79),(1.42,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.91,3.79),(0.91,5.17),(1.64,5.17),(1.64,3.79),(0.91,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.79),(2.025,5.17),(2.685,5.17),(2.685,3.79),(2.025,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,3.79),(0.4,5.17),(1.13,5.17),(1.13,3.79),(0.4,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.675,3.79),(1.675,5.17),(2.405,5.17),(2.405,3.79),(1.675,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.565,3.91),(1.565,5.05),(2.515,5.05),(2.515,3.91),(1.565,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.085,5.17),(2.085,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,3.79),(1.995,5.17),(2.685,5.17),(2.685,3.79),(1.995,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.8),(2.025,4.7),(2.685,4.7),(2.685,3.8),(2.025,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.745,0.89),(1.745,1.67),(1.975,1.67),(1.975,0.89),(1.745,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.1),(2.205,4.4),(2.505,4.4),(2.505,4.1),(2.205,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,4.09),(2.175,4.87),(2.505,4.87),(2.505,4.09),(2.175,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.09),(2.205,4.87),(2.505,4.87),(2.505,4.09),(2.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.09),(2.105,4.87),(2.335,4.87),(2.335,4.09),(2.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.905,1.67),(1.905,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,1.36),(1.635,1.66),(1.935,1.66),(1.935,1.36),(1.635,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,0.89),(1.635,1.67),(1.935,1.67),(1.935,0.89),(1.635,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.36),(0.615,1.66),(0.915,1.66),(0.915,1.36),(0.615,1.36)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.43),(0.685,1.59),(0.845,1.59),(0.845,1.43),(0.685,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,1.43),(1.705,1.59),(1.865,1.59),(1.865,1.43),(1.705,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.17),(2.275,4.33),(2.435,4.33),(2.435,4.17),(2.275,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,1.34),(2.25,4.42),(2.46,4.42),(2.46,1.34),(2.25,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,1.34),(0.765,1.67),(2.355,1.67),(2.355,1.34),(0.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,1.35),(2.25,1.67),(2.46,1.67),(2.46,1.35),(2.25,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,4.09),(2.275,4.42),(2.435,4.42),(2.435,4.09),(2.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,1.35),(1.705,1.67),(1.865,1.67),(1.865,1.35),(1.705,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.35),(0.685,1.67),(0.845,1.67),(0.845,1.35),(0.685,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,1.67),(0.845,1.67),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,4.09),(2.275,4.41),(2.435,4.41),(2.435,4.09),(2.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,1.34),(1.705,1.67),(1.865,1.67),(1.865,1.34),(1.705,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,4.09),(0.58,4.87),(0.95,4.87),(0.95,4.09),(0.58,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,4.42),(1.01,4.42),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,4.09),(1.09,4.87),(1.46,4.87),(1.46,4.09),(1.09,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.89),(1.31,4.42),(1.52,4.42),(1.52,1.89),(1.31,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((1.745,4.09),(1.745,4.87),(1.975,4.87),(1.975,4.09),(1.745,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.905,4.87),(1.905,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.6,4.09),(1.6,4.87),(1.97,4.87),(1.97,4.09),(1.6,4.09)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((1.975,3.91),(1.975,5.05),(2.105,5.05),(2.105,3.91),(1.975,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,2.71),(1.925,3.01),(2.04,3.01),(2.04,2.71),(1.925,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,3.91),(2.105,3.91),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,2.71),(1.775,3.01),(2.075,3.01),(2.075,2.71),(1.775,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,1.85),(2.105,1.85),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,2.78),(1.845,2.94),(2.005,2.94),(2.005,2.78),(1.845,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,2.7),(1.845,3.02),(2.005,3.02),(2.005,2.7),(1.845,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.89),(1.82,4.42),(2.03,4.42),(2.03,1.89),(1.82,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.925), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.925), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['nor4_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,0.89),(1.975,2.55),(2.105,2.55),(2.105,0.89),(1.975,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.89),(2.105,2.55),(2.335,2.55),(2.335,0.89),(2.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,2.55),(2.505,2.55),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,2.55),(1.595,2.55),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.19),(2.505,1.19),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,2.55),(1.425,2.55),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,2.55),(2.505,2.55),(2.505,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,2.55),(1.465,2.55),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.395,2.55),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,0.96),(2.275,1.12),(2.435,1.12),(2.435,0.96),(2.275,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,0.96),(2.195,1.12),(2.515,1.12),(2.515,0.96),(2.195,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,3.17),(1.465,4.87),(1.595,4.87),(1.595,3.17),(1.465,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,3.17),(1.975,4.87),(2.105,4.87),(2.105,3.17),(1.975,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,2.86),(1.895,5.18),(2.815,5.18),(2.815,2.86),(1.895,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,2.86),(1.865,5.18),(2.815,5.18),(2.815,2.86),(1.865,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,2.86),(0.925,5.18),(2.135,5.18),(2.135,2.86),(0.925,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,2.86),(0.27,5.18),(1.26,5.18),(1.26,2.86),(0.27,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.215,5.18),(2.215,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.03),(1.895,4.63),(2.815,4.63),(2.815,3.03),(1.895,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.705,5.18),(1.705,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.78,2.86),(0.78,5.18),(1.77,5.18),(1.77,2.86),(0.78,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.435,2.86),(1.435,5.18),(2.645,5.18),(2.645,2.86),(1.435,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.29,2.86),(1.29,5.18),(2.28,5.18),(2.28,2.86),(1.29,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.055,2.99),(1.055,5.05),(2.005,5.05),(2.005,2.99),(1.055,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,2.87),(0.4,5.17),(1.13,5.17),(1.13,2.87),(0.4,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.085,5.17),(2.085,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.04),(2.025,4.62),(2.685,4.62),(2.685,3.04),(2.025,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,2.87),(1.165,5.17),(1.895,5.17),(1.895,2.87),(1.165,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,2.87),(2.025,5.17),(2.685,5.17),(2.685,2.87),(2.025,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.91,2.87),(0.91,5.17),(1.64,5.17),(1.64,2.87),(0.91,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.42,2.87),(1.42,5.17),(2.15,5.17),(2.15,2.87),(1.42,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.565,2.99),(1.565,5.05),(2.515,5.05),(2.515,2.99),(1.565,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.675,2.87),(1.675,5.17),(2.405,5.17),(2.405,2.87),(1.675,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.575,5.17),(1.575,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,2.87),(1.995,5.17),(2.685,5.17),(2.685,2.87),(1.995,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.17),(2.205,4.87),(2.505,4.87),(2.505,3.17),(2.205,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.42),(0.615,2.4),(0.915,2.4),(0.915,1.42),(0.615,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.905,2.55),(1.905,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,1.42),(1.635,2.4),(1.935,2.4),(1.935,1.42),(1.635,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,3.17),(2.175,4.87),(2.505,4.87),(2.505,3.17),(2.175,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,2.55),(1.825,2.55),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,3.17),(2.105,4.87),(2.335,4.87),(2.335,3.17),(2.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.55),(0.915,2.55),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,0.89),(1.635,2.55),(1.935,2.55),(1.935,0.89),(1.635,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.34),(2.205,4.32),(2.505,4.32),(2.505,3.34),(2.205,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,0.89),(1.745,2.55),(1.975,2.55),(1.975,0.89),(1.745,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.49),(0.685,1.65),(0.845,1.65),(0.845,1.49),(0.685,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.83),(0.685,1.99),(0.845,1.99),(0.845,1.83),(0.685,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,2.17),(0.685,2.33),(0.845,2.33),(0.845,2.17),(0.685,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,1.49),(1.705,1.65),(1.865,1.65),(1.865,1.49),(1.705,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,1.83),(1.705,1.99),(1.865,1.99),(1.865,1.83),(1.705,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,2.17),(1.705,2.33),(1.865,2.33),(1.865,2.17),(1.705,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,3.41),(2.275,3.57),(2.435,3.57),(2.435,3.41),(2.275,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,3.75),(2.275,3.91),(2.435,3.91),(2.435,3.75),(2.275,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.09),(2.275,4.25),(2.435,4.25),(2.435,4.09),(2.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,2.16),(2.25,2.48),(2.46,2.48),(2.46,2.16),(2.25,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,1.34),(2.25,4.42),(2.46,4.42),(2.46,1.34),(2.25,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,1.34),(1.705,2.48),(1.865,2.48),(1.865,1.34),(1.705,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,3.24),(2.275,4.42),(2.435,4.42),(2.435,3.24),(2.275,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,1.41),(1.705,2.41),(1.865,2.41),(1.865,1.41),(1.705,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,1.34),(0.765,2.48),(2.355,2.48),(2.355,1.34),(0.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,3.33),(2.275,4.33),(2.435,4.33),(2.435,3.33),(2.275,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,2.48),(0.845,2.48),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.41),(0.685,2.41),(0.845,2.41),(0.845,1.41),(0.685,1.41)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,4.42),(0.36,4.42),(0.36,1.34),(0.15,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.58,3.17),(0.58,4.87),(0.95,4.87),(0.95,3.17),(0.58,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,2.7),(0.8,4.42),(1.01,4.42),(1.01,2.7),(0.8,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.09,3.17),(1.09,4.87),(1.46,4.87),(1.46,3.17),(1.09,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.395,4.87),(1.395,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,3.17),(1.235,4.87),(1.465,4.87),(1.465,3.17),(1.235,3.17)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,2.99),(1.465,5.05),(1.595,5.05),(1.595,2.99),(1.465,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.99),(1.595,2.99),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.73),(1.595,2.73),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,2.7),(1.31,4.42),(1.52,4.42),(1.52,2.7),(1.31,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.905,4.87),(1.905,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,3.17),(1.745,4.87),(1.975,4.87),(1.975,3.17),(1.745,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,3.17),(1.595,4.87),(1.825,4.87),(1.825,3.17),(1.595,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.6,3.17),(1.6,4.87),(1.97,4.87),(1.97,3.17),(1.6,3.17)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,2.99),(2.105,2.99),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,2.71),(1.925,3.01),(2.04,3.01),(2.04,2.71),(1.925,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,2.73),(2.105,2.73),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,2.99),(1.975,5.05),(2.105,5.05),(2.105,2.99),(1.975,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,2.71),(1.775,3.01),(2.075,3.01),(2.075,2.71),(1.775,2.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,2.78),(1.845,2.94),(2.005,2.94),(2.005,2.78),(1.845,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,2.7),(1.845,3.02),(2.005,3.02),(2.005,2.7),(1.845,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,2.7),(1.82,4.42),(2.03,4.42),(2.03,2.7),(1.82,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.925), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.925), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['or2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(2.4000000000000004), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(2.295,0.405),(2.295,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.455,2.55),(1.455,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.19),(1.455,1.19),(1.455,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,0.105),(0.2,0.405),(2.2,0.405),(2.2,0.105),(0.2,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.265,0.89),(1.265,2.55),(1.495,2.55),(1.495,0.89),(1.265,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.425,2.55),(1.425,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.495,0.89),(1.495,2.55),(1.625,2.55),(1.625,0.89),(1.495,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.225,0.96),(1.225,1.12),(1.385,1.12),(1.385,0.96),(1.225,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,0.175),(0.27,0.335),(0.43,0.335),(0.43,0.175),(0.27,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,0.175),(0.61,0.335),(0.77,0.335),(0.77,0.175),(0.61,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,0.175),(0.95,0.335),(1.11,0.335),(1.11,0.175),(0.95,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,0.175),(1.29,0.335),(1.45,0.335),(1.45,0.175),(1.29,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,0.175),(1.63,0.335),(1.79,0.335),(1.79,0.175),(1.63,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,0.175),(1.97,0.335),(2.13,0.335),(2.13,0.175),(1.97,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(2.4,1.12),(2.4,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,0.095),(0.27,0.415),(2.13,0.415),(2.13,0.095),(0.27,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,0.96),(1.145,1.12),(1.465,1.12),(1.465,0.96),(1.145,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.36),(0.615,1.66),(0.915,1.66),(0.915,1.36),(0.615,1.36)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.43),(0.685,1.59),(0.845,1.59),(0.845,1.43),(0.685,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,4.09),(1.31,4.41),(1.52,4.41),(1.52,4.09),(1.31,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.35),(1.31,4.41),(1.52,4.41),(1.52,1.35),(1.31,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,4.09),(0.255,4.42),(1.415,4.42),(1.415,4.09),(0.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.35),(1.31,1.67),(1.52,1.67),(1.52,1.35),(1.31,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,1.67),(0.845,1.67),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.35),(0.685,1.67),(0.845,1.67),(0.845,1.35),(0.685,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,1.34),(0.765,1.67),(1.415,1.67),(1.415,1.34),(0.765,1.34)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.56,3.01),(1.56,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.495,0.71),(1.495,2.99),(1.625,2.99),(1.625,0.71),(1.495,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.495,2.99),(1.495,5.05),(1.625,5.05),(1.625,2.99),(1.495,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.495,0.71),(1.495,2.73),(1.625,2.73),(1.625,0.71),(1.495,0.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.195,2.87),(1.195,5.17),(1.925,5.17),(1.925,2.87),(1.195,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.635,5.17),(1.635,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,4.27),(0.975,5.17),(1.635,5.17),(1.635,4.27),(0.975,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.04),(1.515,4.62),(2.175,4.62),(2.175,3.04),(1.515,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,3.79),(0.4,5.17),(1.13,5.17),(1.13,3.79),(0.4,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.02,-0.075),(0.02,0.585),(2.38,0.585),(2.38,-0.075),(0.02,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(2.475,5.17),(2.475,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,2.87),(1.515,5.17),(2.175,5.17),(2.175,2.87),(1.515,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.085,2.99),(1.085,5.05),(2.035,5.05),(2.035,2.99),(1.085,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,2.87),(1.515,5.17),(2.175,5.17),(2.175,2.87),(1.515,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.605,5.17),(1.605,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(2.475,0.585),(2.475,-0.075),(-0.075,-0.075)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.11,5.045),(-0.11,5.965),(2.51,5.965),(2.51,5.045),(-0.11,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,3.78),(0.27,5.18),(1.26,5.18),(1.26,3.78),(0.27,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.03),(1.385,4.63),(2.305,4.63),(2.305,3.03),(1.385,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(2.605,5.965),(2.605,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,2.86),(1.385,5.18),(2.305,5.18),(2.305,2.86),(1.385,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(2.71,6.07),(2.71,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.955,2.86),(0.955,5.18),(2.165,5.18),(2.165,2.86),(0.955,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.765,5.18),(1.765,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,2.86),(1.385,5.18),(2.305,5.18),(2.305,2.86),(1.385,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,4.26),(0.845,5.18),(1.765,5.18),(1.765,4.26),(0.845,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.735,5.18),(1.735,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.495,3.17),(1.495,4.87),(1.625,4.87),(1.625,3.17),(1.495,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.455,4.87),(1.455,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.425,4.87),(1.425,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.2,5.355),(0.2,5.655),(2.2,5.655),(2.2,5.355),(0.2,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(2.295,5.655),(2.295,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.265,3.17),(1.265,4.87),(1.495,4.87),(1.495,3.17),(1.265,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.57),(1.155,4.87),(1.455,4.87),(1.455,4.57),(1.155,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.27,5.425),(0.27,5.585),(0.43,5.585),(0.43,5.425),(0.27,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.61,5.425),(0.61,5.585),(0.77,5.585),(0.77,5.425),(0.61,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.95,5.425),(0.95,5.585),(1.11,5.585),(1.11,5.425),(0.95,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.29,5.425),(1.29,5.585),(1.45,5.585),(1.45,5.425),(1.29,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.63,5.425),(1.63,5.585),(1.79,5.585),(1.79,5.425),(1.63,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.97,5.425),(1.97,5.585),(2.13,5.585),(2.13,5.425),(1.97,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.225,4.64),(1.225,4.8),(1.385,4.8),(1.385,4.64),(1.225,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.145,4.64),(1.145,4.8),(1.465,4.8),(1.465,4.64),(1.145,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.27,5.345),(0.27,5.665),(2.13,5.665),(2.13,5.345),(0.27,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(2.4,5.76),(2.4,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.2), u(2.4), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,3.87),(0.36,3.87),(0.36,1.34),(0.15,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,4.09),(0.58,4.87),(0.95,4.87),(0.95,4.09),(0.58,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,3.87),(1.01,3.87),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((1.625,3.17),(1.625,4.87),(1.855,4.87),(1.855,3.17),(1.625,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,1.42),(1.695,2.4),(1.995,2.4),(1.995,1.42),(1.695,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,2.55),(1.995,2.55),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.34),(1.695,4.32),(1.995,4.32),(1.995,3.34),(1.695,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.17),(1.695,4.87),(1.995,4.87),(1.995,3.17),(1.695,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.17),(1.695,4.87),(1.995,4.87),(1.995,3.17),(1.695,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.625,0.89),(1.625,2.55),(1.855,2.55),(1.855,0.89),(1.625,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,2.55),(1.995,2.55),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.49),(1.765,1.65),(1.925,1.65),(1.925,1.49),(1.765,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.83),(1.765,1.99),(1.925,1.99),(1.925,1.83),(1.765,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,2.17),(1.765,2.33),(1.925,2.33),(1.925,2.17),(1.765,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.41),(1.765,3.57),(1.925,3.57),(1.925,3.41),(1.765,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.75),(1.765,3.91),(1.925,3.91),(1.925,3.75),(1.765,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.09),(1.765,4.25),(1.925,4.25),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.41),(1.765,2.41),(1.925,2.41),(1.925,1.41),(1.765,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.33),(1.765,4.33),(1.925,4.33),(1.925,3.33),(1.765,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.34),(1.765,2.48),(1.925,2.48),(1.925,1.34),(1.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.24),(1.765,4.42),(1.925,4.42),(1.925,3.24),(1.765,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.34),(1.74,4.42),(1.95,4.42),(1.95,1.34),(1.74,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)

    cell = new_cells['or3_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.67),(1.425,1.67),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,1.36),(1.125,1.66),(1.425,1.66),(1.425,1.36),(1.125,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,1.43),(1.195,1.59),(1.355,1.59),(1.355,1.43),(1.195,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,2.78),(1.845,2.94),(2.005,2.94),(2.005,2.78),(1.845,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,2.7),(1.845,3.02),(2.005,3.02),(2.005,2.7),(1.845,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,4.09),(1.82,4.41),(2.03,4.41),(2.03,4.09),(1.82,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,4.09),(0.255,4.42),(1.925,4.42),(1.925,4.09),(0.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.195,1.34),(1.195,1.67),(1.355,1.67),(1.355,1.34),(1.195,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.35),(1.82,1.67),(2.03,1.67),(2.03,1.35),(1.82,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.35),(1.82,4.41),(2.03,4.41),(2.03,1.35),(1.82,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,1.67),(1.925,1.67),(1.925,1.34),(0.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.195,1.35),(1.195,1.67),(1.355,1.67),(1.355,1.35),(1.195,1.35)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.005,2.99),(2.005,5.05),(2.135,5.05),(2.135,2.99),(2.005,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,2.71),(1.775,3.01),(2.075,3.01),(2.075,2.71),(1.775,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,2.71),(1.925,3.01),(2.07,3.01),(2.07,2.71),(1.925,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.005,0.71),(2.005,2.99),(2.135,2.99),(2.135,0.71),(2.005,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.005,0.71),(2.005,2.73),(2.135,2.73),(2.135,0.71),(2.005,0.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((2.025,2.87),(2.025,5.17),(2.685,5.17),(2.685,2.87),(2.025,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.145,5.17),(2.145,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.04),(2.025,4.62),(2.685,4.62),(2.685,3.04),(2.025,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,2.87),(2.025,5.17),(2.685,5.17),(2.685,2.87),(2.025,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.91,3.79),(0.91,5.17),(1.64,5.17),(1.64,3.79),(0.91,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.595,2.99),(1.595,5.05),(2.545,5.05),(2.545,2.99),(1.595,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,3.79),(0.4,5.17),(1.13,5.17),(1.13,3.79),(0.4,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,4.27),(1.485,5.17),(2.145,5.17),(2.145,4.27),(1.485,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.705,2.87),(1.705,5.17),(2.435,5.17),(2.435,2.87),(1.705,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,2.87),(1.485,5.17),(2.115,5.17),(2.115,2.87),(1.485,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,2.86),(1.895,5.18),(2.815,5.18),(2.815,2.86),(1.895,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,2.86),(1.895,5.18),(2.815,5.18),(2.815,2.86),(1.895,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.465,2.86),(1.465,5.18),(2.675,5.18),(2.675,2.86),(1.465,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,3.78),(0.27,5.18),(1.26,5.18),(1.26,3.78),(0.27,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.78,3.78),(0.78,5.18),(1.77,5.18),(1.77,3.78),(0.78,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.03),(1.895,4.63),(2.815,4.63),(2.815,3.03),(1.895,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,4.26),(1.355,5.18),(2.275,5.18),(2.275,4.26),(1.355,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.245,5.18),(2.245,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,2.86),(1.355,5.18),(2.275,5.18),(2.275,2.86),(1.355,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.005,3.17),(2.005,4.87),(2.135,4.87),(2.135,3.17),(2.005,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.775,3.17),(1.775,4.87),(2.005,4.87),(2.005,3.17),(1.775,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.965,4.87),(1.965,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.57),(1.665,4.87),(1.965,4.87),(1.965,4.57),(1.665,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.17),(1.665,4.87),(1.935,4.87),(1.935,3.17),(1.665,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.735,4.64),(1.735,4.8),(1.895,4.8),(1.895,4.64),(1.735,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.655,4.64),(1.655,4.8),(1.975,4.8),(1.975,4.64),(1.655,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.19),(1.965,1.19),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.935,2.55),(1.935,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.775,0.89),(1.775,2.55),(2.005,2.55),(2.005,0.89),(1.775,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.55),(1.965,2.55),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.005,0.89),(2.005,2.55),(2.135,2.55),(2.135,0.89),(2.005,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.735,0.96),(1.735,1.12),(1.895,1.12),(1.895,0.96),(1.735,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.655,0.96),(1.655,1.12),(1.975,1.12),(1.975,0.96),(1.655,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.89),(0.15,3.87),(0.36,3.87),(0.36,1.89),(0.15,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,4.09),(0.58,4.87),(0.95,4.87),(0.95,4.09),(0.58,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,3.87),(1.01,3.87),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,4.09),(1.09,4.87),(1.46,4.87),(1.46,4.09),(1.09,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.89),(1.31,3.87),(1.52,3.87),(1.52,1.89),(1.31,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((2.205,3.17),(2.205,4.87),(2.505,4.87),(2.505,3.17),(2.205,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.17),(2.205,4.87),(2.505,4.87),(2.505,3.17),(2.205,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.34),(2.205,4.32),(2.505,4.32),(2.505,3.34),(2.205,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,2.55),(2.505,2.55),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,0.89),(2.135,2.55),(2.365,2.55),(2.365,0.89),(2.135,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.135,3.17),(2.135,4.87),(2.365,4.87),(2.365,3.17),(2.135,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,1.42),(2.205,2.4),(2.505,2.4),(2.505,1.42),(2.205,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,2.55),(2.505,2.55),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.49),(2.275,1.65),(2.435,1.65),(2.435,1.49),(2.275,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.83),(2.275,1.99),(2.435,1.99),(2.435,1.83),(2.275,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,2.17),(2.275,2.33),(2.435,2.33),(2.435,2.17),(2.275,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,3.41),(2.275,3.57),(2.435,3.57),(2.435,3.41),(2.275,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,3.75),(2.275,3.91),(2.435,3.91),(2.435,3.75),(2.275,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.09),(2.275,4.25),(2.435,4.25),(2.435,4.09),(2.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.25,1.34),(2.25,4.42),(2.46,4.42),(2.46,1.34),(2.25,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,3.24),(2.275,4.42),(2.435,4.42),(2.435,3.24),(2.275,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.34),(2.275,2.48),(2.435,2.48),(2.435,1.34),(2.275,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.41),(2.275,2.41),(2.435,2.41),(2.435,1.41),(2.275,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,3.33),(2.275,4.33),(2.435,4.33),(2.435,3.33),(2.275,3.33)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.355), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['or4_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'i3': Net.create(cell, 'i3'),
            'nq': Net.create(cell, 'nq'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.285,0.89),(2.285,2.55),(2.515,2.55),(2.515,0.89),(2.285,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,2.55),(2.475,2.55),(2.475,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,2.55),(2.445,2.55),(2.445,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,0.89),(2.105,1.67),(2.335,1.67),(2.335,0.89),(2.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.515,0.89),(2.515,2.55),(2.645,2.55),(2.645,0.89),(2.515,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,0.89),(1.975,1.67),(2.105,1.67),(2.105,0.89),(1.975,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,0.89),(2.175,1.19),(2.475,1.19),(2.475,0.89),(2.175,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.67),(1.425,1.67),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.245,0.96),(2.245,1.12),(2.405,1.12),(2.405,0.96),(2.245,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.165,0.96),(2.165,1.12),(2.485,1.12),(2.485,0.96),(2.165,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.745,0.89),(1.745,1.67),(1.975,1.67),(1.975,0.89),(1.745,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,1.36),(1.635,1.66),(1.935,1.66),(1.935,1.36),(1.635,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.905,1.67),(1.905,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.635,0.89),(1.635,1.67),(1.935,1.67),(1.935,0.89),(1.635,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,1.36),(0.615,1.66),(0.915,1.66),(0.915,1.36),(0.615,1.36)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,1.43),(0.685,1.59),(0.845,1.59),(0.845,1.43),(0.685,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.705,1.43),(1.705,1.59),(1.865,1.59),(1.865,1.43),(1.705,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.355,2.78),(2.355,2.94),(2.515,2.94),(2.515,2.78),(2.355,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.33,1.35),(2.33,4.41),(2.54,4.41),(2.54,1.35),(2.33,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.33,1.35),(2.33,1.67),(2.54,1.67),(2.54,1.35),(2.33,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,4.09),(0.255,4.42),(2.435,4.42),(2.435,4.09),(0.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,1.35),(1.705,1.67),(1.865,1.67),(1.865,1.35),(1.705,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.34),(0.685,1.67),(0.845,1.67),(0.845,1.34),(0.685,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,1.35),(0.685,1.67),(0.845,1.67),(0.845,1.35),(0.685,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.765,1.34),(0.765,1.67),(2.435,1.67),(2.435,1.34),(0.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.355,2.7),(2.355,3.02),(2.515,3.02),(2.515,2.7),(2.355,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.33,4.09),(2.33,4.41),(2.54,4.41),(2.54,4.09),(2.33,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.705,1.34),(1.705,1.67),(1.865,1.67),(1.865,1.34),(1.705,1.34)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.515,0.71),(2.515,2.73),(2.645,2.73),(2.645,0.71),(2.515,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.285,2.71),(2.285,3.01),(2.585,3.01),(2.585,2.71),(2.285,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.435,2.71),(2.435,3.01),(2.58,3.01),(2.58,2.71),(2.435,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.515,2.99),(2.515,5.05),(2.645,5.05),(2.645,2.99),(2.515,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.515,0.71),(2.515,2.99),(2.645,2.99),(2.645,0.71),(2.515,0.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((2.535,2.87),(2.535,5.17),(3.195,5.17),(3.195,2.87),(2.535,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.04),(2.535,4.62),(3.195,4.62),(3.195,3.04),(2.535,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.42,3.79),(1.42,5.17),(2.15,5.17),(2.15,3.79),(1.42,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,2.87),(1.995,5.17),(2.655,5.17),(2.655,2.87),(1.995,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.91,3.79),(0.91,5.17),(1.64,5.17),(1.64,3.79),(0.91,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,3.79),(0.4,5.17),(1.13,5.17),(1.13,3.79),(0.4,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.675,3.79),(1.675,5.17),(2.405,5.17),(2.405,3.79),(1.675,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.565,3.91),(1.565,5.05),(2.515,5.05),(2.515,3.91),(1.565,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.105,2.99),(2.105,5.05),(3.055,5.05),(3.055,2.99),(2.105,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,2.87),(2.535,5.17),(3.195,5.17),(3.195,2.87),(2.535,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.085,5.17),(2.085,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.215,2.87),(2.215,5.17),(2.945,5.17),(2.945,2.87),(2.215,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,4.27),(1.995,5.17),(2.655,5.17),(2.655,4.27),(1.995,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.995,2.87),(1.995,5.17),(2.625,5.17),(2.625,2.87),(1.995,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.975,2.86),(1.975,5.18),(3.185,5.18),(3.185,2.86),(1.975,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,3.78),(0.27,5.18),(1.26,5.18),(1.26,3.78),(0.27,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.215,5.18),(2.215,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.78,3.78),(0.78,5.18),(1.77,5.18),(1.77,3.78),(0.78,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,2.86),(2.405,5.18),(3.325,5.18),(3.325,2.86),(2.405,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,2.86),(1.865,5.18),(2.755,5.18),(2.755,2.86),(1.865,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,3.03),(2.405,4.63),(3.325,4.63),(3.325,3.03),(2.405,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.29,3.78),(1.29,5.18),(2.28,5.18),(2.28,3.78),(1.29,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.435,3.78),(1.435,5.18),(2.645,5.18),(2.645,3.78),(1.435,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,2.86),(1.865,5.18),(2.785,5.18),(2.785,2.86),(1.865,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,2.86),(2.405,5.18),(3.325,5.18),(3.325,2.86),(2.405,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.865,4.26),(1.865,5.18),(2.785,5.18),(2.785,4.26),(1.865,4.26)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.285,3.17),(2.285,4.87),(2.515,4.87),(2.515,3.17),(2.285,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.105,4.09),(2.105,4.87),(2.335,4.87),(2.335,4.09),(2.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.515,3.17),(2.515,4.87),(2.645,4.87),(2.645,3.17),(2.515,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,3.17),(2.175,4.87),(2.475,4.87),(2.475,3.17),(2.175,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.975,4.09),(1.975,4.87),(2.105,4.87),(2.105,4.09),(1.975,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,3.17),(2.175,4.87),(2.445,4.87),(2.445,3.17),(2.175,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.175,4.57),(2.175,4.87),(2.475,4.87),(2.475,4.57),(2.175,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.245,4.64),(2.245,4.8),(2.405,4.8),(2.405,4.64),(2.245,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.165,4.64),(2.165,4.8),(2.485,4.8),(2.485,4.64),(2.165,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,3.87),(0.36,3.87),(0.36,1.34),(0.15,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,4.09),(0.58,4.87),(0.95,4.87),(0.95,4.09),(0.58,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,3.87),(1.01,3.87),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,4.09),(1.09,4.87),(1.46,4.87),(1.46,4.09),(1.09,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.71),(1.415,3.01),(1.53,3.01),(1.53,2.71),(1.415,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.71),(1.265,3.01),(1.565,3.01),(1.565,2.71),(1.265,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,2.78),(1.335,2.94),(1.495,2.94),(1.495,2.78),(1.335,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.7),(1.335,3.02),(1.495,3.02),(1.495,2.7),(1.335,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.31,1.89),(1.31,3.87),(1.52,3.87),(1.52,1.89),(1.31,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.415), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.415), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((1.745,4.09),(1.745,4.87),(1.975,4.87),(1.975,4.09),(1.745,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.905,4.87),(1.905,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.6,4.09),(1.6,4.87),(1.97,4.87),(1.97,4.09),(1.6,4.09)),
        )
        net = nets['i3']
        createRL(
            tech, net, 'GatPoly',
            ((1.975,3.91),(1.975,5.05),(2.105,5.05),(2.105,3.91),(1.975,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,2.71),(1.925,3.01),(2.04,3.01),(2.04,2.71),(1.925,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,3.91),(2.105,3.91),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,2.71),(1.775,3.01),(2.075,3.01),(2.075,2.71),(1.775,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.975,0.71),(1.975,1.85),(2.105,1.85),(2.105,0.71),(1.975,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,2.78),(1.845,2.94),(2.005,2.94),(2.005,2.78),(1.845,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,2.7),(1.845,3.02),(2.005,3.02),(2.005,2.7),(1.845,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.82,1.89),(1.82,3.87),(2.03,3.87),(2.03,1.89),(1.82,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.925), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.925), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((2.715,3.34),(2.715,4.32),(3.015,4.32),(3.015,3.34),(2.715,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,2.55),(3.015,2.55),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,3.17),(2.715,4.87),(3.015,4.87),(3.015,3.17),(2.715,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,2.55),(3.015,2.55),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,3.17),(2.715,4.87),(3.015,4.87),(3.015,3.17),(2.715,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,1.42),(2.715,2.4),(3.015,2.4),(3.015,1.42),(2.715,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.645,0.89),(2.645,2.55),(2.875,2.55),(2.875,0.89),(2.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.645,3.17),(2.645,4.87),(2.875,4.87),(2.875,3.17),(2.645,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,3.41),(2.785,3.57),(2.945,3.57),(2.945,3.41),(2.785,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,3.75),(2.785,3.91),(2.945,3.91),(2.945,3.75),(2.785,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,4.09),(2.785,4.25),(2.945,4.25),(2.945,4.09),(2.785,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,1.49),(2.785,1.65),(2.945,1.65),(2.945,1.49),(2.785,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,1.83),(2.785,1.99),(2.945,1.99),(2.945,1.83),(2.785,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,2.17),(2.785,2.33),(2.945,2.33),(2.945,2.17),(2.785,2.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.785,1.41),(2.785,2.41),(2.945,2.41),(2.945,1.41),(2.785,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.76,1.34),(2.76,4.42),(2.97,4.42),(2.97,1.34),(2.76,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.785,1.34),(2.785,2.48),(2.945,2.48),(2.945,1.34),(2.785,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.785,3.33),(2.785,4.33),(2.945,4.33),(2.945,3.33),(2.785,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.785,3.24),(2.785,4.42),(2.945,4.42),(2.945,3.24),(2.785,3.24)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.865), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.865), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)
        nets['i3'].setDirection(Net.Direction.IN)

    cell = new_cells['mux2_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_q_n': Net.create(cell, '_q_n'),
            'cmd': Net.create(cell, 'cmd'),
            'cmd_n': Net.create(cell, 'cmd_n'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['cmd_n']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.515,2.24),(1.515,2.4),(1.675,2.4),(1.675,2.24),(1.515,2.24)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.845,3.32),(1.845,3.48),(2.005,3.48),(2.005,3.32),(1.845,3.32)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.515,2.16),(1.515,2.48),(1.675,2.48),(1.675,2.16),(1.515,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.35),(0.15,4.41),(0.36,4.41),(0.36,1.35),(0.15,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.595,3.24),(1.595,3.56),(1.925,3.56),(1.925,3.24),(1.595,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.49,3.24),(1.49,3.56),(1.7,3.56),(1.7,3.24),(1.49,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.49,1.35),(1.49,3.56),(1.7,3.56),(1.7,1.35),(1.49,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,1.67),(1.595,1.67),(1.595,1.34),(0.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,3.24),(1.845,3.56),(2.005,3.56),(2.005,3.24),(1.845,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.49,1.35),(1.49,1.67),(1.7,1.67),(1.7,1.35),(1.49,1.35)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.775,3.25),(1.775,3.55),(2.075,3.55),(2.075,3.25),(1.775,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.53,2.17),(1.53,2.47),(1.595,2.47),(1.595,2.17),(1.53,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.215,3.25),(2.215,5.05),(2.345,5.05),(2.345,3.25),(2.215,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.925,3.25),(1.925,3.55),(2.28,3.55),(2.28,3.25),(1.925,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.445,2.17),(1.445,2.47),(1.745,2.47),(1.745,2.17),(1.445,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.215,3.91),(2.215,5.05),(2.345,5.05),(2.345,3.91),(2.215,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.47),(1.595,2.47),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.235,3.79),(2.235,5.17),(2.835,5.17),(2.835,3.79),(2.235,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.17,3.79),(2.17,5.17),(2.9,5.17),(2.9,3.79),(2.17,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.285,3.32),(3.285,5.17),(3.945,5.17),(3.945,3.32),(3.285,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.855,3.44),(2.855,5.05),(3.805,5.05),(3.805,3.44),(2.855,3.44)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.915,3.79),(1.915,5.17),(2.645,5.17),(2.645,3.79),(1.915,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.285,3.65),(3.285,4.55),(3.945,4.55),(3.945,3.65),(3.285,3.65)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(4.075,5.17),(4.075,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.91,3.79),(0.91,5.17),(1.64,5.17),(1.64,3.79),(0.91,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.325,5.17),(2.325,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.805,3.91),(1.805,5.05),(2.755,5.05),(2.755,3.91),(1.805,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.8),(1.695,4.7),(2.355,4.7),(2.355,3.8),(1.695,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.695,3.79),(1.695,5.17),(2.355,5.17),(2.355,3.79),(1.695,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.285,3.32),(3.285,5.17),(3.945,5.17),(3.945,3.32),(3.285,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.745,3.32),(2.745,5.17),(3.405,5.17),(3.405,3.32),(2.745,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.965,3.32),(2.965,5.17),(3.695,5.17),(3.695,3.32),(2.965,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.315,3.91),(2.315,5.05),(3.265,5.05),(3.265,3.91),(2.315,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.745,3.32),(2.745,5.17),(3.375,5.17),(3.375,3.32),(2.745,3.32)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.425,3.79),(2.425,5.17),(3.155,5.17),(3.155,3.79),(2.425,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.745,4.27),(2.745,5.17),(3.405,5.17),(3.405,4.27),(2.745,4.27)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.615,4.26),(2.615,5.18),(3.535,5.18),(3.535,4.26),(2.615,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.615,3.31),(2.615,5.18),(3.535,5.18),(3.535,3.31),(2.615,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(4.205,5.965),(4.205,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.155,3.31),(3.155,5.18),(4.075,5.18),(4.075,3.31),(3.155,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.04,3.78),(2.04,5.18),(3.03,5.18),(3.03,3.78),(2.04,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.78,3.78),(0.78,5.18),(1.77,5.18),(1.77,3.78),(0.78,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.155,3.31),(3.155,5.18),(4.075,5.18),(4.075,3.31),(3.155,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.155,3.64),(3.155,4.56),(4.075,4.56),(4.075,3.64),(3.155,3.64)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.675,3.78),(1.675,5.18),(2.885,5.18),(2.885,3.78),(1.675,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.455,5.18),(2.455,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.615,3.31),(2.615,5.18),(3.505,5.18),(3.505,3.31),(2.615,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.79),(1.565,4.71),(2.485,4.71),(2.485,3.79),(1.565,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.565,3.78),(1.565,5.18),(2.485,5.18),(2.485,3.78),(1.565,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,5.045),(-0.16,5.965),(4.16,5.965),(4.16,5.045),(-0.16,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(4.31,6.07),(4.31,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.185,3.78),(2.185,5.18),(3.395,5.18),(3.395,3.78),(2.185,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.725,3.31),(2.725,5.18),(3.935,5.18),(3.935,3.31),(2.725,3.31)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.105,3.78),(2.105,5.18),(2.965,5.18),(2.965,3.78),(2.105,3.78)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.035,3.62),(3.035,4.87),(3.265,4.87),(3.265,3.62),(3.035,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.265,3.62),(3.265,4.87),(3.395,4.87),(3.395,3.62),(3.265,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.925,3.62),(2.925,4.87),(3.195,4.87),(3.195,3.62),(2.925,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.895,5.655),(3.895,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.925,4.57),(2.925,4.87),(3.225,4.87),(3.225,4.57),(2.925,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,5.355),(0.15,5.655),(3.85,5.655),(3.85,5.355),(0.15,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.925,3.62),(2.925,4.87),(3.225,4.87),(3.225,3.62),(2.925,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.215,4.09),(2.215,4.87),(2.345,4.87),(2.345,4.09),(2.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.855,4.09),(2.855,4.87),(3.085,4.87),(3.085,4.09),(2.855,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.725,4.09),(2.725,4.87),(2.855,4.87),(2.855,4.09),(2.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.995,4.64),(2.995,4.8),(3.155,4.8),(3.155,4.64),(2.995,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,5.425),(0.22,5.585),(0.38,5.585),(0.38,5.425),(0.22,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,5.425),(0.56,5.585),(0.72,5.585),(0.72,5.425),(0.56,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,5.425),(0.9,5.585),(1.06,5.585),(1.06,5.425),(0.9,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,5.425),(1.24,5.585),(1.4,5.585),(1.4,5.425),(1.24,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,5.425),(1.58,5.585),(1.74,5.585),(1.74,5.425),(1.58,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,5.425),(1.92,5.585),(2.08,5.585),(2.08,5.425),(1.92,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,5.425),(2.26,5.585),(2.42,5.585),(2.42,5.425),(2.26,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,5.425),(2.6,5.585),(2.76,5.585),(2.76,5.425),(2.6,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,5.425),(2.94,5.585),(3.1,5.585),(3.1,5.425),(2.94,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,5.425),(3.28,5.585),(3.44,5.585),(3.44,5.425),(3.28,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,5.425),(3.62,5.585),(3.78,5.585),(3.78,5.425),(3.62,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.915,4.64),(2.915,4.8),(3.235,4.8),(3.235,4.64),(2.915,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(4.0,5.76),(4.0,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,5.345),(0.22,5.665),(3.78,5.665),(3.78,5.345),(0.22,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.925,0.89),(2.925,2.1),(3.225,2.1),(3.225,0.89),(2.925,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.725,0.89),(2.725,1.67),(2.855,1.67),(2.855,0.89),(2.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.855,0.89),(2.855,1.67),(3.085,1.67),(3.085,0.89),(2.855,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.265,0.89),(3.265,2.1),(3.395,2.1),(3.395,0.89),(3.265,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.035,0.89),(3.035,2.1),(3.265,2.1),(3.265,0.89),(3.035,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.925,0.89),(2.925,1.19),(3.225,1.19),(3.225,0.89),(2.925,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.925,0.89),(2.925,2.1),(3.195,2.1),(3.195,0.89),(2.925,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.215,0.89),(2.215,1.67),(2.345,1.67),(2.345,0.89),(2.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.995,0.96),(2.995,1.12),(3.155,1.12),(3.155,0.96),(2.995,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.915,0.96),(2.915,1.12),(3.235,1.12),(3.235,0.96),(2.915,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(4.0,1.12),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['cmd']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.215,0.71),(2.215,1.85),(2.345,1.85),(2.345,0.71),(2.215,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.215,0.71),(2.215,3.01),(2.345,3.01),(2.345,0.71),(2.215,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.71),(0.51,3.01),(2.28,3.01),(2.28,2.71),(0.51,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.71),(0.535,3.01),(0.835,3.01),(0.835,2.71),(0.535,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,2.71),(1.465,5.05),(1.595,5.05),(1.595,2.71),(1.465,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.78),(0.605,2.94),(0.765,2.94),(0.765,2.78),(0.605,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.7),(0.605,3.02),(0.765,3.02),(0.765,2.7),(0.605,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.89),(0.58,4.42),(0.79,4.42),(0.79,1.89),(0.58,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,1.67),(1.46,1.67),(1.46,0.89),(1.09,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.965,2.17),(0.965,2.47),(1.265,2.47),(1.265,2.17),(0.965,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.965,3.25),(0.965,3.55),(1.265,3.55),(1.265,3.25),(0.965,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.02,3.25),(1.02,3.55),(1.115,3.55),(1.115,3.25),(1.02,3.25)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.47),(1.085,2.47),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.02,2.17),(1.02,2.47),(1.115,2.47),(1.115,2.17),(1.02,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.25),(0.955,5.05),(1.085,5.05),(1.085,3.25),(0.955,3.25)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.035,3.32),(1.035,3.48),(1.195,3.48),(1.195,3.32),(1.035,3.32)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.035,2.24),(1.035,2.4),(1.195,2.4),(1.195,2.24),(1.035,2.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.89),(1.01,4.42),(1.22,4.42),(1.22,1.89),(1.01,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.035,3.24),(1.035,3.56),(1.195,3.56),(1.195,3.24),(1.035,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.035,2.16),(1.035,2.48),(1.195,2.48),(1.195,2.16),(1.035,2.16)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.115), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.115), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,4.09),(1.09,4.87),(1.46,4.87),(1.46,4.09),(1.09,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        net = nets['_q_n']
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,1.36),(1.875,1.66),(2.175,1.66),(2.175,1.36),(1.875,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.985,4.09),(1.985,4.87),(2.215,4.87),(2.215,4.09),(1.985,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.09),(1.875,4.87),(2.175,4.87),(2.175,4.09),(1.875,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,0.89),(1.875,1.67),(2.175,1.67),(2.175,0.89),(1.875,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.985,0.89),(1.985,1.67),(2.215,1.67),(2.215,0.89),(1.985,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(2.145,4.87),(2.145,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.875,4.1),(1.875,4.4),(2.175,4.4),(2.175,4.1),(1.875,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(2.145,1.67),(2.145,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.945,1.43),(1.945,1.59),(2.105,1.59),(2.105,1.43),(1.945,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.945,4.17),(1.945,4.33),(2.105,4.33),(2.105,4.17),(1.945,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.105,2.78),(3.105,2.94),(3.265,2.94),(3.265,2.78),(3.105,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.08,1.35),(3.08,4.41),(3.29,4.41),(3.29,1.35),(3.08,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.945,1.35),(1.945,1.67),(2.105,1.67),(2.105,1.35),(1.945,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.105,2.7),(3.105,3.02),(3.265,3.02),(3.265,2.7),(3.105,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.025,1.34),(2.025,1.67),(3.185,1.67),(3.185,1.34),(2.025,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.945,1.34),(1.945,1.67),(2.105,1.67),(2.105,1.34),(1.945,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.945,4.09),(1.945,4.42),(2.105,4.42),(2.105,4.09),(1.945,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.08,1.35),(3.08,1.67),(3.29,1.67),(3.29,1.35),(3.08,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.025,4.09),(2.025,4.42),(3.185,4.42),(3.185,4.09),(2.025,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.08,4.09),(3.08,4.41),(3.29,4.41),(3.29,4.09),(3.08,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.945,4.09),(1.945,4.41),(2.105,4.41),(2.105,4.09),(1.945,4.09)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.265,0.71),(3.265,2.28),(3.395,2.28),(3.395,0.71),(3.265,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.265,0.71),(3.265,3.44),(3.395,3.44),(3.395,0.71),(3.265,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.265,3.44),(3.265,5.05),(3.395,5.05),(3.395,3.44),(3.265,3.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.035,2.71),(3.035,3.01),(3.335,3.01),(3.335,2.71),(3.035,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.185,2.71),(3.185,3.01),(3.33,3.01),(3.33,2.71),(3.185,2.71)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.345,0.89),(2.345,1.67),(2.575,1.67),(2.575,0.89),(2.345,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.495,0.89),(2.495,1.67),(2.725,1.67),(2.725,0.89),(2.495,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.415,0.89),(2.415,1.67),(2.655,1.67),(2.655,0.89),(2.415,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.35,0.89),(2.35,1.67),(2.72,1.67),(2.72,0.89),(2.35,0.89)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Activ',
            ((2.415,4.09),(2.415,4.87),(2.655,4.87),(2.655,4.09),(2.415,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.35,4.09),(2.35,4.87),(2.72,4.87),(2.72,4.09),(2.35,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.345,4.09),(2.345,4.87),(2.575,4.87),(2.575,4.09),(2.345,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.495,4.09),(2.495,4.87),(2.725,4.87),(2.725,4.09),(2.495,4.09)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((2.725,3.91),(2.725,5.05),(2.855,5.05),(2.855,3.91),(2.725,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.675,2.17),(2.675,2.47),(2.79,2.47),(2.79,2.17),(2.675,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.725,0.71),(2.725,3.91),(2.855,3.91),(2.855,0.71),(2.725,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.525,2.17),(2.525,2.47),(2.825,2.47),(2.825,2.17),(2.525,2.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.725,0.71),(2.725,1.85),(2.855,1.85),(2.855,0.71),(2.725,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.595,2.24),(2.595,2.4),(2.755,2.4),(2.755,2.24),(2.595,2.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.595,2.16),(2.595,2.48),(2.755,2.48),(2.755,2.16),(2.595,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.57,1.89),(2.57,3.87),(2.78,3.87),(2.78,1.89),(2.57,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.675), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.675), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((3.465,1.49),(3.465,1.79),(3.765,1.79),(3.765,1.49),(3.465,1.49)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.465,0.89),(3.465,2.1),(3.765,2.1),(3.765,0.89),(3.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.465,3.62),(3.465,4.87),(3.765,4.87),(3.765,3.62),(3.465,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.395,3.62),(3.395,4.87),(3.625,4.87),(3.625,3.62),(3.395,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.465,3.95),(3.465,4.25),(3.765,4.25),(3.765,3.95),(3.465,3.95)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.465,3.62),(3.465,4.87),(3.765,4.87),(3.765,3.62),(3.465,3.62)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.465,0.89),(3.465,2.1),(3.765,2.1),(3.765,0.89),(3.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.395,0.89),(3.395,2.1),(3.625,2.1),(3.625,0.89),(3.395,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.535,4.02),(3.535,4.18),(3.695,4.18),(3.695,4.02),(3.535,4.02)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.535,1.56),(3.535,1.72),(3.695,1.72),(3.695,1.56),(3.535,1.56)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.51,1.34),(3.51,4.42),(3.72,4.42),(3.72,1.34),(3.51,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.535,1.34),(3.535,1.94),(3.695,1.94),(3.695,1.34),(3.535,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.535,1.48),(3.535,1.8),(3.695,1.8),(3.695,1.48),(3.535,1.48)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.535,3.94),(3.535,4.26),(3.695,4.26),(3.695,3.94),(3.535,3.94)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.535,3.78),(3.535,4.42),(3.695,4.42),(3.695,3.78),(3.535,3.78)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.615), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.615), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['cmd'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['and21nor_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.725,0.89),(1.725,1.67),(2.345,1.67),(2.345,0.89),(1.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,0.89),(2.045,1.19),(2.345,1.19),(2.345,0.89),(2.045,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,0.89),(1.655,1.67),(1.885,1.67),(1.885,0.89),(1.655,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,0.89),(1.525,1.67),(1.655,1.67),(1.655,0.89),(1.525,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,0.89),(2.045,1.67),(2.345,1.67),(2.345,0.89),(2.045,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,0.96),(2.115,1.12),(2.275,1.12),(2.275,0.96),(2.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.035,0.96),(2.035,1.12),(2.355,1.12),(2.355,0.96),(2.035,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.09),(1.185,4.87),(1.485,4.87),(1.485,4.09),(1.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,4.09),(1.295,4.87),(1.525,4.87),(1.525,4.09),(1.295,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.455,4.87),(1.455,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.1),(1.185,4.4),(1.485,4.4),(1.485,4.1),(1.185,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.17),(1.255,4.33),(1.415,4.33),(1.415,4.17),(1.255,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,4.09),(0.255,4.42),(1.335,4.42),(1.335,4.09),(0.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.42),(1.415,4.42),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.41),(1.415,4.41),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.545,3.79),(1.545,5.17),(2.525,5.17),(2.525,3.79),(1.545,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.115,3.91),(1.115,5.05),(2.065,5.05),(2.065,3.91),(1.115,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.225,3.79),(1.225,5.17),(1.955,5.17),(1.955,3.79),(1.225,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.865,3.8),(1.865,4.7),(2.525,4.7),(2.525,3.8),(1.865,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.635,5.17),(1.635,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.79),(1.005,5.17),(1.665,5.17),(1.665,3.79),(1.005,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.865,3.79),(1.865,5.17),(2.525,5.17),(2.525,3.79),(1.865,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.8),(1.005,4.7),(1.665,4.7),(1.665,3.8),(1.005,3.8)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((1.735,3.79),(1.735,4.71),(2.655,4.71),(2.655,3.79),(1.735,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.79),(0.875,4.71),(1.795,4.71),(1.795,3.79),(0.875,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.415,3.78),(1.415,5.18),(2.655,5.18),(2.655,3.78),(1.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.765,5.18),(1.765,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.985,3.78),(0.985,5.18),(2.195,5.18),(2.195,3.78),(0.985,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.78),(0.875,5.18),(1.795,5.18),(1.795,3.78),(0.875,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.735,3.78),(1.735,5.18),(2.655,5.18),(2.655,3.78),(1.735,3.78)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,4.09),(1.525,4.87),(1.655,4.87),(1.655,4.09),(1.525,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,1.67),(0.95,1.67),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,3.87),(0.36,3.87),(0.36,1.34),(0.15,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.455,1.67),(1.455,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,0.89),(1.295,1.67),(1.525,1.67),(1.525,0.89),(1.295,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,4.1),(2.045,4.4),(2.345,4.4),(2.345,4.1),(2.045,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.36),(1.185,1.66),(1.485,1.66),(1.485,1.36),(1.185,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.09),(1.725,4.87),(2.345,4.87),(2.345,4.09),(1.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,4.09),(2.045,4.87),(2.345,4.87),(2.345,4.09),(2.045,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,1.67),(1.485,1.67),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,4.09),(1.655,4.87),(1.885,4.87),(1.885,4.09),(1.655,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.43),(1.255,1.59),(1.415,1.59),(1.415,1.43),(1.255,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,4.17),(2.115,4.33),(2.275,4.33),(2.275,4.17),(2.115,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.115,4.09),(2.115,4.41),(2.275,4.41),(2.275,4.09),(2.115,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.09,1.35),(2.09,1.67),(2.3,1.67),(2.3,1.35),(2.09,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.35),(1.255,1.67),(1.415,1.67),(1.415,1.35),(1.255,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,1.67),(1.415,1.67),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,1.34),(1.335,1.67),(2.195,1.67),(2.195,1.34),(1.335,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.09,1.34),(2.09,4.42),(2.3,4.42),(2.3,1.34),(2.09,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.115,4.09),(2.115,4.42),(2.275,4.42),(2.275,4.09),(2.115,4.09)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.195), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.195), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.34),(0.8,3.87),(1.01,3.87),(1.01,1.34),(0.8,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,1.85),(1.655,1.85),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.615,2.71),(1.615,3.01),(1.915,3.01),(1.915,2.71),(1.615,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.59,2.71),(1.59,3.01),(1.765,3.01),(1.765,2.71),(1.59,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,3.91),(1.655,3.91),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,3.91),(1.525,5.05),(1.655,5.05),(1.655,3.91),(1.525,3.91)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.685,2.78),(1.685,2.94),(1.845,2.94),(1.845,2.78),(1.685,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.66,1.89),(1.66,4.42),(1.87,4.42),(1.87,1.89),(1.66,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.685,2.7),(1.685,3.02),(1.845,3.02),(1.845,2.7),(1.685,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.765), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.765), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['and21nor_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,0.89),(2.045,1.19),(2.345,1.19),(2.345,0.89),(2.045,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,0.89),(1.525,2.55),(1.655,2.55),(1.655,0.89),(1.525,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.89),(1.725,2.55),(2.345,2.55),(2.345,0.89),(1.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,0.89),(2.045,2.55),(2.345,2.55),(2.345,0.89),(2.045,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,0.89),(1.655,2.55),(1.885,2.55),(1.885,0.89),(1.655,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.19),(0.405,1.19),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,0.96),(0.175,1.12),(0.335,1.12),(0.335,0.96),(0.175,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,0.96),(2.115,1.12),(2.275,1.12),(2.275,0.96),(2.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.035,0.96),(2.035,1.12),(2.355,1.12),(2.355,0.96),(2.035,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,0.96),(0.095,1.12),(0.415,1.12),(0.415,0.96),(0.095,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,3.17),(1.295,4.87),(1.525,4.87),(1.525,3.17),(1.295,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.34),(0.105,4.32),(0.405,4.32),(0.405,3.34),(0.105,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.17),(1.185,4.87),(1.485,4.87),(1.485,3.17),(1.185,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.34),(1.185,4.32),(1.485,4.32),(1.485,3.34),(1.185,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.455,4.87),(1.455,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,3.41),(1.255,3.57),(1.415,3.57),(1.415,3.41),(1.255,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,3.75),(1.255,3.91),(1.415,3.91),(1.415,3.75),(1.255,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.09),(1.255,4.25),(1.415,4.25),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.41),(0.175,3.57),(0.335,3.57),(0.335,3.41),(0.175,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.75),(0.175,3.91),(0.335,3.91),(0.335,3.75),(0.175,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.09),(0.175,4.25),(0.335,4.25),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.24),(0.175,4.42),(0.335,4.42),(0.335,3.24),(0.175,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.33),(1.255,4.33),(1.415,4.33),(1.415,3.33),(1.255,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.24),(1.255,4.42),(1.415,4.42),(1.415,3.24),(1.255,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,3.33),(0.175,4.33),(0.335,4.33),(0.335,3.33),(0.175,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,3.24),(0.255,4.42),(1.335,4.42),(1.335,3.24),(0.255,3.24)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.865,2.87),(1.865,5.17),(2.525,5.17),(2.525,2.87),(1.865,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,2.87),(0.435,5.17),(1.095,5.17),(1.095,2.87),(0.435,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.225,2.87),(1.225,5.17),(1.955,5.17),(1.955,2.87),(1.225,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.545,2.87),(1.545,5.17),(2.525,5.17),(2.525,2.87),(1.545,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.635,5.17),(1.635,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.865,3.04),(1.865,4.62),(2.525,4.62),(2.525,3.04),(1.865,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.115,2.99),(1.115,5.05),(2.065,5.05),(2.065,2.99),(1.115,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.04),(1.005,4.62),(1.665,4.62),(1.665,3.04),(1.005,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.04),(-0.075,4.62),(0.585,4.62),(0.585,3.04),(-0.075,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,2.87),(1.005,5.17),(1.665,5.17),(1.665,2.87),(1.005,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.875,2.86),(0.875,5.18),(1.795,5.18),(1.795,2.86),(0.875,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.03),(-0.205,4.63),(0.715,4.63),(0.715,3.03),(-0.205,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.735,2.86),(1.735,5.18),(2.655,5.18),(2.655,2.86),(1.735,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.735,3.03),(1.735,4.63),(2.655,4.63),(2.655,3.03),(1.735,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.415,2.86),(1.415,5.18),(2.655,5.18),(2.655,2.86),(1.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,2.86),(0.305,5.18),(1.225,5.18),(1.225,2.86),(0.305,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.765,5.18),(1.765,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.03),(0.875,4.63),(1.795,4.63),(1.795,3.03),(0.875,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.985,2.86),(0.985,5.18),(2.195,5.18),(2.195,2.86),(0.985,2.86)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,3.17),(1.525,4.87),(1.655,4.87),(1.655,3.17),(1.525,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.17),(0.615,4.87),(0.915,4.87),(0.915,3.17),(0.615,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,2.55),(0.95,2.55),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.34),(0.15,3.02),(0.36,3.02),(0.36,1.34),(0.15,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.655,3.17),(1.655,4.87),(1.885,4.87),(1.885,3.17),(1.655,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,3.34),(2.045,4.32),(2.345,4.32),(2.345,3.34),(2.045,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.455,2.55),(1.455,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.42),(1.185,2.4),(1.485,2.4),(1.485,1.42),(1.185,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,3.17),(1.725,4.87),(2.345,4.87),(2.345,3.17),(1.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,0.89),(1.295,2.55),(1.525,2.55),(1.525,0.89),(1.295,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,2.55),(1.485,2.55),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,3.17),(2.045,4.87),(2.345,4.87),(2.345,3.17),(2.045,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,3.41),(2.115,3.57),(2.275,3.57),(2.275,3.41),(2.115,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,3.75),(2.115,3.91),(2.275,3.91),(2.275,3.75),(2.115,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,4.09),(2.115,4.25),(2.275,4.25),(2.275,4.09),(2.115,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.49),(1.255,1.65),(1.415,1.65),(1.415,1.49),(1.255,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.83),(1.255,1.99),(1.415,1.99),(1.415,1.83),(1.255,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,2.17),(1.255,2.33),(1.415,2.33),(1.415,2.17),(1.255,2.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.115,3.24),(2.115,4.42),(2.275,4.42),(2.275,3.24),(2.115,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,1.34),(1.335,2.48),(2.195,2.48),(2.195,1.34),(1.335,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.09,1.34),(2.09,4.42),(2.3,4.42),(2.3,1.34),(2.09,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,2.48),(1.415,2.48),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.115,3.33),(2.115,4.33),(2.275,4.33),(2.275,3.33),(2.115,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.09,2.16),(2.09,2.48),(2.3,2.48),(2.3,2.16),(2.09,2.16)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.41),(1.255,2.41),(1.415,2.41),(1.415,1.41),(1.255,1.41)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.195), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.195), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.34),(0.8,3.02),(1.01,3.02),(1.01,1.34),(0.8,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.525,2.99),(1.525,5.05),(1.655,5.05),(1.655,2.99),(1.525,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.615,2.71),(1.615,3.01),(1.915,3.01),(1.915,2.71),(1.615,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.59,2.71),(1.59,3.01),(1.765,3.01),(1.765,2.71),(1.59,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,2.99),(1.655,2.99),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,2.73),(1.655,2.73),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.685,2.78),(1.685,2.94),(1.845,2.94),(1.845,2.78),(1.685,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.685,2.7),(1.685,3.02),(1.845,3.02),(1.845,2.7),(1.685,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.66,2.7),(1.66,4.42),(1.87,4.42),(1.87,2.7),(1.66,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.765), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.765), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['or21nand_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.455,1.67),(1.455,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,0.89),(1.295,1.67),(1.525,1.67),(1.525,0.89),(1.295,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.36),(1.185,1.66),(1.485,1.66),(1.485,1.36),(1.185,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,1.67),(1.485,1.67),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.43),(1.255,1.59),(1.415,1.59),(1.415,1.43),(1.255,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.35),(1.255,1.67),(1.415,1.67),(1.415,1.35),(1.255,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,1.67),(1.415,1.67),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,1.67),(1.335,1.67),(1.335,1.34),(0.255,1.34)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,4.09),(1.725,4.87),(2.345,4.87),(2.345,4.09),(1.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,4.09),(1.525,4.87),(1.655,4.87),(1.655,4.09),(1.525,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,4.09),(2.045,4.87),(2.345,4.87),(2.345,4.09),(2.045,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,4.09),(1.655,4.87),(1.885,4.87),(1.885,4.09),(1.655,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,4.57),(2.045,4.87),(2.345,4.87),(2.345,4.57),(2.045,4.57)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.79),(0.875,4.71),(1.795,4.71),(1.795,3.79),(0.875,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.735,4.26),(1.735,5.18),(2.655,5.18),(2.655,4.26),(1.735,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.415,3.78),(1.415,5.18),(2.655,5.18),(2.655,3.78),(1.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.765,5.18),(1.765,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.985,3.78),(0.985,5.18),(2.195,5.18),(2.195,3.78),(0.985,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,3.78),(0.27,5.18),(1.26,5.18),(1.26,3.78),(0.27,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.78),(0.875,5.18),(1.795,5.18),(1.795,3.78),(0.875,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.735,3.78),(1.735,5.18),(2.655,5.18),(2.655,3.78),(1.735,3.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,4.64),(2.115,4.8),(2.275,4.8),(2.275,4.64),(2.115,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.035,4.64),(2.035,4.8),(2.355,4.8),(2.355,4.64),(2.035,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.545,3.79),(1.545,5.17),(2.525,5.17),(2.525,3.79),(1.545,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.865,4.27),(1.865,5.17),(2.525,5.17),(2.525,4.27),(1.865,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.115,3.91),(1.115,5.05),(2.065,5.05),(2.065,3.91),(1.115,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.225,3.79),(1.225,5.17),(1.955,5.17),(1.955,3.79),(1.225,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.635,5.17),(1.635,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,3.79),(0.4,5.17),(1.13,5.17),(1.13,3.79),(0.4,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.79),(1.005,5.17),(1.665,5.17),(1.665,3.79),(1.005,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.865,3.79),(1.865,5.17),(2.525,5.17),(2.525,3.79),(1.865,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.8),(1.005,4.7),(1.665,4.7),(1.665,3.8),(1.005,3.8)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,0.89),(1.525,1.67),(1.655,1.67),(1.655,0.89),(1.525,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.89),(0.15,4.42),(0.36,4.42),(0.36,1.89),(0.15,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,4.09),(0.58,4.87),(0.95,4.87),(0.95,4.09),(0.58,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,1.89),(0.8,4.42),(1.01,4.42),(1.01,1.89),(0.8,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.725,0.89),(1.725,1.67),(2.345,1.67),(2.345,0.89),(1.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,1.36),(2.045,1.66),(2.345,1.66),(2.345,1.36),(2.045,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,0.89),(1.655,1.67),(1.885,1.67),(1.885,0.89),(1.655,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.09),(1.185,4.87),(1.485,4.87),(1.485,4.09),(1.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,4.09),(1.295,4.87),(1.525,4.87),(1.525,4.09),(1.295,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.455,4.87),(1.455,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.1),(1.185,4.4),(1.485,4.4),(1.485,4.1),(1.185,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,0.89),(2.045,1.67),(2.345,1.67),(2.345,0.89),(2.045,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,1.43),(2.115,1.59),(2.275,1.59),(2.275,1.43),(2.115,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.17),(1.255,4.33),(1.415,4.33),(1.415,4.17),(1.255,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.115,1.35),(2.115,1.67),(2.275,1.67),(2.275,1.35),(2.115,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.115,1.34),(2.115,1.67),(2.275,1.67),(2.275,1.34),(2.115,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.42),(1.415,4.42),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.09,1.34),(2.09,4.42),(2.3,4.42),(2.3,1.34),(2.09,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.41),(1.415,4.41),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.09,4.09),(2.09,4.41),(2.3,4.41),(2.3,4.09),(2.09,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,4.09),(1.335,4.42),(2.195,4.42),(2.195,4.09),(1.335,4.09)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.195), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.195), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,1.85),(1.655,1.85),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.615,2.71),(1.615,3.01),(1.915,3.01),(1.915,2.71),(1.615,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.59,2.71),(1.59,3.01),(1.765,3.01),(1.765,2.71),(1.59,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,3.91),(1.655,3.91),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,3.91),(1.525,5.05),(1.655,5.05),(1.655,3.91),(1.525,3.91)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.685,2.78),(1.685,2.94),(1.845,2.94),(1.845,2.78),(1.685,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.66,1.34),(1.66,3.87),(1.87,3.87),(1.87,1.34),(1.66,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.685,2.7),(1.685,3.02),(1.845,3.02),(1.845,2.7),(1.685,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.765), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.765), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['or21nand_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'i0': Net.create(cell, 'i0'),
            'i1': Net.create(cell, 'i1'),
            'i2': Net.create(cell, 'i2'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.295,0.89),(1.295,2.55),(1.525,2.55),(1.525,0.89),(1.295,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.405,2.55),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.55),(0.445,2.55),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.55),(1.315,2.55),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.42),(0.105,2.4),(0.405,2.4),(0.405,1.42),(0.105,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.55),(1.455,2.55),(1.455,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.42),(1.185,2.4),(1.485,2.4),(1.485,1.42),(1.185,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.55),(0.375,2.55),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,2.55),(1.485,2.55),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.49),(0.175,1.65),(0.335,1.65),(0.335,1.49),(0.175,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.83),(0.175,1.99),(0.335,1.99),(0.335,1.83),(0.175,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.17),(0.175,2.33),(0.335,2.33),(0.335,2.17),(0.175,2.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.49),(1.255,1.65),(1.415,1.65),(1.415,1.49),(1.255,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.83),(1.255,1.99),(1.415,1.99),(1.415,1.83),(1.255,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,2.17),(1.255,2.33),(1.415,2.33),(1.415,2.17),(1.255,2.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,2.48),(1.335,2.48),(1.335,1.34),(0.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,2.48),(1.415,2.48),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.41),(0.175,2.41),(0.335,2.41),(0.335,1.41),(0.175,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,2.48),(0.335,2.48),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.41),(1.255,2.41),(1.415,2.41),(1.415,1.41),(1.255,1.41)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((1.655,3.17),(1.655,4.87),(1.885,4.87),(1.885,3.17),(1.655,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,3.17),(1.525,4.87),(1.655,4.87),(1.655,3.17),(1.525,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.17),(0.215,4.87),(0.445,4.87),(0.445,3.17),(0.215,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.375,4.87),(0.375,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.17),(0.445,4.87),(0.575,4.87),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.17),(0.105,4.87),(0.405,4.87),(0.405,3.17),(0.105,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,3.17),(1.725,4.87),(2.345,4.87),(2.345,3.17),(1.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,4.57),(2.045,4.87),(2.345,4.87),(2.345,4.57),(2.045,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.17),(0.955,4.87),(1.085,4.87),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,3.17),(2.045,4.87),(2.345,4.87),(2.345,3.17),(2.045,3.17)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,2.86),(0.875,5.18),(1.795,5.18),(1.795,2.86),(0.875,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,2.86),(0.415,5.18),(1.625,5.18),(1.625,2.86),(0.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.735,2.86),(1.735,5.18),(2.655,5.18),(2.655,2.86),(1.735,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.685,5.18),(0.685,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.415,2.86),(1.415,5.18),(2.655,5.18),(2.655,2.86),(1.415,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.27,2.86),(0.27,5.18),(1.26,5.18),(1.26,2.86),(0.27,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,2.86),(-0.095,5.18),(1.115,5.18),(1.115,2.86),(-0.095,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.735,4.26),(1.735,5.18),(2.655,5.18),(2.655,4.26),(1.735,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,2.86),(-0.205,5.18),(0.715,5.18),(0.715,2.86),(-0.205,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,2.86),(0.335,5.18),(1.195,5.18),(1.195,2.86),(0.335,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,2.86),(0.845,5.18),(1.765,5.18),(1.765,2.86),(0.845,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.03),(0.875,4.63),(1.795,4.63),(1.795,3.03),(0.875,3.03)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.985,2.86),(0.985,5.18),(2.195,5.18),(2.195,2.86),(0.985,2.86)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,4.64),(2.115,4.8),(2.275,4.8),(2.275,4.64),(2.115,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.035,4.64),(2.035,4.8),(2.355,4.8),(2.355,4.64),(2.035,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.865,2.87),(1.865,5.17),(2.525,5.17),(2.525,2.87),(1.865,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.4,2.87),(0.4,5.17),(1.13,5.17),(1.13,2.87),(0.4,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.555,5.17),(0.555,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.87),(-0.075,5.17),(0.585,5.17),(0.585,2.87),(-0.075,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.865,4.27),(1.865,5.17),(2.525,5.17),(2.525,4.27),(1.865,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.225,2.87),(1.225,5.17),(1.955,5.17),(1.955,2.87),(1.225,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.545,2.87),(1.545,5.17),(2.525,5.17),(2.525,2.87),(1.545,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,2.87),(0.975,5.17),(1.635,5.17),(1.635,2.87),(0.975,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,2.87),(0.655,5.17),(1.385,5.17),(1.385,2.87),(0.655,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,2.99),(0.035,5.05),(0.985,5.05),(0.985,2.99),(0.035,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,2.87),(0.145,5.17),(0.875,5.17),(0.875,2.87),(0.145,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,2.99),(0.545,5.05),(1.495,5.05),(1.495,2.99),(0.545,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.115,2.99),(1.115,5.05),(2.065,5.05),(2.065,2.99),(1.115,2.99)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,2.87),(0.465,5.17),(1.065,5.17),(1.065,2.87),(0.465,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.04),(1.005,4.62),(1.665,4.62),(1.665,3.04),(1.005,3.04)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,2.87),(1.005,5.17),(1.665,5.17),(1.665,2.87),(1.005,2.87)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.55),(0.885,2.55),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.55),(0.575,2.55),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.525,0.89),(1.525,2.55),(1.655,2.55),(1.655,0.89),(1.525,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.55),(0.805,2.55),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,2.55),(0.915,2.55),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.55),(0.955,2.55),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.55),(1.085,2.55),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.71),(0.105,3.01),(0.405,3.01),(0.405,2.71),(0.105,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,2.99),(0.445,5.05),(0.575,5.05),(0.575,2.99),(0.445,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.99),(0.575,2.99),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.71),(0.255,3.01),(0.51,3.01),(0.51,2.71),(0.255,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.73),(0.575,2.73),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.78),(0.175,2.94),(0.335,2.94),(0.335,2.78),(0.175,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,2.7),(0.15,4.42),(0.36,4.42),(0.36,2.7),(0.15,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.7),(0.175,3.02),(0.335,3.02),(0.335,2.7),(0.175,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((0.58,3.17),(0.58,4.87),(0.95,4.87),(0.95,3.17),(0.58,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.17),(0.725,4.87),(0.955,4.87),(0.955,3.17),(0.725,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.17),(0.645,4.87),(0.885,4.87),(0.885,3.17),(0.645,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,3.17),(0.575,4.87),(0.805,4.87),(0.805,3.17),(0.575,3.17)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((0.755,2.71),(0.755,3.01),(1.055,3.01),(1.055,2.71),(0.755,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.99),(1.085,2.99),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.73),(1.085,2.73),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.905,2.71),(0.905,3.01),(1.02,3.01),(1.02,2.71),(0.905,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,2.99),(0.955,5.05),(1.085,5.05),(1.085,2.99),(0.955,2.99)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.825,2.78),(0.825,2.94),(0.985,2.94),(0.985,2.78),(0.825,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.825,2.7),(0.825,3.02),(0.985,3.02),(0.985,2.7),(0.825,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.8,2.7),(0.8,4.42),(1.01,4.42),(1.01,2.7),(0.8,2.7)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.905), u(0.21), u(2.7), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.905), u(0.21), u(2.7), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.085,3.17),(1.085,4.87),(1.315,4.87),(1.315,3.17),(1.085,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.295,3.17),(1.295,4.87),(1.525,4.87),(1.525,3.17),(1.295,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.725,0.89),(1.725,2.55),(2.345,2.55),(2.345,0.89),(1.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,0.89),(2.045,2.55),(2.345,2.55),(2.345,0.89),(2.045,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.655,0.89),(1.655,2.55),(1.885,2.55),(1.885,0.89),(1.655,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.045,1.42),(2.045,2.4),(2.345,2.4),(2.345,1.42),(2.045,1.42)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.17),(1.185,4.87),(1.485,4.87),(1.485,3.17),(1.185,3.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,3.34),(1.185,4.32),(1.485,4.32),(1.485,3.34),(1.185,3.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.17),(1.155,4.87),(1.455,4.87),(1.455,3.17),(1.155,3.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,3.41),(1.255,3.57),(1.415,3.57),(1.415,3.41),(1.255,3.41)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,3.75),(1.255,3.91),(1.415,3.91),(1.415,3.75),(1.255,3.75)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.09),(1.255,4.25),(1.415,4.25),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,1.49),(2.115,1.65),(2.275,1.65),(2.275,1.49),(2.115,1.49)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,1.83),(2.115,1.99),(2.275,1.99),(2.275,1.83),(2.115,1.83)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.115,2.17),(2.115,2.33),(2.275,2.33),(2.275,2.17),(2.115,2.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.115,1.34),(2.115,2.48),(2.275,2.48),(2.275,1.34),(2.115,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.33),(1.255,4.33),(1.415,4.33),(1.415,3.33),(1.255,3.33)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,3.24),(1.335,4.42),(2.195,4.42),(2.195,3.24),(1.335,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.115,1.41),(2.115,2.41),(2.275,2.41),(2.275,1.41),(2.115,1.41)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,3.24),(1.255,4.42),(1.415,4.42),(1.415,3.24),(1.255,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.09,3.24),(2.09,3.56),(2.3,3.56),(2.3,3.24),(2.09,3.24)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.09,1.34),(2.09,4.42),(2.3,4.42),(2.3,1.34),(2.09,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.195), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.195), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i2']
        createRL(
            tech, net, 'GatPoly',
            ((1.525,2.99),(1.525,5.05),(1.655,5.05),(1.655,2.99),(1.525,2.99)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.615,2.71),(1.615,3.01),(1.915,3.01),(1.915,2.71),(1.615,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.59,2.71),(1.59,3.01),(1.765,3.01),(1.765,2.71),(1.59,2.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,2.99),(1.655,2.99),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.525,0.71),(1.525,2.73),(1.655,2.73),(1.655,0.71),(1.525,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.685,2.78),(1.685,2.94),(1.845,2.94),(1.845,2.78),(1.685,2.78)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.685,2.7),(1.685,3.02),(1.845,3.02),(1.845,2.7),(1.685,2.7)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.66,1.34),(1.66,3.02),(1.87,3.02),(1.87,1.34),(1.66,1.34)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.765), u(0.21), u(1.34), u(3.02),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.765), u(0.21), u(1.34), u(3.02),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['i2'].setDirection(Net.Direction.IN)

    cell = new_cells['xor2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i0_n': Net.create(cell, 'i0_n'),
            'i1': Net.create(cell, 'i1'),
            'i1_n': Net.create(cell, 'i1_n'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i0_n']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.51),(0.175,2.67),(0.335,2.67),(0.335,2.51),(0.175,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.43),(0.175,2.75),(0.335,2.75),(0.335,2.43),(0.175,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.35),(0.15,4.41),(0.36,4.41),(0.36,1.35),(0.15,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,1.85),(2.165,1.85),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.44),(0.255,2.74),(2.1,2.74),(2.1,2.44),(0.255,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.44),(0.105,2.74),(0.405,2.74),(0.405,2.44),(0.105,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,3.91),(2.165,3.91),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.91),(2.035,5.05),(2.165,5.05),(2.165,3.91),(2.035,3.91)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.945,3.8),(0.945,4.7),(1.605,4.7),(1.605,3.8),(0.945,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.755,3.79),(2.755,5.17),(3.485,5.17),(3.485,3.79),(2.755,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.34),(1.485,5.05),(2.145,5.05),(2.145,3.34),(1.485,3.34)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.075,3.79),(3.075,5.17),(3.765,5.17),(3.765,3.79),(3.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.79),(1.735,5.17),(2.465,5.17),(2.465,3.79),(1.735,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.245,3.79),(2.245,5.17),(2.975,5.17),(2.975,3.79),(2.245,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.145,5.17),(2.145,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(4.075,5.17),(4.075,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.79),(2.025,5.17),(2.685,5.17),(2.685,3.79),(2.025,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.625,3.91),(1.625,5.05),(2.575,5.05),(2.575,3.91),(1.625,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.565,3.79),(2.565,5.17),(3.165,5.17),(3.165,3.79),(2.565,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.79),(2.535,5.17),(3.195,5.17),(3.195,3.79),(2.535,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.645,3.91),(2.645,5.05),(3.595,5.05),(3.595,3.91),(2.645,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,3.79),(0.945,5.17),(1.605,5.17),(1.605,3.79),(0.945,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.105,3.79),(3.105,5.17),(3.765,5.17),(3.765,3.79),(3.105,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.105,3.8),(3.105,4.7),(3.765,4.7),(3.765,3.8),(3.105,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.055,3.79),(2.055,5.17),(2.655,5.17),(2.655,3.79),(2.055,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.27),(2.535,5.17),(3.195,5.17),(3.195,4.27),(2.535,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.34),(1.485,4.0),(2.145,4.0),(2.145,3.34),(1.485,3.34)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.8),(2.025,4.7),(2.685,4.7),(2.685,3.8),(2.025,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.135,3.91),(2.135,5.05),(3.085,5.05),(3.085,3.91),(2.135,3.91)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.815,3.79),(0.815,4.71),(1.735,4.71),(1.735,3.79),(0.815,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,3.78),(0.815,5.18),(1.735,5.18),(1.735,3.78),(0.815,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.515,3.78),(2.515,5.18),(3.725,5.18),(3.725,3.78),(2.515,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.975,3.78),(2.975,5.18),(3.895,5.18),(3.895,3.78),(2.975,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,4.26),(2.405,5.18),(3.325,5.18),(3.325,4.26),(2.405,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(4.205,5.965),(4.205,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.925,3.78),(1.925,5.18),(2.785,5.18),(2.785,3.78),(1.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.495,3.78),(1.495,5.18),(2.705,5.18),(2.705,3.78),(1.495,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.945,3.78),(2.945,5.18),(3.895,5.18),(3.895,3.78),(2.945,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.975,3.79),(2.975,4.71),(3.895,4.71),(3.895,3.79),(2.975,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.21),(1.355,5.18),(2.275,5.18),(2.275,3.21),(1.355,3.21)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.79),(1.895,4.71),(2.815,4.71),(2.815,3.79),(1.895,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.435,3.78),(2.435,5.18),(3.295,5.18),(3.295,3.78),(2.435,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,3.78),(2.405,5.18),(3.325,5.18),(3.325,3.78),(2.405,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,5.045),(-0.16,5.965),(4.16,5.965),(4.16,5.045),(-0.16,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.78),(1.895,5.18),(2.815,5.18),(2.815,3.78),(1.895,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.21),(1.355,4.13),(2.275,4.13),(2.275,3.21),(1.355,3.21)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(4.31,6.07),(4.31,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.005,3.78),(2.005,5.18),(3.215,5.18),(3.215,3.78),(2.005,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.275,5.18),(2.275,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.895,5.655),(3.895,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.825,4.09),(2.825,4.87),(3.055,4.87),(3.055,4.09),(2.825,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,4.09),(2.035,4.87),(2.165,4.87),(2.165,4.09),(2.035,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.675,4.09),(2.675,4.87),(2.905,4.87),(2.905,4.09),(2.675,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,5.355),(0.15,5.655),(3.85,5.655),(3.85,5.355),(0.15,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,4.57),(2.715,4.87),(3.015,4.87),(3.015,4.57),(2.715,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,4.09),(2.745,4.87),(2.985,4.87),(2.985,4.09),(2.745,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.055,4.09),(3.055,4.87),(3.185,4.87),(3.185,4.09),(3.055,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,4.09),(2.715,4.87),(3.015,4.87),(3.015,4.09),(2.715,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,4.09),(2.545,4.87),(2.675,4.87),(2.675,4.09),(2.545,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,5.425),(0.22,5.585),(0.38,5.585),(0.38,5.425),(0.22,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,5.425),(0.56,5.585),(0.72,5.585),(0.72,5.425),(0.56,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,5.425),(0.9,5.585),(1.06,5.585),(1.06,5.425),(0.9,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,5.425),(1.24,5.585),(1.4,5.585),(1.4,5.425),(1.24,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,5.425),(1.58,5.585),(1.74,5.585),(1.74,5.425),(1.58,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,5.425),(1.92,5.585),(2.08,5.585),(2.08,5.425),(1.92,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,5.425),(2.26,5.585),(2.42,5.585),(2.42,5.425),(2.26,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,5.425),(2.6,5.585),(2.76,5.585),(2.76,5.425),(2.6,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,5.425),(2.94,5.585),(3.1,5.585),(3.1,5.425),(2.94,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,5.425),(3.28,5.585),(3.44,5.585),(3.44,5.425),(3.28,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,5.425),(3.62,5.585),(3.78,5.585),(3.78,5.425),(3.62,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,4.64),(2.785,4.8),(2.945,4.8),(2.945,4.64),(2.785,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(4.0,5.76),(4.0,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,5.345),(0.22,5.665),(3.78,5.665),(3.78,5.345),(0.22,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.705,4.64),(2.705,4.8),(3.025,4.8),(3.025,4.64),(2.705,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.675,0.89),(2.675,1.67),(2.905,1.67),(2.905,0.89),(2.675,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,0.89),(2.035,1.67),(2.165,1.67),(2.165,0.89),(2.035,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,1.19),(3.015,1.19),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,1.67),(3.015,1.67),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,0.89),(2.545,1.67),(2.675,1.67),(2.675,0.89),(2.545,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.825,0.89),(2.825,1.67),(3.055,1.67),(3.055,0.89),(2.825,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.055,0.89),(3.055,1.67),(3.185,1.67),(3.185,0.89),(3.055,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,0.89),(2.745,1.67),(2.985,1.67),(2.985,0.89),(2.745,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,0.96),(2.785,1.12),(2.945,1.12),(2.945,0.96),(2.785,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(4.0,1.12),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.705,0.96),(2.705,1.12),(3.025,1.12),(3.025,0.96),(2.705,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.2),(0.575,2.2),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,1.9),(0.51,2.2),(1.02,2.2),(1.02,1.9),(0.51,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.52),(0.445,5.05),(0.575,5.05),(0.575,3.52),(0.445,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,1.9),(0.535,2.2),(0.835,2.2),(0.835,1.9),(0.535,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.2),(1.085,2.2),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,3.52),(0.51,3.82),(1.02,3.82),(1.02,3.52),(0.51,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.52),(0.955,5.05),(1.085,5.05),(1.085,3.52),(0.955,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.52),(0.535,3.82),(0.835,3.82),(0.835,3.52),(0.535,3.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.59),(0.605,3.75),(0.765,3.75),(0.765,3.59),(0.605,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,1.97),(0.605,2.13),(0.765,2.13),(0.765,1.97),(0.605,1.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,1.89),(0.605,2.21),(0.765,2.21),(0.765,1.89),(0.605,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.51),(0.605,3.83),(0.765,3.83),(0.765,3.51),(0.605,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,1.67),(1.46,1.67),(1.46,0.89),(1.09,0.89)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((2.205,4.1),(2.205,4.4),(2.505,4.4),(2.505,4.1),(2.205,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.09),(1.125,4.87),(1.425,4.87),(1.425,4.09),(1.125,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,4.09),(2.165,4.87),(2.395,4.87),(2.395,4.09),(2.165,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,4.09),(2.235,4.87),(2.475,4.87),(2.475,4.09),(2.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.09),(2.205,4.87),(2.505,4.87),(2.505,4.09),(2.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.315,4.09),(2.315,4.87),(2.545,4.87),(2.545,4.09),(2.315,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.1),(1.125,4.4),(1.425,4.4),(1.425,4.1),(1.125,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.17),(1.195,4.33),(1.355,4.33),(1.355,4.17),(1.195,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.17),(2.275,4.33),(2.435,4.33),(2.435,4.17),(2.275,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.195,4.09),(1.195,4.42),(1.355,4.42),(1.355,4.09),(1.195,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.195,4.09),(1.195,4.41),(1.355,4.41),(1.355,4.09),(1.195,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,4.09),(2.275,4.42),(2.435,4.42),(2.435,4.09),(2.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.275,4.09),(1.275,4.42),(2.355,4.42),(2.355,4.09),(1.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,4.09),(2.275,4.41),(2.435,4.41),(2.435,4.09),(2.275,4.09)),
        )
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,1.36),(1.665,1.66),(1.965,1.66),(1.965,1.36),(1.665,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,0.89),(1.805,1.67),(2.035,1.67),(2.035,0.89),(1.805,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.965,4.87),(1.965,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,4.09),(1.805,4.87),(2.035,4.87),(2.035,4.09),(1.805,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.965,1.67),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.52),(1.665,4.87),(1.965,4.87),(1.965,3.52),(1.665,3.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.52),(1.665,3.82),(1.965,3.82),(1.965,3.52),(1.665,3.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.965,1.67),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.735,1.43),(1.735,1.59),(1.895,1.59),(1.895,1.43),(1.735,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.735,3.59),(1.735,3.75),(1.895,3.75),(1.895,3.59),(1.735,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.34),(1.01,3.87),(1.22,3.87),(1.22,1.34),(1.01,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.735,1.34),(1.735,1.67),(1.895,1.67),(1.895,1.34),(1.735,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.735,1.35),(1.735,1.67),(1.895,1.67),(1.895,1.35),(1.735,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,1.34),(1.115,1.67),(1.815,1.67),(1.815,1.34),(1.115,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,3.51),(1.01,3.83),(1.22,3.83),(1.22,3.51),(1.01,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,3.51),(1.115,3.83),(1.815,3.83),(1.815,3.51),(1.115,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.35),(1.01,1.67),(1.22,1.67),(1.22,1.35),(1.01,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.735,3.51),(1.735,3.83),(1.895,3.83),(1.895,3.51),(1.735,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.115), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.115), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((3.005,1.9),(3.005,2.2),(3.12,2.2),(3.12,1.9),(3.005,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.61,3.52),(2.61,3.82),(3.12,3.82),(3.12,3.52),(2.61,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,3.52),(3.055,5.05),(3.185,5.05),(3.185,3.52),(3.055,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,3.91),(3.055,5.05),(3.185,5.05),(3.185,3.91),(3.055,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,1.9),(2.855,2.2),(3.155,2.2),(3.155,1.9),(2.855,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,3.91),(2.545,5.05),(2.675,5.05),(2.675,3.91),(2.545,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,0.71),(3.055,2.2),(3.185,2.2),(3.185,0.71),(3.055,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,0.71),(3.055,1.85),(3.185,1.85),(3.185,0.71),(3.055,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.53,1.9),(1.53,2.2),(1.545,2.2),(1.545,1.9),(1.53,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,3.52),(2.545,5.05),(2.675,5.05),(2.675,3.52),(2.545,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.2),(1.595,2.2),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.395,1.9),(1.395,2.2),(1.695,2.2),(1.695,1.9),(1.395,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,3.52),(2.855,3.82),(3.155,3.82),(3.155,3.52),(2.855,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,1.97),(2.925,2.13),(3.085,2.13),(3.085,1.97),(2.925,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.465,1.97),(1.465,2.13),(1.625,2.13),(1.625,1.97),(1.465,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,3.59),(2.925,3.75),(3.085,3.75),(3.085,3.59),(2.925,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.9,1.34),(2.9,4.42),(3.11,4.42),(3.11,1.34),(2.9,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.545,1.89),(1.545,2.21),(3.005,2.21),(3.005,1.89),(1.545,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,1.89),(2.925,2.21),(3.085,2.21),(3.085,1.89),(2.925,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.9,1.89),(2.9,2.21),(3.11,2.21),(3.11,1.89),(2.9,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.465,1.89),(1.465,2.21),(1.625,2.21),(1.625,1.89),(1.465,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,3.51),(2.925,3.83),(3.085,3.83),(3.085,3.51),(2.925,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.005), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.005), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1_n']
        createRL(
            tech, net, 'GatPoly',
            ((1.465,2.98),(1.465,5.05),(1.595,5.05),(1.595,2.98),(1.465,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,2.74),(2.675,2.74),(2.675,0.71),(2.545,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.395,2.98),(1.395,3.28),(1.695,3.28),(1.695,2.98),(1.395,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,1.85),(2.675,1.85),(2.675,0.71),(2.545,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.285,2.44),(3.285,2.74),(3.585,2.74),(3.585,2.44),(3.285,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.53,2.98),(1.53,3.28),(1.545,3.28),(1.545,2.98),(1.53,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.495,2.44),(2.495,2.74),(3.435,2.74),(3.435,2.44),(2.495,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.345,2.44),(2.345,2.74),(2.645,2.74),(2.645,2.44),(2.345,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.185,4.09),(3.185,4.87),(3.415,4.87),(3.415,4.09),(3.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.185,0.89),(3.185,1.67),(3.415,1.67),(3.415,0.89),(3.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.285,1.36),(3.285,1.66),(3.585,1.66),(3.585,1.36),(3.285,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.285,0.89),(3.285,1.67),(3.585,1.67),(3.585,0.89),(3.285,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.255,4.09),(3.255,4.87),(3.585,4.87),(3.585,4.09),(3.255,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.285,4.1),(3.285,4.4),(3.585,4.4),(3.585,4.1),(3.285,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.285,4.09),(3.285,4.87),(3.585,4.87),(3.585,4.09),(3.285,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.255,0.89),(3.255,1.67),(3.585,1.67),(3.585,0.89),(3.255,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.415,2.51),(2.415,2.67),(2.575,2.67),(2.575,2.51),(2.415,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.465,3.05),(1.465,3.21),(1.625,3.21),(1.625,3.05),(1.465,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.355,4.17),(3.355,4.33),(3.515,4.33),(3.515,4.17),(3.355,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.355,1.43),(3.355,1.59),(3.515,1.59),(3.515,1.43),(3.355,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.355,2.51),(3.355,2.67),(3.515,2.67),(3.515,2.51),(3.355,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,4.09),(3.355,4.41),(3.515,4.41),(3.515,4.09),(3.355,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.545,2.97),(1.545,3.29),(2.495,3.29),(2.495,2.97),(1.545,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.465,2.97),(1.465,3.29),(1.625,3.29),(1.625,2.97),(1.465,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,1.34),(3.355,1.67),(3.515,1.67),(3.515,1.34),(3.355,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,2.97),(2.39,3.29),(2.6,3.29),(2.6,2.97),(2.39,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,2.43),(3.355,2.75),(3.515,2.75),(3.515,2.43),(3.355,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,1.35),(3.355,1.67),(3.515,1.67),(3.515,1.35),(3.355,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.33,1.35),(3.33,4.41),(3.54,4.41),(3.54,1.35),(3.33,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,4.09),(3.355,4.42),(3.515,4.42),(3.515,4.09),(3.355,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,2.43),(2.39,3.29),(2.6,3.29),(2.6,2.43),(2.39,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.415,2.43),(2.415,2.75),(2.575,2.75),(2.575,2.43),(2.415,2.43)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.315,0.89),(2.315,1.67),(2.545,1.67),(2.545,0.89),(2.315,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,0.89),(2.235,1.67),(2.475,1.67),(2.475,0.89),(2.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.17,0.89),(2.17,1.67),(2.54,1.67),(2.54,0.89),(2.17,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,0.89),(2.165,1.67),(2.395,1.67),(2.395,0.89),(2.165,0.89)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['nexor2_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(4.0), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            'i0': Net.create(cell, 'i0'),
            'i0_n': Net.create(cell, 'i0_n'),
            'i1': Net.create(cell, 'i1'),
            'i1_n': Net.create(cell, 'i1_n'),
            'nq': Net.create(cell, 'nq'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['i0_n']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,2.51),(0.175,2.67),(0.335,2.67),(0.335,2.51),(0.175,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.43),(0.175,2.75),(0.335,2.75),(0.335,2.43),(0.175,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.35),(0.15,4.41),(0.36,4.41),(0.36,1.35),(0.15,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,1.85),(2.165,1.85),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.44),(0.255,2.74),(2.1,2.74),(2.1,2.44),(0.255,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.44),(0.105,2.74),(0.405,2.74),(0.405,2.44),(0.105,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,3.91),(2.165,3.91),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.91),(2.035,5.05),(2.165,5.05),(2.165,3.91),(2.035,3.91)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.945,3.8),(0.945,4.7),(1.605,4.7),(1.605,3.8),(0.945,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(4.075,0.585),(4.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.755,3.79),(2.755,5.17),(3.485,5.17),(3.485,3.79),(2.755,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.34),(1.485,5.05),(2.145,5.05),(2.145,3.34),(1.485,3.34)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.075,3.79),(3.075,5.17),(3.765,5.17),(3.765,3.79),(3.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.79),(1.735,5.17),(2.465,5.17),(2.465,3.79),(1.735,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.245,3.79),(2.245,5.17),(2.975,5.17),(2.975,3.79),(2.245,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.145,5.17),(2.145,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(4.075,5.17),(4.075,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.03,-0.075),(-0.03,0.585),(4.03,0.585),(4.03,-0.075),(-0.03,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.79),(2.025,5.17),(2.685,5.17),(2.685,3.79),(2.025,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.625,3.91),(1.625,5.05),(2.575,5.05),(2.575,3.91),(1.625,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.565,3.79),(2.565,5.17),(3.165,5.17),(3.165,3.79),(2.565,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,3.79),(2.535,5.17),(3.195,5.17),(3.195,3.79),(2.535,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.645,3.91),(2.645,5.05),(3.595,5.05),(3.595,3.91),(2.645,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,3.79),(0.945,5.17),(1.605,5.17),(1.605,3.79),(0.945,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.105,3.79),(3.105,5.17),(3.765,5.17),(3.765,3.79),(3.105,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.105,3.8),(3.105,4.7),(3.765,4.7),(3.765,3.8),(3.105,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.055,3.79),(2.055,5.17),(2.655,5.17),(2.655,3.79),(2.055,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.535,4.27),(2.535,5.17),(3.195,5.17),(3.195,4.27),(2.535,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.34),(1.485,4.0),(2.145,4.0),(2.145,3.34),(1.485,3.34)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.8),(2.025,4.7),(2.685,4.7),(2.685,3.8),(2.025,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.135,3.91),(2.135,5.05),(3.085,5.05),(3.085,3.91),(2.135,3.91)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((0.815,3.79),(0.815,4.71),(1.735,4.71),(1.735,3.79),(0.815,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,3.78),(0.815,5.18),(1.735,5.18),(1.735,3.78),(0.815,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.515,3.78),(2.515,5.18),(3.725,5.18),(3.725,3.78),(2.515,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.975,3.78),(2.975,5.18),(3.895,5.18),(3.895,3.78),(2.975,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,4.26),(2.405,5.18),(3.325,5.18),(3.325,4.26),(2.405,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(4.205,5.965),(4.205,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.925,3.78),(1.925,5.18),(2.785,5.18),(2.785,3.78),(1.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.495,3.78),(1.495,5.18),(2.705,5.18),(2.705,3.78),(1.495,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.945,3.78),(2.945,5.18),(3.895,5.18),(3.895,3.78),(2.945,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.975,3.79),(2.975,4.71),(3.895,4.71),(3.895,3.79),(2.975,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.21),(1.355,5.18),(2.275,5.18),(2.275,3.21),(1.355,3.21)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.79),(1.895,4.71),(2.815,4.71),(2.815,3.79),(1.895,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.435,3.78),(2.435,5.18),(3.295,5.18),(3.295,3.78),(2.435,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.405,3.78),(2.405,5.18),(3.325,5.18),(3.325,3.78),(2.405,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.16,5.045),(-0.16,5.965),(4.16,5.965),(4.16,5.045),(-0.16,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.78),(1.895,5.18),(2.815,5.18),(2.815,3.78),(1.895,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.21),(1.355,4.13),(2.275,4.13),(2.275,3.21),(1.355,3.21)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(4.31,6.07),(4.31,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.005,3.78),(2.005,5.18),(3.215,5.18),(3.215,3.78),(2.005,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.275,5.18),(2.275,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.895,5.655),(3.895,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.825,4.09),(2.825,4.87),(3.055,4.87),(3.055,4.09),(2.825,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,4.09),(2.035,4.87),(2.165,4.87),(2.165,4.09),(2.035,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.675,4.09),(2.675,4.87),(2.905,4.87),(2.905,4.09),(2.675,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,5.355),(0.15,5.655),(3.85,5.655),(3.85,5.355),(0.15,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,4.57),(2.715,4.87),(3.015,4.87),(3.015,4.57),(2.715,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,4.09),(2.745,4.87),(2.985,4.87),(2.985,4.09),(2.745,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.055,4.09),(3.055,4.87),(3.185,4.87),(3.185,4.09),(3.055,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,4.09),(2.715,4.87),(3.015,4.87),(3.015,4.09),(2.715,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,4.09),(2.545,4.87),(2.675,4.87),(2.675,4.09),(2.545,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,5.425),(0.22,5.585),(0.38,5.585),(0.38,5.425),(0.22,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,5.425),(0.56,5.585),(0.72,5.585),(0.72,5.425),(0.56,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,5.425),(0.9,5.585),(1.06,5.585),(1.06,5.425),(0.9,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,5.425),(1.24,5.585),(1.4,5.585),(1.4,5.425),(1.24,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,5.425),(1.58,5.585),(1.74,5.585),(1.74,5.425),(1.58,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,5.425),(1.92,5.585),(2.08,5.585),(2.08,5.425),(1.92,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,5.425),(2.26,5.585),(2.42,5.585),(2.42,5.425),(2.26,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,5.425),(2.6,5.585),(2.76,5.585),(2.76,5.425),(2.6,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,5.425),(2.94,5.585),(3.1,5.585),(3.1,5.425),(2.94,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,5.425),(3.28,5.585),(3.44,5.585),(3.44,5.425),(3.28,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,5.425),(3.62,5.585),(3.78,5.585),(3.78,5.425),(3.62,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,4.64),(2.785,4.8),(2.945,4.8),(2.945,4.64),(2.785,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(4.0,5.76),(4.0,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,5.345),(0.22,5.665),(3.78,5.665),(3.78,5.345),(0.22,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.705,4.64),(2.705,4.8),(3.025,4.8),(3.025,4.64),(2.705,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((2.675,0.89),(2.675,1.67),(2.905,1.67),(2.905,0.89),(2.675,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,0.89),(2.035,1.67),(2.165,1.67),(2.165,0.89),(2.035,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,1.19),(3.015,1.19),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.715,0.89),(2.715,1.67),(3.015,1.67),(3.015,0.89),(2.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,0.89),(2.545,1.67),(2.675,1.67),(2.675,0.89),(2.545,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.15,0.105),(0.15,0.405),(3.85,0.405),(3.85,0.105),(0.15,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.895,0.405),(3.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.825,0.89),(2.825,1.67),(3.055,1.67),(3.055,0.89),(2.825,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.055,0.89),(3.055,1.67),(3.185,1.67),(3.185,0.89),(3.055,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,0.89),(2.745,1.67),(2.985,1.67),(2.985,0.89),(2.745,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.22,0.175),(0.22,0.335),(0.38,0.335),(0.38,0.175),(0.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.56,0.175),(0.56,0.335),(0.72,0.335),(0.72,0.175),(0.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.9,0.175),(0.9,0.335),(1.06,0.335),(1.06,0.175),(0.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.24,0.175),(1.24,0.335),(1.4,0.335),(1.4,0.175),(1.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.58,0.175),(1.58,0.335),(1.74,0.335),(1.74,0.175),(1.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.92,0.175),(1.92,0.335),(2.08,0.335),(2.08,0.175),(1.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.26,0.175),(2.26,0.335),(2.42,0.335),(2.42,0.175),(2.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.6,0.175),(2.6,0.335),(2.76,0.335),(2.76,0.175),(2.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.94,0.175),(2.94,0.335),(3.1,0.335),(3.1,0.175),(2.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.28,0.175),(3.28,0.335),(3.44,0.335),(3.44,0.175),(3.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.62,0.175),(3.62,0.335),(3.78,0.335),(3.78,0.175),(3.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.785,0.96),(2.785,1.12),(2.945,1.12),(2.945,0.96),(2.785,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.22,0.095),(0.22,0.415),(3.78,0.415),(3.78,0.095),(0.22,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(4.0,1.12),(4.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.705,0.96),(2.705,1.12),(3.025,1.12),(3.025,0.96),(2.705,0.96)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.0), u(4.0), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.0), u(4.0), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i0']
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.2),(0.575,2.2),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,1.9),(0.51,2.2),(1.02,2.2),(1.02,1.9),(0.51,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.52),(0.445,5.05),(0.575,5.05),(0.575,3.52),(0.445,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,1.9),(0.535,2.2),(0.835,2.2),(0.835,1.9),(0.535,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.2),(1.085,2.2),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,3.52),(0.51,3.82),(1.02,3.82),(1.02,3.52),(0.51,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.52),(0.955,5.05),(1.085,5.05),(1.085,3.52),(0.955,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.52),(0.535,3.82),(0.835,3.82),(0.835,3.52),(0.535,3.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.59),(0.605,3.75),(0.765,3.75),(0.765,3.59),(0.605,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,1.97),(0.605,2.13),(0.765,2.13),(0.765,1.97),(0.605,1.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,1.89),(0.605,2.21),(0.765,2.21),(0.765,1.89),(0.605,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.51),(0.605,3.83),(0.765,3.83),(0.765,3.51),(0.605,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.09,0.89),(1.09,1.67),(1.46,1.67),(1.46,0.89),(1.09,0.89)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((2.205,4.1),(2.205,4.4),(2.505,4.4),(2.505,4.1),(2.205,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.09),(1.125,4.87),(1.425,4.87),(1.425,4.09),(1.125,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,4.09),(2.165,4.87),(2.395,4.87),(2.395,4.09),(2.165,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,4.09),(2.235,4.87),(2.475,4.87),(2.475,4.09),(2.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.09),(2.205,4.87),(2.505,4.87),(2.505,4.09),(2.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.315,4.09),(2.315,4.87),(2.545,4.87),(2.545,4.09),(2.315,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.1),(1.125,4.4),(1.425,4.4),(1.425,4.1),(1.125,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.17),(1.195,4.33),(1.355,4.33),(1.355,4.17),(1.195,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.17),(2.275,4.33),(2.435,4.33),(2.435,4.17),(2.275,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.195,4.09),(1.195,4.42),(1.355,4.42),(1.355,4.09),(1.195,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.195,4.09),(1.195,4.41),(1.355,4.41),(1.355,4.09),(1.195,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,4.09),(2.275,4.42),(2.435,4.42),(2.435,4.09),(2.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.275,4.09),(1.275,4.42),(2.355,4.42),(2.355,4.09),(1.275,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,4.09),(2.275,4.41),(2.435,4.41),(2.435,4.09),(2.275,4.09)),
        )
        net = nets['nq']
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,1.36),(1.665,1.66),(1.965,1.66),(1.965,1.36),(1.665,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,0.89),(1.805,1.67),(2.035,1.67),(2.035,0.89),(1.805,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.965,4.87),(1.965,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,4.09),(1.805,4.87),(2.035,4.87),(2.035,4.09),(1.805,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.965,1.67),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.52),(1.665,4.87),(1.965,4.87),(1.965,3.52),(1.665,3.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.52),(1.665,3.82),(1.965,3.82),(1.965,3.52),(1.665,3.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.965,1.67),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.735,1.43),(1.735,1.59),(1.895,1.59),(1.895,1.43),(1.735,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.735,3.59),(1.735,3.75),(1.895,3.75),(1.895,3.59),(1.735,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.34),(1.01,3.87),(1.22,3.87),(1.22,1.34),(1.01,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.735,1.34),(1.735,1.67),(1.895,1.67),(1.895,1.34),(1.735,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.735,1.35),(1.735,1.67),(1.895,1.67),(1.895,1.35),(1.735,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,1.34),(1.115,1.67),(1.815,1.67),(1.815,1.34),(1.115,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,3.51),(1.01,3.83),(1.22,3.83),(1.22,3.51),(1.01,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,3.51),(1.115,3.83),(1.815,3.83),(1.815,3.51),(1.115,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.01,1.35),(1.01,1.67),(1.22,1.67),(1.22,1.35),(1.01,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.735,3.51),(1.735,3.83),(1.895,3.83),(1.895,3.51),(1.735,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.115), u(0.21), u(1.34), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.115), u(0.21), u(1.34), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['i1_n']
        createRL(
            tech, net, 'GatPoly',
            ((2.545,2.44),(2.545,5.05),(2.675,5.05),(2.675,2.44),(2.545,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,3.91),(2.545,5.05),(2.675,5.05),(2.675,3.91),(2.545,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.285,2.44),(3.285,2.74),(3.585,2.74),(3.585,2.44),(3.285,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.345,2.44),(2.345,2.74),(2.645,2.74),(2.645,2.44),(2.345,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.495,2.44),(2.495,2.74),(3.435,2.74),(3.435,2.44),(2.495,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.2),(1.595,2.2),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.395,1.9),(1.395,2.2),(1.695,2.2),(1.695,1.9),(1.395,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.53,1.9),(1.53,2.2),(1.545,2.2),(1.545,1.9),(1.53,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.185,4.09),(3.185,4.87),(3.415,4.87),(3.415,4.09),(3.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.185,0.89),(3.185,1.67),(3.415,1.67),(3.415,0.89),(3.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.285,1.36),(3.285,1.66),(3.585,1.66),(3.585,1.36),(3.285,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.285,0.89),(3.285,1.67),(3.585,1.67),(3.585,0.89),(3.285,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.255,4.09),(3.255,4.87),(3.585,4.87),(3.585,4.09),(3.255,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.285,4.1),(3.285,4.4),(3.585,4.4),(3.585,4.1),(3.285,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.285,4.09),(3.285,4.87),(3.585,4.87),(3.585,4.09),(3.285,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.255,0.89),(3.255,1.67),(3.585,1.67),(3.585,0.89),(3.255,0.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,4.09),(3.355,4.41),(3.515,4.41),(3.515,4.09),(3.355,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,1.89),(2.39,2.75),(2.6,2.75),(2.6,1.89),(2.39,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,2.43),(3.355,2.75),(3.515,2.75),(3.515,2.43),(3.355,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,1.35),(3.355,1.67),(3.515,1.67),(3.515,1.35),(3.355,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,1.89),(2.39,2.21),(2.6,2.21),(2.6,1.89),(2.39,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.465,1.89),(1.465,2.21),(1.625,2.21),(1.625,1.89),(1.465,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.545,1.89),(1.545,2.21),(2.495,2.21),(2.495,1.89),(1.545,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.33,1.35),(3.33,4.41),(3.54,4.41),(3.54,1.35),(3.33,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,4.09),(3.355,4.42),(3.515,4.42),(3.515,4.09),(3.355,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,1.34),(3.355,1.67),(3.515,1.67),(3.515,1.34),(3.355,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.415,2.43),(2.415,2.75),(2.575,2.75),(2.575,2.43),(2.415,2.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.465,1.97),(1.465,2.13),(1.625,2.13),(1.625,1.97),(1.465,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.415,2.51),(2.415,2.67),(2.575,2.67),(2.575,2.51),(2.415,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.355,4.17),(3.355,4.33),(3.515,4.33),(3.515,4.17),(3.355,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.355,1.43),(3.355,1.59),(3.515,1.59),(3.515,1.43),(3.355,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.355,2.51),(3.355,2.67),(3.515,2.67),(3.515,2.51),(3.355,2.51)),
        )
        net = nets['i1']
        createRL(
            tech, net, 'GatPoly',
            ((2.61,1.9),(2.61,2.2),(3.12,2.2),(3.12,1.9),(2.61,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,2.98),(1.465,5.05),(1.595,5.05),(1.595,2.98),(1.465,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,2.2),(2.675,2.2),(2.675,0.71),(2.545,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,3.52),(3.055,5.05),(3.185,5.05),(3.185,3.52),(3.055,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,3.91),(3.055,5.05),(3.185,5.05),(3.185,3.91),(3.055,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,1.85),(2.675,1.85),(2.675,0.71),(2.545,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,1.9),(2.855,2.2),(3.155,2.2),(3.155,1.9),(2.855,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.395,2.98),(1.395,3.28),(1.695,3.28),(1.695,2.98),(1.395,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,0.71),(3.055,2.2),(3.185,2.2),(3.185,0.71),(3.055,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.53,2.98),(1.53,3.28),(1.545,3.28),(1.545,2.98),(1.53,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.005,3.52),(3.005,3.82),(3.12,3.82),(3.12,3.52),(3.005,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,0.71),(3.055,1.85),(3.185,1.85),(3.185,0.71),(3.055,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,3.52),(2.855,3.82),(3.155,3.82),(3.155,3.52),(2.855,3.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,1.97),(2.925,2.13),(3.085,2.13),(3.085,1.97),(2.925,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.465,3.05),(1.465,3.21),(1.625,3.21),(1.625,3.05),(1.465,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,3.59),(2.925,3.75),(3.085,3.75),(3.085,3.59),(2.925,3.59)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.545,2.97),(1.545,3.29),(3.005,3.29),(3.005,2.97),(1.545,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.9,1.34),(2.9,4.42),(3.11,4.42),(3.11,1.34),(2.9,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.465,2.97),(1.465,3.29),(1.625,3.29),(1.625,2.97),(1.465,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.9,2.97),(2.9,3.29),(3.11,3.29),(3.11,2.97),(2.9,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,1.89),(2.925,2.21),(3.085,2.21),(3.085,1.89),(2.925,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,3.51),(2.925,3.83),(3.085,3.83),(3.085,3.51),(2.925,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(3.005), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(3.005), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((2.315,0.89),(2.315,1.67),(2.545,1.67),(2.545,0.89),(2.315,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,0.89),(2.235,1.67),(2.475,1.67),(2.475,0.89),(2.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.17,0.89),(2.17,1.67),(2.54,1.67),(2.54,0.89),(2.17,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,0.89),(2.165,1.67),(2.395,1.67),(2.395,0.89),(2.165,0.89)),
        )
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i0'].setDirection(Net.Direction.IN)
        nets['i1'].setDirection(Net.Direction.IN)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['nsnrlatch_x0']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'nq': Net.create(cell, 'nq'),
            'nrst': Net.create(cell, 'nrst'),
            'nset': Net.create(cell, 'nset'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,4.09),(0.725,4.87),(0.955,4.87),(0.955,4.09),(0.725,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.885,4.87),(0.885,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.1),(0.615,4.4),(0.915,4.4),(0.915,4.1),(0.615,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.17),(0.685,4.33),(0.845,4.33),(0.845,4.17),(0.685,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,3.05),(1.335,3.21),(1.495,3.21),(1.495,3.05),(1.335,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.35),(0.58,1.67),(0.79,1.67),(0.79,1.35),(0.58,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,1.67),(0.685,1.67),(0.685,1.34),(0.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.42),(0.845,4.42),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.97),(1.335,3.29),(1.495,3.29),(1.495,2.97),(1.335,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.41),(0.845,4.41),(0.845,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,4.09),(0.685,4.42),(0.765,4.42),(0.765,4.09),(0.685,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,4.09),(0.58,4.41),(0.79,4.41),(0.79,4.09),(0.58,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,2.97),(0.58,3.29),(0.79,3.29),(0.79,2.97),(0.58,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,2.97),(0.685,3.29),(1.415,3.29),(1.415,2.97),(0.685,2.97)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.98),(1.265,3.28),(1.565,3.28),(1.565,2.98),(1.265,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.02,2.44),(1.02,2.74),(1.115,2.74),(1.115,2.44),(1.02,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.91),(1.595,3.91),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.91),(1.465,5.05),(1.595,5.05),(1.595,3.91),(1.465,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.98),(1.415,3.28),(1.53,3.28),(1.53,2.98),(1.415,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,1.85),(1.595,1.85),(1.595,0.71),(1.465,0.71)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((2.035,4.09),(2.035,4.87),(2.165,4.87),(2.165,4.09),(2.035,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.09),(1.125,4.87),(1.425,4.87),(1.425,4.09),(1.125,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,4.09),(0.955,4.87),(1.085,4.87),(1.085,4.09),(0.955,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,4.09),(2.165,4.87),(2.395,4.87),(2.395,4.09),(2.165,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,4.09),(1.235,4.87),(1.465,4.87),(1.465,4.09),(1.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,4.09),(1.465,4.87),(1.595,4.87),(1.595,4.09),(1.465,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,4.09),(1.155,4.87),(1.395,4.87),(1.395,4.09),(1.155,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.09),(2.205,4.87),(2.505,4.87),(2.505,4.09),(2.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.57),(2.205,4.87),(2.505,4.87),(2.505,4.57),(2.205,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,4.09),(2.235,4.87),(2.505,4.87),(2.505,4.09),(2.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,4.09),(1.085,4.87),(1.315,4.87),(1.315,4.09),(1.085,4.09)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,3.78),(0.815,5.18),(1.735,5.18),(1.735,3.78),(0.815,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,4.26),(1.895,5.18),(2.815,5.18),(2.815,4.26),(1.895,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.78),(1.385,5.18),(2.305,5.18),(2.305,3.78),(1.385,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.495,3.78),(1.495,5.18),(2.705,5.18),(2.705,3.78),(1.495,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.78),(0.415,5.18),(1.625,5.18),(1.625,3.78),(0.415,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.79),(0.305,4.71),(1.225,4.71),(1.225,3.79),(0.305,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.78),(0.925,5.18),(2.135,5.18),(2.135,3.78),(0.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.925,3.78),(1.925,5.18),(2.815,5.18),(2.815,3.78),(1.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.195,5.18),(1.195,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.79),(1.385,4.71),(2.305,4.71),(2.305,3.79),(1.385,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.78),(1.895,5.18),(2.815,5.18),(2.815,3.78),(1.895,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.78),(0.845,5.18),(1.705,5.18),(1.705,3.78),(0.845,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.78),(1.355,5.18),(2.275,5.18),(2.275,3.78),(1.355,3.78)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.64),(2.275,4.8),(2.435,4.8),(2.435,4.64),(2.275,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,4.64),(2.195,4.8),(2.515,4.8),(2.515,4.64),(2.195,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.8),(0.435,4.7),(1.095,4.7),(1.095,3.8),(0.435,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.79),(0.655,5.17),(1.385,5.17),(1.385,3.79),(0.655,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.79),(1.165,5.17),(1.895,5.17),(1.895,3.79),(1.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.91),(1.055,5.05),(2.005,5.05),(2.005,3.91),(1.055,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.8),(1.515,4.7),(2.175,4.7),(2.175,3.8),(1.515,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.79),(1.735,5.17),(2.465,5.17),(2.465,3.79),(1.735,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.91),(0.545,5.05),(1.495,5.05),(1.495,3.91),(0.545,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.79),(1.515,5.17),(2.175,5.17),(2.175,3.79),(1.515,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.79),(1.485,5.17),(2.145,5.17),(2.145,3.79),(1.485,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.79),(0.975,5.17),(1.575,5.17),(1.575,3.79),(0.975,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.79),(2.025,5.17),(2.685,5.17),(2.685,3.79),(2.025,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.625,3.91),(1.625,5.05),(2.575,5.05),(2.575,3.91),(1.625,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,3.79),(0.945,5.17),(1.605,5.17),(1.605,3.79),(0.945,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.055,3.79),(2.055,5.17),(2.685,5.17),(2.685,3.79),(2.055,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.065,5.17),(1.065,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,4.27),(2.025,5.17),(2.685,5.17),(2.685,4.27),(2.025,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,1.67),(1.395,1.67),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,1.67),(1.465,1.67),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,0.89),(2.035,1.67),(2.165,1.67),(2.165,0.89),(2.035,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,1.67),(1.315,1.67),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,1.67),(1.085,1.67),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,1.67),(1.595,1.67),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.67),(1.425,1.67),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.885,1.67),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,1.67),(0.95,1.67),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,1.67),(0.955,1.67),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['nset']
        createRL(
            tech, net, 'GatPoly',
            ((2.1,2.44),(2.1,2.74),(2.275,2.74),(2.275,2.44),(2.1,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(0.51,3.28),(0.51,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.91),(0.575,3.91),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.89),(0.15,4.42),(0.36,4.42),(0.36,1.89),(0.15,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.91),(1.085,3.91),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.91),(0.955,5.05),(1.085,5.05),(1.085,3.91),(0.955,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,1.85),(1.085,1.85),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.965,2.44),(0.965,2.74),(1.265,2.74),(1.265,2.44),(0.965,2.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.035,2.51),(1.035,2.67),(1.195,2.67),(1.195,2.51),(1.035,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.17),(1.765,4.33),(1.925,4.33),(1.925,4.17),(1.765,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.43),(2.275,1.59),(2.435,1.59),(2.435,1.43),(2.275,1.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,1.34),(1.845,1.67),(2.355,1.67),(2.355,1.34),(1.845,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.42),(1.925,4.42),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,2.43),(1.115,2.75),(1.845,2.75),(1.845,2.43),(1.115,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.41),(1.925,4.41),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,2.43),(1.74,2.75),(1.95,2.75),(1.95,2.43),(1.74,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.34),(2.275,1.67),(2.435,1.67),(2.435,1.34),(2.275,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.35),(1.74,1.67),(1.95,1.67),(1.95,1.35),(1.74,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.035,2.43),(1.035,2.75),(1.195,2.75),(1.195,2.43),(1.035,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.34),(1.74,4.42),(1.95,4.42),(1.95,1.34),(1.74,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.35),(2.275,1.67),(2.435,1.67),(2.435,1.35),(2.275,1.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,4.09),(1.595,4.87),(1.825,4.87),(1.825,4.09),(1.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,0.89),(2.235,1.67),(2.505,1.67),(2.505,0.89),(2.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,4.09),(1.665,4.87),(1.965,4.87),(1.965,4.09),(1.665,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.1),(1.695,4.4),(1.995,4.4),(1.995,4.1),(1.695,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,4.09),(1.805,4.87),(2.035,4.87),(2.035,4.09),(1.805,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.09),(1.695,4.87),(1.995,4.87),(1.995,4.09),(1.695,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,0.89),(2.165,1.67),(2.395,1.67),(2.395,0.89),(2.165,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,1.36),(2.205,1.66),(2.505,1.66),(2.505,1.36),(2.205,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.67),(2.505,1.67),(2.505,0.89),(2.205,0.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,1.67),(1.965,1.67),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.66,0.89),(1.66,1.67),(2.03,1.67),(2.03,0.89),(1.66,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,0.89),(1.805,1.67),(2.035,1.67),(2.035,0.89),(1.805,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,1.67),(1.825,1.67),(1.825,0.89),(1.595,0.89)),
        )
        net = nets['nrst']
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,1.85),(2.165,1.85),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,3.91),(2.165,3.91),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.91),(2.035,5.05),(2.165,5.05),(2.165,3.91),(2.035,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.125,2.44),(2.125,2.74),(2.425,2.74),(2.425,2.44),(2.125,2.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.195,2.51),(2.195,2.67),(2.355,2.67),(2.355,2.51),(2.195,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,2.43),(2.195,2.75),(2.355,2.75),(2.355,2.43),(2.195,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.17,1.89),(2.17,4.42),(2.38,4.42),(2.38,1.89),(2.17,1.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.275), u(0.21), u(1.89), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.275), u(0.21), u(1.89), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nset'].setDirection(Net.Direction.IN)
        nets['nrst'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['nsnrlatch_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(3.2), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            'nq': Net.create(cell, 'nq'),
            'nrst': Net.create(cell, 'nrst'),
            'nset': Net.create(cell, 'nset'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['q']
        createRL(
            tech, net, 'Activ',
            ((0.575,3.35),(0.575,4.87),(0.805,4.87),(0.805,3.35),(0.575,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.375,2.37),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,2.37),(0.445,2.37),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.455),(0.105,2.095),(0.405,2.095),(0.405,1.455),(0.105,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.35),(0.615,4.87),(0.915,4.87),(0.915,3.35),(0.615,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,2.37),(0.405,2.37),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,3.35),(0.725,4.87),(0.955,4.87),(0.955,3.35),(0.725,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,3.35),(0.645,4.87),(0.885,4.87),(0.885,3.35),(0.645,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,3.645),(0.615,4.285),(0.915,4.285),(0.915,3.645),(0.615,3.645)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,3.715),(0.685,3.875),(0.845,3.875),(0.845,3.715),(0.685,3.715)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.055),(0.685,4.215),(0.845,4.215),(0.845,4.055),(0.685,4.055)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.335,3.05),(1.335,3.21),(1.495,3.21),(1.495,3.05),(1.335,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.525),(0.175,1.685),(0.335,1.685),(0.335,1.525),(0.175,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.865),(0.175,2.025),(0.335,2.025),(0.335,1.865),(0.175,1.865)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.89),(0.58,2.21),(0.79,2.21),(0.79,1.89),(0.58,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.635),(0.685,4.295),(0.845,4.295),(0.845,3.635),(0.685,3.635)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,2.21),(0.335,2.21),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.255,1.34),(0.255,2.21),(0.685,2.21),(0.685,1.34),(0.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.51),(0.685,4.42),(0.845,4.42),(0.845,3.51),(0.685,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.445),(0.175,2.105),(0.335,2.105),(0.335,1.445),(0.175,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,3.51),(0.685,4.42),(0.765,4.42),(0.765,3.51),(0.685,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.97),(1.335,3.29),(1.495,3.29),(1.495,2.97),(1.335,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,2.97),(0.58,3.29),(0.79,3.29),(0.79,2.97),(0.58,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,3.51),(0.58,3.83),(0.79,3.83),(0.79,3.51),(0.58,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.685,2.97),(0.685,3.29),(1.415,3.29),(1.415,2.97),(0.685,2.97)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,3.17),(1.595,3.17),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,3.17),(1.465,5.05),(1.595,5.05),(1.595,3.17),(1.465,3.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.465,0.71),(1.465,2.55),(1.595,2.55),(1.595,0.71),(1.465,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.265,2.98),(1.265,3.28),(1.565,3.28),(1.565,2.98),(1.265,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.02,2.44),(1.02,2.74),(1.115,2.74),(1.115,2.44),(1.02,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.415,2.98),(1.415,3.28),(1.53,3.28),(1.53,2.98),(1.415,2.98)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vdd']
        createRL(
            tech, net, 'Activ',
            ((2.035,3.35),(2.035,4.87),(2.165,4.87),(2.165,3.35),(2.035,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,3.35),(0.955,4.87),(1.085,4.87),(1.085,3.35),(0.955,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,3.35),(2.235,4.87),(2.505,4.87),(2.505,3.35),(2.235,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,3.35),(1.125,4.87),(1.425,4.87),(1.425,3.35),(1.125,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,3.35),(2.205,4.87),(2.505,4.87),(2.505,3.35),(2.205,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(3.095,5.655),(3.095,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,5.355),(0.26,5.655),(2.94,5.655),(2.94,5.355),(0.26,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,4.57),(1.125,4.87),(1.425,4.87),(1.425,4.57),(1.125,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,3.35),(1.085,4.87),(1.315,4.87),(1.315,3.35),(1.085,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,3.35),(1.235,4.87),(1.465,4.87),(1.465,3.35),(1.235,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.405,4.87),(0.405,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.57),(2.205,4.87),(2.505,4.87),(2.505,4.57),(2.205,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,3.35),(0.215,4.87),(0.445,4.87),(0.445,3.35),(0.215,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.465,3.35),(1.465,4.87),(1.595,4.87),(1.595,3.35),(1.465,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,3.35),(0.445,4.87),(0.575,4.87),(0.575,3.35),(0.445,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,3.35),(2.165,4.87),(2.395,4.87),(2.395,3.35),(2.165,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,3.35),(1.155,4.87),(1.395,4.87),(1.395,3.35),(1.155,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.57),(0.105,4.87),(0.405,4.87),(0.405,4.57),(0.105,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,3.35),(0.105,4.87),(0.375,4.87),(0.375,3.35),(0.105,3.35)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,3.04),(0.815,5.18),(1.735,5.18),(1.735,3.04),(0.815,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.04),(0.335,5.18),(1.195,5.18),(1.195,3.04),(0.335,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.925,3.04),(0.925,5.18),(2.135,5.18),(2.135,3.04),(0.925,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.925,3.04),(1.925,5.18),(2.815,5.18),(2.815,3.04),(1.925,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.685,5.18),(0.685,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,4.26),(1.895,5.18),(2.815,5.18),(2.815,4.26),(1.895,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,4.26),(-0.205,5.18),(0.715,5.18),(0.715,4.26),(-0.205,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.04),(1.385,5.18),(2.305,5.18),(2.305,3.04),(1.385,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.815,4.26),(0.815,5.18),(1.735,5.18),(1.735,4.26),(0.815,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.04),(0.305,5.18),(1.225,5.18),(1.225,3.04),(0.305,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.335),(1.385,4.595),(2.305,4.595),(2.305,3.335),(1.385,3.335)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.845,3.04),(0.845,5.18),(1.705,5.18),(1.705,3.04),(0.845,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.04),(-0.205,5.18),(0.715,5.18),(0.715,3.04),(-0.205,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(3.51,6.07),(3.51,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.495,3.04),(1.495,5.18),(2.705,5.18),(2.705,3.04),(1.495,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.04),(-0.095,5.18),(1.115,5.18),(1.115,3.04),(-0.095,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.415,3.04),(0.415,5.18),(1.625,5.18),(1.625,3.04),(0.415,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.05,5.045),(-0.05,5.965),(3.25,5.965),(3.25,5.045),(-0.05,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(3.405,5.965),(3.405,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.04),(1.895,5.18),(2.815,5.18),(2.815,3.04),(1.895,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.355,3.04),(1.355,5.18),(2.275,5.18),(2.275,3.04),(1.355,3.04)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.335),(0.305,4.595),(1.225,4.595),(1.225,3.335),(0.305,3.335)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,4.64),(1.195,4.8),(1.355,4.8),(1.355,4.64),(1.195,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.64),(0.175,4.8),(0.335,4.8),(0.335,4.64),(0.175,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,5.425),(0.33,5.585),(0.49,5.585),(0.49,5.425),(0.33,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,5.425),(0.67,5.585),(0.83,5.585),(0.83,5.425),(0.67,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,5.425),(1.01,5.585),(1.17,5.585),(1.17,5.425),(1.01,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,5.425),(1.35,5.585),(1.51,5.585),(1.51,5.425),(1.35,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,5.425),(1.69,5.585),(1.85,5.585),(1.85,5.425),(1.69,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,5.425),(2.03,5.585),(2.19,5.585),(2.19,5.425),(2.03,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,5.425),(2.37,5.585),(2.53,5.585),(2.53,5.425),(2.37,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,5.425),(2.71,5.585),(2.87,5.585),(2.87,5.425),(2.71,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.64),(2.275,4.8),(2.435,4.8),(2.435,4.64),(2.275,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,5.345),(0.33,5.665),(2.87,5.665),(2.87,5.345),(0.33,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.095,4.64),(0.095,4.8),(0.415,4.8),(0.415,4.64),(0.095,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(3.2,5.76),(3.2,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,4.64),(1.115,4.8),(1.435,4.8),(1.435,4.64),(1.115,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,4.64),(2.195,4.8),(2.515,4.8),(2.515,4.64),(2.195,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((1.625,3.17),(1.625,5.05),(2.575,5.05),(2.575,3.17),(1.625,3.17)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.17),(0.035,5.05),(0.985,5.05),(0.985,3.17),(0.035,3.17)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.655,3.05),(0.655,5.17),(1.385,5.17),(1.385,3.05),(0.655,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.055,3.05),(2.055,5.17),(2.685,5.17),(2.685,3.05),(2.055,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.585,5.17),(0.585,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.05),(0.465,5.17),(1.065,5.17),(1.065,3.05),(0.465,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.545,3.17),(0.545,5.05),(1.495,5.05),(1.495,3.17),(0.545,3.17)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.05),(1.735,5.17),(2.465,5.17),(2.465,3.05),(1.735,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.165,3.05),(1.165,5.17),(1.895,5.17),(1.895,3.05),(1.165,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(3.275,0.585),(3.275,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.05),(1.515,5.17),(2.175,5.17),(2.175,3.05),(1.515,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.05),(0.435,5.17),(1.095,5.17),(1.095,3.05),(0.435,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.08,-0.075),(0.08,0.585),(3.12,0.585),(3.12,-0.075),(0.08,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.055,3.17),(1.055,5.05),(2.005,5.05),(2.005,3.17),(1.055,3.17)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,4.27),(-0.075,5.17),(0.585,5.17),(0.585,4.27),(-0.075,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,3.05),(0.945,5.17),(1.605,5.17),(1.605,3.05),(0.945,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.05),(0.145,5.17),(0.875,5.17),(0.875,3.05),(0.145,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.05),(-0.075,5.17),(0.555,5.17),(0.555,3.05),(-0.075,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,4.27),(2.025,5.17),(2.685,5.17),(2.685,4.27),(2.025,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.05),(2.025,5.17),(2.685,5.17),(2.685,3.05),(2.025,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.485,3.05),(1.485,5.17),(2.145,5.17),(2.145,3.05),(1.485,3.05)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.345),(0.435,4.585),(1.095,4.585),(1.095,3.345),(0.435,3.345)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.945,4.27),(0.945,5.17),(1.605,5.17),(1.605,4.27),(0.945,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.345),(1.515,4.585),(2.175,4.585),(2.175,3.345),(1.515,3.345)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(3.275,5.17),(3.275,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.975,3.05),(0.975,5.17),(1.575,5.17),(1.575,3.05),(0.975,3.05)),
        )
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((1.465,0.89),(1.465,2.37),(1.595,2.37),(1.595,0.89),(1.465,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.235,0.89),(1.235,2.37),(1.465,2.37),(1.465,0.89),(1.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.155,0.89),(1.155,2.37),(1.395,2.37),(1.395,0.89),(1.155,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,2.37),(0.575,2.37),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.085,0.89),(1.085,2.37),(1.315,2.37),(1.315,0.89),(1.085,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.26,0.105),(0.26,0.405),(2.94,0.405),(2.94,0.105),(0.26,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.955,0.89),(0.955,2.37),(1.085,2.37),(1.085,0.89),(0.955,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(3.095,0.405),(3.095,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,2.37),(1.425,2.37),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.125,0.89),(1.125,1.19),(1.425,1.19),(1.425,0.89),(1.125,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,0.89),(2.035,2.37),(2.165,2.37),(2.165,0.89),(2.035,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.195,0.96),(1.195,1.12),(1.355,1.12),(1.355,0.96),(1.195,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.33,0.175),(0.33,0.335),(0.49,0.335),(0.49,0.175),(0.33,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.67,0.175),(0.67,0.335),(0.83,0.335),(0.83,0.175),(0.67,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.01,0.175),(1.01,0.335),(1.17,0.335),(1.17,0.175),(1.01,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.35,0.175),(1.35,0.335),(1.51,0.335),(1.51,0.175),(1.35,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.69,0.175),(1.69,0.335),(1.85,0.335),(1.85,0.175),(1.69,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.03,0.175),(2.03,0.335),(2.19,0.335),(2.19,0.175),(2.03,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.37,0.175),(2.37,0.335),(2.53,0.335),(2.53,0.175),(2.37,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.71,0.175),(2.71,0.335),(2.87,0.335),(2.87,0.175),(2.71,0.175)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,0.96),(1.115,1.12),(1.435,1.12),(1.435,0.96),(1.115,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(3.2,1.12),(3.2,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.33,0.095),(0.33,0.415),(2.87,0.415),(2.87,0.095),(0.33,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.6), u(3.2), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((0.58,0.89),(0.58,2.37),(0.95,2.37),(0.95,0.89),(0.58,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.725,0.89),(0.725,2.37),(0.955,2.37),(0.955,0.89),(0.725,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,2.37),(0.885,2.37),(0.885,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,2.37),(0.805,2.37),(0.805,0.89),(0.575,0.89)),
        )
        net = nets['nset']
        createRL(
            tech, net, 'GatPoly',
            ((2.1,2.44),(2.1,2.74),(2.275,2.74),(2.275,2.44),(2.1,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,3.17),(0.575,3.17),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(0.51,3.28),(0.51,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.55),(0.575,2.55),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.17),(0.445,5.05),(0.575,5.05),(0.575,3.17),(0.445,3.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,2.43),(0.15,4.42),(0.36,4.42),(0.36,2.43),(0.15,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.255), u(0.21), u(2.43), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.255), u(0.21), u(2.43), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['nq']
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,2.55),(1.085,2.55),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,0.71),(0.955,3.17),(1.085,3.17),(1.085,0.71),(0.955,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.955,3.17),(0.955,5.05),(1.085,5.05),(1.085,3.17),(0.955,3.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.965,2.44),(0.965,2.74),(1.265,2.74),(1.265,2.44),(0.965,2.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,3.715),(1.765,3.875),(1.925,3.875),(1.925,3.715),(1.765,3.715)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.055),(1.765,4.215),(1.925,4.215),(1.925,4.055),(1.765,4.055)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.525),(2.275,1.685),(2.435,1.685),(2.435,1.525),(2.275,1.525)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,1.865),(2.275,2.025),(2.435,2.025),(2.435,1.865),(2.275,1.865)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.035,2.51),(1.035,2.67),(1.195,2.67),(1.195,2.51),(1.035,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.115,2.43),(1.115,2.75),(1.845,2.75),(1.845,2.43),(1.115,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.445),(2.275,2.105),(2.435,2.105),(2.435,1.445),(2.275,1.445)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,2.43),(1.74,2.75),(1.95,2.75),(1.95,2.43),(1.74,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.51),(1.765,4.42),(1.925,4.42),(1.925,3.51),(1.765,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,3.635),(1.765,4.295),(1.925,4.295),(1.925,3.635),(1.765,3.635)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.89),(1.74,2.21),(1.95,2.21),(1.95,1.89),(1.74,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.275,1.34),(2.275,2.21),(2.435,2.21),(2.435,1.34),(2.275,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.035,2.43),(1.035,2.75),(1.195,2.75),(1.195,2.43),(1.035,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.74,1.34),(1.74,4.42),(1.95,4.42),(1.95,1.34),(1.74,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,1.34),(1.845,2.21),(2.355,2.21),(2.355,1.34),(1.845,1.34)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,0.89),(2.165,2.37),(2.395,2.37),(2.395,0.89),(2.165,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.35),(1.695,4.87),(1.995,4.87),(1.995,3.35),(1.695,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,0.89),(2.235,2.37),(2.505,2.37),(2.505,0.89),(2.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.665,3.35),(1.665,4.87),(1.965,4.87),(1.965,3.35),(1.665,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,2.37),(2.505,2.37),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,3.35),(1.595,4.87),(1.825,4.87),(1.825,3.35),(1.595,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,3.35),(1.805,4.87),(2.035,4.87),(2.035,3.35),(1.805,3.35)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,1.455),(2.205,2.095),(2.505,2.095),(2.505,1.455),(2.205,1.455)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,3.645),(1.695,4.285),(1.995,4.285),(1.995,3.645),(1.695,3.645)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.845), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((1.665,0.89),(1.665,2.37),(1.965,2.37),(1.965,0.89),(1.665,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.595,0.89),(1.595,2.37),(1.825,2.37),(1.825,0.89),(1.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.66,0.89),(1.66,2.37),(2.03,2.37),(2.03,0.89),(1.66,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,0.89),(1.805,2.37),(2.035,2.37),(2.035,0.89),(1.805,0.89)),
        )
        net = nets['nrst']
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.17),(2.035,5.05),(2.165,5.05),(2.165,3.17),(2.035,3.17)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,2.55),(2.165,2.55),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,3.17),(2.165,3.17),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.125,2.44),(2.125,2.74),(2.425,2.74),(2.425,2.44),(2.125,2.44)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.195,2.51),(2.195,2.67),(2.355,2.67),(2.355,2.51),(2.195,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,2.43),(2.195,2.75),(2.355,2.75),(2.355,2.43),(2.195,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.17,2.43),(2.17,4.42),(2.38,4.42),(2.38,2.43),(2.17,2.43)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(2.275), u(0.21), u(2.43), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(2.275), u(0.21), u(2.43), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['nset'].setDirection(Net.Direction.IN)
        nets['nrst'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['nq'].setDirection(Net.Direction.OUT)

    cell = new_cells['dff_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(8.0), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_clk_buf': Net.create(cell, '_clk_buf'),
            '_clk_n': Net.create(cell, '_clk_n'),
            '_dff_m': Net.create(cell, '_dff_m'),
            '_dff_s': Net.create(cell, '_dff_s'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            '_net5': Net.create(cell, '_net5'),
            '_u': Net.create(cell, '_u'),
            '_y': Net.create(cell, '_y'),
            'clk': Net.create(cell, 'clk'),
            'i': Net.create(cell, 'i'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_clk_n']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.985,3.05),(5.985,3.21),(6.145,3.21),(6.145,3.05),(5.985,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.985,1.97),(5.985,2.13),(6.145,2.13),(6.145,1.97),(5.985,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,1.97),(2.925,2.13),(3.085,2.13),(3.085,1.97),(2.925,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,3.05),(2.925,3.21),(3.085,3.21),(3.085,3.05),(2.925,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,1.89),(2.925,2.21),(3.085,2.21),(3.085,1.89),(2.925,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.985,2.97),(5.985,3.29),(6.145,3.29),(6.145,2.97),(5.985,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.35),(0.15,4.41),(0.36,4.41),(0.36,1.35),(0.15,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.9,1.89),(2.9,3.29),(3.11,3.29),(3.11,1.89),(2.9,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,2.97),(2.925,3.29),(3.085,3.29),(3.085,2.97),(2.925,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.96,1.89),(5.96,3.29),(6.17,3.29),(6.17,1.89),(5.96,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.985,1.89),(5.985,2.21),(6.145,2.21),(6.145,1.89),(5.985,1.89)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,1.9),(2.855,2.2),(3.155,2.2),(3.155,1.9),(2.855,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.395,2.98),(5.395,5.05),(5.525,5.05),(5.525,2.98),(5.395,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.915,1.9),(5.915,2.2),(6.215,2.2),(6.215,1.9),(5.915,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,1.85),(1.145,1.85),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.905,0.71),(5.905,2.2),(6.035,2.2),(6.035,0.71),(5.905,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,0.71),(3.055,1.85),(3.185,1.85),(3.185,0.71),(3.055,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,3.91),(1.015,5.05),(1.145,5.05),(1.145,3.91),(1.015,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,3.91),(3.565,5.05),(3.695,5.05),(3.695,3.91),(3.565,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,2.98),(3.565,5.05),(3.695,5.05),(3.695,2.98),(3.565,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.005,1.9),(3.005,2.2),(3.12,2.2),(3.12,1.9),(3.005,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,0.71),(3.055,2.2),(3.185,2.2),(3.185,0.71),(3.055,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.395,3.91),(5.395,5.05),(5.525,5.05),(5.525,3.91),(5.395,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,2.98),(2.855,3.28),(3.155,3.28),(3.155,2.98),(2.855,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,3.91),(1.145,3.91),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.915,2.98),(5.915,3.28),(6.215,3.28),(6.215,2.98),(5.915,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.97,1.9),(5.97,2.2),(6.065,2.2),(6.065,1.9),(5.97,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.905,0.71),(5.905,1.85),(6.035,1.85),(6.035,0.71),(5.905,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(6.065,3.28),(6.065,2.98),(0.255,2.98)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((4.985,3.91),(4.985,5.05),(5.935,5.05),(5.935,3.91),(4.985,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.245,3.59),(7.245,5.17),(7.905,5.17),(7.905,3.59),(7.245,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.435,4.27),(6.435,5.17),(7.095,5.17),(7.095,4.27),(6.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.045,3.79),(3.045,5.17),(3.705,5.17),(3.705,3.79),(3.045,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.035,3.79),(1.035,5.17),(1.665,5.17),(1.665,3.79),(1.035,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.005,3.91),(6.005,5.05),(6.955,5.05),(6.955,3.91),(6.005,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.245,3.785),(7.245,4.685),(7.905,4.685),(7.905,3.785),(7.245,3.785)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(8.075,0.585),(8.075,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.325,3.79),(4.325,5.17),(5.055,5.17),(5.055,3.79),(4.325,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.275,3.59),(7.275,5.17),(7.905,5.17),(7.905,3.59),(7.275,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.415,3.79),(5.415,5.17),(6.015,5.17),(6.015,3.79),(5.415,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.565,3.79),(2.565,5.17),(3.165,5.17),(3.165,3.79),(2.565,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.065,3.79),(4.065,5.17),(4.725,5.17),(4.725,3.79),(4.065,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(8.075,5.17),(8.075,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.435,3.59),(6.435,5.17),(7.095,5.17),(7.095,3.59),(6.435,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.435,3.59),(6.435,5.17),(7.365,5.17),(7.365,3.59),(6.435,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.135,3.91),(2.135,5.05),(3.085,5.05),(3.085,3.91),(2.135,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.095,3.79),(4.095,5.17),(4.735,5.17),(4.735,3.79),(4.095,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.925,3.79),(5.925,5.17),(6.525,5.17),(6.525,3.79),(5.925,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.86,3.79),(5.86,5.17),(6.59,5.17),(6.59,3.79),(5.86,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.495,3.91),(5.495,5.05),(6.445,5.05),(6.445,3.91),(5.495,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.5,3.79),(2.5,5.17),(3.23,5.17),(3.23,3.79),(2.5,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.075,3.79),(3.075,5.17),(3.675,5.17),(3.675,3.79),(3.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.52,3.79),(3.52,5.17),(4.25,5.17),(4.25,3.79),(3.52,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.245,3.79),(2.245,5.17),(2.975,5.17),(2.975,3.79),(2.245,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.07,-0.075),(-0.07,0.585),(8.07,0.585),(8.07,-0.075),(-0.07,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.215,3.91),(4.215,5.05),(5.165,5.05),(5.165,3.91),(4.215,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.055,3.79),(2.055,5.17),(2.655,5.17),(2.655,3.79),(2.055,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.125,5.17),(1.125,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.065,4.27),(4.065,5.17),(4.725,5.17),(4.725,4.27),(4.065,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.845,3.71),(6.845,5.05),(7.795,5.05),(7.795,3.71),(6.845,3.71)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.045,3.8),(3.045,4.7),(3.705,4.7),(3.705,3.8),(3.045,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.79),(2.025,5.17),(2.685,5.17),(2.685,3.79),(2.025,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.79),(1.515,5.17),(2.145,5.17),(2.145,3.79),(1.515,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.665,3.91),(3.665,5.05),(4.615,5.05),(4.615,3.91),(3.665,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.645,3.79),(4.645,5.17),(5.505,5.17),(5.505,3.79),(4.645,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.755,3.79),(2.755,5.17),(3.485,5.17),(3.485,3.79),(2.755,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.385,3.8),(5.385,4.7),(6.045,4.7),(6.045,3.8),(5.385,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.79),(1.005,5.17),(1.665,5.17),(1.665,3.79),(1.005,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.875,3.8),(4.875,4.7),(5.535,4.7),(5.535,3.8),(4.875,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.115,3.79),(6.115,5.17),(6.845,5.17),(6.845,3.79),(6.115,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.385,3.79),(5.385,5.17),(6.045,5.17),(6.045,3.79),(5.385,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.875,3.79),(4.875,5.17),(5.535,5.17),(5.535,3.79),(4.875,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.775,3.79),(3.775,5.17),(4.505,5.17),(4.505,3.79),(3.775,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.095,3.79),(5.095,5.17),(5.825,5.17),(5.825,3.79),(5.095,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.605,3.91),(0.605,5.05),(1.555,5.05),(1.555,3.91),(0.605,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.955,3.59),(6.955,5.17),(7.685,5.17),(7.685,3.59),(6.955,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.625,3.91),(1.625,5.05),(2.575,5.05),(2.575,3.91),(1.625,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.265,3.79),(3.265,5.17),(3.995,5.17),(3.995,3.79),(3.265,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.155,3.91),(3.155,5.05),(4.105,5.05),(4.105,3.91),(3.155,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.8),(1.515,4.7),(2.175,4.7),(2.175,3.8),(1.515,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.645,3.91),(2.645,5.05),(3.595,5.05),(3.595,3.91),(2.645,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.605,3.79),(5.605,5.17),(6.335,5.17),(6.335,3.79),(5.605,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,4.27),(2.025,5.17),(2.685,5.17),(2.685,4.27),(2.025,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.79),(1.515,5.17),(2.175,5.17),(2.175,3.79),(1.515,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.715,3.79),(0.715,5.17),(1.445,5.17),(1.445,3.79),(0.715,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.585,3.79),(3.585,5.17),(4.185,5.17),(4.185,3.79),(3.585,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.8),(1.005,4.7),(1.665,4.7),(1.665,3.8),(1.005,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.79),(1.735,5.17),(2.465,5.17),(2.465,3.79),(1.735,3.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((1.385,3.78),(1.385,5.18),(2.305,5.18),(2.305,3.78),(1.385,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.875,3.78),(5.875,5.18),(7.085,5.18),(7.085,3.78),(5.875,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.435,3.78),(2.435,5.18),(3.295,5.18),(3.295,3.78),(2.435,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.115,3.775),(7.115,4.695),(8.035,4.695),(8.035,3.775),(7.115,3.775)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.37,3.78),(2.37,5.18),(3.36,5.18),(3.36,3.78),(2.37,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.535,3.78),(3.535,5.18),(4.745,5.18),(4.745,3.78),(3.535,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.795,3.78),(5.795,5.18),(6.655,5.18),(6.655,3.78),(5.795,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.145,3.58),(7.145,5.18),(8.035,5.18),(8.035,3.58),(7.145,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.935,3.78),(3.935,5.18),(4.855,5.18),(4.855,3.78),(3.935,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.915,3.79),(2.915,4.71),(3.835,4.71),(3.835,3.79),(2.915,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.915,3.78),(2.915,5.18),(3.835,5.18),(3.835,3.78),(2.915,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.515,3.78),(2.515,5.18),(3.725,5.18),(3.725,3.78),(2.515,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.455,3.78),(3.455,5.18),(4.315,5.18),(4.315,3.78),(3.455,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(8.205,5.965),(8.205,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.005,3.78),(2.005,5.18),(3.215,5.18),(3.215,3.78),(2.005,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(8.31,6.07),(8.31,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.115,3.58),(7.115,5.18),(8.035,5.18),(8.035,3.58),(7.115,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.475,3.78),(0.475,5.18),(1.685,5.18),(1.685,3.78),(0.475,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.285,3.78),(5.285,5.18),(6.145,5.18),(6.145,3.78),(5.285,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.715,3.58),(6.715,5.18),(7.925,5.18),(7.925,3.58),(6.715,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.365,3.78),(5.365,5.18),(6.575,5.18),(6.575,3.78),(5.365,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.255,3.79),(5.255,4.71),(6.175,4.71),(6.175,3.79),(5.255,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.255,5.18),(1.255,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.085,3.78),(4.085,5.18),(5.295,5.18),(5.295,3.78),(4.085,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.945,3.78),(2.945,5.18),(3.805,5.18),(3.805,3.78),(2.945,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.935,4.26),(3.935,5.18),(4.855,5.18),(4.855,4.26),(3.935,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.255,3.78),(5.255,5.18),(6.175,5.18),(6.175,3.78),(5.255,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.305,3.58),(6.305,5.18),(7.495,5.18),(7.495,3.58),(6.305,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.855,3.78),(4.855,5.18),(6.065,5.18),(6.065,3.78),(4.855,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.73,3.78),(5.73,5.18),(6.72,5.18),(6.72,3.78),(5.73,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.79),(1.385,4.71),(2.305,4.71),(2.305,3.79),(1.385,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.78),(1.895,5.18),(2.815,5.18),(2.815,3.78),(1.895,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.905,3.78),(0.905,5.18),(1.795,5.18),(1.795,3.78),(0.905,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.2,5.045),(-0.2,5.965),(8.2,5.965),(8.2,5.045),(-0.2,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.78),(0.875,5.18),(1.795,5.18),(1.795,3.78),(0.875,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.925,3.78),(1.925,5.18),(2.785,5.18),(2.785,3.78),(1.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.305,4.26),(6.305,5.18),(7.225,5.18),(7.225,4.26),(6.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.79),(0.875,4.71),(1.795,4.71),(1.795,3.79),(0.875,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.495,3.78),(1.495,5.18),(2.705,5.18),(2.705,3.78),(1.495,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.515,3.78),(4.515,5.18),(5.635,5.18),(5.635,3.78),(4.515,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,4.26),(1.895,5.18),(2.815,5.18),(2.815,4.26),(1.895,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.025,3.78),(3.025,5.18),(4.235,5.18),(4.235,3.78),(3.025,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.39,3.78),(3.39,5.18),(4.38,5.18),(4.38,3.78),(3.39,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.965,3.78),(3.965,5.18),(4.865,5.18),(4.865,3.78),(3.965,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.78),(1.385,5.18),(2.275,5.18),(2.275,3.78),(1.385,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.305,3.58),(6.305,5.18),(7.225,5.18),(7.225,3.58),(6.305,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.745,3.78),(4.745,5.18),(5.665,5.18),(5.665,3.78),(4.745,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.745,3.79),(4.745,4.71),(5.665,4.71),(5.665,3.79),(4.745,3.79)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.415,4.09),(6.415,4.87),(6.545,4.87),(6.545,4.09),(6.415,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.205,4.09),(4.205,4.87),(4.435,4.87),(4.435,4.09),(4.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.57),(2.205,4.87),(2.505,4.87),(2.505,4.57),(2.205,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.055,4.09),(3.055,4.87),(3.185,4.87),(3.185,4.09),(3.055,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.905,4.09),(5.905,4.87),(6.035,4.87),(6.035,4.09),(5.905,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,4.09),(2.165,4.87),(2.395,4.87),(2.395,4.09),(2.165,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,4.09),(2.035,4.87),(2.165,4.87),(2.165,4.09),(2.035,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.025,3.89),(7.025,4.87),(7.255,4.87),(7.255,3.89),(7.025,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.09),(2.205,4.87),(2.505,4.87),(2.505,4.09),(2.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,4.57),(4.245,4.87),(4.545,4.87),(4.545,4.57),(4.245,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,4.09),(1.015,4.87),(1.145,4.87),(1.145,4.09),(1.015,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,4.09),(2.235,4.87),(2.475,4.87),(2.475,4.09),(2.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,4.09),(4.245,4.87),(4.545,4.87),(4.545,4.09),(4.245,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.625,4.09),(4.625,4.87),(4.755,4.87),(4.755,4.09),(4.625,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(7.895,5.655),(7.895,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.255,3.89),(7.255,4.87),(7.385,4.87),(7.385,3.89),(7.255,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.545,4.09),(6.545,4.87),(6.775,4.87),(6.775,4.09),(6.545,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.275,4.09),(4.275,4.87),(4.555,4.87),(4.555,4.09),(4.275,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,4.09),(2.545,4.87),(2.675,4.87),(2.675,4.09),(2.545,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.945,4.87),(0.945,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.075,4.09),(4.075,4.87),(4.205,4.87),(4.205,4.09),(4.075,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.395,4.09),(5.395,4.87),(5.525,4.87),(5.525,4.09),(5.395,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.615,3.89),(6.615,4.87),(7.185,4.87),(7.185,3.89),(6.615,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.11,5.355),(0.11,5.655),(7.89,5.655),(7.89,5.355),(0.11,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.615,3.89),(6.615,4.87),(6.915,4.87),(6.915,3.89),(6.615,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.615,4.57),(6.615,4.87),(6.915,4.87),(6.915,4.57),(6.615,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,4.09),(0.785,4.87),(1.015,4.87),(1.015,4.09),(0.785,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.395,4.09),(4.395,4.87),(4.625,4.87),(4.625,4.09),(4.395,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.315,4.09),(2.315,4.87),(2.545,4.87),(2.545,4.09),(2.315,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.565,4.09),(3.565,4.87),(3.695,4.87),(3.695,4.09),(3.565,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.64),(2.275,4.8),(2.435,4.8),(2.435,4.64),(2.275,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.18,5.425),(0.18,5.585),(0.34,5.585),(0.34,5.425),(0.18,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.52,5.425),(0.52,5.585),(0.68,5.585),(0.68,5.425),(0.52,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.86,5.425),(0.86,5.585),(1.02,5.585),(1.02,5.425),(0.86,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.2,5.425),(1.2,5.585),(1.36,5.585),(1.36,5.425),(1.2,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.54,5.425),(1.54,5.585),(1.7,5.585),(1.7,5.425),(1.54,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.88,5.425),(1.88,5.585),(2.04,5.585),(2.04,5.425),(1.88,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.22,5.425),(2.22,5.585),(2.38,5.585),(2.38,5.425),(2.22,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.56,5.425),(2.56,5.585),(2.72,5.585),(2.72,5.425),(2.56,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.9,5.425),(2.9,5.585),(3.06,5.585),(3.06,5.425),(2.9,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.24,5.425),(3.24,5.585),(3.4,5.585),(3.4,5.425),(3.24,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.58,5.425),(3.58,5.585),(3.74,5.585),(3.74,5.425),(3.58,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.92,5.425),(3.92,5.585),(4.08,5.585),(4.08,5.425),(3.92,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.26,5.425),(4.26,5.585),(4.42,5.585),(4.42,5.425),(4.26,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.6,5.425),(4.6,5.585),(4.76,5.585),(4.76,5.425),(4.6,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.94,5.425),(4.94,5.585),(5.1,5.585),(5.1,5.425),(4.94,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.28,5.425),(5.28,5.585),(5.44,5.585),(5.44,5.425),(5.28,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.62,5.425),(5.62,5.585),(5.78,5.585),(5.78,5.425),(5.62,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.96,5.425),(5.96,5.585),(6.12,5.585),(6.12,5.425),(5.96,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.3,5.425),(6.3,5.585),(6.46,5.585),(6.46,5.425),(6.3,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.64,5.425),(6.64,5.585),(6.8,5.585),(6.8,5.425),(6.64,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.98,5.425),(6.98,5.585),(7.14,5.585),(7.14,5.425),(6.98,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.32,5.425),(7.32,5.585),(7.48,5.585),(7.48,5.425),(7.32,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.66,5.425),(7.66,5.585),(7.82,5.585),(7.82,5.425),(7.66,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.315,4.64),(4.315,4.8),(4.475,4.8),(4.475,4.64),(4.315,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.685,4.64),(6.685,4.8),(6.845,4.8),(6.845,4.64),(6.685,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.235,4.64),(4.235,4.8),(4.555,4.8),(4.555,4.64),(4.235,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,4.64),(2.195,4.8),(2.515,4.8),(2.515,4.64),(2.195,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.18,5.345),(0.18,5.665),(7.82,5.665),(7.82,5.345),(0.18,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(8.0,5.76),(8.0,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.605,4.64),(6.605,4.8),(6.925,4.8),(6.925,4.64),(6.605,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(4.0), u(8.0), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((7.025,0.89),(7.025,1.83),(7.255,1.83),(7.255,0.89),(7.025,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.395,0.89),(5.395,1.67),(5.525,1.67),(5.525,0.89),(5.395,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.11,0.105),(0.11,0.405),(7.89,0.405),(7.89,0.105),(0.11,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.615,0.89),(6.615,1.83),(6.915,1.83),(6.915,0.89),(6.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,0.89),(2.035,1.67),(2.165,1.67),(2.165,0.89),(2.035,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(7.895,0.405),(7.895,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,0.89),(2.235,1.67),(2.475,1.67),(2.475,0.89),(2.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.205,0.89),(4.205,1.67),(4.435,1.67),(4.435,0.89),(4.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,0.89),(1.015,1.67),(1.145,1.67),(1.145,0.89),(1.015,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.415,0.89),(6.415,1.67),(6.545,1.67),(6.545,0.89),(6.415,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.545,0.89),(6.545,1.67),(6.775,1.67),(6.775,0.89),(6.545,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,0.89),(4.245,1.19),(4.545,1.19),(4.545,0.89),(4.245,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,0.89),(2.545,1.67),(2.675,1.67),(2.675,0.89),(2.545,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.905,0.89),(5.905,1.67),(6.035,1.67),(6.035,0.89),(5.905,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.625,0.89),(4.625,1.67),(4.755,1.67),(4.755,0.89),(4.625,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.255,0.89),(7.255,1.83),(7.385,1.83),(7.385,0.89),(7.255,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,0.89),(2.165,1.67),(2.395,1.67),(2.395,0.89),(2.165,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.075,0.89),(4.075,1.67),(4.205,1.67),(4.205,0.89),(4.075,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.19),(2.505,1.19),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,0.89),(0.785,1.67),(1.015,1.67),(1.015,0.89),(0.785,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.565,0.89),(3.565,1.67),(3.695,1.67),(3.695,0.89),(3.565,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.615,0.89),(6.615,1.19),(6.915,1.19),(6.915,0.89),(6.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,0.89),(4.245,1.67),(4.545,1.67),(4.545,0.89),(4.245,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.055,0.89),(3.055,1.67),(3.185,1.67),(3.185,0.89),(3.055,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.315,0.89),(2.315,1.67),(2.545,1.67),(2.545,0.89),(2.315,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.67),(2.505,1.67),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.945,1.67),(0.945,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.275,0.89),(4.275,1.67),(4.555,1.67),(4.555,0.89),(4.275,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.615,0.89),(6.615,1.83),(7.185,1.83),(7.185,0.89),(6.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.395,0.89),(4.395,1.67),(4.625,1.67),(4.625,0.89),(4.395,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,0.96),(2.275,1.12),(2.435,1.12),(2.435,0.96),(2.275,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.18,0.175),(0.18,0.335),(0.34,0.335),(0.34,0.175),(0.18,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.52,0.175),(0.52,0.335),(0.68,0.335),(0.68,0.175),(0.52,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.86,0.175),(0.86,0.335),(1.02,0.335),(1.02,0.175),(0.86,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.2,0.175),(1.2,0.335),(1.36,0.335),(1.36,0.175),(1.2,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.54,0.175),(1.54,0.335),(1.7,0.335),(1.7,0.175),(1.54,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.88,0.175),(1.88,0.335),(2.04,0.335),(2.04,0.175),(1.88,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.22,0.175),(2.22,0.335),(2.38,0.335),(2.38,0.175),(2.22,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.56,0.175),(2.56,0.335),(2.72,0.335),(2.72,0.175),(2.56,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.9,0.175),(2.9,0.335),(3.06,0.335),(3.06,0.175),(2.9,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.24,0.175),(3.24,0.335),(3.4,0.335),(3.4,0.175),(3.24,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.58,0.175),(3.58,0.335),(3.74,0.335),(3.74,0.175),(3.58,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.92,0.175),(3.92,0.335),(4.08,0.335),(4.08,0.175),(3.92,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.26,0.175),(4.26,0.335),(4.42,0.335),(4.42,0.175),(4.26,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.6,0.175),(4.6,0.335),(4.76,0.335),(4.76,0.175),(4.6,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.94,0.175),(4.94,0.335),(5.1,0.335),(5.1,0.175),(4.94,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.28,0.175),(5.28,0.335),(5.44,0.335),(5.44,0.175),(5.28,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.62,0.175),(5.62,0.335),(5.78,0.335),(5.78,0.175),(5.62,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.96,0.175),(5.96,0.335),(6.12,0.335),(6.12,0.175),(5.96,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.3,0.175),(6.3,0.335),(6.46,0.335),(6.46,0.175),(6.3,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.64,0.175),(6.64,0.335),(6.8,0.335),(6.8,0.175),(6.64,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.98,0.175),(6.98,0.335),(7.14,0.335),(7.14,0.175),(6.98,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.32,0.175),(7.32,0.335),(7.48,0.335),(7.48,0.175),(7.32,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.66,0.175),(7.66,0.335),(7.82,0.335),(7.82,0.175),(7.66,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.315,0.96),(4.315,1.12),(4.475,1.12),(4.475,0.96),(4.315,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.685,0.96),(6.685,1.12),(6.845,1.12),(6.845,0.96),(6.685,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,0.96),(2.195,1.12),(2.515,1.12),(2.515,0.96),(2.195,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(8.0,1.12),(8.0,0.0),(0.0,0.0)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.605,0.96),(6.605,1.12),(6.925,1.12),(6.925,0.96),(6.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.235,0.96),(4.235,1.12),(4.555,1.12),(4.555,0.96),(4.235,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.18,0.095),(0.18,0.415),(7.82,0.415),(7.82,0.095),(0.18,0.095)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(4.0), u(8.0), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.0), u(8.0), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['clk']
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.44),(0.535,2.74),(0.835,2.74),(0.835,2.44),(0.535,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,3.52),(0.51,3.82),(0.685,3.82),(0.685,3.52),(0.51,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.74),(0.575,2.74),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.44),(0.51,2.74),(0.685,2.74),(0.685,2.44),(0.51,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.52),(0.445,5.05),(0.575,5.05),(0.575,3.52),(0.445,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.52),(0.535,3.82),(0.835,3.82),(0.835,3.52),(0.535,3.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.59),(0.605,3.75),(0.765,3.75),(0.765,3.59),(0.605,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.51),(0.605,2.67),(0.765,2.67),(0.765,2.51),(0.605,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.51),(0.605,3.83),(0.765,3.83),(0.765,3.51),(0.605,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.43),(0.605,2.75),(0.765,2.75),(0.765,2.43),(0.605,2.43)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_clk_buf']
        createRL(
            tech, net, 'Activ',
            ((1.215,4.09),(1.215,4.87),(1.485,4.87),(1.485,4.09),(1.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.09),(1.185,4.87),(1.485,4.87),(1.485,4.09),(1.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.36),(1.185,1.66),(1.485,1.66),(1.485,1.36),(1.185,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.1),(1.185,4.4),(1.485,4.4),(1.485,4.1),(1.185,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,4.09),(1.145,4.87),(1.375,4.87),(1.375,4.09),(1.145,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,1.67),(1.485,1.67),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,0.89),(1.145,1.67),(1.375,1.67),(1.375,0.89),(1.145,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.215,0.89),(1.215,1.67),(1.485,1.67),(1.485,0.89),(1.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.43),(1.255,1.59),(1.415,1.59),(1.415,1.43),(1.255,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.355,2.51),(3.355,2.67),(3.515,2.67),(3.515,2.51),(3.355,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.17),(1.255,4.33),(1.415,4.33),(1.415,4.17),(1.255,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,3.59),(2.925,3.75),(3.085,3.75),(3.085,3.59),(2.925,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.775,3.59),(5.775,3.75),(5.935,3.75),(5.935,3.59),(5.775,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.395,2.51),(1.395,2.67),(1.555,2.67),(1.555,2.51),(1.395,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.555,2.51),(5.555,2.67),(5.715,2.67),(5.715,2.51),(5.555,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.35),(1.23,4.41),(1.44,4.41),(1.44,1.35),(1.23,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.53,3.51),(5.53,3.83),(5.74,3.83),(5.74,3.51),(5.53,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,2.43),(3.355,2.75),(3.515,2.75),(3.515,2.43),(3.355,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,3.51),(2.925,3.83),(3.085,3.83),(3.085,3.51),(2.925,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.42),(1.415,4.42),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.775,3.51),(5.775,3.83),(5.935,3.83),(5.935,3.51),(5.775,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.33,3.51),(3.33,3.83),(3.54,3.83),(3.54,3.51),(3.33,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,2.43),(1.23,2.75),(1.44,2.75),(1.44,2.43),(1.23,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.43),(1.335,2.75),(1.475,2.75),(1.475,2.43),(1.335,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.41),(1.415,4.41),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.395,2.43),(1.395,2.75),(1.555,2.75),(1.555,2.43),(1.395,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.005,3.51),(3.005,3.83),(3.435,3.83),(3.435,3.51),(3.005,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.33,2.43),(3.33,3.83),(3.54,3.83),(3.54,2.43),(3.33,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.35),(1.255,1.67),(1.415,1.67),(1.415,1.35),(1.255,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.555,2.43),(5.555,2.75),(5.715,2.75),(5.715,2.43),(5.555,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.635,3.51),(5.635,3.83),(5.855,3.83),(5.855,3.51),(5.635,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,1.67),(1.415,1.67),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.53,2.43),(5.53,3.83),(5.74,3.83),(5.74,2.43),(5.53,2.43)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.395,0.71),(5.395,2.74),(5.525,2.74),(5.525,0.71),(5.395,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,3.52),(3.055,5.05),(3.185,5.05),(3.185,3.52),(3.055,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.395,0.71),(5.395,1.85),(5.525,1.85),(5.525,0.71),(5.395,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.005,3.52),(3.005,3.82),(3.12,3.82),(3.12,3.52),(3.005,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,3.52),(2.855,3.82),(3.155,3.82),(3.155,3.52),(2.855,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.485,2.44),(5.485,2.74),(5.785,2.74),(5.785,2.44),(5.485,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.285,2.44),(3.285,2.74),(3.585,2.74),(3.585,2.44),(3.285,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.905,3.52),(5.905,5.05),(6.035,5.05),(6.035,3.52),(5.905,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.905,3.91),(5.905,5.05),(6.035,5.05),(6.035,3.91),(5.905,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,0.71),(3.565,2.74),(3.695,2.74),(3.695,0.71),(3.565,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,0.71),(3.565,1.85),(3.695,1.85),(3.695,0.71),(3.565,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,3.91),(3.055,5.05),(3.185,5.05),(3.185,3.91),(3.055,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.855,3.52),(5.855,3.82),(5.97,3.82),(5.97,3.52),(5.855,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.325,2.44),(1.325,2.74),(1.625,2.74),(1.625,2.44),(1.325,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.705,3.52),(5.705,3.82),(6.005,3.82),(6.005,3.52),(5.705,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.475,2.44),(1.475,2.74),(5.635,2.74),(5.635,2.44),(1.475,2.44)),
        )
        net = nets['_u']
        createRL(
            tech, net, 'Activ',
            ((1.695,4.09),(1.695,4.87),(1.965,4.87),(1.965,4.09),(1.695,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,1.36),(1.695,1.66),(1.995,1.66),(1.995,1.36),(1.695,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,1.67),(1.965,1.67),(1.965,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.1),(1.695,4.4),(1.995,4.4),(1.995,4.1),(1.695,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,1.67),(1.995,1.67),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,0.89),(1.805,1.67),(2.035,1.67),(2.035,0.89),(1.805,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,4.09),(1.805,4.87),(2.035,4.87),(2.035,4.09),(1.805,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.09),(1.695,4.87),(1.995,4.87),(1.995,4.09),(1.695,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.415,3.59),(2.415,3.75),(2.575,3.75),(2.575,3.59),(2.415,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.415,1.97),(2.415,2.13),(2.575,2.13),(2.575,1.97),(2.415,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.17),(1.765,4.33),(1.925,4.33),(1.925,4.17),(1.765,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.43),(1.765,1.59),(1.925,1.59),(1.925,1.43),(1.765,1.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,1.35),(2.39,1.67),(2.6,1.67),(2.6,1.35),(2.39,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.415,3.51),(2.415,3.83),(2.575,3.83),(2.575,3.51),(2.415,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.415,1.89),(2.415,2.21),(2.575,2.21),(2.575,1.89),(2.415,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.34),(1.765,1.67),(1.925,1.67),(1.925,1.34),(1.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.35),(1.765,1.67),(1.925,1.67),(1.925,1.35),(1.765,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,4.09),(2.39,4.41),(2.6,4.41),(2.6,4.09),(2.39,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.42),(1.925,4.42),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,1.34),(1.845,1.67),(2.495,1.67),(2.495,1.34),(1.845,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,1.35),(2.39,4.41),(2.6,4.41),(2.6,1.35),(2.39,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.41),(1.925,4.41),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,4.09),(1.845,4.42),(2.495,4.42),(2.495,4.09),(1.845,4.09)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,3.52),(2.545,5.05),(2.675,5.05),(2.675,3.52),(2.545,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.495,3.52),(2.495,3.82),(2.61,3.82),(2.61,3.52),(2.495,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.345,3.52),(2.345,3.82),(2.645,3.82),(2.645,3.52),(2.345,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.495,1.9),(2.495,2.2),(2.61,2.2),(2.61,1.9),(2.495,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,3.91),(2.545,5.05),(2.675,5.05),(2.675,3.91),(2.545,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.345,1.9),(2.345,2.2),(2.645,2.2),(2.645,1.9),(2.345,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,2.2),(2.675,2.2),(2.675,0.71),(2.545,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,1.85),(2.675,1.85),(2.675,0.71),(2.545,0.71)),
        )
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,1.85),(2.165,1.85),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.91),(2.035,5.05),(2.165,5.05),(2.165,3.91),(2.035,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.755,1.9),(1.755,2.2),(2.055,2.2),(2.055,1.9),(1.755,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.755,3.52),(1.755,3.82),(2.055,3.82),(2.055,3.52),(1.755,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,1.9),(1.905,2.2),(2.1,2.2),(2.1,1.9),(1.905,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,2.2),(2.165,2.2),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.52),(2.035,5.05),(2.165,5.05),(2.165,3.52),(2.035,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.52),(1.905,3.82),(2.1,3.82),(2.1,3.52),(1.905,3.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.825,3.59),(1.825,3.75),(1.985,3.75),(1.985,3.59),(1.825,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.825,1.97),(1.825,2.13),(1.985,2.13),(1.985,1.97),(1.825,1.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.825,1.89),(1.825,2.21),(1.985,2.21),(1.985,1.89),(1.825,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.8,1.89),(1.8,3.87),(2.01,3.87),(2.01,1.89),(1.8,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.825,3.51),(1.825,3.83),(1.985,3.83),(1.985,3.51),(1.825,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.905), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.905), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((2.825,0.89),(2.825,1.67),(3.055,1.67),(3.055,0.89),(2.825,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.68,0.89),(2.68,1.67),(3.05,1.67),(3.05,0.89),(2.68,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,0.89),(2.745,1.67),(2.985,1.67),(2.985,0.89),(2.745,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.675,0.89),(2.675,1.67),(2.905,1.67),(2.905,0.89),(2.675,0.89)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((2.825,4.09),(2.825,4.87),(3.055,4.87),(3.055,4.09),(2.825,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,4.09),(2.745,4.87),(2.985,4.87),(2.985,4.09),(2.745,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.68,4.09),(2.68,4.87),(3.05,4.87),(3.05,4.09),(2.68,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.675,4.09),(2.675,4.87),(2.905,4.87),(2.905,4.09),(2.675,4.09)),
        )
        net = nets['_dff_m']
        createRL(
            tech, net, 'Activ',
            ((3.185,0.89),(3.185,1.67),(3.415,1.67),(3.415,0.89),(3.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.225,0.89),(3.225,1.67),(3.525,1.67),(3.525,0.89),(3.225,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.335,0.89),(3.335,1.67),(3.565,1.67),(3.565,0.89),(3.335,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.225,4.1),(3.225,4.4),(3.525,4.4),(3.525,4.1),(3.225,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.255,0.89),(3.255,1.67),(3.495,1.67),(3.495,0.89),(3.255,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.335,4.09),(3.335,4.87),(3.565,4.87),(3.565,4.09),(3.335,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.225,4.09),(3.225,4.87),(3.525,4.87),(3.525,4.09),(3.225,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.185,4.09),(3.185,4.87),(3.415,4.87),(3.415,4.09),(3.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.255,4.09),(3.255,4.87),(3.495,4.87),(3.495,4.09),(3.255,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.225,1.36),(3.225,1.66),(3.525,1.66),(3.525,1.36),(3.225,1.36)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.295,4.17),(3.295,4.33),(3.455,4.33),(3.455,4.17),(3.295,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.295,1.43),(3.295,1.59),(3.455,1.59),(3.455,1.43),(3.295,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.695,3.59),(4.695,3.75),(4.855,3.75),(4.855,3.59),(4.695,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.695,1.97),(4.695,2.13),(4.855,2.13),(4.855,1.97),(4.695,1.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.375,1.34),(3.375,1.67),(3.865,1.67),(3.865,1.34),(3.375,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.295,4.09),(3.295,4.42),(3.455,4.42),(3.455,4.09),(3.295,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.295,1.34),(3.295,1.67),(3.455,1.67),(3.455,1.34),(3.295,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.67,4.09),(4.67,4.41),(4.88,4.41),(4.88,4.09),(4.67,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.295,4.09),(3.295,4.41),(3.455,4.41),(3.455,4.09),(3.295,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.695,3.51),(4.695,3.83),(4.855,3.83),(4.855,3.51),(4.695,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.76,4.09),(3.76,4.41),(3.97,4.41),(3.97,4.09),(3.76,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.695,1.89),(4.695,2.21),(4.855,2.21),(4.855,1.89),(4.695,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.76,1.35),(3.76,4.41),(3.97,4.41),(3.97,1.35),(3.76,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.76,1.35),(3.76,1.67),(3.97,1.67),(3.97,1.35),(3.76,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.295,1.35),(3.295,1.67),(3.455,1.67),(3.455,1.35),(3.295,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.67,1.89),(4.67,4.41),(4.88,4.41),(4.88,1.89),(4.67,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.375,4.09),(3.375,4.42),(4.775,4.42),(4.775,4.09),(3.375,4.09)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,0.71),(4.625,2.2),(4.755,2.2),(4.755,0.71),(4.625,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.69,3.52),(4.69,3.82),(4.775,3.82),(4.775,3.52),(4.69,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,0.71),(4.625,1.85),(4.755,1.85),(4.755,0.71),(4.625,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,3.52),(4.625,3.82),(4.925,3.82),(4.925,3.52),(4.625,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,1.9),(4.625,2.2),(4.925,2.2),(4.925,1.9),(4.625,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,3.91),(4.625,5.05),(4.755,5.05),(4.755,3.91),(4.625,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,3.52),(4.625,5.05),(4.755,5.05),(4.755,3.52),(4.625,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.69,1.9),(4.69,2.2),(4.775,2.2),(4.775,1.9),(4.69,1.9)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((3.7,0.89),(3.7,1.67),(4.07,1.67),(4.07,0.89),(3.7,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,0.89),(3.765,1.67),(4.005,1.67),(4.005,0.89),(3.765,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.695,0.89),(3.695,1.67),(3.925,1.67),(3.925,0.89),(3.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.845,0.89),(3.845,1.67),(4.075,1.67),(4.075,0.89),(3.845,0.89)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Activ',
            ((3.765,4.09),(3.765,4.87),(4.005,4.87),(4.005,4.09),(3.765,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.695,4.09),(3.695,4.87),(3.925,4.87),(3.925,4.09),(3.695,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.845,4.09),(3.845,4.87),(4.075,4.87),(4.075,4.09),(3.845,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.7,4.09),(3.7,4.87),(4.07,4.87),(4.07,4.09),(3.7,4.09)),
        )
        net = nets['_y']
        createRL(
            tech, net, 'GatPoly',
            ((4.075,3.52),(4.075,5.05),(4.205,5.05),(4.205,3.52),(4.075,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.075,3.91),(4.075,5.05),(4.205,5.05),(4.205,3.91),(4.075,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.14,3.52),(4.14,3.82),(4.295,3.82),(4.295,3.52),(4.14,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.075,0.71),(4.075,2.2),(4.205,2.2),(4.205,0.71),(4.075,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.075,0.71),(4.075,1.85),(4.205,1.85),(4.205,0.71),(4.075,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.145,1.9),(4.145,2.2),(4.445,2.2),(4.445,1.9),(4.145,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.145,3.52),(4.145,3.82),(4.445,3.82),(4.445,3.52),(4.145,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.14,1.9),(4.14,2.2),(4.295,2.2),(4.295,1.9),(4.14,1.9)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.215,3.51),(4.215,3.83),(4.375,3.83),(4.375,3.51),(4.215,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.215,1.89),(4.215,2.21),(4.375,2.21),(4.375,1.89),(4.215,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.1,1.35),(5.1,4.41),(5.31,4.41),(5.31,1.35),(5.1,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.125,4.09),(5.125,4.42),(5.285,4.42),(5.285,4.09),(5.125,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.125,1.34),(5.125,1.67),(5.285,1.67),(5.285,1.34),(5.125,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.125,4.09),(5.125,4.41),(5.285,4.41),(5.285,4.09),(5.125,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.19,1.35),(4.19,1.67),(4.4,1.67),(4.4,1.35),(4.19,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.295,1.34),(4.295,1.67),(5.205,1.67),(5.205,1.34),(4.295,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.125,1.35),(5.125,1.67),(5.285,1.67),(5.285,1.35),(5.125,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.19,1.35),(4.19,3.83),(4.4,3.83),(4.4,1.35),(4.19,1.35)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.215,3.59),(4.215,3.75),(4.375,3.75),(4.375,3.59),(4.215,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.125,1.43),(5.125,1.59),(5.285,1.59),(5.285,1.43),(5.125,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.215,1.97),(4.215,2.13),(4.375,2.13),(4.375,1.97),(4.215,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.125,4.17),(5.125,4.33),(5.285,4.33),(5.285,4.17),(5.125,4.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.825,4.09),(4.825,4.87),(5.325,4.87),(5.325,4.09),(4.825,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.055,4.09),(5.055,4.87),(5.355,4.87),(5.355,4.09),(5.055,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.165,4.09),(5.165,4.87),(5.395,4.87),(5.395,4.09),(5.165,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.825,0.89),(4.825,1.67),(5.325,1.67),(5.325,0.89),(4.825,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.755,4.09),(4.755,4.87),(4.985,4.87),(4.985,4.09),(4.755,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.055,1.36),(5.055,1.66),(5.355,1.66),(5.355,1.36),(5.055,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.165,0.89),(5.165,1.67),(5.395,1.67),(5.395,0.89),(5.165,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.055,0.89),(5.055,1.67),(5.355,1.67),(5.355,0.89),(5.055,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.755,0.89),(4.755,1.67),(4.985,1.67),(4.985,0.89),(4.755,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.055,4.1),(5.055,4.4),(5.355,4.4),(5.355,4.1),(5.055,4.1)),
        )
        net = nets['_dff_s']
        createRL(
            tech, net, 'Activ',
            ((5.565,1.36),(5.565,1.66),(5.865,1.66),(5.865,1.36),(5.565,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.675,4.09),(5.675,4.87),(5.905,4.87),(5.905,4.09),(5.675,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.595,4.09),(5.595,4.87),(5.835,4.87),(5.835,4.09),(5.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.565,4.1),(5.565,4.4),(5.865,4.4),(5.865,4.1),(5.565,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.675,0.89),(5.675,1.67),(5.905,1.67),(5.905,0.89),(5.675,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.525,4.09),(5.525,4.87),(5.755,4.87),(5.755,4.09),(5.525,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.565,0.89),(5.565,1.67),(5.865,1.67),(5.865,0.89),(5.565,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.525,0.89),(5.525,1.67),(5.755,1.67),(5.755,0.89),(5.525,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.595,0.89),(5.595,1.67),(5.835,1.67),(5.835,0.89),(5.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.565,4.09),(5.565,4.87),(5.865,4.87),(5.865,4.09),(5.565,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.415,2.51),(6.415,2.67),(6.575,2.67),(6.575,2.51),(6.415,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.635,1.43),(5.635,1.59),(5.795,1.59),(5.795,1.43),(5.635,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.635,4.17),(5.635,4.33),(5.795,4.33),(5.795,4.17),(5.635,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.415,2.43),(6.415,2.75),(6.575,2.75),(6.575,2.43),(6.415,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.635,1.34),(5.635,1.67),(5.795,1.67),(5.795,1.34),(5.635,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.39,1.35),(6.39,1.67),(6.6,1.67),(6.6,1.35),(6.39,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.635,4.09),(5.635,4.42),(5.795,4.42),(5.795,4.09),(5.635,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.715,1.34),(5.715,1.67),(6.495,1.67),(6.495,1.34),(5.715,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.635,4.09),(5.635,4.41),(5.795,4.41),(5.795,4.09),(5.635,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.715,4.09),(5.715,4.42),(6.495,4.42),(6.495,4.09),(5.715,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.39,4.09),(6.39,4.41),(6.6,4.41),(6.6,4.09),(6.39,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.635,1.35),(5.635,1.67),(5.795,1.67),(5.795,1.35),(5.635,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.39,1.35),(6.39,4.41),(6.6,4.41),(6.6,1.35),(6.39,1.35)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.255,0.71),(7.255,3.71),(7.385,3.71),(7.385,0.71),(7.255,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.495,2.44),(6.495,2.74),(7.32,2.74),(7.32,2.44),(6.495,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.345,2.44),(6.345,2.74),(6.645,2.74),(6.645,2.44),(6.345,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.255,0.71),(7.255,2.01),(7.385,2.01),(7.385,0.71),(7.255,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.255,3.71),(7.255,5.05),(7.385,5.05),(7.385,3.71),(7.255,3.71)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'Activ',
            ((6.105,0.89),(6.105,1.67),(6.345,1.67),(6.345,0.89),(6.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.185,0.89),(6.185,1.67),(6.415,1.67),(6.415,0.89),(6.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.035,0.89),(6.035,1.67),(6.265,1.67),(6.265,0.89),(6.035,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.04,0.89),(6.04,1.67),(6.41,1.67),(6.41,0.89),(6.04,0.89)),
        )
        net = nets['_net5']
        createRL(
            tech, net, 'Activ',
            ((6.185,4.09),(6.185,4.87),(6.415,4.87),(6.415,4.09),(6.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.035,4.09),(6.035,4.87),(6.265,4.87),(6.265,4.09),(6.035,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.105,4.09),(6.105,4.87),(6.345,4.87),(6.345,4.09),(6.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.04,4.09),(6.04,4.87),(6.41,4.87),(6.41,4.09),(6.04,4.09)),
        )
        net = nets['q']
        createRL(
            tech, net, 'Metal1',
            ((6.82,1.35),(6.82,1.67),(7.03,1.67),(7.03,1.35),(6.82,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.925,4.05),(6.925,4.42),(7.575,4.42),(7.575,4.05),(6.925,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.495,1.34),(7.495,1.67),(7.655,1.67),(7.655,1.34),(7.495,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.845,1.89),(6.845,2.21),(7.005,2.21),(7.005,1.89),(6.845,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.82,4.05),(6.82,4.37),(7.03,4.37),(7.03,4.05),(6.82,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.495,4.05),(7.495,4.42),(7.655,4.42),(7.655,4.05),(7.495,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.925,1.34),(6.925,1.67),(7.575,1.67),(7.575,1.34),(6.925,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.495,4.075),(7.495,4.395),(7.655,4.395),(7.655,4.075),(7.495,4.075)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.495,1.345),(7.495,1.665),(7.655,1.665),(7.655,1.345),(7.495,1.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.845,2.97),(6.845,3.29),(7.005,3.29),(7.005,2.97),(6.845,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.82,1.34),(6.82,4.42),(7.03,4.42),(7.03,1.34),(6.82,1.34)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.415,2.98),(6.415,5.05),(6.545,5.05),(6.545,2.98),(6.415,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.415,0.71),(6.415,1.85),(6.545,1.85),(6.545,0.71),(6.415,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.48,1.9),(6.48,2.2),(6.925,2.2),(6.925,1.9),(6.48,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.415,3.91),(6.415,5.05),(6.545,5.05),(6.545,3.91),(6.415,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.775,1.9),(6.775,2.2),(7.075,2.2),(7.075,1.9),(6.775,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.415,0.71),(6.415,2.2),(6.545,2.2),(6.545,0.71),(6.415,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.48,2.98),(6.48,3.28),(6.925,3.28),(6.925,2.98),(6.48,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.775,2.98),(6.775,3.28),(7.075,3.28),(7.075,2.98),(6.775,2.98)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.495,1.425),(7.495,1.585),(7.655,1.585),(7.655,1.425),(7.495,1.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.845,1.97),(6.845,2.13),(7.005,2.13),(7.005,1.97),(6.845,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.495,4.155),(7.495,4.315),(7.655,4.315),(7.655,4.155),(7.495,4.155)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.845,3.05),(6.845,3.21),(7.005,3.21),(7.005,3.05),(6.845,3.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.425,1.355),(7.425,1.655),(7.725,1.655),(7.725,1.355),(7.425,1.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.425,4.085),(7.425,4.385),(7.725,4.385),(7.725,4.085),(7.425,4.085)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.455,0.89),(7.455,1.83),(7.725,1.83),(7.725,0.89),(7.455,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.385,3.89),(7.385,4.87),(7.615,4.87),(7.615,3.89),(7.385,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.425,3.89),(7.425,4.87),(7.725,4.87),(7.725,3.89),(7.425,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.455,3.89),(7.455,4.87),(7.725,4.87),(7.725,3.89),(7.455,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.385,0.89),(7.385,1.83),(7.615,1.83),(7.615,0.89),(7.385,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.425,0.89),(7.425,1.83),(7.725,1.83),(7.725,0.89),(7.425,0.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(6.925), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(6.925), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['clk'].setType(Net.Type.CLOCK)
        nets['clk'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)

    cell = new_cells['dffnr_x1']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(0.0), u(9.600000000000001), u(5.76),
        ))
        nets = {
            '*': Net.create(cell, '*'),
            '_clk_buf': Net.create(cell, '_clk_buf'),
            '_clk_n': Net.create(cell, '_clk_n'),
            '_dff_m': Net.create(cell, '_dff_m'),
            '_dff_s': Net.create(cell, '_dff_s'),
            '_net0': Net.create(cell, '_net0'),
            '_net1': Net.create(cell, '_net1'),
            '_net2': Net.create(cell, '_net2'),
            '_net3': Net.create(cell, '_net3'),
            '_net4': Net.create(cell, '_net4'),
            '_net5': Net.create(cell, '_net5'),
            '_net6': Net.create(cell, '_net6'),
            '_net7': Net.create(cell, '_net7'),
            '_u': Net.create(cell, '_u'),
            '_y': Net.create(cell, '_y'),
            'clk': Net.create(cell, 'clk'),
            'i': Net.create(cell, 'i'),
            'nrst': Net.create(cell, 'nrst'),
            'q': Net.create(cell, 'q'),
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['_clk_n']
        createRL(
            tech, net, 'Activ',
            ((0.215,4.09),(0.215,4.87),(0.445,4.87),(0.445,4.09),(0.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.405,4.87),(0.405,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,1.36),(0.105,1.66),(0.405,1.66),(0.405,1.36),(0.105,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.09),(0.105,4.87),(0.375,4.87),(0.375,4.09),(0.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.405,1.67),(0.405,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,4.1),(0.105,4.4),(0.405,4.4),(0.405,4.1),(0.105,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.89),(0.105,1.67),(0.375,1.67),(0.375,0.89),(0.105,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.215,0.89),(0.215,1.67),(0.445,1.67),(0.445,0.89),(0.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,4.17),(0.175,4.33),(0.335,4.33),(0.335,4.17),(0.175,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,3.05),(0.175,3.21),(0.335,3.21),(0.335,3.05),(0.175,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.175,1.43),(0.175,1.59),(0.335,1.59),(0.335,1.43),(0.175,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,1.97),(2.925,2.13),(3.085,2.13),(3.085,1.97),(2.925,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,3.05),(2.925,3.21),(3.085,3.21),(3.085,3.05),(2.925,3.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.35),(0.175,1.67),(0.335,1.67),(0.335,1.35),(0.175,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,1.89),(2.925,2.21),(3.085,2.21),(3.085,1.89),(2.925,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,1.34),(0.175,1.67),(0.335,1.67),(0.335,1.34),(0.175,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.15,1.35),(0.15,4.41),(0.36,4.41),(0.36,1.35),(0.15,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.9,1.89),(2.9,3.29),(3.11,3.29),(3.11,1.89),(2.9,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,2.97),(2.925,3.29),(3.085,3.29),(3.085,2.97),(2.925,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.42),(0.335,4.42),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,4.09),(0.175,4.41),(0.335,4.41),(0.335,4.09),(0.175,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.175,2.97),(0.175,3.29),(0.335,3.29),(0.335,2.97),(0.175,2.97)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,1.9),(2.855,2.2),(3.155,2.2),(3.155,1.9),(2.855,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,2.98),(2.855,3.28),(3.155,3.28),(3.155,2.98),(2.855,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.225,0.71),(7.225,1.85),(7.355,1.85),(7.355,0.71),(7.225,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,3.91),(1.145,3.91),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,0.71),(3.055,1.85),(3.185,1.85),(3.185,0.71),(3.055,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,3.91),(1.015,5.05),(1.145,5.05),(1.145,3.91),(1.015,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.015,0.71),(1.015,1.85),(1.145,1.85),(1.145,0.71),(1.015,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,3.91),(3.565,5.05),(3.695,5.05),(3.695,3.91),(3.565,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,2.98),(3.565,5.05),(3.695,5.05),(3.695,2.98),(3.565,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.225,3.91),(7.225,5.05),(7.355,5.05),(7.355,3.91),(7.225,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.105,2.98),(0.105,3.28),(0.405,3.28),(0.405,2.98),(0.105,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.225,0.71),(7.225,3.91),(7.355,3.91),(7.355,0.71),(7.225,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.005,1.9),(3.005,2.2),(3.12,2.2),(3.12,1.9),(3.005,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.255,2.98),(0.255,3.28),(7.29,3.28),(7.29,2.98),(0.255,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,0.71),(3.055,2.2),(3.185,2.2),(3.185,0.71),(3.055,0.71)),
        )
        net = nets['*']
        createRL(
            tech, net, 'pSD',
            ((2.565,3.79),(2.565,5.17),(3.165,5.17),(3.165,3.79),(2.565,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.8),(-0.075,4.7),(0.585,4.7),(0.585,3.8),(-0.075,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.165,3.8),(6.165,4.7),(6.825,4.7),(6.825,3.8),(6.165,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.005,3.79),(8.005,5.17),(8.735,5.17),(8.735,3.79),(8.005,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.815,3.91),(6.815,5.05),(7.765,5.05),(7.765,3.91),(6.815,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.325,3.59),(8.325,5.17),(8.985,5.17),(8.985,3.59),(8.325,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.075,3.79),(3.075,5.17),(3.675,5.17),(3.675,3.79),(3.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.245,3.79),(2.245,5.17),(2.975,5.17),(2.975,3.79),(2.245,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.035,3.91),(0.035,5.05),(0.985,5.05),(0.985,3.91),(0.035,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.045,3.8),(3.045,4.7),(3.705,4.7),(3.705,3.8),(3.045,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.325,4.27),(8.325,5.17),(8.985,5.17),(8.985,4.27),(8.325,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.79),(1.515,5.17),(2.145,5.17),(2.145,3.79),(1.515,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.385,3.79),(5.385,5.17),(6.045,5.17),(6.045,3.79),(5.385,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.875,3.79),(4.875,5.17),(5.535,5.17),(5.535,3.79),(4.875,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.605,3.91),(0.605,5.05),(1.555,5.05),(1.555,3.91),(0.605,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,-0.075),(-0.075,0.585),(9.675,0.585),(9.675,-0.075),(-0.075,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.605,3.79),(5.605,5.17),(6.335,5.17),(6.335,3.79),(5.605,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.155,3.91),(3.155,5.05),(4.105,5.05),(4.105,3.91),(3.155,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,3.79),(0.435,5.17),(1.095,5.17),(1.095,3.79),(0.435,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.035,3.79),(1.035,5.17),(1.665,5.17),(1.665,3.79),(1.035,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.675,3.79),(6.675,5.17),(7.335,5.17),(7.335,3.79),(6.675,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.325,3.79),(4.325,5.17),(5.055,5.17),(5.055,3.79),(4.325,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.415,3.79),(5.415,5.17),(6.015,5.17),(6.015,3.79),(5.415,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.585,5.17),(0.585,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.065,3.79),(4.065,5.17),(4.725,5.17),(4.725,3.79),(4.065,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,3.79),(-0.075,5.17),(0.555,5.17),(0.555,3.79),(-0.075,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.465,3.71),(8.465,5.05),(9.415,5.05),(9.415,3.71),(8.465,3.71)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.495,3.91),(5.495,5.05),(6.445,5.05),(6.445,3.91),(5.495,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.435,4.27),(0.435,5.17),(1.095,5.17),(1.095,4.27),(0.435,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.065,4.27),(4.065,5.17),(4.725,5.17),(4.725,4.27),(4.065,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((-0.075,2.86),(-0.075,5.17),(9.675,5.17),(9.675,2.86),(-0.075,2.86)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.79),(1.005,5.17),(1.665,5.17),(1.665,3.79),(1.005,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.575,3.59),(8.575,5.17),(9.305,5.17),(9.305,3.59),(8.575,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.095,3.79),(5.095,5.17),(5.825,5.17),(5.825,3.79),(5.095,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.785,3.79),(7.785,5.17),(8.445,5.17),(8.445,3.79),(7.785,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.8),(1.515,4.7),(2.175,4.7),(2.175,3.8),(1.515,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.055,3.79),(2.055,5.17),(2.655,5.17),(2.655,3.79),(2.055,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.005,3.8),(1.005,4.7),(1.665,4.7),(1.665,3.8),(1.005,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.735,3.79),(1.735,5.17),(2.465,5.17),(2.465,3.79),(1.735,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.985,3.91),(4.985,5.05),(5.935,5.05),(5.935,3.91),(4.985,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.045,3.79),(3.045,5.17),(3.705,5.17),(3.705,3.79),(3.045,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.895,3.91),(7.895,5.05),(8.845,5.05),(8.845,3.91),(7.895,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.135,3.91),(2.135,5.05),(3.085,5.05),(3.085,3.91),(2.135,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.165,3.79),(6.165,5.17),(6.825,5.17),(6.825,3.79),(6.165,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.5,3.79),(2.5,5.17),(3.23,5.17),(3.23,3.79),(2.5,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.215,3.91),(4.215,5.05),(5.165,5.05),(5.165,3.91),(4.215,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.465,3.79),(0.465,5.17),(1.125,5.17),(1.125,3.79),(0.465,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.895,3.59),(8.895,5.17),(9.525,5.17),(9.525,3.59),(8.895,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.495,3.79),(7.495,5.17),(8.225,5.17),(8.225,3.79),(7.495,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.245,3.79),(7.245,5.17),(7.905,5.17),(7.905,3.79),(7.245,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,3.79),(2.025,5.17),(2.685,5.17),(2.685,3.79),(2.025,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.145,3.79),(0.145,5.17),(0.875,5.17),(0.875,3.79),(0.145,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.665,3.91),(3.665,5.05),(4.615,5.05),(4.615,3.91),(3.665,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.645,3.79),(4.645,5.17),(5.505,5.17),(5.505,3.79),(4.645,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.755,3.79),(2.755,5.17),(3.485,5.17),(3.485,3.79),(2.755,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.875,3.8),(4.875,4.7),(5.535,4.7),(5.535,3.8),(4.875,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.775,3.79),(3.775,5.17),(4.505,5.17),(4.505,3.79),(3.775,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.625,3.91),(1.625,5.05),(2.575,5.05),(2.575,3.91),(1.625,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.265,3.79),(3.265,5.17),(3.995,5.17),(3.995,3.79),(3.265,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.785,3.8),(7.785,4.7),(8.445,4.7),(8.445,3.8),(7.785,3.8)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.025,4.27),(2.025,5.17),(2.685,5.17),(2.685,4.27),(2.025,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.715,3.79),(0.715,5.17),(1.445,5.17),(1.445,3.79),(0.715,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.585,3.79),(3.585,5.17),(4.185,5.17),(4.185,3.79),(3.585,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.245,3.34),(7.245,5.05),(7.905,5.05),(7.905,3.34),(7.245,3.34)),
        )
        createRL(
            tech, net, 'pSD',
            ((0.05,-0.075),(0.05,0.585),(9.55,0.585),(9.55,-0.075),(0.05,-0.075)),
        )
        createRL(
            tech, net, 'pSD',
            ((4.095,3.79),(4.095,5.17),(4.735,5.17),(4.735,3.79),(4.095,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.865,3.785),(8.865,4.685),(9.525,4.685),(9.525,3.785),(8.865,3.785)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.925,3.79),(5.925,5.17),(6.825,5.17),(6.825,3.79),(5.925,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.865,3.59),(8.865,5.17),(9.525,5.17),(9.525,3.59),(8.865,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((3.52,3.79),(3.52,5.17),(4.25,5.17),(4.25,3.79),(3.52,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.675,3.34),(6.675,5.05),(7.335,5.05),(7.335,3.34),(6.675,3.34)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.675,3.34),(6.675,4.0),(7.335,4.0),(7.335,3.34),(6.675,3.34)),
        )
        createRL(
            tech, net, 'pSD',
            ((8.325,3.59),(8.325,5.17),(8.985,5.17),(8.985,3.59),(8.325,3.59)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.245,3.34),(7.245,4.0),(7.905,4.0),(7.905,3.34),(7.245,3.34)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.385,3.91),(7.385,5.05),(8.335,5.05),(8.335,3.91),(7.385,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((2.645,3.91),(2.645,5.05),(3.595,5.05),(3.595,3.91),(2.645,3.91)),
        )
        createRL(
            tech, net, 'pSD',
            ((6.925,3.79),(6.925,5.17),(7.655,5.17),(7.655,3.79),(6.925,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((5.385,4.27),(5.385,5.17),(6.045,5.17),(6.045,4.27),(5.385,4.27)),
        )
        createRL(
            tech, net, 'pSD',
            ((1.515,3.79),(1.515,5.17),(2.175,5.17),(2.175,3.79),(1.515,3.79)),
        )
        createRL(
            tech, net, 'pSD',
            ((7.815,3.79),(7.815,5.17),(8.415,5.17),(8.415,3.79),(7.815,3.79)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'NWell',
            ((1.385,3.78),(1.385,5.18),(2.305,5.18),(2.305,3.78),(1.385,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.715,5.18),(0.715,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.435,3.78),(2.435,5.18),(3.295,5.18),(3.295,3.78),(2.435,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.795,3.78),(5.795,5.18),(6.955,5.18),(6.955,3.78),(5.795,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.37,3.78),(2.37,5.18),(3.36,5.18),(3.36,3.78),(2.37,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.535,3.78),(3.535,5.18),(4.745,5.18),(4.745,3.78),(3.535,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.195,3.58),(8.195,5.18),(9.115,5.18),(9.115,3.58),(8.195,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.31,2.86),(-0.31,6.07),(9.91,6.07),(9.91,2.86),(-0.31,2.86)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.08,5.045),(-0.08,5.965),(9.68,5.965),(9.68,5.045),(-0.08,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.255,3.78),(7.255,5.18),(8.465,5.18),(8.465,3.78),(7.255,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.115,3.21),(7.115,5.18),(8.035,5.18),(8.035,3.21),(7.115,3.21)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.765,3.58),(8.765,5.18),(9.655,5.18),(9.655,3.58),(8.765,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.935,3.78),(3.935,5.18),(4.855,5.18),(4.855,3.78),(3.935,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.685,3.78),(7.685,5.18),(8.545,5.18),(8.545,3.78),(7.685,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.915,3.79),(2.915,4.71),(3.835,4.71),(3.835,3.79),(2.915,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.915,3.78),(2.915,5.18),(3.835,5.18),(3.835,3.78),(2.915,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.515,3.78),(2.515,5.18),(3.725,5.18),(3.725,3.78),(2.515,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.455,3.78),(3.455,5.18),(4.315,5.18),(4.315,3.78),(3.455,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.79),(-0.205,4.71),(0.715,4.71),(0.715,3.79),(-0.205,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.115,3.78),(7.115,5.18),(8.035,5.18),(8.035,3.78),(7.115,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.005,3.78),(2.005,5.18),(3.215,5.18),(3.215,3.78),(2.005,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.685,3.78),(6.685,5.18),(7.895,5.18),(7.895,3.78),(6.685,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.545,3.21),(6.545,4.13),(7.465,4.13),(7.465,3.21),(6.545,3.21)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.545,3.78),(6.545,5.18),(7.465,5.18),(7.465,3.78),(6.545,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.335,3.58),(8.335,5.18),(9.545,5.18),(9.545,3.58),(8.335,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.195,4.26),(8.195,5.18),(9.115,5.18),(9.115,4.26),(8.195,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.735,3.775),(8.735,4.695),(9.655,4.695),(9.655,3.775),(8.735,3.775)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.475,3.78),(0.475,5.18),(1.685,5.18),(1.685,3.78),(0.475,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.195,3.58),(8.195,5.18),(9.115,5.18),(9.115,3.58),(8.195,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.285,3.78),(5.285,5.18),(6.145,5.18),(6.145,3.78),(5.285,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.655,3.79),(7.655,4.71),(8.575,4.71),(8.575,3.79),(7.655,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.365,3.78),(5.365,5.18),(6.575,5.18),(6.575,3.78),(5.365,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.335,3.78),(0.335,5.18),(1.255,5.18),(1.255,3.78),(0.335,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.035,3.79),(6.035,4.71),(6.955,4.71),(6.955,3.79),(6.035,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.085,3.78),(4.085,5.18),(5.295,5.18),(5.295,3.78),(4.085,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((2.945,3.78),(2.945,5.18),(3.805,5.18),(3.805,3.78),(2.945,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.935,4.26),(3.935,5.18),(4.855,5.18),(4.855,4.26),(3.935,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.255,3.78),(5.255,5.18),(6.175,5.18),(6.175,3.78),(5.255,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.115,3.21),(7.115,4.13),(8.035,4.13),(8.035,3.21),(7.115,3.21)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,3.78),(0.305,5.18),(1.225,5.18),(1.225,3.78),(0.305,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.855,3.78),(4.855,5.18),(6.065,5.18),(6.065,3.78),(4.855,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.79),(1.385,4.71),(2.305,4.71),(2.305,3.79),(1.385,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((5.255,4.26),(5.255,5.18),(6.175,5.18),(6.175,4.26),(5.255,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.655,3.78),(7.655,5.18),(8.575,5.18),(8.575,3.78),(7.655,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((8.735,3.58),(8.735,5.18),(9.655,5.18),(9.655,3.58),(8.735,3.58)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,3.78),(1.895,5.18),(2.815,5.18),(2.815,3.78),(1.895,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,3.78),(-0.205,5.18),(0.685,5.18),(0.685,3.78),(-0.205,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.905,3.78),(0.905,5.18),(1.795,5.18),(1.795,3.78),(0.905,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.78),(0.875,5.18),(1.795,5.18),(1.795,3.78),(0.875,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.095,3.78),(-0.095,5.18),(1.115,5.18),(1.115,3.78),(-0.095,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.925,3.78),(1.925,5.18),(2.785,5.18),(2.785,3.78),(1.925,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((-0.205,5.045),(-0.205,5.965),(9.805,5.965),(9.805,5.045),(-0.205,5.045)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.875,3.79),(0.875,4.71),(1.795,4.71),(1.795,3.79),(0.875,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.495,3.78),(1.495,5.18),(2.705,5.18),(2.705,3.78),(1.495,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.515,3.78),(4.515,5.18),(5.635,5.18),(5.635,3.78),(4.515,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.895,4.26),(1.895,5.18),(2.815,5.18),(2.815,4.26),(1.895,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.745,3.79),(4.745,4.71),(5.665,4.71),(5.665,3.79),(4.745,3.79)),
        )
        createRL(
            tech, net, 'NWell',
            ((0.305,4.26),(0.305,5.18),(1.225,5.18),(1.225,4.26),(0.305,4.26)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.025,3.78),(3.025,5.18),(4.235,5.18),(4.235,3.78),(3.025,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.39,3.78),(3.39,5.18),(4.38,5.18),(4.38,3.78),(3.39,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.035,3.78),(6.035,5.18),(6.955,5.18),(6.955,3.78),(6.035,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((3.965,3.78),(3.965,5.18),(4.865,5.18),(4.865,3.78),(3.965,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((1.385,3.78),(1.385,5.18),(2.275,5.18),(2.275,3.78),(1.385,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((4.745,3.78),(4.745,5.18),(5.665,5.18),(5.665,3.78),(4.745,3.78)),
        )
        createRL(
            tech, net, 'NWell',
            ((6.545,3.21),(6.545,5.18),(7.465,5.18),(7.465,3.21),(6.545,3.21)),
        )
        createRL(
            tech, net, 'NWell',
            ((7.765,3.78),(7.765,5.18),(8.975,5.18),(8.975,3.78),(7.765,3.78)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.09),(0.615,4.87),(0.915,4.87),(0.915,4.09),(0.615,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.565,4.57),(5.565,4.87),(5.865,4.87),(5.865,4.57),(5.565,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.675,4.09),(5.675,4.87),(5.905,4.87),(5.905,4.09),(5.675,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.305,4.09),(8.305,4.87),(8.435,4.87),(8.435,4.09),(8.305,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.205,4.09),(4.205,4.87),(4.435,4.87),(4.435,4.09),(4.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.525,4.09),(5.525,4.87),(5.755,4.87),(5.755,4.09),(5.525,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.435,4.09),(8.435,4.87),(8.665,4.87),(8.665,4.09),(8.435,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.57),(2.205,4.87),(2.505,4.87),(2.505,4.57),(2.205,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.645,3.89),(8.645,4.87),(8.875,4.87),(8.875,3.89),(8.645,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.055,4.09),(3.055,4.87),(3.185,4.87),(3.185,4.09),(3.055,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,5.355),(0.105,5.655),(9.495,5.655),(9.495,5.355),(0.105,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.905,4.09),(5.905,4.87),(6.035,4.87),(6.035,4.09),(5.905,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,4.09),(2.165,4.87),(2.395,4.87),(2.395,4.09),(2.165,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,4.09),(2.035,4.87),(2.165,4.87),(2.165,4.09),(2.035,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.505,4.57),(8.505,4.87),(8.805,4.87),(8.805,4.57),(8.505,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.595,4.09),(5.595,4.87),(5.835,4.87),(5.835,4.09),(5.595,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,4.09),(0.575,4.87),(0.805,4.87),(0.805,4.09),(0.575,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,4.09),(2.205,4.87),(2.505,4.87),(2.505,4.09),(2.205,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,4.57),(4.245,4.87),(4.545,4.87),(4.545,4.57),(4.245,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,4.09),(1.015,4.87),(1.145,4.87),(1.145,4.09),(1.015,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.505,3.89),(8.505,4.87),(8.805,4.87),(8.805,3.89),(8.505,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,4.57),(0.615,4.87),(0.915,4.87),(0.915,4.57),(0.615,4.57)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,4.09),(2.235,4.87),(2.475,4.87),(2.475,4.09),(2.235,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,4.09),(4.245,4.87),(4.545,4.87),(4.545,4.09),(4.245,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.795,4.09),(7.795,4.87),(7.925,4.87),(7.925,4.09),(7.795,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.625,4.09),(4.625,4.87),(4.755,4.87),(4.755,4.09),(4.625,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,4.09),(0.445,4.87),(0.575,4.87),(0.575,4.09),(0.445,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.505,3.89),(8.505,4.87),(8.805,4.87),(8.805,3.89),(8.505,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.225,4.09),(7.225,4.87),(7.355,4.87),(7.355,4.09),(7.225,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.875,3.89),(8.875,4.87),(9.005,4.87),(9.005,3.89),(8.875,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.275,4.09),(4.275,4.87),(4.555,4.87),(4.555,4.09),(4.275,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,4.09),(2.545,4.87),(2.675,4.87),(2.675,4.09),(2.545,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,4.09),(0.645,4.87),(0.945,4.87),(0.945,4.09),(0.645,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.075,4.09),(4.075,4.87),(4.205,4.87),(4.205,4.09),(4.075,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.395,4.09),(5.395,4.87),(5.525,4.87),(5.525,4.09),(5.395,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.23,5.355),(0.23,5.655),(9.37,5.655),(9.37,5.355),(0.23,5.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,4.09),(0.785,4.87),(1.015,4.87),(1.015,4.09),(0.785,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.395,4.09),(4.395,4.87),(4.625,4.87),(4.625,4.09),(4.395,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.315,4.09),(2.315,4.87),(2.545,4.87),(2.545,4.09),(2.315,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.565,4.09),(3.565,4.87),(3.695,4.87),(3.695,4.09),(3.565,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.565,4.09),(5.565,4.87),(5.865,4.87),(5.865,4.09),(5.565,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,4.64),(2.275,4.8),(2.435,4.8),(2.435,4.64),(2.275,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.635,4.64),(5.635,4.8),(5.795,4.8),(5.795,4.64),(5.635,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.575,4.64),(8.575,4.8),(8.735,4.8),(8.735,4.64),(8.575,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.315,4.64),(4.315,4.8),(4.475,4.8),(4.475,4.64),(4.315,4.64)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.3,5.425),(0.3,5.585),(0.46,5.585),(0.46,5.425),(0.3,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.64,5.425),(0.64,5.585),(0.8,5.585),(0.8,5.425),(0.64,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.98,5.425),(0.98,5.585),(1.14,5.585),(1.14,5.425),(0.98,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.32,5.425),(1.32,5.585),(1.48,5.585),(1.48,5.425),(1.32,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.66,5.425),(1.66,5.585),(1.82,5.585),(1.82,5.425),(1.66,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.0,5.425),(2.0,5.585),(2.16,5.585),(2.16,5.425),(2.0,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.34,5.425),(2.34,5.585),(2.5,5.585),(2.5,5.425),(2.34,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.68,5.425),(2.68,5.585),(2.84,5.585),(2.84,5.425),(2.68,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.02,5.425),(3.02,5.585),(3.18,5.585),(3.18,5.425),(3.02,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.36,5.425),(3.36,5.585),(3.52,5.585),(3.52,5.425),(3.36,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.7,5.425),(3.7,5.585),(3.86,5.585),(3.86,5.425),(3.7,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.04,5.425),(4.04,5.585),(4.2,5.585),(4.2,5.425),(4.04,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.38,5.425),(4.38,5.585),(4.54,5.585),(4.54,5.425),(4.38,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.72,5.425),(4.72,5.585),(4.88,5.585),(4.88,5.425),(4.72,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.06,5.425),(5.06,5.585),(5.22,5.585),(5.22,5.425),(5.06,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.4,5.425),(5.4,5.585),(5.56,5.585),(5.56,5.425),(5.4,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.74,5.425),(5.74,5.585),(5.9,5.585),(5.9,5.425),(5.74,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.08,5.425),(6.08,5.585),(6.24,5.585),(6.24,5.425),(6.08,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.42,5.425),(6.42,5.585),(6.58,5.585),(6.58,5.425),(6.42,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.76,5.425),(6.76,5.585),(6.92,5.585),(6.92,5.425),(6.76,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.1,5.425),(7.1,5.585),(7.26,5.585),(7.26,5.425),(7.1,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.44,5.425),(7.44,5.585),(7.6,5.585),(7.6,5.425),(7.44,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.78,5.425),(7.78,5.585),(7.94,5.585),(7.94,5.425),(7.78,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.12,5.425),(8.12,5.585),(8.28,5.585),(8.28,5.425),(8.12,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.46,5.425),(8.46,5.585),(8.62,5.585),(8.62,5.425),(8.46,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.8,5.425),(8.8,5.585),(8.96,5.585),(8.96,5.425),(8.8,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.14,5.425),(9.14,5.585),(9.3,5.585),(9.3,5.425),(9.14,5.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,4.64),(0.685,4.8),(0.845,4.8),(0.845,4.64),(0.685,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.235,4.64),(4.235,4.8),(4.555,4.8),(4.555,4.64),(4.235,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,4.64),(2.195,4.8),(2.515,4.8),(2.515,4.64),(2.195,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.495,4.64),(8.495,4.8),(8.815,4.8),(8.815,4.64),(8.495,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,4.64),(0.605,4.8),(0.925,4.8),(0.925,4.64),(0.605,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.3,5.345),(0.3,5.665),(9.3,5.665),(9.3,5.345),(0.3,5.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.555,4.64),(5.555,4.8),(5.875,4.8),(5.875,4.64),(5.555,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,5.76),(9.6,5.76),(9.6,4.64),(0.0,4.64)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(4.8), u(9.6), u(4.64), u(5.76),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.8), u(9.6), u(4.64), u(5.76),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['vss']
        createRL(
            tech, net, 'Activ',
            ((5.395,0.89),(5.395,1.67),(5.525,1.67),(5.525,0.89),(5.395,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.505,0.89),(8.505,1.19),(8.805,1.19),(8.805,0.89),(8.505,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.035,0.89),(2.035,1.67),(2.165,1.67),(2.165,0.89),(2.035,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.225,0.89),(7.225,1.67),(7.355,1.67),(7.355,0.89),(7.225,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.575,0.89),(0.575,1.67),(0.805,1.67),(0.805,0.89),(0.575,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.445,0.89),(0.445,1.67),(0.575,1.67),(0.575,0.89),(0.445,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.235,0.89),(2.235,1.67),(2.475,1.67),(2.475,0.89),(2.235,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.205,0.89),(4.205,1.67),(4.435,1.67),(4.435,0.89),(4.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.015,0.89),(1.015,1.67),(1.145,1.67),(1.145,0.89),(1.015,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.685,0.89),(6.685,1.67),(6.815,1.67),(6.815,0.89),(6.685,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.645,0.89),(8.645,1.83),(8.875,1.83),(8.875,0.89),(8.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.875,0.89),(8.875,1.83),(9.005,1.83),(9.005,0.89),(8.875,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.795,0.89),(7.795,1.67),(7.925,1.67),(7.925,0.89),(7.795,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,0.89),(4.245,1.19),(4.545,1.19),(4.545,0.89),(4.245,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.545,0.89),(2.545,1.67),(2.675,1.67),(2.675,0.89),(2.545,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.625,0.89),(4.625,1.67),(4.755,1.67),(4.755,0.89),(4.625,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.165,0.89),(2.165,1.67),(2.395,1.67),(2.395,0.89),(2.165,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.23,0.105),(0.23,0.405),(9.37,0.405),(9.37,0.105),(0.23,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.075,0.89),(4.075,1.67),(4.205,1.67),(4.205,0.89),(4.075,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.19),(0.915,1.19),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.19),(2.505,1.19),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.785,0.89),(0.785,1.67),(1.015,1.67),(1.015,0.89),(0.785,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.565,0.89),(3.565,1.67),(3.695,1.67),(3.695,0.89),(3.565,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.505,0.89),(8.505,1.83),(8.805,1.83),(8.805,0.89),(8.505,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.505,0.89),(8.505,1.83),(8.805,1.83),(8.805,0.89),(8.505,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.245,0.89),(4.245,1.67),(4.545,1.67),(4.545,0.89),(4.245,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.055,0.89),(3.055,1.67),(3.185,1.67),(3.185,0.89),(3.055,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.315,0.89),(2.315,1.67),(2.545,1.67),(2.545,0.89),(2.315,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.615,0.89),(0.615,1.67),(0.915,1.67),(0.915,0.89),(0.615,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.305,0.89),(8.305,1.67),(8.435,1.67),(8.435,0.89),(8.305,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.205,0.89),(2.205,1.67),(2.505,1.67),(2.505,0.89),(2.205,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.645,0.89),(0.645,1.67),(0.945,1.67),(0.945,0.89),(0.645,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((0.105,0.105),(0.105,0.405),(9.495,0.405),(9.495,0.105),(0.105,0.105)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.275,0.89),(4.275,1.67),(4.555,1.67),(4.555,0.89),(4.275,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.435,0.89),(8.435,1.67),(8.665,1.67),(8.665,0.89),(8.435,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.395,0.89),(4.395,1.67),(4.625,1.67),(4.625,0.89),(4.395,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.275,0.96),(2.275,1.12),(2.435,1.12),(2.435,0.96),(2.275,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.3,0.175),(0.3,0.335),(0.46,0.335),(0.46,0.175),(0.3,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.64,0.175),(0.64,0.335),(0.8,0.335),(0.8,0.175),(0.64,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.98,0.175),(0.98,0.335),(1.14,0.335),(1.14,0.175),(0.98,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.32,0.175),(1.32,0.335),(1.48,0.335),(1.48,0.175),(1.32,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.66,0.175),(1.66,0.335),(1.82,0.335),(1.82,0.175),(1.66,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.0,0.175),(2.0,0.335),(2.16,0.335),(2.16,0.175),(2.0,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.34,0.175),(2.34,0.335),(2.5,0.335),(2.5,0.175),(2.34,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.68,0.175),(2.68,0.335),(2.84,0.335),(2.84,0.175),(2.68,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.02,0.175),(3.02,0.335),(3.18,0.335),(3.18,0.175),(3.02,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.36,0.175),(3.36,0.335),(3.52,0.335),(3.52,0.175),(3.36,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.7,0.175),(3.7,0.335),(3.86,0.335),(3.86,0.175),(3.7,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.04,0.175),(4.04,0.335),(4.2,0.335),(4.2,0.175),(4.04,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.38,0.175),(4.38,0.335),(4.54,0.335),(4.54,0.175),(4.38,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.72,0.175),(4.72,0.335),(4.88,0.335),(4.88,0.175),(4.72,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.06,0.175),(5.06,0.335),(5.22,0.335),(5.22,0.175),(5.06,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.4,0.175),(5.4,0.335),(5.56,0.335),(5.56,0.175),(5.4,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.74,0.175),(5.74,0.335),(5.9,0.335),(5.9,0.175),(5.74,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.08,0.175),(6.08,0.335),(6.24,0.335),(6.24,0.175),(6.08,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.42,0.175),(6.42,0.335),(6.58,0.335),(6.58,0.175),(6.42,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.76,0.175),(6.76,0.335),(6.92,0.335),(6.92,0.175),(6.76,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.1,0.175),(7.1,0.335),(7.26,0.335),(7.26,0.175),(7.1,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.44,0.175),(7.44,0.335),(7.6,0.335),(7.6,0.175),(7.44,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.78,0.175),(7.78,0.335),(7.94,0.335),(7.94,0.175),(7.78,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.12,0.175),(8.12,0.335),(8.28,0.335),(8.28,0.175),(8.12,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.46,0.175),(8.46,0.335),(8.62,0.335),(8.62,0.175),(8.46,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.8,0.175),(8.8,0.335),(8.96,0.335),(8.96,0.175),(8.8,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.14,0.175),(9.14,0.335),(9.3,0.335),(9.3,0.175),(9.14,0.175)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.685,0.96),(0.685,1.12),(0.845,1.12),(0.845,0.96),(0.685,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.315,0.96),(4.315,1.12),(4.475,1.12),(4.475,0.96),(4.315,0.96)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.575,0.96),(8.575,1.12),(8.735,1.12),(8.735,0.96),(8.575,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.195,0.96),(2.195,1.12),(2.515,1.12),(2.515,0.96),(2.195,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.495,0.96),(8.495,1.12),(8.815,1.12),(8.815,0.96),(8.495,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.3,0.095),(0.3,0.415),(9.3,0.415),(9.3,0.095),(0.3,0.095)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,0.96),(0.605,1.12),(0.925,1.12),(0.925,0.96),(0.605,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.235,0.96),(4.235,1.12),(4.555,1.12),(4.555,0.96),(4.235,0.96)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,0.0),(0.0,1.12),(9.6,1.12),(9.6,0.0),(0.0,0.0)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(4.8), u(9.6), u(0.0), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(4.8), u(9.6), u(0.0), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['clk']
        createRL(
            tech, net, 'GatPoly',
            ((0.535,2.44),(0.535,2.74),(0.835,2.74),(0.835,2.44),(0.535,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.91),(0.445,5.05),(0.575,5.05),(0.575,3.91),(0.445,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,3.52),(0.51,3.82),(0.685,3.82),(0.685,3.52),(0.51,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,2.74),(0.575,2.74),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.51,2.44),(0.51,2.74),(0.685,2.74),(0.685,2.44),(0.51,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,3.52),(0.445,5.05),(0.575,5.05),(0.575,3.52),(0.445,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.445,0.71),(0.445,1.85),(0.575,1.85),(0.575,0.71),(0.445,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((0.535,3.52),(0.535,3.82),(0.835,3.82),(0.835,3.52),(0.535,3.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,3.59),(0.605,3.75),(0.765,3.75),(0.765,3.59),(0.605,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((0.605,2.51),(0.605,2.67),(0.765,2.67),(0.765,2.51),(0.605,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.58,1.34),(0.58,4.42),(0.79,4.42),(0.79,1.34),(0.58,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,3.51),(0.605,3.83),(0.765,3.83),(0.765,3.51),(0.605,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.605,2.43),(0.605,2.75),(0.765,2.75),(0.765,2.43),(0.605,2.43)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(0.685), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_clk_buf']
        createRL(
            tech, net, 'Activ',
            ((1.215,4.09),(1.215,4.87),(1.485,4.87),(1.485,4.09),(1.215,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.09),(1.185,4.87),(1.485,4.87),(1.485,4.09),(1.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,1.36),(1.185,1.66),(1.485,1.66),(1.485,1.36),(1.185,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,4.1),(1.185,4.4),(1.485,4.4),(1.485,4.1),(1.185,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,4.09),(1.145,4.87),(1.375,4.87),(1.375,4.09),(1.145,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.185,0.89),(1.185,1.67),(1.485,1.67),(1.485,0.89),(1.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.145,0.89),(1.145,1.67),(1.375,1.67),(1.375,0.89),(1.145,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.215,0.89),(1.215,1.67),(1.485,1.67),(1.485,0.89),(1.215,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,1.43),(1.255,1.59),(1.415,1.59),(1.415,1.43),(1.255,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.355,2.51),(3.355,2.67),(3.515,2.67),(3.515,2.51),(3.355,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.255,4.17),(1.255,4.33),(1.415,4.33),(1.415,4.17),(1.255,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.985,2.51),(5.985,2.67),(6.145,2.67),(6.145,2.51),(5.985,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.925,3.59),(2.925,3.75),(3.085,3.75),(3.085,3.59),(2.925,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.605,3.05),(7.605,3.21),(7.765,3.21),(7.765,3.05),(7.605,3.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.395,2.51),(1.395,2.67),(1.555,2.67),(1.555,2.51),(1.395,2.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,1.35),(1.23,4.41),(1.44,4.41),(1.44,1.35),(1.23,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.065,2.97),(6.065,3.29),(7.685,3.29),(7.685,2.97),(6.065,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.355,2.43),(3.355,2.75),(3.515,2.75),(3.515,2.43),(3.355,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.985,2.43),(5.985,2.75),(6.145,2.75),(6.145,2.43),(5.985,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.925,3.51),(2.925,3.83),(3.085,3.83),(3.085,3.51),(2.925,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.42),(1.415,4.42),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.23,2.43),(1.23,2.75),(1.44,2.75),(1.44,2.43),(1.23,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.33,3.51),(3.33,3.83),(3.54,3.83),(3.54,3.51),(3.33,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.335,2.43),(1.335,2.75),(1.475,2.75),(1.475,2.43),(1.335,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,4.09),(1.255,4.41),(1.415,4.41),(1.415,4.09),(1.255,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.96,2.97),(5.96,3.29),(6.17,3.29),(6.17,2.97),(5.96,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.395,2.43),(1.395,2.75),(1.555,2.75),(1.555,2.43),(1.395,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.005,3.51),(3.005,3.83),(3.435,3.83),(3.435,3.51),(3.005,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.33,2.43),(3.33,3.83),(3.54,3.83),(3.54,2.43),(3.33,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.96,2.43),(5.96,3.29),(6.17,3.29),(6.17,2.43),(5.96,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.35),(1.255,1.67),(1.415,1.67),(1.415,1.35),(1.255,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.255,1.34),(1.255,1.67),(1.415,1.67),(1.415,1.34),(1.255,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.605,2.97),(7.605,3.29),(7.765,3.29),(7.765,2.97),(7.605,2.97)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.685,0.71),(6.685,2.74),(6.815,2.74),(6.815,0.71),(6.685,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((6.685,0.71),(6.685,1.85),(6.815,1.85),(6.815,0.71),(6.685,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.795,2.98),(7.795,5.05),(7.925,5.05),(7.925,2.98),(7.795,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,3.52),(3.055,5.05),(3.185,5.05),(3.185,3.52),(3.055,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.795,3.91),(7.795,5.05),(7.925,5.05),(7.925,3.91),(7.795,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.915,2.44),(5.915,2.74),(6.215,2.74),(6.215,2.44),(5.915,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.535,2.98),(7.535,3.28),(7.835,3.28),(7.835,2.98),(7.535,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.685,2.98),(7.685,3.28),(7.86,3.28),(7.86,2.98),(7.685,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.005,3.52),(3.005,3.82),(3.12,3.82),(3.12,3.52),(3.005,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.285,2.44),(3.285,2.74),(3.585,2.74),(3.585,2.44),(3.285,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.855,3.52),(2.855,3.82),(3.155,3.82),(3.155,3.52),(2.855,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,0.71),(3.565,2.74),(3.695,2.74),(3.695,0.71),(3.565,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.565,0.71),(3.565,1.85),(3.695,1.85),(3.695,0.71),(3.565,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((3.055,3.91),(3.055,5.05),(3.185,5.05),(3.185,3.91),(3.055,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.325,2.44),(1.325,2.74),(1.625,2.74),(1.625,2.44),(1.325,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.475,2.44),(1.475,2.74),(6.75,2.74),(6.75,2.44),(1.475,2.44)),
        )
        net = nets['_u']
        createRL(
            tech, net, 'Activ',
            ((1.695,4.09),(1.695,4.87),(1.965,4.87),(1.965,4.09),(1.695,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,1.36),(1.695,1.66),(1.995,1.66),(1.995,1.36),(1.695,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,1.67),(1.965,1.67),(1.965,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.1),(1.695,4.4),(1.995,4.4),(1.995,4.1),(1.695,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,0.89),(1.695,1.67),(1.995,1.67),(1.995,0.89),(1.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,0.89),(1.805,1.67),(2.035,1.67),(2.035,0.89),(1.805,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.805,4.09),(1.805,4.87),(2.035,4.87),(2.035,4.09),(1.805,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((1.695,4.09),(1.695,4.87),(1.995,4.87),(1.995,4.09),(1.695,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.415,3.59),(2.415,3.75),(2.575,3.75),(2.575,3.59),(2.415,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((2.415,1.97),(2.415,2.13),(2.575,2.13),(2.575,1.97),(2.415,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,4.17),(1.765,4.33),(1.925,4.33),(1.925,4.17),(1.765,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.765,1.43),(1.765,1.59),(1.925,1.59),(1.925,1.43),(1.765,1.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,1.35),(2.39,1.67),(2.6,1.67),(2.6,1.35),(2.39,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.415,3.51),(2.415,3.83),(2.575,3.83),(2.575,3.51),(2.415,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.415,1.89),(2.415,2.21),(2.575,2.21),(2.575,1.89),(2.415,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.34),(1.765,1.67),(1.925,1.67),(1.925,1.34),(1.765,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,1.35),(1.765,1.67),(1.925,1.67),(1.925,1.35),(1.765,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,4.09),(2.39,4.41),(2.6,4.41),(2.6,4.09),(2.39,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.42),(1.925,4.42),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,1.34),(1.845,1.67),(2.495,1.67),(2.495,1.34),(1.845,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((2.39,1.35),(2.39,4.41),(2.6,4.41),(2.6,1.35),(2.39,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.765,4.09),(1.765,4.41),(1.925,4.41),(1.925,4.09),(1.765,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.845,4.09),(1.845,4.42),(2.495,4.42),(2.495,4.09),(1.845,4.09)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,3.52),(2.545,5.05),(2.675,5.05),(2.675,3.52),(2.545,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.495,3.52),(2.495,3.82),(2.61,3.82),(2.61,3.52),(2.495,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.345,3.52),(2.345,3.82),(2.645,3.82),(2.645,3.52),(2.345,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.495,1.9),(2.495,2.2),(2.61,2.2),(2.61,1.9),(2.495,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,3.91),(2.545,5.05),(2.675,5.05),(2.675,3.91),(2.545,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.345,1.9),(2.345,2.2),(2.645,2.2),(2.645,1.9),(2.345,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,2.2),(2.675,2.2),(2.675,0.71),(2.545,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.545,0.71),(2.545,1.85),(2.675,1.85),(2.675,0.71),(2.545,0.71)),
        )
        net = nets['i']
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,1.85),(2.165,1.85),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.91),(2.035,5.05),(2.165,5.05),(2.165,3.91),(2.035,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.755,1.9),(1.755,2.2),(2.055,2.2),(2.055,1.9),(1.755,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.755,3.52),(1.755,3.82),(2.055,3.82),(2.055,3.52),(1.755,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,1.9),(1.905,2.2),(2.1,2.2),(2.1,1.9),(1.905,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,0.71),(2.035,2.2),(2.165,2.2),(2.165,0.71),(2.035,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((2.035,3.52),(2.035,5.05),(2.165,5.05),(2.165,3.52),(2.035,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((1.905,3.52),(1.905,3.82),(2.1,3.82),(2.1,3.52),(1.905,3.52)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.825,3.59),(1.825,3.75),(1.985,3.75),(1.985,3.59),(1.825,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((1.825,1.97),(1.825,2.13),(1.985,2.13),(1.985,1.97),(1.825,1.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.825,1.89),(1.825,2.21),(1.985,2.21),(1.985,1.89),(1.825,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.8,1.89),(1.8,3.87),(2.01,3.87),(2.01,1.89),(1.8,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((1.825,3.51),(1.825,3.83),(1.985,3.83),(1.985,3.51),(1.825,3.51)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(1.905), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(1.905), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net0']
        createRL(
            tech, net, 'Activ',
            ((2.825,0.89),(2.825,1.67),(3.055,1.67),(3.055,0.89),(2.825,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.68,0.89),(2.68,1.67),(3.05,1.67),(3.05,0.89),(2.68,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,0.89),(2.745,1.67),(2.985,1.67),(2.985,0.89),(2.745,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.675,0.89),(2.675,1.67),(2.905,1.67),(2.905,0.89),(2.675,0.89)),
        )
        net = nets['_net1']
        createRL(
            tech, net, 'Activ',
            ((2.825,4.09),(2.825,4.87),(3.055,4.87),(3.055,4.09),(2.825,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.745,4.09),(2.745,4.87),(2.985,4.87),(2.985,4.09),(2.745,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.68,4.09),(2.68,4.87),(3.05,4.87),(3.05,4.09),(2.68,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((2.675,4.09),(2.675,4.87),(2.905,4.87),(2.905,4.09),(2.675,4.09)),
        )
        net = nets['_dff_m']
        createRL(
            tech, net, 'Activ',
            ((3.185,0.89),(3.185,1.67),(3.415,1.67),(3.415,0.89),(3.185,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.225,0.89),(3.225,1.67),(3.525,1.67),(3.525,0.89),(3.225,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.335,0.89),(3.335,1.67),(3.565,1.67),(3.565,0.89),(3.335,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.225,4.1),(3.225,4.4),(3.525,4.4),(3.525,4.1),(3.225,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.255,0.89),(3.255,1.67),(3.495,1.67),(3.495,0.89),(3.255,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.335,4.09),(3.335,4.87),(3.565,4.87),(3.565,4.09),(3.335,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.225,4.09),(3.225,4.87),(3.525,4.87),(3.525,4.09),(3.225,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.185,4.09),(3.185,4.87),(3.415,4.87),(3.415,4.09),(3.185,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.255,4.09),(3.255,4.87),(3.495,4.87),(3.495,4.09),(3.255,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.225,1.36),(3.225,1.66),(3.525,1.66),(3.525,1.36),(3.225,1.36)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.295,4.17),(3.295,4.33),(3.455,4.33),(3.455,4.17),(3.295,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((3.295,1.43),(3.295,1.59),(3.455,1.59),(3.455,1.43),(3.295,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.695,3.59),(4.695,3.75),(4.855,3.75),(4.855,3.59),(4.695,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.695,1.97),(4.695,2.13),(4.855,2.13),(4.855,1.97),(4.695,1.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.375,1.34),(3.375,1.67),(3.865,1.67),(3.865,1.34),(3.375,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.295,4.09),(3.295,4.42),(3.455,4.42),(3.455,4.09),(3.295,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.295,1.34),(3.295,1.67),(3.455,1.67),(3.455,1.34),(3.295,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.67,4.09),(4.67,4.41),(4.88,4.41),(4.88,4.09),(4.67,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.295,4.09),(3.295,4.41),(3.455,4.41),(3.455,4.09),(3.295,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.695,3.51),(4.695,3.83),(4.855,3.83),(4.855,3.51),(4.695,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.76,4.09),(3.76,4.41),(3.97,4.41),(3.97,4.09),(3.76,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.695,1.89),(4.695,2.21),(4.855,2.21),(4.855,1.89),(4.695,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.76,1.35),(3.76,4.41),(3.97,4.41),(3.97,1.35),(3.76,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.76,1.35),(3.76,1.67),(3.97,1.67),(3.97,1.35),(3.76,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.295,1.35),(3.295,1.67),(3.455,1.67),(3.455,1.35),(3.295,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.67,1.89),(4.67,4.41),(4.88,4.41),(4.88,1.89),(4.67,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((3.375,4.09),(3.375,4.42),(4.775,4.42),(4.775,4.09),(3.375,4.09)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,0.71),(4.625,2.2),(4.755,2.2),(4.755,0.71),(4.625,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.69,3.52),(4.69,3.82),(4.775,3.82),(4.775,3.52),(4.69,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,0.71),(4.625,1.85),(4.755,1.85),(4.755,0.71),(4.625,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,3.52),(4.625,3.82),(4.925,3.82),(4.925,3.52),(4.625,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,1.9),(4.625,2.2),(4.925,2.2),(4.925,1.9),(4.625,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,3.91),(4.625,5.05),(4.755,5.05),(4.755,3.91),(4.625,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.625,3.52),(4.625,5.05),(4.755,5.05),(4.755,3.52),(4.625,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.69,1.9),(4.69,2.2),(4.775,2.2),(4.775,1.9),(4.69,1.9)),
        )
        net = nets['_net2']
        createRL(
            tech, net, 'Activ',
            ((3.7,0.89),(3.7,1.67),(4.07,1.67),(4.07,0.89),(3.7,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.765,0.89),(3.765,1.67),(4.005,1.67),(4.005,0.89),(3.765,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.695,0.89),(3.695,1.67),(3.925,1.67),(3.925,0.89),(3.695,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.845,0.89),(3.845,1.67),(4.075,1.67),(4.075,0.89),(3.845,0.89)),
        )
        net = nets['_net3']
        createRL(
            tech, net, 'Activ',
            ((3.765,4.09),(3.765,4.87),(4.005,4.87),(4.005,4.09),(3.765,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.695,4.09),(3.695,4.87),(3.925,4.87),(3.925,4.09),(3.695,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.845,4.09),(3.845,4.87),(4.075,4.87),(4.075,4.09),(3.845,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((3.7,4.09),(3.7,4.87),(4.07,4.87),(4.07,4.09),(3.7,4.09)),
        )
        net = nets['_y']
        createRL(
            tech, net, 'GatPoly',
            ((4.075,3.52),(4.075,5.05),(4.205,5.05),(4.205,3.52),(4.075,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.075,3.91),(4.075,5.05),(4.205,5.05),(4.205,3.91),(4.075,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.14,3.52),(4.14,3.82),(4.295,3.82),(4.295,3.52),(4.14,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.075,0.71),(4.075,2.2),(4.205,2.2),(4.205,0.71),(4.075,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.075,0.71),(4.075,1.85),(4.205,1.85),(4.205,0.71),(4.075,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.145,1.9),(4.145,2.2),(4.445,2.2),(4.445,1.9),(4.145,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.145,3.52),(4.145,3.82),(4.445,3.82),(4.445,3.52),(4.145,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((4.14,1.9),(4.14,2.2),(4.295,2.2),(4.295,1.9),(4.14,1.9)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.635,1.34),(5.635,1.67),(5.795,1.67),(5.795,1.34),(5.635,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.96,4.09),(5.96,4.41),(6.17,4.41),(6.17,4.09),(5.96,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.1,1.35),(5.1,1.67),(5.31,1.67),(5.31,1.35),(5.1,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.215,1.89),(4.215,2.21),(4.375,2.21),(4.375,1.89),(4.215,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.215,3.51),(4.215,3.83),(4.375,3.83),(4.375,3.51),(4.215,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.925,3.51),(6.925,3.83),(7.085,3.83),(7.085,3.51),(6.925,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.1,1.35),(5.1,4.41),(5.31,4.41),(5.31,1.35),(5.1,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.19,1.35),(4.19,3.83),(4.4,3.83),(4.4,1.35),(4.19,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.125,4.09),(5.125,4.42),(5.285,4.42),(5.285,4.09),(5.125,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.96,3.51),(5.96,4.41),(6.17,4.41),(6.17,3.51),(5.96,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.96,3.51),(5.96,3.83),(6.17,3.83),(6.17,3.51),(5.96,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.125,4.09),(5.125,4.41),(5.285,4.41),(5.285,4.09),(5.125,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.065,3.51),(6.065,3.83),(7.005,3.83),(7.005,3.51),(6.065,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.205,4.09),(5.205,4.42),(6.065,4.42),(6.065,4.09),(5.205,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.635,1.35),(5.635,1.67),(5.795,1.67),(5.795,1.35),(5.635,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.19,1.35),(4.19,1.67),(4.4,1.67),(4.4,1.35),(4.19,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((4.295,1.34),(4.295,1.67),(5.715,1.67),(5.715,1.34),(4.295,1.34)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.925,3.59),(6.925,3.75),(7.085,3.75),(7.085,3.59),(6.925,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.635,1.43),(5.635,1.59),(5.795,1.59),(5.795,1.43),(5.635,1.43)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.215,3.59),(4.215,3.75),(4.375,3.75),(4.375,3.59),(4.215,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((4.215,1.97),(4.215,2.13),(4.375,2.13),(4.375,1.97),(4.215,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.125,4.17),(5.125,4.33),(5.285,4.33),(5.285,4.17),(5.125,4.17)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,4.09),(6.855,4.87),(7.155,4.87),(7.155,4.09),(6.855,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.715,0.89),(5.715,1.67),(6.495,1.67),(6.495,0.89),(5.715,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.595,0.89),(5.595,1.67),(5.97,1.67),(5.97,0.89),(5.595,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.565,1.36),(5.565,1.66),(5.865,1.66),(5.865,1.36),(5.565,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,3.52),(6.855,3.82),(7.155,3.82),(7.155,3.52),(6.855,3.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.31,0.89),(6.31,1.67),(6.68,1.67),(6.68,0.89),(6.31,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.97,0.89),(5.97,1.67),(6.615,1.67),(6.615,0.89),(5.97,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.995,4.09),(6.995,4.87),(7.225,4.87),(7.225,4.09),(6.995,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.055,4.09),(5.055,4.87),(5.355,4.87),(5.355,4.09),(5.055,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.165,4.09),(5.165,4.87),(5.395,4.87),(5.395,4.09),(5.165,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,3.52),(6.855,4.87),(7.155,4.87),(7.155,3.52),(6.855,3.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.755,4.09),(4.755,4.87),(4.985,4.87),(4.985,4.09),(4.755,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.565,0.89),(5.565,1.67),(5.865,1.67),(5.865,0.89),(5.565,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.785,0.89),(5.785,1.67),(6.155,1.67),(6.155,0.89),(5.785,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.525,0.89),(5.525,1.67),(5.755,1.67),(5.755,0.89),(5.525,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.825,4.09),(4.825,4.87),(5.325,4.87),(5.325,4.09),(4.825,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.055,4.1),(5.055,4.4),(5.355,4.4),(5.355,4.1),(5.055,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.455,0.89),(6.455,1.67),(6.685,1.67),(6.685,0.89),(6.455,0.89)),
        )
        net = nets['_net6']
        createRL(
            tech, net, 'Activ',
            ((4.755,0.89),(4.755,1.67),(4.985,1.67),(4.985,0.89),(4.755,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((4.825,0.89),(4.825,1.67),(5.325,1.67),(5.325,0.89),(4.825,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.165,0.89),(5.165,1.67),(5.395,1.67),(5.395,0.89),(5.165,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((5.02,0.89),(5.02,1.67),(5.39,1.67),(5.39,0.89),(5.02,0.89)),
        )
        net = nets['nrst']
        createRL(
            tech, net, 'GatPoly',
            ((5.395,3.91),(5.395,5.05),(5.525,5.05),(5.525,3.91),(5.395,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.795,0.71),(7.795,2.2),(7.925,2.2),(7.925,0.71),(7.795,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.485,3.52),(5.485,3.82),(5.785,3.82),(5.785,3.52),(5.485,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.395,0.71),(5.395,1.85),(5.525,1.85),(5.525,0.71),(5.395,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.46,1.9),(5.46,2.2),(5.635,2.2),(5.635,1.9),(5.46,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.795,0.71),(7.795,1.85),(7.925,1.85),(7.925,0.71),(7.795,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.905,3.91),(5.905,5.05),(6.035,5.05),(6.035,3.91),(5.905,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.685,1.9),(7.685,2.2),(7.86,2.2),(7.86,1.9),(7.685,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.535,1.9),(7.535,2.2),(7.835,2.2),(7.835,1.9),(7.535,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.485,1.9),(5.485,2.2),(5.785,2.2),(5.785,1.9),(5.485,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.46,3.52),(5.46,3.82),(5.97,3.82),(5.97,3.52),(5.46,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.395,0.71),(5.395,2.2),(5.525,2.2),(5.525,0.71),(5.395,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.395,3.52),(5.395,5.05),(5.525,5.05),(5.525,3.52),(5.395,3.52)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((5.905,3.52),(5.905,5.05),(6.035,5.05),(6.035,3.52),(5.905,3.52)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.555,3.51),(5.555,3.83),(5.715,3.83),(5.715,3.51),(5.555,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.555,1.89),(5.555,2.21),(5.715,2.21),(5.715,1.89),(5.555,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.605,1.89),(7.605,2.21),(7.765,2.21),(7.765,1.89),(7.605,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.58,1.89),(7.58,2.21),(7.79,2.21),(7.79,1.89),(7.58,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.635,1.89),(5.635,2.21),(7.685,2.21),(7.685,1.89),(5.635,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.58,1.89),(7.58,2.21),(7.79,2.21),(7.79,1.89),(7.58,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.53,1.89),(5.53,3.87),(5.74,3.87),(5.74,1.89),(5.53,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((5.53,1.89),(5.53,2.21),(5.74,2.21),(5.74,1.89),(5.53,1.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.555,1.97),(5.555,2.13),(5.715,2.13),(5.715,1.97),(5.555,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.605,1.97),(7.605,2.13),(7.765,2.13),(7.765,1.97),(7.605,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((5.555,3.59),(5.555,3.75),(5.715,3.75),(5.715,3.59),(5.555,3.59)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(5.635), u(0.21), u(1.89), u(3.87),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(5.635), u(0.21), u(1.89), u(3.87),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        net = nets['_net5']
        createRL(
            tech, net, 'Activ',
            ((6.035,4.09),(6.035,4.87),(6.265,4.87),(6.265,4.09),(6.035,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.345,4.09),(6.345,4.87),(6.645,4.87),(6.645,4.09),(6.345,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.965,4.09),(7.965,4.87),(8.265,4.87),(8.265,4.09),(7.965,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((8.075,4.09),(8.075,4.87),(8.305,4.87),(8.305,4.09),(8.075,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.345,4.1),(6.345,4.4),(6.645,4.4),(6.645,4.1),(6.345,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.965,4.1),(7.965,4.4),(8.265,4.4),(8.265,4.1),(7.965,4.1)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.925,4.09),(7.925,4.87),(8.155,4.87),(8.155,4.09),(7.925,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.105,4.09),(6.105,4.87),(6.645,4.87),(6.645,4.09),(6.105,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.995,4.09),(7.995,4.87),(8.235,4.87),(8.235,4.09),(7.995,4.09)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.415,4.17),(6.415,4.33),(6.575,4.33),(6.575,4.17),(6.415,4.17)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.035,4.17),(8.035,4.33),(8.195,4.33),(8.195,4.17),(8.035,4.17)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.035,4.09),(8.035,4.42),(8.195,4.42),(8.195,4.09),(8.035,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.035,4.09),(8.035,4.41),(8.195,4.41),(8.195,4.09),(8.035,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.495,4.09),(6.495,4.42),(8.115,4.42),(8.115,4.09),(6.495,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.415,4.09),(6.415,4.42),(6.575,4.42),(6.575,4.09),(6.415,4.09)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.415,4.09),(6.415,4.41),(6.575,4.41),(6.575,4.09),(6.415,4.09)),
        )
        net = nets['_dff_s']
        createRL(
            tech, net, 'Activ',
            ((6.885,0.89),(6.885,1.67),(7.155,1.67),(7.155,0.89),(6.885,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,1.36),(6.855,1.66),(7.155,1.66),(7.155,1.36),(6.855,1.36)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.425,3.52),(7.425,3.82),(7.725,3.82),(7.725,3.52),(7.425,3.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.425,3.52),(7.425,4.87),(7.725,4.87),(7.725,3.52),(7.425,3.52)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.565,4.09),(7.565,4.87),(7.795,4.87),(7.795,4.09),(7.565,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.425,4.09),(7.425,4.87),(7.725,4.87),(7.725,4.09),(7.425,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.855,0.89),(6.855,1.67),(7.155,1.67),(7.155,0.89),(6.855,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.815,0.89),(6.815,1.67),(7.045,1.67),(7.045,0.89),(6.815,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.355,4.09),(7.355,4.87),(7.585,4.87),(7.585,4.09),(7.355,4.09)),
        )
        createRL(
            tech, net, 'Activ',
            ((6.995,0.89),(6.995,1.67),(7.225,1.67),(7.225,0.89),(6.995,0.89)),
        )
        createRL(
            tech, net, 'Cont',
            ((7.495,3.59),(7.495,3.75),(7.655,3.75),(7.655,3.59),(7.495,3.59)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.035,2.51),(8.035,2.67),(8.195,2.67),(8.195,2.51),(8.035,2.51)),
        )
        createRL(
            tech, net, 'Cont',
            ((6.925,1.43),(6.925,1.59),(7.085,1.59),(7.085,1.43),(6.925,1.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.01,1.35),(8.01,3.83),(8.22,3.83),(8.22,1.35),(8.01,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.495,3.51),(7.495,3.83),(7.655,3.83),(7.655,3.51),(7.495,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.01,3.51),(8.01,3.83),(8.22,3.83),(8.22,3.51),(8.01,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.575,3.51),(7.575,3.83),(8.115,3.83),(8.115,3.51),(7.575,3.51)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.925,1.35),(6.925,1.67),(7.085,1.67),(7.085,1.35),(6.925,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((7.005,1.34),(7.005,1.67),(8.115,1.67),(8.115,1.34),(7.005,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.035,2.43),(8.035,2.75),(8.195,2.75),(8.195,2.43),(8.035,2.43)),
        )
        createRL(
            tech, net, 'Metal1',
            ((6.925,1.34),(6.925,1.67),(7.085,1.67),(7.085,1.34),(6.925,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.01,1.35),(8.01,1.67),(8.22,1.67),(8.22,1.35),(8.01,1.35)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.875,0.71),(8.875,3.71),(9.005,3.71),(9.005,0.71),(8.875,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.875,0.71),(8.875,2.01),(9.005,2.01),(9.005,0.71),(8.875,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.875,3.71),(8.875,5.05),(9.005,5.05),(9.005,3.71),(8.875,3.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((7.965,2.44),(7.965,2.74),(8.265,2.74),(8.265,2.44),(7.965,2.44)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.115,2.44),(8.115,2.74),(8.94,2.74),(8.94,2.44),(8.115,2.44)),
        )
        net = nets['_net7']
        createRL(
            tech, net, 'Activ',
            ((7.425,0.89),(7.425,1.67),(7.725,1.67),(7.725,0.89),(7.425,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.565,0.89),(7.565,1.67),(7.795,1.67),(7.795,0.89),(7.565,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.355,0.89),(7.355,1.67),(7.585,1.67),(7.585,0.89),(7.355,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.39,0.89),(7.39,1.67),(7.76,1.67),(7.76,0.89),(7.39,0.89)),
        )
        net = nets['_net4']
        createRL(
            tech, net, 'Activ',
            ((8.075,0.89),(8.075,1.67),(8.305,1.67),(8.305,0.89),(8.075,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.93,0.89),(7.93,1.67),(8.3,1.67),(8.3,0.89),(7.93,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.995,0.89),(7.995,1.67),(8.235,1.67),(8.235,0.89),(7.995,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((7.925,0.89),(7.925,1.67),(8.155,1.67),(8.155,0.89),(7.925,0.89)),
        )
        net = nets['q']
        createRL(
            tech, net, 'GatPoly',
            ((8.305,3.91),(8.305,5.05),(8.435,5.05),(8.435,3.91),(8.305,3.91)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.37,1.9),(8.37,2.2),(8.545,2.2),(8.545,1.9),(8.37,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.395,1.9),(8.395,2.2),(8.695,2.2),(8.695,1.9),(8.395,1.9)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.395,2.98),(8.395,3.28),(8.695,3.28),(8.695,2.98),(8.395,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.305,0.71),(8.305,2.2),(8.435,2.2),(8.435,0.71),(8.305,0.71)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.305,2.98),(8.305,5.05),(8.435,5.05),(8.435,2.98),(8.305,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.37,2.98),(8.37,3.28),(8.545,3.28),(8.545,2.98),(8.37,2.98)),
        )
        createRL(
            tech, net, 'GatPoly',
            ((8.305,0.71),(8.305,1.85),(8.435,1.85),(8.435,0.71),(8.305,0.71)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.44,1.35),(8.44,1.67),(8.65,1.67),(8.65,1.35),(8.44,1.35)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.465,1.89),(8.465,2.21),(8.625,2.21),(8.625,1.89),(8.465,1.89)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.115,4.05),(9.115,4.42),(9.275,4.42),(9.275,4.05),(9.115,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.545,4.05),(8.545,4.42),(9.195,4.42),(9.195,4.05),(8.545,4.05)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.115,4.075),(9.115,4.395),(9.275,4.395),(9.275,4.075),(9.115,4.075)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.44,1.34),(8.44,4.42),(8.65,4.42),(8.65,1.34),(8.44,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.115,1.34),(9.115,1.67),(9.275,1.67),(9.275,1.34),(9.115,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((9.115,1.345),(9.115,1.665),(9.275,1.665),(9.275,1.345),(9.115,1.345)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.545,1.34),(8.545,1.67),(9.195,1.67),(9.195,1.34),(8.545,1.34)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.465,2.97),(8.465,3.29),(8.625,3.29),(8.625,2.97),(8.465,2.97)),
        )
        createRL(
            tech, net, 'Metal1',
            ((8.44,4.05),(8.44,4.37),(8.65,4.37),(8.65,4.05),(8.44,4.05)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.465,1.97),(8.465,2.13),(8.625,2.13),(8.625,1.97),(8.465,1.97)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.115,4.155),(9.115,4.315),(9.275,4.315),(9.275,4.155),(9.115,4.155)),
        )
        createRL(
            tech, net, 'Cont',
            ((9.115,1.425),(9.115,1.585),(9.275,1.585),(9.275,1.425),(9.115,1.425)),
        )
        createRL(
            tech, net, 'Cont',
            ((8.465,3.05),(8.465,3.21),(8.625,3.21),(8.625,3.05),(8.465,3.05)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.045,3.89),(9.045,4.87),(9.345,4.87),(9.345,3.89),(9.045,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.045,0.89),(9.045,1.83),(9.345,1.83),(9.345,0.89),(9.045,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.075,0.89),(9.075,1.83),(9.345,1.83),(9.345,0.89),(9.075,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.045,1.355),(9.045,1.655),(9.345,1.655),(9.345,1.355),(9.045,1.355)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.045,4.085),(9.045,4.385),(9.345,4.385),(9.345,4.085),(9.045,4.085)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.005,0.89),(9.005,1.83),(9.235,1.83),(9.235,0.89),(9.005,0.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.075,3.89),(9.075,4.87),(9.345,4.87),(9.345,3.89),(9.075,3.89)),
        )
        createRL(
            tech, net, 'Activ',
            ((9.005,3.89),(9.005,4.87),(9.235,4.87),(9.235,3.89),(9.005,3.89)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(8.545), u(0.21), u(1.34), u(4.42),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(8.545), u(0.21), u(1.34), u(4.42),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        nets['vdd'].setGlobal(True)
        nets['vss'].setGlobal(True)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['i'].setDirection(Net.Direction.IN)
        nets['clk'].setType(Net.Type.CLOCK)
        nets['clk'].setDirection(Net.Direction.IN)
        nets['q'].setDirection(Net.Direction.OUT)
        nets['nrst'].setDirection(Net.Direction.IN)

    cell = new_cells['Gallery']
    with UpdateSession():
        cell.setAbutmentBox(Box(
            u(0.0), u(-5.76), u(140.00000000000003), u(11.52),
        ))
        nets = {
            'vdd': Net.create(cell, 'vdd'),
            'vss': Net.create(cell, 'vss'),
        }
        net = nets['vss']
        createRL(
            tech, net, 'Metal1',
            ((0.0,10.4),(0.0,11.52),(0.21,11.52),(0.21,10.4),(0.0,10.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,-1.12),(0.0,1.12),(140.0,1.12),(140.0,-1.12),(0.0,-1.12)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,10.4),(0.0,11.52),(140.0,11.52),(140.0,10.4),(0.0,10.4)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,-1.12),(0.0,1.12),(0.21,1.12),(0.21,-1.12),(0.0,-1.12)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(70.0), u(140.0), u(-1.12), u(1.12),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(70.0), u(140.0), u(-1.12), u(1.12),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(70.0), u(140.0), u(10.4), u(11.52),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(70.0), u(140.0), u(10.4), u(11.52),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Via1',
            ((0.01,10.455),(0.01,10.645),(0.2,10.645),(0.2,10.455),(0.01,10.455)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,10.865),(0.01,11.055),(0.2,11.055),(0.2,10.865),(0.01,10.865)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,11.275),(0.01,11.465),(0.2,11.465),(0.2,11.275),(0.01,11.275)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,-0.915),(0.01,-0.725),(0.2,-0.725),(0.2,-0.915),(0.01,-0.915)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,-0.505),(0.01,-0.315),(0.2,-0.315),(0.2,-0.505),(0.01,-0.505)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,-0.095),(0.01,0.095),(0.2,0.095),(0.2,-0.095),(0.01,-0.095)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,0.315),(0.01,0.505),(0.2,0.505),(0.2,0.315),(0.01,0.315)),
        )
        createRL(
            tech, net, 'Via1',
            ((0.01,0.725),(0.01,0.915),(0.2,0.915),(0.2,0.725),(0.01,0.725)),
        )
        createRL(
            tech, net, 'Metal2',
            ((0.005,-0.965),(0.005,0.965),(0.205,0.965),(0.205,-0.965),(0.005,-0.965)),
        )
        createRL(
            tech, net, 'Metal2',
            ((0.005,10.405),(0.005,11.515),(0.205,11.515),(0.205,10.405),(0.005,10.405)),
        )
        createRL(
            tech, net, 'Metal2',
            ((0.005,-0.965),(0.005,11.515),(0.205,11.515),(0.205,-0.965),(0.005,-0.965)),
        )
        net = nets['vdd']
        createRL(
            tech, net, 'Metal1',
            ((0.0,4.64),(0.0,6.88),(140.0,6.88),(140.0,4.64),(0.0,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((139.79,4.64),(139.79,6.88),(140.0,6.88),(140.0,4.64),(139.79,4.64)),
        )
        createRL(
            tech, net, 'Metal1',
            ((0.0,-5.76),(0.0,-4.64),(140.0,-4.64),(140.0,-5.76),(0.0,-5.76)),
        )
        createRL(
            tech, net, 'Metal1',
            ((139.79,-5.76),(139.79,-4.64),(140.0,-4.64),(140.0,-5.76),(139.79,-5.76)),
        )
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(70.0), u(140.0), u(4.64), u(6.88),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(70.0), u(140.0), u(4.64), u(6.88),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        Vertical.create(
            net, tech.getLayer('Metal1.pin'),
            u(70.0), u(140.0), u(-5.76), u(-4.64),
        )
        pin = Vertical.create(
            net, tech.getLayer('Metal1'),
            u(70.0), u(140.0), u(-5.76), u(-4.64),
        )
        net.setExternal(True)
        NetExternalComponents.setExternal(pin)
        createRL(
            tech, net, 'Via1',
            ((139.8,4.845),(139.8,5.035),(139.99,5.035),(139.99,4.845),(139.8,4.845)),
        )
        createRL(
            tech, net, 'Via1',
            ((139.8,5.255),(139.8,5.445),(139.99,5.445),(139.99,5.255),(139.8,5.255)),
        )
        createRL(
            tech, net, 'Via1',
            ((139.8,5.665),(139.8,5.855),(139.99,5.855),(139.99,5.665),(139.8,5.665)),
        )
        createRL(
            tech, net, 'Via1',
            ((139.8,6.075),(139.8,6.265),(139.99,6.265),(139.99,6.075),(139.8,6.075)),
        )
        createRL(
            tech, net, 'Via1',
            ((139.8,6.485),(139.8,6.675),(139.99,6.675),(139.99,6.485),(139.8,6.485)),
        )
        createRL(
            tech, net, 'Via1',
            ((139.8,-5.705),(139.8,-5.515),(139.99,-5.515),(139.99,-5.705),(139.8,-5.705)),
        )
        createRL(
            tech, net, 'Via1',
            ((139.8,-5.295),(139.8,-5.105),(139.99,-5.105),(139.99,-5.295),(139.8,-5.295)),
        )
        createRL(
            tech, net, 'Via1',
            ((139.8,-4.885),(139.8,-4.695),(139.99,-4.695),(139.99,-4.885),(139.8,-4.885)),
        )
        createRL(
            tech, net, 'Metal2',
            ((139.795,-5.755),(139.795,6.725),(139.995,6.725),(139.995,-5.755),(139.795,-5.755)),
        )
        createRL(
            tech, net, 'Metal2',
            ((139.795,4.795),(139.795,6.725),(139.995,6.725),(139.995,4.795),(139.795,4.795)),
        )
        createRL(
            tech, net, 'Metal2',
            ((139.795,-5.755),(139.795,-4.645),(139.995,-4.645),(139.995,-5.755),(139.795,-5.755)),
        )
        nets['vss'].setGlobal(True)
        nets['vdd'].setGlobal(True)
        nets['vss'].setType(Net.Type.GROUND)
        nets['vss'].setDirection(Net.Direction.IN)
        nets['vdd'].setType(Net.Type.POWER)
        nets['vdd'].setDirection(Net.Direction.IN)
        try:
            subcell = new_cells['fill']
        except:
            subcell = af.getCell('fill', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'fill[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dffnr_x1']
        except:
            subcell = af.getCell('dffnr_x1', 0)
        trans = Transformation(
            u(0.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'dffnr_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dffnr_x1']
        except:
            subcell = af.getCell('dffnr_x1', 0)
        trans = Transformation(
            u(0.0), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'dffnr_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie']
        except:
            subcell = af.getCell('tie', 0)
        trans = Transformation(
            u(0.8), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dff_x1']
        except:
            subcell = af.getCell('dff_x1', 0)
        trans = Transformation(
            u(9.600000000000001), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'dff_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill']
        except:
            subcell = af.getCell('fill', 0)
        trans = Transformation(
            u(9.600000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff']
        except:
            subcell = af.getCell('tie_diff', 0)
        trans = Transformation(
            u(1.6), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_diff[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x1']
        except:
            subcell = af.getCell('nsnrlatch_x1', 0)
        trans = Transformation(
            u(17.6), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nsnrlatch_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dff_x1']
        except:
            subcell = af.getCell('dff_x1', 0)
        trans = Transformation(
            u(10.400000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'dff_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly']
        except:
            subcell = af.getCell('tie_poly', 0)
        trans = Transformation(
            u(2.4000000000000004), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_poly[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x0']
        except:
            subcell = af.getCell('nsnrlatch_x0', 0)
        trans = Transformation(
            u(20.8), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nsnrlatch_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie']
        except:
            subcell = af.getCell('tie', 0)
        trans = Transformation(
            u(18.400000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w2']
        except:
            subcell = af.getCell('fill_w2', 0)
        trans = Transformation(
            u(3.2), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'fill_w2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nexor2_x0']
        except:
            subcell = af.getCell('nexor2_x0', 0)
        trans = Transformation(
            u(24.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nexor2_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x1']
        except:
            subcell = af.getCell('nsnrlatch_x1', 0)
        trans = Transformation(
            u(19.200000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nsnrlatch_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w2']
        except:
            subcell = af.getCell('tie_w2', 0)
        trans = Transformation(
            u(4.800000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_w2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['xor2_x0']
        except:
            subcell = af.getCell('xor2_x0', 0)
        trans = Transformation(
            u(28.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'xor2_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff']
        except:
            subcell = af.getCell('tie_diff', 0)
        trans = Transformation(
            u(22.400000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w2']
        except:
            subcell = af.getCell('tie_diff_w2', 0)
        trans = Transformation(
            u(6.4), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_diff_w2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x1']
        except:
            subcell = af.getCell('or21nand_x1', 0)
        trans = Transformation(
            u(32.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or21nand_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x0']
        except:
            subcell = af.getCell('nsnrlatch_x0', 0)
        trans = Transformation(
            u(23.200000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nsnrlatch_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w2']
        except:
            subcell = af.getCell('tie_poly_w2', 0)
        trans = Transformation(
            u(8.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_poly_w2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x0']
        except:
            subcell = af.getCell('or21nand_x0', 0)
        trans = Transformation(
            u(35.2), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or21nand_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly']
        except:
            subcell = af.getCell('tie_poly', 0)
        trans = Transformation(
            u(26.400000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w4']
        except:
            subcell = af.getCell('fill_w4', 0)
        trans = Transformation(
            u(9.6), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'fill_w4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x1']
        except:
            subcell = af.getCell('and21nor_x1', 0)
        trans = Transformation(
            u(38.400000000000006), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and21nor_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nexor2_x0']
        except:
            subcell = af.getCell('nexor2_x0', 0)
        trans = Transformation(
            u(27.200000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nexor2_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w4']
        except:
            subcell = af.getCell('tie_w4', 0)
        trans = Transformation(
            u(12.8), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_w4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x0']
        except:
            subcell = af.getCell('and21nor_x0', 0)
        trans = Transformation(
            u(41.60000000000001), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and21nor_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w2']
        except:
            subcell = af.getCell('fill_w2', 0)
        trans = Transformation(
            u(31.200000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill_w2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w4']
        except:
            subcell = af.getCell('tie_diff_w4', 0)
        trans = Transformation(
            u(16.0), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_diff_w4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['mux2_x1']
        except:
            subcell = af.getCell('mux2_x1', 0)
        trans = Transformation(
            u(44.80000000000001), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'mux2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['xor2_x0']
        except:
            subcell = af.getCell('xor2_x0', 0)
        trans = Transformation(
            u(32.800000000000004), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'xor2_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w4']
        except:
            subcell = af.getCell('tie_poly_w4', 0)
        trans = Transformation(
            u(19.2), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'tie_poly_w4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or4_x1']
        except:
            subcell = af.getCell('or4_x1', 0)
        trans = Transformation(
            u(48.80000000000001), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or4_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w2']
        except:
            subcell = af.getCell('tie_w2', 0)
        trans = Transformation(
            u(36.800000000000004), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_w2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['diode_w1']
        except:
            subcell = af.getCell('diode_w1', 0)
        trans = Transformation(
            u(22.4), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'diode_w1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or3_x1']
        except:
            subcell = af.getCell('or3_x1', 0)
        trans = Transformation(
            u(52.000000000000014), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or3_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x1']
        except:
            subcell = af.getCell('or21nand_x1', 0)
        trans = Transformation(
            u(38.400000000000006), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or21nand_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zero_x1']
        except:
            subcell = af.getCell('zero_x1', 0)
        trans = Transformation(
            u(23.2), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'zero_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or2_x1']
        except:
            subcell = af.getCell('or2_x1', 0)
        trans = Transformation(
            u(55.20000000000002), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w2']
        except:
            subcell = af.getCell('tie_diff_w2', 0)
        trans = Transformation(
            u(41.60000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff_w2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['one_x1']
        except:
            subcell = af.getCell('one_x1', 0)
        trans = Transformation(
            u(24.8), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'one_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x1']
        except:
            subcell = af.getCell('nor4_x1', 0)
        trans = Transformation(
            u(57.600000000000016), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor4_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x0']
        except:
            subcell = af.getCell('or21nand_x0', 0)
        trans = Transformation(
            u(43.20000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or21nand_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zeroone_x1']
        except:
            subcell = af.getCell('zeroone_x1', 0)
        trans = Transformation(
            u(26.400000000000002), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'zeroone_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x0']
        except:
            subcell = af.getCell('nor4_x0', 0)
        trans = Transformation(
            u(60.80000000000002), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor4_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w2']
        except:
            subcell = af.getCell('tie_poly_w2', 0)
        trans = Transformation(
            u(46.40000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly_w2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['decap_w0']
        except:
            subcell = af.getCell('decap_w0', 0)
        trans = Transformation(
            u(28.000000000000004), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'decap_w0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x1']
        except:
            subcell = af.getCell('nor3_x1', 0)
        trans = Transformation(
            u(64.00000000000001), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor3_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x1']
        except:
            subcell = af.getCell('and21nor_x1', 0)
        trans = Transformation(
            u(48.000000000000014), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and21nor_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x0']
        except:
            subcell = af.getCell('inv_x0', 0)
        trans = Transformation(
            u(29.600000000000005), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'inv_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x0']
        except:
            subcell = af.getCell('nor3_x0', 0)
        trans = Transformation(
            u(66.40000000000002), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor3_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w4']
        except:
            subcell = af.getCell('fill_w4', 0)
        trans = Transformation(
            u(51.20000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill_w4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x1']
        except:
            subcell = af.getCell('inv_x1', 0)
        trans = Transformation(
            u(31.200000000000006), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'inv_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x1']
        except:
            subcell = af.getCell('nor2_x1', 0)
        trans = Transformation(
            u(68.80000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x0']
        except:
            subcell = af.getCell('and21nor_x0', 0)
        trans = Transformation(
            u(54.40000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and21nor_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x2']
        except:
            subcell = af.getCell('inv_x2', 0)
        trans = Transformation(
            u(32.800000000000004), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'inv_x2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x0']
        except:
            subcell = af.getCell('nor2_x0', 0)
        trans = Transformation(
            u(70.40000000000002), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor2_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w4']
        except:
            subcell = af.getCell('tie_w4', 0)
        trans = Transformation(
            u(57.60000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_w4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x4']
        except:
            subcell = af.getCell('inv_x4', 0)
        trans = Transformation(
            u(34.400000000000006), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'inv_x4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and4_x1']
        except:
            subcell = af.getCell('and4_x1', 0)
        trans = Transformation(
            u(72.00000000000001), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and4_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['mux2_x1']
        except:
            subcell = af.getCell('mux2_x1', 0)
        trans = Transformation(
            u(60.800000000000026), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'mux2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x1']
        except:
            subcell = af.getCell('buf_x1', 0)
        trans = Transformation(
            u(37.60000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'buf_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and3_x1']
        except:
            subcell = af.getCell('and3_x1', 0)
        trans = Transformation(
            u(75.20000000000002), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and3_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w4']
        except:
            subcell = af.getCell('tie_diff_w4', 0)
        trans = Transformation(
            u(64.80000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff_w4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x2']
        except:
            subcell = af.getCell('buf_x2', 0)
        trans = Transformation(
            u(39.20000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'buf_x2[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and2_x1']
        except:
            subcell = af.getCell('and2_x1', 0)
        trans = Transformation(
            u(78.40000000000002), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or4_x1']
        except:
            subcell = af.getCell('or4_x1', 0)
        trans = Transformation(
            u(68.00000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or4_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x4']
        except:
            subcell = af.getCell('buf_x4', 0)
        trans = Transformation(
            u(41.60000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'buf_x4[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x1']
        except:
            subcell = af.getCell('nand4_x1', 0)
        trans = Transformation(
            u(80.80000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand4_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w4']
        except:
            subcell = af.getCell('tie_poly_w4', 0)
        trans = Transformation(
            u(71.20000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly_w4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x0']
        except:
            subcell = af.getCell('nand2_x0', 0)
        trans = Transformation(
            u(44.80000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand2_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x0']
        except:
            subcell = af.getCell('nand4_x0', 0)
        trans = Transformation(
            u(84.00000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand4_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or3_x1']
        except:
            subcell = af.getCell('or3_x1', 0)
        trans = Transformation(
            u(74.40000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or3_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x1']
        except:
            subcell = af.getCell('nand2_x1', 0)
        trans = Transformation(
            u(46.40000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x1']
        except:
            subcell = af.getCell('nand3_x1', 0)
        trans = Transformation(
            u(87.20000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand3_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['diode_w1']
        except:
            subcell = af.getCell('diode_w1', 0)
        trans = Transformation(
            u(77.60000000000004), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'diode_w1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x0']
        except:
            subcell = af.getCell('nand3_x0', 0)
        trans = Transformation(
            u(48.000000000000014), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand3_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x0']
        except:
            subcell = af.getCell('nand3_x0', 0)
        trans = Transformation(
            u(89.60000000000004), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand3_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or2_x1']
        except:
            subcell = af.getCell('or2_x1', 0)
        trans = Transformation(
            u(78.40000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'or2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x1']
        except:
            subcell = af.getCell('nand3_x1', 0)
        trans = Transformation(
            u(50.40000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand3_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x1']
        except:
            subcell = af.getCell('nand2_x1', 0)
        trans = Transformation(
            u(92.00000000000004), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand2_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zero_x1']
        except:
            subcell = af.getCell('zero_x1', 0)
        trans = Transformation(
            u(80.80000000000004), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'zero_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x0']
        except:
            subcell = af.getCell('nand4_x0', 0)
        trans = Transformation(
            u(52.80000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand4_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x0']
        except:
            subcell = af.getCell('nand2_x0', 0)
        trans = Transformation(
            u(93.60000000000004), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand2_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x1']
        except:
            subcell = af.getCell('nor4_x1', 0)
        trans = Transformation(
            u(82.40000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor4_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x1']
        except:
            subcell = af.getCell('nand4_x1', 0)
        trans = Transformation(
            u(56.000000000000014), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nand4_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x4']
        except:
            subcell = af.getCell('buf_x4', 0)
        trans = Transformation(
            u(95.20000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['one_x1']
        except:
            subcell = af.getCell('one_x1', 0)
        trans = Transformation(
            u(85.60000000000004), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'one_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and2_x1']
        except:
            subcell = af.getCell('and2_x1', 0)
        trans = Transformation(
            u(59.20000000000002), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x2']
        except:
            subcell = af.getCell('buf_x2', 0)
        trans = Transformation(
            u(98.40000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x0']
        except:
            subcell = af.getCell('nor4_x0', 0)
        trans = Transformation(
            u(87.20000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor4_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and3_x1']
        except:
            subcell = af.getCell('and3_x1', 0)
        trans = Transformation(
            u(61.600000000000016), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and3_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x1']
        except:
            subcell = af.getCell('buf_x1', 0)
        trans = Transformation(
            u(100.80000000000004), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zeroone_x1']
        except:
            subcell = af.getCell('zeroone_x1', 0)
        trans = Transformation(
            u(90.40000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'zeroone_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and4_x1']
        except:
            subcell = af.getCell('and4_x1', 0)
        trans = Transformation(
            u(64.80000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and4_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x4']
        except:
            subcell = af.getCell('inv_x4', 0)
        trans = Transformation(
            u(102.40000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x1']
        except:
            subcell = af.getCell('nor3_x1', 0)
        trans = Transformation(
            u(92.00000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor3_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x0']
        except:
            subcell = af.getCell('nor2_x0', 0)
        trans = Transformation(
            u(68.00000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor2_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x2']
        except:
            subcell = af.getCell('inv_x2', 0)
        trans = Transformation(
            u(105.60000000000004), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['decap_w0']
        except:
            subcell = af.getCell('decap_w0', 0)
        trans = Transformation(
            u(94.40000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'decap_w0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x1']
        except:
            subcell = af.getCell('nor2_x1', 0)
        trans = Transformation(
            u(69.60000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x1']
        except:
            subcell = af.getCell('inv_x1', 0)
        trans = Transformation(
            u(107.20000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x0']
        except:
            subcell = af.getCell('nor3_x0', 0)
        trans = Transformation(
            u(96.00000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor3_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x0']
        except:
            subcell = af.getCell('nor3_x0', 0)
        trans = Transformation(
            u(71.2), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor3_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x0']
        except:
            subcell = af.getCell('inv_x0', 0)
        trans = Transformation(
            u(108.80000000000003), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x0']
        except:
            subcell = af.getCell('inv_x0', 0)
        trans = Transformation(
            u(98.40000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor3_x1']
        except:
            subcell = af.getCell('nor3_x1', 0)
        trans = Transformation(
            u(73.60000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor3_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['decap_w0']
        except:
            subcell = af.getCell('decap_w0', 0)
        trans = Transformation(
            u(110.40000000000002), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'decap_w0[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x1']
        except:
            subcell = af.getCell('nor2_x1', 0)
        trans = Transformation(
            u(100.00000000000003), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x0']
        except:
            subcell = af.getCell('nor4_x0', 0)
        trans = Transformation(
            u(76.00000000000001), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor4_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zeroone_x1']
        except:
            subcell = af.getCell('zeroone_x1', 0)
        trans = Transformation(
            u(112.00000000000001), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'zeroone_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x1']
        except:
            subcell = af.getCell('inv_x1', 0)
        trans = Transformation(
            u(101.60000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor4_x1']
        except:
            subcell = af.getCell('nor4_x1', 0)
        trans = Transformation(
            u(79.20000000000002), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nor4_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['one_x1']
        except:
            subcell = af.getCell('one_x1', 0)
        trans = Transformation(
            u(113.60000000000001), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'one_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nor2_x0']
        except:
            subcell = af.getCell('nor2_x0', 0)
        trans = Transformation(
            u(103.20000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nor2_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or2_x1']
        except:
            subcell = af.getCell('or2_x1', 0)
        trans = Transformation(
            u(82.40000000000002), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['zero_x1']
        except:
            subcell = af.getCell('zero_x1', 0)
        trans = Transformation(
            u(115.2), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'zero_x1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x2']
        except:
            subcell = af.getCell('inv_x2', 0)
        trans = Transformation(
            u(104.80000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or3_x1']
        except:
            subcell = af.getCell('or3_x1', 0)
        trans = Transformation(
            u(84.80000000000003), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or3_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['diode_w1']
        except:
            subcell = af.getCell('diode_w1', 0)
        trans = Transformation(
            u(116.8), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'diode_w1[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and4_x1']
        except:
            subcell = af.getCell('and4_x1', 0)
        trans = Transformation(
            u(106.4), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and4_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or4_x1']
        except:
            subcell = af.getCell('or4_x1', 0)
        trans = Transformation(
            u(88.00000000000003), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or4_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w4']
        except:
            subcell = af.getCell('tie_poly_w4', 0)
        trans = Transformation(
            u(117.6), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly_w4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['inv_x4']
        except:
            subcell = af.getCell('inv_x4', 0)
        trans = Transformation(
            u(109.60000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'inv_x4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['mux2_x1']
        except:
            subcell = af.getCell('mux2_x1', 0)
        trans = Transformation(
            u(91.20000000000003), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'mux2_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w4']
        except:
            subcell = af.getCell('tie_diff_w4', 0)
        trans = Transformation(
            u(120.8), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff_w4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and3_x1']
        except:
            subcell = af.getCell('and3_x1', 0)
        trans = Transformation(
            u(112.80000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and3_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x0']
        except:
            subcell = af.getCell('and21nor_x0', 0)
        trans = Transformation(
            u(95.20000000000003), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and21nor_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w4']
        except:
            subcell = af.getCell('tie_w4', 0)
        trans = Transformation(
            u(124.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_w4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x1']
        except:
            subcell = af.getCell('buf_x1', 0)
        trans = Transformation(
            u(116.00000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and21nor_x1']
        except:
            subcell = af.getCell('and21nor_x1', 0)
        trans = Transformation(
            u(98.40000000000003), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'and21nor_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w4']
        except:
            subcell = af.getCell('fill_w4', 0)
        trans = Transformation(
            u(127.2), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill_w4[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['and2_x1']
        except:
            subcell = af.getCell('and2_x1', 0)
        trans = Transformation(
            u(117.60000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'and2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x0']
        except:
            subcell = af.getCell('or21nand_x0', 0)
        trans = Transformation(
            u(101.60000000000004), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or21nand_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly_w2']
        except:
            subcell = af.getCell('tie_poly_w2', 0)
        trans = Transformation(
            u(130.4), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly_w2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x2']
        except:
            subcell = af.getCell('buf_x2', 0)
        trans = Transformation(
            u(120.00000000000001), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x2[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['or21nand_x1']
        except:
            subcell = af.getCell('or21nand_x1', 0)
        trans = Transformation(
            u(104.80000000000004), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'or21nand_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff_w2']
        except:
            subcell = af.getCell('tie_diff_w2', 0)
        trans = Transformation(
            u(132.0), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff_w2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x1']
        except:
            subcell = af.getCell('nand4_x1', 0)
        trans = Transformation(
            u(122.40000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand4_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['xor2_x0']
        except:
            subcell = af.getCell('xor2_x0', 0)
        trans = Transformation(
            u(108.00000000000004), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'xor2_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_w2']
        except:
            subcell = af.getCell('tie_w2', 0)
        trans = Transformation(
            u(133.6), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_w2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['buf_x4']
        except:
            subcell = af.getCell('buf_x4', 0)
        trans = Transformation(
            u(125.60000000000002), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'buf_x4[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nexor2_x0']
        except:
            subcell = af.getCell('nexor2_x0', 0)
        trans = Transformation(
            u(112.00000000000004), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nexor2_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill_w2']
        except:
            subcell = af.getCell('fill_w2', 0)
        trans = Transformation(
            u(135.2), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill_w2[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand4_x0']
        except:
            subcell = af.getCell('nand4_x0', 0)
        trans = Transformation(
            u(128.8), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand4_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x0']
        except:
            subcell = af.getCell('nsnrlatch_x0', 0)
        trans = Transformation(
            u(116.00000000000004), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nsnrlatch_x0[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_poly']
        except:
            subcell = af.getCell('tie_poly', 0)
        trans = Transformation(
            u(136.79999999999998), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_poly[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x0']
        except:
            subcell = af.getCell('nand2_x0', 0)
        trans = Transformation(
            u(132.0), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand2_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nsnrlatch_x1']
        except:
            subcell = af.getCell('nsnrlatch_x1', 0)
        trans = Transformation(
            u(119.20000000000005), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'nsnrlatch_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie_diff']
        except:
            subcell = af.getCell('tie_diff', 0)
        trans = Transformation(
            u(137.6), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie_diff[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x1']
        except:
            subcell = af.getCell('nand3_x1', 0)
        trans = Transformation(
            u(133.6), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand3_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dff_x1']
        except:
            subcell = af.getCell('dff_x1', 0)
        trans = Transformation(
            u(122.40000000000005), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'dff_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['tie']
        except:
            subcell = af.getCell('tie', 0)
        trans = Transformation(
            u(138.4), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'tie[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand2_x1']
        except:
            subcell = af.getCell('nand2_x1', 0)
        trans = Transformation(
            u(136.0), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand2_x1[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['dffnr_x1']
        except:
            subcell = af.getCell('dffnr_x1', 0)
        trans = Transformation(
            u(130.40000000000003), u(0.0), Transformation.Orientation.ID,
        )
        Instance.create(
            cell, 'dffnr_x1[0]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['fill']
        except:
            subcell = af.getCell('fill', 0)
        trans = Transformation(
            u(139.20000000000002), u(0.0), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'fill[1]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )
        try:
            subcell = new_cells['nand3_x0']
        except:
            subcell = af.getCell('nand3_x0', 0)
        trans = Transformation(
            u(137.6), u(11.52), Transformation.Orientation.MX,
        )
        Instance.create(
            cell, 'nand3_x0[2]', subcell, trans,
            Instance.PlacementStatus.PLACED,
        )

    af.wrapLibrary(lib, 0)

    return lib

def setup():
    lib = _load()
    _routing()
    try:
        from .StdCellLib_fix import fix
    except:
        pass
    else:
        fix(lib)

    return lib
